import { reactive, toRefs, watch, onBeforeUnmount, resolveComponent, resolveDirective, withDirectives, openBlock, createElementBlock, createElementVNode, createVNode, withCtx, Fragment, renderList, createBlock, createTextVNode, toDisplayString, normalizeClass, vShow } from 'vue';

function _typeof(obj) {
  "@babel/helpers - typeof";

  if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
    _typeof = function (obj) {
      return typeof obj;
    };
  } else {
    _typeof = function (obj) {
      return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
    };
  }

  return _typeof(obj);
}

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);

  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    if (enumerableOnly) symbols = symbols.filter(function (sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    });
    keys.push.apply(keys, symbols);
  }

  return keys;
}

function _objectSpread2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};

    if (i % 2) {
      ownKeys(Object(source), true).forEach(function (key) {
        _defineProperty(target, key, source[key]);
      });
    } else if (Object.getOwnPropertyDescriptors) {
      Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
      ownKeys(Object(source)).forEach(function (key) {
        Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
      });
    }
  }

  return target;
}

function _toConsumableArray(arr) {
  return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread();
}

function _arrayWithoutHoles(arr) {
  if (Array.isArray(arr)) return _arrayLikeToArray(arr);
}

function _iterableToArray(iter) {
  if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter);
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

  return arr2;
}

function _nonIterableSpread() {
  throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

// 创建一个简单的store状态管理

var storeState = reactive({
  isViewer: false,
  //viewer初始化标志
  changeLayers: 0,
  //图层改变加载完毕监听
  changeGeometrys: 0 //三维分析体改变标志

});

/*
* 常用工具类
*/
//axios本版本不支持jsonp
var axiosJsonp = function axiosJsonp(url) {
  if (!url) {
    console.error('Axios.JSONP 至少需要一个url参数!');
    return;
  }

  return new Promise(function (resolve, reject) {
    window.jsonCallBack = function (result) {
      resolve(result);
    };

    var JSONP = document.createElement("script");
    JSONP.type = "text/javascript";
    JSONP.src = "".concat(url, "&callback=jsonCallBack");
    document.getElementsByTagName("head")[0].appendChild(JSONP);
    setTimeout(function () {
      document.getElementsByTagName("head")[0].removeChild(JSONP);
    }, 500);
  });
}; //判断两数组或对象相等


var isEqualArr = function isEqualArr(arg1, arg2) {
  if (!arg1 || !arg2) return true;
  var bol = true;

  if (Object.keys(arg1).length != Object.keys(arg2).length) {
    return false;
  }

  for (var key in arg1) {
    if (_typeof(arg1[key]) == 'object') {
      bol = isSame(arg1[key], arg2[key]);

      if (!bol) {
        break;
      }
    } else if (arg1[key] != arg2[key]) {
      bol = false;
      break;
    }
  }

  return bol;
}; //坐标转化
//笛卡尔转经纬度


var CartesiantoDegrees = function CartesiantoDegrees(Cartesians) {
  var array = [].concat(Cartesians);
  var positions = [];

  for (var i = 0, len = array.length; i < len; i++) {
    var cartographic = Cesium.Cartographic.fromCartesian(array[i]);
    var longitude = Cesium.Math.toDegrees(cartographic.longitude);
    var latitude = Cesium.Math.toDegrees(cartographic.latitude);
    var h = cartographic.height;

    if (positions.indexOf(longitude) == -1 && positions.indexOf(latitude) == -1) {
      positions.push(longitude);
      positions.push(latitude);
      positions.push(h);
    }
  }

  return positions;
}; //笛卡尔转经纬度(每个点是独立的对象)


var CartesiantoDegreesObjs = function CartesiantoDegreesObjs(Cartesians) {
  var array = [].concat(Cartesians);
  var positions = [];

  for (var i = 0, len = array.length; i < len; i++) {
    var cartographic = Cesium.Cartographic.fromCartesian(array[i]);
    var obj = {
      longitude: Cesium.Math.toDegrees(cartographic.longitude),
      latitude: Cesium.Math.toDegrees(cartographic.latitude),
      height: cartographic.height
    };
    positions.push(obj);
  }

  return positions;
}; // 弧度转经纬度


var CartographictoDegrees = function CartographictoDegrees(wgsPosition) {
  var longitude = Cesium.Math.toDegrees(wgsPosition.longitude);
  var latitude = Cesium.Math.toDegrees(wgsPosition.latitude);
  var height = wgsPosition.height;
  return [longitude, latitude, height];
}; //去重函数  数组


var unique = function unique(arr) {
  var res = [];
  var json = {};

  for (var i = 0; i < arr.length; i++) {
    if (!json[arr[i]]) {
      res.push(arr[i]);
      json[arr[i]] = 1;
    }
  }

  return res;
}; // 获取渐变色函数


function gradientColors(start, end, steps, gamma) {
  var i,
      j,
      ms,
      me,
      output = [],
      so = [];
  gamma = gamma || 1;

  var normalize = function normalize(channel) {
    return Math.pow(channel / 255, gamma);
  };

  start = parseColor(start).map(normalize);
  end = parseColor(end).map(normalize);

  for (i = 0; i < steps; i++) {
    ms = i / (steps - 1);
    me = 1 - ms;

    for (j = 0; j < 3; j++) {
      so[j] = pad(Math.round(Math.pow(start[j] * me + end[j] * ms, 1 / gamma) * 255).toString(16));
    }

    output.push('#' + so.join(''));
  }

  return output;

  function parseColor(hexStr) {
    return hexStr.length === 4 ? hexStr.substr(1).split('').map(function (s) {
      return 0x11 * parseInt(s, 16);
    }) : [hexStr.substr(1, 2), hexStr.substr(3, 2), hexStr.substr(5, 2)].map(function (s) {
      return parseInt(s, 16);
    });
  }

  function pad(s) {
    return s.length === 1 ? '0' + s : s;
  }
}

function getAngleAndRadian(pointA, pointB) {
  //建立以点A为原点，X轴为east,Y轴为north,Z轴朝上的坐标系
  var transform = Cesium.Transforms.eastNorthUpToFixedFrame(pointA); //向量AB

  var positionvector = Cesium.Cartesian3.subtract(pointB, pointA, new Cesium.Cartesian3()); //因transform是将A为原点的eastNorthUp坐标系中的点转换到世界坐标系的矩阵
  //AB为世界坐标中的向量
  //因此将AB向量转换为A原点坐标系中的向量，需乘以transform的逆矩阵。

  var vector = Cesium.Matrix4.multiplyByPointAsVector(Cesium.Matrix4.inverse(transform, new Cesium.Matrix4()), positionvector, new Cesium.Cartesian3()); //归一化

  var direction = Cesium.Cartesian3.normalize(vector, new Cesium.Cartesian3()); //heading

  var heading1 = Math.atan2(direction.y, direction.x) - Cesium.Math.PI_OVER_TWO;
  var radian = Cesium.Math.TWO_PI - Cesium.Math.zeroToTwoPi(heading1);
  var angle = radian * (180 / Math.PI);

  if (angle < 0) {
    angle = angle + 360;
  }

  return {
    angle: angle,
    radian: radian
  };
}

function getPitch(pointA, pointB) {
  var transfrom = Cesium.Transforms.eastNorthUpToFixedFrame(pointA);
  var vector = Cesium.Cartesian3.subtract(pointB, pointA, new Cesium.Cartesian3());
  var direction = Cesium.Matrix4.multiplyByPointAsVector(Cesium.Matrix4.inverse(transfrom, transfrom), vector, vector);
  Cesium.Cartesian3.normalize(direction, direction); //因为direction已归一化，斜边长度等于1，所以余弦函数等于direction.z

  var radian = Cesium.Math.PI_OVER_TWO - Cesium.Math.acosClamped(direction.z);
  var angle = radian * (180 / Math.PI);

  if (angle < 0) {
    angle = angle + 360;
  }

  return {
    angle: angle,
    radian: radian
  };
}

var tool = {
  axiosJsonp: axiosJsonp,
  isEqualArr: isEqualArr,
  CartesiantoDegrees: CartesiantoDegrees,
  CartesiantoDegreesObjs: CartesiantoDegreesObjs,
  unique: unique,
  gradientColors: gradientColors,
  getAngleAndRadian: getAngleAndRadian,
  CartographictoDegrees: CartographictoDegrees,
  getPitch: getPitch
};

var ResourceCN = {
  showRenderLoopErrors: '渲染时发生错误，已停止渲染。',
  AttributeError: '该组件props没有这个属性：',
  NoPickPositionSupported: "不支持深度纹理,无法绘制多边形，地形操作功能无法使用！",
  NoTerrain: "请在地形里使用地形组件！",
  initViewerWarn: '请先初始化viewer!',
  MoveMouseHeightBox: '点击鼠标左键结束矩形绘制，移动鼠标绘制box高度',
  RightClickEndDrawing: '右键单击结束绘制',
  LeftClickBottomBox: '点击鼠标左键，开始绘制矩形作为box底面',
  ClickModelAddBox: '点击模型，添加裁剪盒子',
  SkyLineWarn: "获取天际线体前，请先绘制天际线！",
  SkyLineBody: '天际线体',
  ShadowqueryWarn: "此操作需要先开启阴影！",
  VeiwshedBody: '可视体',
  VeiwshedBodyHidden: '不可视体',
  EchartsErr: "二维显示需要echarts支持，未找到相关依赖！",
  BaseMapImg: '底图',
  tip1: '<p>点击左键确定操作区域中间点</p><p>右键单击结束绘制</p>'
};

// 组件内部的语言资源：主要包括提示信息
var currentLanguage, Resource;
var cookieLanguage = getLang().toLowerCase();

function getLang() {
  //浏览器语言  IE用browserLanguage，非IE使用language进行判断
  var lang = (navigator.language || navigator.browserLanguage).toLowerCase();
  window.lang = lang; //判断portal设置语言 通过cookie获取
  //   const cookies = document.cookie.split(';');
  //   if (cookies.length > 0) {
  //     cookies.forEach(function (cookie) {
  //       const arr = cookie.split('=');
  //       if (arr[0].toLowerCase().trim() === 'language') {
  //         lang = arr[1];
  //         return;
  //       }
  //     });
  //   }

  return lang;
}

if (cookieLanguage !== undefined) {
  currentLanguage = cookieLanguage;
} else {
  currentLanguage = (navigator.language || navigator.browserLanguage).toLowerCase(); // 获取当前浏览器的语言
}

if (currentLanguage.startsWith('zh')) {
  Resource = ResourceCN;
} else if (currentLanguage.startsWith('ja')) {
  Resource = ResourceCN;
} else {
  Resource = ResourceCN;
}

var resource = Resource;

//随鼠标移动消息提示工具
function createTooltip(frameDiv) {
  var tooltip = function tooltip(frameDiv) {
    var div = document.createElement("DIV");
    div.className = "twipsy right";
    var arrow = document.createElement("DIV");
    arrow.className = "twipsy-arrow";
    div.appendChild(arrow);
    var title = document.createElement("DIV");
    title.className = "twipsy-inner";
    div.appendChild(title);
    this._div = div;
    this._title = title;
    this.message = "";
    frameDiv.appendChild(div);
    var that = this;

    div.onmousemove = function (evt) {
      that.showAt({
        x: evt.clientX,
        y: evt.clientY
      }, that.message);
    };
  };

  tooltip.prototype.setVisible = function (visible) {
    this._div.style.display = visible ? "block" : "none";
  };

  tooltip.prototype.showAt = function (position, message) {
    if (position && message) {
      this.setVisible(true);
      this._title.innerHTML = message;
      this._div.style.left = position.x + 10 + "px";
      this._div.style.top = position.y - this._div.clientHeight / 2 + "px";
      this.message = message;
    }
  };

  return new tooltip(frameDiv);
}

/**
 * 初始化
 * DrawMode：类型
 * clampMode：模式
 */

var initHandler = function initHandler(DrawMode, clampMode) {
  var clampmode = 0;

  if (clampMode) {
    clampmode = clampMode;
  }

  switch (DrawMode) {
    case "Point":
      window.handlerPoint = new Cesium.DrawHandler(viewer, Cesium.DrawMode.Point);
      break;

    case "Polyline":
      window.handlerPolyline = new Cesium.DrawHandler(viewer, Cesium.DrawMode.Line, clampmode);
      break;

    case "Polygon":
      window.handlerPolygon = new Cesium.DrawHandler(viewer, Cesium.DrawMode.Polygon, clampmode);
      break;

    case "Marker":
      window.handlerMarker = new Cesium.DrawHandler(viewer, Cesium.DrawMode.Marker, clampmode);
      break;

    case "Box":
      window.handlerBox = new Cesium.DrawHandler(viewer, Cesium.DrawMode.Box, clampmode);
      break;
  }

  if (!window.tooltip) {
    window.tooltip = createTooltip(viewer._element);
  } // 半透线创建


  if (!window.polylineCollection) {
    window.polylineCollection = new Cesium.PolylineCollection({
      translucentRS: Cesium.RenderState.fromCache({
        depthMask: false,
        depthTest: {
          enabled: false
        }
      })
    });
    window.polylineTransparent = window.polylineCollection.add({
      width: 2,
      material: Cesium.Material.fromType(Cesium.Material.ColorType, {
        color: Cesium.Color.fromCssColorString("#51ff00").withAlpha(0.3)
      })
    });
    viewer.scene.primitives.add(window.polylineCollection);
  }
};
/**
 * 绘制
 * PolyType：类型 
 * lineVisib：绘制时是否显示绘制线（boolean）
 * toolTipObj：绘制时提示内容{beforeDrawing：绘制开始前提示(string)，isDrawing：正在绘制时提示,即绘制过程中（string）}
 */


var handlerDrawing = function handlerDrawing(PolyType, lineVisib, toolTipObj) {
  var lineVisible = true;

  if (lineVisib === false) {
    lineVisible = lineVisib;
  }

  var DrawHandler = judgeDrawHandlerType(PolyType); //获取操作对象

  return new Promise(function (resolve, reject) {
    //做一些异步操作
    var tooltip = window.tooltip;
    var clearActFn = DrawHandler.activeEvt.addEventListener(function (isActive) {
      if (isActive == true) {
        viewer.enableCursorStyle = false;
        viewer._element.style.cursor = '';

        if (PolyType == "Point" || PolyType == "Marker") {
          document.body.classList.add("measureCur");
        } else {
          document.body.classList.add("drawCur");
        }
      } else {
        viewer.enableCursorStyle = true;
        tooltip.setVisible(false);

        if (PolyType == "Point" || PolyType == "Marker") {
          document.body.classList.remove('measureCur');
        } else {
          document.body.classList.remove('drawCur');
        }
      }
    });
    var clearMovFn = DrawHandler.movingEvt.addEventListener(function (windowPosition) {
      if (windowPosition.x < 200 && windowPosition.y < 150) {
        tooltip.setVisible(false);
        return;
      }
      //     tooltip.showAt(windowPosition, tiptext);
      // } else if (toolTipObj && toolTipObj.beforeDrawing) {
      //     tooltip.showAt(windowPosition, toolTipObj.beforeDrawing);
      // }else if (DrawHandler.isDrawing && toolTipObj.isDrawing) {
      //     tooltip.showAt(windowPosition, toolTipObj.isDrawing);
      // }

      if (DrawHandler.polyline && DrawHandler.isDrawing) {
        var p = _toConsumableArray(DrawHandler.polyline.positions);

        if (PolyType == "Polygon") {
          //画面时，需要首尾相连
          p.push(p[0]);
        }
        window.polylineTransparent.show = true;
        window.polylineTransparent.positions = p;
      }
    });
    var clearDrawFn = DrawHandler.drawEvt.addEventListener(function (result) {
      if (!result.object.positions && PolyType != "Point" && PolyType != "Box") {
        tooltip.showAt(result, '<p>请绘制正确的多边形</p>');
        DrawHandler.polygon.show = false;
        DrawHandler.polyline.show = false;
        DrawHandler.deactivate();
        DrawHandler.activate();
        return;
      }

      if (PolyType == "Box") {
        resolve({
          result: result
        });
        return;
      }

      if (PolyType == "Point" || PolyType == "Marker") {
        DrawHandler.clear(); // 不显示绘制的点

        resolve({
          result: result
        });
      } else {
        //半透线
        window.polylineTransparent.show = lineVisible;

        if (lineVisible) {
          if (PolyType == "Polygon" && lineVisible) {
            DrawHandler.polygon._polygon._material._color._value.alpha = 0.1; //绘制面透明度

            var p2 = _toConsumableArray(result.object.positions); //画面时，需要首尾相连


            p2.push(p2[0]);
            window.polylineTransparent.positions = p2;
          }
        }

        var positions = CartesiantoDegrees(result.object.positions);
        resolve({
          result: result,
          positions: positions
        });
      }

      clearActFn();
      clearMovFn();
      clearDrawFn();
    });
  });
}; //清除


var clearHandlerDrawing = function clearHandlerDrawing(PolyType) {
  var DrawHandler;

  if (!PolyType) {
    DrawHandler = window.handlerPolygon;
  } else {
    DrawHandler = judgeDrawHandlerType(PolyType);
  }
  if (!DrawHandler) return;
  DrawHandler.deactivate();
  DrawHandler.clear();
  viewer.enableCursorStyle = true; // document.body.classList.remove("drawCur");
  // document.body.classList.remove("measureCur");

  window.tooltip.setVisible(false);

  if (window.polylineTransparent) {
    window.polylineTransparent.show = false;
  }
}; // 类型判断


var judgeDrawHandlerType = function judgeDrawHandlerType(PolyType) {
  var DrawHandler;

  switch (PolyType) {
    case "Point":
      DrawHandler = window.handlerPoint;
      break;

    case "Polyline":
      DrawHandler = window.handlerPolyline;
      break;

    case "Polygon":
      DrawHandler = window.handlerPolygon;
      break;

    case "Marker":
      DrawHandler = window.handlerMarker;
      break;

    case "Box":
      DrawHandler = window.handlerBox;
      break;
  }

  return DrawHandler;
};

function createTooltip$1(frameDiv) {
  var tooltip = function tooltip(frameDiv) {
    var div = document.createElement('DIV');
    div.className = "tooltip";
    this._div = div;
    this.message = '';
    frameDiv.appendChild(div);
  };

  tooltip.prototype.setVisible = function (visible) {
    if (visible) {
      this._div.style.right = '10px';
    } else {
      this._div.style.right = '-300px';
    }
  };

  tooltip.prototype.showAt = function (message, top) {
    //top:200px => string
    if (top) {
      this._div.style.top = top;
    }

    if (message) {
      this.setVisible(true);
      this._div.innerHTML = message;
    }
  };

  return new tooltip(frameDiv);
}

var s3mModels = [{
  id: 0,
  name: "树木",
  nameEN: 'tree',
  type: "tree",
  data: [{
    id: 0,
    name: "树1",
    nameEN: 'tree1',
    thumbnail: "public/data/s3m/S3MData/tree.png",
    path: "public/data/s3m/S3MData/tree1.s3m"
  }, {
    id: 1,
    name: "树2",
    nameEN: 'tree2',
    thumbnail: "public/data/s3m/S3MData/pine.png",
    path: "public/data/s3m/S3MData/tree2.s3m"
  }, {
    id: 2,
    name: "树3",
    nameEN: 'tree3',
    thumbnail: "public/data/s3m/S3MData/tree3.png",
    path: "public/data/s3m/S3MData/tree3.s3m"
  }, {
    id: 3,
    name: "树4",
    nameEN: 'tree4',
    thumbnail: "public/data/s3m/S3MData/tree2.png",
    path: "public/data/s3m/S3MData/tree4.s3m"
  }, {
    id: 4,
    name: "springTree",
    nameEN: 'tree5',
    thumbnail: "public/data/s3m/S3MData/springTree.png",
    path: "public/data/s3m/S3MData/springTree.s3m"
  }, {
    id: 5,
    name: "autumnTree",
    nameEN: 'tree6',
    thumbnail: "public/data/s3m/S3MData/autumnTree.png",
    path: "public/data/s3m/S3MData/autumnTree.s3m"
  }, {
    id: 6,
    name: "winterTree",
    nameEN: 'tree7',
    thumbnail: "public/data/s3m/S3MData/winterTree.png",
    path: "public/data/s3m/S3MData/winterTree.s3m"
  }, {}, //个数凑5的倍数便于排版
  {}, {}]
}, {
  id: 1,
  name: "公共设施",
  nameEN: 'public-utilities',
  type: "public-utilities",
  data: [{
    id: 0,
    name: "椅子",
    nameEN: 'Chair',
    thumbnail: "public/data/s3m/S3MData/bench.png",
    path: "public/data/s3m/S3MData/Chair.s3m"
  }, {
    id: 1,
    name: "垃圾箱",
    nameEN: 'Dustbin',
    thumbnail: "public/data/s3m/S3MData/Dustbin.png",
    path: "public/data/s3m/S3MData/Dustbin.s3m"
  }, {
    id: 2,
    name: "垃圾箱2",
    nameEN: 'Dustbin2',
    thumbnail: "public/data/s3m/S3MData/paper-bucket.png",
    path: "public/data/s3m/S3MData/Dustbin2.s3m"
  }, {
    id: 3,
    name: "垃圾桶",
    nameEN: 'GarbageCan',
    thumbnail: "public/data/s3m/S3MData/dustbin1.png",
    path: "public/data/s3m/S3MData/GarbageCan.s3m"
  }, {
    id: 4,
    name: "报亭",
    nameEN: 'NewsStand',
    thumbnail: "public/data/s3m/S3MData/newspaper.png",
    path: "public/data/s3m/S3MData/NewsStand.s3m"
  }, {
    id: 5,
    name: "邮政信箱",
    nameEN: 'PO-Box',
    thumbnail: "public/data/s3m/S3MData/mailbox.png",
    path: "public/data/s3m/S3MData/PO-Box.s3m"
  }, {
    id: 6,
    name: "电信电话亭",
    nameEN: 'T-TelBooth',
    thumbnail: "public/data/s3m/S3MData/phone-booth.png",
    path: "public/data/s3m/S3MData/T-TelBooth.s3m"
  }, {}, {}, {}]
}, {
  id: 2,
  name: "交通",
  nameEN: 'traffic',
  type: "traffic",
  data: [{
    id: 0,
    name: "限速牌",
    nameEN: 'RestrictionBoard',
    thumbnail: "public/data/s3m/S3MData/speed-limit.png",
    path: "public/data/s3m/S3MData/RestrictionBoard.s3m"
  }, {
    id: 1,
    name: "路灯",
    nameEN: 'StreetLight',
    thumbnail: "public/data/s3m/S3MData/lamp-post.png",
    path: "public/data/s3m/S3MData/StreetLight.s3m"
  }, {
    id: 2,
    name: "红绿灯",
    nameEN: 'TrafficLight',
    thumbnail: "public/data/s3m/S3MData/traffic-light.png",
    path: "public/data/s3m/S3MData/TrafficLight.s3m"
  }, {}, {}]
}];

var PolygonEmitter = /*#__PURE__*/function () {
  function PolygonEmitter() {
    _classCallCheck(this, PolygonEmitter);

    this._positions = null;
    this.boundingSphere = null;
    this._geometry = null;
    this._triangleArrayByWeight = null;
  }

  _createClass(PolygonEmitter, [{
    key: "initPolygonEmitter",
    value: function initPolygonEmitter(positions) {
      this._positions = Cesium.defaultValue(positions, [new Cesium.Cartesian3(), new Cesium.Cartesian3(), new Cesium.Cartesian3()]);
      this.boundingSphere = Cesium.BoundingSphere.fromPoints(positions);

      if (Cesium.defaultValue(positions)) {
        var PolygonGeometry = Cesium.PolygonGeometry.fromPositions({
          positions: positions,
          perPositionHeight: true
        });
        this._geometry = Cesium.PolygonGeometry.createGeometry(PolygonGeometry);
        this._triangleArrayByWeight = this.initWeight(this._geometry);
      }
    }
  }, {
    key: "initWeight",
    value: function initWeight(geometry) {
      var vertex0 = new Cesium.Cartesian3();
      var vertex1 = new Cesium.Cartesian3();
      var vertex2 = new Cesium.Cartesian3();
      var indices = geometry.indices;
      var triangleCount = indices.length / 3;
      var vertices = geometry.attributes.position.values;
      var i, j;
      var areaArray = [];
      var totalArea = 0.0;

      for (i = 0; i < triangleCount; i++) {
        var vertexIndex0 = indices[i * 3];
        var vertexIndex1 = indices[i * 3 + 1];
        var vertexIndex2 = indices[i * 3 + 2];
        vertex0.x = vertices[vertexIndex0 * 3];
        vertex0.y = vertices[vertexIndex0 * 3 + 1];
        vertex0.z = vertices[vertexIndex0 * 3 + 2];
        vertex1.x = vertices[vertexIndex1 * 3];
        vertex1.y = vertices[vertexIndex1 * 3 + 1];
        vertex1.z = vertices[vertexIndex1 * 3 + 2];
        vertex2.x = vertices[vertexIndex2 * 3];
        vertex2.y = vertices[vertexIndex2 * 3 + 1];
        vertex2.z = vertices[vertexIndex2 * 3 + 2];
        var area = this.triangleArea(vertex0, vertex1, vertex2);
        totalArea += area;
        areaArray.push(area);
      }

      var weightArraySize = Math.max(100, triangleCount * 10);
      var triangleWeightArray = [];

      for (i = 0; i < triangleCount; i++) {
        var weight = Math.floor(areaArray[i] / totalArea * weightArraySize);
        weight = Math.max(1, weight);

        for (j = 0; j < weight; j++) {
          triangleWeightArray.push(i);
        }
      }

      return triangleWeightArray;
    }
  }, {
    key: "triangleArea",
    value: function triangleArea(v0, v1, v2) {
      var scratchCartesian0 = new Cesium.Cartesian3();
      var scratchCartesian1 = new Cesium.Cartesian3();
      var scratchCartesian2 = new Cesium.Cartesian3();
      scratchCartesian0 = Cesium.Cartesian3.subtract(v1, v0, scratchCartesian0);
      scratchCartesian1 = Cesium.Cartesian3.subtract(v2, v0, scratchCartesian1);
      scratchCartesian2 = Cesium.Cartesian3.cross(scratchCartesian0, scratchCartesian1, scratchCartesian2);
      return 0.5 * Cesium.Cartesian3.magnitude(scratchCartesian2);
    }
  }, {
    key: "randomVertex",
    value: function randomVertex(r1, r2, A, B, C) {
      return (1 - Math.sqrt(r1)) * A + Math.sqrt(r1) * (1 - r2) * B + Math.sqrt(r1) * r2 * C;
    }
  }, {
    key: "getOneRandomPosition",
    value: function getOneRandomPosition() {
      if (!Cesium.defaultValue(this._geometry)) {
        return;
      }

      var indexInWeightArray = Math.floor(Cesium.Math.randomBetween(0.0, this._triangleArrayByWeight.length));
      var triangleIndex = this._triangleArrayByWeight[indexInWeightArray];
      var vertexIndex0 = this._geometry.indices[triangleIndex * 3];
      var vertexIndex1 = this._geometry.indices[triangleIndex * 3 + 1];
      var vertexIndex2 = this._geometry.indices[triangleIndex * 3 + 2];
      var vertices = this._geometry.attributes.position.values;
      var vertex0X = vertices[vertexIndex0 * 3];
      var vertex0Y = vertices[vertexIndex0 * 3 + 1];
      var vertex0Z = vertices[vertexIndex0 * 3 + 2];
      var vertex1X = vertices[vertexIndex1 * 3];
      var vertex1Y = vertices[vertexIndex1 * 3 + 1];
      var vertex1Z = vertices[vertexIndex1 * 3 + 2];
      var vertex2X = vertices[vertexIndex2 * 3];
      var vertex2Y = vertices[vertexIndex2 * 3 + 1];
      var vertex2Z = vertices[vertexIndex2 * 3 + 2];
      var r1 = Cesium.Math.randomBetween(0.0, 1.0);
      var r2 = Cesium.Math.randomBetween(0.0, 1.0);
      var x = this.randomVertex(r1, r2, vertex0X, vertex1X, vertex2X);
      var y = this.randomVertex(r1, r2, vertex0Y, vertex1Y, vertex2Y);
      var z = this.randomVertex(r1, r2, vertex0Z, vertex1Z, vertex2Z);
      return Cesium.Cartesian3.fromElements(x, y, z);
    }
  }, {
    key: "positions",
    get: function get() {
      return this._positions;
    },
    set: function set(positions) {
      if (!Cesium.defaultValue(positions)) {
        return;
      }

      this._positions = positions;
      var PolygonGeometry = Cesium.PolygonGeometry.fromPositions({
        positions: this._positions,
        perPositionHeight: true
      });
      this._geometry = Cesium.PolygonGeometry.createGeometry(PolygonGeometry);
      this._triangleArrayByWeight = this.initWeight(this._geometry);
      this.boundingSphere = Cesium.BoundingSphere.fromPoints(positions);
    }
  }]);

  return PolygonEmitter;
}();

function addPointSymbol(props) {
  // 设置默认值数据
  var state = reactive({
    selectedTypeId: 0,
    //选中符号类型id
    selectedSymbolId: 0,
    //选中符号id
    symbolColor: "#ffffff",
    //符号颜色
    space: 10,
    //直线种树间距
    density: 100,
    //区域种树总数
    addType: 'single'
  }); // 传入props改变默认值

  if (props) {
    for (var key in props) {
      if (state.hasOwnProperty(key)) {
        if (props[key] != undefined) state[key] = props[key];
      } else {
        tool.Message.errorMsg(resource.AttributeError + key);
      }
    }
  } // 初始化数据


  var currentData = s3mModels[state.selectedTypeId].data;
  var s3mInstanceColc;
  var currentSelectedSymbol = null;
  var modelEditor, emitter;
  var isAddLIneFace = false;
  var currentUrls = [];
  var isAddSingle = false;
  var isTooltipShow = true;

  if (storeState.isViewer) {
    if (!window.tooltip) {
      window.tooltip = createTooltip$1(viewer._element);
    }

    s3mInstanceColc = new Cesium.S3MInstanceCollection(scene._context);
    viewer.scene.primitives.add(s3mInstanceColc);
    emitter = new PolygonEmitter(); //区域粒子随机发射器，用于区域添加
  } //viewer 初始化完成的监听


  watch(function () {
    return storeState.isViewer;
  }, function (val) {
    if (val) {
      if (!window.tooltip) {
        window.tooltip = createTooltip$1(viewer._element);
      }

      s3mInstanceColc = new Cesium.S3MInstanceCollection(scene._context);
      viewer.scene.primitives.add(s3mInstanceColc);
      emitter = new PolygonEmitter();
    }
  });

  function changeSelect(id) {
    state.selectedSymbolId = id;
  }

  function click_symbol(e) {
    if (isAddLIneFace) return;

    if (isAddSingle) {
      tooltip.setVisible(false);
      viewer.enableCursorStyle = true;
      document.body.classList.remove("measureCur");
      var position = scene.pickPosition(e.message.position);
      var color = Cesium.Color.fromCssColorString(state.symbolColor);
      var id = 'symbol-' + s3mModels[state.selectedTypeId].id + '-' + currentData[state.selectedSymbolId].id + '-' + new Date().getTime();
      var path = currentData[state.selectedSymbolId].path;
      s3mInstanceColc.add(path, {
        id: id,
        position: position,
        color: color
      });
      if (!currentUrls.includes(path)) currentUrls.push(path);
      isAddSingle = false; // currentSelectedSymbol = s3mInstanceColc.getInstance(currentData[state.selectedSymbolId].path, id)

      return;
    }

    var symbol = viewer.scene.pick(e.message.position) || viewer.selectedEntity;

    if (symbol && symbol.id && typeof symbol.id === 'string' && symbol.id.indexOf("symbol-") != -1) {
      if (currentSelectedSymbol && currentSelectedSymbol.id === symbol.id) return;
      if (modelEditor) modelEditor.destroy();
      currentSelectedSymbol = symbol;
      modelEditor = new Cesium.ModelEditor({
        model: currentSelectedSymbol.primitive,
        scene: viewer.scene // offset: new Cesium.Cartesian3(0, 0, 2)

      });
      modelEditor.activate();
      return;
    }

    if (modelEditor) modelEditor.destroy();
    modelEditor = null;
    currentSelectedSymbol = null;
  }

  function clear() {
    if (currentSelectedSymbol) {
      var id = currentSelectedSymbol.id;
      var ids = id.split('-');
      var url = s3mModels[ids[1]].data[ids[2]].path;

      if (url) {
        s3mInstanceColc.removeInstance(url, id);
        currentSelectedSymbol = null;
      }
    } else {
      currentUrls.forEach(function (url) {
        s3mInstanceColc.removeCollection(url);
      });
      currentUrls.length = 0;
    }

    if (currentUrls.length === 0) {
      viewer.eventManager.removeEventListener("CLICK", click_symbol); //移除鼠标点击事件监听
    }

    if (modelEditor) modelEditor.destroy();
    modelEditor = null;
    window.tooltip.setVisible(false);
    clearHandlerDrawing('Polyline');
    clearHandlerDrawing('Polygon');
    isAddSingle = false;
    viewer.enableCursorStyle = true;
    document.body.classList.remove("measureCur");
  } //单个添加


  function add_single() {
    viewer.enableCursorStyle = false;
    viewer._element.style.cursor = "";
    document.body.classList.add("measureCur");
    isAddSingle = true;
  } // 沿线添加


  function add_line() {
    isAddLIneFace = true;

    if (!window.handlerPolyline) {
      initHandler("Polyline");
    }

    handlerDrawing("Polyline").then(function (res) {
      DrawPolylineUpdate('', res.result.object); //划线效果

      var handlerPolyline = window.handlerPolyline;
      handlerPolyline.polyline.show = false;
      window.polylineTransparent.show = false; //半透线隐藏

      handlerPolyline.deactivate();
      tooltip.setVisible(false);
    }, function (err) {
      console.log(err);
    });
    window.handlerPolyline.activate();
  }

  function DrawPolylineUpdate(position, line) {
    var positions = [];

    for (var i = 1, j = line._positions.length; i < j; i++) {
      var startPoint = line._positions[i - 1];
      var endPoint = line._positions[i];
      var d = Cesium.Cartesian3.distance(startPoint, endPoint);
      var count = getCount(parseInt(d));

      for (var _i = 1, _j = count; _i <= _j; _i++) {
        positions.push(Cesium.Cartesian3.lerp(startPoint, endPoint, _i / count, new Cesium.Cartesian3()));
      }
    }

    viewer.scene.clampToHeightMostDetailed(positions).then(function (Cartesians) {
      isAddLIneFace = false;
      var color = Cesium.Color.fromCssColorString(state.symbolColor);
      var id = 'symbol-' + s3mModels[state.selectedTypeId].id + '-' + currentData[state.selectedSymbolId].id + '-';
      var path = currentData[state.selectedSymbolId].path;
      if (!currentUrls.includes(path)) currentUrls.push(path);

      for (var _i2 = 0, _j2 = Cartesians.length; _i2 <= _j2; _i2++) {
        s3mInstanceColc.add(path, {
          id: id + new Date().getTime() + _i2,
          position: Cartesians[_i2],
          color: color
        });
      }
    });
  } //精度计算count插值


  function getCount(distance) {
    var space = Number(state.space);
    return parseInt(distance / space) + 1;
  } //区域添加


  function add_face() {
    isAddLIneFace = true;

    if (!window.handlerPolygon) {
      initHandler("Polygon");
    }

    handlerDrawing("Polygon", false).then(function (res) {
      tooltip.setVisible(false);
      var handlerPolygon = window.handlerPolygon;
      handlerPolygon.polygon.show = false;
      handlerPolygon.polyline.show = false;
      handlerPolygon.deactivate();
      emitter.initPolygonEmitter(res.result.object.positions);
      var color = Cesium.Color.fromCssColorString(state.symbolColor);
      var id = 'symbol-' + s3mModels[state.selectedTypeId].id + '-' + currentData[state.selectedSymbolId].id + '-';
      var path = currentData[state.selectedSymbolId].path;
      if (!currentUrls.includes(path)) currentUrls.push(path);
      var density = Number(state.density);

      for (var i = 0; i < density; i++) {
        var p = emitter.getOneRandomPosition();
        s3mInstanceColc.add(path, {
          id: id + new Date().getTime() + i,
          position: p,
          color: color
        });
      }

      isAddLIneFace = false;
    }, function (err) {
      console.log(err);
    });
    window.handlerPolygon.activate();
  } // 开始添加


  function statrtAdd() {
    if (isTooltipShow) {
      window.tooltip.showAt('<p>选中模型可以编辑和清除选中模型</p><p>未选中模型时清除所有</p>', '420px');
      isTooltipShow = false;
    }

    viewer.eventManager.addEventListener("CLICK", click_symbol, true);

    switch (state.addType) {
      case 'single':
        add_single();
        break;

      case 'line':
        add_line();
        break;

      case 'face':
        add_face();
        break;

      default:
        add_single();
        break;
    }
  } // 销毁


  onBeforeUnmount(function () {
    currentData.length = 0;
    s3mInstanceColc = null;
    currentSelectedSymbol = null;
    if (modelEditor) modelEditor.destroy();
    currentUrls.length = 0;
  });
  watch(function () {
    return state.selectedTypeId;
  }, function (val) {
    currentData = s3mModels[state.selectedTypeId].data;
  });
  watch(function () {
    return state.symbolColor;
  }, function (val) {
    var color = Cesium.Color.fromCssColorString(val);

    if (currentSelectedSymbol) {
      var instance = currentSelectedSymbol.primitive;
      var index = currentSelectedSymbol.id;
      instance.updateColor(color, index);
    }
  });
  return _objectSpread2(_objectSpread2({}, toRefs(state)), {}, {
    s3mModels: s3mModels,
    changeSelect: changeSelect,
    clear: clear,
    statrtAdd: statrtAdd
  });
}

var script = {
  name: "Sm3dPointSymbol",
  props: {
    // 选中符号类型id
    selectedTypeId: {
      type: Number
    },
    // 符号颜色
    symbolColor: {
      type: String
    },
    // 直线种树间距
    space: {
      type: Number
    },
    // 区域种树总数
    density: {
      type: Number
    }
  },
  setup: function setup(props) {
    var _addPointSymbol = addPointSymbol(props),
        s3mModels = _addPointSymbol.s3mModels,
        selectedTypeId = _addPointSymbol.selectedTypeId,
        selectedSymbolId = _addPointSymbol.selectedSymbolId,
        symbolColor = _addPointSymbol.symbolColor,
        changeSelect = _addPointSymbol.changeSelect,
        space = _addPointSymbol.space,
        density = _addPointSymbol.density,
        clear = _addPointSymbol.clear,
        statrtAdd = _addPointSymbol.statrtAdd,
        addType = _addPointSymbol.addType;

    return {
      s3mModels: s3mModels,
      selectedTypeId: selectedTypeId,
      selectedSymbolId: selectedSymbolId,
      symbolColor: symbolColor,
      changeSelect: changeSelect,
      space: space,
      density: density,
      clear: clear,
      statrtAdd: statrtAdd,
      addType: addType
    };
  }
};

var _hoisted_1 = {
  id: "draw-panel",
  "class": "sm-panel"
};
var _hoisted_2 = {
  "class": "sm-function-module-sub-section",
  style: {
    "margin": "0"
  }
};
var _hoisted_3 = {
  "class": "sm-half-L"
};

var _hoisted_4 = /*#__PURE__*/createElementVNode("label", {
  style: {
    "width": "35%"
  }
}, "符号类型", -1
/* HOISTED */
);

var _hoisted_5 = {
  "class": "sm-half-L symbolic"
};
var _hoisted_6 = ["title", "onClick"];
var _hoisted_7 = ["src"];

var _hoisted_8 = /*#__PURE__*/createElementVNode("div", {
  "class": "sm-half-L"
}, [/*#__PURE__*/createElementVNode("label", {
  style: {
    "width": "35%"
  }
}, "符号颜色"), /*#__PURE__*/createElementVNode("input", {
  type: "color"
})], -1
/* HOISTED */
);

var _hoisted_9 = {
  "class": "sm-half-L"
};

var _hoisted_10 = /*#__PURE__*/createElementVNode("label", {
  style: {
    "width": "35%"
  }
}, "添加模式", -1
/* HOISTED */
);

var _hoisted_11 = /*#__PURE__*/createTextVNode("单个添加");

var _hoisted_12 = /*#__PURE__*/createTextVNode("沿线添加");

var _hoisted_13 = /*#__PURE__*/createTextVNode("区域添加");

var _hoisted_14 = {
  "class": "sm-half-L"
};

var _hoisted_15 = /*#__PURE__*/createElementVNode("label", {
  style: {
    "width": "35%"
  }
}, "间距", -1
/* HOISTED */
);

var _hoisted_16 = {
  "class": "sm-half-L"
};

var _hoisted_17 = /*#__PURE__*/createElementVNode("label", {
  style: {
    "width": "35%"
  }
}, "数量", -1
/* HOISTED */
);

var _hoisted_18 = {
  "class": "boxchild"
};
function render(_ctx, _cache, $props, $setup, $data, $options) {
  var _component_a_select_option = resolveComponent("a-select-option");

  var _component_a_select = resolveComponent("a-select");

  var _component_a_input_number = resolveComponent("a-input-number");

  var _directive_stopdrag = resolveDirective("stopdrag");

  var _directive_drag = resolveDirective("drag");

  return withDirectives((openBlock(), createElementBlock("div", _hoisted_1, [withDirectives((openBlock(), createElementBlock("div", _hoisted_2, [createElementVNode("div", _hoisted_3, [_hoisted_4, createVNode(_component_a_select, {
    "class": "sm-select",
    style: {
      "width": "63%"
    },
    modelValue: $setup.selectedTypeId,
    "onUpdate:modelValue": _cache[0] || (_cache[0] = function ($event) {
      return $setup.selectedTypeId = $event;
    })
  }, {
    "default": withCtx(function () {
      return [(openBlock(true), createElementBlock(Fragment, null, renderList($setup.s3mModels, function (model) {
        return openBlock(), createBlock(_component_a_select_option, {
          key: model.id,
          value: model.id
        }, {
          "default": withCtx(function () {
            return [createTextVNode(toDisplayString(model.name), 1
            /* TEXT */
            )];
          }),
          _: 2
          /* DYNAMIC */

        }, 1032
        /* PROPS, DYNAMIC_SLOTS */
        , ["value"]);
      }), 128
      /* KEYED_FRAGMENT */
      ))];
    }),
    _: 1
    /* STABLE */

  }, 8
  /* PROPS */
  , ["modelValue"])]), createElementVNode("div", _hoisted_5, [(openBlock(true), createElementBlock(Fragment, null, renderList($setup.s3mModels[$setup.selectedTypeId].data, function (model, index) {
    return openBlock(), createElementBlock("div", {
      key: model.id,
      "class": normalizeClass(["symbolic-box", {
        'theme-border-color': model.id === $setup.selectedSymbolId
      }]),
      style: {
        "width": "40px"
      },
      title: model.name,
      onClick: function onClick($event) {
        return $setup.changeSelect(index);
      }
    }, [withDirectives(createElementVNode("img", {
      src: model.thumbnail,
      alt: ""
    }, null, 8
    /* PROPS */
    , _hoisted_7), [[vShow, model.name]])], 10
    /* CLASS, PROPS */
    , _hoisted_6);
  }), 128
  /* KEYED_FRAGMENT */
  ))]), _hoisted_8, createElementVNode("div", _hoisted_9, [_hoisted_10, createVNode(_component_a_select, {
    "class": "sm-select",
    style: {
      "width": "63%"
    },
    modelValue: $setup.addType,
    "onUpdate:modelValue": _cache[1] || (_cache[1] = function ($event) {
      return $setup.addType = $event;
    })
  }, {
    "default": withCtx(function () {
      return [createVNode(_component_a_select_option, {
        value: "single"
      }, {
        "default": withCtx(function () {
          return [_hoisted_11];
        }),
        _: 1
        /* STABLE */

      }), createVNode(_component_a_select_option, {
        value: "line"
      }, {
        "default": withCtx(function () {
          return [_hoisted_12];
        }),
        _: 1
        /* STABLE */

      }), createVNode(_component_a_select_option, {
        value: "face"
      }, {
        "default": withCtx(function () {
          return [_hoisted_13];
        }),
        _: 1
        /* STABLE */

      })];
    }),
    _: 1
    /* STABLE */

  }, 8
  /* PROPS */
  , ["modelValue"])]), withDirectives(createElementVNode("div", _hoisted_14, [_hoisted_15, createVNode(_component_a_input_number, {
    value: _ctx.inputValue1,
    "onUpdate:value": _cache[2] || (_cache[2] = function ($event) {
      return _ctx.inputValue1 = $event;
    }),
    min: 1,
    max: 20,
    style: {
      "margin-left": "16px"
    }
  }, null, 8
  /* PROPS */
  , ["value"])], 512
  /* NEED_PATCH */
  ), [[vShow, $setup.addType === 'line']]), withDirectives(createElementVNode("div", _hoisted_16, [_hoisted_17, createVNode(_component_a_input_number, {
    value: _ctx.inputValue1,
    "onUpdate:value": _cache[3] || (_cache[3] = function ($event) {
      return _ctx.inputValue1 = $event;
    }),
    min: 1,
    max: 20,
    style: {
      "margin-left": "16px"
    }
  }, null, 8
  /* PROPS */
  , ["value"])], 512
  /* NEED_PATCH */
  ), [[vShow, $setup.addType === 'face']]), createElementVNode("div", _hoisted_18, [createElementVNode("button", {
    "class": "tbtn",
    type: "button ",
    onClick: _cache[4] || (_cache[4] = function () {
      return $setup.statrtAdd && $setup.statrtAdd.apply($setup, arguments);
    })
  }, "添加"), createElementVNode("button", {
    "class": "tbtn tbtn-margin-left",
    type: "button ",
    onClick: _cache[5] || (_cache[5] = function () {
      return $setup.clear && $setup.clear.apply($setup, arguments);
    })
  }, "清除")])])), [[_directive_stopdrag]])])), [[_directive_drag]]);
}

script.render = render;
script.__file = "src/components/draw/add-point-symbol/add-point-symbol.vue";

script.install = function (app) {
  app.component(script.name, script);
};

export default script;
