import { reactive, toRefs, watch, onBeforeUnmount, resolveDirective, withDirectives, openBlock, createElementBlock, createElementVNode, vModelRadio, createTextVNode, toDisplayString } from 'vue';

function _typeof(obj) {
  "@babel/helpers - typeof";

  if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
    _typeof = function (obj) {
      return typeof obj;
    };
  } else {
    _typeof = function (obj) {
      return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
    };
  }

  return _typeof(obj);
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);

  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    if (enumerableOnly) symbols = symbols.filter(function (sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    });
    keys.push.apply(keys, symbols);
  }

  return keys;
}

function _objectSpread2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};

    if (i % 2) {
      ownKeys(Object(source), true).forEach(function (key) {
        _defineProperty(target, key, source[key]);
      });
    } else if (Object.getOwnPropertyDescriptors) {
      Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
      ownKeys(Object(source)).forEach(function (key) {
        Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
      });
    }
  }

  return target;
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

  return arr2;
}

function _createForOfIteratorHelper(o, allowArrayLike) {
  var it;

  if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) {
    if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") {
      if (it) o = it;
      var i = 0;

      var F = function () {};

      return {
        s: F,
        n: function () {
          if (i >= o.length) return {
            done: true
          };
          return {
            done: false,
            value: o[i++]
          };
        },
        e: function (e) {
          throw e;
        },
        f: F
      };
    }

    throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
  }

  var normalCompletion = true,
      didErr = false,
      err;
  return {
    s: function () {
      it = o[Symbol.iterator]();
    },
    n: function () {
      var step = it.next();
      normalCompletion = step.done;
      return step;
    },
    e: function (e) {
      didErr = true;
      err = e;
    },
    f: function () {
      try {
        if (!normalCompletion && it.return != null) it.return();
      } finally {
        if (didErr) throw err;
      }
    }
  };
}

/*
* 常用工具类
*/
//axios本版本不支持jsonp
var axiosJsonp = function axiosJsonp(url) {
  if (!url) {
    console.error('Axios.JSONP 至少需要一个url参数!');
    return;
  }

  return new Promise(function (resolve, reject) {
    window.jsonCallBack = function (result) {
      resolve(result);
    };

    var JSONP = document.createElement("script");
    JSONP.type = "text/javascript";
    JSONP.src = "".concat(url, "&callback=jsonCallBack");
    document.getElementsByTagName("head")[0].appendChild(JSONP);
    setTimeout(function () {
      document.getElementsByTagName("head")[0].removeChild(JSONP);
    }, 500);
  });
}; //判断两数组或对象相等


var isEqualArr = function isEqualArr(arg1, arg2) {
  if (!arg1 || !arg2) return true;
  var bol = true;

  if (Object.keys(arg1).length != Object.keys(arg2).length) {
    return false;
  }

  for (var key in arg1) {
    if (_typeof(arg1[key]) == 'object') {
      bol = isSame(arg1[key], arg2[key]);

      if (!bol) {
        break;
      }
    } else if (arg1[key] != arg2[key]) {
      bol = false;
      break;
    }
  }

  return bol;
}; //坐标转化
//笛卡尔转经纬度


var CartesiantoDegrees = function CartesiantoDegrees(Cartesians) {
  var array = [].concat(Cartesians);
  var positions = [];

  for (var i = 0, len = array.length; i < len; i++) {
    var cartographic = Cesium.Cartographic.fromCartesian(array[i]);
    var longitude = Cesium.Math.toDegrees(cartographic.longitude);
    var latitude = Cesium.Math.toDegrees(cartographic.latitude);
    var h = cartographic.height;

    if (positions.indexOf(longitude) == -1 && positions.indexOf(latitude) == -1) {
      positions.push(longitude);
      positions.push(latitude);
      positions.push(h);
    }
  }

  return positions;
}; //笛卡尔转经纬度(每个点是独立的对象)


var CartesiantoDegreesObjs = function CartesiantoDegreesObjs(Cartesians) {
  var array = [].concat(Cartesians);
  var positions = [];

  for (var i = 0, len = array.length; i < len; i++) {
    var cartographic = Cesium.Cartographic.fromCartesian(array[i]);
    var obj = {
      longitude: Cesium.Math.toDegrees(cartographic.longitude),
      latitude: Cesium.Math.toDegrees(cartographic.latitude),
      height: cartographic.height
    };
    positions.push(obj);
  }

  return positions;
}; // 弧度转经纬度


var CartographictoDegrees = function CartographictoDegrees(wgsPosition) {
  var longitude = Cesium.Math.toDegrees(wgsPosition.longitude);
  var latitude = Cesium.Math.toDegrees(wgsPosition.latitude);
  var height = wgsPosition.height;
  return [longitude, latitude, height];
}; //去重函数  数组


var unique = function unique(arr) {
  var res = [];
  var json = {};

  for (var i = 0; i < arr.length; i++) {
    if (!json[arr[i]]) {
      res.push(arr[i]);
      json[arr[i]] = 1;
    }
  }

  return res;
}; // 获取渐变色函数


function gradientColors(start, end, steps, gamma) {
  var i,
      j,
      ms,
      me,
      output = [],
      so = [];
  gamma = gamma || 1;

  var normalize = function normalize(channel) {
    return Math.pow(channel / 255, gamma);
  };

  start = parseColor(start).map(normalize);
  end = parseColor(end).map(normalize);

  for (i = 0; i < steps; i++) {
    ms = i / (steps - 1);
    me = 1 - ms;

    for (j = 0; j < 3; j++) {
      so[j] = pad(Math.round(Math.pow(start[j] * me + end[j] * ms, 1 / gamma) * 255).toString(16));
    }

    output.push('#' + so.join(''));
  }

  return output;

  function parseColor(hexStr) {
    return hexStr.length === 4 ? hexStr.substr(1).split('').map(function (s) {
      return 0x11 * parseInt(s, 16);
    }) : [hexStr.substr(1, 2), hexStr.substr(3, 2), hexStr.substr(5, 2)].map(function (s) {
      return parseInt(s, 16);
    });
  }

  function pad(s) {
    return s.length === 1 ? '0' + s : s;
  }
}

function getAngleAndRadian(pointA, pointB) {
  //建立以点A为原点，X轴为east,Y轴为north,Z轴朝上的坐标系
  var transform = Cesium.Transforms.eastNorthUpToFixedFrame(pointA); //向量AB

  var positionvector = Cesium.Cartesian3.subtract(pointB, pointA, new Cesium.Cartesian3()); //因transform是将A为原点的eastNorthUp坐标系中的点转换到世界坐标系的矩阵
  //AB为世界坐标中的向量
  //因此将AB向量转换为A原点坐标系中的向量，需乘以transform的逆矩阵。

  var vector = Cesium.Matrix4.multiplyByPointAsVector(Cesium.Matrix4.inverse(transform, new Cesium.Matrix4()), positionvector, new Cesium.Cartesian3()); //归一化

  var direction = Cesium.Cartesian3.normalize(vector, new Cesium.Cartesian3()); //heading

  var heading1 = Math.atan2(direction.y, direction.x) - Cesium.Math.PI_OVER_TWO;
  var radian = Cesium.Math.TWO_PI - Cesium.Math.zeroToTwoPi(heading1);
  var angle = radian * (180 / Math.PI);

  if (angle < 0) {
    angle = angle + 360;
  }

  return {
    angle: angle,
    radian: radian
  };
}

function getPitch(pointA, pointB) {
  var transfrom = Cesium.Transforms.eastNorthUpToFixedFrame(pointA);
  var vector = Cesium.Cartesian3.subtract(pointB, pointA, new Cesium.Cartesian3());
  var direction = Cesium.Matrix4.multiplyByPointAsVector(Cesium.Matrix4.inverse(transfrom, transfrom), vector, vector);
  Cesium.Cartesian3.normalize(direction, direction); //因为direction已归一化，斜边长度等于1，所以余弦函数等于direction.z

  var radian = Cesium.Math.PI_OVER_TWO - Cesium.Math.acosClamped(direction.z);
  var angle = radian * (180 / Math.PI);

  if (angle < 0) {
    angle = angle + 360;
  }

  return {
    angle: angle,
    radian: radian
  };
}

var tool = {
  axiosJsonp: axiosJsonp,
  isEqualArr: isEqualArr,
  CartesiantoDegrees: CartesiantoDegrees,
  CartesiantoDegreesObjs: CartesiantoDegreesObjs,
  unique: unique,
  gradientColors: gradientColors,
  getAngleAndRadian: getAngleAndRadian,
  CartographictoDegrees: CartographictoDegrees,
  getPitch: getPitch
};

var ResourceCN = {
  showRenderLoopErrors: '渲染时发生错误，已停止渲染。',
  AttributeError: '该组件props没有这个属性：',
  NoPickPositionSupported: "不支持深度纹理,无法绘制多边形，地形操作功能无法使用！",
  NoTerrain: "请在地形里使用地形组件！",
  initViewerWarn: '请先初始化viewer!',
  MoveMouseHeightBox: '点击鼠标左键结束矩形绘制，移动鼠标绘制box高度',
  RightClickEndDrawing: '右键单击结束绘制',
  LeftClickBottomBox: '点击鼠标左键，开始绘制矩形作为box底面',
  ClickModelAddBox: '点击模型，添加裁剪盒子',
  SkyLineWarn: "获取天际线体前，请先绘制天际线！",
  SkyLineBody: '天际线体',
  ShadowqueryWarn: "此操作需要先开启阴影！",
  VeiwshedBody: '可视体',
  VeiwshedBodyHidden: '不可视体',
  EchartsErr: "二维显示需要echarts支持，未找到相关依赖！",
  BaseMapImg: '底图',
  tip1: '<p>点击左键确定操作区域中间点</p><p>右键单击结束绘制</p>'
};

// 组件内部的语言资源：主要包括提示信息
var currentLanguage, Resource;
var cookieLanguage = getLang().toLowerCase();

function getLang() {
  //浏览器语言  IE用browserLanguage，非IE使用language进行判断
  var lang = (navigator.language || navigator.browserLanguage).toLowerCase();
  window.lang = lang; //判断portal设置语言 通过cookie获取
  //   const cookies = document.cookie.split(';');
  //   if (cookies.length > 0) {
  //     cookies.forEach(function (cookie) {
  //       const arr = cookie.split('=');
  //       if (arr[0].toLowerCase().trim() === 'language') {
  //         lang = arr[1];
  //         return;
  //       }
  //     });
  //   }

  return lang;
}

if (cookieLanguage !== undefined) {
  currentLanguage = cookieLanguage;
} else {
  currentLanguage = (navigator.language || navigator.browserLanguage).toLowerCase(); // 获取当前浏览器的语言
}

if (currentLanguage.startsWith('zh')) {
  Resource = ResourceCN;
} else if (currentLanguage.startsWith('ja')) {
  Resource = ResourceCN;
} else {
  Resource = ResourceCN;
}

var resource = Resource;

function createTooltip(frameDiv) {
  var tooltip = function tooltip(frameDiv) {
    var div = document.createElement('DIV');
    div.className = "tooltip";
    this._div = div;
    this.message = '';
    frameDiv.appendChild(div);
  };

  tooltip.prototype.setVisible = function (visible) {
    if (visible) {
      this._div.style.right = '10px';
    } else {
      this._div.style.right = '-300px';
    }
  };

  tooltip.prototype.showAt = function (message, top) {
    //top:200px => string
    if (top) {
      this._div.style.top = top;
    }

    if (message) {
      this.setVisible(true);
      this._div.innerHTML = message;
    }
  };

  return new tooltip(frameDiv);
}

// 创建一个简单的store状态管理

var storeState = reactive({
  isViewer: false,
  //viewer初始化标志
  changeLayers: 0,
  //图层改变加载完毕监听
  changeGeometrys: 0 //三维分析体改变标志

});

function clipBoxByeditor(props) {
  // 设置默认值数据
  var state = reactive({
    clipModel: 'ClipInside' //裁剪模式js

  }); // 传入props改变默认值

  if (props) {
    for (var key in props) {
      if (state.hasOwnProperty(key)) {
        if (props[key] != undefined) state[key] = props[key];
      } else {
        tool.Message.errorMsg(resource.AttributeError + key);
      }
    }
  } // 初始化数据


  var clipMode = 'clip_behind_all_plane'; //裁剪模式值 外部: clip_behind_any_plane

  var layers, handlerBox, boxEntity, editorBox;

  if (storeState.isViewer) {
    layers = viewer.scene.layers.layerQueue;
    handlerBox = new Cesium.DrawHandler(viewer, Cesium.DrawMode.Box);

    if (!window.tooltip) {
      window.tooltip = createTooltip(viewer._element);
    }
  } //viewer 初始化完成的监听


  watch(function () {
    return storeState.isViewer;
  }, function (val) {
    if (val) {
      layers = viewer.scene.layers.layerQueue;
      handlerBox = new Cesium.DrawHandler(viewer, Cesium.DrawMode.Box);

      if (!window.tooltip) {
        window.tooltip = createTooltip(viewer._element);
      }
    }
  });
  /*
   ***裁剪交互分析模块***
  */
  // 分析

  function BoxClipByEitor() {
    clearBoxClipByEitor();

    if (editorBox) {
      handlerBox.activate();
      return;
    } // 设置裁剪线颜色


    setAllLayersClipColor(); //交互绘制box

    handlerBox.movingEvt.addEventListener(function (windowPosition) {
      if (handlerBox.isDrawing) {
        tooltip.showAt(' <p>点击鼠标左键结束绘制box底面</p><p>移动鼠标绘制box高度</p><p>点击鼠标右键结束绘制</p>', '230px');
      } else {
        tooltip.showAt(' <p>点击鼠标左键开始绘制box底面</p>', '230px');
      }
    });
    handlerBox.drawEvt.addEventListener(function (e) {
      boxEntity = e.object; // let boxEntity = this.boxEntity;

      var newDim = boxEntity.box.dimensions.getValue();
      var position = boxEntity.position.getValue(0);
      var boxOption = {
        dimensions: newDim,
        position: position,
        clipMode: clipMode,
        heading: 0
      }; //box编辑

      editorBox = new Cesium.BoxEditor(viewer, boxEntity);
      editorBox.editEvt.addEventListener(function (e) {
        boxEntity.box.dimensions = e.dimensions;
        boxEntity.position = e.position;
        boxEntity.orientation = e.orientation;
        setClipBox();
      });
      editorBox.activate();
      setAllLayersClipOptions(boxOption);
      tooltip.setVisible(false);
      handlerBox.clear();
      handlerBox.deactivate();
    });
    handlerBox.activate();
  }

  function setClipBox() {
    if (typeof boxEntity == "undefined") {
      return;
    }

    var newDim = boxEntity.box.dimensions.getValue();
    var position = boxEntity.position.getValue(0);
    var heading = 0;

    if (typeof boxEntity.orientation != "undefined") {
      var rotationM3 = Cesium.Matrix3.fromQuaternion(boxEntity.orientation._value, new Cesium.Matrix3());
      var localFrame = Cesium.Matrix4.fromRotationTranslation(rotationM3, Cesium.Cartesian3.ZERO, new Cesium.Matrix4());
      var inverse = Cesium.Matrix4.inverse(Cesium.Transforms.eastNorthUpToFixedFrame(position), new Cesium.Matrix4());
      var hprm = Cesium.Matrix4.multiply(inverse, localFrame, new Cesium.Matrix4());
      var rotation = Cesium.Matrix4.getMatrix3(hprm, new Cesium.Matrix3());
      var hpr = Cesium.HeadingPitchRoll.fromQuaternion(Cesium.Quaternion.fromRotationMatrix(rotation));
      heading = hpr.heading;
    }

    var boxOptions = {
      dimensions: newDim,
      position: position,
      clipMode: clipMode,
      heading: heading
    };
    setAllLayersClipOptions(boxOptions);
  }

  function setAllLayersClipOptions(boxOptions) {
    for (var i = 0, j = layers.length; i < j; i++) {
      layers[i].setCustomClipBox(boxOptions);
    }
  }

  function setAllLayersClipColor() {
    for (var i = 0, j = layers.length; i < j; i++) {
      layers[i].selectEnabled = false;
      layers[i].clipLineColor = new Cesium.Color(1, 1, 1, 0);
    }
  }

  function clearBoxClipByEitor() {
    if (handlerBox) {
      handlerBox.deactivate();
      tooltip.setVisible(false);
    }

    if (!boxEntity) {
      return;
    }

    var _iterator = _createForOfIteratorHelper(layers),
        _step;

    try {
      for (_iterator.s(); !(_step = _iterator.n()).done;) {
        var layer = _step.value;
        layer.clearCustomClipBox();
      }
    } catch (err) {
      _iterator.e(err);
    } finally {
      _iterator.f();
    }

    boxEntity = undefined;
    editorBox.deactivate();
    viewer.entities.removeAll();
    handlerBox.clear();
  }

  watch(function () {
    return state.clipModel;
  }, function (val) {
    switch (val) {
      case "ClipInside":
        clipMode = 'clip_behind_all_plane';
        break;

      case "ClipOutside":
        clipMode = 'clip_behind_any_plane';
        break;
    }

    if (boxEntity) {
      setClipBox();
    }
  }); // 销毁

  onBeforeUnmount(function () {
    if (editorBox) {
      editorBox.destroy();
    }

    editorBox = undefined;
    layers = undefined;
    handlerBox = undefined;
    boxEntity = undefined;
  });
  return _objectSpread2(_objectSpread2({}, toRefs(state)), {}, {
    BoxClipByEitor: BoxClipByEitor,
    clearBoxClipByEitor: clearBoxClipByEitor
  });
}

var script = {
  name: "Sm3dClipBoxByeditor",
  props: {
    //裁剪模式
    clipModel: {
      type: String,
      "default": "ClipInside"
    }
  },
  setup: function setup(props) {
    var _clipBoxByeditor = clipBoxByeditor(props),
        clipModel = _clipBoxByeditor.clipModel,
        BoxClipByEitor = _clipBoxByeditor.BoxClipByEitor,
        clearBoxClipByEitor = _clipBoxByeditor.clearBoxClipByEitor;

    return {
      clipModel: clipModel,
      BoxClipByEitor: BoxClipByEitor,
      clearBoxClipByEitor: clearBoxClipByEitor
    };
  }
};

var _hoisted_1 = {
  id: "clip-box-panel",
  "class": "sm-panel"
};
var _hoisted_2 = {
  "class": "sm-function-module-sub-section",
  style: {
    "margin": "0"
  }
};
var _hoisted_3 = {
  "class": "sm-half-L"
};
var _hoisted_4 = {
  style: {
    "width": "auto"
  }
};
var _hoisted_5 = {
  style: {
    "width": "auto"
  }
};
var _hoisted_6 = {
  "class": "boxchild"
};
function render(_ctx, _cache, $props, $setup, $data, $options) {
  var _directive_stopdrag = resolveDirective("stopdrag");

  var _directive_drag = resolveDirective("drag");

  return withDirectives((openBlock(), createElementBlock("div", _hoisted_1, [withDirectives((openBlock(), createElementBlock("div", _hoisted_2, [createElementVNode("div", _hoisted_3, [createElementVNode("label", _hoisted_4, [withDirectives(createElementVNode("input", {
    type: "radio",
    value: "ClipInside",
    "onUpdate:modelValue": _cache[0] || (_cache[0] = function ($event) {
      return $setup.clipModel = $event;
    })
  }, null, 512
  /* NEED_PATCH */
  ), [[vModelRadio, $setup.clipModel]]), createTextVNode(toDisplayString(_ctx.Resource.clipInside), 1
  /* TEXT */
  )]), createElementVNode("label", _hoisted_5, [withDirectives(createElementVNode("input", {
    type: "radio",
    value: "ClipOutside",
    "onUpdate:modelValue": _cache[1] || (_cache[1] = function ($event) {
      return $setup.clipModel = $event;
    })
  }, null, 512
  /* NEED_PATCH */
  ), [[vModelRadio, $setup.clipModel]]), createTextVNode(toDisplayString(_ctx.Resource.clipOutside), 1
  /* TEXT */
  )])]), createElementVNode("div", _hoisted_6, [createElementVNode("button", {
    onClick: _cache[2] || (_cache[2] = function () {
      return $setup.BoxClipByEitor && $setup.BoxClipByEitor.apply($setup, arguments);
    }),
    "class": "tbtn",
    type: "button"
  }, toDisplayString(_ctx.Resource.clip), 1
  /* TEXT */
  ), createElementVNode("button", {
    onClick: _cache[3] || (_cache[3] = function () {
      return $setup.clearBoxClipByEitor && $setup.clearBoxClipByEitor.apply($setup, arguments);
    }),
    "class": "tbtn tbtn-margin-left",
    type: "button"
  }, toDisplayString(_ctx.Resource.clear), 1
  /* TEXT */
  )])])), [[_directive_stopdrag]])])), [[_directive_drag]]);
}

script.render = render;
script.__file = "src/components/clip/clip-box-editor/clip-box-editor.vue";

script.install = function (app) {
  app.component(script.name, script);
};

export default script;
