import { reactive, toRefs, watch, onBeforeUnmount, resolveComponent, resolveDirective, withDirectives, openBlock, createElementBlock, createElementVNode, toDisplayString, createVNode, vModelText } from 'vue';

function _typeof(obj) {
  "@babel/helpers - typeof";

  if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
    _typeof = function (obj) {
      return typeof obj;
    };
  } else {
    _typeof = function (obj) {
      return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
    };
  }

  return _typeof(obj);
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);

  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    if (enumerableOnly) symbols = symbols.filter(function (sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    });
    keys.push.apply(keys, symbols);
  }

  return keys;
}

function _objectSpread2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};

    if (i % 2) {
      ownKeys(Object(source), true).forEach(function (key) {
        _defineProperty(target, key, source[key]);
      });
    } else if (Object.getOwnPropertyDescriptors) {
      Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
      ownKeys(Object(source)).forEach(function (key) {
        Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
      });
    }
  }

  return target;
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

  return arr2;
}

function _createForOfIteratorHelper(o, allowArrayLike) {
  var it;

  if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) {
    if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") {
      if (it) o = it;
      var i = 0;

      var F = function () {};

      return {
        s: F,
        n: function () {
          if (i >= o.length) return {
            done: true
          };
          return {
            done: false,
            value: o[i++]
          };
        },
        e: function (e) {
          throw e;
        },
        f: F
      };
    }

    throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
  }

  var normalCompletion = true,
      didErr = false,
      err;
  return {
    s: function () {
      it = o[Symbol.iterator]();
    },
    n: function () {
      var step = it.next();
      normalCompletion = step.done;
      return step;
    },
    e: function (e) {
      didErr = true;
      err = e;
    },
    f: function () {
      try {
        if (!normalCompletion && it.return != null) it.return();
      } finally {
        if (didErr) throw err;
      }
    }
  };
}

/*
* 常用工具类
*/
//axios本版本不支持jsonp
var axiosJsonp = function axiosJsonp(url) {
  if (!url) {
    console.error('Axios.JSONP 至少需要一个url参数!');
    return;
  }

  return new Promise(function (resolve, reject) {
    window.jsonCallBack = function (result) {
      resolve(result);
    };

    var JSONP = document.createElement("script");
    JSONP.type = "text/javascript";
    JSONP.src = "".concat(url, "&callback=jsonCallBack");
    document.getElementsByTagName("head")[0].appendChild(JSONP);
    setTimeout(function () {
      document.getElementsByTagName("head")[0].removeChild(JSONP);
    }, 500);
  });
}; //判断两数组或对象相等


var isEqualArr = function isEqualArr(arg1, arg2) {
  if (!arg1 || !arg2) return true;
  var bol = true;

  if (Object.keys(arg1).length != Object.keys(arg2).length) {
    return false;
  }

  for (var key in arg1) {
    if (_typeof(arg1[key]) == 'object') {
      bol = isSame(arg1[key], arg2[key]);

      if (!bol) {
        break;
      }
    } else if (arg1[key] != arg2[key]) {
      bol = false;
      break;
    }
  }

  return bol;
}; //坐标转化
//笛卡尔转经纬度


var CartesiantoDegrees = function CartesiantoDegrees(Cartesians) {
  var array = [].concat(Cartesians);
  var positions = [];

  for (var i = 0, len = array.length; i < len; i++) {
    var cartographic = Cesium.Cartographic.fromCartesian(array[i]);
    var longitude = Cesium.Math.toDegrees(cartographic.longitude);
    var latitude = Cesium.Math.toDegrees(cartographic.latitude);
    var h = cartographic.height;

    if (positions.indexOf(longitude) == -1 && positions.indexOf(latitude) == -1) {
      positions.push(longitude);
      positions.push(latitude);
      positions.push(h);
    }
  }

  return positions;
}; //笛卡尔转经纬度(每个点是独立的对象)


var CartesiantoDegreesObjs = function CartesiantoDegreesObjs(Cartesians) {
  var array = [].concat(Cartesians);
  var positions = [];

  for (var i = 0, len = array.length; i < len; i++) {
    var cartographic = Cesium.Cartographic.fromCartesian(array[i]);
    var obj = {
      longitude: Cesium.Math.toDegrees(cartographic.longitude),
      latitude: Cesium.Math.toDegrees(cartographic.latitude),
      height: cartographic.height
    };
    positions.push(obj);
  }

  return positions;
}; // 弧度转经纬度


var CartographictoDegrees = function CartographictoDegrees(wgsPosition) {
  var longitude = Cesium.Math.toDegrees(wgsPosition.longitude);
  var latitude = Cesium.Math.toDegrees(wgsPosition.latitude);
  var height = wgsPosition.height;
  return [longitude, latitude, height];
}; //去重函数  数组


var unique = function unique(arr) {
  var res = [];
  var json = {};

  for (var i = 0; i < arr.length; i++) {
    if (!json[arr[i]]) {
      res.push(arr[i]);
      json[arr[i]] = 1;
    }
  }

  return res;
}; // 获取渐变色函数


function gradientColors(start, end, steps, gamma) {
  var i,
      j,
      ms,
      me,
      output = [],
      so = [];
  gamma = gamma || 1;

  var normalize = function normalize(channel) {
    return Math.pow(channel / 255, gamma);
  };

  start = parseColor(start).map(normalize);
  end = parseColor(end).map(normalize);

  for (i = 0; i < steps; i++) {
    ms = i / (steps - 1);
    me = 1 - ms;

    for (j = 0; j < 3; j++) {
      so[j] = pad(Math.round(Math.pow(start[j] * me + end[j] * ms, 1 / gamma) * 255).toString(16));
    }

    output.push('#' + so.join(''));
  }

  return output;

  function parseColor(hexStr) {
    return hexStr.length === 4 ? hexStr.substr(1).split('').map(function (s) {
      return 0x11 * parseInt(s, 16);
    }) : [hexStr.substr(1, 2), hexStr.substr(3, 2), hexStr.substr(5, 2)].map(function (s) {
      return parseInt(s, 16);
    });
  }

  function pad(s) {
    return s.length === 1 ? '0' + s : s;
  }
}

function getAngleAndRadian(pointA, pointB) {
  //建立以点A为原点，X轴为east,Y轴为north,Z轴朝上的坐标系
  var transform = Cesium.Transforms.eastNorthUpToFixedFrame(pointA); //向量AB

  var positionvector = Cesium.Cartesian3.subtract(pointB, pointA, new Cesium.Cartesian3()); //因transform是将A为原点的eastNorthUp坐标系中的点转换到世界坐标系的矩阵
  //AB为世界坐标中的向量
  //因此将AB向量转换为A原点坐标系中的向量，需乘以transform的逆矩阵。

  var vector = Cesium.Matrix4.multiplyByPointAsVector(Cesium.Matrix4.inverse(transform, new Cesium.Matrix4()), positionvector, new Cesium.Cartesian3()); //归一化

  var direction = Cesium.Cartesian3.normalize(vector, new Cesium.Cartesian3()); //heading

  var heading1 = Math.atan2(direction.y, direction.x) - Cesium.Math.PI_OVER_TWO;
  var radian = Cesium.Math.TWO_PI - Cesium.Math.zeroToTwoPi(heading1);
  var angle = radian * (180 / Math.PI);

  if (angle < 0) {
    angle = angle + 360;
  }

  return {
    angle: angle,
    radian: radian
  };
}

function getPitch(pointA, pointB) {
  var transfrom = Cesium.Transforms.eastNorthUpToFixedFrame(pointA);
  var vector = Cesium.Cartesian3.subtract(pointB, pointA, new Cesium.Cartesian3());
  var direction = Cesium.Matrix4.multiplyByPointAsVector(Cesium.Matrix4.inverse(transfrom, transfrom), vector, vector);
  Cesium.Cartesian3.normalize(direction, direction); //因为direction已归一化，斜边长度等于1，所以余弦函数等于direction.z

  var radian = Cesium.Math.PI_OVER_TWO - Cesium.Math.acosClamped(direction.z);
  var angle = radian * (180 / Math.PI);

  if (angle < 0) {
    angle = angle + 360;
  }

  return {
    angle: angle,
    radian: radian
  };
}

var tool = {
  axiosJsonp: axiosJsonp,
  isEqualArr: isEqualArr,
  CartesiantoDegrees: CartesiantoDegrees,
  CartesiantoDegreesObjs: CartesiantoDegreesObjs,
  unique: unique,
  gradientColors: gradientColors,
  getAngleAndRadian: getAngleAndRadian,
  CartographictoDegrees: CartographictoDegrees,
  getPitch: getPitch
};

var ResourceCN = {
  showRenderLoopErrors: '渲染时发生错误，已停止渲染。',
  AttributeError: '该组件props没有这个属性：',
  NoPickPositionSupported: "不支持深度纹理,无法绘制多边形，地形操作功能无法使用！",
  NoTerrain: "请在地形里使用地形组件！",
  initViewerWarn: '请先初始化viewer!',
  MoveMouseHeightBox: '点击鼠标左键结束矩形绘制，移动鼠标绘制box高度',
  RightClickEndDrawing: '右键单击结束绘制',
  LeftClickBottomBox: '点击鼠标左键，开始绘制矩形作为box底面',
  ClickModelAddBox: '点击模型，添加裁剪盒子',
  SkyLineWarn: "获取天际线体前，请先绘制天际线！",
  SkyLineBody: '天际线体',
  ShadowqueryWarn: "此操作需要先开启阴影！",
  VeiwshedBody: '可视体',
  VeiwshedBodyHidden: '不可视体',
  EchartsErr: "二维显示需要echarts支持，未找到相关依赖！",
  BaseMapImg: '底图',
  tip1: '<p>点击左键确定操作区域中间点</p><p>右键单击结束绘制</p>'
};

// 组件内部的语言资源：主要包括提示信息
var currentLanguage, Resource;
var cookieLanguage = getLang().toLowerCase();

function getLang() {
  //浏览器语言  IE用browserLanguage，非IE使用language进行判断
  var lang = (navigator.language || navigator.browserLanguage).toLowerCase();
  window.lang = lang; //判断portal设置语言 通过cookie获取
  //   const cookies = document.cookie.split(';');
  //   if (cookies.length > 0) {
  //     cookies.forEach(function (cookie) {
  //       const arr = cookie.split('=');
  //       if (arr[0].toLowerCase().trim() === 'language') {
  //         lang = arr[1];
  //         return;
  //       }
  //     });
  //   }

  return lang;
}

if (cookieLanguage !== undefined) {
  currentLanguage = cookieLanguage;
} else {
  currentLanguage = (navigator.language || navigator.browserLanguage).toLowerCase(); // 获取当前浏览器的语言
}

if (currentLanguage.startsWith('zh')) {
  Resource = ResourceCN;
} else if (currentLanguage.startsWith('ja')) {
  Resource = ResourceCN;
} else {
  Resource = ResourceCN;
}

var resource = Resource;

// 创建一个简单的store状态管理

var storeState = reactive({
  isViewer: false,
  //viewer初始化标志
  changeLayers: 0,
  //图层改变加载完毕监听
  changeGeometrys: 0 //三维分析体改变标志

});

function clipCrossAnalysis(props) {
  // 设置默认值数据
  var state = reactive({
    clipWidth: 5,
    clipHeight: 5,
    heading: 0,
    pitch: 0,
    roll: 0,
    extrude: 1
  }); // 传入props改变默认值

  if (props) {
    for (var key in props) {
      if (state.hasOwnProperty(key)) {
        if (props[key] != undefined) state[key] = props[key];
      } else {
        tool.Message.errorMsg(resource.AttributeError + key);
      }
    }
  } // 初始化数据


  var layers;
  var screenSpaceEventHandler;
  var startClip, //裁剪标志
  box, boxPosition, dim, //entity
  position; //裁剪区域

  if (storeState.isViewer) {
    screenSpaceEventHandler = new Cesium.ScreenSpaceEventHandler(viewer.scene.canvas);
    layers = viewer.scene.layers.layerQueue;
  } //viewer 初始化完成的监听


  watch(function () {
    return storeState.isViewer;
  }, function (val) {
    if (val) {
      screenSpaceEventHandler = new Cesium.ScreenSpaceEventHandler(viewer.scene.canvas);
      layers = viewer.scene.layers.layerQueue;
    }
  });
  /*
   ***cross分析模块***
  */
  // 分析

  function startCross(e) {
    e.preventDefault();

    if (!viewer) {
      return;
    }

    if (box) {
      clearCross();
    }

    start();
    startClip = true;
    box.show = true;
  }

  function start() {
    var _iterator = _createForOfIteratorHelper(layers),
        _step;

    try {
      for (_iterator.s(); !(_step = _iterator.n()).done;) {
        var layer = _step.value;
        layer.selectEnabled = false;
      } // 添加盒子

    } catch (err) {
      _iterator.e(err);
    } finally {
      _iterator.f();
    }

    boxPosition = Cesium.Cartesian3.fromDegrees(0, 0, 0);
    dim = new Cesium.Cartesian3(state.clipWidth, state.clipHeight, 0.1);
    box = viewer.entities.add({
      // 标识盒
      id: "cross-clip-identify-box",
      position: boxPosition,
      show: false,
      box: {
        dimensions: dim,
        fill: false,
        outline: true,
        outlineColor: Cesium.Color.AQUA,
        outlineWidth: 5.0
      }
    });
    var hpr;
    screenSpaceEventHandler.setInputAction(function (movement) {
      if (startClip) {
        boxPosition = scene.pickPosition(movement.endPosition);

        if (!boxPosition) {
          return;
        }

        box.position = boxPosition;

        if (!hpr) {
          hpr = new Cesium.HeadingPitchRoll(Cesium.Math.toRadians(state.heading), Cesium.Math.toRadians(state.pitch), Cesium.Math.toRadians(state.roll));
        }

        var orientation = Cesium.Transforms.headingPitchRollQuaternion(boxPosition, hpr);
        box.orientation = orientation;
      }
    }, Cesium.ScreenSpaceEventType.MOUSE_MOVE);
    screenSpaceEventHandler.setInputAction(function (evt) {
      if (startClip) {
        position = scene.pickPosition(evt.position);

        if (!position) {
          return;
        }

        updateClip();
        startClip = false;
        box.show = false;
      }

      screenSpaceEventHandler.removeInputAction(Cesium.ScreenSpaceEventType.MOUSE_MOVE);
      screenSpaceEventHandler.removeInputAction(Cesium.ScreenSpaceEventType.LEFT_CLICK);
      hpr = null;
    }, Cesium.ScreenSpaceEventType.LEFT_CLICK);
  }

  function updateClip() {
    var _iterator2 = _createForOfIteratorHelper(layers),
        _step2;

    try {
      for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
        var layer = _step2.value;
        layer.setCustomClipCross({
          position: position,
          dimensions: dim,
          heading: state.heading,
          pitch: state.pitch,
          roll: state.roll,
          extrudeDistance: Number(state.extrude)
        });
      }
    } catch (err) {
      _iterator2.e(err);
    } finally {
      _iterator2.f();
    }
  }

  function clearCross() {
    box && viewer.entities.removeById("cross-clip-identify-box");

    var _iterator3 = _createForOfIteratorHelper(layers),
        _step3;

    try {
      for (_iterator3.s(); !(_step3 = _iterator3.n()).done;) {
        var layer = _step3.value;
        layer.clearCustomClipBox();
      }
    } catch (err) {
      _iterator3.e(err);
    } finally {
      _iterator3.f();
    }

    startClip = false;
    box = undefined;
    screenSpaceEventHandler.removeInputAction(Cesium.ScreenSpaceEventType.MOUSE_MOVE);
    screenSpaceEventHandler.removeInputAction(Cesium.ScreenSpaceEventType.LEFT_CLICK);
  }

  watch(function () {
    return state.clipWidth;
  }, function (val) {
    var temp_width = Number(val);

    if (temp_width <= 0 || !box) {
      return;
    }

    box.box.dimensions = new Cesium.Cartesian3(state.clipWidth, state.clipHeight, 0.1);
    dim = new Cesium.Cartesian3(temp_width, state.clipHeight, state.extrude);
    updateClip();
  });
  watch(function () {
    return state.clipHeight;
  }, function (val) {
    var temp_height = Number(val);

    if (temp_height <= 0 || !box) {
      return;
    }

    box.box.dimensions = new Cesium.Cartesian3(state.clipWidth, state.clipHeight, 0.1);
    dim = new Cesium.Cartesian3(state.clipWidth, temp_height, state.extrude);
    updateClip();
  });
  watch(function () {
    return state.pitch;
  }, function (val) {
    if (val === "" || !box) {
      return;
    }

    var pitch = Number(val);
    var hpr = new Cesium.HeadingPitchRoll(Cesium.Math.toRadians(state.heading), Cesium.Math.toRadians(pitch), Cesium.Math.toRadians(state.roll));
    var orientation = Cesium.Transforms.headingPitchRollQuaternion(boxPosition, hpr);
    box.orientation = orientation;
    updateClip();
  });
  watch(function () {
    return state.roll;
  }, function (val) {
    if (val === "" || !box) {
      return;
    }

    var roll = Number(val);
    var hpr = new Cesium.HeadingPitchRoll(Cesium.Math.toRadians(state.heading), Cesium.Math.toRadians(state.pitch), Cesium.Math.toRadians(roll));
    var orientation = Cesium.Transforms.headingPitchRollQuaternion(boxPosition, hpr);
    box.orientation = orientation;
    updateClip();
  });
  watch(function () {
    return state.heading;
  }, function (val) {
    if (val === "" || !box) {
      return;
    }

    var heading = Number(val);
    var hpr = new Cesium.HeadingPitchRoll(Cesium.Math.toRadians(heading), Cesium.Math.toRadians(state.pitch), Cesium.Math.toRadians(state.roll));
    var orientation = Cesium.Transforms.headingPitchRollQuaternion(boxPosition, hpr);
    box.orientation = orientation;
    updateClip();
  });
  watch(function () {
    return state.extrude;
  }, function (val) {
    var temp_extrudeDistance = Number(val);

    if (temp_extrudeDistance <= 0 || !box) {
      return;
    }

    updateClip();
  }); // 销毁

  onBeforeUnmount(function () {
    screenSpaceEventHandler.destroy();
    layers = undefined;
    box = undefined;
    screenSpaceEventHandler = undefined;
    dim = undefined;
  });
  return _objectSpread2(_objectSpread2({}, toRefs(state)), {}, {
    startCross: startCross,
    clearCross: clearCross
  });
}

var script = {
  name: "Sm3dClipCross",
  props: {
    //宽度
    clipWidth: {
      type: Number,
      "default": 5
    },
    //高度
    clipHeight: {
      type: Number,
      "default": 5
    },
    //绕X选转
    heading: {
      type: Number,
      "default": 0
    },
    //绕Y
    pitch: {
      type: Number,
      "default": 0
    },
    //绕Z
    roll: {
      type: Number,
      "default": 0
    },
    //拉伸
    extrude: {
      type: Number,
      "default": 1
    }
  },
  setup: function setup(props) {
    var _clipCrossAnalysis = clipCrossAnalysis(props),
        clipWidth = _clipCrossAnalysis.clipWidth,
        clipHeight = _clipCrossAnalysis.clipHeight,
        heading = _clipCrossAnalysis.heading,
        pitch = _clipCrossAnalysis.pitch,
        roll = _clipCrossAnalysis.roll,
        extrude = _clipCrossAnalysis.extrude,
        startCross = _clipCrossAnalysis.startCross,
        clearCross = _clipCrossAnalysis.clearCross;

    return {
      clipWidth: clipWidth,
      clipHeight: clipHeight,
      heading: heading,
      pitch: pitch,
      roll: roll,
      extrude: extrude,
      startCross: startCross,
      clearCross: clearCross
    };
  }
};

var _hoisted_1 = {
  id: "viewer-panel",
  "class": "sm-panel"
};
var _hoisted_2 = {
  "class": "sm-function-module-sub-section",
  style: {
    "margin": "0"
  }
};
var _hoisted_3 = {
  "class": "sm-half-L"
};
var _hoisted_4 = {
  "class": "label-S"
};
var _hoisted_5 = {
  "class": "sm-slider-input-box"
};
var _hoisted_6 = {
  "class": "sm-half-L"
};
var _hoisted_7 = {
  "class": "label-S"
};
var _hoisted_8 = {
  "class": "sm-slider-input-box"
};
var _hoisted_9 = {
  "class": "sm-half-L"
};
var _hoisted_10 = {
  "class": "label-S"
};
var _hoisted_11 = {
  "class": "sm-slider-input-box"
};
var _hoisted_12 = {
  "class": "sm-half-L"
};
var _hoisted_13 = {
  "class": "label-S"
};
var _hoisted_14 = {
  "class": "sm-slider-input-box"
};
var _hoisted_15 = {
  "class": "sm-half-L"
};
var _hoisted_16 = {
  "class": "label-S"
};
var _hoisted_17 = {
  "class": "sm-slider-input-box"
};
var _hoisted_18 = {
  "class": "sm-half-L"
};
var _hoisted_19 = {
  "class": "label-S"
};
var _hoisted_20 = {
  "class": "sm-slider-input-box"
};
var _hoisted_21 = {
  "class": "boxchild"
};
function render(_ctx, _cache, $props, $setup, $data, $options) {
  var _component_el_slider = resolveComponent("el-slider");

  var _directive_stopdrag = resolveDirective("stopdrag");

  var _directive_drag = resolveDirective("drag");

  return withDirectives((openBlock(), createElementBlock("div", _hoisted_1, [withDirectives((openBlock(), createElementBlock("div", _hoisted_2, [createElementVNode("div", _hoisted_3, [createElementVNode("label", _hoisted_4, toDisplayString(_ctx.Resource.ClipWidth), 1
  /* TEXT */
  ), createElementVNode("div", _hoisted_5, [createVNode(_component_el_slider, {
    modelValue: $setup.clipWidth,
    "onUpdate:modelValue": _cache[0] || (_cache[0] = function ($event) {
      return $setup.clipWidth = $event;
    }),
    min: 1,
    step: 1,
    "input-size": "mini",
    debounce: 500,
    "show-tooltip": false,
    style: {
      "width": "62%"
    }
  }, null, 8
  /* PROPS */
  , ["modelValue"]), withDirectives(createElementVNode("input", {
    "class": "sm-input-S",
    min: "1",
    type: "number",
    "onUpdate:modelValue": _cache[1] || (_cache[1] = function ($event) {
      return $setup.clipWidth = $event;
    })
  }, null, 512
  /* NEED_PATCH */
  ), [[vModelText, $setup.clipWidth]])])]), createElementVNode("div", _hoisted_6, [createElementVNode("label", _hoisted_7, toDisplayString(_ctx.Resource.ClipHeight), 1
  /* TEXT */
  ), createElementVNode("div", _hoisted_8, [createVNode(_component_el_slider, {
    modelValue: $setup.clipHeight,
    "onUpdate:modelValue": _cache[2] || (_cache[2] = function ($event) {
      return $setup.clipHeight = $event;
    }),
    min: 1,
    step: 1,
    "input-size": "mini",
    debounce: 500,
    "show-tooltip": false,
    style: {
      "width": "62%"
    }
  }, null, 8
  /* PROPS */
  , ["modelValue"]), withDirectives(createElementVNode("input", {
    "class": "sm-input-S",
    min: "1",
    step: "1",
    type: "number",
    "onUpdate:modelValue": _cache[3] || (_cache[3] = function ($event) {
      return $setup.clipHeight = $event;
    })
  }, null, 512
  /* NEED_PATCH */
  ), [[vModelText, $setup.clipHeight]])])]), createElementVNode("div", _hoisted_9, [createElementVNode("label", _hoisted_10, toDisplayString(_ctx.Resource.Xrotation), 1
  /* TEXT */
  ), createElementVNode("div", _hoisted_11, [createVNode(_component_el_slider, {
    modelValue: $setup.pitch,
    "onUpdate:modelValue": _cache[4] || (_cache[4] = function ($event) {
      return $setup.pitch = $event;
    }),
    min: 0,
    step: 1,
    max: 360,
    "input-size": "mini",
    debounce: 500,
    "show-tooltip": false,
    style: {
      "width": "62%"
    }
  }, null, 8
  /* PROPS */
  , ["modelValue"]), withDirectives(createElementVNode("input", {
    "class": "sm-input-S",
    min: "0",
    max: "360",
    step: "1",
    type: "number",
    "onUpdate:modelValue": _cache[5] || (_cache[5] = function ($event) {
      return $setup.pitch = $event;
    })
  }, null, 512
  /* NEED_PATCH */
  ), [[vModelText, $setup.pitch]])])]), createElementVNode("div", _hoisted_12, [createElementVNode("label", _hoisted_13, toDisplayString(_ctx.Resource.Yrotation), 1
  /* TEXT */
  ), createElementVNode("div", _hoisted_14, [createVNode(_component_el_slider, {
    modelValue: $setup.roll,
    "onUpdate:modelValue": _cache[6] || (_cache[6] = function ($event) {
      return $setup.roll = $event;
    }),
    min: 0,
    step: 1,
    max: 360,
    "input-size": "mini",
    debounce: 500,
    "show-tooltip": false,
    style: {
      "width": "62%"
    }
  }, null, 8
  /* PROPS */
  , ["modelValue"]), withDirectives(createElementVNode("input", {
    "class": "sm-input-S",
    min: "0",
    step: "1",
    max: "360",
    type: "number",
    "onUpdate:modelValue": _cache[7] || (_cache[7] = function ($event) {
      return $setup.roll = $event;
    })
  }, null, 512
  /* NEED_PATCH */
  ), [[vModelText, $setup.roll]])])]), createElementVNode("div", _hoisted_15, [createElementVNode("label", _hoisted_16, toDisplayString(_ctx.Resource.Zrotation), 1
  /* TEXT */
  ), createElementVNode("div", _hoisted_17, [createVNode(_component_el_slider, {
    modelValue: $setup.heading,
    "onUpdate:modelValue": _cache[8] || (_cache[8] = function ($event) {
      return $setup.heading = $event;
    }),
    min: 0,
    step: 1,
    max: 360,
    "input-size": "mini",
    debounce: 500,
    "show-tooltip": false,
    style: {
      "width": "62%"
    }
  }, null, 8
  /* PROPS */
  , ["modelValue"]), withDirectives(createElementVNode("input", {
    "class": "sm-input-S",
    min: "0",
    step: "1",
    max: "360",
    type: "number",
    "onUpdate:modelValue": _cache[9] || (_cache[9] = function ($event) {
      return $setup.heading = $event;
    })
  }, null, 512
  /* NEED_PATCH */
  ), [[vModelText, $setup.heading]])])]), createElementVNode("div", _hoisted_18, [createElementVNode("label", _hoisted_19, toDisplayString(_ctx.Resource.stretchHeight), 1
  /* TEXT */
  ), createElementVNode("div", _hoisted_20, [createVNode(_component_el_slider, {
    modelValue: $setup.extrude,
    "onUpdate:modelValue": _cache[10] || (_cache[10] = function ($event) {
      return $setup.extrude = $event;
    }),
    min: 1,
    step: 1,
    "input-size": "mini",
    debounce: 500,
    "show-tooltip": false,
    style: {
      "width": "62%"
    }
  }, null, 8
  /* PROPS */
  , ["modelValue"]), withDirectives(createElementVNode("input", {
    "class": "sm-input-S",
    min: "1",
    step: "1",
    type: "number",
    "onUpdate:modelValue": _cache[11] || (_cache[11] = function ($event) {
      return $setup.extrude = $event;
    })
  }, null, 512
  /* NEED_PATCH */
  ), [[vModelText, $setup.extrude]])])]), createElementVNode("div", _hoisted_21, [createElementVNode("button", {
    onClick: _cache[12] || (_cache[12] = function () {
      return $setup.startCross && $setup.startCross.apply($setup, arguments);
    }),
    "class": "tbtn",
    type: "button"
  }, toDisplayString(_ctx.Resource.clip), 1
  /* TEXT */
  ), createElementVNode("button", {
    onClick: _cache[13] || (_cache[13] = function () {
      return $setup.clearCross && $setup.clearCross.apply($setup, arguments);
    }),
    "class": "tbtn tbtn-margin-left",
    type: "button"
  }, toDisplayString(_ctx.Resource.clear), 1
  /* TEXT */
  )])])), [[_directive_stopdrag]])])), [[_directive_drag]]);
}

script.render = render;
script.__file = "src/components/clip/clip-cross/clip-cross.vue";

script.install = function (app) {
  app.component(script.name, script);
};

export default script;
