import { reactive, toRefs, ref, watch, onBeforeUnmount, openBlock, createElementBlock, createElementVNode, normalizeClass } from 'vue';

function _typeof(obj) {
  "@babel/helpers - typeof";

  if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
    _typeof = function (obj) {
      return typeof obj;
    };
  } else {
    _typeof = function (obj) {
      return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
    };
  }

  return _typeof(obj);
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);

  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    if (enumerableOnly) symbols = symbols.filter(function (sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    });
    keys.push.apply(keys, symbols);
  }

  return keys;
}

function _objectSpread2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};

    if (i % 2) {
      ownKeys(Object(source), true).forEach(function (key) {
        _defineProperty(target, key, source[key]);
      });
    } else if (Object.getOwnPropertyDescriptors) {
      Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
      ownKeys(Object(source)).forEach(function (key) {
        Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
      });
    }
  }

  return target;
}

// 创建一个简单的store状态管理

var storeState = reactive({
  isViewer: false,
  //viewer初始化标志
  changeLayers: 0,
  //图层改变加载完毕监听
  changeGeometrys: 0 //三维分析体改变标志

});

/*
* 常用工具类
*/
//axios本版本不支持jsonp
var axiosJsonp = function axiosJsonp(url) {
  if (!url) {
    console.error('Axios.JSONP 至少需要一个url参数!');
    return;
  }

  return new Promise(function (resolve, reject) {
    window.jsonCallBack = function (result) {
      resolve(result);
    };

    var JSONP = document.createElement("script");
    JSONP.type = "text/javascript";
    JSONP.src = "".concat(url, "&callback=jsonCallBack");
    document.getElementsByTagName("head")[0].appendChild(JSONP);
    setTimeout(function () {
      document.getElementsByTagName("head")[0].removeChild(JSONP);
    }, 500);
  });
}; //判断两数组或对象相等


var isEqualArr = function isEqualArr(arg1, arg2) {
  if (!arg1 || !arg2) return true;
  var bol = true;

  if (Object.keys(arg1).length != Object.keys(arg2).length) {
    return false;
  }

  for (var key in arg1) {
    if (_typeof(arg1[key]) == 'object') {
      bol = isSame(arg1[key], arg2[key]);

      if (!bol) {
        break;
      }
    } else if (arg1[key] != arg2[key]) {
      bol = false;
      break;
    }
  }

  return bol;
}; //坐标转化
//笛卡尔转经纬度


var CartesiantoDegrees = function CartesiantoDegrees(Cartesians) {
  var array = [].concat(Cartesians);
  var positions = [];

  for (var i = 0, len = array.length; i < len; i++) {
    var cartographic = Cesium.Cartographic.fromCartesian(array[i]);
    var longitude = Cesium.Math.toDegrees(cartographic.longitude);
    var latitude = Cesium.Math.toDegrees(cartographic.latitude);
    var h = cartographic.height;

    if (positions.indexOf(longitude) == -1 && positions.indexOf(latitude) == -1) {
      positions.push(longitude);
      positions.push(latitude);
      positions.push(h);
    }
  }

  return positions;
}; //笛卡尔转经纬度(每个点是独立的对象)


var CartesiantoDegreesObjs = function CartesiantoDegreesObjs(Cartesians) {
  var array = [].concat(Cartesians);
  var positions = [];

  for (var i = 0, len = array.length; i < len; i++) {
    var cartographic = Cesium.Cartographic.fromCartesian(array[i]);
    var obj = {
      longitude: Cesium.Math.toDegrees(cartographic.longitude),
      latitude: Cesium.Math.toDegrees(cartographic.latitude),
      height: cartographic.height
    };
    positions.push(obj);
  }

  return positions;
}; // 弧度转经纬度


var CartographictoDegrees = function CartographictoDegrees(wgsPosition) {
  var longitude = Cesium.Math.toDegrees(wgsPosition.longitude);
  var latitude = Cesium.Math.toDegrees(wgsPosition.latitude);
  var height = wgsPosition.height;
  return [longitude, latitude, height];
}; //去重函数  数组


var unique = function unique(arr) {
  var res = [];
  var json = {};

  for (var i = 0; i < arr.length; i++) {
    if (!json[arr[i]]) {
      res.push(arr[i]);
      json[arr[i]] = 1;
    }
  }

  return res;
}; // 获取渐变色函数


function gradientColors(start, end, steps, gamma) {
  var i,
      j,
      ms,
      me,
      output = [],
      so = [];
  gamma = gamma || 1;

  var normalize = function normalize(channel) {
    return Math.pow(channel / 255, gamma);
  };

  start = parseColor(start).map(normalize);
  end = parseColor(end).map(normalize);

  for (i = 0; i < steps; i++) {
    ms = i / (steps - 1);
    me = 1 - ms;

    for (j = 0; j < 3; j++) {
      so[j] = pad(Math.round(Math.pow(start[j] * me + end[j] * ms, 1 / gamma) * 255).toString(16));
    }

    output.push('#' + so.join(''));
  }

  return output;

  function parseColor(hexStr) {
    return hexStr.length === 4 ? hexStr.substr(1).split('').map(function (s) {
      return 0x11 * parseInt(s, 16);
    }) : [hexStr.substr(1, 2), hexStr.substr(3, 2), hexStr.substr(5, 2)].map(function (s) {
      return parseInt(s, 16);
    });
  }

  function pad(s) {
    return s.length === 1 ? '0' + s : s;
  }
}

function getAngleAndRadian(pointA, pointB) {
  //建立以点A为原点，X轴为east,Y轴为north,Z轴朝上的坐标系
  var transform = Cesium.Transforms.eastNorthUpToFixedFrame(pointA); //向量AB

  var positionvector = Cesium.Cartesian3.subtract(pointB, pointA, new Cesium.Cartesian3()); //因transform是将A为原点的eastNorthUp坐标系中的点转换到世界坐标系的矩阵
  //AB为世界坐标中的向量
  //因此将AB向量转换为A原点坐标系中的向量，需乘以transform的逆矩阵。

  var vector = Cesium.Matrix4.multiplyByPointAsVector(Cesium.Matrix4.inverse(transform, new Cesium.Matrix4()), positionvector, new Cesium.Cartesian3()); //归一化

  var direction = Cesium.Cartesian3.normalize(vector, new Cesium.Cartesian3()); //heading

  var heading1 = Math.atan2(direction.y, direction.x) - Cesium.Math.PI_OVER_TWO;
  var radian = Cesium.Math.TWO_PI - Cesium.Math.zeroToTwoPi(heading1);
  var angle = radian * (180 / Math.PI);

  if (angle < 0) {
    angle = angle + 360;
  }

  return {
    angle: angle,
    radian: radian
  };
}

function getPitch(pointA, pointB) {
  var transfrom = Cesium.Transforms.eastNorthUpToFixedFrame(pointA);
  var vector = Cesium.Cartesian3.subtract(pointB, pointA, new Cesium.Cartesian3());
  var direction = Cesium.Matrix4.multiplyByPointAsVector(Cesium.Matrix4.inverse(transfrom, transfrom), vector, vector);
  Cesium.Cartesian3.normalize(direction, direction); //因为direction已归一化，斜边长度等于1，所以余弦函数等于direction.z

  var radian = Cesium.Math.PI_OVER_TWO - Cesium.Math.acosClamped(direction.z);
  var angle = radian * (180 / Math.PI);

  if (angle < 0) {
    angle = angle + 360;
  }

  return {
    angle: angle,
    radian: radian
  };
}

var tool = {
  axiosJsonp: axiosJsonp,
  isEqualArr: isEqualArr,
  CartesiantoDegrees: CartesiantoDegrees,
  CartesiantoDegreesObjs: CartesiantoDegreesObjs,
  unique: unique,
  gradientColors: gradientColors,
  getAngleAndRadian: getAngleAndRadian,
  CartographictoDegrees: CartographictoDegrees,
  getPitch: getPitch
};

var ResourceCN = {
  showRenderLoopErrors: '渲染时发生错误，已停止渲染。',
  AttributeError: '该组件props没有这个属性：',
  NoPickPositionSupported: "不支持深度纹理,无法绘制多边形，地形操作功能无法使用！",
  NoTerrain: "请在地形里使用地形组件！",
  initViewerWarn: '请先初始化viewer!',
  MoveMouseHeightBox: '点击鼠标左键结束矩形绘制，移动鼠标绘制box高度',
  RightClickEndDrawing: '右键单击结束绘制',
  LeftClickBottomBox: '点击鼠标左键，开始绘制矩形作为box底面',
  ClickModelAddBox: '点击模型，添加裁剪盒子',
  SkyLineWarn: "获取天际线体前，请先绘制天际线！",
  SkyLineBody: '天际线体',
  ShadowqueryWarn: "此操作需要先开启阴影！",
  VeiwshedBody: '可视体',
  VeiwshedBodyHidden: '不可视体',
  EchartsErr: "二维显示需要echarts支持，未找到相关依赖！",
  BaseMapImg: '底图',
  tip1: '<p>点击左键确定操作区域中间点</p><p>右键单击结束绘制</p>'
};

// 组件内部的语言资源：主要包括提示信息
var currentLanguage, Resource;
var cookieLanguage = getLang().toLowerCase();

function getLang() {
  //浏览器语言  IE用browserLanguage，非IE使用language进行判断
  var lang = (navigator.language || navigator.browserLanguage).toLowerCase();
  window.lang = lang; //判断portal设置语言 通过cookie获取
  //   const cookies = document.cookie.split(';');
  //   if (cookies.length > 0) {
  //     cookies.forEach(function (cookie) {
  //       const arr = cookie.split('=');
  //       if (arr[0].toLowerCase().trim() === 'language') {
  //         lang = arr[1];
  //         return;
  //       }
  //     });
  //   }

  return lang;
}

if (cookieLanguage !== undefined) {
  currentLanguage = cookieLanguage;
} else {
  currentLanguage = (navigator.language || navigator.browserLanguage).toLowerCase(); // 获取当前浏览器的语言
}

if (currentLanguage.startsWith('zh')) {
  Resource = ResourceCN;
} else if (currentLanguage.startsWith('ja')) {
  Resource = ResourceCN;
} else {
  Resource = ResourceCN;
}

var resource = Resource;

function compass(props) {
  // 设置默认值数据
  var state = reactive({
    resetPosition: '',
    //重置初始位置fromDegrees
    isfull: false //全屏标志

  });
  state.resetPosition = new Cesium.Cartesian3.fromDegrees(110.60396458865515, 34.54408834959379, 30644793.325518917); // 传入props改变默认值

  if (props) {
    for (var key in props) {
      if (state.hasOwnProperty(key)) {
        if (props[key] != undefined) state[key] = props[key];
      } else {
        tool.Message.errorMsg(resource.AttributeError + key);
      }
    }
  }

  if (state.isfull) fullscreenchange(); // 初始化数据

  var scene, scratchWindowPosition;
  var compass_dom = ref(null);
  var zoomIn_timer, zoomOut_timer;
  var isFlyCircle = false;

  if (storeState.isViewer) {
    scene = viewer.scene;
    initCompass();
  } //viewer 初始化完成的监听


  watch(function () {
    return storeState.isViewer;
  }, function (val) {
    if (val) {
      scene = viewer.scene;
      initCompass();
    }
  }); //初始化控件

  function initCompass() {
    scratchWindowPosition = new Cesium.Cartesian2(); //获取屏幕中心点

    scratchWindowPosition.x = scene.canvas.clientWidth / 2;
    scratchWindowPosition.y = scene.canvas.clientHeight / 2;
    scene.postRender.addEventListener(listener); //监听指北针转动

    window.addEventListener('resize', function () {
      scratchWindowPosition.x = scene.canvas.clientWidth / 2;
      scratchWindowPosition.y = scene.canvas.clientHeight / 2;
    });
  }

  function listener() {
    var heading = scene.camera.heading;
    var x = -Cesium.Math.toDegrees(heading);
    var degrees = "rotate(" + x + "deg)";
    compass_dom.value.style.transform = degrees;
    if (!isFlyCircle) return;

    if (heading <= 0.05 || heading >= 6.23) {
      scene.camera.stopFlyCircle();
      heading = 0;
      isFlyCircle = false;
    }
  }
  /**
  * 分析
  */
  //相机指北

  function reduceCompass() {
    var heading = scene.camera.heading;
    var speed = 8;
    if (heading <= 0.05 || heading >= 6.23) return;
    if (heading <= 0.5 || heading >= 5.8) speed = 2;
    isFlyCircle = true;
    var viewCenter = scene.pickPosition(scratchWindowPosition);

    if (scene.camera.heading - Cesium.Math.PI >= 0) {
      scene.camera.speedRatio = speed;
      scene.camera.flyCircle(viewCenter);
      return;
    }

    scene.camera.speedRatio = -speed;
    scene.camera.flyCircle(viewCenter);
  }

  function reset() {
    viewer.camera.flyTo({
      destination: state.resetPosition
    });
  }

  function zoomIn() {
    var speed = 10;
    clearInterval(zoomIn_timer);
    zoomIn_timer = setInterval(function () {
      speed = zoomSpeed();
      viewer.camera.zoomIn(speed);
    }, 30);
  }

  function mouseup_zoomIn() {
    clearInterval(zoomIn_timer);
  }

  function zoomOut() {
    var speed = 10;
    clearInterval(zoomOut_timer);
    zoomOut_timer = setInterval(function () {
      speed = zoomSpeed();
      viewer.camera.zoomOut(speed);
    }, 30);
  }

  function mouseup_zoomOut() {
    clearInterval(zoomOut_timer);
  }

  function zoomSpeed() {
    var viewCenter = scene.pickPosition(scratchWindowPosition);
    var camera_position = viewer.camera.position;
    var distance = Cesium.Cartesian3.distance(viewCenter, camera_position);
    if (distance >= 1000) return distance / 30;
    if (distance >= 20) return distance / 20;
    if (distance > 0) return 0.5;
    return 0;
  }
  /**
   * 进入全屏模式。
   */

  function fullscreenchange() {
    if (!document.fullscreenElement) {
      state.isfull = true;
      launchFullscreen(document.documentElement);
    } else {
      state.isfull = false;
      exitFullscreen();
    }
  }

  function launchFullscreen(element) {
    if (element.requestFullscreen) {
      element.requestFullscreen();
    } else if (element.mozRequestFullScreen) {
      element.mozRequestFullScreen();
    } else if (element.msRequestFullscreen) {
      element.msRequestFullscreen();
    } else if (element.webkitRequestFullscreen) {
      element.webkitRequestFullscreen();
    }
  }
  /**
   * 退出全屏模式。兼容模式。
   */

  function exitFullscreen() {
    if (document.exitFullscreen) {
      document.exitFullscreen();
    } else if (document.msExitFullscreen) {
      document.msExitFullscreen();
    } else if (document.mozCancelFullScreen) {
      document.mozCancelFullScreen();
    } else if (document.webkitExitFullscreen) {
      document.webkitExitFullscreen();
    }
  }

  onBeforeUnmount(function () {
    scene.postRender.removeEventListener(listener);
  });
  return _objectSpread2(_objectSpread2({}, toRefs(state)), {}, {
    compass_dom: compass_dom,
    reduceCompass: reduceCompass,
    reset: reset,
    fullscreenchange: fullscreenchange,
    zoomIn: zoomIn,
    mouseup_zoomIn: mouseup_zoomIn,
    zoomOut: zoomOut,
    mouseup_zoomOut: mouseup_zoomOut
  });
}

var script = {
  name: "Sm3dCompass",
  props: {
    //
    isfull: {
      type: Boolean,
      "default": false
    }
  },
  setup: function setup(props) {
    var _compass = compass(props),
        compass_dom = _compass.compass_dom,
        isfull = _compass.isfull,
        reduceCompass = _compass.reduceCompass,
        reset = _compass.reset,
        fullscreenchange = _compass.fullscreenchange,
        zoomIn = _compass.zoomIn,
        mouseup_zoomIn = _compass.mouseup_zoomIn,
        zoomOut = _compass.zoomOut,
        mouseup_zoomOut = _compass.mouseup_zoomOut;

    return {
      compass_dom: compass_dom,
      isfull: isfull,
      reduceCompass: reduceCompass,
      reset: reset,
      fullscreenchange: fullscreenchange,
      zoomIn: zoomIn,
      mouseup_zoomIn: mouseup_zoomIn,
      zoomOut: zoomOut,
      mouseup_zoomOut: mouseup_zoomOut
    };
  }
};

var _hoisted_1 = {
  id: "compass-panel",
  "class": "compass-panel"
};
var _hoisted_2 = ["title"];
var _hoisted_3 = {
  id: "compass",
  style: {
    "transform": "rotate(-45deg)",
    "display": "inline-block"
  },
  "class": "iconfont iconzhibeizhen",
  ref: "compass_dom"
};
var _hoisted_4 = ["title"];

var _hoisted_5 = /*#__PURE__*/createElementVNode("span", {
  "class": "iconfont iconzhongzhi"
}, null, -1
/* HOISTED */
);

var _hoisted_6 = [_hoisted_5];
var _hoisted_7 = ["title"];

var _hoisted_8 = /*#__PURE__*/createElementVNode("span", {
  "class": "iconfont iconfangda"
}, null, -1
/* HOISTED */
);

var _hoisted_9 = [_hoisted_8];
var _hoisted_10 = ["title"];

var _hoisted_11 = /*#__PURE__*/createElementVNode("span", {
  "class": "iconfont iconsuoxiao"
}, null, -1
/* HOISTED */
);

var _hoisted_12 = [_hoisted_11];
var _hoisted_13 = ["title"];
function render(_ctx, _cache, $props, $setup, $data, $options) {
  return openBlock(), createElementBlock("div", _hoisted_1, [createElementVNode("div", {
    "class": "btn_box",
    style: {
      "border-radius": "50%"
    },
    onClick: _cache[0] || (_cache[0] = function () {
      return $setup.reduceCompass && $setup.reduceCompass.apply($setup, arguments);
    }),
    title: _ctx.Resource.compass
  }, [createElementVNode("span", _hoisted_3, null, 512
  /* NEED_PATCH */
  )], 8
  /* PROPS */
  , _hoisted_2), createElementVNode("div", {
    "class": "btn_box",
    onClick: _cache[1] || (_cache[1] = function () {
      return $setup.reset && $setup.reset.apply($setup, arguments);
    }),
    title: _ctx.Resource.reset
  }, _hoisted_6, 8
  /* PROPS */
  , _hoisted_4), createElementVNode("div", {
    "class": "btn_box",
    onMousedown: _cache[2] || (_cache[2] = function () {
      return $setup.zoomIn && $setup.zoomIn.apply($setup, arguments);
    }),
    onMouseup: _cache[3] || (_cache[3] = function () {
      return $setup.mouseup_zoomIn && $setup.mouseup_zoomIn.apply($setup, arguments);
    }),
    title: _ctx.Resource.zoomIn
  }, _hoisted_9, 40
  /* PROPS, HYDRATE_EVENTS */
  , _hoisted_7), createElementVNode("div", {
    "class": "btn_box",
    onMousedown: _cache[4] || (_cache[4] = function () {
      return $setup.zoomOut && $setup.zoomOut.apply($setup, arguments);
    }),
    onMouseup: _cache[5] || (_cache[5] = function () {
      return $setup.mouseup_zoomOut && $setup.mouseup_zoomOut.apply($setup, arguments);
    }),
    title: _ctx.Resource.zoomOut
  }, _hoisted_12, 40
  /* PROPS, HYDRATE_EVENTS */
  , _hoisted_10), createElementVNode("div", {
    "class": "btn_box",
    onClick: _cache[6] || (_cache[6] = function () {
      return $setup.fullscreenchange && $setup.fullscreenchange.apply($setup, arguments);
    }),
    title: _ctx.Resource.fullScreen
  }, [createElementVNode("span", {
    "class": normalizeClass(["iconfont", !$setup.isfull ? 'iconquanping' : 'iconshouqi1'])
  }, null, 2
  /* CLASS */
  )], 8
  /* PROPS */
  , _hoisted_13)]);
}

script.render = render;
script.__file = "src/components/scene/compass/compass.vue";

script.install = function (app) {
  app.component(script.name, script);
};

export default script;
