import { reactive, toRefs, watch, onBeforeUnmount, resolveComponent, resolveDirective, withDirectives, openBlock, createElementBlock, createElementVNode, vModelRadio, createTextVNode, toDisplayString, vModelSelect, vModelCheckbox, createCommentVNode, Fragment, renderList, normalizeClass, createVNode, vModelText, vShow } from 'vue';

function _typeof(obj) {
  "@babel/helpers - typeof";

  if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
    _typeof = function (obj) {
      return typeof obj;
    };
  } else {
    _typeof = function (obj) {
      return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
    };
  }

  return _typeof(obj);
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);

  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    if (enumerableOnly) symbols = symbols.filter(function (sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    });
    keys.push.apply(keys, symbols);
  }

  return keys;
}

function _objectSpread2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};

    if (i % 2) {
      ownKeys(Object(source), true).forEach(function (key) {
        _defineProperty(target, key, source[key]);
      });
    } else if (Object.getOwnPropertyDescriptors) {
      Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
      ownKeys(Object(source)).forEach(function (key) {
        Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
      });
    }
  }

  return target;
}

function _toConsumableArray(arr) {
  return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread();
}

function _arrayWithoutHoles(arr) {
  if (Array.isArray(arr)) return _arrayLikeToArray(arr);
}

function _iterableToArray(iter) {
  if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter);
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

  return arr2;
}

function _nonIterableSpread() {
  throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

// 创建一个简单的store状态管理

var storeState = reactive({
  isViewer: false,
  //viewer初始化标志
  changeLayers: 0,
  //图层改变加载完毕监听
  changeGeometrys: 0 //三维分析体改变标志

});

/*
* 常用工具类
*/
//axios本版本不支持jsonp
var axiosJsonp = function axiosJsonp(url) {
  if (!url) {
    console.error('Axios.JSONP 至少需要一个url参数!');
    return;
  }

  return new Promise(function (resolve, reject) {
    window.jsonCallBack = function (result) {
      resolve(result);
    };

    var JSONP = document.createElement("script");
    JSONP.type = "text/javascript";
    JSONP.src = "".concat(url, "&callback=jsonCallBack");
    document.getElementsByTagName("head")[0].appendChild(JSONP);
    setTimeout(function () {
      document.getElementsByTagName("head")[0].removeChild(JSONP);
    }, 500);
  });
}; //判断两数组或对象相等


var isEqualArr = function isEqualArr(arg1, arg2) {
  if (!arg1 || !arg2) return true;
  var bol = true;

  if (Object.keys(arg1).length != Object.keys(arg2).length) {
    return false;
  }

  for (var key in arg1) {
    if (_typeof(arg1[key]) == 'object') {
      bol = isSame(arg1[key], arg2[key]);

      if (!bol) {
        break;
      }
    } else if (arg1[key] != arg2[key]) {
      bol = false;
      break;
    }
  }

  return bol;
}; //坐标转化
//笛卡尔转经纬度


var CartesiantoDegrees = function CartesiantoDegrees(Cartesians) {
  var array = [].concat(Cartesians);
  var positions = [];

  for (var i = 0, len = array.length; i < len; i++) {
    var cartographic = Cesium.Cartographic.fromCartesian(array[i]);
    var longitude = Cesium.Math.toDegrees(cartographic.longitude);
    var latitude = Cesium.Math.toDegrees(cartographic.latitude);
    var h = cartographic.height;

    if (positions.indexOf(longitude) == -1 && positions.indexOf(latitude) == -1) {
      positions.push(longitude);
      positions.push(latitude);
      positions.push(h);
    }
  }

  return positions;
}; //笛卡尔转经纬度(每个点是独立的对象)


var CartesiantoDegreesObjs = function CartesiantoDegreesObjs(Cartesians) {
  var array = [].concat(Cartesians);
  var positions = [];

  for (var i = 0, len = array.length; i < len; i++) {
    var cartographic = Cesium.Cartographic.fromCartesian(array[i]);
    var obj = {
      longitude: Cesium.Math.toDegrees(cartographic.longitude),
      latitude: Cesium.Math.toDegrees(cartographic.latitude),
      height: cartographic.height
    };
    positions.push(obj);
  }

  return positions;
}; // 弧度转经纬度


var CartographictoDegrees = function CartographictoDegrees(wgsPosition) {
  var longitude = Cesium.Math.toDegrees(wgsPosition.longitude);
  var latitude = Cesium.Math.toDegrees(wgsPosition.latitude);
  var height = wgsPosition.height;
  return [longitude, latitude, height];
}; //去重函数  数组


var unique = function unique(arr) {
  var res = [];
  var json = {};

  for (var i = 0; i < arr.length; i++) {
    if (!json[arr[i]]) {
      res.push(arr[i]);
      json[arr[i]] = 1;
    }
  }

  return res;
}; // 获取渐变色函数


function gradientColors(start, end, steps, gamma) {
  var i,
      j,
      ms,
      me,
      output = [],
      so = [];
  gamma = gamma || 1;

  var normalize = function normalize(channel) {
    return Math.pow(channel / 255, gamma);
  };

  start = parseColor(start).map(normalize);
  end = parseColor(end).map(normalize);

  for (i = 0; i < steps; i++) {
    ms = i / (steps - 1);
    me = 1 - ms;

    for (j = 0; j < 3; j++) {
      so[j] = pad(Math.round(Math.pow(start[j] * me + end[j] * ms, 1 / gamma) * 255).toString(16));
    }

    output.push('#' + so.join(''));
  }

  return output;

  function parseColor(hexStr) {
    return hexStr.length === 4 ? hexStr.substr(1).split('').map(function (s) {
      return 0x11 * parseInt(s, 16);
    }) : [hexStr.substr(1, 2), hexStr.substr(3, 2), hexStr.substr(5, 2)].map(function (s) {
      return parseInt(s, 16);
    });
  }

  function pad(s) {
    return s.length === 1 ? '0' + s : s;
  }
}

function getAngleAndRadian(pointA, pointB) {
  //建立以点A为原点，X轴为east,Y轴为north,Z轴朝上的坐标系
  var transform = Cesium.Transforms.eastNorthUpToFixedFrame(pointA); //向量AB

  var positionvector = Cesium.Cartesian3.subtract(pointB, pointA, new Cesium.Cartesian3()); //因transform是将A为原点的eastNorthUp坐标系中的点转换到世界坐标系的矩阵
  //AB为世界坐标中的向量
  //因此将AB向量转换为A原点坐标系中的向量，需乘以transform的逆矩阵。

  var vector = Cesium.Matrix4.multiplyByPointAsVector(Cesium.Matrix4.inverse(transform, new Cesium.Matrix4()), positionvector, new Cesium.Cartesian3()); //归一化

  var direction = Cesium.Cartesian3.normalize(vector, new Cesium.Cartesian3()); //heading

  var heading1 = Math.atan2(direction.y, direction.x) - Cesium.Math.PI_OVER_TWO;
  var radian = Cesium.Math.TWO_PI - Cesium.Math.zeroToTwoPi(heading1);
  var angle = radian * (180 / Math.PI);

  if (angle < 0) {
    angle = angle + 360;
  }

  return {
    angle: angle,
    radian: radian
  };
}

function getPitch(pointA, pointB) {
  var transfrom = Cesium.Transforms.eastNorthUpToFixedFrame(pointA);
  var vector = Cesium.Cartesian3.subtract(pointB, pointA, new Cesium.Cartesian3());
  var direction = Cesium.Matrix4.multiplyByPointAsVector(Cesium.Matrix4.inverse(transfrom, transfrom), vector, vector);
  Cesium.Cartesian3.normalize(direction, direction); //因为direction已归一化，斜边长度等于1，所以余弦函数等于direction.z

  var radian = Cesium.Math.PI_OVER_TWO - Cesium.Math.acosClamped(direction.z);
  var angle = radian * (180 / Math.PI);

  if (angle < 0) {
    angle = angle + 360;
  }

  return {
    angle: angle,
    radian: radian
  };
}

var tool = {
  axiosJsonp: axiosJsonp,
  isEqualArr: isEqualArr,
  CartesiantoDegrees: CartesiantoDegrees,
  CartesiantoDegreesObjs: CartesiantoDegreesObjs,
  unique: unique,
  gradientColors: gradientColors,
  getAngleAndRadian: getAngleAndRadian,
  CartographictoDegrees: CartographictoDegrees,
  getPitch: getPitch
};

var ResourceCN = {
  showRenderLoopErrors: '渲染时发生错误，已停止渲染。',
  AttributeError: '该组件props没有这个属性：',
  NoPickPositionSupported: "不支持深度纹理,无法绘制多边形，地形操作功能无法使用！",
  NoTerrain: "请在地形里使用地形组件！",
  initViewerWarn: '请先初始化viewer!',
  MoveMouseHeightBox: '点击鼠标左键结束矩形绘制，移动鼠标绘制box高度',
  RightClickEndDrawing: '右键单击结束绘制',
  LeftClickBottomBox: '点击鼠标左键，开始绘制矩形作为box底面',
  ClickModelAddBox: '点击模型，添加裁剪盒子',
  SkyLineWarn: "获取天际线体前，请先绘制天际线！",
  SkyLineBody: '天际线体',
  ShadowqueryWarn: "此操作需要先开启阴影！",
  VeiwshedBody: '可视体',
  VeiwshedBodyHidden: '不可视体',
  EchartsErr: "二维显示需要echarts支持，未找到相关依赖！",
  BaseMapImg: '底图',
  tip1: '<p>点击左键确定操作区域中间点</p><p>右键单击结束绘制</p>'
};

// 组件内部的语言资源：主要包括提示信息
var currentLanguage, Resource;
var cookieLanguage = getLang().toLowerCase();

function getLang() {
  //浏览器语言  IE用browserLanguage，非IE使用language进行判断
  var lang = (navigator.language || navigator.browserLanguage).toLowerCase();
  window.lang = lang; //判断portal设置语言 通过cookie获取
  //   const cookies = document.cookie.split(';');
  //   if (cookies.length > 0) {
  //     cookies.forEach(function (cookie) {
  //       const arr = cookie.split('=');
  //       if (arr[0].toLowerCase().trim() === 'language') {
  //         lang = arr[1];
  //         return;
  //       }
  //     });
  //   }

  return lang;
}

if (cookieLanguage !== undefined) {
  currentLanguage = cookieLanguage;
} else {
  currentLanguage = (navigator.language || navigator.browserLanguage).toLowerCase(); // 获取当前浏览器的语言
}

if (currentLanguage.startsWith('zh')) {
  Resource = ResourceCN;
} else if (currentLanguage.startsWith('ja')) {
  Resource = ResourceCN;
} else {
  Resource = ResourceCN;
}

var resource = Resource;

//随鼠标移动消息提示工具
function createTooltip(frameDiv) {
  var tooltip = function tooltip(frameDiv) {
    var div = document.createElement("DIV");
    div.className = "twipsy right";
    var arrow = document.createElement("DIV");
    arrow.className = "twipsy-arrow";
    div.appendChild(arrow);
    var title = document.createElement("DIV");
    title.className = "twipsy-inner";
    div.appendChild(title);
    this._div = div;
    this._title = title;
    this.message = "";
    frameDiv.appendChild(div);
    var that = this;

    div.onmousemove = function (evt) {
      that.showAt({
        x: evt.clientX,
        y: evt.clientY
      }, that.message);
    };
  };

  tooltip.prototype.setVisible = function (visible) {
    this._div.style.display = visible ? "block" : "none";
  };

  tooltip.prototype.showAt = function (position, message) {
    if (position && message) {
      this.setVisible(true);
      this._title.innerHTML = message;
      this._div.style.left = position.x + 10 + "px";
      this._div.style.top = position.y - this._div.clientHeight / 2 + "px";
      this.message = message;
    }
  };

  return new tooltip(frameDiv);
}

/**
 * 初始化
 * DrawMode：类型
 * clampMode：模式
 */

var initHandler = function initHandler(DrawMode, clampMode) {
  var clampmode = 0;

  if (clampMode) {
    clampmode = clampMode;
  }

  switch (DrawMode) {
    case "Point":
      window.handlerPoint = new Cesium.DrawHandler(viewer, Cesium.DrawMode.Point);
      break;

    case "Polyline":
      window.handlerPolyline = new Cesium.DrawHandler(viewer, Cesium.DrawMode.Line, clampmode);
      break;

    case "Polygon":
      window.handlerPolygon = new Cesium.DrawHandler(viewer, Cesium.DrawMode.Polygon, clampmode);
      break;

    case "Marker":
      window.handlerMarker = new Cesium.DrawHandler(viewer, Cesium.DrawMode.Marker, clampmode);
      break;

    case "Box":
      window.handlerBox = new Cesium.DrawHandler(viewer, Cesium.DrawMode.Box, clampmode);
      break;
  }

  if (!window.tooltip) {
    window.tooltip = createTooltip(viewer._element);
  } // 半透线创建


  if (!window.polylineCollection) {
    window.polylineCollection = new Cesium.PolylineCollection({
      translucentRS: Cesium.RenderState.fromCache({
        depthMask: false,
        depthTest: {
          enabled: false
        }
      })
    });
    window.polylineTransparent = window.polylineCollection.add({
      width: 2,
      material: Cesium.Material.fromType(Cesium.Material.ColorType, {
        color: Cesium.Color.fromCssColorString("#51ff00").withAlpha(0.3)
      })
    });
    viewer.scene.primitives.add(window.polylineCollection);
  }
};
/**
 * 绘制
 * PolyType：类型 
 * lineVisib：绘制时是否显示绘制线（boolean）
 * toolTipObj：绘制时提示内容{beforeDrawing：绘制开始前提示(string)，isDrawing：正在绘制时提示,即绘制过程中（string）}
 */


var handlerDrawing = function handlerDrawing(PolyType, lineVisib, toolTipObj) {
  var lineVisible = true;

  if (lineVisib === false) {
    lineVisible = lineVisib;
  }

  var DrawHandler = judgeDrawHandlerType(PolyType); //获取操作对象

  return new Promise(function (resolve, reject) {
    //做一些异步操作
    var tooltip = window.tooltip;
    var clearActFn = DrawHandler.activeEvt.addEventListener(function (isActive) {
      if (isActive == true) {
        viewer.enableCursorStyle = false;
        viewer._element.style.cursor = '';

        if (PolyType == "Point" || PolyType == "Marker") {
          document.body.classList.add("measureCur");
        } else {
          document.body.classList.add("drawCur");
        }
      } else {
        viewer.enableCursorStyle = true;
        tooltip.setVisible(false);

        if (PolyType == "Point" || PolyType == "Marker") {
          document.body.classList.remove('measureCur');
        } else {
          document.body.classList.remove('drawCur');
        }
      }
    });
    var clearMovFn = DrawHandler.movingEvt.addEventListener(function (windowPosition) {
      if (windowPosition.x < 200 && windowPosition.y < 150) {
        tooltip.setVisible(false);
        return;
      }
      //     tooltip.showAt(windowPosition, tiptext);
      // } else if (toolTipObj && toolTipObj.beforeDrawing) {
      //     tooltip.showAt(windowPosition, toolTipObj.beforeDrawing);
      // }else if (DrawHandler.isDrawing && toolTipObj.isDrawing) {
      //     tooltip.showAt(windowPosition, toolTipObj.isDrawing);
      // }

      if (DrawHandler.polyline && DrawHandler.isDrawing) {
        var p = _toConsumableArray(DrawHandler.polyline.positions);

        if (PolyType == "Polygon") {
          //画面时，需要首尾相连
          p.push(p[0]);
        }
        window.polylineTransparent.show = true;
        window.polylineTransparent.positions = p;
      }
    });
    var clearDrawFn = DrawHandler.drawEvt.addEventListener(function (result) {
      if (!result.object.positions && PolyType != "Point" && PolyType != "Box") {
        tooltip.showAt(result, '<p>请绘制正确的多边形</p>');
        DrawHandler.polygon.show = false;
        DrawHandler.polyline.show = false;
        DrawHandler.deactivate();
        DrawHandler.activate();
        return;
      }

      if (PolyType == "Box") {
        resolve({
          result: result
        });
        return;
      }

      if (PolyType == "Point" || PolyType == "Marker") {
        DrawHandler.clear(); // 不显示绘制的点

        resolve({
          result: result
        });
      } else {
        //半透线
        window.polylineTransparent.show = lineVisible;

        if (lineVisible) {
          if (PolyType == "Polygon" && lineVisible) {
            DrawHandler.polygon._polygon._material._color._value.alpha = 0.1; //绘制面透明度

            var p2 = _toConsumableArray(result.object.positions); //画面时，需要首尾相连


            p2.push(p2[0]);
            window.polylineTransparent.positions = p2;
          }
        }

        var positions = CartesiantoDegrees(result.object.positions);
        resolve({
          result: result,
          positions: positions
        });
      }

      clearActFn();
      clearMovFn();
      clearDrawFn();
    });
  });
}; //清除


var clearHandlerDrawing = function clearHandlerDrawing(PolyType) {
  var DrawHandler;

  if (!PolyType) {
    DrawHandler = window.handlerPolygon;
  } else {
    DrawHandler = judgeDrawHandlerType(PolyType);
  }
  if (!DrawHandler) return;
  DrawHandler.deactivate();
  DrawHandler.clear();
  viewer.enableCursorStyle = true; // document.body.classList.remove("drawCur");
  // document.body.classList.remove("measureCur");

  window.tooltip.setVisible(false);

  if (window.polylineTransparent) {
    window.polylineTransparent.show = false;
  }
}; // 类型判断


var judgeDrawHandlerType = function judgeDrawHandlerType(PolyType) {
  var DrawHandler;

  switch (PolyType) {
    case "Point":
      DrawHandler = window.handlerPoint;
      break;

    case "Polyline":
      DrawHandler = window.handlerPolyline;
      break;

    case "Polygon":
      DrawHandler = window.handlerPolygon;
      break;

    case "Marker":
      DrawHandler = window.handlerMarker;
      break;

    case "Box":
      DrawHandler = window.handlerBox;
      break;
  }

  return DrawHandler;
};

/**
 * 编辑功能
 * EditPositions：编辑前的区域，用于编辑后的比较变化（array）
 * isEditZ：是否编辑z轴
 * callback：编辑后触发的回调函数
 * 注意：为了更好的性能，编辑功能是全局的唯一的，所以只能进行当前操作的编辑
 */

var Edit = function Edit(EditPositions, isEditZ, callback) {
  if (!window.selectHandler) {
    window.selectHandler = new Cesium.ScreenSpaceEventHandler(viewer.scene.canvas);
  }

  var selectHandler = window.selectHandler;

  if (window.handlerPolygon && window.handlerPolygon.polygon) {
    window.handlerPolygon.polygon.show = true;
  }

  selectHandler.setInputAction(function () {
    var entity = viewer.selectedEntity;
    var editHandler = window.editHandler;

    if (!entity) {
      if (editHandler) {
        editHandler && editHandler.deactivate();
      }

      return;
    }

    if (!editHandler) {
      window.editHandler = new Cesium.EditHandler(viewer, entity);

      if (isEditZ) {
        window.editHandler.isEditZ = isEditZ;
      } else {
        window.editHandler.isEditZ = false;
      }

      window.editHandler.activate();
    } else {
      editHandler.deactivate();
      editHandler.setEditObject(entity);
      editHandler.activate();
    }

    selectHandler.setInputAction(function () {
      entity = viewer.selectedEntity;
      editHandler = window.editHandler;

      if (!entity) {
        return;
      }

      if (editHandler && editHandler._positions) {
        var positions = CartesiantoDegrees(editHandler._positions);

        if (isEqualArr(EditPositions, positions)) {
          return;
        } else {
          EditPositions = positions;

          if (callback) {
            callback(positions, window.editHandler);
          }
        }

        if (window.handlerPolygon && window.handlerPolygon.polygon && window.handlerPolygon.polygon.show) {
          var p3 = _toConsumableArray(editHandler._positions);

          p3.push(p3[0]);
          window.polylineTransparent.positions = p3; //半透线
        }
      }
    }, Cesium.ScreenSpaceEventType.LEFT_UP);
  }, Cesium.ScreenSpaceEventType.LEFT_CLICK);
};

var clearEditHandler = function clearEditHandler() {
  if (window.editHandler) {
    window.editHandler.deactivate();
    window.editHandler.clear();
  }

  if (window.selectHandler) {
    //移除鼠标移动事件监听
    window.selectHandler.removeInputAction(Cesium.ScreenSpaceEventType.LEFT_UP);
    window.selectHandler.removeInputAction(Cesium.ScreenSpaceEventType.LEFT_CLICK);
    window.selectHandler.destroy();
    window.selectHandler = null;
  }
};

function createTooltip$1(frameDiv) {
  var tooltip = function tooltip(frameDiv) {
    var div = document.createElement('DIV');
    div.className = "tooltip";
    this._div = div;
    this.message = '';
    frameDiv.appendChild(div);
  };

  tooltip.prototype.setVisible = function (visible) {
    if (visible) {
      this._div.style.right = '10px';
    } else {
      this._div.style.right = '-300px';
    }
  };

  tooltip.prototype.showAt = function (message, top) {
    //top:200px => string
    if (top) {
      this._div.style.top = top;
    }

    if (message) {
      this.setVisible(true);
      this._div.innerHTML = message;
    }
  };

  return new tooltip(frameDiv);
}

var config = {
  polyline: [{
    id: '1',
    iconfont: 'iconshixian',
    lineName: '实线'
  }, {
    id: '2',
    iconfont: 'iconxuxian',
    lineName: '虚线'
  }, {
    id: '3',
    iconfont: 'iconlunkuoxian',
    lineName: '轮廓线'
  }, {
    id: '4',
    iconfont: 'iconjiantouxian',
    lineName: '箭头线'
  }, {
    id: '5',
    iconfont: 'iconguangyunxian',
    lineName: '光晕线'
  }, {
    id: '6',
    iconfont: 'iconweijixian',
    lineName: '尾迹线'
  }, {}, {}],
  polygon: [{
    id: '1',
    iconfont: 'iconchunse',
    faceName: '纯色'
  }, {
    id: '2',
    iconfont: 'iconwangge',
    faceName: '网格'
  }, {
    id: '3',
    iconfont: 'icontiaowen',
    faceName: '条纹'
  }]
};

/** Detect free variable `global` from Node.js. */

var freeGlobal = (typeof global === "undefined" ? "undefined" : _typeof(global)) == 'object' && global && global.Object === Object && global;
/** Detect free variable `self`. */

var freeSelf = (typeof self === "undefined" ? "undefined" : _typeof(self)) == 'object' && self && self.Object === Object && self;
/** Used as a reference to the global object. */

var root = freeGlobal || freeSelf || Function('return this')();

function draw(props) {
  // 设置默认值数据
  var state = reactive({
    drawModle: "space",
    //绘制模式
    currentId: "1",
    //当前选中线id
    config: config,
    //线类型配置  
    lineColor: "rgba(250, 196, 65, 1)",
    //设置线颜色
    lineWidth: 5,
    //设置选中线宽
    dottedColor: "rgba(250, 196, 65, 0)",
    //间隔颜色
    dottedLength: 30,
    outLineColor: "rgba(29, 206, 200, 1)",
    outLineWidth: 2,
    glowStrength: 0.5,
    trailPercentage: 0.3,
    trailPeroid: 2,
    isEdit: true,
    isEditZ: false,
    //面
    drawType: 'polyline',
    solidColor: "rgba(250, 196, 65, 1)",
    gridColor: "rgba(250, 196, 65, 1)",
    gridWidth: 1,
    gridCount: 8,
    gridCellAlpha: 0.1,
    stripeEvenColor: "#FFFFFF",
    stripeOddColor: "#000000",
    stripeRepeat: 12,
    stripeOffset: 0,
    stripeOrientation: "horizontal"
  }); // 传入props改变默认值

  if (props) {
    for (var key in props) {
      if (state.hasOwnProperty(key)) {
        if (props[key] != undefined) state[key] = props[key];
      } else {
        tool.Message.errorMsg(resource.AttributeError + key);
      }
    }
  } // 初始化数据


  var clampToGround = undefined,
      classificationType = undefined;
  var perPositionHeight = true,
      classificationType_gon = Cesium.ClassificationType.TERRAIN;
  var selected_line = undefined;
  var selected_gon = undefined;
  var setHeight = undefined;

  if (storeState.isViewer) {
    if (!window.tooltip) {
      window.tooltip = createTooltip$1(viewer._element);
    }

    viewer.eventManager.addEventListener("CLICK", LEFT_CLICK_Listener, false);
    Edit(); //编辑功能
  } //viewer 初始化完成的监听


  watch(function () {
    return storeState.isViewer;
  }, function (val) {
    if (val) {
      if (!window.tooltip) {
        window.tooltip = createTooltip$1(viewer._element);
      }

      viewer.eventManager.addEventListener("CLICK", LEFT_CLICK_Listener, false);
      Edit(); //编辑功能
    }
  });

  function changeSelect(id) {
    state.currentId = id;
  }

  function drawPolyline() {
    if (!window.handlerPolyline) {
      initHandler("Polyline");
    }

    window.tooltip.showAt(' <p>点击鼠标左键开始绘制</p><p>右键单击结束分析</p><p>选中对象进行编辑或清除</p>', '50%');
    handlerDrawing("Polyline").then(function (res) {
      creat_entity_line(res.result.object.positions);
      var handlerPolyline = window.handlerPolyline;
      handlerPolyline.polyline.show = false;
      window.polylineTransparent.show = false; //半透线隐藏

      handlerPolyline.deactivate();
      tooltip.setVisible(false);
    }, function (err) {
      console.log(err);
    });
    window.handlerPolyline.activate();
  }

  function creat_entity_line(position) {
    var lineColor = Cesium.Color.fromCssColorString(state.lineColor);
    var lineWidth = Number(state.lineWidth);
    var material;

    switch (state.currentId) {
      case '1':
        material = lineColor;
        break;

      case '2':
        var dottedColor = Cesium.Color.fromCssColorString(state.dottedColor); //间隔颜色

        var dottedLength = Number(state.dottedLength);
        material = new Cesium.PolylineDashMaterialProperty({
          color: lineColor,
          gapColor: dottedColor,
          dashLength: dottedLength
        });
        break;

      case '3':
        var outLineColor = Cesium.Color.fromCssColorString(state.outLineColor); //轮廓颜色

        var outLineWidth = Number(state.outLineWidth);
        material = new Cesium.PolylineOutlineMaterialProperty({
          color: lineColor,
          outlineWidth: outLineWidth,
          outlineColor: outLineColor
        });
        break;

      case '4':
        material = new Cesium.PolylineArrowMaterialProperty(lineColor);
        break;

      case '5':
        var glowStrength = Number(state.glowStrength);
        material = new Cesium.PolylineGlowMaterialProperty({
          glowPower: glowStrength,
          color: lineColor
        });
        break;

      case '6':
        var trailPercentage = Number(state.trailPercentage);
        material = new Cesium.PolylineTrailMaterialProperty({
          color: lineColor,
          trailLength: trailPercentage,
          period: state.trailPeroid
        });
        break;

      default:
        material = lineColor;
        break;
    }
    selected_line = viewer.entities.add({
      id: "polyline-symbol-line-" + new Date().getTime(),
      polyline: {
        positions: position,
        width: lineWidth,
        material: material,
        clampToGround: clampToGround,
        //线贴地
        classificationType: classificationType,
        //线面贴对象
        height: setHeight
      }
    });
  }

  function LEFT_CLICK_Listener(e) {
    //获取点击位置笛卡尔坐标
    var selectedEntity = viewer.scene.pick(e.message.position);

    if (selectedEntity && selectedEntity.id && selectedEntity.id.id && typeof selectedEntity.id.id === 'string') {
      if (selectedEntity.id.id.indexOf("polyline-symbol-line") != -1) {
        selected_line = selectedEntity.id;
      }

      if (selectedEntity.id.id.indexOf("polygon-symbol-gon") != -1) {
        selected_gon = selectedEntity.id;
      }
    }
  }

  function clear() {
    if (selected_line && state.drawType === 'polyline') viewer.entities.removeById(selected_line.id);
    if (selected_gon && state.drawType === 'polygon') viewer.entities.removeById(selected_gon.id);
    window.tooltip.setVisible(false);
    clearHandlerDrawing('Polyline');
    clearHandlerDrawing('Polygon');
    if (window.editHandler) window.editHandler.clear();
  }

  function draw() {
    if (state.drawType === 'polyline') drawPolyline();else drawPolygon();
  }

  function drawPolygon() {
    if (!window.handlerPolygon) {
      initHandler("Polygon");
    }

    handlerDrawing("Polygon", false).then(function (res) {
      var handlerPolygon = window.handlerPolygon;
      creat_entity_gon(res.result.object.positions);
      handlerPolygon.polygon.show = false;
      handlerPolygon.polyline.show = false;
      handlerPolygon.deactivate();
    }, function (err) {
      console.log(err);
    });
    window.handlerPolygon.activate();
  }

  function creat_entity_gon(position) {
    console.log(position);
    var material;

    switch (state.currentId) {
      case '1':
        var polygonColor = Cesium.Color.fromCssColorString(state.solidColor);
        material = polygonColor;
        break;

      case '2':
        var gridColor = Cesium.Color.fromCssColorString(state.gridColor); //间隔颜色

        var gridWidth = Number(state.gridWidth);
        var gridCount = Number(state.gridCount);
        var gridCellAlpha = Number(state.gridCellAlpha);
        material = new Cesium.GridMaterialProperty({
          color: gridColor,
          cellAlpha: gridCellAlpha,
          lineCount: new Cesium.Cartesian2(gridCount, gridCount),
          lineThickness: new Cesium.Cartesian2(gridWidth, gridWidth)
        });
        break;

      case '3':
        var stripeEvenColor = Cesium.Color.fromCssColorString(state.stripeEvenColor); //间隔颜色

        var stripeOddColor = Cesium.Color.fromCssColorString(state.stripeOddColor); //间隔颜色

        var stripeRepeat = Number(state.stripeRepeat);
        var stripeOffset = Number(state.stripeOffset);
        material = new Cesium.StripeMaterialProperty({
          evenColor: stripeEvenColor,
          oddColor: stripeOddColor,
          repeat: stripeRepeat,
          offset: stripeOffset,
          orientation: state.stripeOrientation === 'horizontal' ? 0 : 1
        });
        break;
    }
    selected_gon = viewer.entities.add({
      id: "polygon-symbol-gon-" + new Date().getTime(),
      polygon: {
        hierarchy: {
          positions: position
        },
        material: material // perPositionHeight: perPositionHeight,
        // heightReference: Cesium.HeightReference.NONE 

      } // clampToS3M: clampToS3M
      // classificationType: classificationType, //面贴对象
      // height: setHeight

    });
  } // 销毁


  onBeforeUnmount(function () {
    if (viewer) viewer.eventManager.removeEventListener("CLICK", LEFT_CLICK_Listener);
  }); // 监听

  function setLineMode(val1, val2, val3) {
    clampToGround = val1;
    classificationType = val2;
    setHeight = val3;

    if (selected_line) {
      selected_line.polyline.clampToGround = clampToGround;
      selected_line.polyline.classificationType = classificationType;
      selected_line.polyline.height = val3;
    }
  } // 


  function setGonMode(val1, val2, val3) {
    perPositionHeight = val1;
    classificationType = val2;
    setHeight = val3;

    if (selected_gon) {
      selected_gon.polygon.perPositionHeight = perPositionHeight;
      selected_gon.classificationType = classificationType;
      selected_gon.polygon.height = val3;
    }
  }

  watch(function () {
    return state.drawModle;
  }, function (val) {
    var isLine = state.drawType === 'polyline' ? true : false;

    switch (val) {
      case "space":
        if (isLine) setLineMode(undefined, undefined, undefined);else setGonMode(true, undefined, undefined);
        break;

      case "stick":
        if (isLine) setLineMode(true, Cesium.ClassificationType.TERRAIN, 0);else setGonMode(false, Cesium.ClassificationType.TERRAIN, 0);
        break;

      case "postObject":
        if (isLine) setLineMode(true, Cesium.ClassificationType.S3M_TILE, undefined);else setGonMode(false, Cesium.ClassificationType.S3M_TILE, undefined);
        break;

      default:
        setLineMode(undefined, undefined, undefined);
        setGonMode(true, false, undefined);
        break;
    }
  });
  watch(function () {
    return state.lineColor;
  }, function (val) {
    var color = Cesium.Color.fromCssColorString(val);
    if (selected_line) selected_line.polyline.material.color = color;
  });
  watch(function () {
    return state.lineWidth;
  }, function (val) {
    if (selected_line) selected_line.polyline.width = Number(val);
  });
  watch(function () {
    return state.dottedColor;
  }, function (val) {
    var color = Cesium.Color.fromCssColorString(val);
    if (selected_line) selected_line.polyline.material.gapColor = color;
  });
  watch(function () {
    return state.dottedLength;
  }, function (val) {
    if (selected_line) selected_line.polyline.material.dashLength = Number(val);
  });
  watch(function () {
    return state.outLineColor;
  }, function (val) {
    var color = Cesium.Color.fromCssColorString(val);
    if (selected_line) selected_line.polyline.material.outlineColor = color;
  });
  watch(function () {
    return state.outLineWidth;
  }, function (val) {
    if (selected_line) selected_line.polyline.material.outlineWidth = Number(val);
  });
  watch(function () {
    return state.glowStrength;
  }, function (val) {
    if (selected_line) selected_line.polyline.material.glowPower = Number(val);
  });
  watch(function () {
    return state.trailPercentage;
  }, function (val) {
    if (selected_line) selected_line.polyline.material.trailLength = Number(val);
  });
  watch(function () {
    return state.isEdit;
  }, function (val) {
    if (!selected_line) return;

    if (val) {
      Edit();
      return;
    }

    clearEditHandler();
  });
  watch(function () {
    return state.isEditZ;
  }, function (val) {
    if (!selected_line) return;

    if (window.editHandler) {
      window.editHandler.isEditZ = val;
    }
  }); //面

  watch(function () {
    return state.drawType;
  }, function (val) {
    state.currentId = '1';
  });
  watch(function () {
    return state.solidColor;
  }, function (val) {
    var color = Cesium.Color.fromCssColorString(val);
    if (selected_gon) selected_gon.polygon.material = color;
  });
  watch(function () {
    return state.gridColor;
  }, function (val) {
    var color = Cesium.Color.fromCssColorString(val);
    if (selected_gon) selected_gon.polygon.material.color = color;
  });
  watch(function () {
    return state.gridWidth;
  }, function (val) {
    if (selected_gon) selected_gon.polygon.material.lineThickness = new Cesium.Cartesian2(Number(val), Number(val));
  });
  watch(function () {
    return state.gridCount;
  }, function (val) {
    if (selected_gon) selected_gon.polygon.material.lineCount = new Cesium.Cartesian2(Number(val), Number(val));
  });
  watch(function () {
    return state.gridCellAlpha;
  }, function (val) {
    if (selected_gon) selected_gon.polygon.material.cellAlpha = Number(val);
  });
  watch(function () {
    return state.stripeEvenColor;
  }, function (val) {
    var color = Cesium.Color.fromCssColorString(val);
    if (selected_gon) selected_gon.polygon.material.evenColor = color;
  });
  watch(function () {
    return state.stripeOddColor;
  }, function (val) {
    var color = Cesium.Color.fromCssColorString(val);
    if (selected_gon) selected_gon.polygon.material.oddColor = color;
  });
  watch(function () {
    return state.stripeRepeat;
  }, function (val) {
    if (selected_gon) selected_gon.polygon.material.repeat = Number(val);
  });
  watch(function () {
    return state.stripeOffset;
  }, function (val) {
    if (selected_gon) selected_gon.polygon.material.offset = Number(val);
  });
  watch(function () {
    return state.stripeOrientation;
  }, function (val) {
    if (!selected_gon) return;
    var or = val === 'horizontal' ? 0 : 1;
    selected_gon.polygon.material.orientation = or;
  });
  return _objectSpread2(_objectSpread2({}, toRefs(state)), {}, {
    draw: draw,
    changeSelect: changeSelect,
    clear: clear
  });
}

var script = {
  name: "Sm3dDrawLinePolygon",
  props: {},
  setup: function setup(props) {
    var _drawline = draw(props),
        drawModle = _drawline.drawModle,
        currentId = _drawline.currentId,
        lineColor = _drawline.lineColor,
        lineWidth = _drawline.lineWidth,
        config = _drawline.config,
        draw$1 = _drawline.draw,
        changeSelect = _drawline.changeSelect,
        clear = _drawline.clear,
        isEdit = _drawline.isEdit,
        isEditZ = _drawline.isEditZ,
        dottedColor = _drawline.dottedColor,
        dottedLength = _drawline.dottedLength,
        outLineColor = _drawline.outLineColor,
        outLineWidth = _drawline.outLineWidth,
        glowStrength = _drawline.glowStrength,
        trailPercentage = _drawline.trailPercentage,
        drawType = _drawline.drawType,
        solidColor = _drawline.solidColor,
        gridColor = _drawline.gridColor,
        gridWidth = _drawline.gridWidth,
        gridCount = _drawline.gridCount,
        gridCellAlpha = _drawline.gridCellAlpha,
        stripeEvenColor = _drawline.stripeEvenColor,
        stripeOddColor = _drawline.stripeOddColor,
        stripeRepeat = _drawline.stripeRepeat,
        stripeOffset = _drawline.stripeOffset,
        stripeOrientation = _drawline.stripeOrientation;

    return {
      drawModle: drawModle,
      currentId: currentId,
      lineColor: lineColor,
      lineWidth: lineWidth,
      config: config,
      draw: draw$1,
      changeSelect: changeSelect,
      clear: clear,
      isEdit: isEdit,
      isEditZ: isEditZ,
      dottedColor: dottedColor,
      //间隔颜色
      dottedLength: dottedLength,
      outLineColor: outLineColor,
      outLineWidth: outLineWidth,
      glowStrength: glowStrength,
      trailPercentage: trailPercentage,
      drawType: drawType,
      solidColor: solidColor,
      gridColor: gridColor,
      gridWidth: gridWidth,
      gridCount: gridCount,
      gridCellAlpha: gridCellAlpha,
      stripeEvenColor: stripeEvenColor,
      stripeOddColor: stripeOddColor,
      stripeRepeat: stripeRepeat,
      stripeOffset: stripeOffset,
      stripeOrientation: stripeOrientation
    };
  }
};

var _hoisted_1 = {
  id: "draw-panel",
  "class": "sm-panel"
};
var _hoisted_2 = {
  "class": "sm-function-module-sub-section",
  style: {
    "margin": "0"
  }
};
var _hoisted_3 = {
  "class": "sm-half-L"
};
var _hoisted_4 = {
  style: {
    "width": "auto"
  }
};
var _hoisted_5 = {
  style: {
    "width": "auto"
  }
};
var _hoisted_6 = {
  "class": "sm-half-L"
};
var _hoisted_7 = {
  style: {
    "width": "35%"
  }
};
var _hoisted_8 = {
  value: "space"
};
var _hoisted_9 = {
  value: "stick"
};
var _hoisted_10 = {
  value: "postObject"
};
var _hoisted_11 = {
  "class": "sm-half-L"
};
var _hoisted_12 = {
  style: {
    "width": "auto"
  }
};
var _hoisted_13 = {
  style: {
    "width": "100%"
  }
};
var _hoisted_14 = {
  "class": "sm-half-L symbolic"
};
var _hoisted_15 = ["onClick"];
var _hoisted_16 = {
  style: {
    "width": "100%"
  }
};
var _hoisted_17 = {
  "class": "sm-half-L"
};
var _hoisted_18 = {
  style: {
    "width": "35%"
  }
};
var _hoisted_19 = {
  "class": "sm-half-L"
};
var _hoisted_20 = {
  style: {
    "width": "35%"
  }
};
var _hoisted_21 = {
  "class": "sm-half-L"
};
var _hoisted_22 = {
  style: {
    "width": "35%"
  }
};
var _hoisted_23 = {
  "class": "sm-half-L"
};
var _hoisted_24 = {
  style: {
    "width": "35%"
  }
};
var _hoisted_25 = {
  "class": "sm-half-L"
};
var _hoisted_26 = {
  style: {
    "width": "35%"
  }
};
var _hoisted_27 = {
  "class": "sm-half-L"
};
var _hoisted_28 = {
  style: {
    "width": "35%"
  }
};
var _hoisted_29 = {
  "class": "sm-half-L"
};
var _hoisted_30 = {
  style: {
    "width": "35%"
  }
};
var _hoisted_31 = {
  "class": "sm-half-L"
};
var _hoisted_32 = {
  style: {
    "width": "35%"
  }
};
var _hoisted_33 = {
  style: {
    "width": "100%"
  }
};
var _hoisted_34 = {
  "class": "sm-half-L symbolic"
};
var _hoisted_35 = ["onClick"];
var _hoisted_36 = {
  style: {
    "width": "100%"
  }
};
var _hoisted_37 = {
  "class": "sm-half-L"
};
var _hoisted_38 = {
  style: {
    "width": "35%"
  }
};
var _hoisted_39 = {
  "class": "sm-half-L"
};
var _hoisted_40 = {
  style: {
    "width": "35%"
  }
};
var _hoisted_41 = {
  "class": "sm-half-L"
};
var _hoisted_42 = {
  style: {
    "width": "35%"
  }
};
var _hoisted_43 = {
  "class": "sm-half-L"
};
var _hoisted_44 = {
  style: {
    "width": "35%"
  }
};
var _hoisted_45 = {
  "class": "sm-half-L"
};
var _hoisted_46 = {
  style: {
    "width": "35%"
  }
};
var _hoisted_47 = {
  "class": "sm-half-L"
};
var _hoisted_48 = {
  style: {
    "width": "35%"
  }
};
var _hoisted_49 = {
  "class": "sm-half-L"
};
var _hoisted_50 = {
  style: {
    "width": "35%"
  }
};
var _hoisted_51 = {
  "class": "sm-half-L"
};
var _hoisted_52 = {
  style: {
    "width": "35%"
  }
};
var _hoisted_53 = {
  "class": "sm-half-L"
};
var _hoisted_54 = {
  style: {
    "width": "35%"
  }
};
var _hoisted_55 = {
  "class": "sm-half-L"
};
var _hoisted_56 = {
  style: {
    "width": "auto"
  }
};
var _hoisted_57 = {
  style: {
    "width": "auto"
  }
};
var _hoisted_58 = {
  "class": "boxchild"
};
function render(_ctx, _cache, $props, $setup, $data, $options) {
  var _component_el_color_picker = resolveComponent("el-color-picker");

  var _directive_stopdrag = resolveDirective("stopdrag");

  var _directive_drag = resolveDirective("drag");

  return withDirectives((openBlock(), createElementBlock("div", _hoisted_1, [withDirectives((openBlock(), createElementBlock("div", _hoisted_2, [createElementVNode("div", _hoisted_3, [createElementVNode("label", _hoisted_4, [withDirectives(createElementVNode("input", {
    type: "radio",
    value: "polyline",
    "onUpdate:modelValue": _cache[0] || (_cache[0] = function ($event) {
      return $setup.drawType = $event;
    })
  }, null, 512
  /* NEED_PATCH */
  ), [[vModelRadio, $setup.drawType]]), createTextVNode(" " + toDisplayString(_ctx.Resource.polyline), 1
  /* TEXT */
  )]), createElementVNode("label", _hoisted_5, [withDirectives(createElementVNode("input", {
    type: "radio",
    value: "polygon",
    "onUpdate:modelValue": _cache[1] || (_cache[1] = function ($event) {
      return $setup.drawType = $event;
    })
  }, null, 512
  /* NEED_PATCH */
  ), [[vModelRadio, $setup.drawType]]), createTextVNode(" " + toDisplayString(_ctx.Resource.polygon), 1
  /* TEXT */
  )])]), createElementVNode("div", _hoisted_6, [createElementVNode("label", _hoisted_7, toDisplayString(_ctx.Resource.drawModle), 1
  /* TEXT */
  ), withDirectives(createElementVNode("select", {
    "class": "sm-select",
    style: {
      "width": "63%"
    },
    "onUpdate:modelValue": _cache[2] || (_cache[2] = function ($event) {
      return $setup.drawModle = $event;
    })
  }, [createElementVNode("option", _hoisted_8, toDisplayString(_ctx.Resource.space), 1
  /* TEXT */
  ), createElementVNode("option", _hoisted_9, toDisplayString(_ctx.Resource.stick), 1
  /* TEXT */
  ), createElementVNode("option", _hoisted_10, toDisplayString(_ctx.Resource.postObject), 1
  /* TEXT */
  )], 512
  /* NEED_PATCH */
  ), [[vModelSelect, $setup.drawModle]])]), createElementVNode("div", _hoisted_11, [createElementVNode("label", _hoisted_12, [withDirectives(createElementVNode("input", {
    type: "checkbox",
    style: {
      "margin-right": "14px"
    },
    "onUpdate:modelValue": _cache[3] || (_cache[3] = function ($event) {
      return $setup.isEdit = $event;
    })
  }, null, 512
  /* NEED_PATCH */
  ), [[vModelCheckbox, $setup.isEdit]]), createTextVNode(" " + toDisplayString(_ctx.Resource.isEdit), 1
  /* TEXT */
  )]), createCommentVNode(" <label style=\"width:auto\">\r\n          <input type=\"checkbox\" style=\"margin-right:14px\" v-model=\"  \" />\r\n          {{Resource.isEditZ}}\r\n        </label> ")]), createCommentVNode(" 线 "), withDirectives(createElementVNode("div", _hoisted_13, [createElementVNode("div", _hoisted_14, [(openBlock(true), createElementBlock(Fragment, null, renderList($setup.config.polyline, function (line) {
    return openBlock(), createElementBlock("div", {
      key: line.id,
      "class": normalizeClass(["symbolic-box", {
        'theme-color': line.id === $setup.currentId
      }]),
      onClick: function onClick($event) {
        return $setup.changeSelect(line.id);
      }
    }, [createElementVNode("span", {
      "class": normalizeClass(["iconfont", line.iconfont])
    }, null, 2
    /* CLASS */
    ), createElementVNode("label", _hoisted_16, toDisplayString(line.lineName), 1
    /* TEXT */
    )], 10
    /* CLASS, PROPS */
    , _hoisted_15);
  }), 128
  /* KEYED_FRAGMENT */
  ))]), createElementVNode("div", _hoisted_17, [createElementVNode("label", _hoisted_18, toDisplayString(_ctx.Resource.lineColor), 1
  /* TEXT */
  ), createVNode(_component_el_color_picker, {
    modelValue: $setup.lineColor,
    "onUpdate:modelValue": _cache[4] || (_cache[4] = function ($event) {
      return $setup.lineColor = $event;
    }),
    size: "mini",
    "show-alpha": "",
    style: {
      "width": "63%"
    }
  }, null, 8
  /* PROPS */
  , ["modelValue"])]), createElementVNode("div", _hoisted_19, [createElementVNode("label", _hoisted_20, toDisplayString(_ctx.Resource.lineWidth), 1
  /* TEXT */
  ), withDirectives(createElementVNode("input", {
    type: "number",
    "class": "sm-input",
    style: {
      "width": "63%"
    },
    "onUpdate:modelValue": _cache[5] || (_cache[5] = function ($event) {
      return $setup.lineWidth = $event;
    })
  }, null, 512
  /* NEED_PATCH */
  ), [[vModelText, $setup.lineWidth]])]), createCommentVNode(" 虚线 "), withDirectives(createElementVNode("div", _hoisted_21, [createElementVNode("label", _hoisted_22, toDisplayString(_ctx.Resource.dottedColor), 1
  /* TEXT */
  ), createVNode(_component_el_color_picker, {
    modelValue: $setup.dottedColor,
    "onUpdate:modelValue": _cache[6] || (_cache[6] = function ($event) {
      return $setup.dottedColor = $event;
    }),
    size: "mini",
    "show-alpha": "",
    style: {
      "width": "63%"
    }
  }, null, 8
  /* PROPS */
  , ["modelValue"])], 512
  /* NEED_PATCH */
  ), [[vShow, $setup.currentId === '2']]), withDirectives(createElementVNode("div", _hoisted_23, [createElementVNode("label", _hoisted_24, toDisplayString(_ctx.Resource.dottedLength), 1
  /* TEXT */
  ), withDirectives(createElementVNode("input", {
    type: "number",
    min: "0",
    "class": "sm-input",
    style: {
      "width": "63%"
    },
    "onUpdate:modelValue": _cache[7] || (_cache[7] = function ($event) {
      return $setup.dottedLength = $event;
    })
  }, null, 512
  /* NEED_PATCH */
  ), [[vModelText, $setup.dottedLength]])], 512
  /* NEED_PATCH */
  ), [[vShow, $setup.currentId === '2']]), createCommentVNode(" 轮廓线 "), withDirectives(createElementVNode("div", _hoisted_25, [createElementVNode("label", _hoisted_26, toDisplayString(_ctx.Resource.outLineColor), 1
  /* TEXT */
  ), createVNode(_component_el_color_picker, {
    modelValue: $setup.outLineColor,
    "onUpdate:modelValue": _cache[8] || (_cache[8] = function ($event) {
      return $setup.outLineColor = $event;
    }),
    size: "mini",
    "show-alpha": "",
    style: {
      "width": "63%"
    }
  }, null, 8
  /* PROPS */
  , ["modelValue"])], 512
  /* NEED_PATCH */
  ), [[vShow, $setup.currentId === '3']]), withDirectives(createElementVNode("div", _hoisted_27, [createElementVNode("label", _hoisted_28, toDisplayString(_ctx.Resource.outLineWidth), 1
  /* TEXT */
  ), withDirectives(createElementVNode("input", {
    type: "number",
    min: "0",
    "class": "sm-input",
    style: {
      "width": "63%"
    },
    "onUpdate:modelValue": _cache[9] || (_cache[9] = function ($event) {
      return $setup.outLineWidth = $event;
    })
  }, null, 512
  /* NEED_PATCH */
  ), [[vModelText, $setup.outLineWidth]])], 512
  /* NEED_PATCH */
  ), [[vShow, $setup.currentId === '3']]), createCommentVNode(" 光晕线 "), withDirectives(createElementVNode("div", _hoisted_29, [createElementVNode("label", _hoisted_30, toDisplayString(_ctx.Resource.glowStrength), 1
  /* TEXT */
  ), withDirectives(createElementVNode("input", {
    type: "number",
    "class": "sm-input",
    min: "0",
    step: "0.1",
    style: {
      "width": "63%"
    },
    "onUpdate:modelValue": _cache[10] || (_cache[10] = function ($event) {
      return $setup.glowStrength = $event;
    })
  }, null, 512
  /* NEED_PATCH */
  ), [[vModelText, $setup.glowStrength]])], 512
  /* NEED_PATCH */
  ), [[vShow, $setup.currentId === '5']]), createCommentVNode(" 尾迹线 "), withDirectives(createElementVNode("div", _hoisted_31, [createElementVNode("label", _hoisted_32, toDisplayString(_ctx.Resource.trailPercentage), 1
  /* TEXT */
  ), withDirectives(createElementVNode("input", {
    type: "number",
    "class": "sm-input",
    min: "0",
    step: "0.1",
    style: {
      "width": "63%"
    },
    "onUpdate:modelValue": _cache[11] || (_cache[11] = function ($event) {
      return $setup.trailPercentage = $event;
    })
  }, null, 512
  /* NEED_PATCH */
  ), [[vModelText, $setup.trailPercentage]])], 512
  /* NEED_PATCH */
  ), [[vShow, $setup.currentId === '6']])], 512
  /* NEED_PATCH */
  ), [[vShow, $setup.drawType === 'polyline']]), createCommentVNode(" 面 "), withDirectives(createElementVNode("div", _hoisted_33, [createElementVNode("div", _hoisted_34, [(openBlock(true), createElementBlock(Fragment, null, renderList($setup.config.polygon, function (polygon) {
    return openBlock(), createElementBlock("div", {
      key: polygon.id,
      "class": normalizeClass(["symbolic-box", {
        'theme-color': polygon.id === $setup.currentId
      }]),
      onClick: function onClick($event) {
        return $setup.changeSelect(polygon.id);
      }
    }, [createElementVNode("span", {
      "class": normalizeClass(["iconfont", polygon.iconfont])
    }, null, 2
    /* CLASS */
    ), createElementVNode("label", _hoisted_36, toDisplayString(polygon.faceName), 1
    /* TEXT */
    )], 10
    /* CLASS, PROPS */
    , _hoisted_35);
  }), 128
  /* KEYED_FRAGMENT */
  ))]), createCommentVNode(" 纯色 "), withDirectives(createElementVNode("div", _hoisted_37, [createElementVNode("label", _hoisted_38, toDisplayString(_ctx.Resource.polygonColor), 1
  /* TEXT */
  ), createVNode(_component_el_color_picker, {
    modelValue: $setup.solidColor,
    "onUpdate:modelValue": _cache[12] || (_cache[12] = function ($event) {
      return $setup.solidColor = $event;
    }),
    size: "mini",
    "show-alpha": "",
    style: {
      "width": "63%"
    }
  }, null, 8
  /* PROPS */
  , ["modelValue"])], 512
  /* NEED_PATCH */
  ), [[vShow, $setup.currentId === '1']]), createCommentVNode(" 网格 "), withDirectives(createElementVNode("div", _hoisted_39, [createElementVNode("label", _hoisted_40, toDisplayString(_ctx.Resource.polygonColor), 1
  /* TEXT */
  ), createVNode(_component_el_color_picker, {
    modelValue: $setup.gridColor,
    "onUpdate:modelValue": _cache[13] || (_cache[13] = function ($event) {
      return $setup.gridColor = $event;
    }),
    size: "mini",
    "show-alpha": "",
    style: {
      "width": "63%"
    }
  }, null, 8
  /* PROPS */
  , ["modelValue"])], 512
  /* NEED_PATCH */
  ), [[vShow, $setup.currentId === '2']]), withDirectives(createElementVNode("div", _hoisted_41, [createElementVNode("label", _hoisted_42, toDisplayString(_ctx.Resource.gridWidth), 1
  /* TEXT */
  ), withDirectives(createElementVNode("input", {
    type: "number",
    min: "0",
    "class": "sm-input",
    style: {
      "width": "63%"
    },
    "onUpdate:modelValue": _cache[14] || (_cache[14] = function ($event) {
      return $setup.gridWidth = $event;
    })
  }, null, 512
  /* NEED_PATCH */
  ), [[vModelText, $setup.gridWidth]])], 512
  /* NEED_PATCH */
  ), [[vShow, $setup.currentId === '2']]), withDirectives(createElementVNode("div", _hoisted_43, [createElementVNode("label", _hoisted_44, toDisplayString(_ctx.Resource.gridCount), 1
  /* TEXT */
  ), withDirectives(createElementVNode("input", {
    type: "number",
    min: "0",
    "class": "sm-input",
    style: {
      "width": "63%"
    },
    "onUpdate:modelValue": _cache[15] || (_cache[15] = function ($event) {
      return $setup.gridCount = $event;
    })
  }, null, 512
  /* NEED_PATCH */
  ), [[vModelText, $setup.gridCount]])], 512
  /* NEED_PATCH */
  ), [[vShow, $setup.currentId === '2']]), withDirectives(createElementVNode("div", _hoisted_45, [createElementVNode("label", _hoisted_46, toDisplayString(_ctx.Resource.gridCellAlpha), 1
  /* TEXT */
  ), withDirectives(createElementVNode("input", {
    type: "number",
    "class": "sm-input",
    min: "0",
    step: "0.1",
    style: {
      "width": "63%"
    },
    "onUpdate:modelValue": _cache[16] || (_cache[16] = function ($event) {
      return $setup.gridCellAlpha = $event;
    })
  }, null, 512
  /* NEED_PATCH */
  ), [[vModelText, $setup.gridCellAlpha]])], 512
  /* NEED_PATCH */
  ), [[vShow, $setup.currentId === '2']]), createCommentVNode(" 条纹 "), withDirectives(createElementVNode("div", _hoisted_47, [createElementVNode("label", _hoisted_48, toDisplayString(_ctx.Resource.stripeEvenColor), 1
  /* TEXT */
  ), createVNode(_component_el_color_picker, {
    modelValue: $setup.stripeEvenColor,
    "onUpdate:modelValue": _cache[17] || (_cache[17] = function ($event) {
      return $setup.stripeEvenColor = $event;
    }),
    size: "mini",
    "show-alpha": "",
    style: {
      "width": "63%"
    }
  }, null, 8
  /* PROPS */
  , ["modelValue"])], 512
  /* NEED_PATCH */
  ), [[vShow, $setup.currentId === '3']]), withDirectives(createElementVNode("div", _hoisted_49, [createElementVNode("label", _hoisted_50, toDisplayString(_ctx.Resource.stripeOddColor), 1
  /* TEXT */
  ), createVNode(_component_el_color_picker, {
    modelValue: $setup.stripeOddColor,
    "onUpdate:modelValue": _cache[18] || (_cache[18] = function ($event) {
      return $setup.stripeOddColor = $event;
    }),
    size: "mini",
    "show-alpha": "",
    style: {
      "width": "63%"
    }
  }, null, 8
  /* PROPS */
  , ["modelValue"])], 512
  /* NEED_PATCH */
  ), [[vShow, $setup.currentId === '3']]), withDirectives(createElementVNode("div", _hoisted_51, [createElementVNode("label", _hoisted_52, toDisplayString(_ctx.Resource.stripeRepeat), 1
  /* TEXT */
  ), withDirectives(createElementVNode("input", {
    type: "number",
    min: "0",
    "class": "sm-input",
    style: {
      "width": "63%"
    },
    "onUpdate:modelValue": _cache[19] || (_cache[19] = function ($event) {
      return $setup.stripeRepeat = $event;
    })
  }, null, 512
  /* NEED_PATCH */
  ), [[vModelText, $setup.stripeRepeat]])], 512
  /* NEED_PATCH */
  ), [[vShow, $setup.currentId === '3']]), withDirectives(createElementVNode("div", _hoisted_53, [createElementVNode("label", _hoisted_54, toDisplayString(_ctx.Resource.stripeOffset), 1
  /* TEXT */
  ), withDirectives(createElementVNode("input", {
    type: "number",
    min: "0",
    "class": "sm-input",
    style: {
      "width": "63%"
    },
    "onUpdate:modelValue": _cache[20] || (_cache[20] = function ($event) {
      return $setup.stripeOffset = $event;
    })
  }, null, 512
  /* NEED_PATCH */
  ), [[vModelText, $setup.stripeOffset]])], 512
  /* NEED_PATCH */
  ), [[vShow, $setup.currentId === '3']]), withDirectives(createElementVNode("div", _hoisted_55, [createElementVNode("label", _hoisted_56, [withDirectives(createElementVNode("input", {
    type: "radio",
    value: "horizontal",
    "onUpdate:modelValue": _cache[21] || (_cache[21] = function ($event) {
      return $setup.stripeOrientation = $event;
    })
  }, null, 512
  /* NEED_PATCH */
  ), [[vModelRadio, $setup.stripeOrientation]]), createTextVNode(" " + toDisplayString(_ctx.Resource.stripeOrientation), 1
  /* TEXT */
  )]), createElementVNode("label", _hoisted_57, [withDirectives(createElementVNode("input", {
    type: "radio",
    value: "vertical",
    "onUpdate:modelValue": _cache[22] || (_cache[22] = function ($event) {
      return $setup.stripeOrientation = $event;
    })
  }, null, 512
  /* NEED_PATCH */
  ), [[vModelRadio, $setup.stripeOrientation]]), createTextVNode(" " + toDisplayString(_ctx.Resource.stripeOrientation), 1
  /* TEXT */
  )])], 512
  /* NEED_PATCH */
  ), [[vShow, $setup.currentId === '3']])], 512
  /* NEED_PATCH */
  ), [[vShow, $setup.drawType === 'polygon']]), createElementVNode("div", _hoisted_58, [createElementVNode("button", {
    "class": "tbtn",
    type: "button",
    style: {
      "width": "auto"
    },
    onClick: _cache[23] || (_cache[23] = function () {
      return $setup.draw && $setup.draw.apply($setup, arguments);
    })
  }, toDisplayString(_ctx.Resource.draw), 1
  /* TEXT */
  ), createElementVNode("button", {
    "class": "tbtn tbtn-margin-left",
    style: {
      "width": "auto"
    },
    type: "button ",
    onClick: _cache[24] || (_cache[24] = function () {
      return $setup.clear && $setup.clear.apply($setup, arguments);
    })
  }, toDisplayString(_ctx.Resource.clear), 1
  /* TEXT */
  )])])), [[_directive_stopdrag]])])), [[_directive_drag]]);
}

script.render = render;
script.__file = "src/components/draw/draw-line-surface/draw-line-surface.vue";

script.install = function (app) {
  app.component(script.name, script);
};

export default script;
