import { reactive, toRefs, ref, watch, onMounted, onBeforeUnmount, resolveDirective, withDirectives, openBlock, createElementBlock, createElementVNode, vModelRadio, createTextVNode, toDisplayString, createCommentVNode, vModelText, vShow, Fragment, renderList, vModelSelect, vModelCheckbox } from 'vue';

function _typeof(obj) {
  "@babel/helpers - typeof";

  if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
    _typeof = function (obj) {
      return typeof obj;
    };
  } else {
    _typeof = function (obj) {
      return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
    };
  }

  return _typeof(obj);
}

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);

  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    if (enumerableOnly) symbols = symbols.filter(function (sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    });
    keys.push.apply(keys, symbols);
  }

  return keys;
}

function _objectSpread2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};

    if (i % 2) {
      ownKeys(Object(source), true).forEach(function (key) {
        _defineProperty(target, key, source[key]);
      });
    } else if (Object.getOwnPropertyDescriptors) {
      Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
      ownKeys(Object(source)).forEach(function (key) {
        Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
      });
    }
  }

  return target;
}

// 创建一个简单的store状态管理

var storeState = reactive({
  isViewer: false,
  //viewer初始化标志
  changeLayers: 0,
  //图层改变加载完毕监听
  changeGeometrys: 0 //三维分析体改变标志

});

/*
* 常用工具类
*/
//axios本版本不支持jsonp
var axiosJsonp = function axiosJsonp(url) {
  if (!url) {
    console.error('Axios.JSONP 至少需要一个url参数!');
    return;
  }

  return new Promise(function (resolve, reject) {
    window.jsonCallBack = function (result) {
      resolve(result);
    };

    var JSONP = document.createElement("script");
    JSONP.type = "text/javascript";
    JSONP.src = "".concat(url, "&callback=jsonCallBack");
    document.getElementsByTagName("head")[0].appendChild(JSONP);
    setTimeout(function () {
      document.getElementsByTagName("head")[0].removeChild(JSONP);
    }, 500);
  });
}; //判断两数组或对象相等


var isEqualArr = function isEqualArr(arg1, arg2) {
  if (!arg1 || !arg2) return true;
  var bol = true;

  if (Object.keys(arg1).length != Object.keys(arg2).length) {
    return false;
  }

  for (var key in arg1) {
    if (_typeof(arg1[key]) == 'object') {
      bol = isSame(arg1[key], arg2[key]);

      if (!bol) {
        break;
      }
    } else if (arg1[key] != arg2[key]) {
      bol = false;
      break;
    }
  }

  return bol;
}; //坐标转化
//笛卡尔转经纬度


var CartesiantoDegrees = function CartesiantoDegrees(Cartesians) {
  var array = [].concat(Cartesians);
  var positions = [];

  for (var i = 0, len = array.length; i < len; i++) {
    var cartographic = Cesium.Cartographic.fromCartesian(array[i]);
    var longitude = Cesium.Math.toDegrees(cartographic.longitude);
    var latitude = Cesium.Math.toDegrees(cartographic.latitude);
    var h = cartographic.height;

    if (positions.indexOf(longitude) == -1 && positions.indexOf(latitude) == -1) {
      positions.push(longitude);
      positions.push(latitude);
      positions.push(h);
    }
  }

  return positions;
}; //笛卡尔转经纬度(每个点是独立的对象)


var CartesiantoDegreesObjs = function CartesiantoDegreesObjs(Cartesians) {
  var array = [].concat(Cartesians);
  var positions = [];

  for (var i = 0, len = array.length; i < len; i++) {
    var cartographic = Cesium.Cartographic.fromCartesian(array[i]);
    var obj = {
      longitude: Cesium.Math.toDegrees(cartographic.longitude),
      latitude: Cesium.Math.toDegrees(cartographic.latitude),
      height: cartographic.height
    };
    positions.push(obj);
  }

  return positions;
}; // 弧度转经纬度


var CartographictoDegrees = function CartographictoDegrees(wgsPosition) {
  var longitude = Cesium.Math.toDegrees(wgsPosition.longitude);
  var latitude = Cesium.Math.toDegrees(wgsPosition.latitude);
  var height = wgsPosition.height;
  return [longitude, latitude, height];
}; //去重函数  数组


var unique = function unique(arr) {
  var res = [];
  var json = {};

  for (var i = 0; i < arr.length; i++) {
    if (!json[arr[i]]) {
      res.push(arr[i]);
      json[arr[i]] = 1;
    }
  }

  return res;
}; // 获取渐变色函数


function gradientColors(start, end, steps, gamma) {
  var i,
      j,
      ms,
      me,
      output = [],
      so = [];
  gamma = gamma || 1;

  var normalize = function normalize(channel) {
    return Math.pow(channel / 255, gamma);
  };

  start = parseColor(start).map(normalize);
  end = parseColor(end).map(normalize);

  for (i = 0; i < steps; i++) {
    ms = i / (steps - 1);
    me = 1 - ms;

    for (j = 0; j < 3; j++) {
      so[j] = pad(Math.round(Math.pow(start[j] * me + end[j] * ms, 1 / gamma) * 255).toString(16));
    }

    output.push('#' + so.join(''));
  }

  return output;

  function parseColor(hexStr) {
    return hexStr.length === 4 ? hexStr.substr(1).split('').map(function (s) {
      return 0x11 * parseInt(s, 16);
    }) : [hexStr.substr(1, 2), hexStr.substr(3, 2), hexStr.substr(5, 2)].map(function (s) {
      return parseInt(s, 16);
    });
  }

  function pad(s) {
    return s.length === 1 ? '0' + s : s;
  }
}

function getAngleAndRadian(pointA, pointB) {
  //建立以点A为原点，X轴为east,Y轴为north,Z轴朝上的坐标系
  var transform = Cesium.Transforms.eastNorthUpToFixedFrame(pointA); //向量AB

  var positionvector = Cesium.Cartesian3.subtract(pointB, pointA, new Cesium.Cartesian3()); //因transform是将A为原点的eastNorthUp坐标系中的点转换到世界坐标系的矩阵
  //AB为世界坐标中的向量
  //因此将AB向量转换为A原点坐标系中的向量，需乘以transform的逆矩阵。

  var vector = Cesium.Matrix4.multiplyByPointAsVector(Cesium.Matrix4.inverse(transform, new Cesium.Matrix4()), positionvector, new Cesium.Cartesian3()); //归一化

  var direction = Cesium.Cartesian3.normalize(vector, new Cesium.Cartesian3()); //heading

  var heading1 = Math.atan2(direction.y, direction.x) - Cesium.Math.PI_OVER_TWO;
  var radian = Cesium.Math.TWO_PI - Cesium.Math.zeroToTwoPi(heading1);
  var angle = radian * (180 / Math.PI);

  if (angle < 0) {
    angle = angle + 360;
  }

  return {
    angle: angle,
    radian: radian
  };
}

function getPitch(pointA, pointB) {
  var transfrom = Cesium.Transforms.eastNorthUpToFixedFrame(pointA);
  var vector = Cesium.Cartesian3.subtract(pointB, pointA, new Cesium.Cartesian3());
  var direction = Cesium.Matrix4.multiplyByPointAsVector(Cesium.Matrix4.inverse(transfrom, transfrom), vector, vector);
  Cesium.Cartesian3.normalize(direction, direction); //因为direction已归一化，斜边长度等于1，所以余弦函数等于direction.z

  var radian = Cesium.Math.PI_OVER_TWO - Cesium.Math.acosClamped(direction.z);
  var angle = radian * (180 / Math.PI);

  if (angle < 0) {
    angle = angle + 360;
  }

  return {
    angle: angle,
    radian: radian
  };
}

var tool = {
  axiosJsonp: axiosJsonp,
  isEqualArr: isEqualArr,
  CartesiantoDegrees: CartesiantoDegrees,
  CartesiantoDegreesObjs: CartesiantoDegreesObjs,
  unique: unique,
  gradientColors: gradientColors,
  getAngleAndRadian: getAngleAndRadian,
  CartographictoDegrees: CartographictoDegrees,
  getPitch: getPitch
};

var ResourceCN = {
  showRenderLoopErrors: '渲染时发生错误，已停止渲染。',
  AttributeError: '该组件props没有这个属性：',
  NoPickPositionSupported: "不支持深度纹理,无法绘制多边形，地形操作功能无法使用！",
  NoTerrain: "请在地形里使用地形组件！",
  initViewerWarn: '请先初始化viewer!',
  MoveMouseHeightBox: '点击鼠标左键结束矩形绘制，移动鼠标绘制box高度',
  RightClickEndDrawing: '右键单击结束绘制',
  LeftClickBottomBox: '点击鼠标左键，开始绘制矩形作为box底面',
  ClickModelAddBox: '点击模型，添加裁剪盒子',
  SkyLineWarn: "获取天际线体前，请先绘制天际线！",
  SkyLineBody: '天际线体',
  ShadowqueryWarn: "此操作需要先开启阴影！",
  VeiwshedBody: '可视体',
  VeiwshedBodyHidden: '不可视体',
  EchartsErr: "二维显示需要echarts支持，未找到相关依赖！",
  BaseMapImg: '底图',
  tip1: '<p>点击左键确定操作区域中间点</p><p>右键单击结束绘制</p>'
};

// 组件内部的语言资源：主要包括提示信息
var currentLanguage, Resource;
var cookieLanguage = getLang().toLowerCase();

function getLang() {
  //浏览器语言  IE用browserLanguage，非IE使用language进行判断
  var lang = (navigator.language || navigator.browserLanguage).toLowerCase();
  window.lang = lang; //判断portal设置语言 通过cookie获取
  //   const cookies = document.cookie.split(';');
  //   if (cookies.length > 0) {
  //     cookies.forEach(function (cookie) {
  //       const arr = cookie.split('=');
  //       if (arr[0].toLowerCase().trim() === 'language') {
  //         lang = arr[1];
  //         return;
  //       }
  //     });
  //   }

  return lang;
}

if (cookieLanguage !== undefined) {
  currentLanguage = cookieLanguage;
} else {
  currentLanguage = (navigator.language || navigator.browserLanguage).toLowerCase(); // 获取当前浏览器的语言
}

if (currentLanguage.startsWith('zh')) {
  Resource = ResourceCN;
} else if (currentLanguage.startsWith('ja')) {
  Resource = ResourceCN;
} else {
  Resource = ResourceCN;
}

var resource = Resource;

/*
 * @Author: juzi.liu 
 * @Date: 2021-04-09 09:22:43 
 * @Last Modified by: juzi.liu
 * @Last Modified time: 2021-04-09 09:45:51
 */
var flylinexml = /*#__PURE__*/function () {
  function flylinexml() {
    _classCallCheck(this, flylinexml);
  }
  /**
   * 添加飞行的路线节点
   * @param {*} route ={idnex:0,speed:0, ~~~}
   */


  _createClass(flylinexml, [{
    key: "createXMLflyLine",
    value: function createXMLflyLine(route) {
      var parser = new DOMParser();
      window.parser = parser;
      var xmlDoc = parser.parseFromString("<cusxmlRoute></cusxmlRoute>", "text/xml");
      window.xmlDoc = xmlDoc;
      var sceneRouteNode = this.createSceneRouteNode(xmlDoc); //创建路线

      var routeNode = this.createRouteNode(xmlDoc, route);
      var routeStyleNode = this.createRouteStyleNode(xmlDoc);
      routeNode.appendChild(routeStyleNode); //开始添加站点

      var _that = this;

      var stops = route.routeStops;

      if (stops.length < 2) {
        console.warn("节点数小于2");
        return;
      }

      for (var index = 0; index < stops.length; index++) {
        var stop = stops[index];
        var camerainfo = {
          longitude: stop.point[0],
          latitude: stop.point[1],
          altitude: stop.point[2],
          heading: stop.heading * (180 / Math.PI),
          tilt: stop.tilt * (180 / Math.PI) + 90
        };

        var stopnode = _that.createStopNode(xmlDoc, camerainfo, stop, index);

        routeNode.appendChild(stopnode);
      }

      sceneRouteNode.appendChild(routeNode);
      xmlDoc.children[0].appendChild(sceneRouteNode);
      var flylinexml = xmlDoc.children[0].innerHTML;
      return flylinexml;
    }
  }, {
    key: "createSceneRouteNode",
    value: function createSceneRouteNode(rootXmlDoc) {
      var sceneRouteNode = rootXmlDoc.createElement("SceneRoute");
      sceneRouteNode.setAttribute("xmlns", "http://www.supermap.com.cn/ugc60");
      return sceneRouteNode;
    }
  }, {
    key: "createRouteNode",
    value: function createRouteNode(rootXmlDoc, route) {
      var routeNode = rootXmlDoc.createElement("route");
      var attrs = {
        name: route.routeName || "飞行路线",
        speed: route.speed || "200",
        lineType: "0",
        showroutestop: "False",
        showrouteline: "False",
        altitudefree: "False",
        headingfree: "False",
        tiltfree: "False",
        flycircle: "False",
        alongline: route.isAlongLine || "False"
      };

      for (var key in attrs) {
        routeNode.setAttribute(key, attrs[key]);
      }

      return routeNode;
    }
  }, {
    key: "createRouteStyleNode",
    value: function createRouteStyleNode(rootXmlDoc) {
      var routeStyleNode = rootXmlDoc.createElement("style");
      var geostyle3d = rootXmlDoc.createElement("geostyle3d");
      var linecolor = rootXmlDoc.createElement("linecolor");
      linecolor.textContent = "RGBA(147,112,219,255)";
      var linewidth = rootXmlDoc.createElement("linewidth");
      linewidth.textContent = 2;
      var altitudeMode = rootXmlDoc.createElement("altitudeMode");
      altitudeMode.textContent = "Absolute";
      var bottomAltitude = rootXmlDoc.createElement("bottomAltitude");
      bottomAltitude.textContent = 0.00;
      geostyle3d.appendChild(linecolor);
      geostyle3d.appendChild(linewidth);
      geostyle3d.appendChild(altitudeMode);
      geostyle3d.appendChild(bottomAltitude);
      routeStyleNode.appendChild(geostyle3d);
      return routeStyleNode;
    }
  }, {
    key: "createStopNode",
    value: function createStopNode(rootXmlDoc, camerainfo, stop, index) {
      var stopNode = rootXmlDoc.createElement("routestop");
      var name = stop.stopName || 'Stop' + (index + 1);
      var attris = {
        name: name,
        speed: stop.speed,
        excluded: "False",
        viewType: "camera"
      };

      for (var key in attris) {
        stopNode.setAttribute(key, attris[key]);
      }

      var cameranode = this.createStopCameraNode(rootXmlDoc, camerainfo);
      stopNode.appendChild(cameranode);
      var stylenode = this.createStopStyleNode(rootXmlDoc);
      stopNode.appendChild(stylenode);
      var settingnode = this.createStopSettingNode(rootXmlDoc, stop);
      stopNode.appendChild(settingnode);
      return stopNode;
    }
  }, {
    key: "createStopCameraNode",
    value: function createStopCameraNode(rootXmlDoc, cameraObj) {
      var stopCameraNode = rootXmlDoc.createElement("camera");

      for (var key in cameraObj) {
        var node = rootXmlDoc.createElement(key);
        node.textContent = cameraObj[key];
        stopCameraNode.appendChild(node);
      }

      return stopCameraNode;
    }
  }, {
    key: "createStopStyleNode",
    value: function createStopStyleNode(rootXmlDoc) {
      var nodeObj = {
        icon: "",
        markersize: 4.8,
        markericonscale: 1,
        markercolor: "RGBA(255, 255, 255, 255)"
      };
      var stopStyleNode = rootXmlDoc.createElement("style");
      var geostyle3d = rootXmlDoc.createElement("geostyle3d");

      for (var key in nodeObj) {
        var node = rootXmlDoc.createElement(key);
        node.textContent = nodeObj[key];
        geostyle3d.appendChild(node);
      }

      stopStyleNode.appendChild(geostyle3d);
      return stopStyleNode;
    }
  }, {
    key: "createStopSettingNode",
    value: function createStopSettingNode(rootXmlDoc, stop) {
      var stopSettingNode = rootXmlDoc.createElement("setting");
      var nodesObj = {
        turnTime: stop.surroundDuration || 1.5,
        turnSlowly: "False",
        stopPlayMode: stop.stopPlayMode || "StopPause",
        autoPlay: "False",
        pauseTime: stop.waitTime || 0,
        angularSpeed: 1
      };

      for (var key in nodesObj) {
        var node = rootXmlDoc.createElement(key);
        node.textContent = nodesObj[key];
        stopSettingNode.appendChild(node);
      }

      return stopSettingNode;
    }
  }]);

  return flylinexml;
}();

function createTooltip(frameDiv) {
  var tooltip = function tooltip(frameDiv) {
    var div = document.createElement('DIV');
    div.className = "tooltip";
    this._div = div;
    this.message = '';
    frameDiv.appendChild(div);
  };

  tooltip.prototype.setVisible = function (visible) {
    if (visible) {
      this._div.style.right = '10px';
    } else {
      this._div.style.right = '-300px';
    }
  };

  tooltip.prototype.showAt = function (message, top) {
    //top:200px => string
    if (top) {
      this._div.style.top = top;
    }

    if (message) {
      this.setVisible(true);
      this._div.innerHTML = message;
    }
  };

  return new tooltip(frameDiv);
}

function compass(props) {
  // 设置默认值数据
  var state = reactive({
    routeType: "designatedRoute",
    //自定义还得指定路线类型
    fileSrc: "",
    //文件地址,不能同时使用fpfUrl
    fpfUrl: null,
    //指定fpf路径
    selectedStopIndex: 0,
    //选中当前站点
    showRoute: false,
    //显示路线
    showStop: false,
    //显示站点
    currentStopNames: [],
    //当前路线的站点名称集合
    //自定义
    customRouteNames: [],
    //保存自定义路线名称
    customRouteSelectedIndex: null,
    //自定义选中路线索引
    routeStops: [],
    //自定义当前路线的站点集合
    selectedAddedStopIndex: null,
    //自定义已加站点选中索引
    //站点
    setStopName: 'Stop-1',
    //设置当前站点名称
    setStopSpeed: 0,
    // 设置当前站点速度
    stopPlayMode: 'StopPause',
    //设置站点模式:默认停留
    waitTime: 0,
    //停留时间
    surroundDuration: 1,
    //环绕模式时间
    //飞行路线设置
    isAlongline: false,
    //获取或者设置该飞行路线是否是沿线飞行。
    routeSpeed: 200 //飞行路线速度

  }); // 传入props改变默认值

  if (props) {
    for (var key in props) {
      if (state.hasOwnProperty(key)) {
        if (props[key] != undefined) state[key] = props[key];
      } else {
        tool.Message.errorMsg(resource.AttributeError + key);
      }
    }
  } // 初始化数据


  var flyManager, routeCollection; //创建飞行路线集合对象类

  var flyFile_dom = ref(null);
  var currentStops; //当前路线所有站点集合

  var reader = new FileReader();
  var createXml,
      flyLineXmls = []; //创建和保存xml飞行路线文件

  if (storeState.isViewer) {
    if (!window.tooltip) {
      window.tooltip = createTooltip(viewer._element);
    }

    initFlyManager();
  } //viewer 初始化完成的监听


  watch(function () {
    return storeState.isViewer;
  }, function (val) {
    if (val) {
      if (!window.tooltip) {
        window.tooltip = createTooltip(viewer._element);
      }

      initFlyManager();
    }
  });
  onMounted(function () {
    fileChange();
  });
  /**
  * 指定路线分析
  */
  //初始化飞行管理

  function initFlyManager() {
    routeCollection = new Cesium.RouteCollection(viewer.entities);
    flyManager = new Cesium.FlyManager({
      scene: viewer.scene,
      routes: routeCollection
    });
    createXml = new flylinexml();

    if (state.fpfUrl) {
      fpfUrlChange();
    }
  } // 点击选择文件函数


  function chooseFile() {
    flyFile_dom.value.click();
  } // 改变默认fpf文件路径触发


  function fpfUrlChange() {
    flyManager.stop();
    routeCollection.fromFile(state.fpfUrl);
    flyManager.readyPromise.then(function () {
      var route = flyManager.currentRoute;
      route.isLineVisible = state.showRoute;
      route.isStopVisible = state.showStop;
      updateCurrentStops();
    });
  } //文件夹改变文件触发


  function fileChange() {
    flyFile_dom.value.addEventListener("change", function (evt) {
      flyManager.stop();
      var route = flyManager.currentRoute;
      if (route) route.clear(); //清除之前的

      routeCollection = new Cesium.RouteCollection(viewer.entities); //飞行路线底层默认第一条路线，所以重新new

      var file = evt.target.files[0];
      if (!file) return;
      state.fileSrc = flyFile_dom.value.value;

      reader.onload = function (e) {
        // 读取操作完成时出发
        var XMLContent = e.target.result;
        routeCollection.fromXML(XMLContent);
      };

      reader.readAsBinaryString(file);
      readyPromise();
    });
  } // 异步飞行管理准备就绪函数


  function readyPromise() {
    routeCollection.readyPromise.then(function () {
      flyManager.routes = routeCollection;
      var route = flyManager.currentRoute;
      route.isLineVisible = state.showRoute;
      route.isStopVisible = state.showStop;
      updateCurrentStops();
    });
  } // 更新当前路线站点


  function updateCurrentStops() {
    state.currentStopNames.length = 0;
    currentStops = flyManager.getAllRouteStops();

    for (var i = 0, j = currentStops.length; i < j; i++) {
      var stopName = currentStops[i].stopName || 'Stop' + (i + 1);
      state.currentStopNames.push(stopName);
    }
  } // 更新当前飞行管理的所有路线(暂不支持路线选择,所有未开放)

  function flyStart() {
    flyManager.readyPromise.then(function () {
      flyManager.play();
    });
  }

  function flyPause() {
    flyManager && flyManager.pause();
  }

  function flyStop() {
    flyManager && flyManager.stop();
  }
  /**
  * 自定义路线分析
  */
  // 添加站点

  function addStop() {
    flyManager.stop();
    var point = viewer.camera.position;
    var position = tool.CartesiantoDegrees(point);
    var stop = {
      stopName: state.setStopName,
      point: position,
      heading: viewer.camera.heading,
      tilt: viewer.camera.pitch,
      speed: state.setStopSpeed,
      stopPlayMode: state.stopPlayMode,
      surroundDuration: state.surroundDuration,
      waitTime: state.waitTime
    };
    state.routeStops.push(stop);

    if (state.routeStops.length > 0) {
      var len = state.routeStops.length;
      var lastStopName = state.routeStops[len - 1].stopName;
      var index = lastStopName.split('-')[1] || 1;
      var name = 'Stop-' + (Number(index) + 1);
      state.setStopName = name;
    }

    state.selectedAddedStopIndex = state.routeStops.length - 1;
  } // 保存站点


  function saveStop() {
    if (state.routeStops.length < 2) {
      tool.Message.warnMsg('节点小于2');
      return;
    } // 飞行路线配置


    var index = flyLineXmls.length + 1;
    var route = {
      routeName: '飞行路线_' + index,
      speed: state.routeSpeed,
      isAlongLine: "False",
      routeStops: state.routeStops
    };
    var xml = createXml.createXMLflyLine(route);
    flyLineXmls.push(xml);
    state.customRouteNames.push(route.routeName); // restStops();

    if (state.customRouteSelectedIndex === null) state.customRouteSelectedIndex = 0;
  } // 重置当前路线


  function restStops() {
    state.routeStops.length = 0;
    state.setStopName = 'Stop-1';
    state.setStopSpeed = 0;
    state.stopPlayMode = 'StopPause';
    state.waitTime = 0;
    state.surroundDuration = 1;
  } // 下载选择的飞行路线fpf文件


  function downLoad() {
    var data = flyLineXmls[state.customRouteSelectedIndex];
    if (!data) return;
    var blob = new Blob([data]); //将返回的数据包装成blob（方法的具体使用参考mdn）

    var alink = document.createElement("a");
    alink.download = 'fly-route.fpf'; //文件名,大部分浏览器兼容,IE10及以下不兼容

    alink.href = URL.createObjectURL(blob); //根据blob 创建 url

    alink.click(); //自动点击
  } // 清除选中飞行路线


  function clearRoute() {
    flyManager.stop();
    if (flyLineXmls.length < 1) return;
    flyLineXmls.splice(state.customRouteSelectedIndex, 1);
    state.customRouteNames.splice(state.customRouteSelectedIndex, 1);

    if (flyLineXmls.length > 0) {
      state.customRouteSelectedIndex = 0;
      return;
    }

    state.customRouteSelectedIndex = null;
    state.currentStopNames.length = 0;
    var route = flyManager.currentRoute;
    if (route) route.clear(); //清除之前的
  } // 清除选中站点


  function clearStop() {
    state.routeStops.splice(state.selectedAddedStopIndex, 1);

    if (state.routeStops.length > 0) {
      state.selectedAddedStopIndex = state.routeStops.length - 1;
      return;
    }

    state.selectedAddedStopIndex = null;
    state.setStopName = 'Stop-1';
  } // 监听


  watch(function () {
    return state.selectedStopIndex;
  }, function (val) {
    flyManager && flyManager.stop();
    var index = Number(val);
    var stop = currentStops[index];
    flyManager.viewToStop(stop);
  });
  watch(function () {
    return state.showRoute;
  }, function (val) {
    var route = flyManager.currentRoute;
    if (route) route.isLineVisible = val;
  });
  watch(function () {
    return state.showStop;
  }, function (val) {
    var route = flyManager.currentRoute;
    if (route) route.isStopVisible = val;
  });
  watch(function () {
    return state.fpfUrl;
  }, function (val) {
    fpfUrlChange();
  });
  watch(function () {
    return state.customRouteSelectedIndex;
  }, function (val) {
    if (val === null) return;
    flyManager && flyManager.stop();
    var route = flyManager.currentRoute;
    if (route) route.clear(); //清除之前的

    routeCollection = new Cesium.RouteCollection(viewer.entities); //飞行路线底层默认第一条路线，所以重新new

    routeCollection.fromXML(flyLineXmls[val]);
    readyPromise();
  });
  watch(function () {
    return state.selectedAddedStopIndex;
  }, function (val) {
    var stop = state.routeStops[val];
    if (!stop) return;
    viewer.camera.setView({
      destination: Cesium.Cartesian3.fromDegrees(stop.point[0], stop.point[1], stop.point[2]),
      orientation: {
        heading: stop.heading,
        pitch: stop.tilt,
        roll: 0
      }
    });
  });
  watch(function () {
    return state.routeType;
  }, function (val) {
    if (val === 'customRoute') {
      window.tooltip.showAt(' <p>调整当前相机位置和视角</p><p>以当前相机位置和视角设置站点</p><p>点击添加保存此站点</p>', '50%');
      setTimeout(function () {
        window.tooltip.setVisible(false);
      }, 5000);
    } else {
      window.tooltip.setVisible(false);
    }
  }); // 销毁

  onBeforeUnmount(function () {
    state = null;
    flyManager = routeCollection = null;
    currentStops = null;
    createXml = flyLineXmls = null;
  });
  return _objectSpread2(_objectSpread2({}, toRefs(state)), {}, {
    flyFile_dom: flyFile_dom,
    chooseFile: chooseFile,
    flyStart: flyStart,
    flyPause: flyPause,
    flyStop: flyStop,
    addStop: addStop,
    saveStop: saveStop,
    restStops: restStops,
    downLoad: downLoad,
    clearRoute: clearRoute,
    clearStop: clearStop
  });
}

var script = {
  name: "Sm3dFlyRoute",
  props: {
    //指定fpf路径
    fpfUrl: {
      type: String
    },
    //显示路线
    showRoute: {
      type: Boolean
    },
    //显示站点
    showStop: {
      type: Boolean
    },
    //设置站点模式:默认停留,StopAround :环绕
    stopPlayMode: {
      type: String
    },
    //停留时间
    waitTime: {
      type: Number
    },
    //环绕模式时间
    surroundDuration: {
      type: Number
    },
    //飞行路线是否是沿线飞行
    isAlongline: {
      type: Boolean
    },
    //飞行路线速度
    routeSpeed: {
      type: Number
    }
  },
  setup: function setup(props) {
    var _flyRoute = compass(props),
        routeType = _flyRoute.routeType,
        fileSrc = _flyRoute.fileSrc,
        fpfUrl = _flyRoute.fpfUrl,
        selectedStopIndex = _flyRoute.selectedStopIndex,
        showRoute = _flyRoute.showRoute,
        showStop = _flyRoute.showStop,
        flyFile_dom = _flyRoute.flyFile_dom,
        chooseFile = _flyRoute.chooseFile,
        currentStopNames = _flyRoute.currentStopNames,
        flyStart = _flyRoute.flyStart,
        flyPause = _flyRoute.flyPause,
        flyStop = _flyRoute.flyStop,
        routeStops = _flyRoute.routeStops,
        selectedAddedStopIndex = _flyRoute.selectedAddedStopIndex,
        routeSpeed = _flyRoute.routeSpeed,
        clearStop = _flyRoute.clearStop,
        addStop = _flyRoute.addStop,
        saveStop = _flyRoute.saveStop,
        restStops = _flyRoute.restStops,
        customRouteNames = _flyRoute.customRouteNames,
        customRouteSelectedIndex = _flyRoute.customRouteSelectedIndex,
        downLoad = _flyRoute.downLoad,
        clearRoute = _flyRoute.clearRoute;

    return {
      routeType: routeType,
      fileSrc: fileSrc,
      fpfUrl: fpfUrl,
      selectedStopIndex: selectedStopIndex,
      showRoute: showRoute,
      showStop: showStop,
      flyFile_dom: flyFile_dom,
      chooseFile: chooseFile,
      currentStopNames: currentStopNames,
      flyStart: flyStart,
      flyPause: flyPause,
      flyStop: flyStop,
      routeStops: routeStops,
      selectedAddedStopIndex: selectedAddedStopIndex,
      routeSpeed: routeSpeed,
      clearStop: clearStop,
      addStop: addStop,
      saveStop: saveStop,
      restStops: restStops,
      customRouteNames: customRouteNames,
      customRouteSelectedIndex: customRouteSelectedIndex,
      downLoad: downLoad,
      clearRoute: clearRoute
    };
  }
};

var _hoisted_1 = {
  id: "fly-route-panel",
  "class": "sm-panel"
};
var _hoisted_2 = {
  "class": "sm-function-module-sub-section",
  style: {
    "margin": "0"
  }
};
var _hoisted_3 = {
  "class": "sm-half-L"
};
var _hoisted_4 = {
  style: {
    "width": "auto"
  }
};
var _hoisted_5 = {
  style: {
    "width": "auto"
  }
};
var _hoisted_6 = {
  "class": "sm-half-L"
};
var _hoisted_7 = {
  "class": "sm-half-L"
};
var _hoisted_8 = {
  style: {
    "width": "35%"
  }
};
var _hoisted_9 = {
  type: "file",
  accept: ".fpf",
  id: "flyFile",
  style: {
    "display": "none"
  },
  ref: "flyFile_dom"
};
var _hoisted_10 = {
  "class": "sm-half-L"
};
var _hoisted_11 = {
  style: {
    "width": "35%"
  }
};
var _hoisted_12 = ["value"];
var _hoisted_13 = {
  "class": "sm-half-L flex-between"
};
var _hoisted_14 = {
  style: {
    "width": "auto"
  }
};
var _hoisted_15 = {
  style: {
    "width": "auto"
  }
};
var _hoisted_16 = {
  "class": "sm-half-L flex-around"
};
var _hoisted_17 = ["title"];
var _hoisted_18 = ["title"];
var _hoisted_19 = ["title"];
var _hoisted_20 = {
  "class": "sm-half-L"
};
var _hoisted_21 = {
  "class": "sm-half-L"
};
var _hoisted_22 = {
  style: {
    "width": "35%"
  }
};
var _hoisted_23 = {
  "class": "sm-half-L"
};
var _hoisted_24 = {
  style: {
    "width": "35%"
  }
};
var _hoisted_25 = ["value"];
var _hoisted_26 = {
  "class": "boxchild"
};
var _hoisted_27 = {
  "class": "sm-half-L"
};
var _hoisted_28 = {
  style: {
    "margin": "15px 0 5px 0"
  }
};

var _hoisted_29 = /*#__PURE__*/createElementVNode("div", {
  "class": "sm-point"
}, null, -1
/* HOISTED */
);

var _hoisted_30 = {
  "class": "sm-half-L"
};
var _hoisted_31 = {
  style: {
    "width": "35%"
  }
};
var _hoisted_32 = ["value"];
var _hoisted_33 = {
  "class": "sm-half-L"
};
var _hoisted_34 = {
  style: {
    "width": "35%"
  }
};
var _hoisted_35 = ["value"];
var _hoisted_36 = {
  "class": "sm-half-L flex-between"
};
var _hoisted_37 = {
  style: {
    "width": "auto"
  }
};
var _hoisted_38 = {
  style: {
    "width": "auto"
  }
};
var _hoisted_39 = {
  "class": "sm-half-L flex-around"
};
var _hoisted_40 = ["title"];
var _hoisted_41 = ["title"];
var _hoisted_42 = ["title"];
var _hoisted_43 = {
  "class": "boxchild",
  style: {
    "margin-bottom": "-5px"
  }
};
function render(_ctx, _cache, $props, $setup, $data, $options) {
  var _directive_stopdrag = resolveDirective("stopdrag");

  var _directive_drag = resolveDirective("drag");

  return withDirectives((openBlock(), createElementBlock("div", _hoisted_1, [withDirectives((openBlock(), createElementBlock("div", _hoisted_2, [createElementVNode("div", _hoisted_3, [createElementVNode("label", _hoisted_4, [withDirectives(createElementVNode("input", {
    type: "radio",
    value: "designatedRoute",
    "onUpdate:modelValue": _cache[0] || (_cache[0] = function ($event) {
      return $setup.routeType = $event;
    })
  }, null, 512
  /* NEED_PATCH */
  ), [[vModelRadio, $setup.routeType]]), createTextVNode(" " + toDisplayString(_ctx.Resource.designatedRoute), 1
  /* TEXT */
  )]), createElementVNode("label", _hoisted_5, [withDirectives(createElementVNode("input", {
    type: "radio",
    value: "customRoute",
    "onUpdate:modelValue": _cache[1] || (_cache[1] = function ($event) {
      return $setup.routeType = $event;
    })
  }, null, 512
  /* NEED_PATCH */
  ), [[vModelRadio, $setup.routeType]]), createTextVNode(" " + toDisplayString(_ctx.Resource.customRoute), 1
  /* TEXT */
  )])]), createCommentVNode(" 指定路线面板 "), withDirectives(createElementVNode("div", _hoisted_6, [withDirectives(createElementVNode("div", _hoisted_7, [createElementVNode("label", _hoisted_8, toDisplayString(_ctx.Resource.routeType), 1
  /* TEXT */
  ), withDirectives(createElementVNode("input", {
    type: "text",
    "class": "sm-input",
    disabled: "",
    style: {
      "width": "63%",
      "position": "relative",
      "padding-right": "30px"
    },
    "onUpdate:modelValue": _cache[2] || (_cache[2] = function ($event) {
      return $setup.fileSrc = $event;
    }),
    placeholder: "选择飞行线路文件"
  }, null, 512
  /* NEED_PATCH */
  ), [[vModelText, $setup.fileSrc]]), createElementVNode("span", {
    "class": "iconfont iconwenjianjia fpfFile",
    onClick: _cache[3] || (_cache[3] = function () {
      return $setup.chooseFile && $setup.chooseFile.apply($setup, arguments);
    })
  }), createElementVNode("input", _hoisted_9, null, 512
  /* NEED_PATCH */
  )], 512
  /* NEED_PATCH */
  ), [[vShow, !$setup.fpfUrl]]), withDirectives(createElementVNode("div", _hoisted_10, [createElementVNode("label", _hoisted_11, toDisplayString(_ctx.Resource.selectStop), 1
  /* TEXT */
  ), withDirectives(createElementVNode("select", {
    "class": "sm-select",
    style: {
      "width": "63%"
    },
    "onUpdate:modelValue": _cache[4] || (_cache[4] = function ($event) {
      return $setup.selectedStopIndex = $event;
    })
  }, [(openBlock(true), createElementBlock(Fragment, null, renderList($setup.currentStopNames, function (stop, index) {
    return openBlock(), createElementBlock("option", {
      value: index,
      key: index
    }, toDisplayString(stop), 9
    /* TEXT, PROPS */
    , _hoisted_12);
  }), 128
  /* KEYED_FRAGMENT */
  ))], 512
  /* NEED_PATCH */
  ), [[vModelSelect, $setup.selectedStopIndex]])], 512
  /* NEED_PATCH */
  ), [[vShow, $setup.currentStopNames.length > 0]]), createElementVNode("div", _hoisted_13, [createElementVNode("label", _hoisted_14, [withDirectives(createElementVNode("input", {
    type: "checkbox",
    "onUpdate:modelValue": _cache[5] || (_cache[5] = function ($event) {
      return $setup.showRoute = $event;
    })
  }, null, 512
  /* NEED_PATCH */
  ), [[vModelCheckbox, $setup.showRoute]]), createTextVNode(" " + toDisplayString(_ctx.Resource.showRoute), 1
  /* TEXT */
  )]), createElementVNode("label", _hoisted_15, [withDirectives(createElementVNode("input", {
    type: "checkbox",
    "onUpdate:modelValue": _cache[6] || (_cache[6] = function ($event) {
      return $setup.showStop = $event;
    })
  }, null, 512
  /* NEED_PATCH */
  ), [[vModelCheckbox, $setup.showStop]]), createTextVNode(" " + toDisplayString(_ctx.Resource.showStop), 1
  /* TEXT */
  )])]), createElementVNode("div", _hoisted_16, [createElementVNode("div", null, [createElementVNode("span", {
    "class": "iconfont iconbofang",
    style: {
      "font-size": "32px",
      "color": "var(--theme-bg-color)"
    },
    onClick: _cache[7] || (_cache[7] = function () {
      return $setup.flyStart && $setup.flyStart.apply($setup, arguments);
    }),
    title: _ctx.Resource.start
  }, null, 8
  /* PROPS */
  , _hoisted_17)]), createElementVNode("div", null, [createElementVNode("span", {
    "class": "iconfont iconzanting",
    style: {
      "font-size": "32px",
      "color": "var(--theme-bg-color)"
    },
    onClick: _cache[8] || (_cache[8] = function () {
      return $setup.flyPause && $setup.flyPause.apply($setup, arguments);
    }),
    title: _ctx.Resource.pause
  }, null, 8
  /* PROPS */
  , _hoisted_18)]), createElementVNode("div", null, [createElementVNode("span", {
    "class": "iconfont icontingzhi",
    style: {
      "font-size": "32px",
      "color": "var(--theme-bg-color)"
    },
    onClick: _cache[9] || (_cache[9] = function () {
      return $setup.flyStop && $setup.flyStop.apply($setup, arguments);
    }),
    title: _ctx.Resource.stop
  }, null, 8
  /* PROPS */
  , _hoisted_19)])])], 512
  /* NEED_PATCH */
  ), [[vShow, $setup.routeType === 'designatedRoute']]), createCommentVNode(" 自定义路线面板 "), withDirectives(createElementVNode("div", _hoisted_20, [createElementVNode("div", _hoisted_21, [createElementVNode("label", _hoisted_22, toDisplayString(_ctx.Resource.flySpeed), 1
  /* TEXT */
  ), withDirectives(createElementVNode("input", {
    type: "number",
    "class": "sm-input",
    style: {
      "width": "63%"
    },
    "onUpdate:modelValue": _cache[10] || (_cache[10] = function ($event) {
      return $setup.routeSpeed = $event;
    })
  }, null, 512
  /* NEED_PATCH */
  ), [[vModelText, $setup.routeSpeed]])]), withDirectives(createElementVNode("div", _hoisted_23, [createElementVNode("label", _hoisted_24, toDisplayString(_ctx.Resource.addedStops), 1
  /* TEXT */
  ), withDirectives(createElementVNode("select", {
    "class": "sm-select",
    style: {
      "width": "63%"
    },
    "onUpdate:modelValue": _cache[11] || (_cache[11] = function ($event) {
      return $setup.selectedAddedStopIndex = $event;
    })
  }, [(openBlock(true), createElementBlock(Fragment, null, renderList($setup.routeStops, function (stop, index) {
    return openBlock(), createElementBlock("option", {
      value: index,
      key: index
    }, toDisplayString(stop.stopName), 9
    /* TEXT, PROPS */
    , _hoisted_25);
  }), 128
  /* KEYED_FRAGMENT */
  ))], 512
  /* NEED_PATCH */
  ), [[vModelSelect, $setup.selectedAddedStopIndex]])], 512
  /* NEED_PATCH */
  ), [[vShow, $setup.routeStops.length > 0]]), createElementVNode("div", _hoisted_26, [createElementVNode("button", {
    onClick: _cache[12] || (_cache[12] = function () {
      return $setup.addStop && $setup.addStop.apply($setup, arguments);
    }),
    "class": "tbtn",
    type: "button"
  }, toDisplayString(_ctx.Resource.add), 1
  /* TEXT */
  ), createElementVNode("button", {
    onClick: _cache[13] || (_cache[13] = function () {
      return $setup.clearStop && $setup.clearStop.apply($setup, arguments);
    }),
    "class": "tbtn tbtn-margin-left",
    type: "button"
  }, toDisplayString(_ctx.Resource["delete"]), 1
  /* TEXT */
  ), createElementVNode("button", {
    onClick: _cache[14] || (_cache[14] = function () {
      return $setup.restStops && $setup.restStops.apply($setup, arguments);
    }),
    "class": "tbtn tbtn-margin-left",
    type: "button"
  }, toDisplayString(_ctx.Resource.reset), 1
  /* TEXT */
  ), createElementVNode("button", {
    onClick: _cache[15] || (_cache[15] = function () {
      return $setup.saveStop && $setup.saveStop.apply($setup, arguments);
    }),
    "class": "tbtn tbtn-margin-left",
    type: "button"
  }, toDisplayString(_ctx.Resource.save), 1
  /* TEXT */
  )]), createCommentVNode(" 保存飞行路线操作  v-show=\"customRouteNames.length>0\" "), withDirectives(createElementVNode("div", _hoisted_27, [createElementVNode("div", _hoisted_28, [_hoisted_29, createTextVNode(" " + toDisplayString(_ctx.Resource.customRouteOperating), 1
  /* TEXT */
  )]), createElementVNode("div", _hoisted_30, [createElementVNode("label", _hoisted_31, toDisplayString(_ctx.Resource.routeType), 1
  /* TEXT */
  ), withDirectives(createElementVNode("select", {
    "class": "sm-select",
    style: {
      "width": "63%"
    },
    "onUpdate:modelValue": _cache[16] || (_cache[16] = function ($event) {
      return $setup.customRouteSelectedIndex = $event;
    })
  }, [(openBlock(true), createElementBlock(Fragment, null, renderList($setup.customRouteNames, function (route, index) {
    return openBlock(), createElementBlock("option", {
      value: index,
      key: index
    }, toDisplayString(route), 9
    /* TEXT, PROPS */
    , _hoisted_32);
  }), 128
  /* KEYED_FRAGMENT */
  ))], 512
  /* NEED_PATCH */
  ), [[vModelSelect, $setup.customRouteSelectedIndex]])]), withDirectives(createElementVNode("div", _hoisted_33, [createElementVNode("label", _hoisted_34, toDisplayString(_ctx.Resource.selectStop), 1
  /* TEXT */
  ), withDirectives(createElementVNode("select", {
    "class": "sm-select",
    style: {
      "width": "63%"
    },
    "onUpdate:modelValue": _cache[17] || (_cache[17] = function ($event) {
      return $setup.selectedStopIndex = $event;
    })
  }, [(openBlock(true), createElementBlock(Fragment, null, renderList($setup.currentStopNames, function (stop, index) {
    return openBlock(), createElementBlock("option", {
      value: index,
      key: index
    }, toDisplayString(stop), 9
    /* TEXT, PROPS */
    , _hoisted_35);
  }), 128
  /* KEYED_FRAGMENT */
  ))], 512
  /* NEED_PATCH */
  ), [[vModelSelect, $setup.selectedStopIndex]])], 512
  /* NEED_PATCH */
  ), [[vShow, $setup.currentStopNames.length > 0]]), createElementVNode("div", _hoisted_36, [createElementVNode("label", _hoisted_37, [withDirectives(createElementVNode("input", {
    type: "checkbox",
    "onUpdate:modelValue": _cache[18] || (_cache[18] = function ($event) {
      return $setup.showRoute = $event;
    })
  }, null, 512
  /* NEED_PATCH */
  ), [[vModelCheckbox, $setup.showRoute]]), createTextVNode(" " + toDisplayString(_ctx.Resource.showRoute), 1
  /* TEXT */
  )]), createElementVNode("label", _hoisted_38, [withDirectives(createElementVNode("input", {
    type: "checkbox",
    "onUpdate:modelValue": _cache[19] || (_cache[19] = function ($event) {
      return $setup.showStop = $event;
    })
  }, null, 512
  /* NEED_PATCH */
  ), [[vModelCheckbox, $setup.showStop]]), createTextVNode(" " + toDisplayString(_ctx.Resource.showStop), 1
  /* TEXT */
  )])]), createElementVNode("div", _hoisted_39, [createElementVNode("div", null, [createElementVNode("span", {
    "class": "iconfont iconbofang",
    style: {
      "font-size": "32px",
      "color": "var(--theme-bg-color)"
    },
    onClick: _cache[20] || (_cache[20] = function () {
      return $setup.flyStart && $setup.flyStart.apply($setup, arguments);
    }),
    title: _ctx.Resource.start
  }, null, 8
  /* PROPS */
  , _hoisted_40)]), createElementVNode("div", null, [createElementVNode("span", {
    "class": "iconfont iconzanting",
    style: {
      "font-size": "32px",
      "color": "var(--theme-bg-color)"
    },
    onClick: _cache[21] || (_cache[21] = function () {
      return $setup.flyPause && $setup.flyPause.apply($setup, arguments);
    }),
    title: _ctx.Resource.pause
  }, null, 8
  /* PROPS */
  , _hoisted_41)]), createElementVNode("div", null, [createElementVNode("span", {
    "class": "iconfont icontingzhi",
    style: {
      "font-size": "32px",
      "color": "var(--theme-bg-color)"
    },
    onClick: _cache[22] || (_cache[22] = function () {
      return $setup.flyStop && $setup.flyStop.apply($setup, arguments);
    }),
    title: _ctx.Resource.stop
  }, null, 8
  /* PROPS */
  , _hoisted_42)]), createElementVNode("div", _hoisted_43, [createElementVNode("button", {
    onClick: _cache[23] || (_cache[23] = function () {
      return $setup.downLoad && $setup.downLoad.apply($setup, arguments);
    }),
    "class": "tbtn",
    type: "button"
  }, toDisplayString(_ctx.Resource.downLoad), 1
  /* TEXT */
  ), createElementVNode("button", {
    onClick: _cache[24] || (_cache[24] = function () {
      return $setup.clearRoute && $setup.clearRoute.apply($setup, arguments);
    }),
    "class": "tbtn tbtn-margin-left",
    type: "button"
  }, toDisplayString(_ctx.Resource.clear), 1
  /* TEXT */
  )])])], 512
  /* NEED_PATCH */
  ), [[vShow, $setup.customRouteNames.length > 0]])], 512
  /* NEED_PATCH */
  ), [[vShow, $setup.routeType === 'customRoute']])])), [[_directive_stopdrag]])])), [[_directive_drag]]);
}

script.render = render;
script.__file = "src/components/fly/fly-route/fly-route.vue";

script.install = function (app) {
  app.component(script.name, script);
};

export default script;
