import { reactive, toRefs, watch, onBeforeUnmount, resolveComponent, resolveDirective, withDirectives, openBlock, createElementBlock, createElementVNode, toDisplayString, Fragment, renderList, vShow, vModelSelect, createVNode } from 'vue';

function _typeof(obj) {
  "@babel/helpers - typeof";

  if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
    _typeof = function (obj) {
      return typeof obj;
    };
  } else {
    _typeof = function (obj) {
      return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
    };
  }

  return _typeof(obj);
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);

  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    if (enumerableOnly) symbols = symbols.filter(function (sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    });
    keys.push.apply(keys, symbols);
  }

  return keys;
}

function _objectSpread2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};

    if (i % 2) {
      ownKeys(Object(source), true).forEach(function (key) {
        _defineProperty(target, key, source[key]);
      });
    } else if (Object.getOwnPropertyDescriptors) {
      Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
      ownKeys(Object(source)).forEach(function (key) {
        Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
      });
    }
  }

  return target;
}

// 创建一个简单的store状态管理

var storeState = reactive({
  isViewer: false,
  //viewer初始化标志
  changeLayers: 0,
  //图层改变加载完毕监听
  changeGeometrys: 0 //三维分析体改变标志

});

/*
* 常用工具类
*/
//axios本版本不支持jsonp
var axiosJsonp = function axiosJsonp(url) {
  if (!url) {
    console.error('Axios.JSONP 至少需要一个url参数!');
    return;
  }

  return new Promise(function (resolve, reject) {
    window.jsonCallBack = function (result) {
      resolve(result);
    };

    var JSONP = document.createElement("script");
    JSONP.type = "text/javascript";
    JSONP.src = "".concat(url, "&callback=jsonCallBack");
    document.getElementsByTagName("head")[0].appendChild(JSONP);
    setTimeout(function () {
      document.getElementsByTagName("head")[0].removeChild(JSONP);
    }, 500);
  });
}; //判断两数组或对象相等


var isEqualArr = function isEqualArr(arg1, arg2) {
  if (!arg1 || !arg2) return true;
  var bol = true;

  if (Object.keys(arg1).length != Object.keys(arg2).length) {
    return false;
  }

  for (var key in arg1) {
    if (_typeof(arg1[key]) == 'object') {
      bol = isSame(arg1[key], arg2[key]);

      if (!bol) {
        break;
      }
    } else if (arg1[key] != arg2[key]) {
      bol = false;
      break;
    }
  }

  return bol;
}; //坐标转化
//笛卡尔转经纬度


var CartesiantoDegrees = function CartesiantoDegrees(Cartesians) {
  var array = [].concat(Cartesians);
  var positions = [];

  for (var i = 0, len = array.length; i < len; i++) {
    var cartographic = Cesium.Cartographic.fromCartesian(array[i]);
    var longitude = Cesium.Math.toDegrees(cartographic.longitude);
    var latitude = Cesium.Math.toDegrees(cartographic.latitude);
    var h = cartographic.height;

    if (positions.indexOf(longitude) == -1 && positions.indexOf(latitude) == -1) {
      positions.push(longitude);
      positions.push(latitude);
      positions.push(h);
    }
  }

  return positions;
}; //笛卡尔转经纬度(每个点是独立的对象)


var CartesiantoDegreesObjs = function CartesiantoDegreesObjs(Cartesians) {
  var array = [].concat(Cartesians);
  var positions = [];

  for (var i = 0, len = array.length; i < len; i++) {
    var cartographic = Cesium.Cartographic.fromCartesian(array[i]);
    var obj = {
      longitude: Cesium.Math.toDegrees(cartographic.longitude),
      latitude: Cesium.Math.toDegrees(cartographic.latitude),
      height: cartographic.height
    };
    positions.push(obj);
  }

  return positions;
}; // 弧度转经纬度


var CartographictoDegrees = function CartographictoDegrees(wgsPosition) {
  var longitude = Cesium.Math.toDegrees(wgsPosition.longitude);
  var latitude = Cesium.Math.toDegrees(wgsPosition.latitude);
  var height = wgsPosition.height;
  return [longitude, latitude, height];
}; //去重函数  数组


var unique = function unique(arr) {
  var res = [];
  var json = {};

  for (var i = 0; i < arr.length; i++) {
    if (!json[arr[i]]) {
      res.push(arr[i]);
      json[arr[i]] = 1;
    }
  }

  return res;
}; // 获取渐变色函数


function gradientColors(start, end, steps, gamma) {
  var i,
      j,
      ms,
      me,
      output = [],
      so = [];
  gamma = gamma || 1;

  var normalize = function normalize(channel) {
    return Math.pow(channel / 255, gamma);
  };

  start = parseColor(start).map(normalize);
  end = parseColor(end).map(normalize);

  for (i = 0; i < steps; i++) {
    ms = i / (steps - 1);
    me = 1 - ms;

    for (j = 0; j < 3; j++) {
      so[j] = pad(Math.round(Math.pow(start[j] * me + end[j] * ms, 1 / gamma) * 255).toString(16));
    }

    output.push('#' + so.join(''));
  }

  return output;

  function parseColor(hexStr) {
    return hexStr.length === 4 ? hexStr.substr(1).split('').map(function (s) {
      return 0x11 * parseInt(s, 16);
    }) : [hexStr.substr(1, 2), hexStr.substr(3, 2), hexStr.substr(5, 2)].map(function (s) {
      return parseInt(s, 16);
    });
  }

  function pad(s) {
    return s.length === 1 ? '0' + s : s;
  }
}

function getAngleAndRadian(pointA, pointB) {
  //建立以点A为原点，X轴为east,Y轴为north,Z轴朝上的坐标系
  var transform = Cesium.Transforms.eastNorthUpToFixedFrame(pointA); //向量AB

  var positionvector = Cesium.Cartesian3.subtract(pointB, pointA, new Cesium.Cartesian3()); //因transform是将A为原点的eastNorthUp坐标系中的点转换到世界坐标系的矩阵
  //AB为世界坐标中的向量
  //因此将AB向量转换为A原点坐标系中的向量，需乘以transform的逆矩阵。

  var vector = Cesium.Matrix4.multiplyByPointAsVector(Cesium.Matrix4.inverse(transform, new Cesium.Matrix4()), positionvector, new Cesium.Cartesian3()); //归一化

  var direction = Cesium.Cartesian3.normalize(vector, new Cesium.Cartesian3()); //heading

  var heading1 = Math.atan2(direction.y, direction.x) - Cesium.Math.PI_OVER_TWO;
  var radian = Cesium.Math.TWO_PI - Cesium.Math.zeroToTwoPi(heading1);
  var angle = radian * (180 / Math.PI);

  if (angle < 0) {
    angle = angle + 360;
  }

  return {
    angle: angle,
    radian: radian
  };
}

function getPitch(pointA, pointB) {
  var transfrom = Cesium.Transforms.eastNorthUpToFixedFrame(pointA);
  var vector = Cesium.Cartesian3.subtract(pointB, pointA, new Cesium.Cartesian3());
  var direction = Cesium.Matrix4.multiplyByPointAsVector(Cesium.Matrix4.inverse(transfrom, transfrom), vector, vector);
  Cesium.Cartesian3.normalize(direction, direction); //因为direction已归一化，斜边长度等于1，所以余弦函数等于direction.z

  var radian = Cesium.Math.PI_OVER_TWO - Cesium.Math.acosClamped(direction.z);
  var angle = radian * (180 / Math.PI);

  if (angle < 0) {
    angle = angle + 360;
  }

  return {
    angle: angle,
    radian: radian
  };
}

var tool = {
  axiosJsonp: axiosJsonp,
  isEqualArr: isEqualArr,
  CartesiantoDegrees: CartesiantoDegrees,
  CartesiantoDegreesObjs: CartesiantoDegreesObjs,
  unique: unique,
  gradientColors: gradientColors,
  getAngleAndRadian: getAngleAndRadian,
  CartographictoDegrees: CartographictoDegrees,
  getPitch: getPitch
};

var ResourceCN = {
  showRenderLoopErrors: '渲染时发生错误，已停止渲染。',
  AttributeError: '该组件props没有这个属性：',
  NoPickPositionSupported: "不支持深度纹理,无法绘制多边形，地形操作功能无法使用！",
  NoTerrain: "请在地形里使用地形组件！",
  initViewerWarn: '请先初始化viewer!',
  MoveMouseHeightBox: '点击鼠标左键结束矩形绘制，移动鼠标绘制box高度',
  RightClickEndDrawing: '右键单击结束绘制',
  LeftClickBottomBox: '点击鼠标左键，开始绘制矩形作为box底面',
  ClickModelAddBox: '点击模型，添加裁剪盒子',
  SkyLineWarn: "获取天际线体前，请先绘制天际线！",
  SkyLineBody: '天际线体',
  ShadowqueryWarn: "此操作需要先开启阴影！",
  VeiwshedBody: '可视体',
  VeiwshedBodyHidden: '不可视体',
  EchartsErr: "二维显示需要echarts支持，未找到相关依赖！",
  BaseMapImg: '底图',
  tip1: '<p>点击左键确定操作区域中间点</p><p>右键单击结束绘制</p>'
};

// 组件内部的语言资源：主要包括提示信息
var currentLanguage, Resource;
var cookieLanguage = getLang().toLowerCase();

function getLang() {
  //浏览器语言  IE用browserLanguage，非IE使用language进行判断
  var lang = (navigator.language || navigator.browserLanguage).toLowerCase();
  window.lang = lang; //判断portal设置语言 通过cookie获取
  //   const cookies = document.cookie.split(';');
  //   if (cookies.length > 0) {
  //     cookies.forEach(function (cookie) {
  //       const arr = cookie.split('=');
  //       if (arr[0].toLowerCase().trim() === 'language') {
  //         lang = arr[1];
  //         return;
  //       }
  //     });
  //   }

  return lang;
}

if (cookieLanguage !== undefined) {
  currentLanguage = cookieLanguage;
} else {
  currentLanguage = (navigator.language || navigator.browserLanguage).toLowerCase(); // 获取当前浏览器的语言
}

if (currentLanguage.startsWith('zh')) {
  Resource = ResourceCN;
} else if (currentLanguage.startsWith('ja')) {
  Resource = ResourceCN;
} else {
  Resource = ResourceCN;
}

var resource = Resource;

function s3mlayerAttribute(props) {
  // 设置默认值数据
  var state = reactive({
    layerNames: [],
    //当前存在的可选择s3m图层
    selectedLayerName: 'none',
    //默认选择图层名称
    brightness: 1,
    contrast: 1,
    hue: 0,
    saturation: 1,
    gamma: 1,
    alpha: 1,
    transparentBackColor: '#eecccc',
    transparentBackColorTolerance: 0
  }); // 传入props改变默认值

  if (props) {
    for (var key in props) {
      if (state.hasOwnProperty(key)) {
        if (props[key] != undefined) state[key] = props[key];
      } else {
        tool.Message.errorMsg(resource.AttributeError + key);
      }
    }
  } // 初始化数据


  var layers, selectedLayer;

  if (storeState.isViewer) {
    getLayerNames();
  } //viewer 初始化完成的监听


  watch(function () {
    return storeState.isViewer;
  }, function (val) {
    if (val) {
      getLayerNames();
    }
  }); //监听图层加载完成

  watch(function () {
    return storeState.changeLayers;
  }, function (val) {
    getLayerNames();
  }); //初始化图层

  function getLayerNames() {
    viewer.scene;
    layers = viewer.imageryLayers._layers;

    if (layers && layers.length > 1) {
      layers.forEach(function (layer, index) {
        var isMvt = layer._imageryProvider instanceof Cesium.MvtProviderGL;
        if (index === 0 || isMvt) return true;

        if (!state.layerNames.includes(layer._imageryProvider.tablename)) {
          state.layerNames.push(layer._imageryProvider.tablename);
        }
      });

      if (state.selectedLayerName = 'none') {
        state.selectedLayerName = state.layerNames[0];
        selectedLayer = layers[1];
      }
    }
  } // 销毁


  onBeforeUnmount(function () {
    layers = null;
  }); // 监听

  watch(function () {
    return state.selectedLayerName;
  }, function (val) {
    var index = state.layerNames.indexOf(val);
    if (index == -1) return;
    selectedLayer = layers[index + 1];
  });
  watch(function () {
    return state.brightness;
  }, function (val) {
    if (selectedLayer) selectedLayer.brightness = Number(val);
  });
  watch(function () {
    return state.contrast;
  }, function (val) {
    if (selectedLayer) selectedLayer.contrast = Number(val);
  });
  watch(function () {
    return state.hue;
  }, function (val) {
    if (selectedLayer) selectedLayer.hue = Number(val);
  });
  watch(function () {
    return state.saturation;
  }, function (val) {
    if (selectedLayer) selectedLayer.saturation = Number(val);
  });
  watch(function () {
    return state.gamma;
  }, function (val) {
    if (selectedLayer) selectedLayer.gamma = Number(val);
  });
  watch(function () {
    return state.alpha;
  }, function (val) {
    if (selectedLayer) selectedLayer.alpha = Number(val);
  });
  watch(function () {
    return state.transparentBackColor;
  }, function (val) {
    var color = Cesium.Color.fromCssColorString(val);
    if (selectedLayer) selectedLayer.transparentBackColor = color;
  });
  watch(function () {
    return state.transparentBackColorTolerance;
  }, function (val) {
    if (selectedLayer) selectedLayer.transparentBackColorTolerance = Number(val);
  });
  return _objectSpread2({}, toRefs(state));
}

var script = {
  name: "Sm3dImglayerAttribute",
  props: {
    //默认选择图层名称
    selectedLayerName: {
      type: String
    },
    //默认亮度
    brightness: {
      type: Number
    },
    //对比度
    contrast: {
      type: Number
    },
    //色调
    hue: {
      type: Number
    },
    //饱和度
    saturation: {
      type: Number
    },
    //伽马
    gamma: {
      type: Number
    },
    alpha: {
      type: Number
    },
    transparentBackColor: {
      type: String
    },
    transparentBackColorTolerance: {
      type: Number
    }
  },
  setup: function setup(props) {
    var _layerAttribute = s3mlayerAttribute(props),
        layerNames = _layerAttribute.layerNames,
        selectedLayerName = _layerAttribute.selectedLayerName,
        brightness = _layerAttribute.brightness,
        contrast = _layerAttribute.contrast,
        hue = _layerAttribute.hue,
        saturation = _layerAttribute.saturation,
        gamma = _layerAttribute.gamma,
        alpha = _layerAttribute.alpha,
        transparentBackColor = _layerAttribute.transparentBackColor,
        transparentBackColorTolerance = _layerAttribute.transparentBackColorTolerance;

    return {
      layerNames: layerNames,
      selectedLayerName: selectedLayerName,
      brightness: brightness,
      contrast: contrast,
      hue: hue,
      saturation: saturation,
      gamma: gamma,
      alpha: alpha,
      transparentBackColor: transparentBackColor,
      transparentBackColorTolerance: transparentBackColorTolerance
    };
  }
};

var _hoisted_1 = {
  id: "s3mlayer-attribute-panel",
  "class": "sm-panel"
};
var _hoisted_2 = {
  "class": "sm-function-module-sub-section",
  style: {
    "margin": "0"
  }
};
var _hoisted_3 = {
  "class": "sm-half-L"
};
var _hoisted_4 = {
  style: {
    "width": "35%"
  }
};
var _hoisted_5 = ["value"];
var _hoisted_6 = {
  "class": "sm-half-L"
};
var _hoisted_7 = {
  style: {
    "width": "35%"
  }
};
var _hoisted_8 = {
  "class": "sm-half-L"
};
var _hoisted_9 = {
  style: {
    "width": "35%"
  }
};
var _hoisted_10 = {
  "class": "sm-half-L"
};
var _hoisted_11 = {
  style: {
    "width": "35%"
  }
};
var _hoisted_12 = {
  "class": "sm-half-L"
};
var _hoisted_13 = {
  style: {
    "width": "35%"
  }
};
var _hoisted_14 = {
  "class": "sm-half-L"
};
var _hoisted_15 = {
  style: {
    "width": "35%"
  }
};
var _hoisted_16 = {
  "class": "sm-half-L"
};
var _hoisted_17 = {
  style: {
    "width": "35%"
  }
};
var _hoisted_18 = {
  "class": "sm-half-L"
};
var _hoisted_19 = {
  style: {
    "width": "35%"
  }
};
var _hoisted_20 = {
  "class": "sm-half-L"
};
var _hoisted_21 = {
  style: {
    "width": "35%"
  }
};
function render(_ctx, _cache, $props, $setup, $data, $options) {
  var _component_el_slider = resolveComponent("el-slider");

  var _component_el_color_picker = resolveComponent("el-color-picker");

  var _directive_stopdrag = resolveDirective("stopdrag");

  var _directive_drag = resolveDirective("drag");

  return withDirectives((openBlock(), createElementBlock("div", _hoisted_1, [withDirectives((openBlock(), createElementBlock("div", _hoisted_2, [createElementVNode("div", _hoisted_3, [createElementVNode("label", _hoisted_4, toDisplayString(_ctx.Resource.selectedLayer), 1
  /* TEXT */
  ), withDirectives(createElementVNode("select", {
    "class": "sm-select",
    style: {
      "width": "63%"
    },
    "onUpdate:modelValue": _cache[0] || (_cache[0] = function ($event) {
      return $setup.selectedLayerName = $event;
    })
  }, [(openBlock(true), createElementBlock(Fragment, null, renderList($setup.layerNames, function (layer, index) {
    return openBlock(), createElementBlock("option", {
      key: index,
      value: layer
    }, toDisplayString(layer), 9
    /* TEXT, PROPS */
    , _hoisted_5);
  }), 128
  /* KEYED_FRAGMENT */
  )), withDirectives(createElementVNode("option", {
    value: "none"
  }, toDisplayString(_ctx.Resource.noImgLayer), 513
  /* TEXT, NEED_PATCH */
  ), [[vShow, $setup.layerNames.length == 0]])], 512
  /* NEED_PATCH */
  ), [[vModelSelect, $setup.selectedLayerName]])]), createElementVNode("div", _hoisted_6, [createElementVNode("label", _hoisted_7, toDisplayString(_ctx.Resource.brightness), 1
  /* TEXT */
  ), createVNode(_component_el_slider, {
    modelValue: $setup.brightness,
    "onUpdate:modelValue": _cache[1] || (_cache[1] = function ($event) {
      return $setup.brightness = $event;
    }),
    min: 0,
    max: 3,
    step: 0.05,
    "input-size": "mini",
    debounce: 500,
    "tooltip-class": "tooltip-class",
    style: {
      "width": "63%"
    }
  }, null, 8
  /* PROPS */
  , ["modelValue", "step"])]), createElementVNode("div", _hoisted_8, [createElementVNode("label", _hoisted_9, toDisplayString(_ctx.Resource.contrast), 1
  /* TEXT */
  ), createVNode(_component_el_slider, {
    modelValue: $setup.contrast,
    "onUpdate:modelValue": _cache[2] || (_cache[2] = function ($event) {
      return $setup.contrast = $event;
    }),
    min: 0,
    max: 3,
    step: 0.05,
    "input-size": "mini",
    debounce: 500,
    "tooltip-class": "tooltip-class",
    style: {
      "width": "63%"
    }
  }, null, 8
  /* PROPS */
  , ["modelValue", "step"])]), createElementVNode("div", _hoisted_10, [createElementVNode("label", _hoisted_11, toDisplayString(_ctx.Resource.hue), 1
  /* TEXT */
  ), createVNode(_component_el_slider, {
    modelValue: $setup.hue,
    "onUpdate:modelValue": _cache[3] || (_cache[3] = function ($event) {
      return $setup.hue = $event;
    }),
    min: 0,
    max: 3,
    step: 0.05,
    "input-size": "mini",
    debounce: 500,
    "tooltip-class": "tooltip-class",
    style: {
      "width": "63%"
    }
  }, null, 8
  /* PROPS */
  , ["modelValue", "step"])]), createElementVNode("div", _hoisted_12, [createElementVNode("label", _hoisted_13, toDisplayString(_ctx.Resource.saturation), 1
  /* TEXT */
  ), createVNode(_component_el_slider, {
    modelValue: $setup.saturation,
    "onUpdate:modelValue": _cache[4] || (_cache[4] = function ($event) {
      return $setup.saturation = $event;
    }),
    min: 0,
    max: 3,
    step: 0.05,
    "input-size": "mini",
    debounce: 500,
    "tooltip-class": "tooltip-class",
    style: {
      "width": "63%"
    }
  }, null, 8
  /* PROPS */
  , ["modelValue", "step"])]), createElementVNode("div", _hoisted_14, [createElementVNode("label", _hoisted_15, toDisplayString(_ctx.Resource.gamma), 1
  /* TEXT */
  ), createVNode(_component_el_slider, {
    modelValue: $setup.gamma,
    "onUpdate:modelValue": _cache[5] || (_cache[5] = function ($event) {
      return $setup.gamma = $event;
    }),
    min: 0,
    max: 3,
    step: 0.05,
    "input-size": "mini",
    debounce: 500,
    "tooltip-class": "tooltip-class",
    style: {
      "width": "63%"
    }
  }, null, 8
  /* PROPS */
  , ["modelValue", "step"])]), createElementVNode("div", _hoisted_16, [createElementVNode("label", _hoisted_17, toDisplayString(_ctx.Resource.alpha), 1
  /* TEXT */
  ), createVNode(_component_el_slider, {
    modelValue: $setup.alpha,
    "onUpdate:modelValue": _cache[6] || (_cache[6] = function ($event) {
      return $setup.alpha = $event;
    }),
    min: 0,
    max: 1,
    step: 0.01,
    "input-size": "mini",
    debounce: 500,
    "tooltip-class": "tooltip-class",
    style: {
      "width": "63%"
    }
  }, null, 8
  /* PROPS */
  , ["modelValue", "step"])]), createElementVNode("div", _hoisted_18, [createElementVNode("label", _hoisted_19, toDisplayString(_ctx.Resource.transparentColor), 1
  /* TEXT */
  ), createVNode(_component_el_color_picker, {
    modelValue: $setup.transparentBackColor,
    "onUpdate:modelValue": _cache[7] || (_cache[7] = function ($event) {
      return $setup.transparentBackColor = $event;
    }),
    size: "mini",
    style: {
      "width": "63%"
    }
  }, null, 8
  /* PROPS */
  , ["modelValue"])]), createElementVNode("div", _hoisted_20, [createElementVNode("label", _hoisted_21, toDisplayString(_ctx.Resource.transparentColorTolerance), 1
  /* TEXT */
  ), createVNode(_component_el_slider, {
    modelValue: $setup.transparentBackColorTolerance,
    "onUpdate:modelValue": _cache[8] || (_cache[8] = function ($event) {
      return $setup.transparentBackColorTolerance = $event;
    }),
    min: 0,
    max: 1,
    step: 0.01,
    "input-size": "mini",
    debounce: 500,
    "tooltip-class": "tooltip-class",
    style: {
      "width": "63%"
    }
  }, null, 8
  /* PROPS */
  , ["modelValue", "step"])])])), [[_directive_stopdrag]])])), [[_directive_drag]]);
}

script.render = render;
script.__file = "src/components/layer/imglayer-attribute/imglayer-attribute.vue";

script.install = function (app) {
  app.component(script.name, script);
};

export default script;
