import { reactive, toRefs, ref, watch, onBeforeUnmount, resolveComponent, resolveDirective, openBlock, createElementBlock, Fragment, withDirectives, createElementVNode, renderList, normalizeClass, toDisplayString, createVNode, vShow, vModelCheckbox, createTextVNode, createCommentVNode, vModelText } from 'vue';

function _typeof(obj) {
  "@babel/helpers - typeof";

  if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
    _typeof = function (obj) {
      return typeof obj;
    };
  } else {
    _typeof = function (obj) {
      return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
    };
  }

  return _typeof(obj);
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);

  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    if (enumerableOnly) symbols = symbols.filter(function (sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    });
    keys.push.apply(keys, symbols);
  }

  return keys;
}

function _objectSpread2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};

    if (i % 2) {
      ownKeys(Object(source), true).forEach(function (key) {
        _defineProperty(target, key, source[key]);
      });
    } else if (Object.getOwnPropertyDescriptors) {
      Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
      ownKeys(Object(source)).forEach(function (key) {
        Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
      });
    }
  }

  return target;
}

function _toConsumableArray(arr) {
  return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread();
}

function _arrayWithoutHoles(arr) {
  if (Array.isArray(arr)) return _arrayLikeToArray(arr);
}

function _iterableToArray(iter) {
  if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter);
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

  return arr2;
}

function _nonIterableSpread() {
  throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

// 创建一个简单的store状态管理

var storeState = reactive({
  isViewer: false,
  //viewer初始化标志
  changeLayers: 0,
  //图层改变加载完毕监听
  changeGeometrys: 0 //三维分析体改变标志

});

/*
* 常用工具类
*/
//axios本版本不支持jsonp
var axiosJsonp = function axiosJsonp(url) {
  if (!url) {
    console.error('Axios.JSONP 至少需要一个url参数!');
    return;
  }

  return new Promise(function (resolve, reject) {
    window.jsonCallBack = function (result) {
      resolve(result);
    };

    var JSONP = document.createElement("script");
    JSONP.type = "text/javascript";
    JSONP.src = "".concat(url, "&callback=jsonCallBack");
    document.getElementsByTagName("head")[0].appendChild(JSONP);
    setTimeout(function () {
      document.getElementsByTagName("head")[0].removeChild(JSONP);
    }, 500);
  });
}; //判断两数组或对象相等


var isEqualArr = function isEqualArr(arg1, arg2) {
  if (!arg1 || !arg2) return true;
  var bol = true;

  if (Object.keys(arg1).length != Object.keys(arg2).length) {
    return false;
  }

  for (var key in arg1) {
    if (_typeof(arg1[key]) == 'object') {
      bol = isSame(arg1[key], arg2[key]);

      if (!bol) {
        break;
      }
    } else if (arg1[key] != arg2[key]) {
      bol = false;
      break;
    }
  }

  return bol;
}; //坐标转化
//笛卡尔转经纬度


var CartesiantoDegrees = function CartesiantoDegrees(Cartesians) {
  var array = [].concat(Cartesians);
  var positions = [];

  for (var i = 0, len = array.length; i < len; i++) {
    var cartographic = Cesium.Cartographic.fromCartesian(array[i]);
    var longitude = Cesium.Math.toDegrees(cartographic.longitude);
    var latitude = Cesium.Math.toDegrees(cartographic.latitude);
    var h = cartographic.height;

    if (positions.indexOf(longitude) == -1 && positions.indexOf(latitude) == -1) {
      positions.push(longitude);
      positions.push(latitude);
      positions.push(h);
    }
  }

  return positions;
}; //笛卡尔转经纬度(每个点是独立的对象)


var CartesiantoDegreesObjs = function CartesiantoDegreesObjs(Cartesians) {
  var array = [].concat(Cartesians);
  var positions = [];

  for (var i = 0, len = array.length; i < len; i++) {
    var cartographic = Cesium.Cartographic.fromCartesian(array[i]);
    var obj = {
      longitude: Cesium.Math.toDegrees(cartographic.longitude),
      latitude: Cesium.Math.toDegrees(cartographic.latitude),
      height: cartographic.height
    };
    positions.push(obj);
  }

  return positions;
}; // 弧度转经纬度


var CartographictoDegrees = function CartographictoDegrees(wgsPosition) {
  var longitude = Cesium.Math.toDegrees(wgsPosition.longitude);
  var latitude = Cesium.Math.toDegrees(wgsPosition.latitude);
  var height = wgsPosition.height;
  return [longitude, latitude, height];
}; //去重函数  数组


var unique = function unique(arr) {
  var res = [];
  var json = {};

  for (var i = 0; i < arr.length; i++) {
    if (!json[arr[i]]) {
      res.push(arr[i]);
      json[arr[i]] = 1;
    }
  }

  return res;
}; // 获取渐变色函数


function gradientColors(start, end, steps, gamma) {
  var i,
      j,
      ms,
      me,
      output = [],
      so = [];
  gamma = gamma || 1;

  var normalize = function normalize(channel) {
    return Math.pow(channel / 255, gamma);
  };

  start = parseColor(start).map(normalize);
  end = parseColor(end).map(normalize);

  for (i = 0; i < steps; i++) {
    ms = i / (steps - 1);
    me = 1 - ms;

    for (j = 0; j < 3; j++) {
      so[j] = pad(Math.round(Math.pow(start[j] * me + end[j] * ms, 1 / gamma) * 255).toString(16));
    }

    output.push('#' + so.join(''));
  }

  return output;

  function parseColor(hexStr) {
    return hexStr.length === 4 ? hexStr.substr(1).split('').map(function (s) {
      return 0x11 * parseInt(s, 16);
    }) : [hexStr.substr(1, 2), hexStr.substr(3, 2), hexStr.substr(5, 2)].map(function (s) {
      return parseInt(s, 16);
    });
  }

  function pad(s) {
    return s.length === 1 ? '0' + s : s;
  }
}

function getAngleAndRadian(pointA, pointB) {
  //建立以点A为原点，X轴为east,Y轴为north,Z轴朝上的坐标系
  var transform = Cesium.Transforms.eastNorthUpToFixedFrame(pointA); //向量AB

  var positionvector = Cesium.Cartesian3.subtract(pointB, pointA, new Cesium.Cartesian3()); //因transform是将A为原点的eastNorthUp坐标系中的点转换到世界坐标系的矩阵
  //AB为世界坐标中的向量
  //因此将AB向量转换为A原点坐标系中的向量，需乘以transform的逆矩阵。

  var vector = Cesium.Matrix4.multiplyByPointAsVector(Cesium.Matrix4.inverse(transform, new Cesium.Matrix4()), positionvector, new Cesium.Cartesian3()); //归一化

  var direction = Cesium.Cartesian3.normalize(vector, new Cesium.Cartesian3()); //heading

  var heading1 = Math.atan2(direction.y, direction.x) - Cesium.Math.PI_OVER_TWO;
  var radian = Cesium.Math.TWO_PI - Cesium.Math.zeroToTwoPi(heading1);
  var angle = radian * (180 / Math.PI);

  if (angle < 0) {
    angle = angle + 360;
  }

  return {
    angle: angle,
    radian: radian
  };
}

function getPitch(pointA, pointB) {
  var transfrom = Cesium.Transforms.eastNorthUpToFixedFrame(pointA);
  var vector = Cesium.Cartesian3.subtract(pointB, pointA, new Cesium.Cartesian3());
  var direction = Cesium.Matrix4.multiplyByPointAsVector(Cesium.Matrix4.inverse(transfrom, transfrom), vector, vector);
  Cesium.Cartesian3.normalize(direction, direction); //因为direction已归一化，斜边长度等于1，所以余弦函数等于direction.z

  var radian = Cesium.Math.PI_OVER_TWO - Cesium.Math.acosClamped(direction.z);
  var angle = radian * (180 / Math.PI);

  if (angle < 0) {
    angle = angle + 360;
  }

  return {
    angle: angle,
    radian: radian
  };
}

var tool = {
  axiosJsonp: axiosJsonp,
  isEqualArr: isEqualArr,
  CartesiantoDegrees: CartesiantoDegrees,
  CartesiantoDegreesObjs: CartesiantoDegreesObjs,
  unique: unique,
  gradientColors: gradientColors,
  getAngleAndRadian: getAngleAndRadian,
  CartographictoDegrees: CartographictoDegrees,
  getPitch: getPitch
};

var ResourceCN = {
  showRenderLoopErrors: '渲染时发生错误，已停止渲染。',
  AttributeError: '该组件props没有这个属性：',
  NoPickPositionSupported: "不支持深度纹理,无法绘制多边形，地形操作功能无法使用！",
  NoTerrain: "请在地形里使用地形组件！",
  initViewerWarn: '请先初始化viewer!',
  MoveMouseHeightBox: '点击鼠标左键结束矩形绘制，移动鼠标绘制box高度',
  RightClickEndDrawing: '右键单击结束绘制',
  LeftClickBottomBox: '点击鼠标左键，开始绘制矩形作为box底面',
  ClickModelAddBox: '点击模型，添加裁剪盒子',
  SkyLineWarn: "获取天际线体前，请先绘制天际线！",
  SkyLineBody: '天际线体',
  ShadowqueryWarn: "此操作需要先开启阴影！",
  VeiwshedBody: '可视体',
  VeiwshedBodyHidden: '不可视体',
  EchartsErr: "二维显示需要echarts支持，未找到相关依赖！",
  BaseMapImg: '底图',
  tip1: '<p>点击左键确定操作区域中间点</p><p>右键单击结束绘制</p>'
};

// 组件内部的语言资源：主要包括提示信息
var currentLanguage, Resource;
var cookieLanguage = getLang().toLowerCase();

function getLang() {
  //浏览器语言  IE用browserLanguage，非IE使用language进行判断
  var lang = (navigator.language || navigator.browserLanguage).toLowerCase();
  window.lang = lang; //判断portal设置语言 通过cookie获取
  //   const cookies = document.cookie.split(';');
  //   if (cookies.length > 0) {
  //     cookies.forEach(function (cookie) {
  //       const arr = cookie.split('=');
  //       if (arr[0].toLowerCase().trim() === 'language') {
  //         lang = arr[1];
  //         return;
  //       }
  //     });
  //   }

  return lang;
}

if (cookieLanguage !== undefined) {
  currentLanguage = cookieLanguage;
} else {
  currentLanguage = (navigator.language || navigator.browserLanguage).toLowerCase(); // 获取当前浏览器的语言
}

if (currentLanguage.startsWith('zh')) {
  Resource = ResourceCN;
} else if (currentLanguage.startsWith('ja')) {
  Resource = ResourceCN;
} else {
  Resource = ResourceCN;
}

var resource = Resource;

//随鼠标移动消息提示工具
function createTooltip(frameDiv) {
  var tooltip = function tooltip(frameDiv) {
    var div = document.createElement("DIV");
    div.className = "twipsy right";
    var arrow = document.createElement("DIV");
    arrow.className = "twipsy-arrow";
    div.appendChild(arrow);
    var title = document.createElement("DIV");
    title.className = "twipsy-inner";
    div.appendChild(title);
    this._div = div;
    this._title = title;
    this.message = "";
    frameDiv.appendChild(div);
    var that = this;

    div.onmousemove = function (evt) {
      that.showAt({
        x: evt.clientX,
        y: evt.clientY
      }, that.message);
    };
  };

  tooltip.prototype.setVisible = function (visible) {
    this._div.style.display = visible ? "block" : "none";
  };

  tooltip.prototype.showAt = function (position, message) {
    if (position && message) {
      this.setVisible(true);
      this._title.innerHTML = message;
      this._div.style.left = position.x + 10 + "px";
      this._div.style.top = position.y - this._div.clientHeight / 2 + "px";
      this.message = message;
    }
  };

  return new tooltip(frameDiv);
}

/**
 * 初始化
 * DrawMode：类型
 * clampMode：模式
 */

var initHandler = function initHandler(DrawMode, clampMode) {
  var clampmode = 0;

  if (clampMode) {
    clampmode = clampMode;
  }

  switch (DrawMode) {
    case "Point":
      window.handlerPoint = new Cesium.DrawHandler(viewer, Cesium.DrawMode.Point);
      break;

    case "Polyline":
      window.handlerPolyline = new Cesium.DrawHandler(viewer, Cesium.DrawMode.Line, clampmode);
      break;

    case "Polygon":
      window.handlerPolygon = new Cesium.DrawHandler(viewer, Cesium.DrawMode.Polygon, clampmode);
      break;

    case "Marker":
      window.handlerMarker = new Cesium.DrawHandler(viewer, Cesium.DrawMode.Marker, clampmode);
      break;

    case "Box":
      window.handlerBox = new Cesium.DrawHandler(viewer, Cesium.DrawMode.Box, clampmode);
      break;
  }

  if (!window.tooltip) {
    window.tooltip = createTooltip(viewer._element);
  } // 半透线创建


  if (!window.polylineCollection) {
    window.polylineCollection = new Cesium.PolylineCollection({
      translucentRS: Cesium.RenderState.fromCache({
        depthMask: false,
        depthTest: {
          enabled: false
        }
      })
    });
    window.polylineTransparent = window.polylineCollection.add({
      width: 2,
      material: Cesium.Material.fromType(Cesium.Material.ColorType, {
        color: Cesium.Color.fromCssColorString("#51ff00").withAlpha(0.3)
      })
    });
    viewer.scene.primitives.add(window.polylineCollection);
  }
};
/**
 * 绘制
 * PolyType：类型 
 * lineVisib：绘制时是否显示绘制线（boolean）
 * toolTipObj：绘制时提示内容{beforeDrawing：绘制开始前提示(string)，isDrawing：正在绘制时提示,即绘制过程中（string）}
 */


var handlerDrawing = function handlerDrawing(PolyType, lineVisib, toolTipObj) {
  var lineVisible = true;

  if (lineVisib === false) {
    lineVisible = lineVisib;
  }

  var DrawHandler = judgeDrawHandlerType(PolyType); //获取操作对象

  return new Promise(function (resolve, reject) {
    //做一些异步操作
    var tooltip = window.tooltip;
    var clearActFn = DrawHandler.activeEvt.addEventListener(function (isActive) {
      if (isActive == true) {
        viewer.enableCursorStyle = false;
        viewer._element.style.cursor = '';

        if (PolyType == "Point" || PolyType == "Marker") {
          document.body.classList.add("measureCur");
        } else {
          document.body.classList.add("drawCur");
        }
      } else {
        viewer.enableCursorStyle = true;
        tooltip.setVisible(false);

        if (PolyType == "Point" || PolyType == "Marker") {
          document.body.classList.remove('measureCur');
        } else {
          document.body.classList.remove('drawCur');
        }
      }
    });
    var clearMovFn = DrawHandler.movingEvt.addEventListener(function (windowPosition) {
      if (windowPosition.x < 200 && windowPosition.y < 150) {
        tooltip.setVisible(false);
        return;
      }
      //     tooltip.showAt(windowPosition, tiptext);
      // } else if (toolTipObj && toolTipObj.beforeDrawing) {
      //     tooltip.showAt(windowPosition, toolTipObj.beforeDrawing);
      // }else if (DrawHandler.isDrawing && toolTipObj.isDrawing) {
      //     tooltip.showAt(windowPosition, toolTipObj.isDrawing);
      // }

      if (DrawHandler.polyline && DrawHandler.isDrawing) {
        var p = _toConsumableArray(DrawHandler.polyline.positions);

        if (PolyType == "Polygon") {
          //画面时，需要首尾相连
          p.push(p[0]);
        }
        window.polylineTransparent.show = true;
        window.polylineTransparent.positions = p;
      }
    });
    var clearDrawFn = DrawHandler.drawEvt.addEventListener(function (result) {
      if (!result.object.positions && PolyType != "Point" && PolyType != "Box") {
        tooltip.showAt(result, '<p>请绘制正确的多边形</p>');
        DrawHandler.polygon.show = false;
        DrawHandler.polyline.show = false;
        DrawHandler.deactivate();
        DrawHandler.activate();
        return;
      }

      if (PolyType == "Box") {
        resolve({
          result: result
        });
        return;
      }

      if (PolyType == "Point" || PolyType == "Marker") {
        DrawHandler.clear(); // 不显示绘制的点

        resolve({
          result: result
        });
      } else {
        //半透线
        window.polylineTransparent.show = lineVisible;

        if (lineVisible) {
          if (PolyType == "Polygon" && lineVisible) {
            DrawHandler.polygon._polygon._material._color._value.alpha = 0.1; //绘制面透明度

            var p2 = _toConsumableArray(result.object.positions); //画面时，需要首尾相连


            p2.push(p2[0]);
            window.polylineTransparent.positions = p2;
          }
        }

        var positions = CartesiantoDegrees(result.object.positions);
        resolve({
          result: result,
          positions: positions
        });
      }

      clearActFn();
      clearMovFn();
      clearDrawFn();
    });
  });
}; //清除


var clearHandlerDrawing = function clearHandlerDrawing(PolyType) {
  var DrawHandler;

  if (!PolyType) {
    DrawHandler = window.handlerPolygon;
  } else {
    DrawHandler = judgeDrawHandlerType(PolyType);
  }
  if (!DrawHandler) return;
  DrawHandler.deactivate();
  DrawHandler.clear();
  viewer.enableCursorStyle = true; // document.body.classList.remove("drawCur");
  // document.body.classList.remove("measureCur");

  window.tooltip.setVisible(false);

  if (window.polylineTransparent) {
    window.polylineTransparent.show = false;
  }
}; // 类型判断


var judgeDrawHandlerType = function judgeDrawHandlerType(PolyType) {
  var DrawHandler;

  switch (PolyType) {
    case "Point":
      DrawHandler = window.handlerPoint;
      break;

    case "Polyline":
      DrawHandler = window.handlerPolyline;
      break;

    case "Polygon":
      DrawHandler = window.handlerPolygon;
      break;

    case "Marker":
      DrawHandler = window.handlerMarker;
      break;

    case "Box":
      DrawHandler = window.handlerBox;
      break;
  }

  return DrawHandler;
};

function createTooltip$1(frameDiv) {
  var tooltip = function tooltip(frameDiv) {
    var div = document.createElement('DIV');
    div.className = "tooltip";
    this._div = div;
    this.message = '';
    frameDiv.appendChild(div);
  };

  tooltip.prototype.setVisible = function (visible) {
    if (visible) {
      this._div.style.right = '10px';
    } else {
      this._div.style.right = '-300px';
    }
  };

  tooltip.prototype.showAt = function (message, top) {
    //top:200px => string
    if (top) {
      this._div.style.top = top;
    }

    if (message) {
      this.setVisible(true);
      this._div.innerHTML = message;
    }
  };

  return new tooltip(frameDiv);
}

var config = [{
  id: 0,
  iconfont: 'icondianguangyuan',
  lightName: '点光源'
}, {
  id: 1,
  iconfont: 'iconjuguangdeng',
  lightName: '聚光灯'
}, {
  id: 2,
  iconfont: 'iconpinghangguang',
  lightName: '平行光'
}];

function addPointSymbol(props) {
  // 设置默认值数据
  var state = reactive({
    lightSelectId: 0,
    lightColor: "#FFFFFF",
    cutoffDistance: 200,
    lightDecay: 5,
    lightIntensity: 5,
    spotLightAngle: 30,
    visibleModel: true,
    dockFontShow: true,
    //停靠图标显示
    modelPosition: [0, 0, 0],
    modelLongitude: '',
    modelLatitude: '',
    modelHeight: '',
    bubbleShow: false,
    visiblePositions: false
  }); // 传入props改变默认值

  if (props) {
    for (var key in props) {
      if (state.hasOwnProperty(key)) {
        if (props[key] != undefined) state[key] = props[key];
      } else {
        tool.Message.errorMsg(resource.AttributeError + key);
      }
    }
  } // 初始化数据


  var currentSelectedEntity, selectdeLightSource, s3mInstanceColc;
  var isAddPointLight = false;
  var entityLightPairs = new Map(); // Entity和点光源对象的键值对

  var modelUrl = 'public/data/s3m/light.s3m';
  var modelEditor;
  var bubble = ref(null);

  if (storeState.isViewer) {
    if (!window.tooltip) {
      window.tooltip = createTooltip$1(viewer._element);
    }

    s3mInstanceColc = new Cesium.S3MInstanceCollection(scene._context);
    viewer.scene.primitives.add(s3mInstanceColc);
  } //viewer 初始化完成的监听


  watch(function () {
    return storeState.isViewer;
  }, function (val) {
    if (val) {
      if (!window.tooltip) {
        window.tooltip = createTooltip$1(viewer._element);
      }

      s3mInstanceColc = new Cesium.S3MInstanceCollection(scene._context);
      viewer.scene.primitives.add(s3mInstanceColc);
    }
  });

  function addModel(position, pointLight) {
    var id = "light-model-" + new Date().getTime();
    s3mInstanceColc.add(modelUrl, {
      id: id,
      position: position,
      scale: new Cesium.Cartesian3(2, 2, 2)
    });
    currentSelectedEntity = s3mInstanceColc.getInstance(modelUrl, id);
    entityLightPairs.set(id, pointLight);
  }

  function getTooltipText() {
    if (state.lightSelectId === 0) {
      return '<p>点击确认点光源位置</p><p>选中光源模型可编辑与删除</p>';
    }

    return '<p>点击第一点确认光源位置</p><p>第二点确认光源方向</p><p>选中光源模型可编辑与删除</p>';
  }

  var isModelMoving = false;

  function addModelEditor(model) {
    modelEditor = new Cesium.ModelEditor({
      model: model,
      scene: viewer.scene,
      axesShow: {
        "translation": true,
        "rotation": false,
        "scale": true
      }
    });
    modelEditor.activate();
    modelEditor.changedEvt.addEventListener(function (param) {
      var Cartesian3 = new Cesium.Cartesian3();
      Cesium.Matrix4.getTranslation(param.modelMatrix, Cartesian3);

      if (Cartesian3) {
        var _state$modelPosition;

        selectdeLightSource.position = Cartesian3;
        isModelMoving = true;
        changeSlider(function () {
          return isModelMoving = false;
        });
        var position = tool.CartesiantoDegrees(Cartesian3);
        state.modelPosition.length = 0;

        (_state$modelPosition = state.modelPosition).push.apply(_state$modelPosition, [position[0].toFixed(6), position[1].toFixed(6), position[2].toFixed(2)]);
      }
    });
  }

  function drawPolyline() {
    if (!window.handlerPolyline) {
      initHandler("Polyline");
    }

    handlerDrawing("Polyline").then(function (res) {
      if (state.lightSelectId === 1) {
        addSpotLight(res.result.object.positions);
      } else {
        addDirectionalLight(res.result.object.positions);
      }

      var handlerPolyline = window.handlerPolyline;
      handlerPolyline.polyline.show = false;
      window.polylineTransparent.show = false; //半透线隐藏

      handlerPolyline.deactivate();
      tooltip.setVisible(false);
    }, function (err) {
      console.log(err);
    });
    window.handlerPolyline.activate();
  }

  function addLight() {
    var test = getTooltipText();
    window.tooltip.showAt(test, '400px');
    viewer.eventManager.addEventListener("CLICK", click_light, true);

    if (state.lightSelectId === 0) {
      viewer.enableCursorStyle = false;
      viewer._element.style.cursor = "";
      document.body.classList.add("measureCur");
      isAddPointLight = true;
      return;
    }

    drawPolyline();
  }

  function click_light(e) {
    if (isAddPointLight) {
      isAddPointLight = false;
      viewer.enableCursorStyle = true;
      document.body.classList.remove("measureCur");
      var targetPosition = scene.pickPosition(e.message.position);
      addPointLight(targetPosition);
      tooltip.setVisible(false);
    } else {
      var symbol = viewer.scene.pick(e.message.position) || viewer.selectedEntity;

      if (symbol && symbol.id && typeof symbol.id === 'string' && symbol.id.indexOf("light-model-") != -1) {
        var _state$modelPosition2;

        if (currentSelectedEntity && currentSelectedEntity.id === symbol.id.id) return;
        currentSelectedEntity = symbol;
        selectdeLightSource = entityLightPairs.get(symbol.id);
        if (!modelEditor) addModelEditor(symbol.primitive);else modelEditor.setEditObject(symbol.primitive); //

        bubble.value.style.top = e.message.position.y - 160 + 'px';
        bubble.value.style.left = e.message.position.x + 'px';
        console.log(modelEditor);
        var position = tool.CartesiantoDegrees(modelEditor._position);
        state.modelPosition.length = 0;

        (_state$modelPosition2 = state.modelPosition).push.apply(_state$modelPosition2, [position[0].toFixed(6), position[1].toFixed(6), position[2].toFixed(2)]);

        state.bubbleShow = true;
        return;
      }

      currentSelectedEntity = undefined;
      selectdeLightSource = undefined;
      if (modelEditor) modelEditor.deactivate();
      state.bubbleShow = false;
    }
  }

  function addPointLight(position0) {
    var position = addModleHeight(position0);
    var options = {
      color: Cesium.Color.fromCssColorString(state.lightColor),
      cutoffDistance: Number(state.cutoffDistance),
      decay: Number(state.lightDecay),
      intensity: Number(state.lightIntensity)
    };
    var pointLight = new Cesium.PointLight(position, options);
    selectdeLightSource = pointLight;
    viewer.scene.addLightSource(pointLight);
    addModel(position, pointLight);
  }

  function addSpotLight(positions) {
    var position1 = addModleHeight(positions[0]);
    var position2 = positions[1];
    var options = {
      color: Cesium.Color.fromCssColorString(state.lightColor),
      distance: Number(state.cutoffDistance),
      decay: Number(state.lightDecay),
      intensity: Number(state.lightIntensity),
      angle: Cesium.Math.toRadians(Number(state.spotLightAngle))
    };
    var spotLight = new Cesium.SpotLight(position1, position2, options);
    selectdeLightSource = spotLight;
    viewer.scene.addLightSource(spotLight);
    addModel(position1, spotLight);
  }

  function addDirectionalLight(positions) {
    var position1 = addModleHeight(positions[0]);
    var position2 = positions[1];
    var options = {
      targetPosition: position2,
      color: Cesium.Color.fromCssColorString(state.lightColor),
      intensity: Number(state.lightIntensity)
    };
    var directionalLight = new Cesium.DirectionalLight(position1, options);
    selectdeLightSource = directionalLight;
    viewer.scene.addLightSource(directionalLight);
    addModel(position1, directionalLight);
  }

  function addModleHeight(Cartesian3) {
    var Cartographic = Cesium.Cartographic.fromCartesian(Cartesian3);
    Cartographic.height += 0.5;
    return Cesium.Cartographic.toCartesian(Cartographic);
  }

  function clearLight() {
    if (currentSelectedEntity) {
      entityLightPairs["delete"](currentSelectedEntity.id);
      s3mInstanceColc.removeInstance(modelUrl, currentSelectedEntity.id);
      currentSelectedEntity = null;
    }

    if (selectdeLightSource) viewer.scene.removeLightSource(selectdeLightSource);
    if (entityLightPairs.size === 0) viewer.eventManager.removeEventListener("CLICK", click_light);
    if (modelEditor) modelEditor.deactivate();
    isAddPointLight = false;
    selectdeLightSource = null;
    clearHandlerDrawing();
    viewer.enableCursorStyle = true;
    document.body.classList.remove("measureCur");
    tooltip.setVisible(false);
    closeBubble();
  } //关闭气泡


  function closeBubble() {
    state.bubbleShow = false;
  } //悬停气泡


  function dockBubble(val) {
    if (val) {
      bubble.value.classList.add('bubbleDock');
      state.dockFontShow = false;
    } else {
      bubble.value.classList.remove('bubbleDock');
      state.dockFontShow = true;
    }
  }

  watch(function () {
    return state.lightColor;
  }, function (val) {
    if (!selectdeLightSource) return;
    var color = Cesium.Color.fromCssColorString(val);
    selectdeLightSource.color = color;
  });
  watch(function () {
    return state.cutoffDistance;
  }, function (val) {
    if (!selectdeLightSource) return;

    if (selectdeLightSource.lightType === 1) {
      selectdeLightSource.cutoffDistance = Number(val);
      return;
    }

    if (selectdeLightSource.lightType === 2) {
      selectdeLightSource.distance = Number(val);
      return;
    }
  });
  watch(function () {
    return state.lightDecay;
  }, function (val) {
    if (!selectdeLightSource) return;

    if (selectdeLightSource.lightType !== 0) {
      selectdeLightSource.decay = Number(val);
    }
  });
  watch(function () {
    return state.lightIntensity;
  }, function (val) {
    if (!selectdeLightSource) return;
    selectdeLightSource.intensity = Number(val);
  });
  watch(function () {
    return state.spotLightAngle;
  }, function (val) {
    if (!selectdeLightSource) return;

    if (selectdeLightSource.lightType === 2) {
      selectdeLightSource.angle = Cesium.Math.toRadians(Number(val));
    }
  });
  watch(function () {
    return state.visibleModel;
  }, function (val) {
    if (!currentSelectedEntity) return;
    if (modelEditor) modelEditor.deactivate();
    s3mInstanceColc.visible = val;
  });
  watch(function () {
    return state.modelPosition;
  }, function (val) {
    if (!currentSelectedEntity || isModelMoving) return;
    changeSlider(function () {
      var lon = Number(val[0]);
      var lat = Number(val[1]);
      var hei = Number(val[2]);
      var position = Cesium.Cartesian3.fromDegrees(lon, lat, hei);
      selectdeLightSource.position = position;
      currentSelectedEntity.primitive.updatePosition(position);
      if (modelEditor) modelEditor.setEditObject(currentSelectedEntity.primitive);
    });
  }, {
    deep: true
  });
  var timer; // 防止滑块快速滑动的多次执行

  function changeSlider(callback) {
    if (timer) clearTimeout(timer);
    timer = setTimeout(function () {
      callback();
    }, 1000);
  } // 销毁


  onBeforeUnmount(function () {// if (viewer) viewer.eventManager.removeEventListener("CLICK", click_light);
  });
  return _objectSpread2(_objectSpread2({}, toRefs(state)), {}, {
    config: config,
    addLight: addLight,
    clearLight: clearLight,
    bubble: bubble,
    closeBubble: closeBubble,
    dockBubble: dockBubble
  });
}

var script = {
  name: "Sm3dLight",
  props: {
    // 颜色
    lightColor: {
      type: String
    },
    // 扩散距离
    cutoffDistance: {
      type: Number
    },
    // 衰减因子
    lightDecay: {
      type: Number
    },
    // 光源强度
    lightIntensity: {
      type: Number
    },
    // 聚光范围
    spotLightAngle: {
      type: Number
    }
  },
  setup: function setup(props) {
    var _light = addPointSymbol(props),
        lightSelectId = _light.lightSelectId,
        lightColor = _light.lightColor,
        cutoffDistance = _light.cutoffDistance,
        lightDecay = _light.lightDecay,
        lightIntensity = _light.lightIntensity,
        spotLightAngle = _light.spotLightAngle,
        config = _light.config,
        addLight = _light.addLight,
        clearLight = _light.clearLight,
        visibleModel = _light.visibleModel,
        bubble = _light.bubble,
        closeBubble = _light.closeBubble,
        dockBubble = _light.dockBubble,
        dockFontShow = _light.dockFontShow,
        modelPosition = _light.modelPosition,
        bubbleShow = _light.bubbleShow,
        visiblePositions = _light.visiblePositions;

    return {
      lightSelectId: lightSelectId,
      lightColor: lightColor,
      cutoffDistance: cutoffDistance,
      lightDecay: lightDecay,
      lightIntensity: lightIntensity,
      spotLightAngle: spotLightAngle,
      config: config,
      addLight: addLight,
      clearLight: clearLight,
      visibleModel: visibleModel,
      bubble: bubble,
      closeBubble: closeBubble,
      dockBubble: dockBubble,
      dockFontShow: dockFontShow,
      modelPosition: modelPosition,
      bubbleShow: bubbleShow,
      visiblePositions: visiblePositions
    };
  }
};

var _hoisted_1 = {
  id: "draw-panel",
  "class": "sm-panel"
};
var _hoisted_2 = {
  "class": "sm-function-module-sub-section",
  style: {
    "margin": "0"
  }
};
var _hoisted_3 = {
  "class": "sm-half-L symbolic"
};
var _hoisted_4 = ["onClick"];
var _hoisted_5 = {
  style: {
    "width": "100%"
  }
};
var _hoisted_6 = {
  "class": "sm-half-L"
};
var _hoisted_7 = {
  style: {
    "width": "35%"
  }
};
var _hoisted_8 = {
  "class": "sm-half-L"
};
var _hoisted_9 = {
  style: {
    "width": "35%"
  }
};
var _hoisted_10 = {
  "class": "sm-half-L"
};
var _hoisted_11 = {
  style: {
    "width": "35%"
  }
};
var _hoisted_12 = {
  "class": "sm-half-L"
};
var _hoisted_13 = {
  style: {
    "width": "35%"
  }
};
var _hoisted_14 = {
  "class": "sm-half-L"
};
var _hoisted_15 = {
  style: {
    "width": "35%"
  }
};
var _hoisted_16 = {
  "class": "sm-half-L flex-between"
};
var _hoisted_17 = {
  style: {
    "width": "auto"
  }
};
var _hoisted_18 = {
  style: {
    "width": "auto"
  }
};
var _hoisted_19 = {
  "class": "boxchild",
  style: {
    "padding": "0"
  }
};
var _hoisted_20 = {
  id: "bubble",
  "class": "bubble",
  ref: "bubble"
};
var _hoisted_21 = {
  "class": "boxchild flex-between"
};
var _hoisted_22 = {
  style: {
    "width": "auto"
  }
};
var _hoisted_23 = {
  "class": "flex flex-end",
  style: {
    "width": "auto"
  }
};
var _hoisted_24 = {
  "class": "sm-half-L"
};
var _hoisted_25 = {
  "class": "label-S"
};
var _hoisted_26 = {
  "class": "sm-half-L"
};
var _hoisted_27 = {
  "class": "label-S"
};
var _hoisted_28 = {
  "class": "sm-half-L"
};
var _hoisted_29 = {
  "class": "label-S"
};
function render(_ctx, _cache, $props, $setup, $data, $options) {
  var _component_el_color_picker = resolveComponent("el-color-picker");

  var _component_el_slider = resolveComponent("el-slider");

  var _directive_stopdrag = resolveDirective("stopdrag");

  var _directive_drag = resolveDirective("drag");

  return openBlock(), createElementBlock(Fragment, null, [withDirectives((openBlock(), createElementBlock("div", _hoisted_1, [withDirectives((openBlock(), createElementBlock("div", _hoisted_2, [createElementVNode("div", _hoisted_3, [(openBlock(true), createElementBlock(Fragment, null, renderList($setup.config, function (light) {
    return openBlock(), createElementBlock("div", {
      key: light.id,
      "class": normalizeClass(["symbolic-box", {
        'theme-color': light.id === $setup.lightSelectId
      }]),
      onClick: function onClick($event) {
        return $setup.lightSelectId = light.id;
      }
    }, [createElementVNode("span", {
      "class": normalizeClass(["iconfont", light.iconfont])
    }, null, 2
    /* CLASS */
    ), createElementVNode("label", _hoisted_5, toDisplayString(light.lightName), 1
    /* TEXT */
    )], 10
    /* CLASS, PROPS */
    , _hoisted_4);
  }), 128
  /* KEYED_FRAGMENT */
  ))]), createElementVNode("div", _hoisted_6, [createElementVNode("label", _hoisted_7, toDisplayString(_ctx.Resource.lightColor), 1
  /* TEXT */
  ), createVNode(_component_el_color_picker, {
    modelValue: $setup.lightColor,
    "onUpdate:modelValue": _cache[0] || (_cache[0] = function ($event) {
      return $setup.lightColor = $event;
    }),
    size: "mini",
    "show-alpha": "",
    style: {
      "width": "63%"
    }
  }, null, 8
  /* PROPS */
  , ["modelValue"])]), withDirectives(createElementVNode("div", _hoisted_8, [createElementVNode("label", _hoisted_9, toDisplayString(_ctx.Resource.cutoffDistance), 1
  /* TEXT */
  ), createVNode(_component_el_slider, {
    modelValue: $setup.cutoffDistance,
    "onUpdate:modelValue": _cache[1] || (_cache[1] = function ($event) {
      return $setup.cutoffDistance = $event;
    }),
    min: 0,
    max: 500,
    step: 1,
    "input-size": "mini",
    debounce: 500,
    "tooltip-class": "tooltip-class",
    style: {
      "width": "63%"
    }
  }, null, 8
  /* PROPS */
  , ["modelValue"])], 512
  /* NEED_PATCH */
  ), [[vShow, $setup.lightSelectId !== 2]]), withDirectives(createElementVNode("div", _hoisted_10, [createElementVNode("label", _hoisted_11, toDisplayString(_ctx.Resource.lightDecay), 1
  /* TEXT */
  ), createVNode(_component_el_slider, {
    modelValue: $setup.lightDecay,
    "onUpdate:modelValue": _cache[2] || (_cache[2] = function ($event) {
      return $setup.lightDecay = $event;
    }),
    min: 0,
    max: 10,
    step: 0.1,
    "input-size": "mini",
    debounce: 500,
    "tooltip-class": "tooltip-class",
    style: {
      "width": "63%"
    }
  }, null, 8
  /* PROPS */
  , ["modelValue", "step"])], 512
  /* NEED_PATCH */
  ), [[vShow, $setup.lightSelectId !== 2]]), createElementVNode("div", _hoisted_12, [createElementVNode("label", _hoisted_13, toDisplayString(_ctx.Resource.lightIntensity), 1
  /* TEXT */
  ), createVNode(_component_el_slider, {
    modelValue: $setup.lightIntensity,
    "onUpdate:modelValue": _cache[3] || (_cache[3] = function ($event) {
      return $setup.lightIntensity = $event;
    }),
    min: 0,
    max: 10,
    step: 0.1,
    "input-size": "mini",
    debounce: 500,
    "tooltip-class": "tooltip-class",
    style: {
      "width": "63%"
    }
  }, null, 8
  /* PROPS */
  , ["modelValue", "step"])]), withDirectives(createElementVNode("div", _hoisted_14, [createElementVNode("label", _hoisted_15, toDisplayString(_ctx.Resource.spotLightAngle), 1
  /* TEXT */
  ), createVNode(_component_el_slider, {
    modelValue: $setup.spotLightAngle,
    "onUpdate:modelValue": _cache[4] || (_cache[4] = function ($event) {
      return $setup.spotLightAngle = $event;
    }),
    min: 0,
    max: 90,
    step: 1,
    "input-size": "mini",
    debounce: 500,
    "tooltip-class": "tooltip-class",
    style: {
      "width": "63%"
    }
  }, null, 8
  /* PROPS */
  , ["modelValue"])], 512
  /* NEED_PATCH */
  ), [[vShow, $setup.lightSelectId === 1]]), createElementVNode("div", _hoisted_16, [createElementVNode("label", _hoisted_17, [withDirectives(createElementVNode("input", {
    type: "checkbox",
    "onUpdate:modelValue": _cache[5] || (_cache[5] = function ($event) {
      return $setup.visibleModel = $event;
    })
  }, null, 512
  /* NEED_PATCH */
  ), [[vModelCheckbox, $setup.visibleModel]]), createTextVNode(" " + toDisplayString(_ctx.Resource.lightModel), 1
  /* TEXT */
  )]), createElementVNode("label", _hoisted_18, [withDirectives(createElementVNode("input", {
    type: "checkbox",
    "onUpdate:modelValue": _cache[6] || (_cache[6] = function ($event) {
      return $setup.visiblePositions = $event;
    })
  }, null, 512
  /* NEED_PATCH */
  ), [[vModelCheckbox, $setup.visiblePositions]]), createTextVNode(" " + toDisplayString(_ctx.Resource.lightPositions), 1
  /* TEXT */
  )])]), createElementVNode("div", _hoisted_19, [createCommentVNode(" <div class=\"flex flex-start\" style=\"width:56%; align-items: center;\">\r\n          <input checked type=\"checkbox\" style=\"margin-right:10%\" v-model=\"showLight\" />\r\n          <label style=\"width:auto\">显示光源</label>\r\n        </div>"), createElementVNode("button", {
    "class": "tbtn",
    type: "button",
    style: {
      "width": "auto"
    },
    onClick: _cache[7] || (_cache[7] = function () {
      return $setup.addLight && $setup.addLight.apply($setup, arguments);
    })
  }, toDisplayString(_ctx.Resource.add), 1
  /* TEXT */
  ), createElementVNode("button", {
    "class": "tbtn tbtn-margin-left",
    style: {
      "width": "auto"
    },
    type: "button ",
    onClick: _cache[8] || (_cache[8] = function () {
      return $setup.clearLight && $setup.clearLight.apply($setup, arguments);
    })
  }, toDisplayString(_ctx.Resource.clear), 1
  /* TEXT */
  )])])), [[_directive_stopdrag]])])), [[_directive_drag]]), withDirectives(createElementVNode("div", _hoisted_20, [createElementVNode("div", _hoisted_21, [createElementVNode("label", _hoisted_22, toDisplayString(_ctx.Resource.visiblePositions), 1
  /* TEXT */
  ), createElementVNode("div", _hoisted_23, [withDirectives(createElementVNode("i", {
    "class": "el-icon-position",
    title: "停靠",
    style: {
      "margin-right": "8px"
    },
    onClick: _cache[9] || (_cache[9] = function ($event) {
      return $setup.dockBubble(true);
    })
  }, null, 512
  /* NEED_PATCH */
  ), [[vShow, $setup.dockFontShow]]), withDirectives(createElementVNode("i", {
    "class": "el-icon-chat-square",
    title: "悬浮",
    style: {
      "margin-right": "8px"
    },
    onClick: _cache[10] || (_cache[10] = function ($event) {
      return $setup.dockBubble(false);
    })
  }, null, 512
  /* NEED_PATCH */
  ), [[vShow, !$setup.dockFontShow]]), createElementVNode("i", {
    "class": "el-icon-close",
    title: "关闭",
    onClick: _cache[11] || (_cache[11] = function () {
      return $setup.closeBubble && $setup.closeBubble.apply($setup, arguments);
    })
  })])]), createElementVNode("div", _hoisted_24, [createElementVNode("label", _hoisted_25, toDisplayString(_ctx.Resource.longitude), 1
  /* TEXT */
  ), withDirectives(createElementVNode("input", {
    "class": "sm-input-M",
    style: {
      "width": "70%",
      "height": "20px"
    },
    type: "text",
    "onUpdate:modelValue": _cache[12] || (_cache[12] = function ($event) {
      return $setup.modelPosition[0] = $event;
    })
  }, null, 512
  /* NEED_PATCH */
  ), [[vModelText, $setup.modelPosition[0]]])]), createElementVNode("div", _hoisted_26, [createElementVNode("label", _hoisted_27, toDisplayString(_ctx.Resource.latitude), 1
  /* TEXT */
  ), withDirectives(createElementVNode("input", {
    "class": "sm-input-M",
    style: {
      "width": "70%",
      "height": "20px"
    },
    type: "text",
    "onUpdate:modelValue": _cache[13] || (_cache[13] = function ($event) {
      return $setup.modelPosition[1] = $event;
    })
  }, null, 512
  /* NEED_PATCH */
  ), [[vModelText, $setup.modelPosition[1]]])]), createElementVNode("div", _hoisted_28, [createElementVNode("label", _hoisted_29, toDisplayString(_ctx.Resource.altitude), 1
  /* TEXT */
  ), withDirectives(createElementVNode("input", {
    "class": "sm-input-M",
    style: {
      "width": "70%",
      "height": "20px"
    },
    type: "text",
    "onUpdate:modelValue": _cache[14] || (_cache[14] = function ($event) {
      return $setup.modelPosition[2] = $event;
    })
  }, null, 512
  /* NEED_PATCH */
  ), [[vModelText, $setup.modelPosition[2]]])])], 512
  /* NEED_PATCH */
  ), [[vShow, $setup.bubbleShow && $setup.visiblePositions]])], 64
  /* STABLE_FRAGMENT */
  );
}

script.render = render;
script.__file = "src/components/scene/light/light.vue";

script.install = function (app) {
  app.component(script.name, script);
};

export default script;
