import { reactive, toRefs, watch, onBeforeUnmount, resolveDirective, withDirectives, openBlock, createElementBlock, createElementVNode, toDisplayString, createCommentVNode, vModelSelect, normalizeClass, vModelCheckbox, vShow } from 'vue';

function _typeof(obj) {
  "@babel/helpers - typeof";

  if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
    _typeof = function (obj) {
      return typeof obj;
    };
  } else {
    _typeof = function (obj) {
      return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
    };
  }

  return _typeof(obj);
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);

  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    if (enumerableOnly) symbols = symbols.filter(function (sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    });
    keys.push.apply(keys, symbols);
  }

  return keys;
}

function _objectSpread2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};

    if (i % 2) {
      ownKeys(Object(source), true).forEach(function (key) {
        _defineProperty(target, key, source[key]);
      });
    } else if (Object.getOwnPropertyDescriptors) {
      Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
      ownKeys(Object(source)).forEach(function (key) {
        Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
      });
    }
  }

  return target;
}

/*
* 常用工具类
*/
//axios本版本不支持jsonp
var axiosJsonp = function axiosJsonp(url) {
  if (!url) {
    console.error('Axios.JSONP 至少需要一个url参数!');
    return;
  }

  return new Promise(function (resolve, reject) {
    window.jsonCallBack = function (result) {
      resolve(result);
    };

    var JSONP = document.createElement("script");
    JSONP.type = "text/javascript";
    JSONP.src = "".concat(url, "&callback=jsonCallBack");
    document.getElementsByTagName("head")[0].appendChild(JSONP);
    setTimeout(function () {
      document.getElementsByTagName("head")[0].removeChild(JSONP);
    }, 500);
  });
}; //判断两数组或对象相等


var isEqualArr = function isEqualArr(arg1, arg2) {
  if (!arg1 || !arg2) return true;
  var bol = true;

  if (Object.keys(arg1).length != Object.keys(arg2).length) {
    return false;
  }

  for (var key in arg1) {
    if (_typeof(arg1[key]) == 'object') {
      bol = isSame(arg1[key], arg2[key]);

      if (!bol) {
        break;
      }
    } else if (arg1[key] != arg2[key]) {
      bol = false;
      break;
    }
  }

  return bol;
}; //坐标转化
//笛卡尔转经纬度


var CartesiantoDegrees = function CartesiantoDegrees(Cartesians) {
  var array = [].concat(Cartesians);
  var positions = [];

  for (var i = 0, len = array.length; i < len; i++) {
    var cartographic = Cesium.Cartographic.fromCartesian(array[i]);
    var longitude = Cesium.Math.toDegrees(cartographic.longitude);
    var latitude = Cesium.Math.toDegrees(cartographic.latitude);
    var h = cartographic.height;

    if (positions.indexOf(longitude) == -1 && positions.indexOf(latitude) == -1) {
      positions.push(longitude);
      positions.push(latitude);
      positions.push(h);
    }
  }

  return positions;
}; //笛卡尔转经纬度(每个点是独立的对象)


var CartesiantoDegreesObjs = function CartesiantoDegreesObjs(Cartesians) {
  var array = [].concat(Cartesians);
  var positions = [];

  for (var i = 0, len = array.length; i < len; i++) {
    var cartographic = Cesium.Cartographic.fromCartesian(array[i]);
    var obj = {
      longitude: Cesium.Math.toDegrees(cartographic.longitude),
      latitude: Cesium.Math.toDegrees(cartographic.latitude),
      height: cartographic.height
    };
    positions.push(obj);
  }

  return positions;
}; // 弧度转经纬度


var CartographictoDegrees = function CartographictoDegrees(wgsPosition) {
  var longitude = Cesium.Math.toDegrees(wgsPosition.longitude);
  var latitude = Cesium.Math.toDegrees(wgsPosition.latitude);
  var height = wgsPosition.height;
  return [longitude, latitude, height];
}; //去重函数  数组


var unique = function unique(arr) {
  var res = [];
  var json = {};

  for (var i = 0; i < arr.length; i++) {
    if (!json[arr[i]]) {
      res.push(arr[i]);
      json[arr[i]] = 1;
    }
  }

  return res;
}; // 获取渐变色函数


function gradientColors(start, end, steps, gamma) {
  var i,
      j,
      ms,
      me,
      output = [],
      so = [];
  gamma = gamma || 1;

  var normalize = function normalize(channel) {
    return Math.pow(channel / 255, gamma);
  };

  start = parseColor(start).map(normalize);
  end = parseColor(end).map(normalize);

  for (i = 0; i < steps; i++) {
    ms = i / (steps - 1);
    me = 1 - ms;

    for (j = 0; j < 3; j++) {
      so[j] = pad(Math.round(Math.pow(start[j] * me + end[j] * ms, 1 / gamma) * 255).toString(16));
    }

    output.push('#' + so.join(''));
  }

  return output;

  function parseColor(hexStr) {
    return hexStr.length === 4 ? hexStr.substr(1).split('').map(function (s) {
      return 0x11 * parseInt(s, 16);
    }) : [hexStr.substr(1, 2), hexStr.substr(3, 2), hexStr.substr(5, 2)].map(function (s) {
      return parseInt(s, 16);
    });
  }

  function pad(s) {
    return s.length === 1 ? '0' + s : s;
  }
}

function getAngleAndRadian(pointA, pointB) {
  //建立以点A为原点，X轴为east,Y轴为north,Z轴朝上的坐标系
  var transform = Cesium.Transforms.eastNorthUpToFixedFrame(pointA); //向量AB

  var positionvector = Cesium.Cartesian3.subtract(pointB, pointA, new Cesium.Cartesian3()); //因transform是将A为原点的eastNorthUp坐标系中的点转换到世界坐标系的矩阵
  //AB为世界坐标中的向量
  //因此将AB向量转换为A原点坐标系中的向量，需乘以transform的逆矩阵。

  var vector = Cesium.Matrix4.multiplyByPointAsVector(Cesium.Matrix4.inverse(transform, new Cesium.Matrix4()), positionvector, new Cesium.Cartesian3()); //归一化

  var direction = Cesium.Cartesian3.normalize(vector, new Cesium.Cartesian3()); //heading

  var heading1 = Math.atan2(direction.y, direction.x) - Cesium.Math.PI_OVER_TWO;
  var radian = Cesium.Math.TWO_PI - Cesium.Math.zeroToTwoPi(heading1);
  var angle = radian * (180 / Math.PI);

  if (angle < 0) {
    angle = angle + 360;
  }

  return {
    angle: angle,
    radian: radian
  };
}

function getPitch(pointA, pointB) {
  var transfrom = Cesium.Transforms.eastNorthUpToFixedFrame(pointA);
  var vector = Cesium.Cartesian3.subtract(pointB, pointA, new Cesium.Cartesian3());
  var direction = Cesium.Matrix4.multiplyByPointAsVector(Cesium.Matrix4.inverse(transfrom, transfrom), vector, vector);
  Cesium.Cartesian3.normalize(direction, direction); //因为direction已归一化，斜边长度等于1，所以余弦函数等于direction.z

  var radian = Cesium.Math.PI_OVER_TWO - Cesium.Math.acosClamped(direction.z);
  var angle = radian * (180 / Math.PI);

  if (angle < 0) {
    angle = angle + 360;
  }

  return {
    angle: angle,
    radian: radian
  };
}

var tool = {
  axiosJsonp: axiosJsonp,
  isEqualArr: isEqualArr,
  CartesiantoDegrees: CartesiantoDegrees,
  CartesiantoDegreesObjs: CartesiantoDegreesObjs,
  unique: unique,
  gradientColors: gradientColors,
  getAngleAndRadian: getAngleAndRadian,
  CartographictoDegrees: CartographictoDegrees,
  getPitch: getPitch
};

// 组件内部的语言资源：主要包括提示信息
var currentLanguage;
var cookieLanguage = getLang().toLowerCase();

function getLang() {
  //浏览器语言  IE用browserLanguage，非IE使用language进行判断
  var lang = (navigator.language || navigator.browserLanguage).toLowerCase();
  window.lang = lang; //判断portal设置语言 通过cookie获取
  //   const cookies = document.cookie.split(';');
  //   if (cookies.length > 0) {
  //     cookies.forEach(function (cookie) {
  //       const arr = cookie.split('=');
  //       if (arr[0].toLowerCase().trim() === 'language') {
  //         lang = arr[1];
  //         return;
  //       }
  //     });
  //   }

  return lang;
}

if (cookieLanguage !== undefined) {
  currentLanguage = cookieLanguage;
} else {
  currentLanguage = (navigator.language || navigator.browserLanguage).toLowerCase(); // 获取当前浏览器的语言
}

if (currentLanguage.startsWith('zh')) ; else if (currentLanguage.startsWith('ja')) ; else ;

// 创建一个简单的store状态管理

var storeState = reactive({
  isViewer: false,
  //viewer初始化标志
  changeLayers: 0,
  //图层改变加载完毕监听
  changeGeometrys: 0 //三维分析体改变标志

});

function measure(props) {
  // 设置默认值数据
  var state = reactive({
    measureMode: 'Space',
    //测量模式
    clampMode: Cesium.ClampMode.Space,
    //贴地模式
    Ellipsoid: null,
    //椭球选择
    contourColor: '#ff7d00',
    //等高线颜色
    isShowDVH: false,
    //显示等高线界面
    isShowLine: true,
    //显示等高线
    pickPointEnabled: true //开启顶点捕捉

  }); // 初始化数据

  var layers,
      handlerDis,
      handlerArea,
      handlerHeight,
      isoline,
      lineHeight,
      setHypFlag,
      height_0 = 0; // 等高线

  isoline = new Cesium.HypsometricSetting();
  isoline.DisplayMode = Cesium.HypsometricSettingEnum.DisplayMode.LINE;
  var colorTable = new Cesium.ColorTable();
  isoline._lineColor = Cesium.Color.fromCssColorString(state.contourColor);
  isoline.ColorTable = colorTable;
  isoline.Opacity = 0.6;
  isoline.MaxVisibleValue = -100;
  isoline.MinVisibleValue = -100;

  var init = function init() {
    // layers = viewer.scene.layers && viewer.scene.layers.layerQueue;
    viewer.scene.globe.HypsometricSetting = {
      hypsometricSetting: isoline,
      analysisMode: Cesium.HypsometricSettingEnum.AnalysisRegionMode.ARM_ALL
    };

    if (storeState.changeLayers) {
      setHypsometricSetting();
    }

    handlerDis = new Cesium.MeasureHandler(viewer, Cesium.MeasureMode.Distance, state.clampMode);
    handlerArea = new Cesium.MeasureHandler(viewer, Cesium.MeasureMode.Area, state.clampMode);
    handlerHeight = new Cesium.MeasureHandler(viewer, Cesium.MeasureMode.DVH); //初始化测量距离

    handlerDis.activeEvt.addEventListener(function (isActive) {
      if (isActive == true) {
        viewer.enableCursorStyle = false;
        viewer._element.style.cursor = "";
        document.body.classList.add("measureCur");
        viewer.scene.pickPointEnabled = state.pickPointEnabled;
      } else {
        viewer.enableCursorStyle = true;
        document.body.classList.remove("measureCur");
        viewer.scene.pickPointEnabled = false;
      }
    }); //注册测距功能事件

    handlerDis.measureEvt.addEventListener(function (result) {
      var dis = Number(result.distance);
      var mode = state.measureMode;

      if (mode == "CGCS2000" || mode == "XIAN80" || mode == "WGS84") {
        dis = Number(calcClampDistance(result.positions));
      }

      var distance = dis > 1000 ? (dis / 1000).toFixed(2) + "km" : dis.toFixed(2) + "m";
      handlerDis.disLabel.text = "距离:" + distance;
    }); //初始化测量面积

    handlerArea.activeEvt.addEventListener(function (isActive) {
      if (isActive == true) {
        viewer.enableCursorStyle = false;
        viewer._element.style.cursor = "";
        document.body.classList.add("measureCur");
        viewer.scene.pickPointEnabled = state.pickPointEnabled;
      } else {
        viewer.enableCursorStyle = true;
        document.body.classList.remove("measureCur");
        viewer.scene.pickPointEnabled = false;
      }
    });
    handlerArea.measureEvt.addEventListener(function (result) {
      var mj = Number(result.area);
      var mode = state.measureMode;

      if (mode == "CGCS2000" || mode == "XIAN80" || mode == "WGS84") {
        mj = Number(calcClampValue(result.positions));
      } else if (mode == "6") {
        mj = Number(calcAreaWithoutHeight(result.positions));
      }

      var area = mj > 1000000 ? (mj / 1000000).toFixed(2) + "km²" : mj.toFixed(2) + "㎡";
      handlerArea.areaLabel.text = "面积:" + area;
    });
    var point1, point2; //初始化测量高度

    handlerHeight.measureEvt.addEventListener(function (result) {
      var distance = result.distance > 1000 ? (result.distance / 1000).toFixed(2) + "km" : (result.distance / 1).toFixed(2) + "m";
      var vHeight = result.verticalHeight > 1000 ? (result.verticalHeight / 1000).toFixed(2) + "km" : (result.verticalHeight / 1).toFixed(2) + "m";
      var hDistance = result.horizontalDistance > 1000 ? (result.horizontalDistance / 1000).toFixed(2) + "km" : (result.horizontalDistance / 1).toFixed(2) + "m";
      handlerHeight.disLabel.text = "空间距离:" + distance;
      handlerHeight.vLabel.text = "垂直高度:" + vHeight;
      handlerHeight.vLabel.horizontalOrigin = Cesium.HorizontalOrigin.RIGHT;
      handlerHeight.hLabel.text = "水平距离:" + hDistance;
      handlerHeight.hLabel.verticalOrigin = Cesium.VerticalOrigin.BOTTOM; //实时等高线显示

      point1 = Cesium.Cartographic.fromCartesian(result.verticalPositions[0]);
      point2 = Cesium.Cartographic.fromCartesian(result.verticalPositions[1]);
      if (point1.height > point2.height) lineHeight = Number(result.verticalHeight) + height_0;else lineHeight = -Number(result.verticalHeight) + height_0;
      if (state.isShowLine) updateContourLine(lineHeight);
    });
    handlerHeight.activeEvt.addEventListener(function (isActive) {
      if (isActive == true) {
        viewer.enableCursorStyle = false;
        viewer._element.style.cursor = "";
        document.body.classList.add("measureCur");
        viewer.scene.pickPointEnabled = state.pickPointEnabled;
      } else {
        viewer.enableCursorStyle = true;
        document.body.classList.remove("measureCur");
        viewer.scene.pickPointEnabled = false;
      }
    });
  };

  if (storeState.isViewer) {
    init();
  } //viewer 初始化完成的监听


  watch(function () {
    return storeState.isViewer;
  }, function (val) {
    if (val) init();
  }); // 展示解决，加载数据，但是组件先加载的问题。未获取到viewer.scene.layers.layerQueue，需要优化

  setTimeout(function () {
    layers = viewer.scene.layers && viewer.scene.layers.layerQueue;
    console.log('layers', layers);
  }, 5000); //监听图层加载完成

  watch(function () {
    return storeState.changeLayers;
  }, function (val) {
    // setTimeout(() => {
    setHypsometricSetting(); // }, 4000)
  }); // 初始化设置图层等高线

  function setHypsometricSetting() {
    if (!layers) return;

    for (var i = 0; i < layers.length; i++) {
      layers[i].hypsometricSetting = {
        hypsometricSetting: isoline,
        analysisMode: Cesium.HypsometricSettingEnum.AnalysisRegionMode.ARM_ALL
      };
    }

    setHypFlag = true;
  } // 分析
  //椭球贴地距离


  function calcClampDistance(positions) {
    var lonlat = [];

    for (var i = 0; i < positions.length; i++) {
      var cartographic = Cesium.Cartographic.fromCartesian(positions[i]);
      var lon = Cesium.Math.toDegrees(cartographic.longitude);
      var lat = Cesium.Math.toDegrees(cartographic.latitude);
      lonlat.push(lon, lat);
    }

    var gemetry = new Cesium.PolylineGeometry({
      positions: Cesium.Cartesian3.fromDegreesArray(lonlat)
    });
    return scene.globe.computeSurfaceDistance(gemetry, state.Ellipsoid);
  }

  function calcClampValue(positions) {
    var lonlat = [];

    for (var i = 0; i < positions.length; i++) {
      var cartographic = Cesium.Cartographic.fromCartesian(positions[i]);
      var lon = Cesium.Math.toDegrees(cartographic.longitude);
      var lat = Cesium.Math.toDegrees(cartographic.latitude);
      lonlat.push(lon, lat);
    }

    var gemetry = new Cesium.PolygonGeometry.fromPositions({
      positions: Cesium.Cartesian3.fromDegreesArray(lonlat)
    });
    return scene.globe.computeSurfaceArea(gemetry, state.Ellipsoid);
  }

  function calcAreaWithoutHeight(positions) {
    var totalLon = 0;

    for (var i = 0; i < positions.length; i++) {
      var cartographic = Cesium.Cartographic.fromCartesian(positions[i]);
      var lon = Cesium.Math.toDegrees(cartographic.longitude);
      totalLon += lon;
    }

    var dh = Math.round((totalLon / positions.length + 6) / 6); //带号

    var centralMeridian = dh * 6 - 3; //高斯投影

    var projection = new Cesium.CustomProjection({
      name: "tmerc",
      centralMeridian: centralMeridian,
      primeMeridian: 0,
      standardParallel_1: 0,
      standardParallel_2: 0,
      eastFalse: 500000.0,
      northFalse: 0.0,
      semimajorAxis: 6378137,
      inverseFlattening: 298.257222101
    });
    var cartesians = [];

    for (var _i = 0; _i < positions.length; _i++) {
      var _cartographic = Cesium.Cartographic.fromCartesian(positions[_i]);

      var cartesian = projection.project(_cartographic);
      cartesians.push(cartesian);
    }

    cartesians.push(cartesians[0]); //首尾相接

    var value = Cesium.getPreciseArea(cartesians, "China2000", centralMeridian, dh, 1);
    return value;
  }

  function updateContourLine(height) {
    viewer.scene.globe.HypsometricSetting.hypsometricSetting.MaxVisibleValue = height;
    viewer.scene.globe.HypsometricSetting.hypsometricSetting.MinVisibleValue = height;
    if (!setHypFlag) return;

    for (var i = 0; i < layers.length; i++) {
      if (layers[i].hypsometricSetting.hypsometricSetting) {
        layers[i].hypsometricSetting.hypsometricSetting.MaxVisibleValue = height;
        layers[i].hypsometricSetting.hypsometricSetting.MinVisibleValue = height;
      } else {
        setHypsometricSetting();
      }
    }
  }

  function distanceClk() {
    deactiveAll();
    handlerDis && handlerDis.activate();
  }

  function areaClk() {
    deactiveAll();
    handlerArea && handlerArea.activate();
  }

  function heightClk() {
    if (!setHypFlag) setHypsometricSetting();
    clearLine(); //鼠标左键事件监听

    viewer.eventManager.addEventListener("CLICK", measureHeightClk, true);
    deactiveAll();
    state.isShowDVH = true;
    handlerHeight && handlerHeight.activate();
  }

  function measureHeightClk(e) {
    var position = scene.pickPosition(e.message.position);
    var p = tool.CartesiantoDegrees(position); // 将获取的点的位置转化成经纬度

    height_0 = p[2];
  } // 清除


  function clearAll() {
    deactiveAll();
    handlerDis && handlerDis.clear();
    handlerArea && handlerArea.clear();
    handlerHeight && handlerHeight.clear();
    clearLine();
  }

  function clearLine() {
    updateContourLine(-10000);
    viewer.eventManager.removeEventListener("CLICK", measureHeightClk); //移除鼠标点击事件监听
  }

  function deactiveAll() {
    if (!handlerDis) init();
    handlerDis && handlerDis.deactivate();
    handlerArea && handlerArea.deactivate();
    handlerHeight && handlerHeight.deactivate();
    state.isShowDVH = false;
    state.Ellipsoid = null;
    lineHeight = -10000;
  }

  function clear() {
    clearAll();
    viewer.scene.pickPointEnabled = false;
  }

  watch(function () {
    return state.isShowLine;
  }, function (val) {
    if (!val) {
      updateContourLine(-10000);
    } else {
      updateContourLine(lineHeight);
    }
  });
  watch(function () {
    return state.pickPointEnabled;
  }, function (val) {
    viewer.scene.pickPointEnabled = val;
  });
  watch(function () {
    return state.measureMode;
  }, function (val) {
    if (val == "Space") {
      state.clampMode = Cesium.ClampMode.Space;
      handlerArea.clampMode = Cesium.ClampMode.Space;
      handlerDis.clampMode = Cesium.ClampMode.Space;
    } else {
      state.clampMode = Cesium.ClampMode.Ground;
      handlerArea.clampMode = Cesium.ClampMode.Ground;
      handlerDis.clampMode = Cesium.ClampMode.Ground;

      if (val == "XIAN80") {
        state.Ellipsoid = Cesium.Ellipsoid.XIAN80;
      } else if (val == "CGCS2000") {
        state.Ellipsoid = Cesium.Ellipsoid.CGCS2000;
      } else if (val == "WGS84") {
        state.Ellipsoid = Cesium.Ellipsoid.WGS84;
      } else {
        state.Ellipsoid = null;
      }
    }
  }); // 销毁

  onBeforeUnmount(function () {
    isoline.destroy();
    layers = undefined;
  });
  return _objectSpread2(_objectSpread2({}, toRefs(state)), {}, {
    distanceClk: distanceClk,
    areaClk: areaClk,
    heightClk: heightClk,
    clear: clear
  });
}

var script = {
  name: "Sm3dMeasure",
  setup: function setup(props) {
    var _measure = measure(),
        measureMode = _measure.measureMode,
        isShowDVH = _measure.isShowDVH,
        interval = _measure.interval,
        isShowLine = _measure.isShowLine,
        distanceClk = _measure.distanceClk,
        areaClk = _measure.areaClk,
        heightClk = _measure.heightClk,
        clear = _measure.clear;

    return {
      measureMode: measureMode,
      //测量模式
      isShowDVH: isShowDVH,
      //显示勾选界面
      interval: interval,
      //等值线距
      isShowLine: isShowLine,
      //显示等高线
      distanceClk: distanceClk,
      areaClk: areaClk,
      heightClk: heightClk,
      clear: clear
    };
  }
};

var _hoisted_1 = {
  id: "measure-panel",
  "class": "sm-panel"
};
var _hoisted_2 = {
  "class": "sm-function-module-sub-section",
  style: {
    "margin": "0"
  }
};
var _hoisted_3 = {
  "class": "sm-half-L"
};
var _hoisted_4 = {
  "class": "label-S"
};
var _hoisted_5 = {
  selected: "",
  value: "Space"
};
var _hoisted_6 = {
  value: "Ground"
};

var _hoisted_7 = /*#__PURE__*/createElementVNode("option", {
  selected: "",
  value: "CGCS2000"
}, "CGCS2000", -1
/* HOISTED */
);

var _hoisted_8 = /*#__PURE__*/createElementVNode("option", {
  value: "XIAN80"
}, "XIAN80", -1
/* HOISTED */
);

var _hoisted_9 = /*#__PURE__*/createElementVNode("option", {
  value: "WGS84"
}, "WGS84", -1
/* HOISTED */
);

var _hoisted_10 = {
  value: "null"
};
var _hoisted_11 = ["title", "disabled"];

var _hoisted_12 = /*#__PURE__*/createElementVNode("span", {
  "class": "iconfont iconkongjianjuli"
}, null, -1
/* HOISTED */
);

var _hoisted_13 = [_hoisted_12];
var _hoisted_14 = ["title", "disabled"];

var _hoisted_15 = /*#__PURE__*/createElementVNode("span", {
  "class": "iconfont icongaoduceliang"
}, null, -1
/* HOISTED */
);

var _hoisted_16 = [_hoisted_15];
var _hoisted_17 = ["title"];

var _hoisted_18 = /*#__PURE__*/createElementVNode("span", {
  "class": "iconfont iconkongjianmianji"
}, null, -1
/* HOISTED */
);

var _hoisted_19 = [_hoisted_18];
var _hoisted_20 = ["title"];

var _hoisted_21 = /*#__PURE__*/createElementVNode("span", {
  "class": "iconfont iconqingchu"
}, null, -1
/* HOISTED */
);

var _hoisted_22 = [_hoisted_21];
var _hoisted_23 = {
  "class": "sm-half-L flex-start",
  style: {
    "margin-top": "6px"
  }
};
var _hoisted_24 = {
  style: {
    "margin-left": "10%"
  }
};
function render(_ctx, _cache, $props, $setup, $data, $options) {
  var _directive_stopdrag = resolveDirective("stopdrag");

  var _directive_drag = resolveDirective("drag");

  return withDirectives((openBlock(), createElementBlock("div", _hoisted_1, [withDirectives((openBlock(), createElementBlock("div", _hoisted_2, [createElementVNode("div", _hoisted_3, [createElementVNode("label", _hoisted_4, toDisplayString(_ctx.Resource.selectMode), 1
  /* TEXT */
  ), withDirectives(createElementVNode("select", {
    "class": "sm-select-m",
    "onUpdate:modelValue": _cache[0] || (_cache[0] = function ($event) {
      return $setup.measureMode = $event;
    })
  }, [createElementVNode("option", _hoisted_5, toDisplayString(_ctx.Resource.measureSpace), 1
  /* TEXT */
  ), createElementVNode("option", _hoisted_6, toDisplayString(_ctx.Resource.measureGround), 1
  /* TEXT */
  ), _hoisted_7, _hoisted_8, _hoisted_9, createElementVNode("option", _hoisted_10, toDisplayString(_ctx.Resource.planeProjection), 1
  /* TEXT */
  ), createCommentVNode(" <option value=\"2\">+ Resource.skylinesectorbody +</option> // 需要iServer910支持 ")], 512
  /* NEED_PATCH */
  ), [[vModelSelect, $setup.measureMode]])]), createElementVNode("button", {
    onClick: _cache[1] || (_cache[1] = function () {
      return $setup.distanceClk && $setup.distanceClk.apply($setup, arguments);
    }),
    "class": normalizeClass(["sm-btn", $setup.measureMode === 'null' ? 'pointer-events' : '']),
    id: "distance",
    title: _ctx.Resource.measureDistance,
    type: "button",
    disabled: $setup.measureMode === 'null'
  }, _hoisted_13, 10
  /* CLASS, PROPS */
  , _hoisted_11), createElementVNode("button", {
    onClick: _cache[2] || (_cache[2] = function () {
      return $setup.heightClk && $setup.heightClk.apply($setup, arguments);
    }),
    "class": normalizeClass(["sm-btn", $setup.measureMode != 'Space' && $setup.measureMode != 'Ground' ? 'pointer-events' : '']),
    id: "height",
    title: _ctx.Resource.measureHeight,
    type: "button",
    disabled: $setup.measureMode != 'Space' && $setup.measureMode != 'Ground'
  }, _hoisted_16, 10
  /* CLASS, PROPS */
  , _hoisted_14), createElementVNode("button", {
    onClick: _cache[3] || (_cache[3] = function () {
      return $setup.areaClk && $setup.areaClk.apply($setup, arguments);
    }),
    "class": "sm-btn",
    id: "area",
    title: _ctx.Resource.measureSurface,
    type: "button"
  }, _hoisted_19, 8
  /* PROPS */
  , _hoisted_17), createElementVNode("button", {
    onClick: _cache[4] || (_cache[4] = function () {
      return $setup.clear && $setup.clear.apply($setup, arguments);
    }),
    "class": "sm-btn",
    id: "clear",
    title: _ctx.Resource.clear,
    type: "button"
  }, _hoisted_22, 8
  /* PROPS */
  , _hoisted_20), withDirectives(createElementVNode("div", _hoisted_23, [withDirectives(createElementVNode("input", {
    checked: "",
    id: "showLine",
    style: {
      "margin-left": "6px"
    },
    type: "checkbox",
    "onUpdate:modelValue": _cache[5] || (_cache[5] = function ($event) {
      return $setup.isShowLine = $event;
    })
  }, null, 512
  /* NEED_PATCH */
  ), [[vModelCheckbox, $setup.isShowLine]]), createElementVNode("span", _hoisted_24, toDisplayString(_ctx.Resource.showContour), 1
  /* TEXT */
  )], 512
  /* NEED_PATCH */
  ), [[vShow, $setup.isShowDVH]])])), [[_directive_stopdrag]])])), [[_directive_drag]]);
}

script.render = render;
script.__file = "src/components/analysis_3d/measure/measure.vue";

script.install = function (app) {
  app.component(script.name, script);
};

export default script;
