import { reactive, toRefs, ref, watch, onBeforeUnmount, resolveComponent, resolveDirective, openBlock, createElementBlock, Fragment, withDirectives, createElementVNode, renderList, toDisplayString, vShow, vModelSelect, createVNode, vModelCheckbox, vModelText, createTextVNode } from 'vue';

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);

  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    if (enumerableOnly) symbols = symbols.filter(function (sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    });
    keys.push.apply(keys, symbols);
  }

  return keys;
}

function _objectSpread2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};

    if (i % 2) {
      ownKeys(Object(source), true).forEach(function (key) {
        _defineProperty(target, key, source[key]);
      });
    } else if (Object.getOwnPropertyDescriptors) {
      Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
      ownKeys(Object(source)).forEach(function (key) {
        Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
      });
    }
  }

  return target;
}

// 组件内部的语言资源：主要包括提示信息
var currentLanguage;
var cookieLanguage = getLang().toLowerCase();

function getLang() {
  //浏览器语言  IE用browserLanguage，非IE使用language进行判断
  var lang = (navigator.language || navigator.browserLanguage).toLowerCase();
  window.lang = lang; //判断portal设置语言 通过cookie获取
  //   const cookies = document.cookie.split(';');
  //   if (cookies.length > 0) {
  //     cookies.forEach(function (cookie) {
  //       const arr = cookie.split('=');
  //       if (arr[0].toLowerCase().trim() === 'language') {
  //         lang = arr[1];
  //         return;
  //       }
  //     });
  //   }

  return lang;
}

if (cookieLanguage !== undefined) {
  currentLanguage = cookieLanguage;
} else {
  currentLanguage = (navigator.language || navigator.browserLanguage).toLowerCase(); // 获取当前浏览器的语言
}

if (currentLanguage.startsWith('zh')) ; else if (currentLanguage.startsWith('ja')) ; else ;

// 创建一个简单的store状态管理

var storeState = reactive({
  isViewer: false,
  //viewer初始化标志
  changeLayers: 0,
  //图层改变加载完毕监听
  changeGeometrys: 0 //三维分析体改变标志

});

function mvtlayerStyle(props) {
  // 设置默认值数据
  var state = reactive({
    layerNames: [],
    //当前存在的可选择mvt图层
    selectedLayerIndex: 'none',
    //默认选择图层名称
    childLayerNames: [],
    //子图层
    selectedChildLayerIndex: 'none',
    //默认子图层选择
    mvtAlpha: 1,
    //透明度
    showLayer: true,
    //显隐图层
    textAvoidance: true,
    //文字避让
    openFilter: false,
    propertyKeys: [],
    //子图层属性数组
    symbols: [],
    //符号数组
    clickGetFeature: {
      layer: {
        id: null
      },
      id: null
    },
    //点击查询属性
    isClickShowProperty: true,
    //是否点击显示要素
    dockFontShow: true,
    //停靠图标显示
    bubbleShow: false,
    //悬浮窗口显示
    selectedPropertyKeys: [''],
    //下拉选择属性
    selectedSymbols: [''],
    //下拉选择符号
    inputPropertys: [''],
    //输入框属性
    inputSymbols: [''],
    //输入框符号
    inputValues: [''] //输入框值

  }); // 初始化数据

  var mvtLayers, selectedLayer, selectedChildLayer;
  var saveOldPropertyStates = [];
  var isFilter = false;
  var bubble = ref(null);
  state.symbols = ['!', '!=', '>', '>=', '<', '<=', '==', 'in', 'like', '!like', 'left', 'right'];

  if (storeState.isViewer) {
    setTimeout(function () {
      return getLayerNames();
    }, 500);
  } //viewer 初始化完成的监听


  watch(function () {
    return storeState.isViewer;
  }, function (val) {
    getLayerNames();
  }); //监听图层加载完成

  watch(function () {
    return storeState.changeLayers;
  }, function (val) {
    getLayerNames();
  }); //初始化图层

  function getLayerNames() {
    mvtLayers = viewer.scene._vectorTileMaps._layerQueue;

    if (mvtLayers && mvtLayers.length > 0) {
      mvtLayers.forEach(function (element, index) {
        if (!state.layerNames.includes(element.name)) {
          state.layerNames.push(element.name);
        }
      });
      console.log('init');

      if (state.selectedLayerIndex = 'none') {
        state.selectedLayerIndex = 0;
      }
    } else {
      state.selectedLayerIndex = 'none';
    }

    viewer.eventManager.addEventListener("CLICK", clickShowProperty, true);
  } // 分析
  // 增行删行


  function addCondition(flag) {
    if (!flag) {
      state.selectedPropertyKeys = deletelast(state.selectedPropertyKeys);
      state.selectedSymbols = deletelast(state.selectedSymbols);
      state.inputSymbols = deletelast(state.inputSymbols);
      state.inputPropertys = deletelast(state.inputPropertys);
      state.inputValues = deletelast(state.inputValues);
      return;
    }

    state.selectedPropertyKeys = state.selectedPropertyKeys.concat(['']);
    state.selectedSymbols = state.selectedSymbols.concat(['']);
    state.inputSymbols = state.inputSymbols.concat(['']);
    state.inputPropertys = state.inputPropertys.concat(['']);
    state.inputValues = state.inputValues.concat(['']);
  }

  function deletelast(arr) {
    return arr.slice(0, arr.length - 1);
  } // 获取过滤条件


  function getFilter() {
    if (state.inputPropertys[0] == '') return false;
    var filterArr = ['any'];
    state.inputPropertys.forEach(function (pro, i) {
      var arr = [];
      arr[0] = state.inputSymbols[i];
      arr[1] = pro;
      arr[2] = state.inputValues[i];
      if (typeof Number(arr[2]) == 'number') arr[2] = Number(arr[2]);
      filterArr.push(arr);
    });
    if (filterArr.length < 2) return false;
    return filterArr;
  } // 查询功能


  function propertySearch() {
    var filter = getFilter();

    if (filter) {
      setHighlightLayer(filter);
    }
  }

  var highlightLayer; // 设置查询高亮图层

  function setHighlightLayer(filter) {
    if (highlightLayer) clearSearch();
    if (!selectedChildLayer) return;
    var highlightLayerID = selectedChildLayer.id + "_highlight"; // var highlightLayer = highlightLayers[highlightLayerID];

    if (!highlightLayer) {
      highlightLayer = Cesium.clone(selectedChildLayer, true);
      highlightLayer.id = highlightLayerID;

      if (selectedChildLayer.type == "line") {
        // 线
        highlightLayer.paint["line-color"] = "rgba(0,255,255,1.00)";
      } else if (selectedChildLayer.type == "fill") {
        // 面
        highlightLayer.paint["fill-color"] = "rgba(0,255,255,1.00)";
      } else {
        highlightLayer.paint["text-color"] = "rgba(255,0,0,1.00)";
      }

      highlightLayer.layout['visibility'] = 'visible';
      highlightLayer.minzoom = 3;
      selectedLayer.addLayer(highlightLayer); // 设置过滤条件

      selectedLayer.setFilter(highlightLayer.id, filter);
    }
  } // 开始过滤


  function propertyFilter() {
    var filter = getFilter();
    isFilter = true;
    if (!selectedLayer) return;
    selectedLayer.mapboxStyle.layers.forEach(function (ly) {
      selectedLayer.setLayoutProperty(ly.id, 'visibility', 'none'); //隐藏图层
    });
    selectedLayer.setLayoutProperty(selectedChildLayer.id, 'visibility', 'visible'); //隐藏某个图层

    if (filter) selectedLayer.setFilter(selectedChildLayer.id, filter);
  } // 点击显示属性


  function clickShowProperty(e) {
    var selectedEntity = viewer.scene.pick(e.message.position) || viewer.selectedEntity;

    if (!Cesium.defined(selectedEntity) || !Cesium.defined(selectedEntity.pickResult)) {
      state.bubbleShow = false;
      return;
    }

    var cha = document.body.clientWidth - e.message.position.x;
    if (cha >= 300) bubble.value.style.left = e.message.position.x + 'px';else bubble.value.style.left = e.message.position.x - 250 + 'px';
    bubble.value.style.top = e.message.position.y - 220 + 'px';
    state.bubbleShow = true;
    var obj = null;

    for (var key in selectedEntity.pickResult) {
      obj = selectedEntity.pickResult[key];
      break;
    }

    var feature = obj[0].feature;
    if (feature) state.clickGetFeature = feature;
    console.log(feature);
  } // 删除查询函数


  function clearSearch() {
    // viewer.scene.removeVectorTilesMap(mvtLayers[index].name);
    if (!highlightLayer) return;
    selectedLayer.removeLayer(highlightLayer.id);
    highlightLayer = null;
  }

  function clearFilter() {
    if (!isFilter) return;
    selectedLayer.mapboxStyle.layers.forEach(function (ly, index) {
      selectedLayer.setLayoutProperty(ly.id, 'visibility', saveOldPropertyStates[index]); //隐藏某个图层
    });
    selectedLayer.setFilter(selectedChildLayer.id, null);
    selectedLayer.refresh();
    isFilter = false;
  }

  function clear() {
    clearSearch();
    clearFilter();
  } //关闭气泡


  function closeBubble() {
    state.bubbleShow = false;
  } //悬停气泡


  function dockBubble(val) {
    if (val) {
      bubble.value.classList.add('bubbleDock');
      state.dockFontShow = false;
    } else {
      bubble.value.classList.remove('bubbleDock');
      state.dockFontShow = true;
    }
  }

  watch(function () {
    return state.selectedLayerIndex;
  }, function (val) {
    if (val === 'none') return;
    saveOldPropertyStates.length = 0;
    selectedLayer = mvtLayers[val];
    state.showLayer = selectedLayer.show;
    selectedLayer.readyPromise.then(function (res) {
      if (res) {
        selectedLayer.mapboxStyle.layers.forEach(function (layer, index) {
          if (!state.childLayerNames.includes(layer.id)) {
            state.childLayerNames.push(layer.id);
          }

          var visible = selectedLayer.getLayoutProperty(layer.id, 'visibility');
          saveOldPropertyStates.push(visible);
        });
        state.selectedChildLayerIndex = 0;
      }
    });
  });
  watch(function () {
    return state.selectedChildLayerIndex;
  }, function (val) {
    selectedChildLayer = selectedLayer.mapboxStyle.layers[val];
    var features = selectedLayer.querySourceFeatures({
      sourceLayer: selectedChildLayer.id,
      filter: ["<", "$id", 10]
    });

    if (features.length == 0) {
      state.propertyKeys = [];
    } else {
      state.propertyKeys = features[0]._keys.length > 0 ? features[0]._keys : [];
    }
  });
  watch(function () {
    return state.mvtAlpha;
  }, function (val) {
    if (selectedLayer) selectedLayer.alpha = Number(val);
  });
  watch(function () {
    return state.showLayer;
  }, function (val) {
    if (selectedLayer) selectedLayer.show = val;
  });
  watch(function () {
    return state.textAvoidance;
  }, function (val) {
    if (!selectedLayer) return;
    var layers = selectedLayer.mapboxStyle.layers;

    for (var i = 0; i < layers.length; i++) {
      layers[i].isOverlapDisplayed = val;
    }
  });
  watch(function () {
    return state.isClickShowProperty;
  }, function (val) {
    if (val) {
      viewer.eventManager.addEventListener("CLICK", clickShowProperty, true);
      state.bubbleShow = true;
      return;
    }

    viewer.eventManager.removeEventListener("CLICK", clickShowProperty); //移除鼠标点击事件监听

    state.bubbleShow = false;
  });
  watch(function () {
    return state.selectedPropertyKeys;
  }, function (val, old) {
    if (val.length !== old.length) return;
    val.forEach(function (spro, i) {
      state.inputPropertys[i] = spro;
    });
  }, {
    deep: true
  });
  watch(function () {
    return state.selectedSymbols;
  }, function (val, old) {
    if (val.length !== old.length) return;
    val.forEach(function (ssym, i) {
      if (ssym === 'left' || ssym === 'right') {
        if (state.inputPropertys[i] !== '' && !state.inputPropertys[i].includes('left(') && !state.inputPropertys[i].includes('right(')) {
          state.inputPropertys[i] = ssym + '(' + state.inputPropertys[i] + ',' + 2 + ')';
          return;
        }

        state.inputPropertys[i] = ssym + '()';
        return;
      }

      state.inputSymbols[i] = ssym;
    });
  }, {
    deep: true
  }); // 销毁

  onBeforeUnmount(function () {
    mvtLayers = null;
    selectedLayer = null;
    selectedChildLayer = null;
  });
  return _objectSpread2(_objectSpread2({}, toRefs(state)), {}, {
    addCondition: addCondition,
    propertySearch: propertySearch,
    propertyFilter: propertyFilter,
    clear: clear,
    bubble: bubble,
    closeBubble: closeBubble,
    dockBubble: dockBubble
  });
}

var script = {
  name: "Sm3dMvtlayerStyle",
  setup: function setup(props) {
    var _mvtlayerStyle = mvtlayerStyle(),
        layerNames = _mvtlayerStyle.layerNames,
        selectedLayerIndex = _mvtlayerStyle.selectedLayerIndex,
        childLayerNames = _mvtlayerStyle.childLayerNames,
        selectedChildLayerIndex = _mvtlayerStyle.selectedChildLayerIndex,
        mvtAlpha = _mvtlayerStyle.mvtAlpha,
        showLayer = _mvtlayerStyle.showLayer,
        textAvoidance = _mvtlayerStyle.textAvoidance,
        propertyKeys = _mvtlayerStyle.propertyKeys,
        symbols = _mvtlayerStyle.symbols,
        openFilter = _mvtlayerStyle.openFilter,
        propertySearch = _mvtlayerStyle.propertySearch,
        propertyFilter = _mvtlayerStyle.propertyFilter,
        clear = _mvtlayerStyle.clear,
        isClickShowProperty = _mvtlayerStyle.isClickShowProperty,
        clickGetFeature = _mvtlayerStyle.clickGetFeature,
        bubble = _mvtlayerStyle.bubble,
        closeBubble = _mvtlayerStyle.closeBubble,
        dockBubble = _mvtlayerStyle.dockBubble,
        dockFontShow = _mvtlayerStyle.dockFontShow,
        bubbleShow = _mvtlayerStyle.bubbleShow,
        selectedPropertyKeys = _mvtlayerStyle.selectedPropertyKeys,
        selectedSymbols = _mvtlayerStyle.selectedSymbols,
        inputPropertys = _mvtlayerStyle.inputPropertys,
        inputSymbols = _mvtlayerStyle.inputSymbols,
        inputValues = _mvtlayerStyle.inputValues,
        addCondition = _mvtlayerStyle.addCondition;

    return {
      layerNames: layerNames,
      selectedLayerIndex: selectedLayerIndex,
      childLayerNames: childLayerNames,
      selectedChildLayerIndex: selectedChildLayerIndex,
      mvtAlpha: mvtAlpha,
      showLayer: showLayer,
      textAvoidance: textAvoidance,
      propertyKeys: propertyKeys,
      symbols: symbols,
      openFilter: openFilter,
      propertySearch: propertySearch,
      propertyFilter: propertyFilter,
      clear: clear,
      isClickShowProperty: isClickShowProperty,
      clickGetFeature: clickGetFeature,
      bubble: bubble,
      closeBubble: closeBubble,
      dockBubble: dockBubble,
      dockFontShow: dockFontShow,
      bubbleShow: bubbleShow,
      selectedPropertyKeys: selectedPropertyKeys,
      selectedSymbols: selectedSymbols,
      inputPropertys: inputPropertys,
      inputSymbols: inputSymbols,
      inputValues: inputValues,
      addCondition: addCondition
    };
  }
};

var _hoisted_1 = {
  id: "mvtlayer-panel",
  "class": "sm-panel"
};
var _hoisted_2 = {
  "class": "sm-function-module-sub-section",
  style: {
    "margin": "0"
  }
};
var _hoisted_3 = {
  "class": "sm-half-L"
};

var _hoisted_4 = /*#__PURE__*/createElementVNode("label", {
  style: {
    "width": "28%"
  }
}, "选择图层", -1
/* HOISTED */
);

var _hoisted_5 = ["value"];
var _hoisted_6 = {
  value: "none"
};
var _hoisted_7 = {
  "class": "sm-half-L"
};

var _hoisted_8 = /*#__PURE__*/createElementVNode("label", {
  style: {
    "width": "28%"
  }
}, "透明度", -1
/* HOISTED */
);

var _hoisted_9 = {
  "class": "sm-half-L"
};
var _hoisted_10 = {
  style: {
    "width": "auto"
  }
};

var _hoisted_11 = /*#__PURE__*/createTextVNode("图层显隐 ");

var _hoisted_12 = {
  style: {
    "width": "auto"
  }
};

var _hoisted_13 = /*#__PURE__*/createTextVNode("文字避让 ");

var _hoisted_14 = {
  style: {
    "width": "auto"
  }
};

var _hoisted_15 = /*#__PURE__*/createTextVNode("图层属性 ");

var _hoisted_16 = {
  style: {
    "width": "auto"
  }
};

var _hoisted_17 = /*#__PURE__*/createTextVNode("查询过滤 ");

var _hoisted_18 = {
  style: {
    "width": "100%"
  }
};
var _hoisted_19 = {
  "class": "sm-half-L",
  style: {
    "margin-top": "5px"
  }
};

var _hoisted_20 = /*#__PURE__*/createElementVNode("label", {
  style: {
    "width": "28%"
  }
}, "选择子图层", -1
/* HOISTED */
);

var _hoisted_21 = ["value"];
var _hoisted_22 = {
  "class": "sm-half-L",
  style: {
    "padding": "6px 0 6px 0"
  }
};

var _hoisted_23 = /*#__PURE__*/createElementVNode("label", {
  style: {
    "width": "28%"
  }
}, "设置条件", -1
/* HOISTED */
);

var _hoisted_24 = {
  "class": "sm-half-L"
};
var _hoisted_25 = {
  "class": "tab tab2"
};

var _hoisted_26 = /*#__PURE__*/createElementVNode("tr", null, [/*#__PURE__*/createElementVNode("th", null, "属性"), /*#__PURE__*/createElementVNode("th", null, "条件"), /*#__PURE__*/createElementVNode("th", null, "值")], -1
/* HOISTED */
);

var _hoisted_27 = {
  style: {
    "position": "relative"
  }
};
var _hoisted_28 = ["onUpdate:modelValue"];
var _hoisted_29 = ["value"];
var _hoisted_30 = ["onUpdate:modelValue"];
var _hoisted_31 = {
  style: {
    "position": "relative"
  }
};
var _hoisted_32 = ["onUpdate:modelValue"];
var _hoisted_33 = ["value"];
var _hoisted_34 = ["onUpdate:modelValue"];
var _hoisted_35 = ["onUpdate:modelValue"];
var _hoisted_36 = {
  "class": "boxchild"
};
var _hoisted_37 = {
  id: "mvtlayer-drop-left-panel",
  "class": "sm-panel"
};
var _hoisted_38 = {
  id: "bubble",
  "class": "bubble-tabel",
  ref: "bubble"
};
var _hoisted_39 = {
  "class": "boxchild flex-between"
};

var _hoisted_40 = /*#__PURE__*/createElementVNode("label", {
  style: {
    "width": "auto"
  }
}, "对象属性", -1
/* HOISTED */
);

var _hoisted_41 = {
  "class": "flex flex-end",
  style: {
    "width": "auto"
  }
};
var _hoisted_42 = {
  "class": "tab"
};

var _hoisted_43 = /*#__PURE__*/createElementVNode("tr", null, [/*#__PURE__*/createElementVNode("th", null, "属性"), /*#__PURE__*/createElementVNode("th", null, "值")], -1
/* HOISTED */
);

var _hoisted_44 = /*#__PURE__*/createElementVNode("td", null, "图层", -1
/* HOISTED */
);

var _hoisted_45 = /*#__PURE__*/createElementVNode("td", null, "$id", -1
/* HOISTED */
);

function render(_ctx, _cache, $props, $setup, $data, $options) {
  var _component_el_slider = resolveComponent("el-slider");

  var _directive_stopdrag = resolveDirective("stopdrag");

  var _directive_drag = resolveDirective("drag");

  return openBlock(), createElementBlock(Fragment, null, [withDirectives((openBlock(), createElementBlock("div", _hoisted_1, [withDirectives((openBlock(), createElementBlock("div", _hoisted_2, [createElementVNode("div", _hoisted_3, [_hoisted_4, withDirectives(createElementVNode("select", {
    "class": "sm-select",
    style: {
      "width": "70%"
    },
    "onUpdate:modelValue": _cache[0] || (_cache[0] = function ($event) {
      return $setup.selectedLayerIndex = $event;
    })
  }, [(openBlock(true), createElementBlock(Fragment, null, renderList($setup.layerNames, function (layer, index) {
    return openBlock(), createElementBlock("option", {
      key: index,
      value: index
    }, toDisplayString(layer), 9
    /* TEXT, PROPS */
    , _hoisted_5);
  }), 128
  /* KEYED_FRAGMENT */
  )), withDirectives(createElementVNode("option", _hoisted_6, "暂无mvt图层", 512
  /* NEED_PATCH */
  ), [[vShow, $setup.layerNames.length == 0]])], 512
  /* NEED_PATCH */
  ), [[vModelSelect, $setup.selectedLayerIndex]])]), createElementVNode("div", _hoisted_7, [_hoisted_8, createVNode(_component_el_slider, {
    modelValue: $setup.mvtAlpha,
    "onUpdate:modelValue": _cache[1] || (_cache[1] = function ($event) {
      return $setup.mvtAlpha = $event;
    }),
    min: 0,
    max: 1,
    step: 0.05,
    "input-size": "mini",
    debounce: 500,
    "tooltip-class": "tooltip-class",
    style: {
      "width": "70%"
    }
  }, null, 8
  /* PROPS */
  , ["modelValue", "step"])]), createElementVNode("div", _hoisted_9, [createElementVNode("label", _hoisted_10, [withDirectives(createElementVNode("input", {
    type: "checkbox",
    "onUpdate:modelValue": _cache[2] || (_cache[2] = function ($event) {
      return $setup.showLayer = $event;
    })
  }, null, 512
  /* NEED_PATCH */
  ), [[vModelCheckbox, $setup.showLayer]]), _hoisted_11]), createElementVNode("label", _hoisted_12, [withDirectives(createElementVNode("input", {
    type: "checkbox",
    "onUpdate:modelValue": _cache[3] || (_cache[3] = function ($event) {
      return $setup.textAvoidance = $event;
    })
  }, null, 512
  /* NEED_PATCH */
  ), [[vModelCheckbox, $setup.textAvoidance]]), _hoisted_13]), createElementVNode("label", _hoisted_14, [withDirectives(createElementVNode("input", {
    type: "checkbox",
    "onUpdate:modelValue": _cache[4] || (_cache[4] = function ($event) {
      return $setup.isClickShowProperty = $event;
    })
  }, null, 512
  /* NEED_PATCH */
  ), [[vModelCheckbox, $setup.isClickShowProperty]]), _hoisted_15]), createElementVNode("label", _hoisted_16, [withDirectives(createElementVNode("input", {
    type: "checkbox",
    "onUpdate:modelValue": _cache[5] || (_cache[5] = function ($event) {
      return $setup.openFilter = $event;
    })
  }, null, 512
  /* NEED_PATCH */
  ), [[vModelCheckbox, $setup.openFilter]]), _hoisted_17])]), withDirectives(createElementVNode("div", _hoisted_18, [createElementVNode("div", _hoisted_19, [_hoisted_20, withDirectives(createElementVNode("select", {
    "class": "sm-select",
    style: {
      "width": "70%"
    },
    "onUpdate:modelValue": _cache[6] || (_cache[6] = function ($event) {
      return $setup.selectedChildLayerIndex = $event;
    })
  }, [(openBlock(true), createElementBlock(Fragment, null, renderList($setup.childLayerNames, function (Clayer, index) {
    return openBlock(), createElementBlock("option", {
      key: index,
      value: index
    }, toDisplayString(Clayer), 9
    /* TEXT, PROPS */
    , _hoisted_21);
  }), 128
  /* KEYED_FRAGMENT */
  ))], 512
  /* NEED_PATCH */
  ), [[vModelSelect, $setup.selectedChildLayerIndex]])]), createElementVNode("div", _hoisted_22, [_hoisted_23, createElementVNode("div", null, [createElementVNode("button", {
    "class": "tbtn",
    type: "button",
    style: {
      "width": "auto"
    },
    onClick: _cache[7] || (_cache[7] = function ($event) {
      return $setup.addCondition(true);
    })
  }, "增行"), createElementVNode("button", {
    "class": "tbtn tbtn-margin-left",
    type: "button",
    style: {
      "width": "auto"
    },
    onClick: _cache[8] || (_cache[8] = function ($event) {
      return $setup.addCondition(false);
    })
  }, "删行")])]), createElementVNode("div", _hoisted_24, [createElementVNode("table", _hoisted_25, [createElementVNode("tbody", null, [_hoisted_26, (openBlock(true), createElementBlock(Fragment, null, renderList($setup.selectedPropertyKeys, function (pro, index) {
    return openBlock(), createElementBlock("tr", {
      key: index
    }, [createElementVNode("td", _hoisted_27, [withDirectives(createElementVNode("select", {
      "class": "sm-select",
      "onUpdate:modelValue": function onUpdateModelValue($event) {
        return $setup.selectedPropertyKeys[index] = $event;
      }
    }, [(openBlock(true), createElementBlock(Fragment, null, renderList($setup.propertyKeys, function (key) {
      return openBlock(), createElementBlock("option", {
        key: key,
        value: key
      }, toDisplayString(key), 9
      /* TEXT, PROPS */
      , _hoisted_29);
    }), 128
    /* KEYED_FRAGMENT */
    ))], 8
    /* PROPS */
    , _hoisted_28), [[vModelSelect, $setup.selectedPropertyKeys[index]]]), withDirectives(createElementVNode("input", {
      type: "text",
      "class": "input",
      "onUpdate:modelValue": function onUpdateModelValue($event) {
        return $setup.inputPropertys[index] = $event;
      }
    }, null, 8
    /* PROPS */
    , _hoisted_30), [[vModelText, $setup.inputPropertys[index]]])]), createElementVNode("td", _hoisted_31, [withDirectives(createElementVNode("select", {
      "class": "sm-select",
      "onUpdate:modelValue": function onUpdateModelValue($event) {
        return $setup.selectedSymbols[index] = $event;
      }
    }, [(openBlock(true), createElementBlock(Fragment, null, renderList($setup.symbols, function (key) {
      return openBlock(), createElementBlock("option", {
        key: key,
        value: key
      }, toDisplayString(key), 9
      /* TEXT, PROPS */
      , _hoisted_33);
    }), 128
    /* KEYED_FRAGMENT */
    ))], 8
    /* PROPS */
    , _hoisted_32), [[vModelSelect, $setup.selectedSymbols[index]]]), withDirectives(createElementVNode("input", {
      type: "text",
      "class": "input",
      "onUpdate:modelValue": function onUpdateModelValue($event) {
        return $setup.inputSymbols[index] = $event;
      }
    }, null, 8
    /* PROPS */
    , _hoisted_34), [[vModelText, $setup.inputSymbols[index]]])]), createElementVNode("td", null, [withDirectives(createElementVNode("input", {
      type: "text",
      "class": "input2",
      "onUpdate:modelValue": function onUpdateModelValue($event) {
        return $setup.inputValues[index] = $event;
      }
    }, null, 8
    /* PROPS */
    , _hoisted_35), [[vModelText, $setup.inputValues[index]]])])]);
  }), 128
  /* KEYED_FRAGMENT */
  ))])])]), createElementVNode("div", _hoisted_36, [createElementVNode("button", {
    "class": "tbtn",
    type: "button",
    style: {
      "width": "auto"
    },
    onClick: _cache[9] || (_cache[9] = function () {
      return $setup.propertySearch && $setup.propertySearch.apply($setup, arguments);
    })
  }, "查询"), createElementVNode("button", {
    "class": "tbtn tbtn-margin-left",
    type: "button",
    style: {
      "width": "auto"
    },
    onClick: _cache[10] || (_cache[10] = function () {
      return $setup.propertyFilter && $setup.propertyFilter.apply($setup, arguments);
    })
  }, "过滤"), createElementVNode("button", {
    "class": "tbtn tbtn-margin-left",
    style: {
      "width": "auto"
    },
    type: "button ",
    onClick: _cache[11] || (_cache[11] = function () {
      return $setup.clear && $setup.clear.apply($setup, arguments);
    })
  }, "清除")])], 512
  /* NEED_PATCH */
  ), [[vShow, $setup.openFilter]])])), [[_directive_stopdrag]])])), [[_directive_drag]]), withDirectives(createElementVNode("div", _hoisted_37, null, 512
  /* NEED_PATCH */
  ), [[vShow, _ctx.isShowproPerties && $setup.propertyKeys.length > 0], [_directive_drag]]), withDirectives((openBlock(), createElementBlock("div", _hoisted_38, [createElementVNode("div", _hoisted_39, [_hoisted_40, createElementVNode("div", _hoisted_41, [withDirectives(createElementVNode("i", {
    "class": "el-icon-position",
    title: "停靠",
    style: {
      "margin-right": "8px"
    },
    onClick: _cache[12] || (_cache[12] = function ($event) {
      return $setup.dockBubble(true);
    })
  }, null, 512
  /* NEED_PATCH */
  ), [[vShow, $setup.dockFontShow]]), withDirectives(createElementVNode("i", {
    "class": "el-icon-chat-square",
    title: "悬浮",
    style: {
      "margin-right": "8px"
    },
    onClick: _cache[13] || (_cache[13] = function ($event) {
      return $setup.dockBubble(false);
    })
  }, null, 512
  /* NEED_PATCH */
  ), [[vShow, !$setup.dockFontShow]]), createElementVNode("i", {
    "class": "el-icon-close",
    title: "关闭",
    onClick: _cache[14] || (_cache[14] = function () {
      return $setup.closeBubble && $setup.closeBubble.apply($setup, arguments);
    })
  })])]), createElementVNode("table", _hoisted_42, [createElementVNode("tbody", null, [_hoisted_43, createElementVNode("tr", null, [_hoisted_44, createElementVNode("td", null, toDisplayString($setup.clickGetFeature.layer.id), 1
  /* TEXT */
  )]), createElementVNode("tr", null, [_hoisted_45, createElementVNode("td", null, toDisplayString($setup.clickGetFeature.id), 1
  /* TEXT */
  )]), (openBlock(true), createElementBlock(Fragment, null, renderList($setup.clickGetFeature.properties, function (value, key, index) {
    return openBlock(), createElementBlock("tr", {
      key: index
    }, [createElementVNode("td", null, toDisplayString(key), 1
    /* TEXT */
    ), createElementVNode("td", null, toDisplayString(value), 1
    /* TEXT */
    )]);
  }), 128
  /* KEYED_FRAGMENT */
  ))])])])), [[_directive_drag], [vShow, $setup.bubbleShow]])], 64
  /* STABLE_FRAGMENT */
  );
}

script.render = render;
script.__file = "src/components/layer/mvtlayer-style/mvtlayer-style.vue";

script.install = function (app) {
  app.component(script.name, script);
};

export default script;
