import { reactive, toRefs, watch, onBeforeUnmount, resolveComponent, resolveDirective, withDirectives, openBlock, createElementBlock, createElementVNode, toDisplayString, createVNode, createCommentVNode, vModelSelect, vModelCheckbox, createTextVNode } from 'vue';

function _typeof(obj) {
  "@babel/helpers - typeof";

  if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
    _typeof = function (obj) {
      return typeof obj;
    };
  } else {
    _typeof = function (obj) {
      return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
    };
  }

  return _typeof(obj);
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);

  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    if (enumerableOnly) symbols = symbols.filter(function (sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    });
    keys.push.apply(keys, symbols);
  }

  return keys;
}

function _objectSpread2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};

    if (i % 2) {
      ownKeys(Object(source), true).forEach(function (key) {
        _defineProperty(target, key, source[key]);
      });
    } else if (Object.getOwnPropertyDescriptors) {
      Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
      ownKeys(Object(source)).forEach(function (key) {
        Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
      });
    }
  }

  return target;
}

/*
* 常用工具类
*/
//axios本版本不支持jsonp
var axiosJsonp = function axiosJsonp(url) {
  if (!url) {
    console.error('Axios.JSONP 至少需要一个url参数!');
    return;
  }

  return new Promise(function (resolve, reject) {
    window.jsonCallBack = function (result) {
      resolve(result);
    };

    var JSONP = document.createElement("script");
    JSONP.type = "text/javascript";
    JSONP.src = "".concat(url, "&callback=jsonCallBack");
    document.getElementsByTagName("head")[0].appendChild(JSONP);
    setTimeout(function () {
      document.getElementsByTagName("head")[0].removeChild(JSONP);
    }, 500);
  });
}; //判断两数组或对象相等


var isEqualArr = function isEqualArr(arg1, arg2) {
  if (!arg1 || !arg2) return true;
  var bol = true;

  if (Object.keys(arg1).length != Object.keys(arg2).length) {
    return false;
  }

  for (var key in arg1) {
    if (_typeof(arg1[key]) == 'object') {
      bol = isSame(arg1[key], arg2[key]);

      if (!bol) {
        break;
      }
    } else if (arg1[key] != arg2[key]) {
      bol = false;
      break;
    }
  }

  return bol;
}; //坐标转化
//笛卡尔转经纬度


var CartesiantoDegrees = function CartesiantoDegrees(Cartesians) {
  var array = [].concat(Cartesians);
  var positions = [];

  for (var i = 0, len = array.length; i < len; i++) {
    var cartographic = Cesium.Cartographic.fromCartesian(array[i]);
    var longitude = Cesium.Math.toDegrees(cartographic.longitude);
    var latitude = Cesium.Math.toDegrees(cartographic.latitude);
    var h = cartographic.height;

    if (positions.indexOf(longitude) == -1 && positions.indexOf(latitude) == -1) {
      positions.push(longitude);
      positions.push(latitude);
      positions.push(h);
    }
  }

  return positions;
}; //笛卡尔转经纬度(每个点是独立的对象)


var CartesiantoDegreesObjs = function CartesiantoDegreesObjs(Cartesians) {
  var array = [].concat(Cartesians);
  var positions = [];

  for (var i = 0, len = array.length; i < len; i++) {
    var cartographic = Cesium.Cartographic.fromCartesian(array[i]);
    var obj = {
      longitude: Cesium.Math.toDegrees(cartographic.longitude),
      latitude: Cesium.Math.toDegrees(cartographic.latitude),
      height: cartographic.height
    };
    positions.push(obj);
  }

  return positions;
}; // 弧度转经纬度


var CartographictoDegrees = function CartographictoDegrees(wgsPosition) {
  var longitude = Cesium.Math.toDegrees(wgsPosition.longitude);
  var latitude = Cesium.Math.toDegrees(wgsPosition.latitude);
  var height = wgsPosition.height;
  return [longitude, latitude, height];
}; //去重函数  数组


var unique = function unique(arr) {
  var res = [];
  var json = {};

  for (var i = 0; i < arr.length; i++) {
    if (!json[arr[i]]) {
      res.push(arr[i]);
      json[arr[i]] = 1;
    }
  }

  return res;
}; // 获取渐变色函数


function gradientColors(start, end, steps, gamma) {
  var i,
      j,
      ms,
      me,
      output = [],
      so = [];
  gamma = gamma || 1;

  var normalize = function normalize(channel) {
    return Math.pow(channel / 255, gamma);
  };

  start = parseColor(start).map(normalize);
  end = parseColor(end).map(normalize);

  for (i = 0; i < steps; i++) {
    ms = i / (steps - 1);
    me = 1 - ms;

    for (j = 0; j < 3; j++) {
      so[j] = pad(Math.round(Math.pow(start[j] * me + end[j] * ms, 1 / gamma) * 255).toString(16));
    }

    output.push('#' + so.join(''));
  }

  return output;

  function parseColor(hexStr) {
    return hexStr.length === 4 ? hexStr.substr(1).split('').map(function (s) {
      return 0x11 * parseInt(s, 16);
    }) : [hexStr.substr(1, 2), hexStr.substr(3, 2), hexStr.substr(5, 2)].map(function (s) {
      return parseInt(s, 16);
    });
  }

  function pad(s) {
    return s.length === 1 ? '0' + s : s;
  }
}

function getAngleAndRadian(pointA, pointB) {
  //建立以点A为原点，X轴为east,Y轴为north,Z轴朝上的坐标系
  var transform = Cesium.Transforms.eastNorthUpToFixedFrame(pointA); //向量AB

  var positionvector = Cesium.Cartesian3.subtract(pointB, pointA, new Cesium.Cartesian3()); //因transform是将A为原点的eastNorthUp坐标系中的点转换到世界坐标系的矩阵
  //AB为世界坐标中的向量
  //因此将AB向量转换为A原点坐标系中的向量，需乘以transform的逆矩阵。

  var vector = Cesium.Matrix4.multiplyByPointAsVector(Cesium.Matrix4.inverse(transform, new Cesium.Matrix4()), positionvector, new Cesium.Cartesian3()); //归一化

  var direction = Cesium.Cartesian3.normalize(vector, new Cesium.Cartesian3()); //heading

  var heading1 = Math.atan2(direction.y, direction.x) - Cesium.Math.PI_OVER_TWO;
  var radian = Cesium.Math.TWO_PI - Cesium.Math.zeroToTwoPi(heading1);
  var angle = radian * (180 / Math.PI);

  if (angle < 0) {
    angle = angle + 360;
  }

  return {
    angle: angle,
    radian: radian
  };
}

function getPitch(pointA, pointB) {
  var transfrom = Cesium.Transforms.eastNorthUpToFixedFrame(pointA);
  var vector = Cesium.Cartesian3.subtract(pointB, pointA, new Cesium.Cartesian3());
  var direction = Cesium.Matrix4.multiplyByPointAsVector(Cesium.Matrix4.inverse(transfrom, transfrom), vector, vector);
  Cesium.Cartesian3.normalize(direction, direction); //因为direction已归一化，斜边长度等于1，所以余弦函数等于direction.z

  var radian = Cesium.Math.PI_OVER_TWO - Cesium.Math.acosClamped(direction.z);
  var angle = radian * (180 / Math.PI);

  if (angle < 0) {
    angle = angle + 360;
  }

  return {
    angle: angle,
    radian: radian
  };
}

var tool = {
  axiosJsonp: axiosJsonp,
  isEqualArr: isEqualArr,
  CartesiantoDegrees: CartesiantoDegrees,
  CartesiantoDegreesObjs: CartesiantoDegreesObjs,
  unique: unique,
  gradientColors: gradientColors,
  getAngleAndRadian: getAngleAndRadian,
  CartographictoDegrees: CartographictoDegrees,
  getPitch: getPitch
};

var ResourceCN = {
  showRenderLoopErrors: '渲染时发生错误，已停止渲染。',
  AttributeError: '该组件props没有这个属性：',
  NoPickPositionSupported: "不支持深度纹理,无法绘制多边形，地形操作功能无法使用！",
  NoTerrain: "请在地形里使用地形组件！",
  initViewerWarn: '请先初始化viewer!',
  MoveMouseHeightBox: '点击鼠标左键结束矩形绘制，移动鼠标绘制box高度',
  RightClickEndDrawing: '右键单击结束绘制',
  LeftClickBottomBox: '点击鼠标左键，开始绘制矩形作为box底面',
  ClickModelAddBox: '点击模型，添加裁剪盒子',
  SkyLineWarn: "获取天际线体前，请先绘制天际线！",
  SkyLineBody: '天际线体',
  ShadowqueryWarn: "此操作需要先开启阴影！",
  VeiwshedBody: '可视体',
  VeiwshedBodyHidden: '不可视体',
  EchartsErr: "二维显示需要echarts支持，未找到相关依赖！",
  BaseMapImg: '底图',
  tip1: '<p>点击左键确定操作区域中间点</p><p>右键单击结束绘制</p>'
};

// 组件内部的语言资源：主要包括提示信息
var currentLanguage, Resource;
var cookieLanguage = getLang().toLowerCase();

function getLang() {
  //浏览器语言  IE用browserLanguage，非IE使用language进行判断
  var lang = (navigator.language || navigator.browserLanguage).toLowerCase();
  window.lang = lang; //判断portal设置语言 通过cookie获取
  //   const cookies = document.cookie.split(';');
  //   if (cookies.length > 0) {
  //     cookies.forEach(function (cookie) {
  //       const arr = cookie.split('=');
  //       if (arr[0].toLowerCase().trim() === 'language') {
  //         lang = arr[1];
  //         return;
  //       }
  //     });
  //   }

  return lang;
}

if (cookieLanguage !== undefined) {
  currentLanguage = cookieLanguage;
} else {
  currentLanguage = (navigator.language || navigator.browserLanguage).toLowerCase(); // 获取当前浏览器的语言
}

if (currentLanguage.startsWith('zh')) {
  Resource = ResourceCN;
} else if (currentLanguage.startsWith('ja')) {
  Resource = ResourceCN;
} else {
  Resource = ResourceCN;
}

var resource = Resource;

// 创建一个简单的store状态管理

var storeState = reactive({
  isViewer: false,
  //viewer初始化标志
  changeLayers: 0,
  //图层改变加载完毕监听
  changeGeometrys: 0 //三维分析体改变标志

});

function createTooltip(frameDiv) {
  var tooltip = function tooltip(frameDiv) {
    var div = document.createElement('DIV');
    div.className = "tooltip";
    this._div = div;
    this.message = '';
    frameDiv.appendChild(div);
  };

  tooltip.prototype.setVisible = function (visible) {
    if (visible) {
      this._div.style.right = '10px';
    } else {
      this._div.style.right = '-300px';
    }
  };

  tooltip.prototype.showAt = function (message, top) {
    //top:200px => string
    if (top) {
      this._div.style.top = top;
    }

    if (message) {
      this.setVisible(true);
      this._div.innerHTML = message;
    }
  };

  return new tooltip(frameDiv);
}

function openness(props) {
  // 设置默认值数据
  var state = reactive({
    addHeight: 1,
    //附加高度
    viewPosition: null,
    //分析位置
    viewDomeRadius: 100,
    //分析半径
    domeType: "ALLDOME",
    //分析类型
    isClosed: false,
    //是否封口
    visibleAreaColor: "rgba(9,199,112,0.5)",
    //可见区颜色
    hiddenAreaColor: "rgba(238,114,22,0.5)",
    //不可见颜色
    startAngle: 0,
    //开始角度
    endAngle: 360 //终止角度

  }); // 传入props改变默认值

  if (props) {
    for (var key in props) {
      if (state.hasOwnProperty(key)) {
        if (props[key] != undefined) state[key] = props[key];
      } else {
        tool.Message.errorMsg(resource.AttributeError + key);
      }
    }
  } // 初始化数据


  var scene,
      viewDome,
      Entypositions,
      tipFlag = true;

  if (storeState.isViewer) {
    if (!window.tooltip) {
      window.tooltip = createTooltip(viewer._element);
    }

    init();
  } //viewer 初始化完成的监听


  watch(function () {
    return storeState.isViewer;
  }, function (val) {
    if (val) {
      if (!window.tooltip) {
        window.tooltip = createTooltip(viewer._element);
      }

      init();
    }
  });

  function init() {
    scene = viewer.scene; //初始化

    viewDome = new Cesium.ViewDome(scene); //构造新的开敞度分析对象

    viewDome.viewPosition = [0, 0, 0]; //初始化视点位置

    viewDome.distance = Number(state.viewDomeRadius); //可视距离

    viewDome.domeType = Cesium.ViewDomeType[state.domeType]; //开敞度类型,分为可视部分、不可视部分, 全部显示

    viewDome.visibleAreaColor = Cesium.Color.fromCssColorString(state.visibleAreaColor); //可视部颜色

    viewDome.hiddenAreaColor = Cesium.Color.fromCssColorString(state.hiddenAreaColor); //隐藏部分颜色

    viewDome.startAngle = Number(state.startAngle); //起始角度

    viewDome.endAngle = Number(state.endAngle); //终止角度

    viewDome.isClosed = state.isClosed; //封口

    viewDome.build(); //执行开敞度分析
  }
  /*
   ***分析模块***
  */
  //分析

  function analysis() {
    viewer.enableCursorStyle = false;
    viewer._element.style.cursor = "";
    document.body.classList.add("measureCur");

    if (tipFlag) {
      //只提示一次
      window.tooltip.showAt(' <p>点击鼠标左键确认分析位置</p>', '250px');
      tipFlag = false;
    }

    addPoint(); //鼠标左键事件监听

    viewer.eventManager.addEventListener("CLICK", LEFT_CLICK, true);
    viewer.eventManager.addEventListener("MOUSE_MOVE", MOUSE_MOVE, true);
  }

  function LEFT_CLICK(e) {
    viewer.enableCursorStyle = true;
    document.body.classList.remove("measureCur"); //获取点击位置笛卡尔坐标

    var position = scene.pickPosition(e.message.position); //将笛卡尔坐标转化为经纬度坐标

    var positions = tool.CartesiantoDegrees(position);
    positions[2] += Number(state.addHeight); //点击位置同步到显示框

    state.viewPosition = {
      longitude: positions[0].toFixed(6),
      latitude: positions[1].toFixed(6),
      height: positions[2].toFixed(2)
    };
    viewDome.viewPosition = positions;
    viewDome.build();
    window.tooltip.setVisible(false);
    viewer.eventManager.removeEventListener("CLICK", LEFT_CLICK);
    viewer.eventManager.removeEventListener("MOUSE_MOVE", MOUSE_MOVE);
    viewDome.startAngle = Number(state.startAngle); //改变属性后，加上才能更新效果（应该是缺陷）
  }

  function addPoint() {
    viewer.entities.removeById('opennessPoint');
    viewer.entities.add(new Cesium.Entity({
      id: 'opennessPoint',
      point: new Cesium.PointGraphics({
        color: Cesium.Color.fromCssColorString('rgba(238,114,22,1)'),
        pixelSize: 8
      }),
      // position: p
      position: new Cesium.CallbackProperty(function () {
        return Entypositions;
      }, false)
    }));
  } // 鼠标移动实时分析


  function MOUSE_MOVE(e) {
    Entypositions = scene.pickPosition(e.message.endPosition);
  } //改变经纬度动态移动

  function clear() {
    viewer.entities.removeById('opennessPoint');
    document.body.classList.remove("measureCur");
    window.tooltip.setVisible(false);
    state.viewPosition = null; // viewDome.clear()

    viewDome.viewPosition = [0, 0, 0]; //初始化视点位置

    viewDome.startAngle = Number(state.startAngle); //起始角度
  }

  watch(function () {
    return state.viewDomeRadius;
  }, function (val) {
    if (val == "") return;
    viewDome.distance = Number(val);
  });
  watch(function () {
    return state.domeType;
  }, function (val) {
    if (val == "") return;
    viewDome.domeType = Cesium.ViewDomeType[val];
  });
  watch(function () {
    return state.isClosed;
  }, function (val) {
    if (val == "") return;
    viewDome.isClosed = val;
  });
  watch(function () {
    return state.startAngle;
  }, function (val) {
    if (val == "") return;
    viewDome.startAngle = Number(val);
  });
  watch(function () {
    return state.endAngle;
  }, function (val) {
    if (val == "") return;
    viewDome.endAngle = Number(val);
  });
  watch(function () {
    return state.visibleAreaColor;
  }, function (val) {
    if (val == "") return;
    var VisibleColor = Cesium.Color.fromCssColorString(val);
    viewDome.visibleAreaColor = VisibleColor;
  });
  watch(function () {
    return state.hiddenAreaColor;
  }, function (val) {
    if (val == "") return;
    var HiddenColor = Cesium.Color.fromCssColorString(val);
    viewDome.hiddenAreaColor = HiddenColor;
  });
  watch(function () {
    return state.addHeight;
  }, function (val, oldval) {
    var h = val - oldval;
    h = Cesium.defaultValue(h, 0);
    viewDome.viewPosition[2] += Number(h);
    Entypositions = Cesium.Cartesian3.fromDegrees(viewDome.viewPosition[0], viewDome.viewPosition[1], viewDome.viewPosition[2]);
    viewDome.startAngle = Number(state.startAngle);
  }); // 销毁

  onBeforeUnmount(function () {
    clear();
    viewDome.destroy();
    viewDome = undefined;
  });
  return _objectSpread2(_objectSpread2({}, toRefs(state)), {}, {
    analysis: analysis,
    clear: clear
  });
}

var script = {
  name: "Sm3dOpenness",
  props: {
    //附加高度
    addHeight: {
      type: Number,
      "default": 1
    },
    //分析位置
    viewPosition: {
      type: Array
    },
    //分析半径
    viewDomeRadius: {
      type: Number,
      "default": 100
    },
    //分析类型
    domeType: {
      type: String,
      "default": "ALLDOME"
    },
    //是否封口
    isClosed: {
      type: Boolean,
      "default": false
    },
    //可见区颜色
    visibleAreaColor: {
      type: String,
      "default": "rgba(9,199,112,0.5)"
    },
    //不可见颜色
    hiddenAreaColor: {
      type: String,
      "default": "rgba(238,114,22,0.5)"
    },
    //开始角度
    startAngle: {
      type: Number,
      "default": 10
    },
    //终止角度
    endAngle: {
      type: Number,
      "default": 360
    }
  },
  methods: {
    // 滑块提示函数
    formatTooltip: function formatTooltip(val) {
      return val + "米";
    }
  },
  setup: function setup(props) {
    var _openness = openness(props),
        addHeight = _openness.addHeight,
        viewDomeRadius = _openness.viewDomeRadius,
        domeType = _openness.domeType,
        isClosed = _openness.isClosed,
        visibleAreaColor = _openness.visibleAreaColor,
        hiddenAreaColor = _openness.hiddenAreaColor,
        startAngle = _openness.startAngle,
        endAngle = _openness.endAngle,
        analysis = _openness.analysis,
        clear = _openness.clear;

    return {
      addHeight: addHeight,
      //附加高度
      viewDomeRadius: viewDomeRadius,
      //分析半径
      domeType: domeType,
      //分析类型
      isClosed: isClosed,
      //是否封口
      visibleAreaColor: visibleAreaColor,
      //可见区颜色
      hiddenAreaColor: hiddenAreaColor,
      //不可见颜色
      startAngle: startAngle,
      //开始角度
      endAngle: endAngle,
      //终止角度
      analysis: analysis,
      clear: clear
    };
  }
};

var _hoisted_1 = {
  id: "openness-panel",
  "class": "sm-panel"
};
var _hoisted_2 = {
  "class": "sm-function-module-sub-section",
  style: {
    "margin": "0"
  }
};
var _hoisted_3 = {
  "class": "sm-half-L"
};
var _hoisted_4 = {
  style: {
    "width": "35%"
  }
};
var _hoisted_5 = {
  "class": "sm-half-L"
};
var _hoisted_6 = {
  style: {
    "width": "35%"
  }
};
var _hoisted_7 = {
  "class": "sm-half-L"
};
var _hoisted_8 = {
  style: {
    "width": "35%"
  }
};
var _hoisted_9 = {
  "class": "sm-half-L"
};
var _hoisted_10 = {
  style: {
    "width": "35%"
  }
};
var _hoisted_11 = {
  "class": "sm-half-L"
};
var _hoisted_12 = {
  style: {
    "width": "35%"
  }
};
var _hoisted_13 = {
  "class": "sm-half-L"
};
var _hoisted_14 = {
  style: {
    "width": "35%"
  }
};
var _hoisted_15 = {
  "class": "sm-half-L"
};
var _hoisted_16 = {
  style: {
    "width": "35%"
  }
};
var _hoisted_17 = {
  value: "ALLDOME"
};
var _hoisted_18 = {
  value: "VISIBLEDOME"
};
var _hoisted_19 = {
  value: "HIDDENDOME"
};
var _hoisted_20 = {
  "class": "sm-half-L"
};
var _hoisted_21 = {
  style: {
    "width": "auto"
  }
};
var _hoisted_22 = {
  "class": "boxchild"
};
function render(_ctx, _cache, $props, $setup, $data, $options) {
  var _component_el_slider = resolveComponent("el-slider");

  var _component_el_color_picker = resolveComponent("el-color-picker");

  var _directive_stopdrag = resolveDirective("stopdrag");

  var _directive_drag = resolveDirective("drag");

  return withDirectives((openBlock(), createElementBlock("div", _hoisted_1, [withDirectives((openBlock(), createElementBlock("div", _hoisted_2, [createElementVNode("div", _hoisted_3, [createElementVNode("label", _hoisted_4, toDisplayString(_ctx.Resource.addheight), 1
  /* TEXT */
  ), createVNode(_component_el_slider, {
    modelValue: $setup.addHeight,
    "onUpdate:modelValue": _cache[0] || (_cache[0] = function ($event) {
      return $setup.addHeight = $event;
    }),
    min: 0,
    step: 0.1,
    max: 10,
    "input-size": "mini",
    debounce: 500,
    "tooltip-class": "tooltip-class",
    style: {
      "width": "63%"
    }
  }, null, 8
  /* PROPS */
  , ["modelValue", "step"])]), createElementVNode("div", _hoisted_5, [createElementVNode("label", _hoisted_6, toDisplayString(_ctx.Resource.startAngle), 1
  /* TEXT */
  ), createVNode(_component_el_slider, {
    modelValue: $setup.startAngle,
    "onUpdate:modelValue": _cache[1] || (_cache[1] = function ($event) {
      return $setup.startAngle = $event;
    }),
    min: 0,
    max: 360,
    "input-size": "mini",
    debounce: 500,
    "tooltip-class": "tooltip-class",
    style: {
      "width": "63%"
    }
  }, null, 8
  /* PROPS */
  , ["modelValue"])]), createElementVNode("div", _hoisted_7, [createElementVNode("label", _hoisted_8, toDisplayString(_ctx.Resource.endAngle), 1
  /* TEXT */
  ), createVNode(_component_el_slider, {
    modelValue: $setup.endAngle,
    "onUpdate:modelValue": _cache[2] || (_cache[2] = function ($event) {
      return $setup.endAngle = $event;
    }),
    min: 0,
    max: 360,
    "input-size": "mini",
    debounce: 500,
    "tooltip-class": "tooltip-class",
    style: {
      "width": "63%"
    }
  }, null, 8
  /* PROPS */
  , ["modelValue"])]), createElementVNode("div", _hoisted_9, [createElementVNode("label", _hoisted_10, toDisplayString(_ctx.Resource.observeRadius), 1
  /* TEXT */
  ), createVNode(_component_el_slider, {
    modelValue: $setup.viewDomeRadius,
    "onUpdate:modelValue": _cache[3] || (_cache[3] = function ($event) {
      return $setup.viewDomeRadius = $event;
    }),
    min: 1,
    step: 1,
    max: 1000,
    "input-size": "mini",
    debounce: 500,
    "format-tooltip": $options.formatTooltip,
    "tooltip-class": "tooltip-class",
    style: {
      "width": "63%"
    }
  }, null, 8
  /* PROPS */
  , ["modelValue", "format-tooltip"]), createCommentVNode(" <input class=\"sm-input-S\" min=\"1\" step=\"1\" type=\"number\" v-model=\"clipWidth\" /> ")]), createElementVNode("div", _hoisted_11, [createElementVNode("label", _hoisted_12, toDisplayString(_ctx.Resource.visibleAreaColor), 1
  /* TEXT */
  ), createVNode(_component_el_color_picker, {
    modelValue: $setup.visibleAreaColor,
    "onUpdate:modelValue": _cache[4] || (_cache[4] = function ($event) {
      return $setup.visibleAreaColor = $event;
    }),
    size: "mini",
    "show-alpha": "",
    style: {
      "width": "63%"
    }
  }, null, 8
  /* PROPS */
  , ["modelValue"])]), createElementVNode("div", _hoisted_13, [createElementVNode("label", _hoisted_14, toDisplayString(_ctx.Resource.hiddenAreaColor), 1
  /* TEXT */
  ), createVNode(_component_el_color_picker, {
    modelValue: $setup.hiddenAreaColor,
    "onUpdate:modelValue": _cache[5] || (_cache[5] = function ($event) {
      return $setup.hiddenAreaColor = $event;
    }),
    size: "mini",
    "show-alpha": "",
    style: {
      "width": "63%"
    }
  }, null, 8
  /* PROPS */
  , ["modelValue"])]), createElementVNode("div", _hoisted_15, [createElementVNode("label", _hoisted_16, toDisplayString(_ctx.Resource.displayMode), 1
  /* TEXT */
  ), withDirectives(createElementVNode("select", {
    "class": "sm-select",
    style: {
      "width": "63%"
    },
    "onUpdate:modelValue": _cache[6] || (_cache[6] = function ($event) {
      return $setup.domeType = $event;
    })
  }, [createElementVNode("option", _hoisted_17, toDisplayString(_ctx.Resource.allShow), 1
  /* TEXT */
  ), createElementVNode("option", _hoisted_18, toDisplayString(_ctx.Resource.visibleShow), 1
  /* TEXT */
  ), createElementVNode("option", _hoisted_19, toDisplayString(_ctx.Resource.hiddenShow), 1
  /* TEXT */
  )], 512
  /* NEED_PATCH */
  ), [[vModelSelect, $setup.domeType]])]), createElementVNode("div", _hoisted_20, [createElementVNode("label", _hoisted_21, [withDirectives(createElementVNode("input", {
    type: "checkbox",
    "onUpdate:modelValue": _cache[7] || (_cache[7] = function ($event) {
      return $setup.isClosed = $event;
    })
  }, null, 512
  /* NEED_PATCH */
  ), [[vModelCheckbox, $setup.isClosed]]), createTextVNode(" " + toDisplayString(_ctx.Resource.isClosed), 1
  /* TEXT */
  )])]), createElementVNode("div", _hoisted_22, [createElementVNode("button", {
    "class": "tbtn",
    type: "button",
    onClick: _cache[8] || (_cache[8] = function () {
      return $setup.analysis && $setup.analysis.apply($setup, arguments);
    })
  }, toDisplayString(_ctx.Resource.analyze), 1
  /* TEXT */
  ), createElementVNode("button", {
    onClick: _cache[9] || (_cache[9] = function () {
      return $setup.clear && $setup.clear.apply($setup, arguments);
    }),
    "class": "tbtn",
    style: {
      "margin-left": "4px"
    },
    type: "button"
  }, toDisplayString(_ctx.Resource.clear), 1
  /* TEXT */
  )])])), [[_directive_stopdrag]])])), [[_directive_drag]]);
}

script.render = render;
script.__file = "src/components/analysis_3d/openness/openness.vue";

script.install = function (app) {
  app.component(script.name, script);
};

export default script;
