import { reactive, toRefs, watch, onBeforeUnmount, resolveComponent, resolveDirective, withDirectives, openBlock, createElementBlock, createElementVNode, Fragment, renderList, normalizeClass, toDisplayString, vModelSelect, vShow, vModelCheckbox, createTextVNode, createVNode, vModelText } from 'vue';

function _typeof(obj) {
  "@babel/helpers - typeof";

  if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
    _typeof = function (obj) {
      return typeof obj;
    };
  } else {
    _typeof = function (obj) {
      return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
    };
  }

  return _typeof(obj);
}

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);

  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    if (enumerableOnly) symbols = symbols.filter(function (sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    });
    keys.push.apply(keys, symbols);
  }

  return keys;
}

function _objectSpread2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};

    if (i % 2) {
      ownKeys(Object(source), true).forEach(function (key) {
        _defineProperty(target, key, source[key]);
      });
    } else if (Object.getOwnPropertyDescriptors) {
      Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
      ownKeys(Object(source)).forEach(function (key) {
        Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
      });
    }
  }

  return target;
}

function _setPrototypeOf(o, p) {
  _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };

  return _setPrototypeOf(o, p);
}

function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !Reflect.construct) return false;
  if (Reflect.construct.sham) return false;
  if (typeof Proxy === "function") return true;

  try {
    Date.prototype.toString.call(Reflect.construct(Date, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}

function _construct(Parent, args, Class) {
  if (_isNativeReflectConstruct()) {
    _construct = Reflect.construct;
  } else {
    _construct = function _construct(Parent, args, Class) {
      var a = [null];
      a.push.apply(a, args);
      var Constructor = Function.bind.apply(Parent, a);
      var instance = new Constructor();
      if (Class) _setPrototypeOf(instance, Class.prototype);
      return instance;
    };
  }

  return _construct.apply(null, arguments);
}

function _toConsumableArray(arr) {
  return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread();
}

function _arrayWithoutHoles(arr) {
  if (Array.isArray(arr)) return _arrayLikeToArray(arr);
}

function _iterableToArray(iter) {
  if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter);
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

  return arr2;
}

function _nonIterableSpread() {
  throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

// 创建一个简单的store状态管理

var storeState = reactive({
  isViewer: false,
  //viewer初始化标志
  changeLayers: 0,
  //图层改变加载完毕监听
  changeGeometrys: 0 //三维分析体改变标志

});

/*
* 常用工具类
*/
//axios本版本不支持jsonp
var axiosJsonp = function axiosJsonp(url) {
  if (!url) {
    console.error('Axios.JSONP 至少需要一个url参数!');
    return;
  }

  return new Promise(function (resolve, reject) {
    window.jsonCallBack = function (result) {
      resolve(result);
    };

    var JSONP = document.createElement("script");
    JSONP.type = "text/javascript";
    JSONP.src = "".concat(url, "&callback=jsonCallBack");
    document.getElementsByTagName("head")[0].appendChild(JSONP);
    setTimeout(function () {
      document.getElementsByTagName("head")[0].removeChild(JSONP);
    }, 500);
  });
}; //判断两数组或对象相等


var isEqualArr = function isEqualArr(arg1, arg2) {
  if (!arg1 || !arg2) return true;
  var bol = true;

  if (Object.keys(arg1).length != Object.keys(arg2).length) {
    return false;
  }

  for (var key in arg1) {
    if (_typeof(arg1[key]) == 'object') {
      bol = isSame(arg1[key], arg2[key]);

      if (!bol) {
        break;
      }
    } else if (arg1[key] != arg2[key]) {
      bol = false;
      break;
    }
  }

  return bol;
}; //坐标转化
//笛卡尔转经纬度


var CartesiantoDegrees = function CartesiantoDegrees(Cartesians) {
  var array = [].concat(Cartesians);
  var positions = [];

  for (var i = 0, len = array.length; i < len; i++) {
    var cartographic = Cesium.Cartographic.fromCartesian(array[i]);
    var longitude = Cesium.Math.toDegrees(cartographic.longitude);
    var latitude = Cesium.Math.toDegrees(cartographic.latitude);
    var h = cartographic.height;

    if (positions.indexOf(longitude) == -1 && positions.indexOf(latitude) == -1) {
      positions.push(longitude);
      positions.push(latitude);
      positions.push(h);
    }
  }

  return positions;
}; //笛卡尔转经纬度(每个点是独立的对象)


var CartesiantoDegreesObjs = function CartesiantoDegreesObjs(Cartesians) {
  var array = [].concat(Cartesians);
  var positions = [];

  for (var i = 0, len = array.length; i < len; i++) {
    var cartographic = Cesium.Cartographic.fromCartesian(array[i]);
    var obj = {
      longitude: Cesium.Math.toDegrees(cartographic.longitude),
      latitude: Cesium.Math.toDegrees(cartographic.latitude),
      height: cartographic.height
    };
    positions.push(obj);
  }

  return positions;
}; // 弧度转经纬度


var CartographictoDegrees = function CartographictoDegrees(wgsPosition) {
  var longitude = Cesium.Math.toDegrees(wgsPosition.longitude);
  var latitude = Cesium.Math.toDegrees(wgsPosition.latitude);
  var height = wgsPosition.height;
  return [longitude, latitude, height];
}; //去重函数  数组


var unique = function unique(arr) {
  var res = [];
  var json = {};

  for (var i = 0; i < arr.length; i++) {
    if (!json[arr[i]]) {
      res.push(arr[i]);
      json[arr[i]] = 1;
    }
  }

  return res;
}; // 获取渐变色函数


function gradientColors(start, end, steps, gamma) {
  var i,
      j,
      ms,
      me,
      output = [],
      so = [];
  gamma = gamma || 1;

  var normalize = function normalize(channel) {
    return Math.pow(channel / 255, gamma);
  };

  start = parseColor(start).map(normalize);
  end = parseColor(end).map(normalize);

  for (i = 0; i < steps; i++) {
    ms = i / (steps - 1);
    me = 1 - ms;

    for (j = 0; j < 3; j++) {
      so[j] = pad(Math.round(Math.pow(start[j] * me + end[j] * ms, 1 / gamma) * 255).toString(16));
    }

    output.push('#' + so.join(''));
  }

  return output;

  function parseColor(hexStr) {
    return hexStr.length === 4 ? hexStr.substr(1).split('').map(function (s) {
      return 0x11 * parseInt(s, 16);
    }) : [hexStr.substr(1, 2), hexStr.substr(3, 2), hexStr.substr(5, 2)].map(function (s) {
      return parseInt(s, 16);
    });
  }

  function pad(s) {
    return s.length === 1 ? '0' + s : s;
  }
}

function getAngleAndRadian(pointA, pointB) {
  //建立以点A为原点，X轴为east,Y轴为north,Z轴朝上的坐标系
  var transform = Cesium.Transforms.eastNorthUpToFixedFrame(pointA); //向量AB

  var positionvector = Cesium.Cartesian3.subtract(pointB, pointA, new Cesium.Cartesian3()); //因transform是将A为原点的eastNorthUp坐标系中的点转换到世界坐标系的矩阵
  //AB为世界坐标中的向量
  //因此将AB向量转换为A原点坐标系中的向量，需乘以transform的逆矩阵。

  var vector = Cesium.Matrix4.multiplyByPointAsVector(Cesium.Matrix4.inverse(transform, new Cesium.Matrix4()), positionvector, new Cesium.Cartesian3()); //归一化

  var direction = Cesium.Cartesian3.normalize(vector, new Cesium.Cartesian3()); //heading

  var heading1 = Math.atan2(direction.y, direction.x) - Cesium.Math.PI_OVER_TWO;
  var radian = Cesium.Math.TWO_PI - Cesium.Math.zeroToTwoPi(heading1);
  var angle = radian * (180 / Math.PI);

  if (angle < 0) {
    angle = angle + 360;
  }

  return {
    angle: angle,
    radian: radian
  };
}

function getPitch(pointA, pointB) {
  var transfrom = Cesium.Transforms.eastNorthUpToFixedFrame(pointA);
  var vector = Cesium.Cartesian3.subtract(pointB, pointA, new Cesium.Cartesian3());
  var direction = Cesium.Matrix4.multiplyByPointAsVector(Cesium.Matrix4.inverse(transfrom, transfrom), vector, vector);
  Cesium.Cartesian3.normalize(direction, direction); //因为direction已归一化，斜边长度等于1，所以余弦函数等于direction.z

  var radian = Cesium.Math.PI_OVER_TWO - Cesium.Math.acosClamped(direction.z);
  var angle = radian * (180 / Math.PI);

  if (angle < 0) {
    angle = angle + 360;
  }

  return {
    angle: angle,
    radian: radian
  };
}

var tool = {
  axiosJsonp: axiosJsonp,
  isEqualArr: isEqualArr,
  CartesiantoDegrees: CartesiantoDegrees,
  CartesiantoDegreesObjs: CartesiantoDegreesObjs,
  unique: unique,
  gradientColors: gradientColors,
  getAngleAndRadian: getAngleAndRadian,
  CartographictoDegrees: CartographictoDegrees,
  getPitch: getPitch
};

var ResourceCN = {
  showRenderLoopErrors: '渲染时发生错误，已停止渲染。',
  AttributeError: '该组件props没有这个属性：',
  NoPickPositionSupported: "不支持深度纹理,无法绘制多边形，地形操作功能无法使用！",
  NoTerrain: "请在地形里使用地形组件！",
  initViewerWarn: '请先初始化viewer!',
  MoveMouseHeightBox: '点击鼠标左键结束矩形绘制，移动鼠标绘制box高度',
  RightClickEndDrawing: '右键单击结束绘制',
  LeftClickBottomBox: '点击鼠标左键，开始绘制矩形作为box底面',
  ClickModelAddBox: '点击模型，添加裁剪盒子',
  SkyLineWarn: "获取天际线体前，请先绘制天际线！",
  SkyLineBody: '天际线体',
  ShadowqueryWarn: "此操作需要先开启阴影！",
  VeiwshedBody: '可视体',
  VeiwshedBodyHidden: '不可视体',
  EchartsErr: "二维显示需要echarts支持，未找到相关依赖！",
  BaseMapImg: '底图',
  tip1: '<p>点击左键确定操作区域中间点</p><p>右键单击结束绘制</p>'
};

// 组件内部的语言资源：主要包括提示信息
var currentLanguage, Resource;
var cookieLanguage = getLang().toLowerCase();

function getLang() {
  //浏览器语言  IE用browserLanguage，非IE使用language进行判断
  var lang = (navigator.language || navigator.browserLanguage).toLowerCase();
  window.lang = lang; //判断portal设置语言 通过cookie获取
  //   const cookies = document.cookie.split(';');
  //   if (cookies.length > 0) {
  //     cookies.forEach(function (cookie) {
  //       const arr = cookie.split('=');
  //       if (arr[0].toLowerCase().trim() === 'language') {
  //         lang = arr[1];
  //         return;
  //       }
  //     });
  //   }

  return lang;
}

if (cookieLanguage !== undefined) {
  currentLanguage = cookieLanguage;
} else {
  currentLanguage = (navigator.language || navigator.browserLanguage).toLowerCase(); // 获取当前浏览器的语言
}

if (currentLanguage.startsWith('zh')) {
  Resource = ResourceCN;
} else if (currentLanguage.startsWith('ja')) {
  Resource = ResourceCN;
} else {
  Resource = ResourceCN;
}

var resource = Resource;

//随鼠标移动消息提示工具
function createTooltip(frameDiv) {
  var tooltip = function tooltip(frameDiv) {
    var div = document.createElement("DIV");
    div.className = "twipsy right";
    var arrow = document.createElement("DIV");
    arrow.className = "twipsy-arrow";
    div.appendChild(arrow);
    var title = document.createElement("DIV");
    title.className = "twipsy-inner";
    div.appendChild(title);
    this._div = div;
    this._title = title;
    this.message = "";
    frameDiv.appendChild(div);
    var that = this;

    div.onmousemove = function (evt) {
      that.showAt({
        x: evt.clientX,
        y: evt.clientY
      }, that.message);
    };
  };

  tooltip.prototype.setVisible = function (visible) {
    this._div.style.display = visible ? "block" : "none";
  };

  tooltip.prototype.showAt = function (position, message) {
    if (position && message) {
      this.setVisible(true);
      this._title.innerHTML = message;
      this._div.style.left = position.x + 10 + "px";
      this._div.style.top = position.y - this._div.clientHeight / 2 + "px";
      this.message = message;
    }
  };

  return new tooltip(frameDiv);
}

/**
 * 初始化
 * DrawMode：类型
 * clampMode：模式
 */

var initHandler = function initHandler(DrawMode, clampMode) {
  var clampmode = 0;

  if (clampMode) {
    clampmode = clampMode;
  }

  switch (DrawMode) {
    case "Point":
      window.handlerPoint = new Cesium.DrawHandler(viewer, Cesium.DrawMode.Point);
      break;

    case "Polyline":
      window.handlerPolyline = new Cesium.DrawHandler(viewer, Cesium.DrawMode.Line, clampmode);
      break;

    case "Polygon":
      window.handlerPolygon = new Cesium.DrawHandler(viewer, Cesium.DrawMode.Polygon, clampmode);
      break;

    case "Marker":
      window.handlerMarker = new Cesium.DrawHandler(viewer, Cesium.DrawMode.Marker, clampmode);
      break;

    case "Box":
      window.handlerBox = new Cesium.DrawHandler(viewer, Cesium.DrawMode.Box, clampmode);
      break;
  }

  if (!window.tooltip) {
    window.tooltip = createTooltip(viewer._element);
  } // 半透线创建


  if (!window.polylineCollection) {
    window.polylineCollection = new Cesium.PolylineCollection({
      translucentRS: Cesium.RenderState.fromCache({
        depthMask: false,
        depthTest: {
          enabled: false
        }
      })
    });
    window.polylineTransparent = window.polylineCollection.add({
      width: 2,
      material: Cesium.Material.fromType(Cesium.Material.ColorType, {
        color: Cesium.Color.fromCssColorString("#51ff00").withAlpha(0.3)
      })
    });
    viewer.scene.primitives.add(window.polylineCollection);
  }
};
/**
 * 绘制
 * PolyType：类型 
 * lineVisib：绘制时是否显示绘制线（boolean）
 * toolTipObj：绘制时提示内容{beforeDrawing：绘制开始前提示(string)，isDrawing：正在绘制时提示,即绘制过程中（string）}
 */


var handlerDrawing = function handlerDrawing(PolyType, lineVisib, toolTipObj) {
  var lineVisible = true;

  if (lineVisib === false) {
    lineVisible = lineVisib;
  }

  var DrawHandler = judgeDrawHandlerType(PolyType); //获取操作对象

  return new Promise(function (resolve, reject) {
    //做一些异步操作
    var tooltip = window.tooltip;
    var clearActFn = DrawHandler.activeEvt.addEventListener(function (isActive) {
      if (isActive == true) {
        viewer.enableCursorStyle = false;
        viewer._element.style.cursor = '';

        if (PolyType == "Point" || PolyType == "Marker") {
          document.body.classList.add("measureCur");
        } else {
          document.body.classList.add("drawCur");
        }
      } else {
        viewer.enableCursorStyle = true;
        tooltip.setVisible(false);

        if (PolyType == "Point" || PolyType == "Marker") {
          document.body.classList.remove('measureCur');
        } else {
          document.body.classList.remove('drawCur');
        }
      }
    });
    var clearMovFn = DrawHandler.movingEvt.addEventListener(function (windowPosition) {
      if (windowPosition.x < 200 && windowPosition.y < 150) {
        tooltip.setVisible(false);
        return;
      }
      //     tooltip.showAt(windowPosition, tiptext);
      // } else if (toolTipObj && toolTipObj.beforeDrawing) {
      //     tooltip.showAt(windowPosition, toolTipObj.beforeDrawing);
      // }else if (DrawHandler.isDrawing && toolTipObj.isDrawing) {
      //     tooltip.showAt(windowPosition, toolTipObj.isDrawing);
      // }

      if (DrawHandler.polyline && DrawHandler.isDrawing) {
        var p = _toConsumableArray(DrawHandler.polyline.positions);

        if (PolyType == "Polygon") {
          //画面时，需要首尾相连
          p.push(p[0]);
        }
        window.polylineTransparent.show = true;
        window.polylineTransparent.positions = p;
      }
    });
    var clearDrawFn = DrawHandler.drawEvt.addEventListener(function (result) {
      if (!result.object.positions && PolyType != "Point" && PolyType != "Box") {
        tooltip.showAt(result, '<p>请绘制正确的多边形</p>');
        DrawHandler.polygon.show = false;
        DrawHandler.polyline.show = false;
        DrawHandler.deactivate();
        DrawHandler.activate();
        return;
      }

      if (PolyType == "Box") {
        resolve({
          result: result
        });
        return;
      }

      if (PolyType == "Point" || PolyType == "Marker") {
        DrawHandler.clear(); // 不显示绘制的点

        resolve({
          result: result
        });
      } else {
        //半透线
        window.polylineTransparent.show = lineVisible;

        if (lineVisible) {
          if (PolyType == "Polygon" && lineVisible) {
            DrawHandler.polygon._polygon._material._color._value.alpha = 0.1; //绘制面透明度

            var p2 = _toConsumableArray(result.object.positions); //画面时，需要首尾相连


            p2.push(p2[0]);
            window.polylineTransparent.positions = p2;
          }
        }

        var positions = CartesiantoDegrees(result.object.positions);
        resolve({
          result: result,
          positions: positions
        });
      }

      clearActFn();
      clearMovFn();
      clearDrawFn();
    });
  });
}; //清除


var clearHandlerDrawing = function clearHandlerDrawing(PolyType) {
  var DrawHandler;

  if (!PolyType) {
    DrawHandler = window.handlerPolygon;
  } else {
    DrawHandler = judgeDrawHandlerType(PolyType);
  }
  if (!DrawHandler) return;
  DrawHandler.deactivate();
  DrawHandler.clear();
  viewer.enableCursorStyle = true; // document.body.classList.remove("drawCur");
  // document.body.classList.remove("measureCur");

  window.tooltip.setVisible(false);

  if (window.polylineTransparent) {
    window.polylineTransparent.show = false;
  }
}; // 类型判断


var judgeDrawHandlerType = function judgeDrawHandlerType(PolyType) {
  var DrawHandler;

  switch (PolyType) {
    case "Point":
      DrawHandler = window.handlerPoint;
      break;

    case "Polyline":
      DrawHandler = window.handlerPolyline;
      break;

    case "Polygon":
      DrawHandler = window.handlerPolygon;
      break;

    case "Marker":
      DrawHandler = window.handlerMarker;
      break;

    case "Box":
      DrawHandler = window.handlerBox;
      break;
  }

  return DrawHandler;
};

function createTooltip$1(frameDiv) {
  var tooltip = function tooltip(frameDiv) {
    var div = document.createElement('DIV');
    div.className = "tooltip";
    this._div = div;
    this.message = '';
    frameDiv.appendChild(div);
  };

  tooltip.prototype.setVisible = function (visible) {
    if (visible) {
      this._div.style.right = '10px';
    } else {
      this._div.style.right = '-300px';
    }
  };

  tooltip.prototype.showAt = function (message, top) {
    //top:200px => string
    if (top) {
      this._div.style.top = top;
    }

    if (message) {
      this.setVisible(true);
      this._div.innerHTML = message;
    }
  };

  return new tooltip(frameDiv);
}

var ParticleSystem = /*#__PURE__*/function () {
  function ParticleSystem() {
    _classCallCheck(this, ParticleSystem);

    this.emitterModelMatrix = new Cesium.Matrix4();
    this.translation = new Cesium.Cartesian3();
    this.rotation = new Cesium.Quaternion();
    this.hpr = new Cesium.HeadingPitchRoll();
    this.trs = new Cesium.TranslationRotationScale();
    this.gravityScratch = new Cesium.Cartesian3();
    this.state = null;
    this.particleSystem = null;
    this.gravity = 1; // 烟花

    this.fireWokes = [];
    this.emitterInitialLocation = new Cesium.Cartesian3(0.0, 0.0, 200.0);
    this.emitterModelMatrixScratch = new Cesium.Matrix4();
    this.applyGravity;
  }

  _createClass(ParticleSystem, [{
    key: "create",
    value: function create(state, position, positions) {
      var _this = this;

      //模型位置/区域火位置
      if (Cesium.defaultValue(state)) {
        this.state = state;
        this.gravity = state.gravity;

        var applyGravity = function applyGravity(p, dt) {
          var position = p.position;
          Cesium.Cartesian3.normalize(position, _this.gravityScratch);
          Cesium.Cartesian3.multiplyByScalar(_this.gravityScratch, Number(_this.gravity) * dt, _this.gravityScratch);
          p.velocity = Cesium.Cartesian3.add(p.velocity, _this.gravityScratch, p.velocity);
        };

        this.particleSystem = viewer.scene.primitives.add(new Cesium.ParticleSystem({
          image: state.image,
          startColor: Cesium.Color.fromCssColorString(state.startColor),
          endColor: Cesium.Color.fromCssColorString(state.endColor),
          startScale: Number(state.startScale),
          endScale: Number(state.endScale),
          minimumParticleLife: Number(state.particleLife[0]),
          maximumParticleLife: Number(state.particleLife[1]),
          minimumSpeed: Number(state.speed[0]),
          maximumSpeed: Number(state.speed[1]),
          imageSize: new Cesium.Cartesian2(Number(state.particleSize), Number(state.particleSize)),
          emissionRate: Number(state.emissionRate),
          lifetime: Number(state.lifetime),
          //循环是否开启
          loop: true,
          //爆炸效果
          bursts: state.bursts,
          emitter: this.computeEmitter(state.emitter, positions),
          // emitter: new Cesium.ConeEmitter(Cesium.Math.toRadians(60)),
          // emitter:new Cesium.CircleEmitter(42, 35),
          // emitter:new Cesium.CircleEmitter(2.0),
          emitterModelMatrix: this.computeEmitterModelMatrix(undefined, undefined, position),
          updateCallback: applyGravity,
          sizeInMeters: true,
          modelMatrix: this.computeModelMatrix(position),
          performance: false
        }));
        return this.particleSystem;
      }
    }
  }, {
    key: "computeModelMatrix",
    value: function computeModelMatrix(position) {
      if (!position) return Cesium.Matrix4.IDENTITY;
      return Cesium.Transforms.eastNorthUpToFixedFrame(position, undefined, new Cesium.Matrix4()); // return Cesium.Transforms.eastNorthUpToFixedFrame(Cesium.Cartesian3.fromDegrees(116.381828897766, 39.981967807373));
    }
  }, {
    key: "computeEmitterModelMatrix",
    value: function computeEmitterModelMatrix(HeadingPitchRoll, translation, position) {
      if (!position) return Cesium.Matrix4.IDENTITY;
      this.hpr = Cesium.HeadingPitchRoll.fromDegrees(0, 0, 0, this.hpr);
      this.trs.translation = Cesium.Cartesian3.fromElements(0, 0, 4, this.translation);
      if (HeadingPitchRoll) this.hpr = Cesium.HeadingPitchRoll.fromDegrees(HeadingPitchRoll.heading, HeadingPitchRoll.pitch, HeadingPitchRoll.roll, this.hpr);
      if (translation) this.trs.translation = Cesium.Cartesian3.fromElements(translation.x, translation.y, translation.z, this.translation);
      this.trs.rotation = Cesium.Quaternion.fromHeadingPitchRoll(this.hpr, this.rotation);
      console.log(this.hpr);
      return Cesium.Matrix4.fromTranslationRotationScale(this.trs, this.emitterModelMatrix);
    }
  }, {
    key: "computeEmitterModelMatrixByHpr",
    value: function computeEmitterModelMatrixByHpr(hpr, translation) {
      console.log(123); // hpr.roll = 0;
      // //调节粒子的发射方向
      // if (translation)
      //     this.trs.translation = Cesium.Cartesian3.fromElements(translation.x, translation.y, translation.z, this.translation);
      // this.trs.rotation = Cesium.Quaternion.fromHeadingPitchRoll(hpr, this.rotation);
      // return Cesium.Matrix4.fromTranslationRotationScale(this.trs, this.emitterModelMatrix);

      for (var key in hpr) {
        if (hpr[key] != 0) this.hpr[key] -= hpr[key];
      }

      this.trs.rotation = Cesium.Quaternion.fromHeadingPitchRoll(this.hpr, this.rotation);
      return Cesium.Matrix4.fromTranslationRotationScale(this.trs, this.emitterModelMatrix);
    }
  }, {
    key: "computeEmitter",
    value: function computeEmitter(emitterOptions, positions) {
      var _Cesium$Math;

      var emitter;
      var type = emitterOptions[0];
      var data = emitterOptions[1];

      switch (type) {
        case "CircleEmitter":
          emitter = _construct(Cesium.CircleEmitter, _toConsumableArray(data));
          break;

        case "SphereEmitter":
          emitter = _construct(Cesium.SphereEmitter, _toConsumableArray(data));
          break;

        case "ConeEmitter":
          emitter = new Cesium.ConeEmitter((_Cesium$Math = Cesium.Math).toRadians.apply(_Cesium$Math, _toConsumableArray(data)));
          break;

        case "BoxEmitter":
          emitter = new Cesium.BoxEmitter(_construct(Cesium.Cartesian3, _toConsumableArray(data)));
          break;

        case "PolygonEmitter":
          emitter = new Cesium.PolygonEmitter(positions); //关闭时，拉远看粒子数量不会减少
          // setTimeout(()=>this.particleSystem.lodRangeScale=100,1000)

          break;

        default:
          emitter = new Cesium.CircleEmitter(2.0);
          break;
      }

      return emitter;
    } // function computeModelMatrix(entity, time) {
    //     var position = Cesium.Property.getValueOrUndefined(entity.position, time, new Cesium.Cartesian3());
    //     if (!Cesium.defined(position)) {
    //         return undefined;
    //     }
    //     var orientation = Cesium.Property.getValueOrUndefined(entity.orientation, time, new Cesium.Quaternion());
    //     if (!Cesium.defined(orientation)) {
    //         var modelMatrix = Cesium.Transforms.eastNorthUpToFixedFrame(position, undefined, new Cesium.Matrix4());
    //     } else {
    //         modelMatrix = Cesium.Matrix4.fromRotationTranslation(Cesium.Matrix3.fromQuaternion(orientation, new Cesium.Matrix3()), position, new Cesium.Matrix4());
    //     }
    //     return modelMatrix;
    //  }

  }, {
    key: "clear",
    value: function clear() {
      if (!Cesium.defaultValue(this.particleSystem)) return;

      viewer.scene._primitives.remove(this.particleSystem);
    }
  }, {
    key: "createFirework",
    value: function createFirework(offset, color, bursts, centerPosition) {
      var position = Cesium.Cartesian3.add(this.emitterInitialLocation, offset, new Cesium.Cartesian3());
      var emitterModelMatrix = Cesium.Matrix4.fromTranslation(position, this.emitterModelMatrixScratch);

      function applyGravity(particle, dt) {
        var position = particle.position;
        var gravityVector = Cesium.Cartesian3.normalize(position, new Cesium.Cartesian3());
        Cesium.Cartesian3.multiplyByScalar(gravityVector, 1 * dt, gravityVector);
        particle.velocity = Cesium.Cartesian3.add(particle.velocity, gravityVector, particle.velocity);
      }

      var fireWoke = viewer.scene.primitives.add(new Cesium.ParticleSystem({
        // image: getImage(),
        image: 'public/img/particle/flaretrail6.png',
        startColor: color,
        endColor: color.withAlpha(0.0),
        // particleLife: 0.5,
        minimumParticleLife: 1,
        maximumParticleLife: 2,
        speed: 80.0,
        // minimumSpeed: 80,
        // maximumSpeed: 120,
        imageSize: new Cesium.Cartesian2(15, 15),
        emissionRate: 0,
        emitter: new Cesium.SphereEmitter(0.1),
        bursts: bursts,
        lifetime: 12,
        updateCallback: applyGravity,
        modelMatrix: this.computeModelMatrix(centerPosition),
        emitterModelMatrix: emitterModelMatrix,
        performance: false
      }));
      this.fireWokes.push(fireWoke);
    }
  }, {
    key: "clearFireWoke",
    value: function clearFireWoke() {
      this.fireWokes.forEach(function (fw) {
        viewer.scene._primitives.remove(fw);
      });
      this.fireWokes.length = 0;
    }
  }, {
    key: "getState",
    get: function get() {
      return this.state;
    }
  }, {
    key: "setNewState",
    set: function set(newState) {
      if (!Cesium.defaultValue(newState)) {
        return;
      }

      this.state = newState;
    }
  }]);

  return ParticleSystem;
}();

var config = [{
  particleType: 'flame',
  particleList: [{
    image: 'public/img/particle/基础火焰.png',
    startColor: 'rgba(255, 255, 255, 0.3)',
    endColor: 'rgba(0, 0, 0, 0)',
    lifetime: 6.0,
    loop: true,
    sizeInMeters: true,
    //
    emissionRate: 50.0,
    gravity: 0.0,
    particleLife: [1.5, 1.6],
    speed: [3.5, 4],
    startScale: 2.5,
    endScale: 1.0,
    particleSize: 2,
    emitter: ['ConeEmitter', [60]]
  }, {
    image: 'public/img/particle/环状火焰-火焰.png',
    startColor: 'rgba(255, 255, 255, 0.3)',
    endColor: 'rgba(102, 76.5, 0, 0)',
    lifetime: 6.0,
    loop: true,
    sizeInMeters: true,
    //
    emissionRate: 200.0,
    gravity: 0.0,
    particleLife: [3, 4],
    speed: [0.1, 3],
    startScale: 1,
    endScale: 2,
    particleSize: 5,
    emitter: ['CircleEmitter', [30, 25]]
  }, {
    image: 'public/img/particle/基础火焰.png',
    startColor: 'rgba(255, 255, 255, 0.3)',
    endColor: 'rgba(0, 0, 0, 0)',
    lifetime: 16.0,
    loop: true,
    sizeInMeters: true,
    //
    emissionRate: 40.0,
    gravity: 0.0,
    particleLife: [7, 7],
    speed: [4, 4],
    startScale: 1,
    endScale: 1.5,
    particleSize: 1,
    emitter: ['CircleEmitter', [0.2]]
  }, {
    image: 'public/img/particle/流淌火-火焰.png',
    startColor: 'rgba(255, 255, 255, 0.8)',
    endColor: 'rgba(0, 0, 0, 0)',
    lifetime: 16.0,
    loop: true,
    sizeInMeters: true,
    //
    emissionRate: 1800.0,
    gravity: 1.0,
    particleLife: [1.5, 5],
    speed: [6, 24],
    startScale: 2,
    endScale: 4,
    particleSize: 6,
    emitter: ['PolygonEmitter', []]
  }, {
    image: 'public/img/particle/爆炸起火.png',
    startColor: 'rgba(255, 255, 255, 1)',
    endColor: 'rgba(51,51, 51, 0)',
    lifetime: 5,
    loop: true,
    sizeInMeters: true,
    //
    emissionRate: 30,
    gravity: 0.5,
    particleLife: [1.6, 2.2],
    speed: [3, 4],
    startScale: 3,
    endScale: 1.5,
    particleSize: 2,
    emitter: ['ConeEmitter', [65]]
  }]
}, {
  particleType: 'fountain',
  particleList: [{
    image: 'public/img/particle/水柱.png',
    startColor: 'rgba(255, 255, 255, 0.6)',
    endColor: 'rgba(204, 219, 255, 0.4)',
    lifetime: 16.0,
    loop: true,
    sizeInMeters: true,
    //
    emissionRate: 40.0,
    gravity: -2.6,
    particleLife: [5, 6],
    speed: [9, 9.5],
    startScale: 1,
    endScale: 20.0,
    particleSize: 1,
    emitter: ['CircleEmitter', [0.2]]
  }, {
    image: 'public/img/particle/水柱.png',
    startColor: 'rgba(146, 170, 193, 1)',
    endColor: 'rgba(146, 170, 193, 0)',
    lifetime: 16.0,
    loop: true,
    sizeInMeters: true,
    //
    emissionRate: 40.0,
    gravity: -0.5,
    particleLife: [7, 7],
    speed: [4, 4],
    startScale: 1,
    endScale: 1.5,
    particleSize: 1,
    emitter: ['CircleEmitter', [0.2]]
  }]
} // {
//     particleType: 'fireWork',
//     particleList: [
//         {
//             image: 'public/img/particle/flaretrail6.png',
//             startColor: 'rgba(255, 255, 255, 0.6)',
//             endColor: 'rgba(204, 219, 255, 0)',
//             lifetime: 10.0,
//             loop: true,
//             sizeInMeters: true, //
//             emissionRate: 0,
//             gravity: -3.5,
//             particleLife:[0.3,1],
//             speed:[100,100],
//             startScale: 1,
//             endScale: 20.0,
//             particleSize: 1,
//             emitter:['SphereEmitter',[0.1]]
//         },
//     ]
// }
];

function particleSystem(props) {
  // 设置默认值数据
  var state = reactive({
    particles: [{
      id: 0,
      iconfont: "iconhuoyan",
      particleName: "火焰"
    }, {
      id: 1,
      iconfont: "iconshui",
      particleName: "水"
    }, {
      id: 2,
      iconfont: "iconyanhua",
      particleName: "烟花"
    }],
    particleSelectedId: 0,
    flameTyle: '0',
    fountainTyle: '0',
    ringRadius: [30, 25],
    emissionRate: 50,
    particleSize: 2,
    particleLife: [1.5, 1.6],
    speed: [3.5, 4],
    startScale: 2.5,
    endScale: 1,
    gravity: 0,
    lifetime: 6,
    particleSystemType: "conical",
    image: 'public/img/particle/基础火焰.png',
    startColor: 'rgba(255, 255, 255, 0.3)',
    endColor: 'rgba(0, 0, 0, 0)',
    visibleModel: true,
    visibleParameter: false,
    emitter: ['ConeEmitter', [60]],
    bursts: [] //爆炸

  }); // 传入props改变默认值

  if (props) {
    for (var key in props) {
      if (state.hasOwnProperty(key)) {
        if (props[key] != undefined) state[key] = props[key];
      } else {
        tool.Message.errorMsg(resource.AttributeError + key);
      }
    }
  } // 初始化数据


  var currentSelectedEntity, selectParticleSystem, s3mInstanceColc;
  var isAddParticleSystem = false;
  var entityParticlePairs = new Map(); // Entity和点光源对象的键值对

  var modelUrl = 'public/data/s3m/box.s3m';
  var modelEditor;
  var flowingFires = []; //烟花默认参数设置

  var fireWorkSystem;
  var numberOfFireworks = 18;
  var xMin = -600.0;
  var xMax = 600.0;
  var yMin = -600.0;
  var yMax = 600.0;
  var zMin = 0.0;
  var zMax = 200.0;
  var colorOptions = [{
    minimumRed: 0.95,
    green: 0.0,
    minimumBlue: 0.8,
    alpha: 1.0
  }, {
    red: 0.0,
    minimumGreen: 0.75,
    minimumBlue: 0.8,
    alpha: 1.0
  }, {
    red: 0.0,
    green: 0.0,
    minimumBlue: 0.8,
    alpha: 1.0
  }, {
    minimumRed: 0.9,
    minimumGreen: 0.9,
    blue: 0.0,
    alpha: 1.0
  }];

  if (storeState.isViewer) {
    if (!window.tooltip) {
      window.tooltip = createTooltip$1(viewer._element);
    }

    init();
  } //viewer 初始化完成的监听


  watch(function () {
    return storeState.isViewer;
  }, function (val) {
    if (val) {
      if (!window.tooltip) {
        window.tooltip = createTooltip$1(viewer._element);
      }

      init();
    }
  });

  function init() {
    s3mInstanceColc = new Cesium.S3MInstanceCollection(viewer.scene._context);
    viewer.scene.primitives.add(s3mInstanceColc);
  }

  function addFlame(position) {
    var particleSystem = new ParticleSystem();
    particleSystem.create(state, position);
    addModel(position, particleSystem);
    selectParticleSystem = particleSystem;
    console.log(particleSystem);
  } //烟花


  function addFireWork(position) {
    // 参数场景默认
    setSceneForFireWork(true);
    fireWorkSystem = new ParticleSystem();

    for (var i = 0; i < numberOfFireworks; ++i) {
      var x = Cesium.Math.randomBetween(xMin, xMax);
      var y = Cesium.Math.randomBetween(yMin, yMax);
      var z = Cesium.Math.randomBetween(zMin, zMax);
      var offset = new Cesium.Cartesian3(x, y, z);
      var bursts = [];

      for (var j = 0; j < 3; ++j) {
        bursts.push(new Cesium.ParticleBurst({
          time: Cesium.Math.nextRandomNumber() * 12,
          minimum: 400,
          maximum: 400
        }));
      }

      var color = Cesium.Color.fromRandom(colorOptions[i % colorOptions.length]);
      fireWorkSystem.createFirework(offset, color, bursts, position);
    }

    right_click_removeEvent();
  }

  function setSceneForFireWork(isFlage) {
    viewer.scene.globe.show = isFlage ? false : true;
    viewer.scene.sun.show = isFlage ? false : true;
    viewer.scene.globe.enableLighting = isFlage ? false : true;
    viewer.scene.particlePostRender.quality = isFlage ? 1.0 : 0.25;
    viewer.scene.bloomEffect.show = !isFlage ? false : true;
    viewer.scene.bloomEffect.threshold = isFlage ? 0.8 : 0;
    viewer.scene.bloomEffect.bloomIntensity = isFlage ? 3.6 : 1.34;
    viewer.scene.skyAtmosphere.show = isFlage ? false : true;
  } // 喷射火


  function addFJetFire() {
    if (!window.handlerPolyline) {
      initHandler("Polyline");
    }

    var particleSystem = new ParticleSystem();
    handlerDrawing("Polyline").then(function (res) {
      var handlerPolyline = window.handlerPolyline;
      handlerPolyline.polyline.show = false;
      window.polylineTransparent.show = false; //半透线隐藏

      handlerPolyline.deactivate();
      tooltip.setVisible(false);
      var positions = res.result.object.positions;
      particleSystem.create(state, positions[0]);
      selectParticleSystem = particleSystem; // let heading0 = tool.getAngleAndRadian(positions[0], positions[1]).radian;
      // heading0 = heading0 >= Cesium.Math.PI ? heading0 - Cesium.Math.PI : heading0 + Cesium.Math.PI;
      // let pitch0 = tool.getPitch(positions[0], positions[1]).radian;
      // pitch0 = pitch0<0?-pitch0:pitch0;
      // addModel(positions[0], selectParticleSystem,{ heading: heading0, pitch: 0, roll: pitch0 });

      addModel(positions[0], selectParticleSystem);
      var heading = tool.getAngleAndRadian(positions[0], positions[1]).angle;
      heading = heading - 90 >= 0 ? heading - 90 : heading + 270;
      var pitch = tool.getPitch(positions[0], positions[1]).angle - 90;
      console.log(heading, pitch);
      var hpr = {
        heading: heading,
        pitch: pitch,
        roll: 0
      };
      var translation = {
        x: 0,
        y: 0,
        z: 2
      };
      selectParticleSystem.particleSystem.emitterModelMatrix = selectParticleSystem.computeEmitterModelMatrix(hpr, translation, true);
    }, function (err) {
      console.log(err);
    });
    window.handlerPolyline.activate();
  } // 流淌火


  function addFlowingFire() {
    flowingFires.forEach(function (ps) {
      return ps.clear();
    });
    flowingFires.length = 0;

    if (!window.handlerPolygon) {
      initHandler("Polygon");
    }

    handlerDrawing("Polygon", false).then(function (res) {
      tooltip.setVisible(false);
      var handlerPolygon = window.handlerPolygon;
      handlerPolygon.polygon.show = false;
      handlerPolygon.polyline.show = false;
      handlerPolygon.deactivate();
      var particleSystem = new ParticleSystem();
      particleSystem.create(state, undefined, res.result.object.positions);
      selectParticleSystem = particleSystem;
      flowingFires.push(particleSystem);
    }, function (err) {
      console.log(err);
    });
    window.handlerPolygon.activate();
  }

  function click_addParticle(e) {
    if (isAddParticleSystem) {
      var centerPosition = viewer.scene.pickPosition(e.message.position);
      if (state.particleSelectedId === 0) addFlame(centerPosition);else if (state.particleSelectedId === 1) addFountain(centerPosition);else {
        addFireWork(centerPosition);
      }
    } else {
      var symbol = viewer.scene.pick(e.message.position) || viewer.selectedEntity;

      if (symbol && symbol.id && typeof symbol.id === 'string' && symbol.id.indexOf("particle-model-") != -1) {
        if (currentSelectedEntity && currentSelectedEntity.id === symbol.id.id) return;
        currentSelectedEntity = symbol;
        selectParticleSystem = entityParticlePairs.get(symbol.id);
        if (!modelEditor) addModelEditor(symbol.primitive);else modelEditor.setEditObject(symbol.primitive);
        return;
      }

      currentSelectedEntity = undefined;
      selectParticleSystem = undefined;
      if (modelEditor) modelEditor.deactivate();
    }
  }

  function right_click_removeEvent() {
    window.tooltip.setVisible(false);
    document.body.classList.remove("measureCur"); // viewer.eventManager.removeEventListener("CLICK", click_addParticle);

    isAddParticleSystem = false;
    viewer.eventManager.removeEventListener("RIGHT_CLICK", right_click_removeEvent); //移除鼠标点击事件监听
  }

  function addParticle() {
    viewer.eventManager.addEventListener("CLICK", click_addParticle, true);
    viewer.eventManager.addEventListener("RIGHT_CLICK", right_click_removeEvent);

    if (state.particleSelectedId == 0 && state.flameTyle == '2') {
      window.tooltip.showAt(' <p>点击鼠标左键开始绘制两点</p><p>右键单击结束绘制</p>', '400px');
      isAddParticleSystem = false;
      addFJetFire();
      return;
    }

    if (state.particleSelectedId == 0 && state.flameTyle == '3') {
      window.tooltip.showAt(' <p>点击鼠标左键绘制区域</p><p>右键单击结束分析</p>', '400px');
      isAddParticleSystem = false;
      addFlowingFire();
      return;
    }

    if (state.particleSelectedId == 1 && state.fountainTyle == '1') {
      window.tooltip.showAt(' <p>点击鼠标左键开始绘制两点</p><p>右键单击结束绘制</p>', '400px');
      isAddParticleSystem = false;
      addFJetFire();
      return;
    }

    viewer.enableCursorStyle = false;
    viewer._element.style.cursor = "";
    document.body.classList.add("measureCur");
    isAddParticleSystem = true;

    if (state.particleSelectedId == 2) {
      window.tooltip.showAt(' <p>点击鼠标左键确认烟花中心位置</p>', '400px');
      return;
    }

    window.tooltip.showAt(' <p>点击鼠标左键确认位置</p><p>右键单击结束添加</p><p>选中模型进行删除和编辑</p> ', '400px'); // if(state.particleSelectedId === 0)
    // addFlame();
  }

  function addModelEditor(model) {
    modelEditor = new Cesium.ModelEditor({
      model: model,
      scene: viewer.scene,
      axesShow: {
        "translation": true,
        "rotation": false,
        "scale": false
      }
    });
    modelEditor.activate();
    modelEditor.changedEvt.addEventListener(function (param) {
      var Cartesian3 = new Cesium.Cartesian3();
      Cesium.Matrix4.getTranslation(param.modelMatrix, Cartesian3);

      if (Cartesian3 && selectParticleSystem) {
        selectParticleSystem.particleSystem.modelMatrix = selectParticleSystem.computeModelMatrix(Cartesian3); //旋转
        // var Matrix3 = new Cesium.Matrix3();
        // Cesium.Matrix4.getRotation(param.modelMatrix, Matrix3);
        // let quaternion = new Cesium.Quaternion();
        // Cesium.Quaternion.fromRotationMatrix(param.modelMatrix, quaternion);
        // let hpr = new Cesium.HeadingPitchRoll()
        // Cesium.HeadingPitchRoll.fromQuaternion(quaternion, hpr)
        // console.log(hpr)
        // if(hpr)

        selectParticleSystem.particleSystem.emitterModelMatrix = selectParticleSystem.computeEmitterModelMatrixByHpr(param.rotationAddtion);
      }
    });
  }

  function addModel(position, particleSystem, hpr) {
    var id = "particle-model-" + new Date().getTime();

    if (hpr) {
      s3mInstanceColc.add(modelUrl, {
        id: id,
        position: position,
        hpr: hpr
      });
    } else {
      s3mInstanceColc.add(modelUrl, {
        id: id,
        position: position // scale: new Cesium.Cartesian3(6, 6, 6),
        // offset:new Cesium.Cartesian3(0, 0, -3),

      });
    }

    currentSelectedEntity = s3mInstanceColc.getInstance(modelUrl, id);
    entityParticlePairs.set(id, particleSystem);
  }

  function clear() {
    if (selectParticleSystem) selectParticleSystem.clear();

    if (fireWorkSystem) {
      fireWorkSystem.clearFireWoke();
      setSceneForFireWork(false);
      fireWorkSystem = null;
    }

    if (currentSelectedEntity) {
      entityParticlePairs["delete"](currentSelectedEntity.id);
      s3mInstanceColc.removeInstance(modelUrl, currentSelectedEntity.id);
      currentSelectedEntity = null;
    }

    if (entityParticlePairs.size === 0) viewer.eventManager.removeEventListener("CLICK", click_addParticle);
    if (modelEditor) modelEditor.deactivate();
    isAddParticleSystem = false;
    selectParticleSystem = null;
    clearHandlerDrawing();
    viewer.enableCursorStyle = true;
    document.body.classList.remove("measureCur");
    tooltip.setVisible(false);
    clearHandlerDrawing('Polygon');
    flowingFires.forEach(function (ps) {
      return ps.clear();
    });
    flowingFires.length = 0;
  } // 水柱


  function addFountain(position) {
    var particleSystem = new ParticleSystem();
    particleSystem.create(state, position);
    addModel(position, particleSystem);
    selectParticleSystem = particleSystem;
    console.log(particleSystem);
  } // 监听


  watch(function () {
    return state.particleSelectedId;
  }, function (val) {
    selectParticleSystem = null;
    currentSelectedEntity = null;

    if (val === 2) {
      state.visibleParameter = false;
    }

    var particleParameter = {};
    if (val === 0) particleParameter = config[val].particleList[state.flameTyle];else if (val === 1) particleParameter = config[val].particleList[state.fountainTyle];

    for (var _key in particleParameter) {
      if (state.hasOwnProperty(_key)) {
        state[_key] = particleParameter[_key];
      }
    }
  });
  watch(function () {
    return state.flameTyle;
  }, function (val) {
    selectParticleSystem = null;
    currentSelectedEntity = null;
    if (modelEditor) modelEditor.deactivate();
    if (val == '4') state.bursts = [new Cesium.ParticleBurst({
      time: 1.5,
      minimum: 80,
      maximum: 150
    }), new Cesium.ParticleBurst({
      time: 1.7,
      minimum: 150,
      maximum: 200
    })];else state.bursts = [];
    var particleParameter = config[state.particleSelectedId].particleList[val];

    for (var _key2 in particleParameter) {
      if (state.hasOwnProperty(_key2)) {
        state[_key2] = particleParameter[_key2];
      }
    }
  });
  watch(function () {
    return state.fountainTyle;
  }, function (val) {
    selectParticleSystem = null;
    currentSelectedEntity = null;
    if (modelEditor) modelEditor.deactivate();
    var particleParameter = config[state.particleSelectedId].particleList[val];

    for (var _key3 in particleParameter) {
      if (state.hasOwnProperty(_key3)) {
        state[_key3] = particleParameter[_key3];
      }
    }
  });
  watch(function () {
    return state.emissionRate;
  }, function (val) {
    if (!selectParticleSystem) return;
    selectParticleSystem.particleSystem.emissionRate = Number(val);
  });
  watch(function () {
    return state.particleSize;
  }, function (val) {
    if (!selectParticleSystem) return;
    var particleSize = Number(val);
    selectParticleSystem.particleSystem.minimumImageSize.x = particleSize;
    selectParticleSystem.particleSystem.minimumImageSize.y = particleSize;
    selectParticleSystem.particleSystem.maximumImageSize.x = particleSize;
    selectParticleSystem.particleSystem.maximumImageSize.y = particleSize;
  });
  watch(function () {
    return state.particleLife;
  }, function (val) {
    if (!selectParticleSystem) return;
    selectParticleSystem.particleSystem.minimumParticleLife = Number(val[0]);
    selectParticleSystem.particleSystem.maximumParticleLife = Number(val[1]);
  });
  watch(function () {
    return state.speed;
  }, function (val) {
    if (!selectParticleSystem) return;
    selectParticleSystem.particleSystem.minimumSpeed = Number(val[0]);
    selectParticleSystem.particleSystem.maximumSpeed = Number(val[1]);
  });
  watch(function () {
    return state.startScale;
  }, function (val) {
    if (!selectParticleSystem) return;
    selectParticleSystem.particleSystem.startScale = Number(val);
  });
  watch(function () {
    return state.endScale;
  }, function (val) {
    if (!selectParticleSystem) return;
    selectParticleSystem.particleSystem.endScale = Number(val);
  });
  watch(function () {
    return state.particleSystemType;
  }, function (val) {
    if (!selectParticleSystem) return;

    switch (val) {
      case "circular":
        selectParticleSystem.particleSystem.emitter = new Cesium.CircleEmitter(2.0);
        break;

      case "spheroid":
        selectParticleSystem.particleSystem.emitter = new Cesium.SphereEmitter(2.5);
        break;

      case "conical":
        selectParticleSystem.particleSystem.emitter = new Cesium.ConeEmitter(Cesium.Math.toRadians(30.0));
        break;

      case "box":
        selectParticleSystem.particleSystem.emitter = new Cesium.BoxEmitter(new Cesium.Cartesian3(10.0, 10.0, 10.0));
        break;
    }
  });
  watch(function () {
    return state.image;
  }, function (val) {
    if (!selectParticleSystem) return;
    selectParticleSystem.particleSystem.image = val;
  });
  watch(function () {
    return state.startColor;
  }, function (val) {
    if (!selectParticleSystem) return;
    selectParticleSystem.particleSystem.startColor = Cesium.Color.fromCssColorString(val);
  });
  watch(function () {
    return state.endColor;
  }, function (val) {
    if (!selectParticleSystem) return;
    selectParticleSystem.particleSystem.endColor = Cesium.Color.fromCssColorString(val);
  });
  watch(function () {
    return state.visibleModel;
  }, function (val) {
    s3mInstanceColc.visible = val;
    if (modelEditor) modelEditor.deactivate();
  });
  watch(function () {
    return state.ringRadius;
  }, function (val) {
    if (!selectParticleSystem) return;
    selectParticleSystem.particleSystem.emitter = new Cesium.CircleEmitter(val[1], val[0]);
    if (state.emitter[0] === 'CircleEmitter') state.emitter[1] = val;
  });
  watch(function () {
    return state.lifetime;
  }, function (val) {
    if (!selectParticleSystem) return;
    selectParticleSystem.particleSystem.lifetime = Number(val);
  });
  watch(function () {
    return state.gravity;
  }, function (val) {
    if (!selectParticleSystem) return;
    selectParticleSystem.gravity = Number(val);
  }); // 销毁

  onBeforeUnmount(function () {});
  return _objectSpread2(_objectSpread2({}, toRefs(state)), {}, {
    addParticle: addParticle,
    clear: clear
  });
}

var script = {
  name: "Sm3dParticleSystem",
  props: {},
  data: function data() {
    return {};
  },
  setup: function setup(props) {
    var _particleSystem = particleSystem(props),
        particles = _particleSystem.particles,
        particleSelectedId = _particleSystem.particleSelectedId,
        flameTyle = _particleSystem.flameTyle,
        fountainTyle = _particleSystem.fountainTyle,
        ringRadius = _particleSystem.ringRadius,
        emissionRate = _particleSystem.emissionRate,
        particleSize = _particleSystem.particleSize,
        particleLife = _particleSystem.particleLife,
        speed = _particleSystem.speed,
        startScale = _particleSystem.startScale,
        endScale = _particleSystem.endScale,
        gravity = _particleSystem.gravity,
        particleSystemType = _particleSystem.particleSystemType,
        visibleModel = _particleSystem.visibleModel,
        visibleParameter = _particleSystem.visibleParameter,
        addParticle = _particleSystem.addParticle,
        clear = _particleSystem.clear;

    return {
      particles: particles,
      particleSelectedId: particleSelectedId,
      flameTyle: flameTyle,
      fountainTyle: fountainTyle,
      ringRadius: ringRadius,
      emissionRate: emissionRate,
      particleSize: particleSize,
      particleLife: particleLife,
      speed: speed,
      startScale: startScale,
      endScale: endScale,
      gravity: gravity,
      particleSystemType: particleSystemType,
      visibleModel: visibleModel,
      visibleParameter: visibleParameter,
      addParticle: addParticle,
      clear: clear
    };
  }
};

var _hoisted_1 = {
  id: "scan-effect-panel",
  "class": "sm-panel"
};
var _hoisted_2 = {
  "class": "sm-function-module-sub-section",
  style: {
    "margin": "0"
  }
};
var _hoisted_3 = {
  "class": "sm-half-L symbolic"
};
var _hoisted_4 = ["onClick"];
var _hoisted_5 = {
  style: {
    "width": "100%"
  }
};
var _hoisted_6 = {
  "class": "sm-half-L"
};
var _hoisted_7 = {
  style: {
    "width": "30%"
  }
};
var _hoisted_8 = {
  value: "0"
};
var _hoisted_9 = {
  value: "1"
};
var _hoisted_10 = {
  value: "2"
};
var _hoisted_11 = {
  value: "3"
};
var _hoisted_12 = {
  value: "4"
};
var _hoisted_13 = {
  "class": "sm-half-L"
};
var _hoisted_14 = {
  style: {
    "width": "30%"
  }
};
var _hoisted_15 = {
  value: "0"
};
var _hoisted_16 = {
  value: "1"
};
var _hoisted_17 = {
  "class": "sm-half-L flex-between"
};
var _hoisted_18 = {
  style: {
    "width": "auto"
  }
};
var _hoisted_19 = {
  style: {
    "width": "auto"
  }
};
var _hoisted_20 = {
  "class": "sm-half-L"
};
var _hoisted_21 = {
  style: {
    "width": "30%"
  }
};
var _hoisted_22 = {
  "class": "sm-half-L"
};
var _hoisted_23 = {
  style: {
    "width": "30%"
  }
};
var _hoisted_24 = {
  "class": "sm-half-L"
};
var _hoisted_25 = {
  style: {
    "width": "30%"
  }
};
var _hoisted_26 = {
  "class": "sm-half-L"
};
var _hoisted_27 = {
  style: {
    "width": "30%"
  }
};
var _hoisted_28 = {
  "class": "sm-half-L"
};
var _hoisted_29 = {
  style: {
    "width": "30%"
  }
};
var _hoisted_30 = {
  "class": "sm-half-L"
};
var _hoisted_31 = {
  style: {
    "width": "30%"
  }
};
var _hoisted_32 = {
  "class": "sm-half-L"
};
var _hoisted_33 = {
  style: {
    "width": "30%"
  }
};
var _hoisted_34 = {
  "class": "sm-half-L"
};
var _hoisted_35 = {
  style: {
    "width": "30%"
  }
};
var _hoisted_36 = {
  "class": "sm-half-L"
};
var _hoisted_37 = {
  style: {
    "width": "30%"
  }
};
var _hoisted_38 = {
  value: "circular"
};
var _hoisted_39 = {
  value: "spheroid"
};
var _hoisted_40 = {
  value: "conical"
};
var _hoisted_41 = {
  value: "box"
};
var _hoisted_42 = {
  "class": "boxchild"
};
function render(_ctx, _cache, $props, $setup, $data, $options) {
  var _component_el_slider = resolveComponent("el-slider");

  var _directive_stopdrag = resolveDirective("stopdrag");

  var _directive_drag = resolveDirective("drag");

  return withDirectives((openBlock(), createElementBlock("div", _hoisted_1, [withDirectives((openBlock(), createElementBlock("div", _hoisted_2, [createElementVNode("div", _hoisted_3, [(openBlock(true), createElementBlock(Fragment, null, renderList($setup.particles, function (particle) {
    return openBlock(), createElementBlock("div", {
      key: particle.id,
      "class": normalizeClass(["symbolic-box", {
        'theme-color': particle.id === $setup.particleSelectedId
      }]),
      onClick: function onClick($event) {
        return $setup.particleSelectedId = particle.id;
      }
    }, [createElementVNode("span", {
      "class": normalizeClass(["iconfont", particle.iconfont])
    }, null, 2
    /* CLASS */
    ), createElementVNode("label", _hoisted_5, toDisplayString(particle.particleName), 1
    /* TEXT */
    )], 10
    /* CLASS, PROPS */
    , _hoisted_4);
  }), 128
  /* KEYED_FRAGMENT */
  ))]), withDirectives(createElementVNode("div", _hoisted_6, [createElementVNode("label", _hoisted_7, toDisplayString(_ctx.Resource.type), 1
  /* TEXT */
  ), withDirectives(createElementVNode("select", {
    "class": "sm-select-m",
    style: {
      "width": "66%"
    },
    "onUpdate:modelValue": _cache[0] || (_cache[0] = function ($event) {
      return $setup.flameTyle = $event;
    })
  }, [createElementVNode("option", _hoisted_8, toDisplayString(_ctx.Resource.flame), 1
  /* TEXT */
  ), createElementVNode("option", _hoisted_9, toDisplayString(_ctx.Resource.ringFire), 1
  /* TEXT */
  ), createElementVNode("option", _hoisted_10, toDisplayString(_ctx.Resource.jetFire), 1
  /* TEXT */
  ), createElementVNode("option", _hoisted_11, toDisplayString(_ctx.Resource.flowFire), 1
  /* TEXT */
  ), createElementVNode("option", _hoisted_12, toDisplayString(_ctx.Resource.explosionFire), 1
  /* TEXT */
  )], 512
  /* NEED_PATCH */
  ), [[vModelSelect, $setup.flameTyle]])], 512
  /* NEED_PATCH */
  ), [[vShow, $setup.particleSelectedId === 0]]), withDirectives(createElementVNode("div", _hoisted_13, [createElementVNode("label", _hoisted_14, toDisplayString(_ctx.Resource.type), 1
  /* TEXT */
  ), withDirectives(createElementVNode("select", {
    "class": "sm-select-m",
    style: {
      "width": "66%"
    },
    "onUpdate:modelValue": _cache[1] || (_cache[1] = function ($event) {
      return $setup.fountainTyle = $event;
    })
  }, [createElementVNode("option", _hoisted_15, toDisplayString(_ctx.Resource.fountain), 1
  /* TEXT */
  ), createElementVNode("option", _hoisted_16, toDisplayString(_ctx.Resource.fireWater), 1
  /* TEXT */
  )], 512
  /* NEED_PATCH */
  ), [[vModelSelect, $setup.fountainTyle]])], 512
  /* NEED_PATCH */
  ), [[vShow, $setup.particleSelectedId === 1]]), withDirectives(createElementVNode("div", _hoisted_17, [createElementVNode("label", _hoisted_18, [withDirectives(createElementVNode("input", {
    type: "checkbox",
    "onUpdate:modelValue": _cache[2] || (_cache[2] = function ($event) {
      return $setup.visibleModel = $event;
    })
  }, null, 512
  /* NEED_PATCH */
  ), [[vModelCheckbox, $setup.visibleModel]]), createTextVNode(" " + toDisplayString(_ctx.Resource.isEdit), 1
  /* TEXT */
  )]), createElementVNode("label", _hoisted_19, [withDirectives(createElementVNode("input", {
    type: "checkbox",
    "onUpdate:modelValue": _cache[3] || (_cache[3] = function ($event) {
      return $setup.visibleParameter = $event;
    })
  }, null, 512
  /* NEED_PATCH */
  ), [[vModelCheckbox, $setup.visibleParameter]]), createTextVNode(" " + toDisplayString(_ctx.Resource.setting), 1
  /* TEXT */
  )])], 512
  /* NEED_PATCH */
  ), [[vShow, $setup.particleSelectedId !== 2]]), withDirectives(createElementVNode("div", null, [withDirectives(createElementVNode("div", _hoisted_20, [createElementVNode("label", _hoisted_21, toDisplayString(_ctx.Resource.ringRadius), 1
  /* TEXT */
  ), createVNode(_component_el_slider, {
    modelValue: $setup.ringRadius,
    "onUpdate:modelValue": _cache[4] || (_cache[4] = function ($event) {
      return $setup.ringRadius = $event;
    }),
    min: 0,
    max: 50,
    range: "",
    step: 1,
    "input-size": "mini",
    debounce: 500,
    "tooltip-class": "tooltip-class",
    "format-tooltip": _ctx.formatTooltip,
    style: {
      "width": "66%"
    }
  }, null, 8
  /* PROPS */
  , ["modelValue", "format-tooltip"])], 512
  /* NEED_PATCH */
  ), [[vShow, $setup.flameTyle === '1']]), createElementVNode("div", _hoisted_22, [createElementVNode("label", _hoisted_23, toDisplayString(_ctx.Resource.emissionRate), 1
  /* TEXT */
  ), withDirectives(createElementVNode("input", {
    "class": "sm-input",
    style: {
      "width": "66%"
    },
    min: "0",
    type: "number",
    "onUpdate:modelValue": _cache[5] || (_cache[5] = function ($event) {
      return $setup.emissionRate = $event;
    })
  }, null, 512
  /* NEED_PATCH */
  ), [[vModelText, $setup.emissionRate]])]), createElementVNode("div", _hoisted_24, [createElementVNode("label", _hoisted_25, toDisplayString(_ctx.Resource.particleSize), 1
  /* TEXT */
  ), createVNode(_component_el_slider, {
    modelValue: $setup.particleSize,
    "onUpdate:modelValue": _cache[6] || (_cache[6] = function ($event) {
      return $setup.particleSize = $event;
    }),
    min: 0,
    step: 1,
    max: 20,
    "input-size": "mini",
    debounce: 500,
    "tooltip-class": "tooltip-class",
    style: {
      "width": "66%"
    }
  }, null, 8
  /* PROPS */
  , ["modelValue"])]), createElementVNode("div", _hoisted_26, [createElementVNode("label", _hoisted_27, toDisplayString(_ctx.Resource.particleLife), 1
  /* TEXT */
  ), createVNode(_component_el_slider, {
    modelValue: $setup.particleLife,
    "onUpdate:modelValue": _cache[7] || (_cache[7] = function ($event) {
      return $setup.particleLife = $event;
    }),
    min: 0,
    max: 15,
    range: "",
    step: 0.1,
    "input-size": "mini",
    debounce: 500,
    "tooltip-class": "tooltip-class",
    "format-tooltip": _ctx.formatTooltip,
    style: {
      "width": "66%"
    }
  }, null, 8
  /* PROPS */
  , ["modelValue", "step", "format-tooltip"])]), createElementVNode("div", _hoisted_28, [createElementVNode("label", _hoisted_29, toDisplayString(_ctx.Resource.speedRange), 1
  /* TEXT */
  ), createVNode(_component_el_slider, {
    modelValue: $setup.speed,
    "onUpdate:modelValue": _cache[8] || (_cache[8] = function ($event) {
      return $setup.speed = $event;
    }),
    min: 0,
    max: 15,
    range: "",
    step: 1,
    "input-size": "mini",
    debounce: 500,
    "tooltip-class": "tooltip-class",
    "format-tooltip": _ctx.formatTooltip,
    style: {
      "width": "66%"
    }
  }, null, 8
  /* PROPS */
  , ["modelValue", "format-tooltip"])]), createElementVNode("div", _hoisted_30, [createElementVNode("label", _hoisted_31, toDisplayString(_ctx.Resource.startScale), 1
  /* TEXT */
  ), createVNode(_component_el_slider, {
    modelValue: $setup.startScale,
    "onUpdate:modelValue": _cache[9] || (_cache[9] = function ($event) {
      return $setup.startScale = $event;
    }),
    min: 0,
    step: 0.1,
    max: 10,
    "input-size": "mini",
    debounce: 500,
    "tooltip-class": "tooltip-class",
    style: {
      "width": "66%"
    }
  }, null, 8
  /* PROPS */
  , ["modelValue", "step"])]), createElementVNode("div", _hoisted_32, [createElementVNode("label", _hoisted_33, toDisplayString(_ctx.Resource.endScale), 1
  /* TEXT */
  ), createVNode(_component_el_slider, {
    modelValue: $setup.endScale,
    "onUpdate:modelValue": _cache[10] || (_cache[10] = function ($event) {
      return $setup.endScale = $event;
    }),
    min: 0,
    step: 0.1,
    max: 20,
    "input-size": "mini",
    debounce: 500,
    "tooltip-class": "tooltip-class",
    style: {
      "width": "66%"
    }
  }, null, 8
  /* PROPS */
  , ["modelValue", "step"])]), createElementVNode("div", _hoisted_34, [createElementVNode("label", _hoisted_35, toDisplayString(_ctx.Resource.gravity), 1
  /* TEXT */
  ), createVNode(_component_el_slider, {
    modelValue: $setup.gravity,
    "onUpdate:modelValue": _cache[11] || (_cache[11] = function ($event) {
      return $setup.gravity = $event;
    }),
    min: -10,
    step: 0.1,
    max: 10,
    "input-size": "mini",
    debounce: 500,
    "tooltip-class": "tooltip-class",
    style: {
      "width": "67%"
    }
  }, null, 8
  /* PROPS */
  , ["modelValue", "step"])]), withDirectives(createElementVNode("div", _hoisted_36, [createElementVNode("label", _hoisted_37, toDisplayString(_ctx.Resource.launchType), 1
  /* TEXT */
  ), withDirectives(createElementVNode("select", {
    "class": "sm-select-m",
    style: {
      "width": "66%"
    },
    "onUpdate:modelValue": _cache[12] || (_cache[12] = function ($event) {
      return $setup.particleSystemType = $event;
    })
  }, [createElementVNode("option", _hoisted_38, toDisplayString(_ctx.Resource.circularRadiation), 1
  /* TEXT */
  ), createElementVNode("option", _hoisted_39, toDisplayString(_ctx.Resource.spheroidRadiation), 1
  /* TEXT */
  ), createElementVNode("option", _hoisted_40, toDisplayString(_ctx.Resource.conicalRadiation), 1
  /* TEXT */
  ), createElementVNode("option", _hoisted_41, toDisplayString(_ctx.Resource.boxedRadiation), 1
  /* TEXT */
  )], 512
  /* NEED_PATCH */
  ), [[vModelSelect, $setup.particleSystemType]])], 512
  /* NEED_PATCH */
  ), [[vShow, $setup.flameTyle === '0']])], 512
  /* NEED_PATCH */
  ), [[vShow, $setup.visibleParameter]]), createElementVNode("div", _hoisted_42, [createElementVNode("button", {
    onClick: _cache[13] || (_cache[13] = function () {
      return $setup.addParticle && $setup.addParticle.apply($setup, arguments);
    }),
    "class": "tbtn",
    type: "button"
  }, toDisplayString(_ctx.Resource.add), 1
  /* TEXT */
  ), createElementVNode("button", {
    onClick: _cache[14] || (_cache[14] = function () {
      return $setup.clear && $setup.clear.apply($setup, arguments);
    }),
    "class": "tbtn tbtn-margin-left",
    type: "button"
  }, toDisplayString(_ctx.Resource.clear), 1
  /* TEXT */
  )])])), [[_directive_stopdrag]])])), [[_directive_drag]]);
}

script.render = render;
script.__file = "src/components/special-effects/particle-system/particle-system.vue";

script.install = function (app) {
  app.component(script.name, script);
};

export default script;
