import { reactive, toRefs, ref, watch, onMounted, onBeforeUnmount, resolveComponent, resolveDirective, withDirectives, openBlock, createElementBlock, createElementVNode, toDisplayString, vModelText, createVNode, vModelRadio, createTextVNode, vModelCheckbox, createCommentVNode } from 'vue';

function _typeof(obj) {
  "@babel/helpers - typeof";

  if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
    _typeof = function (obj) {
      return typeof obj;
    };
  } else {
    _typeof = function (obj) {
      return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
    };
  }

  return _typeof(obj);
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);

  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    if (enumerableOnly) symbols = symbols.filter(function (sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    });
    keys.push.apply(keys, symbols);
  }

  return keys;
}

function _objectSpread2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};

    if (i % 2) {
      ownKeys(Object(source), true).forEach(function (key) {
        _defineProperty(target, key, source[key]);
      });
    } else if (Object.getOwnPropertyDescriptors) {
      Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
      ownKeys(Object(source)).forEach(function (key) {
        Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
      });
    }
  }

  return target;
}

function _toConsumableArray(arr) {
  return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread();
}

function _arrayWithoutHoles(arr) {
  if (Array.isArray(arr)) return _arrayLikeToArray(arr);
}

function _iterableToArray(iter) {
  if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter);
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

  return arr2;
}

function _nonIterableSpread() {
  throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

// 创建一个简单的store状态管理

var storeState = reactive({
  isViewer: false,
  //viewer初始化标志
  changeLayers: 0,
  //图层改变加载完毕监听
  changeGeometrys: 0 //三维分析体改变标志

});

/*
* 常用工具类
*/
//axios本版本不支持jsonp
var axiosJsonp = function axiosJsonp(url) {
  if (!url) {
    console.error('Axios.JSONP 至少需要一个url参数!');
    return;
  }

  return new Promise(function (resolve, reject) {
    window.jsonCallBack = function (result) {
      resolve(result);
    };

    var JSONP = document.createElement("script");
    JSONP.type = "text/javascript";
    JSONP.src = "".concat(url, "&callback=jsonCallBack");
    document.getElementsByTagName("head")[0].appendChild(JSONP);
    setTimeout(function () {
      document.getElementsByTagName("head")[0].removeChild(JSONP);
    }, 500);
  });
}; //判断两数组或对象相等


var isEqualArr = function isEqualArr(arg1, arg2) {
  if (!arg1 || !arg2) return true;
  var bol = true;

  if (Object.keys(arg1).length != Object.keys(arg2).length) {
    return false;
  }

  for (var key in arg1) {
    if (_typeof(arg1[key]) == 'object') {
      bol = isSame(arg1[key], arg2[key]);

      if (!bol) {
        break;
      }
    } else if (arg1[key] != arg2[key]) {
      bol = false;
      break;
    }
  }

  return bol;
}; //坐标转化
//笛卡尔转经纬度


var CartesiantoDegrees = function CartesiantoDegrees(Cartesians) {
  var array = [].concat(Cartesians);
  var positions = [];

  for (var i = 0, len = array.length; i < len; i++) {
    var cartographic = Cesium.Cartographic.fromCartesian(array[i]);
    var longitude = Cesium.Math.toDegrees(cartographic.longitude);
    var latitude = Cesium.Math.toDegrees(cartographic.latitude);
    var h = cartographic.height;

    if (positions.indexOf(longitude) == -1 && positions.indexOf(latitude) == -1) {
      positions.push(longitude);
      positions.push(latitude);
      positions.push(h);
    }
  }

  return positions;
}; //笛卡尔转经纬度(每个点是独立的对象)


var CartesiantoDegreesObjs = function CartesiantoDegreesObjs(Cartesians) {
  var array = [].concat(Cartesians);
  var positions = [];

  for (var i = 0, len = array.length; i < len; i++) {
    var cartographic = Cesium.Cartographic.fromCartesian(array[i]);
    var obj = {
      longitude: Cesium.Math.toDegrees(cartographic.longitude),
      latitude: Cesium.Math.toDegrees(cartographic.latitude),
      height: cartographic.height
    };
    positions.push(obj);
  }

  return positions;
}; // 弧度转经纬度


var CartographictoDegrees = function CartographictoDegrees(wgsPosition) {
  var longitude = Cesium.Math.toDegrees(wgsPosition.longitude);
  var latitude = Cesium.Math.toDegrees(wgsPosition.latitude);
  var height = wgsPosition.height;
  return [longitude, latitude, height];
}; //去重函数  数组


var unique = function unique(arr) {
  var res = [];
  var json = {};

  for (var i = 0; i < arr.length; i++) {
    if (!json[arr[i]]) {
      res.push(arr[i]);
      json[arr[i]] = 1;
    }
  }

  return res;
}; // 获取渐变色函数


function gradientColors(start, end, steps, gamma) {
  var i,
      j,
      ms,
      me,
      output = [],
      so = [];
  gamma = gamma || 1;

  var normalize = function normalize(channel) {
    return Math.pow(channel / 255, gamma);
  };

  start = parseColor(start).map(normalize);
  end = parseColor(end).map(normalize);

  for (i = 0; i < steps; i++) {
    ms = i / (steps - 1);
    me = 1 - ms;

    for (j = 0; j < 3; j++) {
      so[j] = pad(Math.round(Math.pow(start[j] * me + end[j] * ms, 1 / gamma) * 255).toString(16));
    }

    output.push('#' + so.join(''));
  }

  return output;

  function parseColor(hexStr) {
    return hexStr.length === 4 ? hexStr.substr(1).split('').map(function (s) {
      return 0x11 * parseInt(s, 16);
    }) : [hexStr.substr(1, 2), hexStr.substr(3, 2), hexStr.substr(5, 2)].map(function (s) {
      return parseInt(s, 16);
    });
  }

  function pad(s) {
    return s.length === 1 ? '0' + s : s;
  }
}

function getAngleAndRadian(pointA, pointB) {
  //建立以点A为原点，X轴为east,Y轴为north,Z轴朝上的坐标系
  var transform = Cesium.Transforms.eastNorthUpToFixedFrame(pointA); //向量AB

  var positionvector = Cesium.Cartesian3.subtract(pointB, pointA, new Cesium.Cartesian3()); //因transform是将A为原点的eastNorthUp坐标系中的点转换到世界坐标系的矩阵
  //AB为世界坐标中的向量
  //因此将AB向量转换为A原点坐标系中的向量，需乘以transform的逆矩阵。

  var vector = Cesium.Matrix4.multiplyByPointAsVector(Cesium.Matrix4.inverse(transform, new Cesium.Matrix4()), positionvector, new Cesium.Cartesian3()); //归一化

  var direction = Cesium.Cartesian3.normalize(vector, new Cesium.Cartesian3()); //heading

  var heading1 = Math.atan2(direction.y, direction.x) - Cesium.Math.PI_OVER_TWO;
  var radian = Cesium.Math.TWO_PI - Cesium.Math.zeroToTwoPi(heading1);
  var angle = radian * (180 / Math.PI);

  if (angle < 0) {
    angle = angle + 360;
  }

  return {
    angle: angle,
    radian: radian
  };
}

function getPitch(pointA, pointB) {
  var transfrom = Cesium.Transforms.eastNorthUpToFixedFrame(pointA);
  var vector = Cesium.Cartesian3.subtract(pointB, pointA, new Cesium.Cartesian3());
  var direction = Cesium.Matrix4.multiplyByPointAsVector(Cesium.Matrix4.inverse(transfrom, transfrom), vector, vector);
  Cesium.Cartesian3.normalize(direction, direction); //因为direction已归一化，斜边长度等于1，所以余弦函数等于direction.z

  var radian = Cesium.Math.PI_OVER_TWO - Cesium.Math.acosClamped(direction.z);
  var angle = radian * (180 / Math.PI);

  if (angle < 0) {
    angle = angle + 360;
  }

  return {
    angle: angle,
    radian: radian
  };
}

var tool = {
  axiosJsonp: axiosJsonp,
  isEqualArr: isEqualArr,
  CartesiantoDegrees: CartesiantoDegrees,
  CartesiantoDegreesObjs: CartesiantoDegreesObjs,
  unique: unique,
  gradientColors: gradientColors,
  getAngleAndRadian: getAngleAndRadian,
  CartographictoDegrees: CartographictoDegrees,
  getPitch: getPitch
};

var ResourceCN = {
  showRenderLoopErrors: '渲染时发生错误，已停止渲染。',
  AttributeError: '该组件props没有这个属性：',
  NoPickPositionSupported: "不支持深度纹理,无法绘制多边形，地形操作功能无法使用！",
  NoTerrain: "请在地形里使用地形组件！",
  initViewerWarn: '请先初始化viewer!',
  MoveMouseHeightBox: '点击鼠标左键结束矩形绘制，移动鼠标绘制box高度',
  RightClickEndDrawing: '右键单击结束绘制',
  LeftClickBottomBox: '点击鼠标左键，开始绘制矩形作为box底面',
  ClickModelAddBox: '点击模型，添加裁剪盒子',
  SkyLineWarn: "获取天际线体前，请先绘制天际线！",
  SkyLineBody: '天际线体',
  ShadowqueryWarn: "此操作需要先开启阴影！",
  VeiwshedBody: '可视体',
  VeiwshedBodyHidden: '不可视体',
  EchartsErr: "二维显示需要echarts支持，未找到相关依赖！",
  BaseMapImg: '底图',
  tip1: '<p>点击左键确定操作区域中间点</p><p>右键单击结束绘制</p>'
};

// 组件内部的语言资源：主要包括提示信息
var currentLanguage, Resource;
var cookieLanguage = getLang().toLowerCase();

function getLang() {
  //浏览器语言  IE用browserLanguage，非IE使用language进行判断
  var lang = (navigator.language || navigator.browserLanguage).toLowerCase();
  window.lang = lang; //判断portal设置语言 通过cookie获取
  //   const cookies = document.cookie.split(';');
  //   if (cookies.length > 0) {
  //     cookies.forEach(function (cookie) {
  //       const arr = cookie.split('=');
  //       if (arr[0].toLowerCase().trim() === 'language') {
  //         lang = arr[1];
  //         return;
  //       }
  //     });
  //   }

  return lang;
}

if (cookieLanguage !== undefined) {
  currentLanguage = cookieLanguage;
} else {
  currentLanguage = (navigator.language || navigator.browserLanguage).toLowerCase(); // 获取当前浏览器的语言
}

if (currentLanguage.startsWith('zh')) {
  Resource = ResourceCN;
} else if (currentLanguage.startsWith('ja')) {
  Resource = ResourceCN;
} else {
  Resource = ResourceCN;
}

var resource = Resource;

//随鼠标移动消息提示工具
function createTooltip(frameDiv) {
  var tooltip = function tooltip(frameDiv) {
    var div = document.createElement("DIV");
    div.className = "twipsy right";
    var arrow = document.createElement("DIV");
    arrow.className = "twipsy-arrow";
    div.appendChild(arrow);
    var title = document.createElement("DIV");
    title.className = "twipsy-inner";
    div.appendChild(title);
    this._div = div;
    this._title = title;
    this.message = "";
    frameDiv.appendChild(div);
    var that = this;

    div.onmousemove = function (evt) {
      that.showAt({
        x: evt.clientX,
        y: evt.clientY
      }, that.message);
    };
  };

  tooltip.prototype.setVisible = function (visible) {
    this._div.style.display = visible ? "block" : "none";
  };

  tooltip.prototype.showAt = function (position, message) {
    if (position && message) {
      this.setVisible(true);
      this._title.innerHTML = message;
      this._div.style.left = position.x + 10 + "px";
      this._div.style.top = position.y - this._div.clientHeight / 2 + "px";
      this.message = message;
    }
  };

  return new tooltip(frameDiv);
}

/**
 * 初始化
 * DrawMode：类型
 * clampMode：模式
 */

var initHandler = function initHandler(DrawMode, clampMode) {
  var clampmode = 0;

  if (clampMode) {
    clampmode = clampMode;
  }

  switch (DrawMode) {
    case "Point":
      window.handlerPoint = new Cesium.DrawHandler(viewer, Cesium.DrawMode.Point);
      break;

    case "Polyline":
      window.handlerPolyline = new Cesium.DrawHandler(viewer, Cesium.DrawMode.Line, clampmode);
      break;

    case "Polygon":
      window.handlerPolygon = new Cesium.DrawHandler(viewer, Cesium.DrawMode.Polygon, clampmode);
      break;

    case "Marker":
      window.handlerMarker = new Cesium.DrawHandler(viewer, Cesium.DrawMode.Marker, clampmode);
      break;

    case "Box":
      window.handlerBox = new Cesium.DrawHandler(viewer, Cesium.DrawMode.Box, clampmode);
      break;
  }

  if (!window.tooltip) {
    window.tooltip = createTooltip(viewer._element);
  } // 半透线创建


  if (!window.polylineCollection) {
    window.polylineCollection = new Cesium.PolylineCollection({
      translucentRS: Cesium.RenderState.fromCache({
        depthMask: false,
        depthTest: {
          enabled: false
        }
      })
    });
    window.polylineTransparent = window.polylineCollection.add({
      width: 2,
      material: Cesium.Material.fromType(Cesium.Material.ColorType, {
        color: Cesium.Color.fromCssColorString("#51ff00").withAlpha(0.3)
      })
    });
    viewer.scene.primitives.add(window.polylineCollection);
  }
};
/**
 * 绘制
 * PolyType：类型 
 * lineVisib：绘制时是否显示绘制线（boolean）
 * toolTipObj：绘制时提示内容{beforeDrawing：绘制开始前提示(string)，isDrawing：正在绘制时提示,即绘制过程中（string）}
 */


var handlerDrawing = function handlerDrawing(PolyType, lineVisib, toolTipObj) {
  var lineVisible = true;

  if (lineVisib === false) {
    lineVisible = lineVisib;
  }

  var DrawHandler = judgeDrawHandlerType(PolyType); //获取操作对象

  return new Promise(function (resolve, reject) {
    //做一些异步操作
    var tooltip = window.tooltip;
    var clearActFn = DrawHandler.activeEvt.addEventListener(function (isActive) {
      if (isActive == true) {
        viewer.enableCursorStyle = false;
        viewer._element.style.cursor = '';

        if (PolyType == "Point" || PolyType == "Marker") {
          document.body.classList.add("measureCur");
        } else {
          document.body.classList.add("drawCur");
        }
      } else {
        viewer.enableCursorStyle = true;
        tooltip.setVisible(false);

        if (PolyType == "Point" || PolyType == "Marker") {
          document.body.classList.remove('measureCur');
        } else {
          document.body.classList.remove('drawCur');
        }
      }
    });
    var clearMovFn = DrawHandler.movingEvt.addEventListener(function (windowPosition) {
      if (windowPosition.x < 200 && windowPosition.y < 150) {
        tooltip.setVisible(false);
        return;
      }
      //     tooltip.showAt(windowPosition, tiptext);
      // } else if (toolTipObj && toolTipObj.beforeDrawing) {
      //     tooltip.showAt(windowPosition, toolTipObj.beforeDrawing);
      // }else if (DrawHandler.isDrawing && toolTipObj.isDrawing) {
      //     tooltip.showAt(windowPosition, toolTipObj.isDrawing);
      // }

      if (DrawHandler.polyline && DrawHandler.isDrawing) {
        var p = _toConsumableArray(DrawHandler.polyline.positions);

        if (PolyType == "Polygon") {
          //画面时，需要首尾相连
          p.push(p[0]);
        }
        window.polylineTransparent.show = true;
        window.polylineTransparent.positions = p;
      }
    });
    var clearDrawFn = DrawHandler.drawEvt.addEventListener(function (result) {
      if (!result.object.positions && PolyType != "Point" && PolyType != "Box") {
        tooltip.showAt(result, '<p>请绘制正确的多边形</p>');
        DrawHandler.polygon.show = false;
        DrawHandler.polyline.show = false;
        DrawHandler.deactivate();
        DrawHandler.activate();
        return;
      }

      if (PolyType == "Box") {
        resolve({
          result: result
        });
        return;
      }

      if (PolyType == "Point" || PolyType == "Marker") {
        DrawHandler.clear(); // 不显示绘制的点

        resolve({
          result: result
        });
      } else {
        //半透线
        window.polylineTransparent.show = lineVisible;

        if (lineVisible) {
          if (PolyType == "Polygon" && lineVisible) {
            DrawHandler.polygon._polygon._material._color._value.alpha = 0.1; //绘制面透明度

            var p2 = _toConsumableArray(result.object.positions); //画面时，需要首尾相连


            p2.push(p2[0]);
            window.polylineTransparent.positions = p2;
          }
        }

        var positions = CartesiantoDegrees(result.object.positions);
        resolve({
          result: result,
          positions: positions
        });
      }

      clearActFn();
      clearMovFn();
      clearDrawFn();
    });
  });
}; //清除


var clearHandlerDrawing = function clearHandlerDrawing(PolyType) {
  var DrawHandler;

  if (!PolyType) {
    DrawHandler = window.handlerPolygon;
  } else {
    DrawHandler = judgeDrawHandlerType(PolyType);
  }
  if (!DrawHandler) return;
  DrawHandler.deactivate();
  DrawHandler.clear();
  viewer.enableCursorStyle = true; // document.body.classList.remove("drawCur");
  // document.body.classList.remove("measureCur");

  window.tooltip.setVisible(false);

  if (window.polylineTransparent) {
    window.polylineTransparent.show = false;
  }
}; // 类型判断


var judgeDrawHandlerType = function judgeDrawHandlerType(PolyType) {
  var DrawHandler;

  switch (PolyType) {
    case "Point":
      DrawHandler = window.handlerPoint;
      break;

    case "Polyline":
      DrawHandler = window.handlerPolyline;
      break;

    case "Polygon":
      DrawHandler = window.handlerPolygon;
      break;

    case "Marker":
      DrawHandler = window.handlerMarker;
      break;

    case "Box":
      DrawHandler = window.handlerBox;
      break;
  }

  return DrawHandler;
};

function createTooltip$1(frameDiv) {
  var tooltip = function tooltip(frameDiv) {
    var div = document.createElement('DIV');
    div.className = "tooltip";
    this._div = div;
    this.message = '';
    frameDiv.appendChild(div);
  };

  tooltip.prototype.setVisible = function (visible) {
    if (visible) {
      this._div.style.right = '10px';
    } else {
      this._div.style.right = '-300px';
    }
  };

  tooltip.prototype.showAt = function (message, top) {
    //top:200px => string
    if (top) {
      this._div.style.top = top;
    }

    if (message) {
      this.setVisible(true);
      this._div.innerHTML = message;
    }
  };

  return new tooltip(frameDiv);
}

function projectionImage(props) {
  // 设置默认值数据
  var state = reactive({
    viewlongitude: "",
    viewlatitude: "",
    viewheight: "",
    direction: "",
    pitch: "",
    horizontal: 20,
    vertical: 10,
    distance: 200,
    hintLineColor: "rgba(251,250,248,1)",
    clipMode: "clip-inside",
    visibleLine: true,
    fileText: "",
    fromInfo: null
  }); // 传入props改变默认值

  if (props) {
    for (var key in props) {
      if (state.hasOwnProperty(key)) {
        if (props[key] != undefined) state[key] = props[key];
      } else {
        tool.Message.errorMsg(resource.AttributeError + key);
      }
    }
  } // 初始化数据


  var layers, scene;
  var currentProject;
  var vedioFile_dom = ref(null);
  var modelIdProjectPairs = new Map(); // 模型id和视频投放对象对象的键值对

  var s3mInstanceColc, modelEditor;
  var modelUrl = 'public/data/s3m/projector.s3m';
  var isActive = false;
  var currentSelectedSymbol = null;
  var reader = new FileReader();
  var currntVideoDom,
      isClip = false;

  if (storeState.isViewer) {
    if (!window.tooltip) {
      window.tooltip = createTooltip$1(viewer._element);
    }

    scene = viewer.scene;
    layers = viewer.scene.layers.layerQueue;
    s3mInstanceColc = new Cesium.S3MInstanceCollection(scene._context);
    viewer.scene.primitives.add(s3mInstanceColc);
    viewer.eventManager.addEventListener("CLICK", click_set_target, true);
  } //viewer 初始化完成的监听


  watch(function () {
    return storeState.isViewer;
  }, function (val) {
    if (val) {
      if (!window.tooltip) {
        window.tooltip = createTooltip$1(viewer._element);
      }

      scene = viewer.scene;
      layers = viewer.scene.layers.layerQueue;
      s3mInstanceColc = new Cesium.S3MInstanceCollection(scene._context);
      viewer.scene.primitives.add(s3mInstanceColc);
    }
  }); //监听图层加载完成

  watch(function () {
    return storeState.changeLayers;
  }, function (val) {
    for (var i = 0; i < layers.length; i++) {
      layers[i].selectEnabled = false;
    }
  });
  onMounted(function () {
    fileChange();
    currntVideoDom = document.getElementById("trailer-0");
  }); // 点击选择文件函数

  function chooseFile() {
    vedioFile_dom.value.click();
  } //文件夹改变文件触发


  function fileChange() {
    vedioFile_dom.value.addEventListener("change", function (evt) {
      var file = evt.target.files[0];
      if (!file) return;
      state.fileText = vedioFile_dom.value.value;
      var aBlob = new Blob([file], {
        type: 'video/mp4'
      });
      reader.readAsDataURL(aBlob);

      reader.onload = function (e) {
        var vedio = e.target.result;
        var index = document.querySelectorAll('#videoContain>video').length;
        creatVideo_dom(vedio, index).then(function (res) {
          currntVideoDom = document.getElementById("trailer-" + index);
        });
      };
    });
  }

  function creatVideo_dom(src, index) {
    return new Promise(function (resolve, reject) {
      var videoContain = document.getElementById("videoContain");
      var video = document.createElement("video");
      var source = document.createElement("source");
      source.src = src;
      video.appendChild(source);
      video.id = "trailer-" + index;
      video.classList.add("videoBox");
      video.setAttribute("autoplay", "autoplay");
      video.setAttribute("loop", "loop");
      video.setAttribute("crossorigin", "crossorigin");
      video.setAttribute("controls", "controls");
      video.setAttribute("muted", "muted");
      videoContain.appendChild(video);
      setTimeout(function () {
        resolve(video);
      }, 500);
    });
  }

  function startProjection() {
    viewer.enableCursorStyle = false;
    viewer._element.style.cursor = "";
    document.body.classList.add("measureCur");
    var viewPosition = viewer.scene.camera.position;
    currntVideoDom.play();
    currentProject = new Cesium.ProjectionImage(scene);
    currentProject.setImage({
      video: currntVideoDom
    });
    currentProject.distance = Number(state.distance);
    currentProject.horizontalFov = Number(state.horizontal);
    currentProject.verticalFov = Number(state.vertical);
    currentProject.viewPosition = tool.CartesiantoDegrees(viewPosition);
    currentProject.build();
    isActive = true;
    window.tooltip.showAt(' <p>选中投放模型进行编辑和清除</p>', '400px');
    viewer.eventManager.addEventListener("MOUSE_MOVE", move_set_target);
    viewer.eventManager.addEventListener("CLICK", click_set_target, true);
  }

  function click_set_target(e) {
    if (isClip) return;

    if (isActive) {
      viewer.enableCursorStyle = true;
      document.body.classList.remove("measureCur");
      var Cartesian3 = Cesium.Cartesian3.fromDegrees(currentProject.viewPosition[0], currentProject.viewPosition[1], currentProject.viewPosition[2]);
      var viewPosition = JSON.parse(JSON.stringify(Cartesian3));
      viewer.eventManager.removeEventListener("MOUSE_MOVE", move_set_target);
      addModel(viewPosition);
      isActive = false;
      return;
    }

    var symbol = viewer.scene.pick(e.message.position) || viewer.selectedEntity;

    if (symbol && symbol.id && typeof symbol.id === 'string' && symbol.id.indexOf("projector-") != -1) {
      // if (currentSelectedSymbol && currentSelectedSymbol.id === symbol.id) return;
      if (modelEditor) modelEditor.destroy();
      currentSelectedSymbol = symbol;
      currentProject = modelIdProjectPairs.get(symbol.id);

      if (currentProject) {
        state.horizontal = currentProject.horizontalFov;
        state.vertical = currentProject.verticalFov;
        state.distance = currentProject.distance;
      } // modelEditor = new Cesium.ModelEditor({
      //     model: symbol.primitive,
      //     scene: viewer.scene,
      //     // offset: new Cesium.Cartesian3(0, 0, 2)
      // });
      // modelEditor.activate();
      // console.log(modelEditor)


      return;
    } // if (modelEditor) modelEditor.destroy();
    // modelEditor = null;


    currentSelectedSymbol = null;
    currentProject = null;
  }

  function move_set_target(e) {
    var distance = 0;
    var viewPosition = viewer.scene.camera.position;
    var targetPosition = scene.pickPosition(e.message.endPosition);
    if (targetPosition) distance = Cesium.Cartesian3.distance(viewPosition, targetPosition);
    if (distance > 0 && distance < 1000) currentProject.setDistDirByPoint(tool.CartesiantoDegrees(targetPosition));
  }

  function addModel(position, position2) {
    var id = 'projector-' + new Date().getTime();
    var direction = currentProject.direction;
    var pitch = currentProject.pitch;
    var radians = Cesium.Math.toRadians(direction);
    var heading = radians >= Cesium.Math.PI ? radians - Cesium.Math.PI : radians + Cesium.Math.PI;
    var pitch2 = -Cesium.Math.toRadians(pitch);
    s3mInstanceColc.add(modelUrl, {
      id: id,
      position: position,
      hpr: {
        heading: heading,
        pitch: 0,
        roll: pitch2
      } // scale: new Cesium.Cartesian3(2, 2, 2),
      // offset: new Cesium.Cartesian3(0, 0, 0.1)

    });
    currentSelectedSymbol = s3mInstanceColc.getInstance(modelUrl, id);
    modelIdProjectPairs.set(id, currentProject);
  } // 裁剪


  function clipProjectImg() {
    isClip = true;
    tooltip.setVisible(false);
    window.tooltip.showAt(' <p>点击鼠标左键绘制裁剪区域</p><p>点击鼠标右键结束绘制</p><p>注：只能裁剪当前选中投放对象</p>', '400px');

    if (!window.handlerPolygon) {
      initHandler("Polygon");
    }

    handlerDrawing("Polygon").then(function (res) {
      isClip = false;
      var handlerPolygon = window.handlerPolygon;
      updateClipImg(res.positions);
      handlerPolygon.polygon.show = false;
      handlerPolygon.polyline.show = false;
      window.polylineTransparent.show = false; //半透线隐藏

      handlerPolygon.deactivate();
    }, function (err) {
      console.log(err);
    });
    window.handlerPolygon.activate();
  }

  function updateClipImg(position) {
    if (!currentProject) return;
    currentProject.addClipRegion({
      name: "clip-Projector" + new Date().getTime(),
      position: position
    });
  }

  function clear() {
    viewer.eventManager.removeEventListener("MOUSE_MOVE", move_set_target);

    if (currentSelectedSymbol) {
      modelIdProjectPairs["delete"](currentSelectedSymbol.id);
      s3mInstanceColc.removeInstance(modelUrl, currentSelectedSymbol.id);
      currentSelectedSymbol = null;
    }

    if (currentProject) {
      currentProject.removeAllClipRegion();
      currentProject.destroy();
    }

    if (modelIdProjectPairs.size === 0) viewer.eventManager.removeEventListener("CLICK", click_set_target);
    if (modelEditor) modelEditor.destroy();
    modelEditor = null;
    currentProject = null;
    window.tooltip.setVisible(false);
    clearHandlerDrawing();
    viewer.enableCursorStyle = true;
    document.body.classList.remove("measureCur");
  }

  watch(function () {
    return state.fileText;
  }, function (val) {
    if (val.indexOf("http") === -1) return;
    var index = document.querySelectorAll('#videoContain>video').length;
    creatVideo_dom(val, index).then(function (res) {
      currntVideoDom = document.getElementById("trailer-" + index);
    });
  });
  watch(function () {
    return state.horizontal;
  }, function (val) {
    if (val == "" || !currentProject) return;
    currentProject.horizontalFov = Number(val);
  });
  watch(function () {
    return state.vertical;
  }, function (val) {
    if (val == "" || !currentProject) return;
    currentProject.verticalFov = Number(val);
  });
  watch(function () {
    return state.distance;
  }, function (val) {
    if (val == "" || !currentProject) return;
    currentProject.distance = Number(val);
  });
  watch(function () {
    return state.visibleLine;
  }, function (val) {
    if (!currentProject) return; // currentProject.hintLineVisible = val;

    s3mInstanceColc.visible = val; //隐藏所有模型

    modelIdProjectPairs.forEach(function (projector) {
      //隐藏所有投放线
      projector.hintLineVisible = val;
    });
  });
  watch(function () {
    return state.hintLineColor;
  }, function (val) {
    if (!currentProject) return;
    currentProject.hintLineColor = Cesium.Color.fromCssColorString(val);
  });
  watch(function () {
    return state.clipMode;
  }, function (val) {
    if (!currentProject) return;
    var clipMode = val === "clip-outside" ? Cesium.ModifyRegionMode.CLIP_INSIDE : Cesium.ModifyRegionMode.CLIP_OUTSIDE;
    currentProject.setClipMode(clipMode);
  });
  watch(function () {
    return state.viewlongitude;
  }, function (val) {
    if (!currentProject || val == "") return;
    currentProject.viewPosition[0] = val;
  });
  watch(function () {
    return state.viewlatitude;
  }, function (val) {
    if (!currentProject || val == "") return;
    currentProject.viewPosition[1] = val;
  });
  watch(function () {
    return state.viewheight;
  }, function (val) {
    if (!currentProject || val == "") return;
    currentProject.viewPosition[2] = val;
  });
  watch(function () {
    return state.direction;
  }, function (val) {
    if (!currentProject || val == "") return;
    currentProject.direction = Number(val);
  });
  watch(function () {
    return state.pitch;
  }, function (val) {
    if (!currentProject || val == "") return;
    currentProject.pitch = Number(val);
  });
  watch(function () {
    return state.fromInfo;
  }, function (val) {
    if (!val || val == "") return;
    Cesium.ProjectionImage.fromInfo(scene, state.fromInfo.infoUrl, state.fromInfo.baseUrl);
  }); // 销毁

  onBeforeUnmount(function () {
    for (var i = 0; i < layers.length; i++) {
      layers[i].selectEnabled = true;
    }
  });
  return _objectSpread2(_objectSpread2({}, toRefs(state)), {}, {
    chooseFile: chooseFile,
    vedioFile_dom: vedioFile_dom,
    startProjection: startProjection,
    clear: clear,
    clipProjectImg: clipProjectImg
  });
}

var script = {
  name: "Sm3dProjectionImage",
  props: {
    // 视频路径
    fileText: {
      type: Number
    },
    //通过文件同时添加多个视频进行投放。
    fromInfo: {
      type: Object
    }
  },
  setup: function setup(props) {
    var _projection = projectionImage(props),
        horizontal = _projection.horizontal,
        vertical = _projection.vertical,
        distance = _projection.distance,
        clipMode = _projection.clipMode,
        visibleLine = _projection.visibleLine,
        fileText = _projection.fileText,
        chooseFile = _projection.chooseFile,
        vedioFile_dom = _projection.vedioFile_dom,
        startProjection = _projection.startProjection,
        clear = _projection.clear,
        clipProjectImg = _projection.clipProjectImg;

    return {
      horizontal: horizontal,
      vertical: vertical,
      distance: distance,
      clipMode: clipMode,
      visibleLine: visibleLine,
      fileText: fileText,
      chooseFile: chooseFile,
      vedioFile_dom: vedioFile_dom,
      startProjection: startProjection,
      clear: clear,
      clipProjectImg: clipProjectImg
    };
  }
};

var _hoisted_1 = {
  id: "fly-route-panel",
  "class": "sm-panel"
};
var _hoisted_2 = {
  "class": "sm-function-module-sub-section",
  style: {
    "margin": "0"
  }
};
var _hoisted_3 = {
  "class": "sm-half-L"
};
var _hoisted_4 = {
  style: {
    "width": "30%"
  }
};
var _hoisted_5 = ["placeholder"];
var _hoisted_6 = {
  type: "file",
  accept: "*.mp4",
  id: "vedioFile",
  style: {
    "display": "none"
  },
  ref: "vedioFile_dom"
};
var _hoisted_7 = {
  "class": "sm-half-L"
};
var _hoisted_8 = {
  style: {
    "width": "30%"
  }
};
var _hoisted_9 = {
  "class": "sm-half-L"
};
var _hoisted_10 = {
  style: {
    "width": "30%"
  }
};
var _hoisted_11 = {
  "class": "sm-half-L"
};
var _hoisted_12 = {
  style: {
    "width": "30%"
  }
};
var _hoisted_13 = {
  "class": "sm-half-L"
};
var _hoisted_14 = {
  style: {
    "width": "30%"
  }
};
var _hoisted_15 = {
  "class": "sm-half",
  style: {
    "width": "68%"
  }
};
var _hoisted_16 = {
  style: {
    "width": "auto"
  }
};
var _hoisted_17 = {
  style: {
    "width": "auto"
  }
};
var _hoisted_18 = {
  "class": "sm-half-L flex-between"
};
var _hoisted_19 = {
  style: {
    "width": "auto"
  }
};
var _hoisted_20 = {
  "class": "boxchild",
  style: {
    "padding": "0"
  }
};

var _hoisted_21 = /*#__PURE__*/createElementVNode("div", {
  id: "videoContain",
  style: {
    "width": "0",
    "height": "0"
  }
}, [/*#__PURE__*/createElementVNode("video", {
  id: "trailer-0",
  style: {
    "visibility": "hidden"
  },
  autoplay: "",
  loop: "",
  crossorigin: "",
  controls: "",
  muted: "",
  multiple: ""
}, [/*#__PURE__*/createElementVNode("source", {
  src: "public/data/media/video.mp4",
  type: "video/mp4"
})])], -1
/* HOISTED */
);

function render(_ctx, _cache, $props, $setup, $data, $options) {
  var _component_el_slider = resolveComponent("el-slider");

  var _directive_stopdrag = resolveDirective("stopdrag");

  var _directive_drag = resolveDirective("drag");

  return withDirectives((openBlock(), createElementBlock("div", _hoisted_1, [withDirectives((openBlock(), createElementBlock("div", _hoisted_2, [createElementVNode("div", _hoisted_3, [createElementVNode("label", _hoisted_4, toDisplayString(_ctx.Resource.videoUrl), 1
  /* TEXT */
  ), withDirectives(createElementVNode("input", {
    type: "text",
    "class": "sm-input",
    style: {
      "width": "65%",
      "position": "relative",
      "padding-right": "30px"
    },
    "onUpdate:modelValue": _cache[0] || (_cache[0] = function ($event) {
      return $setup.fileText = $event;
    }),
    placeholder: _ctx.Resource.fileType
  }, null, 8
  /* PROPS */
  , _hoisted_5), [[vModelText, $setup.fileText]]), createElementVNode("span", {
    "class": "iconfont iconwenjianjia fpfFile",
    onClick: _cache[1] || (_cache[1] = function () {
      return $setup.chooseFile && $setup.chooseFile.apply($setup, arguments);
    })
  }), createElementVNode("input", _hoisted_6, null, 512
  /* NEED_PATCH */
  )]), createElementVNode("div", _hoisted_7, [createElementVNode("label", _hoisted_8, toDisplayString(_ctx.Resource.horizontal), 1
  /* TEXT */
  ), createVNode(_component_el_slider, {
    modelValue: $setup.horizontal,
    "onUpdate:modelValue": _cache[2] || (_cache[2] = function ($event) {
      return $setup.horizontal = $event;
    }),
    min: 0.5,
    max: 60,
    step: 0.5,
    "input-size": "mini",
    debounce: 500,
    "tooltip-class": "tooltip-class",
    style: {
      "width": "65%"
    }
  }, null, 8
  /* PROPS */
  , ["modelValue", "min", "step"])]), createElementVNode("div", _hoisted_9, [createElementVNode("label", _hoisted_10, toDisplayString(_ctx.Resource.vertical), 1
  /* TEXT */
  ), createVNode(_component_el_slider, {
    modelValue: $setup.vertical,
    "onUpdate:modelValue": _cache[3] || (_cache[3] = function ($event) {
      return $setup.vertical = $event;
    }),
    min: 0.5,
    max: 60,
    step: 0.5,
    "input-size": "mini",
    debounce: 500,
    "tooltip-class": "tooltip-class",
    style: {
      "width": "65%"
    }
  }, null, 8
  /* PROPS */
  , ["modelValue", "min", "step"])]), createElementVNode("div", _hoisted_11, [createElementVNode("label", _hoisted_12, toDisplayString(_ctx.Resource.projectDistance), 1
  /* TEXT */
  ), createVNode(_component_el_slider, {
    modelValue: $setup.distance,
    "onUpdate:modelValue": _cache[4] || (_cache[4] = function ($event) {
      return $setup.distance = $event;
    }),
    min: 1,
    max: 500,
    "input-size": "mini",
    debounce: 500,
    "tooltip-class": "tooltip-class",
    style: {
      "width": "65%"
    }
  }, null, 8
  /* PROPS */
  , ["modelValue"])]), createElementVNode("div", _hoisted_13, [createElementVNode("label", _hoisted_14, toDisplayString(_ctx.Resource.clipMode), 1
  /* TEXT */
  ), createElementVNode("div", _hoisted_15, [createElementVNode("label", _hoisted_16, [withDirectives(createElementVNode("input", {
    type: "radio",
    value: "clip-inside",
    "onUpdate:modelValue": _cache[5] || (_cache[5] = function ($event) {
      return $setup.clipMode = $event;
    })
  }, null, 512
  /* NEED_PATCH */
  ), [[vModelRadio, $setup.clipMode]]), createTextVNode(" " + toDisplayString(_ctx.Resource.clipInside), 1
  /* TEXT */
  )]), createElementVNode("label", _hoisted_17, [withDirectives(createElementVNode("input", {
    type: "radio",
    value: "clip-outside",
    "onUpdate:modelValue": _cache[6] || (_cache[6] = function ($event) {
      return $setup.clipMode = $event;
    })
  }, null, 512
  /* NEED_PATCH */
  ), [[vModelRadio, $setup.clipMode]]), createTextVNode(" " + toDisplayString(_ctx.Resource.clipOutside), 1
  /* TEXT */
  )])])]), createElementVNode("div", _hoisted_18, [createElementVNode("label", _hoisted_19, [withDirectives(createElementVNode("input", {
    type: "checkbox",
    "onUpdate:modelValue": _cache[7] || (_cache[7] = function ($event) {
      return $setup.visibleLine = $event;
    })
  }, null, 512
  /* NEED_PATCH */
  ), [[vModelCheckbox, $setup.visibleLine]]), createTextVNode(" " + toDisplayString(_ctx.Resource.visibleLine), 1
  /* TEXT */
  )]), createCommentVNode(" <label style=\"width:auto\">\r\n          <input type=\"checkbox\" v-model=\"visibleLine\" />显示投放线\r\n        </label>")]), createElementVNode("div", _hoisted_20, [createElementVNode("button", {
    "class": "tbtn",
    type: "button",
    onClick: _cache[8] || (_cache[8] = function () {
      return $setup.startProjection && $setup.startProjection.apply($setup, arguments);
    })
  }, toDisplayString(_ctx.Resource.projection), 1
  /* TEXT */
  ), createElementVNode("button", {
    "class": "tbtn tbtn-margin-left",
    type: "button",
    onClick: _cache[9] || (_cache[9] = function () {
      return $setup.clipProjectImg && $setup.clipProjectImg.apply($setup, arguments);
    })
  }, toDisplayString(_ctx.Resource.clip), 1
  /* TEXT */
  ), createElementVNode("button", {
    "class": "tbtn tbtn-margin-left",
    type: "button ",
    onClick: _cache[10] || (_cache[10] = function () {
      return $setup.clear && $setup.clear.apply($setup, arguments);
    })
  }, toDisplayString(_ctx.Resource.clear), 1
  /* TEXT */
  )]), _hoisted_21])), [[_directive_stopdrag]])])), [[_directive_drag]]);
}

script.render = render;
script.__file = "src/components/scene/projection-image/projection-image.vue";

script.install = function (app) {
  app.component(script.name, script);
};

export default script;
