import { reactive, toRefs, ref, watch, onMounted, onBeforeUnmount, resolveComponent, resolveDirective, openBlock, createElementBlock, Fragment, withDirectives, createElementVNode, toDisplayString, vModelSelect, vModelCheckbox, createTextVNode, vModelRadio, vShow, createVNode } from 'vue';

function _typeof(obj) {
  "@babel/helpers - typeof";

  if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
    _typeof = function (obj) {
      return typeof obj;
    };
  } else {
    _typeof = function (obj) {
      return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
    };
  }

  return _typeof(obj);
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);

  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    if (enumerableOnly) symbols = symbols.filter(function (sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    });
    keys.push.apply(keys, symbols);
  }

  return keys;
}

function _objectSpread2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};

    if (i % 2) {
      ownKeys(Object(source), true).forEach(function (key) {
        _defineProperty(target, key, source[key]);
      });
    } else if (Object.getOwnPropertyDescriptors) {
      Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
      ownKeys(Object(source)).forEach(function (key) {
        Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
      });
    }
  }

  return target;
}

/*
* 常用工具类
*/
//axios本版本不支持jsonp
var axiosJsonp = function axiosJsonp(url) {
  if (!url) {
    console.error('Axios.JSONP 至少需要一个url参数!');
    return;
  }

  return new Promise(function (resolve, reject) {
    window.jsonCallBack = function (result) {
      resolve(result);
    };

    var JSONP = document.createElement("script");
    JSONP.type = "text/javascript";
    JSONP.src = "".concat(url, "&callback=jsonCallBack");
    document.getElementsByTagName("head")[0].appendChild(JSONP);
    setTimeout(function () {
      document.getElementsByTagName("head")[0].removeChild(JSONP);
    }, 500);
  });
}; //判断两数组或对象相等


var isEqualArr = function isEqualArr(arg1, arg2) {
  if (!arg1 || !arg2) return true;
  var bol = true;

  if (Object.keys(arg1).length != Object.keys(arg2).length) {
    return false;
  }

  for (var key in arg1) {
    if (_typeof(arg1[key]) == 'object') {
      bol = isSame(arg1[key], arg2[key]);

      if (!bol) {
        break;
      }
    } else if (arg1[key] != arg2[key]) {
      bol = false;
      break;
    }
  }

  return bol;
}; //坐标转化
//笛卡尔转经纬度


var CartesiantoDegrees = function CartesiantoDegrees(Cartesians) {
  var array = [].concat(Cartesians);
  var positions = [];

  for (var i = 0, len = array.length; i < len; i++) {
    var cartographic = Cesium.Cartographic.fromCartesian(array[i]);
    var longitude = Cesium.Math.toDegrees(cartographic.longitude);
    var latitude = Cesium.Math.toDegrees(cartographic.latitude);
    var h = cartographic.height;

    if (positions.indexOf(longitude) == -1 && positions.indexOf(latitude) == -1) {
      positions.push(longitude);
      positions.push(latitude);
      positions.push(h);
    }
  }

  return positions;
}; //笛卡尔转经纬度(每个点是独立的对象)


var CartesiantoDegreesObjs = function CartesiantoDegreesObjs(Cartesians) {
  var array = [].concat(Cartesians);
  var positions = [];

  for (var i = 0, len = array.length; i < len; i++) {
    var cartographic = Cesium.Cartographic.fromCartesian(array[i]);
    var obj = {
      longitude: Cesium.Math.toDegrees(cartographic.longitude),
      latitude: Cesium.Math.toDegrees(cartographic.latitude),
      height: cartographic.height
    };
    positions.push(obj);
  }

  return positions;
}; // 弧度转经纬度


var CartographictoDegrees = function CartographictoDegrees(wgsPosition) {
  var longitude = Cesium.Math.toDegrees(wgsPosition.longitude);
  var latitude = Cesium.Math.toDegrees(wgsPosition.latitude);
  var height = wgsPosition.height;
  return [longitude, latitude, height];
}; //去重函数  数组


var unique = function unique(arr) {
  var res = [];
  var json = {};

  for (var i = 0; i < arr.length; i++) {
    if (!json[arr[i]]) {
      res.push(arr[i]);
      json[arr[i]] = 1;
    }
  }

  return res;
}; // 获取渐变色函数


function gradientColors(start, end, steps, gamma) {
  var i,
      j,
      ms,
      me,
      output = [],
      so = [];
  gamma = gamma || 1;

  var normalize = function normalize(channel) {
    return Math.pow(channel / 255, gamma);
  };

  start = parseColor(start).map(normalize);
  end = parseColor(end).map(normalize);

  for (i = 0; i < steps; i++) {
    ms = i / (steps - 1);
    me = 1 - ms;

    for (j = 0; j < 3; j++) {
      so[j] = pad(Math.round(Math.pow(start[j] * me + end[j] * ms, 1 / gamma) * 255).toString(16));
    }

    output.push('#' + so.join(''));
  }

  return output;

  function parseColor(hexStr) {
    return hexStr.length === 4 ? hexStr.substr(1).split('').map(function (s) {
      return 0x11 * parseInt(s, 16);
    }) : [hexStr.substr(1, 2), hexStr.substr(3, 2), hexStr.substr(5, 2)].map(function (s) {
      return parseInt(s, 16);
    });
  }

  function pad(s) {
    return s.length === 1 ? '0' + s : s;
  }
}

function getAngleAndRadian(pointA, pointB) {
  //建立以点A为原点，X轴为east,Y轴为north,Z轴朝上的坐标系
  var transform = Cesium.Transforms.eastNorthUpToFixedFrame(pointA); //向量AB

  var positionvector = Cesium.Cartesian3.subtract(pointB, pointA, new Cesium.Cartesian3()); //因transform是将A为原点的eastNorthUp坐标系中的点转换到世界坐标系的矩阵
  //AB为世界坐标中的向量
  //因此将AB向量转换为A原点坐标系中的向量，需乘以transform的逆矩阵。

  var vector = Cesium.Matrix4.multiplyByPointAsVector(Cesium.Matrix4.inverse(transform, new Cesium.Matrix4()), positionvector, new Cesium.Cartesian3()); //归一化

  var direction = Cesium.Cartesian3.normalize(vector, new Cesium.Cartesian3()); //heading

  var heading1 = Math.atan2(direction.y, direction.x) - Cesium.Math.PI_OVER_TWO;
  var radian = Cesium.Math.TWO_PI - Cesium.Math.zeroToTwoPi(heading1);
  var angle = radian * (180 / Math.PI);

  if (angle < 0) {
    angle = angle + 360;
  }

  return {
    angle: angle,
    radian: radian
  };
}

function getPitch(pointA, pointB) {
  var transfrom = Cesium.Transforms.eastNorthUpToFixedFrame(pointA);
  var vector = Cesium.Cartesian3.subtract(pointB, pointA, new Cesium.Cartesian3());
  var direction = Cesium.Matrix4.multiplyByPointAsVector(Cesium.Matrix4.inverse(transfrom, transfrom), vector, vector);
  Cesium.Cartesian3.normalize(direction, direction); //因为direction已归一化，斜边长度等于1，所以余弦函数等于direction.z

  var radian = Cesium.Math.PI_OVER_TWO - Cesium.Math.acosClamped(direction.z);
  var angle = radian * (180 / Math.PI);

  if (angle < 0) {
    angle = angle + 360;
  }

  return {
    angle: angle,
    radian: radian
  };
}

var tool = {
  axiosJsonp: axiosJsonp,
  isEqualArr: isEqualArr,
  CartesiantoDegrees: CartesiantoDegrees,
  CartesiantoDegreesObjs: CartesiantoDegreesObjs,
  unique: unique,
  gradientColors: gradientColors,
  getAngleAndRadian: getAngleAndRadian,
  CartographictoDegrees: CartographictoDegrees,
  getPitch: getPitch
};

var ResourceCN = {
  showRenderLoopErrors: '渲染时发生错误，已停止渲染。',
  AttributeError: '该组件props没有这个属性：',
  NoPickPositionSupported: "不支持深度纹理,无法绘制多边形，地形操作功能无法使用！",
  NoTerrain: "请在地形里使用地形组件！",
  initViewerWarn: '请先初始化viewer!',
  MoveMouseHeightBox: '点击鼠标左键结束矩形绘制，移动鼠标绘制box高度',
  RightClickEndDrawing: '右键单击结束绘制',
  LeftClickBottomBox: '点击鼠标左键，开始绘制矩形作为box底面',
  ClickModelAddBox: '点击模型，添加裁剪盒子',
  SkyLineWarn: "获取天际线体前，请先绘制天际线！",
  SkyLineBody: '天际线体',
  ShadowqueryWarn: "此操作需要先开启阴影！",
  VeiwshedBody: '可视体',
  VeiwshedBodyHidden: '不可视体',
  EchartsErr: "二维显示需要echarts支持，未找到相关依赖！",
  BaseMapImg: '底图',
  tip1: '<p>点击左键确定操作区域中间点</p><p>右键单击结束绘制</p>'
};

// 组件内部的语言资源：主要包括提示信息
var currentLanguage, Resource;
var cookieLanguage = getLang().toLowerCase();

function getLang() {
  //浏览器语言  IE用browserLanguage，非IE使用language进行判断
  var lang = (navigator.language || navigator.browserLanguage).toLowerCase();
  window.lang = lang; //判断portal设置语言 通过cookie获取
  //   const cookies = document.cookie.split(';');
  //   if (cookies.length > 0) {
  //     cookies.forEach(function (cookie) {
  //       const arr = cookie.split('=');
  //       if (arr[0].toLowerCase().trim() === 'language') {
  //         lang = arr[1];
  //         return;
  //       }
  //     });
  //   }

  return lang;
}

if (cookieLanguage !== undefined) {
  currentLanguage = cookieLanguage;
} else {
  currentLanguage = (navigator.language || navigator.browserLanguage).toLowerCase(); // 获取当前浏览器的语言
}

if (currentLanguage.startsWith('zh')) {
  Resource = ResourceCN;
} else if (currentLanguage.startsWith('ja')) {
  Resource = ResourceCN;
} else {
  Resource = ResourceCN;
}

var resource = Resource;

// 创建一个简单的store状态管理

var storeState = reactive({
  isViewer: false,
  //viewer初始化标志
  changeLayers: 0,
  //图层改变加载完毕监听
  changeGeometrys: 0 //三维分析体改变标志

});

function roller(props) {
  // 设置默认值数据
  var state = reactive({
    useRoller: false,
    //使用卷帘
    rollerMode: "lrRoller",
    //卷帘模式
    lrRoller: "1",
    //左右卷帘时默认屏蔽左边
    tbRoller: "4",
    //上下卷帘时默认屏蔽上面
    TreeDatas: [] //图层树

  }); // 传入props改变默认值

  if (props) {
    for (var key in props) {
      if (state.hasOwnProperty(key)) {
        if (props[key] != undefined) state[key] = props[key];
      } else {
        tool.Message.errorMsg(resource.AttributeError + key);
      }
    }
  } // 初始化数据


  var layers, imgLayers, mvtLayers;
  var dom = document.getElementById('cesiumContainer');
  var wide = document.body.clientWidth - dom.clientWidth; //定位矫正

  var heide = document.body.clientHeight - dom.clientHeight;
  var width = dom.clientWidth; // 界面宽度

  var height = dom.clientHeight; // 界面高度

  var tree = ref(null);
  var verticalSliderLeft = ref(null);
  var verticalSliderRight = ref(null);
  var horizontalSliderTop = ref(null);
  var horizontalSliderBottom = ref(null);
  var scratchSwipeRegion = new Cesium.BoundingRectangle(); // 卷帘配置参数，以对象方式实现地址传递

  var rollerShutterConfig = {
    startX: 0.33,
    //x方向左卷帘条比例
    startY: 0.33,
    //y方向上卷帘条比例
    endX: 0.66,
    //x方向右卷帘条比例
    endY: 0.66,
    //y方向下卷帘条比例
    index: 1,
    //当前控制卷帘条
    mode: 1 //卷帘模式

  }; //监听图层加载完成

  watch(function () {
    return storeState.changeLayers;
  }, function (val) {
    initLayers();
  });
  onMounted(function () {
    bindSliderEvt(); //绑定事件

    setTimeout(function () {
      initLayers();
    }, 500);
  }); //初始化图层

  function initLayers() {
    layers = viewer.scene.layers.layerQueue;
    imgLayers = viewer.imageryLayers._layers;
    mvtLayers = viewer.scene._vectorTileMaps._layerQueue;
    viewer.terrainProvider;
    state.TreeDatas.length = 0;
    updataS3MLayer();
    updataImgLayers();
    updataMvtLayers();
    updataTerrainLayers();
    setTimeout(function () {
      tree.value.setCheckedNodes(state.TreeDatas); //默认全部勾选参与卷帘

      if (state.useRoller) setRollerShutterSplit();
    }, 500);
  }
  // updatS3M图层

  function updataS3MLayer() {
    if (layers.length == 0) {
      return;
    }

    var S3MLayersObj = {
      id: 's3m',
      label: "S3M图层",
      children: []
    };
    layers.forEach(function (layer, index) {
      var S3Mlayer = {
        id: 's3m-' + index,
        label: layer._name
      };
      S3MLayersObj.children.push(S3Mlayer);
    });
    state.TreeDatas[0] = S3MLayersObj;
  }

  function updataImgLayers() {
    if (imgLayers.length == 1) {
      return;
    }

    var imgLayersObj = {
      id: 'img',
      label: "IMG图层",
      children: []
    };
    imgLayers.forEach(function (layer, index) {
      if (index === 0) return true;
      var isMvt = layer._imageryProvider instanceof Cesium.MvtProviderGL;
      if (isMvt) return true;
      var IMGlayer = {
        id: 'img-' + index,
        label: resource.BaseMapImg
      };

      if (layer._imageryProvider.tablename) {
        IMGlayer.label = layer._imageryProvider.tablename;
      }

      imgLayersObj.children.unshift(IMGlayer);
    });
    if (imgLayersObj.children.length > 0) state.TreeDatas[1] = imgLayersObj;
  }

  function updataMvtLayers() {
    if (mvtLayers.length == 0) {
      return;
    }

    var mvtLayersObj = {
      id: 'mvt',
      label: "MVT图层",
      children: []
    };
    mvtLayers.forEach(function (layer, index) {
      var IMGlayer = {
        id: 'mvt-' + index,
        label: layer.name
      };
      mvtLayersObj.children.unshift(IMGlayer);
    });
    state.TreeDatas[2] = mvtLayersObj;
  }

  function updataTerrainLayers() {
    // if (!terrainLayers.tablename) {
    //     return;
    // }
    var terrainLayersObj = {
      id: 'globe',
      label: "地球",
      children: []
    };
    var TerrainLayer = {
      id: 'globe-0',
      label: '地表'
    };
    terrainLayersObj.children.push(TerrainLayer);
    state.TreeDatas[4] = terrainLayersObj;
  }

  function checkNode(data) {
    var node = tree.value.getNode(data);
    var ids = data.id.split('-');
    setLayersRoller(ids, node.checked);
  }
  /**
       * 设置卷帘的分割方向及分割条的位置。
       *
  */

  function setRollerShutterSplit() {
    var startX = rollerShutterConfig.startX;
    var startY = rollerShutterConfig.startY;
    var endX = rollerShutterConfig.endX;
    var endY = rollerShutterConfig.endY;
    var mode = rollerShutterConfig.mode; // 左右卷帘使用left slider滑动，上下卷帘使用top slider滑动

    switch (mode) {
      case 1:
        Cesium.BoundingRectangle.unpack([startX, 0, 1, 1], 0, scratchSwipeRegion);
        break;

      case 2:
        Cesium.BoundingRectangle.unpack([0, 0, startX, 1], 0, scratchSwipeRegion);
        break;

      case 4:
        Cesium.BoundingRectangle.unpack([0, startY, 1, 1], 0, scratchSwipeRegion);
        break;

      case 8:
        Cesium.BoundingRectangle.unpack([0, 0, 1, startY], 0, scratchSwipeRegion);
        break;

      case 15:
        Cesium.BoundingRectangle.unpack([startX, startY, endX - startX, endY - startY], 0, scratchSwipeRegion);
        break;

      default:
        Cesium.BoundingRectangle.unpack([0, 0, 1, 1], 0, scratchSwipeRegion);
        break;
    }

    var checkedKeys = tree.value.getCheckedKeys(true);
    checkedKeys.forEach(function (key) {
      var ids = key.split('-');
      setLayersRoller(ids, true);
    });
  }

  function setLayersRoller(ids, checked) {
    var type = ids[0];
    var index = ids[1];

    switch (type) {
      case 's3m':
        if (!index) {
          for (var i = 0; i < layers.length; i++) {
            layers[i].swipeEnabled = checked;
            layers[i].swipeRegion = scratchSwipeRegion;
          }

          return;
        }

        layers[index].swipeEnabled = checked;
        layers[index].swipeRegion = scratchSwipeRegion;
        break;

      case 'img':
        if (!index) {
          for (var _i = 1; _i < imgLayers.length; _i++) {
            imgLayers[_i].swipeEnabled = checked;
            imgLayers[_i].swipeRegion = scratchSwipeRegion;
          }

          return;
        }

        imgLayers[index].swipeEnabled = checked;
        imgLayers[index].swipeRegion = scratchSwipeRegion;
        break;

      case 'mvt':
        if (!index) {
          for (var _i2 = 0; _i2 < mvtLayers.length; _i2++) {
            mvtLayers[_i2].swipeEnabled = checked;
            mvtLayers[_i2].swipeRegion = scratchSwipeRegion;
          }

          return;
        }

        mvtLayers[index].swipeEnabled = checked;
        mvtLayers[index].swipeRegion = scratchSwipeRegion;
        break;

      case 'globe':
        viewer.scene.globe.swipeEnabled = checked;
        viewer.scene.globe.swipeRegion = scratchSwipeRegion;
        break;
    }
  }

  function cancelLayersRoller() {
    setLayersRoller(['s3m'], false);
    setLayersRoller(['img'], false);
    setLayersRoller(['mvt'], false);
    setLayersRoller(['globe'], false);
  } //设置卷帘条显隐


  function enableSlider(index) {
    verticalSliderLeft.value.style.display = 'none';
    verticalSliderRight.value.style.display = 'none';
    horizontalSliderTop.value.style.display = 'none';
    horizontalSliderBottom.value.style.display = 'none';

    if (index & 1) {
      verticalSliderLeft.value.style.display = 'block';
    }

    if (index & 2) {
      verticalSliderRight.value.style.display = 'block';
    }

    if (index & 4) {
      horizontalSliderTop.value.style.display = 'block';
    }

    if (index & 8) {
      horizontalSliderBottom.value.style.display = 'block';
    }
  }
  /**
   * 注册卷帘分割条的拖拽事件。
   */


  function bindSliderEvt() {
    verticalSliderLeft.value.addEventListener('mousedown', function (e) {
      mouseDown(e, 1);
    }, false);

    verticalSliderRight.value.onmousedown = function (e) {
      mouseDown(e, 3);
    };

    horizontalSliderTop.value.onmousedown = function (e) {
      mouseDown(e, 2);
    };

    horizontalSliderBottom.value.onmousedown = function (e) {
      mouseDown(e, 4);
    };

    window.addEventListener('resize', function () {
      width = document.body.clientWidth - wide; // 窗口宽度

      height = document.body.clientHeight - heide; // 窗口高度
    });
    document.addEventListener('mouseup', mouseUp, false);

    function mouseUp(e) {
      document.removeEventListener('mousemove', sliderMove, false);
    }

    function mouseDown(e, index) {
      rollerShutterConfig.index = index;
      document.addEventListener('mousemove', sliderMove, false);
    }

    function sliderMove(e) {
      if (e.preventDefault) {
        e.preventDefault();
      } else {
        e.returnValue = false;
      }

      switch (rollerShutterConfig.index) {
        case 1:
          verticalSliderLeft.value.style.left = e.clientX - wide + 'px';
          rollerShutterConfig.startX = (e.clientX - wide) / width;
          break;

        case 2:
          horizontalSliderTop.value.style.top = e.clientY - heide + 'px';
          rollerShutterConfig.startY = (e.clientY - heide) / height;
          break;

        case 3:
          verticalSliderRight.value.style.left = e.clientX - wide + 'px';
          rollerShutterConfig.endX = (e.clientX - wide) / width;
          break;

        case 4:
          horizontalSliderBottom.value.style.top = e.clientY - heide + 'px';
          rollerShutterConfig.endY = (e.clientY - heide) / height;
          break;
      }

      setRollerShutterSplit();
    }
  } //监听


  watch(function () {
    return state.multiViewport;
  }, function (val) {
    viewer.scene.multiViewportMode = Cesium.MultiViewportMode[val];
  });
  watch(function () {
    return state.selectedViewport;
  }, function (val, oldval) {
    var keys = tree.value.getCheckedKeys(true);
    state['KeysViewport' + oldval] = keys;
    tree.value.setCheckedKeys(state['KeysViewport' + val], true);
  });
  watch(function () {
    return state.useRoller;
  }, function (val) {
    if (val) {
      if (rollerShutterConfig.mode == 1 || rollerShutterConfig.mode == 2) enableSlider(1);
      if (rollerShutterConfig.mode == 4 || rollerShutterConfig.mode == 8) enableSlider(4);
      if (rollerShutterConfig.mode == 15) enableSlider(15);
      setRollerShutterSplit();
    } else {
      enableSlider(0);
      cancelLayersRoller();
    }
  });
  watch(function () {
    return state.rollerMode;
  }, function (val) {
    switch (val) {
      case "lrRoller":
        if (state.useRoller) enableSlider(1);
        rollerShutterConfig.mode = Number(state.lrRoller);
        break;

      case "tbRoller":
        if (state.useRoller) enableSlider(4);
        rollerShutterConfig.mode = Number(state.tbRoller);
        break;

      case "customRoller":
        if (state.useRoller) enableSlider(15);
        rollerShutterConfig.mode = 15;
        break;
    }

    if (!state.useRoller) return;
    setRollerShutterSplit();
  });
  watch(function () {
    return state.lrRoller;
  }, function (val) {
    if (!state.useRoller) return;
    rollerShutterConfig.mode = Number(val);
    setRollerShutterSplit();
  });
  watch(function () {
    return state.tbRoller;
  }, function (val) {
    if (!state.useRoller) return;
    rollerShutterConfig.mode = Number(val);
    setRollerShutterSplit();
  }); // 销毁

  onBeforeUnmount(function () {
    layers = undefined;
    imgLayers = undefined;
    mvtLayers = undefined;
  });
  return _objectSpread2(_objectSpread2({}, toRefs(state)), {}, {
    tree: tree,
    checkNode: checkNode,
    verticalSliderLeft: verticalSliderLeft,
    verticalSliderRight: verticalSliderRight,
    horizontalSliderTop: horizontalSliderTop,
    horizontalSliderBottom: horizontalSliderBottom
  });
}

var script = {
  name: "Sm3dRoller",
  props: {
    //卷帘模式
    rollerMode: {
      type: String
    }
  },
  setup: function setup(props) {
    var _roller = roller(props),
        useRoller = _roller.useRoller,
        rollerMode = _roller.rollerMode,
        lrRoller = _roller.lrRoller,
        tbRoller = _roller.tbRoller,
        TreeDatas = _roller.TreeDatas,
        tree = _roller.tree,
        checkNode = _roller.checkNode,
        verticalSliderLeft = _roller.verticalSliderLeft,
        verticalSliderRight = _roller.verticalSliderRight,
        horizontalSliderTop = _roller.horizontalSliderTop,
        horizontalSliderBottom = _roller.horizontalSliderBottom;

    return {
      useRoller: useRoller,
      rollerMode: rollerMode,
      lrRoller: lrRoller,
      tbRoller: tbRoller,
      TreeDatas: TreeDatas,
      tree: tree,
      checkNode: checkNode,
      verticalSliderLeft: verticalSliderLeft,
      verticalSliderRight: verticalSliderRight,
      horizontalSliderTop: horizontalSliderTop,
      horizontalSliderBottom: horizontalSliderBottom
    };
  }
};

var _hoisted_1 = {
  id: "split-screen-panel",
  "class": "sm-panel"
};
var _hoisted_2 = {
  "class": "sm-function-module-sub-section",
  style: {
    "margin": "0"
  }
};
var _hoisted_3 = {
  "class": "sm-half-L"
};
var _hoisted_4 = {
  style: {
    "width": "40%"
  }
};
var _hoisted_5 = {
  value: "lrRoller"
};
var _hoisted_6 = {
  value: "tbRoller"
};
var _hoisted_7 = {
  value: "customRoller"
};
var _hoisted_8 = {
  "class": "sm-half-L"
};
var _hoisted_9 = {
  style: {
    "width": "auto"
  }
};
var _hoisted_10 = {
  "class": "sm-half-L"
};
var _hoisted_11 = {
  style: {
    "width": "auto"
  }
};
var _hoisted_12 = {
  style: {
    "width": "auto"
  }
};
var _hoisted_13 = {
  "class": "sm-half-L"
};
var _hoisted_14 = {
  style: {
    "width": "auto"
  }
};
var _hoisted_15 = {
  style: {
    "width": "auto"
  }
};
var _hoisted_16 = {
  "class": "sm-half-L"
};
var _hoisted_17 = {
  id: "verticalSliderLeft",
  ref: "verticalSliderLeft"
};
var _hoisted_18 = {
  id: "verticalSliderRight",
  ref: "verticalSliderRight"
};
var _hoisted_19 = {
  id: "horizontalSliderTop",
  ref: "horizontalSliderTop"
};
var _hoisted_20 = {
  id: "horizontalSliderBottom",
  ref: "horizontalSliderBottom"
};
function render(_ctx, _cache, $props, $setup, $data, $options) {
  var _component_el_tree = resolveComponent("el-tree");

  var _directive_stopdrag = resolveDirective("stopdrag");

  var _directive_drag = resolveDirective("drag");

  return openBlock(), createElementBlock(Fragment, null, [withDirectives((openBlock(), createElementBlock("div", _hoisted_1, [withDirectives((openBlock(), createElementBlock("div", _hoisted_2, [createElementVNode("div", _hoisted_3, [createElementVNode("label", _hoisted_4, toDisplayString(_ctx.Resource.rollerMode), 1
  /* TEXT */
  ), withDirectives(createElementVNode("select", {
    "class": "sm-select-m",
    style: {
      "width": "60%"
    },
    "onUpdate:modelValue": _cache[0] || (_cache[0] = function ($event) {
      return $setup.rollerMode = $event;
    })
  }, [createElementVNode("option", _hoisted_5, toDisplayString(_ctx.Resource.lrRoller), 1
  /* TEXT */
  ), createElementVNode("option", _hoisted_6, toDisplayString(_ctx.Resource.tbRoller), 1
  /* TEXT */
  ), createElementVNode("option", _hoisted_7, toDisplayString(_ctx.Resource.customRoller), 1
  /* TEXT */
  )], 512
  /* NEED_PATCH */
  ), [[vModelSelect, $setup.rollerMode]])]), createElementVNode("div", _hoisted_8, [createElementVNode("label", _hoisted_9, [withDirectives(createElementVNode("input", {
    type: "checkbox",
    "onUpdate:modelValue": _cache[1] || (_cache[1] = function ($event) {
      return $setup.useRoller = $event;
    })
  }, null, 512
  /* NEED_PATCH */
  ), [[vModelCheckbox, $setup.useRoller]]), createTextVNode(" " + toDisplayString(_ctx.Resource.useRoller), 1
  /* TEXT */
  )])]), withDirectives(createElementVNode("div", _hoisted_10, [createElementVNode("label", _hoisted_11, [withDirectives(createElementVNode("input", {
    type: "radio",
    value: "1",
    "onUpdate:modelValue": _cache[2] || (_cache[2] = function ($event) {
      return $setup.lrRoller = $event;
    })
  }, null, 512
  /* NEED_PATCH */
  ), [[vModelRadio, $setup.lrRoller]]), createTextVNode(" " + toDisplayString(_ctx.Resource.shieldLeft), 1
  /* TEXT */
  )]), createElementVNode("label", _hoisted_12, [withDirectives(createElementVNode("input", {
    type: "radio",
    value: "2",
    "onUpdate:modelValue": _cache[3] || (_cache[3] = function ($event) {
      return $setup.lrRoller = $event;
    })
  }, null, 512
  /* NEED_PATCH */
  ), [[vModelRadio, $setup.lrRoller]]), createTextVNode(" " + toDisplayString(_ctx.Resource.shieldRight), 1
  /* TEXT */
  )])], 512
  /* NEED_PATCH */
  ), [[vShow, $setup.rollerMode == 'lrRoller' && $setup.useRoller]]), withDirectives(createElementVNode("div", _hoisted_13, [createElementVNode("label", _hoisted_14, [withDirectives(createElementVNode("input", {
    type: "radio",
    value: "4",
    "onUpdate:modelValue": _cache[4] || (_cache[4] = function ($event) {
      return $setup.tbRoller = $event;
    })
  }, null, 512
  /* NEED_PATCH */
  ), [[vModelRadio, $setup.tbRoller]]), createTextVNode(" " + toDisplayString(_ctx.Resource.shieldTop), 1
  /* TEXT */
  )]), createElementVNode("label", _hoisted_15, [withDirectives(createElementVNode("input", {
    type: "radio",
    value: "8",
    "onUpdate:modelValue": _cache[5] || (_cache[5] = function ($event) {
      return $setup.tbRoller = $event;
    })
  }, null, 512
  /* NEED_PATCH */
  ), [[vModelRadio, $setup.tbRoller]]), createTextVNode(" " + toDisplayString(_ctx.Resource.shieldBottom), 1
  /* TEXT */
  )])], 512
  /* NEED_PATCH */
  ), [[vShow, $setup.rollerMode == 'tbRoller' && $setup.useRoller]]), withDirectives(createElementVNode("div", _hoisted_16, [createVNode(_component_el_tree, {
    data: $setup.TreeDatas,
    "show-checkbox": "",
    "node-key": "id",
    accordion: "",
    ref: "tree",
    onCheck: $setup.checkNode
  }, null, 8
  /* PROPS */
  , ["data", "onCheck"])], 512
  /* NEED_PATCH */
  ), [[vShow, $setup.useRoller]])])), [[_directive_stopdrag]])])), [[_directive_drag]]), createElementVNode("div", _hoisted_17, null, 512
  /* NEED_PATCH */
  ), createElementVNode("div", _hoisted_18, null, 512
  /* NEED_PATCH */
  ), createElementVNode("div", _hoisted_19, null, 512
  /* NEED_PATCH */
  ), createElementVNode("div", _hoisted_20, null, 512
  /* NEED_PATCH */
  )], 64
  /* STABLE_FRAGMENT */
  );
}

script.render = render;
script.__file = "src/components/scene/roller/roller.vue";

script.install = function (app) {
  app.component(script.name, script);
};

export default script;
