import { reactive, toRefs, watch, onBeforeUnmount, resolveComponent, resolveDirective, withDirectives, openBlock, createElementBlock, createElementVNode, toDisplayString, Fragment, renderList, vShow, vModelSelect, createVNode, vModelRadio, createTextVNode, vModelText } from 'vue';

function _typeof(obj) {
  "@babel/helpers - typeof";

  if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
    _typeof = function (obj) {
      return typeof obj;
    };
  } else {
    _typeof = function (obj) {
      return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
    };
  }

  return _typeof(obj);
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);

  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    if (enumerableOnly) symbols = symbols.filter(function (sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    });
    keys.push.apply(keys, symbols);
  }

  return keys;
}

function _objectSpread2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};

    if (i % 2) {
      ownKeys(Object(source), true).forEach(function (key) {
        _defineProperty(target, key, source[key]);
      });
    } else if (Object.getOwnPropertyDescriptors) {
      Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
      ownKeys(Object(source)).forEach(function (key) {
        Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
      });
    }
  }

  return target;
}

// 创建一个简单的store状态管理

var storeState = reactive({
  isViewer: false,
  //viewer初始化标志
  changeLayers: 0,
  //图层改变加载完毕监听
  changeGeometrys: 0 //三维分析体改变标志

});

/*
* 常用工具类
*/
//axios本版本不支持jsonp
var axiosJsonp = function axiosJsonp(url) {
  if (!url) {
    console.error('Axios.JSONP 至少需要一个url参数!');
    return;
  }

  return new Promise(function (resolve, reject) {
    window.jsonCallBack = function (result) {
      resolve(result);
    };

    var JSONP = document.createElement("script");
    JSONP.type = "text/javascript";
    JSONP.src = "".concat(url, "&callback=jsonCallBack");
    document.getElementsByTagName("head")[0].appendChild(JSONP);
    setTimeout(function () {
      document.getElementsByTagName("head")[0].removeChild(JSONP);
    }, 500);
  });
}; //判断两数组或对象相等


var isEqualArr = function isEqualArr(arg1, arg2) {
  if (!arg1 || !arg2) return true;
  var bol = true;

  if (Object.keys(arg1).length != Object.keys(arg2).length) {
    return false;
  }

  for (var key in arg1) {
    if (_typeof(arg1[key]) == 'object') {
      bol = isSame(arg1[key], arg2[key]);

      if (!bol) {
        break;
      }
    } else if (arg1[key] != arg2[key]) {
      bol = false;
      break;
    }
  }

  return bol;
}; //坐标转化
//笛卡尔转经纬度


var CartesiantoDegrees = function CartesiantoDegrees(Cartesians) {
  var array = [].concat(Cartesians);
  var positions = [];

  for (var i = 0, len = array.length; i < len; i++) {
    var cartographic = Cesium.Cartographic.fromCartesian(array[i]);
    var longitude = Cesium.Math.toDegrees(cartographic.longitude);
    var latitude = Cesium.Math.toDegrees(cartographic.latitude);
    var h = cartographic.height;

    if (positions.indexOf(longitude) == -1 && positions.indexOf(latitude) == -1) {
      positions.push(longitude);
      positions.push(latitude);
      positions.push(h);
    }
  }

  return positions;
}; //笛卡尔转经纬度(每个点是独立的对象)


var CartesiantoDegreesObjs = function CartesiantoDegreesObjs(Cartesians) {
  var array = [].concat(Cartesians);
  var positions = [];

  for (var i = 0, len = array.length; i < len; i++) {
    var cartographic = Cesium.Cartographic.fromCartesian(array[i]);
    var obj = {
      longitude: Cesium.Math.toDegrees(cartographic.longitude),
      latitude: Cesium.Math.toDegrees(cartographic.latitude),
      height: cartographic.height
    };
    positions.push(obj);
  }

  return positions;
}; // 弧度转经纬度


var CartographictoDegrees = function CartographictoDegrees(wgsPosition) {
  var longitude = Cesium.Math.toDegrees(wgsPosition.longitude);
  var latitude = Cesium.Math.toDegrees(wgsPosition.latitude);
  var height = wgsPosition.height;
  return [longitude, latitude, height];
}; //去重函数  数组


var unique = function unique(arr) {
  var res = [];
  var json = {};

  for (var i = 0; i < arr.length; i++) {
    if (!json[arr[i]]) {
      res.push(arr[i]);
      json[arr[i]] = 1;
    }
  }

  return res;
}; // 获取渐变色函数


function gradientColors(start, end, steps, gamma) {
  var i,
      j,
      ms,
      me,
      output = [],
      so = [];
  gamma = gamma || 1;

  var normalize = function normalize(channel) {
    return Math.pow(channel / 255, gamma);
  };

  start = parseColor(start).map(normalize);
  end = parseColor(end).map(normalize);

  for (i = 0; i < steps; i++) {
    ms = i / (steps - 1);
    me = 1 - ms;

    for (j = 0; j < 3; j++) {
      so[j] = pad(Math.round(Math.pow(start[j] * me + end[j] * ms, 1 / gamma) * 255).toString(16));
    }

    output.push('#' + so.join(''));
  }

  return output;

  function parseColor(hexStr) {
    return hexStr.length === 4 ? hexStr.substr(1).split('').map(function (s) {
      return 0x11 * parseInt(s, 16);
    }) : [hexStr.substr(1, 2), hexStr.substr(3, 2), hexStr.substr(5, 2)].map(function (s) {
      return parseInt(s, 16);
    });
  }

  function pad(s) {
    return s.length === 1 ? '0' + s : s;
  }
}

function getAngleAndRadian(pointA, pointB) {
  //建立以点A为原点，X轴为east,Y轴为north,Z轴朝上的坐标系
  var transform = Cesium.Transforms.eastNorthUpToFixedFrame(pointA); //向量AB

  var positionvector = Cesium.Cartesian3.subtract(pointB, pointA, new Cesium.Cartesian3()); //因transform是将A为原点的eastNorthUp坐标系中的点转换到世界坐标系的矩阵
  //AB为世界坐标中的向量
  //因此将AB向量转换为A原点坐标系中的向量，需乘以transform的逆矩阵。

  var vector = Cesium.Matrix4.multiplyByPointAsVector(Cesium.Matrix4.inverse(transform, new Cesium.Matrix4()), positionvector, new Cesium.Cartesian3()); //归一化

  var direction = Cesium.Cartesian3.normalize(vector, new Cesium.Cartesian3()); //heading

  var heading1 = Math.atan2(direction.y, direction.x) - Cesium.Math.PI_OVER_TWO;
  var radian = Cesium.Math.TWO_PI - Cesium.Math.zeroToTwoPi(heading1);
  var angle = radian * (180 / Math.PI);

  if (angle < 0) {
    angle = angle + 360;
  }

  return {
    angle: angle,
    radian: radian
  };
}

function getPitch(pointA, pointB) {
  var transfrom = Cesium.Transforms.eastNorthUpToFixedFrame(pointA);
  var vector = Cesium.Cartesian3.subtract(pointB, pointA, new Cesium.Cartesian3());
  var direction = Cesium.Matrix4.multiplyByPointAsVector(Cesium.Matrix4.inverse(transfrom, transfrom), vector, vector);
  Cesium.Cartesian3.normalize(direction, direction); //因为direction已归一化，斜边长度等于1，所以余弦函数等于direction.z

  var radian = Cesium.Math.PI_OVER_TWO - Cesium.Math.acosClamped(direction.z);
  var angle = radian * (180 / Math.PI);

  if (angle < 0) {
    angle = angle + 360;
  }

  return {
    angle: angle,
    radian: radian
  };
}

var tool = {
  axiosJsonp: axiosJsonp,
  isEqualArr: isEqualArr,
  CartesiantoDegrees: CartesiantoDegrees,
  CartesiantoDegreesObjs: CartesiantoDegreesObjs,
  unique: unique,
  gradientColors: gradientColors,
  getAngleAndRadian: getAngleAndRadian,
  CartographictoDegrees: CartographictoDegrees,
  getPitch: getPitch
};

var ResourceCN = {
  showRenderLoopErrors: '渲染时发生错误，已停止渲染。',
  AttributeError: '该组件props没有这个属性：',
  NoPickPositionSupported: "不支持深度纹理,无法绘制多边形，地形操作功能无法使用！",
  NoTerrain: "请在地形里使用地形组件！",
  initViewerWarn: '请先初始化viewer!',
  MoveMouseHeightBox: '点击鼠标左键结束矩形绘制，移动鼠标绘制box高度',
  RightClickEndDrawing: '右键单击结束绘制',
  LeftClickBottomBox: '点击鼠标左键，开始绘制矩形作为box底面',
  ClickModelAddBox: '点击模型，添加裁剪盒子',
  SkyLineWarn: "获取天际线体前，请先绘制天际线！",
  SkyLineBody: '天际线体',
  ShadowqueryWarn: "此操作需要先开启阴影！",
  VeiwshedBody: '可视体',
  VeiwshedBodyHidden: '不可视体',
  EchartsErr: "二维显示需要echarts支持，未找到相关依赖！",
  BaseMapImg: '底图',
  tip1: '<p>点击左键确定操作区域中间点</p><p>右键单击结束绘制</p>'
};

// 组件内部的语言资源：主要包括提示信息
var currentLanguage, Resource;
var cookieLanguage = getLang().toLowerCase();

function getLang() {
  //浏览器语言  IE用browserLanguage，非IE使用language进行判断
  var lang = (navigator.language || navigator.browserLanguage).toLowerCase();
  window.lang = lang; //判断portal设置语言 通过cookie获取
  //   const cookies = document.cookie.split(';');
  //   if (cookies.length > 0) {
  //     cookies.forEach(function (cookie) {
  //       const arr = cookie.split('=');
  //       if (arr[0].toLowerCase().trim() === 'language') {
  //         lang = arr[1];
  //         return;
  //       }
  //     });
  //   }

  return lang;
}

if (cookieLanguage !== undefined) {
  currentLanguage = cookieLanguage;
} else {
  currentLanguage = (navigator.language || navigator.browserLanguage).toLowerCase(); // 获取当前浏览器的语言
}

if (currentLanguage.startsWith('zh')) {
  Resource = ResourceCN;
} else if (currentLanguage.startsWith('ja')) {
  Resource = ResourceCN;
} else {
  Resource = ResourceCN;
}

var resource = Resource;

function s3mlayerStyle(props) {
  var _this = this;

  // 设置默认值数据
  var state = reactive({
    layerNames: [],
    //当前存在的可选择s3m图层
    selectedLayerName: 'none',
    //默认选择图层名称
    foreColor: "#ffffff",
    //前景色
    lineColor: "rgba(27, 27, 27, 1)",
    //线颜色
    selectedColor: "#A40FF4",
    //选中色
    selectColorMode: 'mix',
    //选中色模式
    bottomAltitude: 0,
    //底部高程
    LODScale: 5,
    //LOD
    layerTrans: 1,
    //图层透明度
    fillStyle: 'fill',
    //填充风格
    visibleDistanceMin: 0,
    //最小可见距离
    visibleDistanceMax: 10000 //最大可见距离

  }); // 传入props改变默认值

  if (props) {
    for (var key in props) {
      if (state.hasOwnProperty(key)) {
        if (props[key] != undefined) state[key] = props[key];
      } else {
        tool.Message.errorMsg(resource.AttributeError + key);
      }
    }
  } // 初始化数据


  var layers, selectedLayer;

  if (storeState.isViewer) {
    getLayerNames();
  } //viewer 初始化完成的监听


  watch(function () {
    return storeState.isViewer;
  }, function (val) {
    if (val) {
      getLayerNames();
    }
  }); //监听图层加载完成

  watch(function () {
    return storeState.changeLayers;
  }, function (val) {
    getLayerNames();
  }); //初始化图层

  function getLayerNames() {
    viewer.scene;
    layers = viewer.scene.layers.layerQueue;

    if (layers && layers.length > 0) {
      layers.forEach(function (element, index) {
        if (!state.layerNames.includes(element._name)) {
          state.layerNames.push(element._name);
        }
      });

      if (state.selectedLayerName = 'none') {
        state.selectedLayerName = state.layerNames[0];
        selectedLayer = layers[0];
      }
    }
  } // 销毁


  onBeforeUnmount(function () {
    layers = null;
  }); // 监听

  watch(function () {
    return state.selectedLayerName;
  }, function (val) {
    var index = state.layerNames.indexOf(val);
    if (index == -1) return;
    selectedLayer = layers[index];
  });
  watch(function () {
    return state.foreColor;
  }, function (val) {
    if (selectedLayer) selectedLayer.style3D.fillForeColor = Cesium.Color.fromCssColorString(val);
  });
  watch(function () {
    return state.lineColor;
  }, function (val) {
    if (selectedLayer) selectedLayer.style3D.lineColor = Cesium.Color.fromCssColorString(val);
  });
  watch(function () {
    return state.selectedColor;
  }, function (val) {
    if (selectedLayer) selectedLayer.selectedColor = Cesium.Color.fromCssColorString(val);
  });
  watch(function () {
    return state.selectColorMode;
  }, function (val) {
    if (selectedLayer) selectedLayer.selectColorType = val === 'mix' ? 0 : 1;
  });
  watch(function () {
    return state.bottomAltitude;
  }, function (val) {
    if (selectedLayer) selectedLayer.style3D.bottomAltitude = Number(val);
    selectedLayer.refresh();
  });
  watch(function () {
    return state.fillStyle;
  }, function (val) {
    if (selectedLayer) switch (val) {
      case "fill":
        selectedLayer.style3D.fillStyle = Cesium.FillStyle.Fill;
        break;

      case "wireframe":
        selectedLayer.style3D.fillStyle = Cesium.FillStyle.WireFrame;
        selectedLayer.style3D.lineColor = Cesium.Color.fromCssColorString(state.lineColor);
        break;

      case "fill-and-wireframe":
        selectedLayer.style3D.fillStyle = Cesium.FillStyle.Fill_And_WireFrame;
        selectedLayer.style3D.lineColor = Cesium.Color.fromCssColorString(state.lineColor);
        break;
    }
    selectedLayer.refresh();
  });
  watch(function () {
    return state.LODScale;
  }, function (val) {
    if (selectedLayer) selectedLayer.lodRangeScale = Number(val);
  });
  watch(function () {
    return state.layerTrans;
  }, function (val) {
    if (selectedLayer) selectedLayer.style3D.fillForeColor.alpha = Number(val);
  });
  watch(function () {
    return state.visibleDistanceMin;
  }, function (val) {
    if (val == "") {
      val = 0.0;
    }

    if (selectedLayer) selectedLayer.visibleDistanceMin = Number(val);
  });
  watch(function () {
    return state.visibleDistanceMax;
  }, function (val) {
    if (val == "") {
      val = _this.maxNumber;
    }

    if (selectedLayer) selectedLayer.cullEnabled = val;
    selectedLayer.visibleDistanceMax = Number(val);
  });
  return _objectSpread2({}, toRefs(state));
}

var script = {
  name: "Sm3dS3mlayerStyle",
  props: {
    //默认选择图层名称
    selectedLayerName: {
      type: String
    },
    //前景色
    foreColor: {
      type: String
    },
    //线颜色
    lineColor: {
      type: String
    },
    //选中色
    selectedColor: {
      type: String
    },
    //选中模式
    selectColorMode: {
      type: String
    },
    //底部高层
    bottomAltitude: {
      type: Number
    },
    //lod
    LODScale: {
      type: Number
    },
    //图层透明度
    layerTrans: {
      type: Number
    },
    //填充风格
    fillStyle: {
      type: String
    },
    //最小可见高度
    visibleDistanceMin: {
      type: Number
    },
    //最大可见高度
    visibleDistanceMax: {
      type: Number
    }
  },
  setup: function setup(props) {
    var _s3mlayerStyle = s3mlayerStyle(props),
        layerNames = _s3mlayerStyle.layerNames,
        selectedLayerName = _s3mlayerStyle.selectedLayerName,
        foreColor = _s3mlayerStyle.foreColor,
        lineColor = _s3mlayerStyle.lineColor,
        selectedColor = _s3mlayerStyle.selectedColor,
        selectColorMode = _s3mlayerStyle.selectColorMode,
        bottomAltitude = _s3mlayerStyle.bottomAltitude,
        LODScale = _s3mlayerStyle.LODScale,
        layerTrans = _s3mlayerStyle.layerTrans,
        fillStyle = _s3mlayerStyle.fillStyle,
        visibleDistanceMin = _s3mlayerStyle.visibleDistanceMin,
        visibleDistanceMax = _s3mlayerStyle.visibleDistanceMax;

    return {
      layerNames: layerNames,
      selectedLayerName: selectedLayerName,
      foreColor: foreColor,
      lineColor: lineColor,
      selectedColor: selectedColor,
      selectColorMode: selectColorMode,
      bottomAltitude: bottomAltitude,
      LODScale: LODScale,
      layerTrans: layerTrans,
      fillStyle: fillStyle,
      visibleDistanceMin: visibleDistanceMin,
      visibleDistanceMax: visibleDistanceMax
    };
  }
};

var _hoisted_1 = {
  id: "s3mlayer-attribute-panel",
  "class": "sm-panel"
};
var _hoisted_2 = {
  "class": "sm-function-module-sub-section",
  style: {
    "margin": "0"
  }
};
var _hoisted_3 = {
  "class": "sm-half-L"
};
var _hoisted_4 = {
  style: {
    "width": "35%"
  }
};
var _hoisted_5 = ["value"];
var _hoisted_6 = {
  "class": "sm-half-L"
};
var _hoisted_7 = {
  style: {
    "width": "35%"
  }
};
var _hoisted_8 = {
  "class": "sm-half-L"
};
var _hoisted_9 = {
  style: {
    "width": "35%"
  }
};
var _hoisted_10 = {
  "class": "sm-half-L"
};
var _hoisted_11 = {
  style: {
    "width": "35%"
  }
};
var _hoisted_12 = {
  "class": "sm-half-L"
};
var _hoisted_13 = {
  style: {
    "width": "35%"
  }
};
var _hoisted_14 = {
  "class": "sm-half",
  style: {
    "width": "63%"
  }
};
var _hoisted_15 = {
  style: {
    "width": "auto"
  }
};
var _hoisted_16 = {
  style: {
    "width": "auto"
  }
};
var _hoisted_17 = {
  "class": "sm-half-L"
};
var _hoisted_18 = {
  style: {
    "width": "35%"
  }
};
var _hoisted_19 = {
  "class": "sm-half-L"
};

var _hoisted_20 = /*#__PURE__*/createElementVNode("label", {
  style: {
    "width": "35%"
  }
}, "LOD", -1
/* HOISTED */
);

var _hoisted_21 = {
  "class": "sm-half-L"
};
var _hoisted_22 = {
  style: {
    "width": "35%"
  }
};
var _hoisted_23 = {
  "class": "sm-half-L"
};
var _hoisted_24 = {
  style: {
    "width": "35%"
  }
};
var _hoisted_25 = {
  value: "fill"
};
var _hoisted_26 = {
  value: "wireframe"
};
var _hoisted_27 = {
  value: "fill-and-wireframe"
};
var _hoisted_28 = {
  "class": "sm-half-L"
};
var _hoisted_29 = {
  style: {
    "width": "35%"
  }
};
var _hoisted_30 = {
  "class": "sm-half-L"
};
var _hoisted_31 = {
  style: {
    "width": "35%"
  }
};
function render(_ctx, _cache, $props, $setup, $data, $options) {
  var _component_el_color_picker = resolveComponent("el-color-picker");

  var _component_el_slider = resolveComponent("el-slider");

  var _directive_stopdrag = resolveDirective("stopdrag");

  var _directive_drag = resolveDirective("drag");

  return withDirectives((openBlock(), createElementBlock("div", _hoisted_1, [withDirectives((openBlock(), createElementBlock("div", _hoisted_2, [createElementVNode("div", _hoisted_3, [createElementVNode("label", _hoisted_4, toDisplayString(_ctx.Resource.selectedLayer), 1
  /* TEXT */
  ), withDirectives(createElementVNode("select", {
    "class": "sm-select",
    style: {
      "width": "63%"
    },
    "onUpdate:modelValue": _cache[0] || (_cache[0] = function ($event) {
      return $setup.selectedLayerName = $event;
    })
  }, [(openBlock(true), createElementBlock(Fragment, null, renderList($setup.layerNames, function (layer, index) {
    return openBlock(), createElementBlock("option", {
      key: index,
      value: layer
    }, toDisplayString(layer), 9
    /* TEXT, PROPS */
    , _hoisted_5);
  }), 128
  /* KEYED_FRAGMENT */
  )), withDirectives(createElementVNode("option", {
    value: "none"
  }, toDisplayString(_ctx.Resource.noS3mLayer), 513
  /* TEXT, NEED_PATCH */
  ), [[vShow, $setup.layerNames.length == 0]])], 512
  /* NEED_PATCH */
  ), [[vModelSelect, $setup.selectedLayerName]])]), createElementVNode("div", _hoisted_6, [createElementVNode("label", _hoisted_7, toDisplayString(_ctx.Resource.foreColor), 1
  /* TEXT */
  ), createVNode(_component_el_color_picker, {
    modelValue: $setup.foreColor,
    "onUpdate:modelValue": _cache[1] || (_cache[1] = function ($event) {
      return $setup.foreColor = $event;
    }),
    size: "mini",
    "show-alpha": "",
    style: {
      "width": "63%"
    }
  }, null, 8
  /* PROPS */
  , ["modelValue"])]), createElementVNode("div", _hoisted_8, [createElementVNode("label", _hoisted_9, toDisplayString(_ctx.Resource.lineColor), 1
  /* TEXT */
  ), createVNode(_component_el_color_picker, {
    modelValue: $setup.lineColor,
    "onUpdate:modelValue": _cache[2] || (_cache[2] = function ($event) {
      return $setup.lineColor = $event;
    }),
    size: "mini",
    "show-alpha": "",
    style: {
      "width": "63%"
    }
  }, null, 8
  /* PROPS */
  , ["modelValue"])]), createElementVNode("div", _hoisted_10, [createElementVNode("label", _hoisted_11, toDisplayString(_ctx.Resource.selectedColor), 1
  /* TEXT */
  ), createVNode(_component_el_color_picker, {
    modelValue: $setup.selectedColor,
    "onUpdate:modelValue": _cache[3] || (_cache[3] = function ($event) {
      return $setup.selectedColor = $event;
    }),
    size: "mini",
    "show-alpha": "",
    style: {
      "width": "63%"
    }
  }, null, 8
  /* PROPS */
  , ["modelValue"])]), createElementVNode("div", _hoisted_12, [createElementVNode("label", _hoisted_13, toDisplayString(_ctx.Resource.selectColorMode), 1
  /* TEXT */
  ), createElementVNode("div", _hoisted_14, [createElementVNode("label", _hoisted_15, [withDirectives(createElementVNode("input", {
    type: "radio",
    value: "mix",
    "onUpdate:modelValue": _cache[4] || (_cache[4] = function ($event) {
      return $setup.selectColorMode = $event;
    })
  }, null, 512
  /* NEED_PATCH */
  ), [[vModelRadio, $setup.selectColorMode]]), createTextVNode(" " + toDisplayString(_ctx.Resource.mix), 1
  /* TEXT */
  )]), createElementVNode("label", _hoisted_16, [withDirectives(createElementVNode("input", {
    type: "radio",
    value: "replace",
    "onUpdate:modelValue": _cache[5] || (_cache[5] = function ($event) {
      return $setup.selectColorMode = $event;
    })
  }, null, 512
  /* NEED_PATCH */
  ), [[vModelRadio, $setup.selectColorMode]]), createTextVNode(" " + toDisplayString(_ctx.Resource.replace), 1
  /* TEXT */
  )])])]), createElementVNode("div", _hoisted_17, [createElementVNode("label", _hoisted_18, toDisplayString(_ctx.Resource.bottomAltitude), 1
  /* TEXT */
  ), createVNode(_component_el_slider, {
    modelValue: $setup.bottomAltitude,
    "onUpdate:modelValue": _cache[6] || (_cache[6] = function ($event) {
      return $setup.bottomAltitude = $event;
    }),
    min: 0,
    step: 1,
    max: 1000,
    "input-size": "mini",
    debounce: 1000,
    "tooltip-class": "tooltip-class",
    style: {
      "width": "63%"
    }
  }, null, 8
  /* PROPS */
  , ["modelValue"])]), createElementVNode("div", _hoisted_19, [_hoisted_20, createVNode(_component_el_slider, {
    modelValue: $setup.LODScale,
    "onUpdate:modelValue": _cache[7] || (_cache[7] = function ($event) {
      return $setup.LODScale = $event;
    }),
    min: 0,
    max: 10,
    step: 0.5,
    "input-size": "mini",
    debounce: 500,
    "tooltip-class": "tooltip-class",
    style: {
      "width": "63%"
    }
  }, null, 8
  /* PROPS */
  , ["modelValue", "step"])]), createElementVNode("div", _hoisted_21, [createElementVNode("label", _hoisted_22, toDisplayString(_ctx.Resource.layerTrans), 1
  /* TEXT */
  ), createVNode(_component_el_slider, {
    modelValue: $setup.layerTrans,
    "onUpdate:modelValue": _cache[8] || (_cache[8] = function ($event) {
      return $setup.layerTrans = $event;
    }),
    min: 0,
    max: 1,
    step: 0.01,
    "input-size": "mini",
    debounce: 500,
    "tooltip-class": "tooltip-class",
    style: {
      "width": "63%"
    }
  }, null, 8
  /* PROPS */
  , ["modelValue", "step"])]), createElementVNode("div", _hoisted_23, [createElementVNode("label", _hoisted_24, toDisplayString(_ctx.Resource.fillStyle), 1
  /* TEXT */
  ), withDirectives(createElementVNode("select", {
    "class": "sm-select",
    style: {
      "width": "63%"
    },
    "onUpdate:modelValue": _cache[9] || (_cache[9] = function ($event) {
      return $setup.fillStyle = $event;
    })
  }, [createElementVNode("option", _hoisted_25, toDisplayString(_ctx.Resource.fillMode), 1
  /* TEXT */
  ), createElementVNode("option", _hoisted_26, toDisplayString(_ctx.Resource.lineMode), 1
  /* TEXT */
  ), createElementVNode("option", _hoisted_27, toDisplayString(_ctx.Resource.fillAndLine), 1
  /* TEXT */
  )], 512
  /* NEED_PATCH */
  ), [[vModelSelect, $setup.fillStyle]])]), createElementVNode("div", _hoisted_28, [createElementVNode("label", _hoisted_29, toDisplayString(_ctx.Resource.visibleDistanceMin), 1
  /* TEXT */
  ), withDirectives(createElementVNode("input", {
    type: "number",
    "class": "sm-input",
    style: {
      "width": "63%"
    },
    "onUpdate:modelValue": _cache[10] || (_cache[10] = function ($event) {
      return $setup.visibleDistanceMin = $event;
    })
  }, null, 512
  /* NEED_PATCH */
  ), [[vModelText, $setup.visibleDistanceMin]])]), createElementVNode("div", _hoisted_30, [createElementVNode("label", _hoisted_31, toDisplayString(_ctx.Resource.visibleDistanceMax), 1
  /* TEXT */
  ), withDirectives(createElementVNode("input", {
    type: "number",
    "class": "sm-input",
    style: {
      "width": "63%"
    },
    "onUpdate:modelValue": _cache[11] || (_cache[11] = function ($event) {
      return $setup.visibleDistanceMax = $event;
    })
  }, null, 512
  /* NEED_PATCH */
  ), [[vModelText, $setup.visibleDistanceMax]])])])), [[_directive_stopdrag]])])), [[_directive_drag]]);
}

script.render = render;
script.__file = "src/components/layer/s3mlayer-style/s3mlayer-style.vue";

script.install = function (app) {
  app.component(script.name, script);
};

export default script;
