import { reactive, toRefs, watch, onBeforeUnmount, resolveDirective, withDirectives, openBlock, createElementBlock, createElementVNode, toDisplayString, vModelRadio, createTextVNode, Fragment, renderList, vModelSelect, vShow } from 'vue';

function _typeof(obj) {
  "@babel/helpers - typeof";

  if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
    _typeof = function (obj) {
      return typeof obj;
    };
  } else {
    _typeof = function (obj) {
      return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
    };
  }

  return _typeof(obj);
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);

  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    if (enumerableOnly) symbols = symbols.filter(function (sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    });
    keys.push.apply(keys, symbols);
  }

  return keys;
}

function _objectSpread2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};

    if (i % 2) {
      ownKeys(Object(source), true).forEach(function (key) {
        _defineProperty(target, key, source[key]);
      });
    } else if (Object.getOwnPropertyDescriptors) {
      Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
      ownKeys(Object(source)).forEach(function (key) {
        Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
      });
    }
  }

  return target;
}

function _toConsumableArray(arr) {
  return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread();
}

function _arrayWithoutHoles(arr) {
  if (Array.isArray(arr)) return _arrayLikeToArray(arr);
}

function _iterableToArray(iter) {
  if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter);
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

  return arr2;
}

function _nonIterableSpread() {
  throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

// 创建一个简单的store状态管理

var storeState = reactive({
  isViewer: false,
  //viewer初始化标志
  changeLayers: 0,
  //图层改变加载完毕监听
  changeGeometrys: 0 //三维分析体改变标志

});

/*
* 常用工具类
*/
//axios本版本不支持jsonp
var axiosJsonp = function axiosJsonp(url) {
  if (!url) {
    console.error('Axios.JSONP 至少需要一个url参数!');
    return;
  }

  return new Promise(function (resolve, reject) {
    window.jsonCallBack = function (result) {
      resolve(result);
    };

    var JSONP = document.createElement("script");
    JSONP.type = "text/javascript";
    JSONP.src = "".concat(url, "&callback=jsonCallBack");
    document.getElementsByTagName("head")[0].appendChild(JSONP);
    setTimeout(function () {
      document.getElementsByTagName("head")[0].removeChild(JSONP);
    }, 500);
  });
}; //判断两数组或对象相等


var isEqualArr = function isEqualArr(arg1, arg2) {
  if (!arg1 || !arg2) return true;
  var bol = true;

  if (Object.keys(arg1).length != Object.keys(arg2).length) {
    return false;
  }

  for (var key in arg1) {
    if (_typeof(arg1[key]) == 'object') {
      bol = isSame(arg1[key], arg2[key]);

      if (!bol) {
        break;
      }
    } else if (arg1[key] != arg2[key]) {
      bol = false;
      break;
    }
  }

  return bol;
}; //坐标转化
//笛卡尔转经纬度


var CartesiantoDegrees = function CartesiantoDegrees(Cartesians) {
  var array = [].concat(Cartesians);
  var positions = [];

  for (var i = 0, len = array.length; i < len; i++) {
    var cartographic = Cesium.Cartographic.fromCartesian(array[i]);
    var longitude = Cesium.Math.toDegrees(cartographic.longitude);
    var latitude = Cesium.Math.toDegrees(cartographic.latitude);
    var h = cartographic.height;

    if (positions.indexOf(longitude) == -1 && positions.indexOf(latitude) == -1) {
      positions.push(longitude);
      positions.push(latitude);
      positions.push(h);
    }
  }

  return positions;
}; //笛卡尔转经纬度(每个点是独立的对象)


var CartesiantoDegreesObjs = function CartesiantoDegreesObjs(Cartesians) {
  var array = [].concat(Cartesians);
  var positions = [];

  for (var i = 0, len = array.length; i < len; i++) {
    var cartographic = Cesium.Cartographic.fromCartesian(array[i]);
    var obj = {
      longitude: Cesium.Math.toDegrees(cartographic.longitude),
      latitude: Cesium.Math.toDegrees(cartographic.latitude),
      height: cartographic.height
    };
    positions.push(obj);
  }

  return positions;
}; // 弧度转经纬度


var CartographictoDegrees = function CartographictoDegrees(wgsPosition) {
  var longitude = Cesium.Math.toDegrees(wgsPosition.longitude);
  var latitude = Cesium.Math.toDegrees(wgsPosition.latitude);
  var height = wgsPosition.height;
  return [longitude, latitude, height];
}; //去重函数  数组


var unique = function unique(arr) {
  var res = [];
  var json = {};

  for (var i = 0; i < arr.length; i++) {
    if (!json[arr[i]]) {
      res.push(arr[i]);
      json[arr[i]] = 1;
    }
  }

  return res;
}; // 获取渐变色函数


function gradientColors(start, end, steps, gamma) {
  var i,
      j,
      ms,
      me,
      output = [],
      so = [];
  gamma = gamma || 1;

  var normalize = function normalize(channel) {
    return Math.pow(channel / 255, gamma);
  };

  start = parseColor(start).map(normalize);
  end = parseColor(end).map(normalize);

  for (i = 0; i < steps; i++) {
    ms = i / (steps - 1);
    me = 1 - ms;

    for (j = 0; j < 3; j++) {
      so[j] = pad(Math.round(Math.pow(start[j] * me + end[j] * ms, 1 / gamma) * 255).toString(16));
    }

    output.push('#' + so.join(''));
  }

  return output;

  function parseColor(hexStr) {
    return hexStr.length === 4 ? hexStr.substr(1).split('').map(function (s) {
      return 0x11 * parseInt(s, 16);
    }) : [hexStr.substr(1, 2), hexStr.substr(3, 2), hexStr.substr(5, 2)].map(function (s) {
      return parseInt(s, 16);
    });
  }

  function pad(s) {
    return s.length === 1 ? '0' + s : s;
  }
}

function getAngleAndRadian(pointA, pointB) {
  //建立以点A为原点，X轴为east,Y轴为north,Z轴朝上的坐标系
  var transform = Cesium.Transforms.eastNorthUpToFixedFrame(pointA); //向量AB

  var positionvector = Cesium.Cartesian3.subtract(pointB, pointA, new Cesium.Cartesian3()); //因transform是将A为原点的eastNorthUp坐标系中的点转换到世界坐标系的矩阵
  //AB为世界坐标中的向量
  //因此将AB向量转换为A原点坐标系中的向量，需乘以transform的逆矩阵。

  var vector = Cesium.Matrix4.multiplyByPointAsVector(Cesium.Matrix4.inverse(transform, new Cesium.Matrix4()), positionvector, new Cesium.Cartesian3()); //归一化

  var direction = Cesium.Cartesian3.normalize(vector, new Cesium.Cartesian3()); //heading

  var heading1 = Math.atan2(direction.y, direction.x) - Cesium.Math.PI_OVER_TWO;
  var radian = Cesium.Math.TWO_PI - Cesium.Math.zeroToTwoPi(heading1);
  var angle = radian * (180 / Math.PI);

  if (angle < 0) {
    angle = angle + 360;
  }

  return {
    angle: angle,
    radian: radian
  };
}

function getPitch(pointA, pointB) {
  var transfrom = Cesium.Transforms.eastNorthUpToFixedFrame(pointA);
  var vector = Cesium.Cartesian3.subtract(pointB, pointA, new Cesium.Cartesian3());
  var direction = Cesium.Matrix4.multiplyByPointAsVector(Cesium.Matrix4.inverse(transfrom, transfrom), vector, vector);
  Cesium.Cartesian3.normalize(direction, direction); //因为direction已归一化，斜边长度等于1，所以余弦函数等于direction.z

  var radian = Cesium.Math.PI_OVER_TWO - Cesium.Math.acosClamped(direction.z);
  var angle = radian * (180 / Math.PI);

  if (angle < 0) {
    angle = angle + 360;
  }

  return {
    angle: angle,
    radian: radian
  };
}

var tool = {
  axiosJsonp: axiosJsonp,
  isEqualArr: isEqualArr,
  CartesiantoDegrees: CartesiantoDegrees,
  CartesiantoDegreesObjs: CartesiantoDegreesObjs,
  unique: unique,
  gradientColors: gradientColors,
  getAngleAndRadian: getAngleAndRadian,
  CartographictoDegrees: CartographictoDegrees,
  getPitch: getPitch
};

var ResourceCN = {
  showRenderLoopErrors: '渲染时发生错误，已停止渲染。',
  AttributeError: '该组件props没有这个属性：',
  NoPickPositionSupported: "不支持深度纹理,无法绘制多边形，地形操作功能无法使用！",
  NoTerrain: "请在地形里使用地形组件！",
  initViewerWarn: '请先初始化viewer!',
  MoveMouseHeightBox: '点击鼠标左键结束矩形绘制，移动鼠标绘制box高度',
  RightClickEndDrawing: '右键单击结束绘制',
  LeftClickBottomBox: '点击鼠标左键，开始绘制矩形作为box底面',
  ClickModelAddBox: '点击模型，添加裁剪盒子',
  SkyLineWarn: "获取天际线体前，请先绘制天际线！",
  SkyLineBody: '天际线体',
  ShadowqueryWarn: "此操作需要先开启阴影！",
  VeiwshedBody: '可视体',
  VeiwshedBodyHidden: '不可视体',
  EchartsErr: "二维显示需要echarts支持，未找到相关依赖！",
  BaseMapImg: '底图',
  tip1: '<p>点击左键确定操作区域中间点</p><p>右键单击结束绘制</p>'
};

// 组件内部的语言资源：主要包括提示信息
var currentLanguage, Resource;
var cookieLanguage = getLang().toLowerCase();

function getLang() {
  //浏览器语言  IE用browserLanguage，非IE使用language进行判断
  var lang = (navigator.language || navigator.browserLanguage).toLowerCase();
  window.lang = lang; //判断portal设置语言 通过cookie获取
  //   const cookies = document.cookie.split(';');
  //   if (cookies.length > 0) {
  //     cookies.forEach(function (cookie) {
  //       const arr = cookie.split('=');
  //       if (arr[0].toLowerCase().trim() === 'language') {
  //         lang = arr[1];
  //         return;
  //       }
  //     });
  //   }

  return lang;
}

if (cookieLanguage !== undefined) {
  currentLanguage = cookieLanguage;
} else {
  currentLanguage = (navigator.language || navigator.browserLanguage).toLowerCase(); // 获取当前浏览器的语言
}

if (currentLanguage.startsWith('zh')) {
  Resource = ResourceCN;
} else if (currentLanguage.startsWith('ja')) {
  Resource = ResourceCN;
} else {
  Resource = ResourceCN;
}

var resource = Resource;

//随鼠标移动消息提示工具
function createTooltip(frameDiv) {
  var tooltip = function tooltip(frameDiv) {
    var div = document.createElement("DIV");
    div.className = "twipsy right";
    var arrow = document.createElement("DIV");
    arrow.className = "twipsy-arrow";
    div.appendChild(arrow);
    var title = document.createElement("DIV");
    title.className = "twipsy-inner";
    div.appendChild(title);
    this._div = div;
    this._title = title;
    this.message = "";
    frameDiv.appendChild(div);
    var that = this;

    div.onmousemove = function (evt) {
      that.showAt({
        x: evt.clientX,
        y: evt.clientY
      }, that.message);
    };
  };

  tooltip.prototype.setVisible = function (visible) {
    this._div.style.display = visible ? "block" : "none";
  };

  tooltip.prototype.showAt = function (position, message) {
    if (position && message) {
      this.setVisible(true);
      this._title.innerHTML = message;
      this._div.style.left = position.x + 10 + "px";
      this._div.style.top = position.y - this._div.clientHeight / 2 + "px";
      this.message = message;
    }
  };

  return new tooltip(frameDiv);
}

/**
 * 初始化
 * DrawMode：类型
 * clampMode：模式
 */

var initHandler = function initHandler(DrawMode, clampMode) {
  var clampmode = 0;

  if (clampMode) {
    clampmode = clampMode;
  }

  switch (DrawMode) {
    case "Point":
      window.handlerPoint = new Cesium.DrawHandler(viewer, Cesium.DrawMode.Point);
      break;

    case "Polyline":
      window.handlerPolyline = new Cesium.DrawHandler(viewer, Cesium.DrawMode.Line, clampmode);
      break;

    case "Polygon":
      window.handlerPolygon = new Cesium.DrawHandler(viewer, Cesium.DrawMode.Polygon, clampmode);
      break;

    case "Marker":
      window.handlerMarker = new Cesium.DrawHandler(viewer, Cesium.DrawMode.Marker, clampmode);
      break;

    case "Box":
      window.handlerBox = new Cesium.DrawHandler(viewer, Cesium.DrawMode.Box, clampmode);
      break;
  }

  if (!window.tooltip) {
    window.tooltip = createTooltip(viewer._element);
  } // 半透线创建


  if (!window.polylineCollection) {
    window.polylineCollection = new Cesium.PolylineCollection({
      translucentRS: Cesium.RenderState.fromCache({
        depthMask: false,
        depthTest: {
          enabled: false
        }
      })
    });
    window.polylineTransparent = window.polylineCollection.add({
      width: 2,
      material: Cesium.Material.fromType(Cesium.Material.ColorType, {
        color: Cesium.Color.fromCssColorString("#51ff00").withAlpha(0.3)
      })
    });
    viewer.scene.primitives.add(window.polylineCollection);
  }
};
/**
 * 绘制
 * PolyType：类型 
 * lineVisib：绘制时是否显示绘制线（boolean）
 * toolTipObj：绘制时提示内容{beforeDrawing：绘制开始前提示(string)，isDrawing：正在绘制时提示,即绘制过程中（string）}
 */


var handlerDrawing = function handlerDrawing(PolyType, lineVisib, toolTipObj) {
  var lineVisible = true;

  if (lineVisib === false) {
    lineVisible = lineVisib;
  }

  var DrawHandler = judgeDrawHandlerType(PolyType); //获取操作对象

  return new Promise(function (resolve, reject) {
    //做一些异步操作
    var tooltip = window.tooltip;
    var clearActFn = DrawHandler.activeEvt.addEventListener(function (isActive) {
      if (isActive == true) {
        viewer.enableCursorStyle = false;
        viewer._element.style.cursor = '';

        if (PolyType == "Point" || PolyType == "Marker") {
          document.body.classList.add("measureCur");
        } else {
          document.body.classList.add("drawCur");
        }
      } else {
        viewer.enableCursorStyle = true;
        tooltip.setVisible(false);

        if (PolyType == "Point" || PolyType == "Marker") {
          document.body.classList.remove('measureCur');
        } else {
          document.body.classList.remove('drawCur');
        }
      }
    });
    var clearMovFn = DrawHandler.movingEvt.addEventListener(function (windowPosition) {
      if (windowPosition.x < 200 && windowPosition.y < 150) {
        tooltip.setVisible(false);
        return;
      }
      //     tooltip.showAt(windowPosition, tiptext);
      // } else if (toolTipObj && toolTipObj.beforeDrawing) {
      //     tooltip.showAt(windowPosition, toolTipObj.beforeDrawing);
      // }else if (DrawHandler.isDrawing && toolTipObj.isDrawing) {
      //     tooltip.showAt(windowPosition, toolTipObj.isDrawing);
      // }

      if (DrawHandler.polyline && DrawHandler.isDrawing) {
        var p = _toConsumableArray(DrawHandler.polyline.positions);

        if (PolyType == "Polygon") {
          //画面时，需要首尾相连
          p.push(p[0]);
        }
        window.polylineTransparent.show = true;
        window.polylineTransparent.positions = p;
      }
    });
    var clearDrawFn = DrawHandler.drawEvt.addEventListener(function (result) {
      if (!result.object.positions && PolyType != "Point" && PolyType != "Box") {
        tooltip.showAt(result, '<p>请绘制正确的多边形</p>');
        DrawHandler.polygon.show = false;
        DrawHandler.polyline.show = false;
        DrawHandler.deactivate();
        DrawHandler.activate();
        return;
      }

      if (PolyType == "Box") {
        resolve({
          result: result
        });
        return;
      }

      if (PolyType == "Point" || PolyType == "Marker") {
        DrawHandler.clear(); // 不显示绘制的点

        resolve({
          result: result
        });
      } else {
        //半透线
        window.polylineTransparent.show = lineVisible;

        if (lineVisible) {
          if (PolyType == "Polygon" && lineVisible) {
            DrawHandler.polygon._polygon._material._color._value.alpha = 0.1; //绘制面透明度

            var p2 = _toConsumableArray(result.object.positions); //画面时，需要首尾相连


            p2.push(p2[0]);
            window.polylineTransparent.positions = p2;
          }
        }

        var positions = CartesiantoDegrees(result.object.positions);
        resolve({
          result: result,
          positions: positions
        });
      }

      clearActFn();
      clearMovFn();
      clearDrawFn();
    });
  });
}; //清除


var clearHandlerDrawing = function clearHandlerDrawing(PolyType) {
  var DrawHandler;

  if (!PolyType) {
    DrawHandler = window.handlerPolygon;
  } else {
    DrawHandler = judgeDrawHandlerType(PolyType);
  }
  if (!DrawHandler) return;
  DrawHandler.deactivate();
  DrawHandler.clear();
  viewer.enableCursorStyle = true; // document.body.classList.remove("drawCur");
  // document.body.classList.remove("measureCur");

  window.tooltip.setVisible(false);

  if (window.polylineTransparent) {
    window.polylineTransparent.show = false;
  }
}; // 类型判断


var judgeDrawHandlerType = function judgeDrawHandlerType(PolyType) {
  var DrawHandler;

  switch (PolyType) {
    case "Point":
      DrawHandler = window.handlerPoint;
      break;

    case "Polyline":
      DrawHandler = window.handlerPolyline;
      break;

    case "Polygon":
      DrawHandler = window.handlerPolygon;
      break;

    case "Marker":
      DrawHandler = window.handlerMarker;
      break;

    case "Box":
      DrawHandler = window.handlerBox;
      break;
  }

  return DrawHandler;
};

function createTooltip$1(frameDiv) {
  var tooltip = function tooltip(frameDiv) {
    var div = document.createElement('DIV');
    div.className = "tooltip";
    this._div = div;
    this.message = '';
    frameDiv.appendChild(div);
  };

  tooltip.prototype.setVisible = function (visible) {
    if (visible) {
      this._div.style.right = '10px';
    } else {
      this._div.style.right = '-300px';
    }
  };

  tooltip.prototype.showAt = function (message, top) {
    //top:200px => string
    if (top) {
      this._div.style.top = top;
    }

    if (message) {
      this.setVisible(true);
      this._div.innerHTML = message;
    }
  };

  return new tooltip(frameDiv);
}

var textures = [{
  name: '线状纹理1',
  type: 'line',
  url: 'public/img/particleSystem/line-1.jpg'
}, {
  name: '线状纹理2',
  type: 'line',
  url: 'public/img/particleSystem/line-2.jpg'
}, {
  name: '环状纹理1',
  type: 'ring',
  url: 'public/img/particleSystem/ring-1.jpg'
}, {
  name: '环状纹理2',
  type: 'ring',
  url: 'public/img/particleSystem/ring-2.jpg'
}, {
  name: '环状六边形纹理',
  type: 'ring',
  url: 'public/img/particleSystem/ring-3.jpg'
}];

function scanEffect(props) {
  var state = reactive({
    scanMode: "lineMode",
    scanColor: "#0F7AF4",
    scanTextures: [],
    selectedTextureIndex: 0,
    bloomShow: false,
    //开启反光
    openHDR: false,
    //开启HDR
    threshold: 0.01,
    //亮度阈值
    intensity: 0.5,
    //泛光强度
    lineWidth: 100,
    //获取或设置线状扫描线的宽度，单位：米。
    period: 3.0,
    //获取或设置扫描线的运行周期，单位：秒。
    speed: 100,
    //获取或设置扫描线的运行速度，单位：米/秒。
    addTextures: null,
    //[{name:纹理1,type:'line / ring',url:xxx}]
    scanShow: false
  }); // 传入props改变默认值

  if (props) {
    for (var key in props) {
      if (state.hasOwnProperty(key)) {
        if (props[key] != undefined) state[key] = props[key];
      } else {
        tool.Message.errorMsg(resource.AttributeError + key);
      }
    }
  } // 初始化数据


  var lineScanTextures = [{
    name: '无纹理',
    type: 'line',
    url: ''
  }];
  var circleScanTextures = [{
    name: '无纹理',
    type: 'ring',
    url: ''
  }];
  getTextures(textures);

  function getTextures(arr) {
    for (var i = 0; i < arr.length; i++) {
      if (arr[i].type === 'line') {
        lineScanTextures.push(arr[i]);
      } else {
        circleScanTextures.push(arr[i]);
      }
    }

    state.scanTextures = state.scanMode === 'lineMode' ? lineScanTextures : circleScanTextures;
  }

  if (storeState.isViewer) {
    if (!window.tooltip) {
      window.tooltip = createTooltip$1(viewer._element);
    }

    init();
  } //viewer 初始化完成的监听


  watch(function () {
    return storeState.isViewer;
  }, function (val) {
    if (val) {
      if (!window.tooltip) {
        window.tooltip = createTooltip$1(viewer._element);
      }

      init();
    }
  });

  function init() {
    viewer.scene.scanEffect.color = Cesium.Color.fromCssColorString(state.scanColor);
    viewer.scene.scanEffect.textureUrl = '';
    viewer.scene.scanEffect.lineWidth = Number(state.lineWidth);
    viewer.scene.scanEffect.period = Number(state.period);
    viewer.scene.scanEffect.speed = Number(state.speed);
    viewer.scene.scanEffect.centerPostion = new Cesium.Cartesian3.fromDegrees(0, 0, 0);
  }

  function drawPolyline() {
    if (!window.handlerPolyline) {
      initHandler("Polyline");
    }

    window.tooltip.showAt(' <p>点击鼠标左键开始绘制</p><p>绘制两点确定扫描线方向</p><p>鼠标右键结束绘制</p>', '350px');
    handlerDrawing("Polyline").then(function (res) {
      addLineScans(res.result.object.positions);
      var handlerPolyline = window.handlerPolyline;
      handlerPolyline.polyline.show = false;
      window.polylineTransparent.show = false; //半透线隐藏

      handlerPolyline.deactivate();
      tooltip.setVisible(false);
    }, function (err) {
      console.log(err);
    });
    window.handlerPolyline.activate();
  }

  function addLineScans(positions) {
    var dir = new Cesium.Cartesian3();
    Cesium.Cartesian3.subtract(positions[1], positions[0], dir); // 获取扫描方向向量

    if (state.scanShow) {
      viewer.scene.scanEffect.add(positions[0]);
      viewer.scene.scanEffect.lineMoveDirection = dir;
      return;
    }

    viewer.scene.scanEffect.centerPostion = positions[0];
    viewer.scene.scanEffect.lineMoveDirection = dir;
    state.scanShow = true;
  }

  function addCircleScans(e) {
    viewer.eventManager.removeEventListener("CLICK", addCircleScans);
    viewer.enableCursorStyle = true;
    document.body.classList.remove("measureCur");
    var centerPosition = viewer.scene.pickPosition(e.message.position);

    if (state.scanShow) {
      viewer.scene.scanEffect.add(centerPosition);
      return;
    }

    viewer.scene.scanEffect.centerPostion = centerPosition;
    state.scanShow = true;
  }

  function addScans() {
    if (state.scanMode === 'lineMode') {
      drawPolyline();
      return;
    }

    viewer.enableCursorStyle = false;
    viewer._element.style.cursor = "";
    document.body.classList.add("measureCur");
    viewer.eventManager.addEventListener("CLICK", addCircleScans, true);
  }

  function clear() {
    state.scanShow = false;
    var index = viewer.scene.scanEffect.count;

    for (var i = 0; i < index; i++) {
      viewer.scene.scanEffect.remove(i);
    }

    viewer.eventManager.removeEventListener("CLICK", addCircleScans);
    clearHandlerDrawing('Polyline');
  } // 监听


  watch(function () {
    return state.scanShow;
  }, function (val) {
    viewer.scene.scanEffect.show = val;
  });
  watch(function () {
    return state.scanMode;
  }, function (val) {
    if (val === "lineMode") {
      viewer.scene.scanEffect.mode = Cesium.ScanEffectMode.LINE;
      state.scanTextures = lineScanTextures;
      return;
    }

    viewer.scene.scanEffect.mode = Cesium.ScanEffectMode.CIRCLE;
    state.scanTextures = circleScanTextures;
  });
  watch(function () {
    return state.scanColor;
  }, function (val) {
    viewer.scene.scanEffect.color = Cesium.Color.fromCssColorString(val);
  });
  watch(function () {
    return state.selectedTextureIndex;
  }, function (val) {
    viewer.scene.scanEffect.textureUrl = state.scanTextures[val].url;
  });
  watch(function () {
    return state.scanTextures;
  }, function (val) {
    state.selectedTextureIndex = 0;
  });
  watch(function () {
    return state.bloomShow;
  }, function (val) {
    viewer.scene.bloomEffect.show = val;
    viewer.scene.bloomEffect.threshold = Number(state.threshold);
    viewer.scene.bloomEffect.bloomIntensity = Number(state.intensity);
  });
  watch(function () {
    return state.openHDR;
  }, function (val) {
    viewer.scene.hdrEnabled = val;
  });
  watch(function () {
    return state.threshold;
  }, function (val) {
    viewer.scene.bloomEffect.threshold = Number(val);
  });
  watch(function () {
    return state.intensity;
  }, function (val) {
    viewer.scene.bloomEffect.bloomIntensity = Number(val);
  });
  watch(function () {
    return state.lineWidth;
  }, function (val) {
    viewer.scene.scanEffect.lineWidth = Number(val);
  });
  watch(function () {
    return state.period;
  }, function (val) {
    viewer.scene.scanEffect.period = Number(val);
  });
  watch(function () {
    return state.speed;
  }, function (val) {
    viewer.scene.scanEffect.speed = Number(val);
  });
  watch(function () {
    return state.scanShow;
  }, function (val) {
    viewer.scene.scanEffect.scanShow = val;
  });
  watch(function () {
    return state.addTextures;
  }, function (val) {
    if (_typeof(val) === 'object') {
      getTextures(val);
    } else {
      console.log('addTextures类型不是数组！');
    }
  }); // 销毁

  onBeforeUnmount(function () {});
  return _objectSpread2(_objectSpread2({}, toRefs(state)), {}, {
    addScans: addScans,
    clear: clear
  });
}

var script = {
  name: "Sm3dScanEffect",
  props: {
    //扫描线模式lineMode/ringMode
    scanMode: {
      type: String
    },
    scanColor: {
      type: String
    },
    selectedTextureIndex: {
      type: Number
    },
    //开启反光
    bloomShow: {
      type: Boolean
    },
    //开启HDR
    openHDR: {
      type: Boolean
    },
    //亮度阈值
    threshold: {
      type: Number
    },
    //泛光强度
    intensity: {
      type: Number
    },
    //获取或设置线状扫描线的宽度，单位：米。
    lineWidth: {
      type: Number
    },
    //获取或设置扫描线的运行周期，单位：秒。
    period: {
      type: Number
    },
    //获取或设置扫描线的运行速度，单位：米/秒。
    speed: {
      type: Number
    },
    //添加纹理[{name:纹理1,type:'line / ring',url:xxx}]
    addTextures: {
      type: Object
    },
    scanShow: {
      type: Boolean
    }
  },
  setup: function setup(props) {
    var _scanEffect = scanEffect(props),
        scanMode = _scanEffect.scanMode,
        scanTextures = _scanEffect.scanTextures,
        selectedTextureIndex = _scanEffect.selectedTextureIndex,
        addScans = _scanEffect.addScans,
        clear = _scanEffect.clear;

    return {
      scanMode: scanMode,
      scanTextures: scanTextures,
      selectedTextureIndex: selectedTextureIndex,
      addScans: addScans,
      clear: clear
    };
  }
};

var _hoisted_1 = {
  id: "scan-effect-panel",
  "class": "sm-panel"
};
var _hoisted_2 = {
  "class": "sm-function-module-sub-section",
  style: {
    "margin": "0"
  }
};
var _hoisted_3 = {
  "class": "sm-half-L"
};
var _hoisted_4 = {
  style: {
    "width": "30%"
  }
};
var _hoisted_5 = {
  "class": "sm-half",
  style: {
    "width": "68%"
  }
};
var _hoisted_6 = {
  style: {
    "width": "auto"
  }
};
var _hoisted_7 = {
  style: {
    "width": "auto"
  }
};
var _hoisted_8 = {
  "class": "sm-half-L"
};
var _hoisted_9 = {
  style: {
    "width": "30%"
  }
};
var _hoisted_10 = ["value"];
var _hoisted_11 = {
  "class": "boxchild",
  style: {
    "padding-bottom": "0"
  }
};
function render(_ctx, _cache, $props, $setup, $data, $options) {
  var _directive_stopdrag = resolveDirective("stopdrag");

  var _directive_drag = resolveDirective("drag");

  return withDirectives((openBlock(), createElementBlock("div", _hoisted_1, [withDirectives((openBlock(), createElementBlock("div", _hoisted_2, [createElementVNode("div", _hoisted_3, [createElementVNode("label", _hoisted_4, toDisplayString(_ctx.Resource.scanMode), 1
  /* TEXT */
  ), createElementVNode("div", _hoisted_5, [createElementVNode("label", _hoisted_6, [withDirectives(createElementVNode("input", {
    type: "radio",
    value: "lineMode",
    "onUpdate:modelValue": _cache[0] || (_cache[0] = function ($event) {
      return $setup.scanMode = $event;
    }),
    style: {
      "margin-right": "0"
    }
  }, null, 512
  /* NEED_PATCH */
  ), [[vModelRadio, $setup.scanMode]]), createTextVNode(" " + toDisplayString(_ctx.Resource.lineScan), 1
  /* TEXT */
  )]), createElementVNode("label", _hoisted_7, [withDirectives(createElementVNode("input", {
    type: "radio",
    value: "ringMode",
    "onUpdate:modelValue": _cache[1] || (_cache[1] = function ($event) {
      return $setup.scanMode = $event;
    }),
    style: {
      "margin-right": "0"
    }
  }, null, 512
  /* NEED_PATCH */
  ), [[vModelRadio, $setup.scanMode]]), createTextVNode(" " + toDisplayString(_ctx.Resource.circularScan), 1
  /* TEXT */
  )])])]), withDirectives(createElementVNode("div", _hoisted_8, [createElementVNode("label", _hoisted_9, toDisplayString(_ctx.Resource.scanTexture), 1
  /* TEXT */
  ), withDirectives(createElementVNode("select", {
    "class": "sm-select-m",
    style: {
      "width": "68%"
    },
    "onUpdate:modelValue": _cache[2] || (_cache[2] = function ($event) {
      return $setup.selectedTextureIndex = $event;
    })
  }, [(openBlock(true), createElementBlock(Fragment, null, renderList($setup.scanTextures, function (texture, index) {
    return openBlock(), createElementBlock("option", {
      value: index,
      key: index
    }, toDisplayString(texture.name), 9
    /* TEXT, PROPS */
    , _hoisted_10);
  }), 128
  /* KEYED_FRAGMENT */
  ))], 512
  /* NEED_PATCH */
  ), [[vModelSelect, $setup.selectedTextureIndex]])], 512
  /* NEED_PATCH */
  ), [[vShow, $setup.scanTextures.length > 0]]), createElementVNode("div", _hoisted_11, [createElementVNode("button", {
    "class": "tbtn",
    type: "button",
    onClick: _cache[3] || (_cache[3] = function () {
      return $setup.addScans && $setup.addScans.apply($setup, arguments);
    })
  }, toDisplayString(_ctx.Resource.add), 1
  /* TEXT */
  ), createElementVNode("button", {
    "class": "tbtn tbtn-margin-left",
    type: "button ",
    onClick: _cache[4] || (_cache[4] = function () {
      return $setup.clear && $setup.clear.apply($setup, arguments);
    })
  }, toDisplayString(_ctx.Resource.clear), 1
  /* TEXT */
  )])])), [[_directive_stopdrag]])])), [[_directive_drag]]);
}

script.render = render;
script.__file = "src/components/special-effects/scan-effect/scan-effect.vue";

script.install = function (app) {
  app.component(script.name, script);
};

export default script;
