import { reactive, toRefs, watch, onBeforeUnmount, resolveComponent, resolveDirective, openBlock, createElementBlock, Fragment, withDirectives, createElementVNode, vModelCheckbox, createTextVNode, toDisplayString, vModelSelect, createVNode, vShow, createBlock, resolveDynamicComponent } from 'vue';

function _typeof(obj) {
  "@babel/helpers - typeof";

  if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
    _typeof = function (obj) {
      return typeof obj;
    };
  } else {
    _typeof = function (obj) {
      return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
    };
  }

  return _typeof(obj);
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);

  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    if (enumerableOnly) symbols = symbols.filter(function (sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    });
    keys.push.apply(keys, symbols);
  }

  return keys;
}

function _objectSpread2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};

    if (i % 2) {
      ownKeys(Object(source), true).forEach(function (key) {
        _defineProperty(target, key, source[key]);
      });
    } else if (Object.getOwnPropertyDescriptors) {
      Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
      ownKeys(Object(source)).forEach(function (key) {
        Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
      });
    }
  }

  return target;
}

// 创建一个简单的store状态管理

var storeState = reactive({
  isViewer: false,
  //viewer初始化标志
  changeLayers: 0,
  //图层改变加载完毕监听
  changeGeometrys: 0 //三维分析体改变标志

});

/*
* 常用工具类
*/
//axios本版本不支持jsonp
var axiosJsonp = function axiosJsonp(url) {
  if (!url) {
    console.error('Axios.JSONP 至少需要一个url参数!');
    return;
  }

  return new Promise(function (resolve, reject) {
    window.jsonCallBack = function (result) {
      resolve(result);
    };

    var JSONP = document.createElement("script");
    JSONP.type = "text/javascript";
    JSONP.src = "".concat(url, "&callback=jsonCallBack");
    document.getElementsByTagName("head")[0].appendChild(JSONP);
    setTimeout(function () {
      document.getElementsByTagName("head")[0].removeChild(JSONP);
    }, 500);
  });
}; //判断两数组或对象相等


var isEqualArr = function isEqualArr(arg1, arg2) {
  if (!arg1 || !arg2) return true;
  var bol = true;

  if (Object.keys(arg1).length != Object.keys(arg2).length) {
    return false;
  }

  for (var key in arg1) {
    if (_typeof(arg1[key]) == 'object') {
      bol = isSame(arg1[key], arg2[key]);

      if (!bol) {
        break;
      }
    } else if (arg1[key] != arg2[key]) {
      bol = false;
      break;
    }
  }

  return bol;
}; //坐标转化
//笛卡尔转经纬度


var CartesiantoDegrees = function CartesiantoDegrees(Cartesians) {
  var array = [].concat(Cartesians);
  var positions = [];

  for (var i = 0, len = array.length; i < len; i++) {
    var cartographic = Cesium.Cartographic.fromCartesian(array[i]);
    var longitude = Cesium.Math.toDegrees(cartographic.longitude);
    var latitude = Cesium.Math.toDegrees(cartographic.latitude);
    var h = cartographic.height;

    if (positions.indexOf(longitude) == -1 && positions.indexOf(latitude) == -1) {
      positions.push(longitude);
      positions.push(latitude);
      positions.push(h);
    }
  }

  return positions;
}; //笛卡尔转经纬度(每个点是独立的对象)


var CartesiantoDegreesObjs = function CartesiantoDegreesObjs(Cartesians) {
  var array = [].concat(Cartesians);
  var positions = [];

  for (var i = 0, len = array.length; i < len; i++) {
    var cartographic = Cesium.Cartographic.fromCartesian(array[i]);
    var obj = {
      longitude: Cesium.Math.toDegrees(cartographic.longitude),
      latitude: Cesium.Math.toDegrees(cartographic.latitude),
      height: cartographic.height
    };
    positions.push(obj);
  }

  return positions;
}; // 弧度转经纬度


var CartographictoDegrees = function CartographictoDegrees(wgsPosition) {
  var longitude = Cesium.Math.toDegrees(wgsPosition.longitude);
  var latitude = Cesium.Math.toDegrees(wgsPosition.latitude);
  var height = wgsPosition.height;
  return [longitude, latitude, height];
}; //去重函数  数组


var unique = function unique(arr) {
  var res = [];
  var json = {};

  for (var i = 0; i < arr.length; i++) {
    if (!json[arr[i]]) {
      res.push(arr[i]);
      json[arr[i]] = 1;
    }
  }

  return res;
}; // 获取渐变色函数


function gradientColors(start, end, steps, gamma) {
  var i,
      j,
      ms,
      me,
      output = [],
      so = [];
  gamma = gamma || 1;

  var normalize = function normalize(channel) {
    return Math.pow(channel / 255, gamma);
  };

  start = parseColor(start).map(normalize);
  end = parseColor(end).map(normalize);

  for (i = 0; i < steps; i++) {
    ms = i / (steps - 1);
    me = 1 - ms;

    for (j = 0; j < 3; j++) {
      so[j] = pad(Math.round(Math.pow(start[j] * me + end[j] * ms, 1 / gamma) * 255).toString(16));
    }

    output.push('#' + so.join(''));
  }

  return output;

  function parseColor(hexStr) {
    return hexStr.length === 4 ? hexStr.substr(1).split('').map(function (s) {
      return 0x11 * parseInt(s, 16);
    }) : [hexStr.substr(1, 2), hexStr.substr(3, 2), hexStr.substr(5, 2)].map(function (s) {
      return parseInt(s, 16);
    });
  }

  function pad(s) {
    return s.length === 1 ? '0' + s : s;
  }
}

function getAngleAndRadian(pointA, pointB) {
  //建立以点A为原点，X轴为east,Y轴为north,Z轴朝上的坐标系
  var transform = Cesium.Transforms.eastNorthUpToFixedFrame(pointA); //向量AB

  var positionvector = Cesium.Cartesian3.subtract(pointB, pointA, new Cesium.Cartesian3()); //因transform是将A为原点的eastNorthUp坐标系中的点转换到世界坐标系的矩阵
  //AB为世界坐标中的向量
  //因此将AB向量转换为A原点坐标系中的向量，需乘以transform的逆矩阵。

  var vector = Cesium.Matrix4.multiplyByPointAsVector(Cesium.Matrix4.inverse(transform, new Cesium.Matrix4()), positionvector, new Cesium.Cartesian3()); //归一化

  var direction = Cesium.Cartesian3.normalize(vector, new Cesium.Cartesian3()); //heading

  var heading1 = Math.atan2(direction.y, direction.x) - Cesium.Math.PI_OVER_TWO;
  var radian = Cesium.Math.TWO_PI - Cesium.Math.zeroToTwoPi(heading1);
  var angle = radian * (180 / Math.PI);

  if (angle < 0) {
    angle = angle + 360;
  }

  return {
    angle: angle,
    radian: radian
  };
}

function getPitch(pointA, pointB) {
  var transfrom = Cesium.Transforms.eastNorthUpToFixedFrame(pointA);
  var vector = Cesium.Cartesian3.subtract(pointB, pointA, new Cesium.Cartesian3());
  var direction = Cesium.Matrix4.multiplyByPointAsVector(Cesium.Matrix4.inverse(transfrom, transfrom), vector, vector);
  Cesium.Cartesian3.normalize(direction, direction); //因为direction已归一化，斜边长度等于1，所以余弦函数等于direction.z

  var radian = Cesium.Math.PI_OVER_TWO - Cesium.Math.acosClamped(direction.z);
  var angle = radian * (180 / Math.PI);

  if (angle < 0) {
    angle = angle + 360;
  }

  return {
    angle: angle,
    radian: radian
  };
}

var tool = {
  axiosJsonp: axiosJsonp,
  isEqualArr: isEqualArr,
  CartesiantoDegrees: CartesiantoDegrees,
  CartesiantoDegreesObjs: CartesiantoDegreesObjs,
  unique: unique,
  gradientColors: gradientColors,
  getAngleAndRadian: getAngleAndRadian,
  CartographictoDegrees: CartographictoDegrees,
  getPitch: getPitch
};

var ResourceCN = {
  showRenderLoopErrors: '渲染时发生错误，已停止渲染。',
  AttributeError: '该组件props没有这个属性：',
  NoPickPositionSupported: "不支持深度纹理,无法绘制多边形，地形操作功能无法使用！",
  NoTerrain: "请在地形里使用地形组件！",
  initViewerWarn: '请先初始化viewer!',
  MoveMouseHeightBox: '点击鼠标左键结束矩形绘制，移动鼠标绘制box高度',
  RightClickEndDrawing: '右键单击结束绘制',
  LeftClickBottomBox: '点击鼠标左键，开始绘制矩形作为box底面',
  ClickModelAddBox: '点击模型，添加裁剪盒子',
  SkyLineWarn: "获取天际线体前，请先绘制天际线！",
  SkyLineBody: '天际线体',
  ShadowqueryWarn: "此操作需要先开启阴影！",
  VeiwshedBody: '可视体',
  VeiwshedBodyHidden: '不可视体',
  EchartsErr: "二维显示需要echarts支持，未找到相关依赖！",
  BaseMapImg: '底图',
  tip1: '<p>点击左键确定操作区域中间点</p><p>右键单击结束绘制</p>'
};

// 组件内部的语言资源：主要包括提示信息
var currentLanguage, Resource;
var cookieLanguage = getLang().toLowerCase();

function getLang() {
  //浏览器语言  IE用browserLanguage，非IE使用language进行判断
  var lang = (navigator.language || navigator.browserLanguage).toLowerCase();
  window.lang = lang; //判断portal设置语言 通过cookie获取
  //   const cookies = document.cookie.split(';');
  //   if (cookies.length > 0) {
  //     cookies.forEach(function (cookie) {
  //       const arr = cookie.split('=');
  //       if (arr[0].toLowerCase().trim() === 'language') {
  //         lang = arr[1];
  //         return;
  //       }
  //     });
  //   }

  return lang;
}

if (cookieLanguage !== undefined) {
  currentLanguage = cookieLanguage;
} else {
  currentLanguage = (navigator.language || navigator.browserLanguage).toLowerCase(); // 获取当前浏览器的语言
}

if (currentLanguage.startsWith('zh')) {
  Resource = ResourceCN;
} else if (currentLanguage.startsWith('ja')) {
  Resource = ResourceCN;
} else {
  Resource = ResourceCN;
}

var resource = Resource;

function s3mlayerAttribute(props) {
  // 设置默认值数据
  var state = reactive({
    earthShow: true,
    //地球显影
    shadows: false,
    //场景阴影
    cloud: false,
    //云层
    skyBox: false,
    //天空盒
    sunShow: false,
    //太阳
    timeline: false,
    //时间轴
    depthAgainst: true,
    //深度检测
    atomsphereRender: true,
    //大气渲染
    fogEffect: true,
    //雾化效果
    underground: true,
    //开启地下
    frameRate: false,
    //帧率
    rain: false,
    snow: false,
    // Facade: false,  //立面图
    surfaceTransparency: 1,
    //地表透明度
    cloudsUrl: 'public/img/skyboxs/clouds/clouds1.png',
    //云层纹理路径
    skyboxSources: null,
    //天空盒资源
    skyboxType: 'bluesky',
    //天空盒类型
    uspeed: 0,
    //获取或者设置天空盒子绕x轴运动的动画速度。设置为1时表示0.01弧度每秒
    vspeed: 0,
    //获取或者设置天空盒子绕y轴运动的动画速度。
    wspeed: 0.5,
    //获取或者设置天空盒子绕z轴运动的动画速度。
    viewMode: '3D',
    //视图模式
    rainAngle: 45,
    rainSpeed: 8,
    snowDesity: 10,
    snowSpeed: 4,
    snowAngle: 10,
    snowType: '0',
    compass: false,
    isCompass: ''
  }); // 设置天空盒默认值

  state.skyboxSources = {
    bluesky: {
      positiveX: 'public/img/skyboxs/bluesky/Right.jpg',
      negativeX: 'public/img/skyboxs/bluesky/Left.jpg',
      positiveY: 'public/img/skyboxs/bluesky/Front.jpg',
      negativeY: 'public/img/skyboxs/bluesky/Back.jpg',
      positiveZ: 'public/img/skyboxs/bluesky/Up.jpg',
      negativeZ: 'public/img/skyboxs/bluesky/Down.jpg'
    },
    sunsetglow: {
      positiveX: 'public/img/skyboxs/sunsetglow/Right.jpg',
      negativeX: 'public/img/skyboxs/sunsetglow/Left.jpg',
      positiveY: 'public/img/skyboxs/sunsetglow/Front.jpg',
      negativeY: 'public/img/skyboxs/sunsetglow/Back.jpg',
      positiveZ: 'public/img/skyboxs/sunsetglow/Up.jpg',
      negativeZ: 'public/img/skyboxs/sunsetglow/Down.jpg'
    }
  }; // 传入props改变默认值

  if (props) {
    for (var key in props) {
      if (state.hasOwnProperty(key)) {
        if (props[key] != undefined) state[key] = props[key];
      } else {
        tool.Message.errorMsg(resource.AttributeError + key);
      }
    }
  } // 初始化数据


  var cloudBox = new Cesium.CloudBox({
    url: state.cloudsUrl
  });
  var skyboxs = {},
      defaultSkybox;

  for (var _key in state.skyboxSources) {
    var skybox = new Cesium.SkyBox({
      sources: state.skyboxSources[_key]
    });
    skybox.USpeed = state.uspeed;
    skybox.VSpeed = state.vspeed;
    skybox.WSpeed = state.wspeed;
    skyboxs[_key] = skybox;
  }

  function initialSkyBox() {
    if (viewer.scene.frameState.passes.render) {
      for (var _key2 in skyboxs) {
        skyboxs[_key2].update(viewer.scene.frameState, true);

        skyboxs[_key2].show = false;
      }

      viewer.scene.postRender.removeEventListener(initialSkyBox);
    }
  }

  function watchCameraHeight() {
    if (state.skyBox) {
      var cameraHeight = viewer.scene.camera.positionCartographic.height;

      if (cameraHeight > 22e4) {
        viewer.scene.skyBox.show = false;
        state.atomsphereRender = true;
      } else {
        viewer.scene.skyBox.show = true;
        state.atomsphereRender = false;
      }
    }
  }

  if (storeState.isViewer) {
    defaultSkybox = viewer.scene.skyBox;
    viewer.scene.postRender.addEventListener(initialSkyBox);
    viewer.scene.postProcessStages.snow.uniforms.density = parseFloat(state.snowDesity);
    viewer.scene.postProcessStages.snow.uniforms.speed = parseFloat(state.snowSpeed);
    viewer.scene.postProcessStages.rain.uniforms.speed = parseFloat(state.rainSpeed);
    watchCameraHeight();
  } //viewer 初始化完成的监听


  watch(function () {
    return storeState.isViewer;
  }, function (val) {
    if (val) {
      defaultSkybox = viewer.scene.skyBox;
      viewer.scene.postRender.addEventListener(initialSkyBox);
      viewer.scene.postProcessStages.snow.uniforms.density = parseFloat(state.snowDesity);
      viewer.scene.postProcessStages.snow.uniforms.speed = parseFloat(state.snowSpeed);
      viewer.scene.postProcessStages.rain.uniforms.speed = parseFloat(state.rainSpeed);
      watchCameraHeight();
    }
  }); // 销毁

  onBeforeUnmount(function () {
    cloudBox.destroy();

    for (var _key3 in skyboxs) {
      skyboxs[_key3].destroy();
    }
    viewer.scene.skyBox = defaultSkybox;
  }); // 监听

  watch(function () {
    return state.earthShow;
  }, function (val) {
    viewer.scene.globe.show = val;
  });
  watch(function () {
    return state.shadows;
  }, function (val) {
    viewer.scene.shadows = val;
  });
  watch(function () {
    return state.sunShow;
  }, function (val) {
    viewer.scene.globe.enableLighting = val;
  });
  watch(function () {
    return state.timeline;
  }, function (val) {
    var timeline = document.getElementsByClassName("cesium-viewer-timelineContainer")[0];

    if (val) {
      timeline.style.visibility = "visible";
    } else {
      timeline.style.visibility = "hidden";
    }
  });
  watch(function () {
    return state.depthAgainst;
  }, function (val) {
    viewer.scene.globe.depthTestAgainstTerrain = val;
  });
  watch(function () {
    return state.atomsphereRender;
  }, function (val) {
    viewer.scene.skyAtmosphere.show = val;
  });
  watch(function () {
    return state.fogEffect;
  }, function (val) {
    viewer.scene.fog.enabled = val;
  });
  watch(function () {
    return state.surfaceTransparency;
  }, function (val) {
    viewer.scene.globe.globeAlpha = parseFloat(val);
  });
  watch(function () {
    return state.underground;
  }, function (val) {
    viewer.scene.undergroundMode = val;
  });
  watch(function () {
    return state.frameRate;
  }, function (val) {
    viewer.scene.debugShowFramesPerSecond = val;
  });
  watch(function () {
    return state.cloud;
  }, function (val) {
    if (val) {
      viewer.scene.cloudBox = cloudBox;
    } else {
      viewer.scene.cloudBox = null;
    }
  });
  watch(function () {
    return state.cloudsUrl;
  }, function (val) {
    viewer.scene.cloudBox.url = val;
  });
  watch(function () {
    return state.skyBox;
  }, function (val) {
    if (val) {
      var cameraHeight = viewer.scene.camera.positionCartographic.height;
      viewer.scene.postRender.addEventListener(watchCameraHeight);
      viewer.scene.skyBox = skyboxs[state.skyboxType];

      if (cameraHeight < 22e4) {
        viewer.scene.skyBox.show = true;
        state.atomsphereRender = false;
      } else {
        state.atomsphereRender = true;
      }
    } else {
      state.atomsphereRender = true;
      viewer.scene.skyBox.show = false;
      viewer.scene.skyBox = defaultSkybox;
      viewer.scene.postRender.removeEventListener(watchCameraHeight);
    }
  });
  watch(function () {
    return state.skyboxType;
  }, function (val) {
    if (state.skyBox) {
      skyboxs[val].show = true;
      viewer.scene.skyBox = skyboxs[val];
    }
  });
  watch(function () {
    return state.uspeed;
  }, function (val) {
    skyboxs[state.skyboxType].USpeed = Number(val);

    if (state.skyBox) {
      viewer.scene.skyBox.USpeed = Number(val);
    }
  });
  watch(function () {
    return state.vspeed;
  }, function (val) {
    skyboxs[state.skyboxType].VSpeed = Number(val);

    if (state.skyBox) {
      viewer.scene.skyBox.VSpeed = Number(val);
    }
  });
  watch(function () {
    return state.wspeed;
  }, function (val) {
    skyboxs[state.skyboxType].WSpeed = Number(val);

    if (state.skyBox) {
      viewer.scene.skyBox.WSpeed = Number(val);
    }
  });
  watch(function () {
    return state.viewMode;
  }, function (val) {
    if (val === "2D") {
      viewer.scene.mode = Cesium.SceneMode.SCENE2D;
    } else if (val === "3D") {
      viewer.scene.mode = Cesium.SceneMode.SCENE3D;
    } else {
      viewer.scene.mode = Cesium.SceneMode.COLUMBUS_VIEW;
    }
  });
  watch(function () {
    return state.rain;
  }, function (val) {
    viewer.scene.postProcessStages.rain.enabled = val;
  });
  watch(function () {
    return state.snow;
  }, function (val) {
    viewer.scene.postProcessStages.snow.enabled = val;
    console.log(viewer.scene.postProcessStages.snow.uniforms);
  });
  watch(function () {
    return state.rainAngle;
  }, function (val) {
    viewer.scene.postProcessStages.rain.uniforms.angle = parseFloat(val);
  });
  watch(function () {
    return state.rainSpeed;
  }, function (val) {
    viewer.scene.postProcessStages.rain.uniforms.speed = parseFloat(val);
  });
  watch(function () {
    return state.snowDesity;
  }, function (val) {
    viewer.scene.postProcessStages.snow.uniforms.density = parseFloat(val);
  });
  watch(function () {
    return state.snowSpeed;
  }, function (val) {
    viewer.scene.postProcessStages.snow.uniforms.speed = parseFloat(val);
  });
  watch(function () {
    return state.snowAngle;
  }, function (val) {
    viewer.scene.postProcessStages.snow.uniforms.angle = parseFloat(val);
  });
  watch(function () {
    return state.snowType;
  }, function (val) {
    switch (val) {
      case '0':
        state.snowDesity = 5;
        state.snowSpeed = 2;
        break;

      case '1':
        state.snowDesity = 10;
        state.snowSpeed = 4;
        break;

      case '2':
        state.snowDesity = 15;
        state.snowSpeed = 6;
        break;

      case '3':
        state.snowDesity = 20;
        state.snowSpeed = 10;
        break;

      default:
        state.snowDesity = 5;
        state.snowSpeed = 2;
        break;
    }
  });
  watch(function () {
    return state.isCompass;
  }, function (val) {
    if (val) {
      state.compass = 'Sm3dCompass';
    } else {
      state.compass = '';
    }
  });
  return _objectSpread2({}, toRefs(state));
}

var script = {
  name: "Sm3dSceneAttribute",
  props: {
    //地球显影
    earthShow: {
      type: Boolean,
      "default": true
    },
    //场景阴影
    shadows: {
      type: Boolean,
      "default": false
    },
    //云层
    cloud: {
      type: Boolean,
      "default": false
    },
    //天空盒
    skyBox: {
      type: Boolean,
      "default": false
    },
    //太阳
    sunShow: {
      type: Boolean,
      "default": false
    },
    //时间轴
    timeline: {
      type: Boolean,
      "default": false
    },
    //深度检测
    depthAgainst: {
      type: Boolean,
      "default": true
    },
    //大气渲染
    atomsphereRender: {
      type: Boolean,
      "default": true
    },
    //雾化效果
    fogEffect: {
      type: Boolean,
      "default": true
    },
    //开启地下
    underground: {
      type: Boolean,
      "default": true
    },
    //帧率
    frameRate: {
      type: Boolean,
      "default": true
    },
    //天空盒自定义对象
    skyboxSources: {
      type: Object
    },
    //地表透明度
    surfaceTransparency: {
      type: Number
    },
    //云层纹理路径
    cloudsUrl: {
      type: String
    },
    //天空盒类型
    skyboxType: {
      type: String
    },
    //天空盒子绕x轴运动的动画速度
    uspeed: {
      type: Number
    },
    //天空盒子绕y轴运动
    vspeed: {
      type: Number
    },
    //天空盒子绕z轴运动
    wspeed: {
      type: Number
    },
    //视图模式
    viewMode: {
      type: String
    },
    //下雨角度
    rainAngle: {
      type: Number
    },
    //下雨速度
    rainSpeed: {
      type: Number
    },
    //下雪密度
    snowDesity: {
      type: Number
    },
    //下雪速度
    snowSpeed: {
      type: Number
    },
    //下雪角度
    snowAngle: {
      type: Number
    },
    //下雪类型
    snowType: {
      type: String
    },
    //罗盘
    isCompass: {
      type: Boolean
    },
    //下雨
    rain: {
      type: Boolean
    },
    //下雪
    snow: {
      type: Boolean
    }
  },
  setup: function setup(props) {
    var _sceneAttribute = s3mlayerAttribute(props),
        earthShow = _sceneAttribute.earthShow,
        shadows = _sceneAttribute.shadows,
        cloud = _sceneAttribute.cloud,
        skyBox = _sceneAttribute.skyBox,
        sunShow = _sceneAttribute.sunShow,
        timeline = _sceneAttribute.timeline,
        depthAgainst = _sceneAttribute.depthAgainst,
        atomsphereRender = _sceneAttribute.atomsphereRender,
        fogEffect = _sceneAttribute.fogEffect,
        underground = _sceneAttribute.underground,
        frameRate = _sceneAttribute.frameRate,
        Facade = _sceneAttribute.Facade,
        surfaceTransparency = _sceneAttribute.surfaceTransparency,
        viewMode = _sceneAttribute.viewMode,
        rain = _sceneAttribute.rain,
        snow = _sceneAttribute.snow,
        snowType = _sceneAttribute.snowType,
        isCompass = _sceneAttribute.isCompass,
        compass = _sceneAttribute.compass;

    return {
      earthShow: earthShow,
      shadows: shadows,
      cloud: cloud,
      skyBox: skyBox,
      sunShow: sunShow,
      timeline: timeline,
      depthAgainst: depthAgainst,
      atomsphereRender: atomsphereRender,
      fogEffect: fogEffect,
      underground: underground,
      frameRate: frameRate,
      Facade: Facade,
      surfaceTransparency: surfaceTransparency,
      viewMode: viewMode,
      rain: rain,
      snow: snow,
      snowType: snowType,
      isCompass: isCompass,
      compass: compass
    };
  }
};

var _hoisted_1 = {
  id: "s3mlayer-attribute-panel",
  "class": "sm-panel"
};
var _hoisted_2 = {
  "class": "sm-function-module-sub-section",
  style: {
    "margin": "0"
  }
};
var _hoisted_3 = {
  "class": "sm-half-L"
};
var _hoisted_4 = {
  style: {
    "width": "28%"
  }
};
var _hoisted_5 = {
  style: {
    "width": "33%"
  }
};
var _hoisted_6 = {
  style: {
    "width": "33%"
  }
};
var _hoisted_7 = {
  style: {
    "width": "28%"
  }
};
var _hoisted_8 = {
  style: {
    "width": "33%"
  }
};
var _hoisted_9 = {
  style: {
    "width": "33%"
  }
};
var _hoisted_10 = {
  style: {
    "width": "28%"
  }
};
var _hoisted_11 = {
  style: {
    "width": "33%"
  }
};
var _hoisted_12 = {
  style: {
    "width": "33%"
  }
};
var _hoisted_13 = {
  style: {
    "width": "28%"
  }
};
var _hoisted_14 = {
  style: {
    "width": "33%"
  }
};
var _hoisted_15 = {
  style: {
    "width": "33%"
  }
};
var _hoisted_16 = {
  style: {
    "width": "28%"
  }
};
var _hoisted_17 = {
  style: {
    "width": "33%"
  }
};

var _hoisted_18 = /*#__PURE__*/createElementVNode("label", {
  style: {
    "width": "33%"
  }
}, null, -1
/* HOISTED */
);

var _hoisted_19 = {
  "class": "sm-half-L"
};
var _hoisted_20 = {
  style: {
    "width": "35%"
  }
};

var _hoisted_21 = /*#__PURE__*/createElementVNode("option", {
  value: "3D"
}, "3D", -1
/* HOISTED */
);

var _hoisted_22 = /*#__PURE__*/createElementVNode("option", {
  value: "2.5D"
}, "2.5D", -1
/* HOISTED */
);

var _hoisted_23 = /*#__PURE__*/createElementVNode("option", {
  value: "2D"
}, "2D", -1
/* HOISTED */
);

var _hoisted_24 = [_hoisted_21, _hoisted_22, _hoisted_23];
var _hoisted_25 = {
  "class": "sm-half-L"
};
var _hoisted_26 = {
  style: {
    "width": "35%"
  }
};
var _hoisted_27 = {
  "class": "sm-half-L"
};

var _hoisted_28 = /*#__PURE__*/createElementVNode("label", {
  style: {
    "width": "35%"
  }
}, "下雪类型", -1
/* HOISTED */
);

var _hoisted_29 = /*#__PURE__*/createElementVNode("option", {
  value: "0"
}, "小雪", -1
/* HOISTED */
);

var _hoisted_30 = /*#__PURE__*/createElementVNode("option", {
  value: "1"
}, "中雪", -1
/* HOISTED */
);

var _hoisted_31 = /*#__PURE__*/createElementVNode("option", {
  value: "2"
}, "大雪", -1
/* HOISTED */
);

var _hoisted_32 = /*#__PURE__*/createElementVNode("option", {
  value: "3"
}, "暴雪", -1
/* HOISTED */
);

var _hoisted_33 = [_hoisted_29, _hoisted_30, _hoisted_31, _hoisted_32];
function render(_ctx, _cache, $props, $setup, $data, $options) {
  var _component_el_slider = resolveComponent("el-slider");

  var _directive_stopdrag = resolveDirective("stopdrag");

  var _directive_drag = resolveDirective("drag");

  return openBlock(), createElementBlock(Fragment, null, [withDirectives((openBlock(), createElementBlock("div", _hoisted_1, [withDirectives((openBlock(), createElementBlock("div", _hoisted_2, [createElementVNode("div", _hoisted_3, [createElementVNode("label", _hoisted_4, [withDirectives(createElementVNode("input", {
    type: "checkbox",
    "onUpdate:modelValue": _cache[0] || (_cache[0] = function ($event) {
      return $setup.earthShow = $event;
    })
  }, null, 512
  /* NEED_PATCH */
  ), [[vModelCheckbox, $setup.earthShow]]), createTextVNode(" " + toDisplayString(_ctx.Resource.earthShow), 1
  /* TEXT */
  )]), createElementVNode("label", _hoisted_5, [withDirectives(createElementVNode("input", {
    type: "checkbox",
    "onUpdate:modelValue": _cache[1] || (_cache[1] = function ($event) {
      return $setup.timeline = $event;
    })
  }, null, 512
  /* NEED_PATCH */
  ), [[vModelCheckbox, $setup.timeline]]), createTextVNode(" " + toDisplayString(_ctx.Resource.timeline), 1
  /* TEXT */
  )]), createElementVNode("label", _hoisted_6, [withDirectives(createElementVNode("input", {
    type: "checkbox",
    "onUpdate:modelValue": _cache[2] || (_cache[2] = function ($event) {
      return $setup.atomsphereRender = $event;
    })
  }, null, 512
  /* NEED_PATCH */
  ), [[vModelCheckbox, $setup.atomsphereRender]]), createTextVNode(" " + toDisplayString(_ctx.Resource.atomsphereRender), 1
  /* TEXT */
  )]), createElementVNode("label", _hoisted_7, [withDirectives(createElementVNode("input", {
    type: "checkbox",
    "onUpdate:modelValue": _cache[3] || (_cache[3] = function ($event) {
      return $setup.sunShow = $event;
    })
  }, null, 512
  /* NEED_PATCH */
  ), [[vModelCheckbox, $setup.sunShow]]), createTextVNode(" " + toDisplayString(_ctx.Resource.sunShow), 1
  /* TEXT */
  )]), createElementVNode("label", _hoisted_8, [withDirectives(createElementVNode("input", {
    type: "checkbox",
    "onUpdate:modelValue": _cache[4] || (_cache[4] = function ($event) {
      return $setup.fogEffect = $event;
    })
  }, null, 512
  /* NEED_PATCH */
  ), [[vModelCheckbox, $setup.fogEffect]]), createTextVNode(" " + toDisplayString(_ctx.Resource.fogEffect), 1
  /* TEXT */
  )]), createElementVNode("label", _hoisted_9, [withDirectives(createElementVNode("input", {
    type: "checkbox",
    "onUpdate:modelValue": _cache[5] || (_cache[5] = function ($event) {
      return $setup.depthAgainst = $event;
    })
  }, null, 512
  /* NEED_PATCH */
  ), [[vModelCheckbox, $setup.depthAgainst]]), createTextVNode(" " + toDisplayString(_ctx.Resource.depthAgainst), 1
  /* TEXT */
  )]), createElementVNode("label", _hoisted_10, [withDirectives(createElementVNode("input", {
    type: "checkbox",
    "onUpdate:modelValue": _cache[6] || (_cache[6] = function ($event) {
      return _ctx.shadowMap = $event;
    })
  }, null, 512
  /* NEED_PATCH */
  ), [[vModelCheckbox, _ctx.shadowMap]]), createTextVNode(" " + toDisplayString(_ctx.Resource.shadowMap), 1
  /* TEXT */
  )]), createElementVNode("label", _hoisted_11, [withDirectives(createElementVNode("input", {
    type: "checkbox",
    "onUpdate:modelValue": _cache[7] || (_cache[7] = function ($event) {
      return $setup.underground = $event;
    })
  }, null, 512
  /* NEED_PATCH */
  ), [[vModelCheckbox, $setup.underground]]), createTextVNode(" " + toDisplayString(_ctx.Resource.underground), 1
  /* TEXT */
  )]), createElementVNode("label", _hoisted_12, [withDirectives(createElementVNode("input", {
    type: "checkbox",
    "onUpdate:modelValue": _cache[8] || (_cache[8] = function ($event) {
      return $setup.frameRate = $event;
    })
  }, null, 512
  /* NEED_PATCH */
  ), [[vModelCheckbox, $setup.frameRate]]), createTextVNode(" " + toDisplayString(_ctx.Resource.frameRate), 1
  /* TEXT */
  )]), createElementVNode("label", _hoisted_13, [withDirectives(createElementVNode("input", {
    type: "checkbox",
    "onUpdate:modelValue": _cache[9] || (_cache[9] = function ($event) {
      return $setup.cloud = $event;
    })
  }, null, 512
  /* NEED_PATCH */
  ), [[vModelCheckbox, $setup.cloud]]), createTextVNode(" " + toDisplayString(_ctx.Resource.cloud), 1
  /* TEXT */
  )]), createElementVNode("label", _hoisted_14, [withDirectives(createElementVNode("input", {
    type: "checkbox",
    "onUpdate:modelValue": _cache[10] || (_cache[10] = function ($event) {
      return $setup.skyBox = $event;
    })
  }, null, 512
  /* NEED_PATCH */
  ), [[vModelCheckbox, $setup.skyBox]]), createTextVNode(" " + toDisplayString(_ctx.Resource.skyBox), 1
  /* TEXT */
  )]), createElementVNode("label", _hoisted_15, [withDirectives(createElementVNode("input", {
    type: "checkbox",
    "onUpdate:modelValue": _cache[11] || (_cache[11] = function ($event) {
      return $setup.rain = $event;
    })
  }, null, 512
  /* NEED_PATCH */
  ), [[vModelCheckbox, $setup.rain]]), createTextVNode(" " + toDisplayString(_ctx.Resource.rain), 1
  /* TEXT */
  )]), createElementVNode("label", _hoisted_16, [withDirectives(createElementVNode("input", {
    type: "checkbox",
    "onUpdate:modelValue": _cache[12] || (_cache[12] = function ($event) {
      return $setup.snow = $event;
    })
  }, null, 512
  /* NEED_PATCH */
  ), [[vModelCheckbox, $setup.snow]]), createTextVNode(" " + toDisplayString(_ctx.Resource.snow), 1
  /* TEXT */
  )]), createElementVNode("label", _hoisted_17, [withDirectives(createElementVNode("input", {
    type: "checkbox",
    "onUpdate:modelValue": _cache[13] || (_cache[13] = function ($event) {
      return $setup.isCompass = $event;
    })
  }, null, 512
  /* NEED_PATCH */
  ), [[vModelCheckbox, $setup.isCompass]]), createTextVNode(" " + toDisplayString(_ctx.Resource.compass), 1
  /* TEXT */
  )]), _hoisted_18]), createElementVNode("div", _hoisted_19, [createElementVNode("label", _hoisted_20, toDisplayString(_ctx.Resource.viewMode), 1
  /* TEXT */
  ), withDirectives(createElementVNode("select", {
    "class": "sm-select",
    style: {
      "width": "63%"
    },
    "onUpdate:modelValue": _cache[14] || (_cache[14] = function ($event) {
      return $setup.viewMode = $event;
    })
  }, _hoisted_24, 512
  /* NEED_PATCH */
  ), [[vModelSelect, $setup.viewMode]])]), createElementVNode("div", _hoisted_25, [createElementVNode("label", _hoisted_26, toDisplayString(_ctx.Resource.surfaceTransparency), 1
  /* TEXT */
  ), createVNode(_component_el_slider, {
    modelValue: $setup.surfaceTransparency,
    "onUpdate:modelValue": _cache[15] || (_cache[15] = function ($event) {
      return $setup.surfaceTransparency = $event;
    }),
    min: 0,
    max: 1,
    step: 0.01,
    "input-size": "mini",
    debounce: 500,
    "tooltip-class": "tooltip-class",
    style: {
      "width": "63%"
    }
  }, null, 8
  /* PROPS */
  , ["modelValue", "step"])]), withDirectives(createElementVNode("div", _hoisted_27, [_hoisted_28, withDirectives(createElementVNode("select", {
    "class": "sm-select",
    style: {
      "width": "63%"
    },
    "onUpdate:modelValue": _cache[16] || (_cache[16] = function ($event) {
      return $setup.snowType = $event;
    })
  }, _hoisted_33, 512
  /* NEED_PATCH */
  ), [[vModelSelect, $setup.snowType]])], 512
  /* NEED_PATCH */
  ), [[vShow, false]])])), [[_directive_stopdrag]])])), [[_directive_drag]]), (openBlock(), createBlock(resolveDynamicComponent($setup.compass)))], 64
  /* STABLE_FRAGMENT */
  );
}

script.render = render;
script.__file = "src/components/scene/scene-attribute/scene-attribute.vue";

script.install = function (app) {
  app.component(script.name, script);
};

export default script;
