import { reactive, toRefs, watch, onBeforeUnmount, resolveComponent, resolveDirective, withDirectives, openBlock, createElementBlock, createElementVNode, toDisplayString, createVNode, vModelCheckbox, createTextVNode } from 'vue';

function _typeof(obj) {
  "@babel/helpers - typeof";

  if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
    _typeof = function (obj) {
      return typeof obj;
    };
  } else {
    _typeof = function (obj) {
      return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
    };
  }

  return _typeof(obj);
}

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);

  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    if (enumerableOnly) symbols = symbols.filter(function (sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    });
    keys.push.apply(keys, symbols);
  }

  return keys;
}

function _objectSpread2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};

    if (i % 2) {
      ownKeys(Object(source), true).forEach(function (key) {
        _defineProperty(target, key, source[key]);
      });
    } else if (Object.getOwnPropertyDescriptors) {
      Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
      ownKeys(Object(source)).forEach(function (key) {
        Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
      });
    }
  }

  return target;
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

  return arr2;
}

function _createForOfIteratorHelper(o, allowArrayLike) {
  var it;

  if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) {
    if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") {
      if (it) o = it;
      var i = 0;

      var F = function () {};

      return {
        s: F,
        n: function () {
          if (i >= o.length) return {
            done: true
          };
          return {
            done: false,
            value: o[i++]
          };
        },
        e: function (e) {
          throw e;
        },
        f: F
      };
    }

    throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
  }

  var normalCompletion = true,
      didErr = false,
      err;
  return {
    s: function () {
      it = o[Symbol.iterator]();
    },
    n: function () {
      var step = it.next();
      normalCompletion = step.done;
      return step;
    },
    e: function (e) {
      didErr = true;
      err = e;
    },
    f: function () {
      try {
        if (!normalCompletion && it.return != null) it.return();
      } finally {
        if (didErr) throw err;
      }
    }
  };
}

/*
* 常用工具类
*/
//axios本版本不支持jsonp
var axiosJsonp = function axiosJsonp(url) {
  if (!url) {
    console.error('Axios.JSONP 至少需要一个url参数!');
    return;
  }

  return new Promise(function (resolve, reject) {
    window.jsonCallBack = function (result) {
      resolve(result);
    };

    var JSONP = document.createElement("script");
    JSONP.type = "text/javascript";
    JSONP.src = "".concat(url, "&callback=jsonCallBack");
    document.getElementsByTagName("head")[0].appendChild(JSONP);
    setTimeout(function () {
      document.getElementsByTagName("head")[0].removeChild(JSONP);
    }, 500);
  });
}; //判断两数组或对象相等


var isEqualArr = function isEqualArr(arg1, arg2) {
  if (!arg1 || !arg2) return true;
  var bol = true;

  if (Object.keys(arg1).length != Object.keys(arg2).length) {
    return false;
  }

  for (var key in arg1) {
    if (_typeof(arg1[key]) == 'object') {
      bol = isSame(arg1[key], arg2[key]);

      if (!bol) {
        break;
      }
    } else if (arg1[key] != arg2[key]) {
      bol = false;
      break;
    }
  }

  return bol;
}; //坐标转化
//笛卡尔转经纬度


var CartesiantoDegrees = function CartesiantoDegrees(Cartesians) {
  var array = [].concat(Cartesians);
  var positions = [];

  for (var i = 0, len = array.length; i < len; i++) {
    var cartographic = Cesium.Cartographic.fromCartesian(array[i]);
    var longitude = Cesium.Math.toDegrees(cartographic.longitude);
    var latitude = Cesium.Math.toDegrees(cartographic.latitude);
    var h = cartographic.height;

    if (positions.indexOf(longitude) == -1 && positions.indexOf(latitude) == -1) {
      positions.push(longitude);
      positions.push(latitude);
      positions.push(h);
    }
  }

  return positions;
}; //笛卡尔转经纬度(每个点是独立的对象)


var CartesiantoDegreesObjs = function CartesiantoDegreesObjs(Cartesians) {
  var array = [].concat(Cartesians);
  var positions = [];

  for (var i = 0, len = array.length; i < len; i++) {
    var cartographic = Cesium.Cartographic.fromCartesian(array[i]);
    var obj = {
      longitude: Cesium.Math.toDegrees(cartographic.longitude),
      latitude: Cesium.Math.toDegrees(cartographic.latitude),
      height: cartographic.height
    };
    positions.push(obj);
  }

  return positions;
}; // 弧度转经纬度


var CartographictoDegrees = function CartographictoDegrees(wgsPosition) {
  var longitude = Cesium.Math.toDegrees(wgsPosition.longitude);
  var latitude = Cesium.Math.toDegrees(wgsPosition.latitude);
  var height = wgsPosition.height;
  return [longitude, latitude, height];
}; //去重函数  数组


var unique = function unique(arr) {
  var res = [];
  var json = {};

  for (var i = 0; i < arr.length; i++) {
    if (!json[arr[i]]) {
      res.push(arr[i]);
      json[arr[i]] = 1;
    }
  }

  return res;
}; // 获取渐变色函数


function gradientColors(start, end, steps, gamma) {
  var i,
      j,
      ms,
      me,
      output = [],
      so = [];
  gamma = gamma || 1;

  var normalize = function normalize(channel) {
    return Math.pow(channel / 255, gamma);
  };

  start = parseColor(start).map(normalize);
  end = parseColor(end).map(normalize);

  for (i = 0; i < steps; i++) {
    ms = i / (steps - 1);
    me = 1 - ms;

    for (j = 0; j < 3; j++) {
      so[j] = pad(Math.round(Math.pow(start[j] * me + end[j] * ms, 1 / gamma) * 255).toString(16));
    }

    output.push('#' + so.join(''));
  }

  return output;

  function parseColor(hexStr) {
    return hexStr.length === 4 ? hexStr.substr(1).split('').map(function (s) {
      return 0x11 * parseInt(s, 16);
    }) : [hexStr.substr(1, 2), hexStr.substr(3, 2), hexStr.substr(5, 2)].map(function (s) {
      return parseInt(s, 16);
    });
  }

  function pad(s) {
    return s.length === 1 ? '0' + s : s;
  }
}

function getAngleAndRadian(pointA, pointB) {
  //建立以点A为原点，X轴为east,Y轴为north,Z轴朝上的坐标系
  var transform = Cesium.Transforms.eastNorthUpToFixedFrame(pointA); //向量AB

  var positionvector = Cesium.Cartesian3.subtract(pointB, pointA, new Cesium.Cartesian3()); //因transform是将A为原点的eastNorthUp坐标系中的点转换到世界坐标系的矩阵
  //AB为世界坐标中的向量
  //因此将AB向量转换为A原点坐标系中的向量，需乘以transform的逆矩阵。

  var vector = Cesium.Matrix4.multiplyByPointAsVector(Cesium.Matrix4.inverse(transform, new Cesium.Matrix4()), positionvector, new Cesium.Cartesian3()); //归一化

  var direction = Cesium.Cartesian3.normalize(vector, new Cesium.Cartesian3()); //heading

  var heading1 = Math.atan2(direction.y, direction.x) - Cesium.Math.PI_OVER_TWO;
  var radian = Cesium.Math.TWO_PI - Cesium.Math.zeroToTwoPi(heading1);
  var angle = radian * (180 / Math.PI);

  if (angle < 0) {
    angle = angle + 360;
  }

  return {
    angle: angle,
    radian: radian
  };
}

function getPitch(pointA, pointB) {
  var transfrom = Cesium.Transforms.eastNorthUpToFixedFrame(pointA);
  var vector = Cesium.Cartesian3.subtract(pointB, pointA, new Cesium.Cartesian3());
  var direction = Cesium.Matrix4.multiplyByPointAsVector(Cesium.Matrix4.inverse(transfrom, transfrom), vector, vector);
  Cesium.Cartesian3.normalize(direction, direction); //因为direction已归一化，斜边长度等于1，所以余弦函数等于direction.z

  var radian = Cesium.Math.PI_OVER_TWO - Cesium.Math.acosClamped(direction.z);
  var angle = radian * (180 / Math.PI);

  if (angle < 0) {
    angle = angle + 360;
  }

  return {
    angle: angle,
    radian: radian
  };
}

var tool = {
  axiosJsonp: axiosJsonp,
  isEqualArr: isEqualArr,
  CartesiantoDegrees: CartesiantoDegrees,
  CartesiantoDegreesObjs: CartesiantoDegreesObjs,
  unique: unique,
  gradientColors: gradientColors,
  getAngleAndRadian: getAngleAndRadian,
  CartographictoDegrees: CartographictoDegrees,
  getPitch: getPitch
};

var ResourceCN = {
  showRenderLoopErrors: '渲染时发生错误，已停止渲染。',
  AttributeError: '该组件props没有这个属性：',
  NoPickPositionSupported: "不支持深度纹理,无法绘制多边形，地形操作功能无法使用！",
  NoTerrain: "请在地形里使用地形组件！",
  initViewerWarn: '请先初始化viewer!',
  MoveMouseHeightBox: '点击鼠标左键结束矩形绘制，移动鼠标绘制box高度',
  RightClickEndDrawing: '右键单击结束绘制',
  LeftClickBottomBox: '点击鼠标左键，开始绘制矩形作为box底面',
  ClickModelAddBox: '点击模型，添加裁剪盒子',
  SkyLineWarn: "获取天际线体前，请先绘制天际线！",
  SkyLineBody: '天际线体',
  ShadowqueryWarn: "此操作需要先开启阴影！",
  VeiwshedBody: '可视体',
  VeiwshedBodyHidden: '不可视体',
  EchartsErr: "二维显示需要echarts支持，未找到相关依赖！",
  BaseMapImg: '底图',
  tip1: '<p>点击左键确定操作区域中间点</p><p>右键单击结束绘制</p>'
};

// 组件内部的语言资源：主要包括提示信息
var currentLanguage, Resource;
var cookieLanguage = getLang().toLowerCase();

function getLang() {
  //浏览器语言  IE用browserLanguage，非IE使用language进行判断
  var lang = (navigator.language || navigator.browserLanguage).toLowerCase();
  window.lang = lang; //判断portal设置语言 通过cookie获取
  //   const cookies = document.cookie.split(';');
  //   if (cookies.length > 0) {
  //     cookies.forEach(function (cookie) {
  //       const arr = cookie.split('=');
  //       if (arr[0].toLowerCase().trim() === 'language') {
  //         lang = arr[1];
  //         return;
  //       }
  //     });
  //   }

  return lang;
}

if (cookieLanguage !== undefined) {
  currentLanguage = cookieLanguage;
} else {
  currentLanguage = (navigator.language || navigator.browserLanguage).toLowerCase(); // 获取当前浏览器的语言
}

if (currentLanguage.startsWith('zh')) {
  Resource = ResourceCN;
} else if (currentLanguage.startsWith('ja')) {
  Resource = ResourceCN;
} else {
  Resource = ResourceCN;
}

var resource = Resource;

// 创建一个简单的store状态管理

var storeState = reactive({
  isViewer: false,
  //viewer初始化标志
  changeLayers: 0,
  //图层改变加载完毕监听
  changeGeometrys: 0 //三维分析体改变标志

});

function createTooltip(frameDiv) {
  var tooltip = function tooltip(frameDiv) {
    var div = document.createElement('DIV');
    div.className = "tooltip";
    this._div = div;
    this.message = '';
    frameDiv.appendChild(div);
  };

  tooltip.prototype.setVisible = function (visible) {
    if (visible) {
      this._div.style.right = '10px';
    } else {
      this._div.style.right = '-300px';
    }
  };

  tooltip.prototype.showAt = function (message, top) {
    //top:200px => string
    if (top) {
      this._div.style.top = top;
    }

    if (message) {
      this.setVisible(true);
      this._div.innerHTML = message;
    }
  };

  return new tooltip(frameDiv);
}

var DragEntity = /*#__PURE__*/function () {
  function DragEntity(_viewer, _id_type, _moveEndCallBack, _leftUpCallBack) {
    _classCallCheck(this, DragEntity);

    this.viewer = _viewer;
    this.id_type = _id_type;
    this.pickedEntity = null;
    this.leftDownFlag = false;
    this.moveEndCallBack = _moveEndCallBack ? _moveEndCallBack : undefined;
    this.leftUpCallBack = _leftUpCallBack ? _leftUpCallBack : undefined;
    this.movePickedEntity = null;
    this.layers = _viewer.scene.layers.layerQueue;
  }

  _createClass(DragEntity, [{
    key: "addEventListener",
    value: function addEventListener() {
      var that = this;

      for (var i = 0; i < that.layers.length; i++) {
        that.layers[i].selectEnabled = false;
      }

      that.viewer.screenSpaceEventHandler.setInputAction(leftDownAction, Cesium.ScreenSpaceEventType.LEFT_DOWN);
      that.viewer.screenSpaceEventHandler.setInputAction(leftUpAction, Cesium.ScreenSpaceEventType.LEFT_UP);
      that.viewer.screenSpaceEventHandler.setInputAction(mouseMoveAction, Cesium.ScreenSpaceEventType.MOUSE_MOVE);

      function leftDownAction(e) {
        var picked = that.viewer.scene.pick(e.position);
        that.leftDownFlag = true;

        if (picked) {
          var Entity = Cesium.defaultValue(picked.id, picked.primitive.id);

          if (Entity.id && Entity.id.includes(that.id_type)) {
            // document.body.style.cursor = 'move';
            that.pickedEntity = Entity; //锁定相机

            that.viewer.scene.screenSpaceCameraController.enableRotate = false;
          }
        }
      }

      function mouseMoveAction(e) {
        if (that.leftDownFlag) {
          if (that.pickedEntity) {
            var cartesian = that.viewer.scene.pickPosition(e.endPosition);
            that.pickedEntity.position = cartesian;

            if (that.moveEndCallBack) {
              that.moveEndCallBack(that.pickedEntity);
            }
          }
        } else {
          var picked = that.viewer.scene.pick(e.endPosition);

          if (picked) {
            var Entity = Cesium.defaultValue(picked.id, picked.primitive.id);

            if (Entity.id && Entity.id.includes(that.id_type)) {
              that.movePickedEntity = Entity;
              Entity.point.pixelSize = 20;
            } else {
              if (that.movePickedEntity) that.movePickedEntity.point.pixelSize = 10;
            }
          } else {
            if (that.movePickedEntity) that.movePickedEntity.point.pixelSize = 10;
          }
        }
      }

      function leftUpAction(e) {
        that.leftDownFlag = false; // document.body.style.cursor = 'default';
        // 解除相机锁定

        that.viewer.scene.screenSpaceCameraController.enableRotate = true;

        if (that.leftUpCallBack && that.pickedEntity) {
          that.leftUpCallBack(that.pickedEntity);
        }

        that.pickedEntity = null;
      }
    }
  }, {
    key: "removeEventListener",
    value: function removeEventListener() {
      this.viewer.screenSpaceEventHandler.removeInputAction(Cesium.ScreenSpaceEventType.LEFT_DOWN);
      this.viewer.screenSpaceEventHandler.removeInputAction(Cesium.ScreenSpaceEventType.MOUSE_MOVE);
      this.viewer.screenSpaceEventHandler.removeInputAction(Cesium.ScreenSpaceEventType.LEFT_UP);
    }
  }]);

  return DragEntity;
}();

function sightLine(props) {
  // 设置默认值数据
  var state = reactive({
    viewPosition: null,
    visibleColor: "rgb(0, 200, 0)",
    hiddenColor: "rgb(200, 0, 0)",
    barrierColor: "rgba(255, 186, 1, 1)",
    highlightBarrier: false,
    lineWidth: 3,
    showBarrierPoints: true
  }); // 传入props改变默认值

  if (props) {
    for (var key in props) {
      if (state.hasOwnProperty(key)) {
        if (props[key] != undefined) state[key] = props[key];
      } else {
        tool.Message.errorMsg(resource.AttributeError + key);
      }
    }
  } // 初始化数据


  var scene, sightline, dragEntity;
  var timer,
      tipFlag = true,
      clickFlag = false,
      ObjectIds = [];
  var point_index = 0,
      sightTargetPoints = [],
      sightBarrierPoints = [],
      sightBarrierPointsColor = [];
  var viewPointPosition;

  if (storeState.isViewer) {
    if (!window.tooltip) {
      window.tooltip = createTooltip(viewer._element);
    }

    init();
  } //viewer 初始化完成的监听


  watch(function () {
    return storeState.isViewer;
  }, function (val) {
    if (val) {
      if (!window.tooltip) {
        window.tooltip = createTooltip(viewer._element);
      }

      init();
    }
  });

  function init() {
    scene = viewer.scene;
    sightline = new Cesium.Sightline(scene);
    sightline.visibleColor = Cesium.Color.fromCssColorString(state.visibleColor);
    sightline.hiddenColor = Cesium.Color.fromCssColorString(state.hiddenColor);
    sightline.lineWidth = Number(state.lineWidth);
    dragEntity = new DragEntity(viewer, 'sightPoint_', _moveEndCallBack, _leftUpCallBack);
  }
  /*
   ***分析模块***
  */
  //分析

  function analysis() {
    viewer.enableCursorStyle = false;
    viewer._element.style.cursor = "";
    document.body.classList.add("measureCur");

    if (tipFlag) {
      //只提示一次
      window.tooltip.showAt(' <p>点击鼠标左键确认观察者位置</p><p>再点击左键确认目标位置</p> <p>右键单击结束分析</p>', '400px');
      tipFlag = false;
    }

    dragEntity.removeEventListener(); //清除编辑交互事件
    //鼠标左键事件监听

    viewer.eventManager.addEventListener("CLICK", LEFT_CLICK, true);
    viewer.eventManager.addEventListener("MOUSE_MOVE", MOUSE_MOVE);
    viewer.eventManager.addEventListener("RIGHT_CLICK", RIGHT_CLICK, true);
  }

  function LEFT_CLICK(e) {
    clickFlag = true;
    clearTimeout(timer);
    timer = setTimeout(function () {
      clickFlag = false;
    }, 20); //添加点时延迟移动添加目标点

    var position = scene.pickPosition(e.message.position);
    var p = tool.CartesiantoDegrees(position); // 将获取的点的位置转化成经纬度

    if (p[2] < 0) {
      p[2] = 0;
      position = Cesium.Cartesian3.fromDegrees(p[0], p[1], p[2]);
    }

    if (state.viewPosition) {
      sightline.addTargetPoint({
        position: p,
        name: "sightPoint_Target" + point_index
      });
      sightTargetPoints.push(position); // 添加障碍点

      requestAnimationFrame(function () {
        requestAnimationFrame(function () {
          sightline.getBarrierPoint('sightPoint_Target' + point_index, function (obj) {
            addSightPoint_Target(point_index); //添加目标点 

            if (obj && obj.position) {
              obj.position.height += 2;

              var _position = Cesium.Cartographic.toCartesian(obj.position);

              sightBarrierPoints.push(_position); //记录障碍点信息
              // 记录障碍物id

              var ObjectId = sightline.getObjectIds();
              ObjectIds.push(ObjectId);
              sightBarrierPointsColor.push(state.hiddenColor);
            } else {
              sightBarrierPoints.push({
                x: 6378137,
                y: 0,
                z: 0
              });
              sightBarrierPointsColor.push(state.visibleColor);
            }

            addBarrierCone(point_index); //添加障碍点

            point_index += 1;
          });
        });
      });
    } else {
      sightline.viewPosition = p; // 观察者信息记录

      state.viewPosition = p;
      sightline.build();
      addSightPoint_view();
      viewPointPosition = position;
    }
  }

  function addSightPoint_view() {
    viewer.entities.add(new Cesium.Entity({
      id: 'sightPoint_view',
      point: new Cesium.PointGraphics({
        color: Cesium.Color.fromCssColorString(state.barrierColor),
        pixelSize: 10
      }),
      position: new Cesium.CallbackProperty(function () {
        return viewPointPosition;
      }, false)
    }));
  }

  function addSightPoint_Target(i) {
    viewer.entities.add(new Cesium.Entity({
      id: 'sightPoint_Target' + i,
      point: new Cesium.PointGraphics({
        // color: Cesium.Color.fromCssColorString(state.barrierColor),
        color: new Cesium.CallbackProperty(function () {
          return Cesium.Color.fromCssColorString(sightBarrierPointsColor[i]);
        }, false),
        pixelSize: 10
      }),
      position: new Cesium.CallbackProperty(function () {
        return sightTargetPoints[i];
      }, false)
    }));
  } // 绘制障碍点圆锥


  var barrierCones = [];

  function addBarrierCone(i) {
    var ab = viewer.entities.add({
      name: 'Point_Barrier' + i,
      position: new Cesium.CallbackProperty(function () {
        return sightBarrierPoints[i];
      }, false),
      // orientation: Cesium.Transforms.headingPitchRollQuaternion(sightBarrierPoints[i], new Cesium.HeadingPitchRoll(0, 0, Math.PI)),
      cylinder: {
        length: 3,
        topRadius: 2,
        bottomRadius: 0,
        material: Cesium.Color.fromCssColorString("#d60000")
      }
    });
    barrierCones.push(ab);
  } // 鼠标移动实时分析


  function MOUSE_MOVE(e) {
    if (!state.viewPosition || clickFlag) return; //获取鼠标屏幕坐标,并将其转化成笛卡尔坐标

    var endPosition = scene.pickPosition(e.message.endPosition);
    var p = tool.CartesiantoDegrees(endPosition); // 将获取的点的位置转化成经纬度

    sightline.addTargetPoint({
      position: p,
      name: "point"
    });
  } // //鼠标右键确认分析距离和方向，不再执行鼠标移动事件中对可视域的操作


  function RIGHT_CLICK() {
    window.tooltip.setVisible(false);
    document.body.classList.remove("measureCur");

    if (state.highlightBarrier) {
      getHighlightBarriers();
    }

    sightline.removeTargetPoint('point');
    sightline.build(); //拖拽编辑点

    dragEntity.addEventListener();
    viewer.eventManager.removeEventListener("CLICK", LEFT_CLICK); //移除鼠标点击事件监听

    viewer.eventManager.removeEventListener("MOUSE_MOVE", MOUSE_MOVE); //移除鼠标点击事件监听

    viewer.eventManager.removeEventListener("RIGHT_CLICK", RIGHT_CLICK); //移除鼠标点击事件监听
  }

  function _moveEndCallBack(Entity) {
    if (!Entity.id) return;

    if (Entity.id.includes('sightPoint_Target')) {
      var p = tool.CartesiantoDegrees(Entity.position._value); // 将获取的点的位置转化成经纬度

      sightline.addTargetPoint({
        position: p,
        name: Entity.id
      });
    } else if (Entity.id.includes('sightPoint_view')) {
      var _p = tool.CartesiantoDegrees(Entity.position._value); // 将获取的点的位置转化成经纬度


      sightline.viewPosition = _p;
    }
  }

  function _leftUpCallBack(Entity) {
    requestAnimationFrame(function () {
      requestAnimationFrame(function () {
        if (!Entity.id) return;

        if (Entity.id.includes('sightPoint_view')) {
          for (var i = 0, j = sightBarrierPoints.length; i < j; i++) {
            setBarrierPoints('sightPoint_Target' + i, true);
          }
        } else if (Entity.id.includes('sightPoint_Target')) {
          setBarrierPoints(Entity.id);
        }

        function setBarrierPoints(Barrier_id, isPointView) {
          sightline.getBarrierPoint(Barrier_id, function (obj) {
            var index = Barrier_id.charAt(Barrier_id.length - 1);

            if (obj && obj.position) {
              obj.position.height += 2;
              var position = Cesium.Cartographic.toCartesian(obj.position);
              var distance;

              if (isPointView) {
                var lan_lon = sightline._targetPoints.values[index];
                var Cartesian = Cesium.Cartesian3.fromDegrees(lan_lon[0], lan_lon[1], lan_lon[2]);
                distance = Cesium.Cartesian3.distance(Cartesian, position);
              } else {
                distance = Cesium.Cartesian3.distance(Entity.position._value, position);
              }

              if (distance >= 2.5) {
                sightBarrierPoints[index] = position; //更新障碍点信息

                sightBarrierPointsColor[index] = state.hiddenColor;
              } else {
                sightBarrierPoints[index] = {
                  x: 6378137,
                  y: 0,
                  z: 0
                }; //更新障碍点信息

                sightBarrierPointsColor[index] = state.visibleColor;
              } // 更新障碍物id


              var ObjectId = sightline.getObjectIds();
              ObjectIds.splice(index, 1, ObjectId);

              if (state.highlightBarrier) {
                var _iterator = _createForOfIteratorHelper(scene.layers.layerQueue),
                    _step;

                try {
                  for (_iterator.s(); !(_step = _iterator.n()).done;) {
                    var layer = _step.value;
                    layer.removeAllObjsColor();
                  }
                } catch (err) {
                  _iterator.e(err);
                } finally {
                  _iterator.f();
                }

                getHighlightBarriers();
              }
            } else {
              sightBarrierPoints[index] = {
                x: 6378137,
                y: 0,
                z: 0
              }; //更新障碍点信息

              sightBarrierPointsColor[index] = state.visibleColor;
            }
          });
        }
      });
    });
  } // 获取障碍物


  function getHighlightBarriers(barrierColor) {
    var color = Cesium.defaultValue(barrierColor, Cesium.Color.fromCssColorString(state.barrierColor));

    try {
      if (ObjectIds.length === 0) return;
      ObjectIds.forEach(function (ObjectId) {
        for (var index in ObjectId) {
          var layer = viewer.scene.layers.findByIndex(Number(index) - 3); // 底层索引从3开始

          var ids = ObjectId[index];
          layer.setObjsColor(ids, color);
        }
      });
    } catch (error) {
      console.log(error);
    }
  } // 清除


  function clear() {
    sightline.removeAllTargetPoint();

    var _iterator2 = _createForOfIteratorHelper(scene.layers.layerQueue),
        _step2;

    try {
      for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
        var layer = _step2.value;
        layer.removeAllObjsColor();
      }
    } catch (err) {
      _iterator2.e(err);
    } finally {
      _iterator2.f();
    }

    point_index = 0;
    ObjectIds.length = 0;
    sightTargetPoints.length = 0;
    sightBarrierPoints.length = 0;
    sightBarrierPointsColor.length = 0;
    dragEntity.removeEventListener();
    viewer.entities.removeAll();
    document.body.classList.remove("measureCur");
    window.tooltip.setVisible(false);
    state.viewPosition = null;
    barrierCones.length = 0;
    viewer.eventManager.removeEventListener("CLICK", LEFT_CLICK); //移除鼠标点击事件监听

    viewer.eventManager.removeEventListener("MOUSE_MOVE", MOUSE_MOVE); //移除鼠标点击事件监听

    viewer.eventManager.removeEventListener("RIGHT_CLICK", RIGHT_CLICK); //移除鼠标点击事件监听
  }

  watch(function () {
    return state.lineWidth;
  }, function (val) {
    if (sightline) sightline.lineWidth = Number(val);
  });
  watch(function () {
    return state.visibleColor;
  }, function (val) {
    if (sightline) sightline.visibleColor = Cesium.Color.fromCssColorString(val);
  });
  watch(function () {
    return state.hiddenColor;
  }, function (val) {
    if (sightline) sightline.hiddenColor = Cesium.Color.fromCssColorString(val);
  });
  watch(function () {
    return state.barrierColor;
  }, function (val) {
    if (ObjectIds.length === 0) return;
    var color = Cesium.Color.fromCssColorString(val);
    getHighlightBarriers(color);
  });
  watch(function () {
    return state.highlightBarrier;
  }, function (newValue) {
    if (newValue) {
      getHighlightBarriers();
    } else {
      var _iterator3 = _createForOfIteratorHelper(scene.layers.layerQueue),
          _step3;

      try {
        for (_iterator3.s(); !(_step3 = _iterator3.n()).done;) {
          var layer = _step3.value;
          layer.removeAllObjsColor();
        }
      } catch (err) {
        _iterator3.e(err);
      } finally {
        _iterator3.f();
      }
    }
  });
  watch(function () {
    return state.showBarrierPoints;
  }, function (val) {
    if (barrierCones.length === 0) return;
    barrierCones.forEach(function (b) {
      b.show = val;
    });
  }); // 销毁

  onBeforeUnmount(function () {
    clear();
    sightline = undefined;
  });
  return _objectSpread2(_objectSpread2({}, toRefs(state)), {}, {
    analysis: analysis,
    clear: clear
  });
}

var script = {
  name: "Sm3dSightline",
  props: {
    //s初始视点位置
    viewPosition: {
      type: Array
    },
    //可见部分颜色
    visibleColor: {
      type: String,
      "default": "rgb(0, 200, 0)"
    },
    //不可见颜色
    hiddenColor: {
      type: String,
      "default": "rgb(200, 0, 0)"
    },
    //高亮障碍物颜色
    barrierColor: {
      type: String,
      "default": "rgba(255, 186, 1, 1)"
    },
    //是否显示高亮障碍物
    highlightBarrier: {
      type: Boolean,
      "default": false
    },
    //通视线宽
    lineWidth: {
      type: Number,
      "default": 3
    },
    showBarrierPoints: {
      type: Boolean,
      "default": true
    }
  },
  setup: function setup(props) {
    var _sightLine = sightLine(props),
        lineWidth = _sightLine.lineWidth,
        visibleColor = _sightLine.visibleColor,
        hiddenColor = _sightLine.hiddenColor,
        barrierColor = _sightLine.barrierColor,
        highlightBarrier = _sightLine.highlightBarrier,
        showBarrierPoints = _sightLine.showBarrierPoints,
        analysis = _sightLine.analysis,
        clear = _sightLine.clear;

    return {
      lineWidth: lineWidth,
      visibleColor: visibleColor,
      hiddenColor: hiddenColor,
      barrierColor: barrierColor,
      highlightBarrier: highlightBarrier,
      showBarrierPoints: showBarrierPoints,
      analysis: analysis,
      clear: clear
    };
  }
};

var _hoisted_1 = {
  id: "sight-line",
  "class": "sm-panel"
};
var _hoisted_2 = {
  "class": "sm-function-module-sub-section",
  style: {
    "margin": "0"
  }
};
var _hoisted_3 = {
  "class": "sm-half-L"
};
var _hoisted_4 = {
  style: {
    "width": "35%"
  }
};
var _hoisted_5 = {
  "class": "sm-half-L"
};
var _hoisted_6 = {
  style: {
    "width": "35%"
  }
};
var _hoisted_7 = {
  "class": "sm-half-L"
};
var _hoisted_8 = {
  style: {
    "width": "35%"
  }
};
var _hoisted_9 = {
  "class": "sm-half-L"
};
var _hoisted_10 = {
  style: {
    "width": "35%"
  }
};
var _hoisted_11 = {
  "class": "sm-half-L"
};
var _hoisted_12 = {
  style: {
    "width": "auto"
  }
};
var _hoisted_13 = {
  style: {
    "width": "auto"
  }
};
var _hoisted_14 = {
  "class": "boxchild"
};
function render(_ctx, _cache, $props, $setup, $data, $options) {
  var _component_el_slider = resolveComponent("el-slider");

  var _component_el_color_picker = resolveComponent("el-color-picker");

  var _directive_stopdrag = resolveDirective("stopdrag");

  var _directive_drag = resolveDirective("drag");

  return withDirectives((openBlock(), createElementBlock("div", _hoisted_1, [withDirectives((openBlock(), createElementBlock("div", _hoisted_2, [createElementVNode("div", _hoisted_3, [createElementVNode("label", _hoisted_4, toDisplayString(_ctx.Resource.lineWidth), 1
  /* TEXT */
  ), createVNode(_component_el_slider, {
    modelValue: $setup.lineWidth,
    "onUpdate:modelValue": _cache[0] || (_cache[0] = function ($event) {
      return $setup.lineWidth = $event;
    }),
    min: 1,
    step: 1,
    max: 10,
    "input-size": "mini",
    debounce: 500,
    "tooltip-class": "tooltip-class",
    style: {
      "width": "63%"
    }
  }, null, 8
  /* PROPS */
  , ["modelValue"])]), createElementVNode("div", _hoisted_5, [createElementVNode("label", _hoisted_6, toDisplayString(_ctx.Resource.visibleColor), 1
  /* TEXT */
  ), createVNode(_component_el_color_picker, {
    modelValue: $setup.visibleColor,
    "onUpdate:modelValue": _cache[1] || (_cache[1] = function ($event) {
      return $setup.visibleColor = $event;
    }),
    size: "mini",
    "show-alpha": "",
    style: {
      "width": "63%"
    }
  }, null, 8
  /* PROPS */
  , ["modelValue"])]), createElementVNode("div", _hoisted_7, [createElementVNode("label", _hoisted_8, toDisplayString(_ctx.Resource.hiddenColor), 1
  /* TEXT */
  ), createVNode(_component_el_color_picker, {
    modelValue: $setup.hiddenColor,
    "onUpdate:modelValue": _cache[2] || (_cache[2] = function ($event) {
      return $setup.hiddenColor = $event;
    }),
    size: "mini",
    "show-alpha": "",
    style: {
      "width": "63%"
    }
  }, null, 8
  /* PROPS */
  , ["modelValue"])]), createElementVNode("div", _hoisted_9, [createElementVNode("label", _hoisted_10, toDisplayString(_ctx.Resource.barrierColor), 1
  /* TEXT */
  ), createVNode(_component_el_color_picker, {
    modelValue: $setup.barrierColor,
    "onUpdate:modelValue": _cache[3] || (_cache[3] = function ($event) {
      return $setup.barrierColor = $event;
    }),
    size: "mini",
    "show-alpha": "",
    style: {
      "width": "63%"
    }
  }, null, 8
  /* PROPS */
  , ["modelValue"])]), createElementVNode("div", _hoisted_11, [createElementVNode("label", _hoisted_12, [withDirectives(createElementVNode("input", {
    type: "checkbox",
    "onUpdate:modelValue": _cache[4] || (_cache[4] = function ($event) {
      return $setup.showBarrierPoints = $event;
    })
  }, null, 512
  /* NEED_PATCH */
  ), [[vModelCheckbox, $setup.showBarrierPoints]]), createTextVNode(" " + toDisplayString(_ctx.Resource.showBarrierPoints), 1
  /* TEXT */
  )]), createElementVNode("label", _hoisted_13, [withDirectives(createElementVNode("input", {
    type: "checkbox",
    "onUpdate:modelValue": _cache[5] || (_cache[5] = function ($event) {
      return $setup.highlightBarrier = $event;
    })
  }, null, 512
  /* NEED_PATCH */
  ), [[vModelCheckbox, $setup.highlightBarrier]]), createTextVNode(" " + toDisplayString(_ctx.Resource.highlightBarrier), 1
  /* TEXT */
  )])]), createElementVNode("div", _hoisted_14, [createElementVNode("button", {
    type: "button",
    "class": "tbtn",
    onClick: _cache[6] || (_cache[6] = function () {
      return $setup.analysis && $setup.analysis.apply($setup, arguments);
    })
  }, toDisplayString(_ctx.Resource.analyze), 1
  /* TEXT */
  ), createElementVNode("button", {
    type: "button",
    "class": "tbtn tbtn-margin-left",
    onClick: _cache[7] || (_cache[7] = function () {
      return $setup.clear && $setup.clear.apply($setup, arguments);
    })
  }, toDisplayString(_ctx.Resource.clear), 1
  /* TEXT */
  )])])), [[_directive_stopdrag]])])), [[_directive_drag]]);
}

script.render = render;
script.__file = "src/components/analysis_3d/sight-line/sight-line.vue";

script.install = function (app) {
  app.component(script.name, script);
};

export default script;
