import { reactive, toRefs, ref, onMounted, watch, onBeforeUnmount, resolveComponent, resolveDirective, openBlock, createElementBlock, Fragment, withDirectives, createElementVNode, toDisplayString, vModelSelect, vModelText, createVNode, vModelCheckbox, createTextVNode, vShow } from 'vue';

function _typeof(obj) {
  "@babel/helpers - typeof";

  if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
    _typeof = function (obj) {
      return typeof obj;
    };
  } else {
    _typeof = function (obj) {
      return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
    };
  }

  return _typeof(obj);
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);

  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    if (enumerableOnly) symbols = symbols.filter(function (sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    });
    keys.push.apply(keys, symbols);
  }

  return keys;
}

function _objectSpread2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};

    if (i % 2) {
      ownKeys(Object(source), true).forEach(function (key) {
        _defineProperty(target, key, source[key]);
      });
    } else if (Object.getOwnPropertyDescriptors) {
      Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
      ownKeys(Object(source)).forEach(function (key) {
        Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
      });
    }
  }

  return target;
}

function _toConsumableArray(arr) {
  return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread();
}

function _arrayWithoutHoles(arr) {
  if (Array.isArray(arr)) return _arrayLikeToArray(arr);
}

function _iterableToArray(iter) {
  if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter);
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

  return arr2;
}

function _nonIterableSpread() {
  throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

/*
* 常用工具类
*/
//axios本版本不支持jsonp
var axiosJsonp = function axiosJsonp(url) {
  if (!url) {
    console.error('Axios.JSONP 至少需要一个url参数!');
    return;
  }

  return new Promise(function (resolve, reject) {
    window.jsonCallBack = function (result) {
      resolve(result);
    };

    var JSONP = document.createElement("script");
    JSONP.type = "text/javascript";
    JSONP.src = "".concat(url, "&callback=jsonCallBack");
    document.getElementsByTagName("head")[0].appendChild(JSONP);
    setTimeout(function () {
      document.getElementsByTagName("head")[0].removeChild(JSONP);
    }, 500);
  });
}; //判断两数组或对象相等


var isEqualArr = function isEqualArr(arg1, arg2) {
  if (!arg1 || !arg2) return true;
  var bol = true;

  if (Object.keys(arg1).length != Object.keys(arg2).length) {
    return false;
  }

  for (var key in arg1) {
    if (_typeof(arg1[key]) == 'object') {
      bol = isSame(arg1[key], arg2[key]);

      if (!bol) {
        break;
      }
    } else if (arg1[key] != arg2[key]) {
      bol = false;
      break;
    }
  }

  return bol;
}; //坐标转化
//笛卡尔转经纬度


var CartesiantoDegrees = function CartesiantoDegrees(Cartesians) {
  var array = [].concat(Cartesians);
  var positions = [];

  for (var i = 0, len = array.length; i < len; i++) {
    var cartographic = Cesium.Cartographic.fromCartesian(array[i]);
    var longitude = Cesium.Math.toDegrees(cartographic.longitude);
    var latitude = Cesium.Math.toDegrees(cartographic.latitude);
    var h = cartographic.height;

    if (positions.indexOf(longitude) == -1 && positions.indexOf(latitude) == -1) {
      positions.push(longitude);
      positions.push(latitude);
      positions.push(h);
    }
  }

  return positions;
}; //笛卡尔转经纬度(每个点是独立的对象)


var CartesiantoDegreesObjs = function CartesiantoDegreesObjs(Cartesians) {
  var array = [].concat(Cartesians);
  var positions = [];

  for (var i = 0, len = array.length; i < len; i++) {
    var cartographic = Cesium.Cartographic.fromCartesian(array[i]);
    var obj = {
      longitude: Cesium.Math.toDegrees(cartographic.longitude),
      latitude: Cesium.Math.toDegrees(cartographic.latitude),
      height: cartographic.height
    };
    positions.push(obj);
  }

  return positions;
}; // 弧度转经纬度


var CartographictoDegrees = function CartographictoDegrees(wgsPosition) {
  var longitude = Cesium.Math.toDegrees(wgsPosition.longitude);
  var latitude = Cesium.Math.toDegrees(wgsPosition.latitude);
  var height = wgsPosition.height;
  return [longitude, latitude, height];
}; //去重函数  数组


var unique = function unique(arr) {
  var res = [];
  var json = {};

  for (var i = 0; i < arr.length; i++) {
    if (!json[arr[i]]) {
      res.push(arr[i]);
      json[arr[i]] = 1;
    }
  }

  return res;
}; // 获取渐变色函数


function gradientColors(start, end, steps, gamma) {
  var i,
      j,
      ms,
      me,
      output = [],
      so = [];
  gamma = gamma || 1;

  var normalize = function normalize(channel) {
    return Math.pow(channel / 255, gamma);
  };

  start = parseColor(start).map(normalize);
  end = parseColor(end).map(normalize);

  for (i = 0; i < steps; i++) {
    ms = i / (steps - 1);
    me = 1 - ms;

    for (j = 0; j < 3; j++) {
      so[j] = pad(Math.round(Math.pow(start[j] * me + end[j] * ms, 1 / gamma) * 255).toString(16));
    }

    output.push('#' + so.join(''));
  }

  return output;

  function parseColor(hexStr) {
    return hexStr.length === 4 ? hexStr.substr(1).split('').map(function (s) {
      return 0x11 * parseInt(s, 16);
    }) : [hexStr.substr(1, 2), hexStr.substr(3, 2), hexStr.substr(5, 2)].map(function (s) {
      return parseInt(s, 16);
    });
  }

  function pad(s) {
    return s.length === 1 ? '0' + s : s;
  }
}

function getAngleAndRadian(pointA, pointB) {
  //建立以点A为原点，X轴为east,Y轴为north,Z轴朝上的坐标系
  var transform = Cesium.Transforms.eastNorthUpToFixedFrame(pointA); //向量AB

  var positionvector = Cesium.Cartesian3.subtract(pointB, pointA, new Cesium.Cartesian3()); //因transform是将A为原点的eastNorthUp坐标系中的点转换到世界坐标系的矩阵
  //AB为世界坐标中的向量
  //因此将AB向量转换为A原点坐标系中的向量，需乘以transform的逆矩阵。

  var vector = Cesium.Matrix4.multiplyByPointAsVector(Cesium.Matrix4.inverse(transform, new Cesium.Matrix4()), positionvector, new Cesium.Cartesian3()); //归一化

  var direction = Cesium.Cartesian3.normalize(vector, new Cesium.Cartesian3()); //heading

  var heading1 = Math.atan2(direction.y, direction.x) - Cesium.Math.PI_OVER_TWO;
  var radian = Cesium.Math.TWO_PI - Cesium.Math.zeroToTwoPi(heading1);
  var angle = radian * (180 / Math.PI);

  if (angle < 0) {
    angle = angle + 360;
  }

  return {
    angle: angle,
    radian: radian
  };
}

function getPitch(pointA, pointB) {
  var transfrom = Cesium.Transforms.eastNorthUpToFixedFrame(pointA);
  var vector = Cesium.Cartesian3.subtract(pointB, pointA, new Cesium.Cartesian3());
  var direction = Cesium.Matrix4.multiplyByPointAsVector(Cesium.Matrix4.inverse(transfrom, transfrom), vector, vector);
  Cesium.Cartesian3.normalize(direction, direction); //因为direction已归一化，斜边长度等于1，所以余弦函数等于direction.z

  var radian = Cesium.Math.PI_OVER_TWO - Cesium.Math.acosClamped(direction.z);
  var angle = radian * (180 / Math.PI);

  if (angle < 0) {
    angle = angle + 360;
  }

  return {
    angle: angle,
    radian: radian
  };
}

var tool = {
  axiosJsonp: axiosJsonp,
  isEqualArr: isEqualArr,
  CartesiantoDegrees: CartesiantoDegrees,
  CartesiantoDegreesObjs: CartesiantoDegreesObjs,
  unique: unique,
  gradientColors: gradientColors,
  getAngleAndRadian: getAngleAndRadian,
  CartographictoDegrees: CartographictoDegrees,
  getPitch: getPitch
};

var ResourceCN = {
  showRenderLoopErrors: '渲染时发生错误，已停止渲染。',
  AttributeError: '该组件props没有这个属性：',
  NoPickPositionSupported: "不支持深度纹理,无法绘制多边形，地形操作功能无法使用！",
  NoTerrain: "请在地形里使用地形组件！",
  initViewerWarn: '请先初始化viewer!',
  MoveMouseHeightBox: '点击鼠标左键结束矩形绘制，移动鼠标绘制box高度',
  RightClickEndDrawing: '右键单击结束绘制',
  LeftClickBottomBox: '点击鼠标左键，开始绘制矩形作为box底面',
  ClickModelAddBox: '点击模型，添加裁剪盒子',
  SkyLineWarn: "获取天际线体前，请先绘制天际线！",
  SkyLineBody: '天际线体',
  ShadowqueryWarn: "此操作需要先开启阴影！",
  VeiwshedBody: '可视体',
  VeiwshedBodyHidden: '不可视体',
  EchartsErr: "二维显示需要echarts支持，未找到相关依赖！",
  BaseMapImg: '底图',
  tip1: '<p>点击左键确定操作区域中间点</p><p>右键单击结束绘制</p>'
};

// 组件内部的语言资源：主要包括提示信息
var currentLanguage, Resource;
var cookieLanguage = getLang().toLowerCase();

function getLang() {
  //浏览器语言  IE用browserLanguage，非IE使用language进行判断
  var lang = (navigator.language || navigator.browserLanguage).toLowerCase();
  window.lang = lang; //判断portal设置语言 通过cookie获取
  //   const cookies = document.cookie.split(';');
  //   if (cookies.length > 0) {
  //     cookies.forEach(function (cookie) {
  //       const arr = cookie.split('=');
  //       if (arr[0].toLowerCase().trim() === 'language') {
  //         lang = arr[1];
  //         return;
  //       }
  //     });
  //   }

  return lang;
}

if (cookieLanguage !== undefined) {
  currentLanguage = cookieLanguage;
} else {
  currentLanguage = (navigator.language || navigator.browserLanguage).toLowerCase(); // 获取当前浏览器的语言
}

if (currentLanguage.startsWith('zh')) {
  Resource = ResourceCN;
} else if (currentLanguage.startsWith('ja')) {
  Resource = ResourceCN;
} else {
  Resource = ResourceCN;
}

var resource = Resource;

// 创建一个简单的store状态管理

var storeState = reactive({
  isViewer: false,
  //viewer初始化标志
  changeLayers: 0,
  //图层改变加载完毕监听
  changeGeometrys: 0 //三维分析体改变标志

});
var actions = {
  setIsViewer: function setIsViewer(newValue) {
    storeState.isViewer = newValue;
  },
  setChangeLayers: function setChangeLayers(newValue) {
    storeState.changeLayers += 1;
  },
  setGeometrys: function setGeometrys(newValue) {
    storeState.changeGeometrys += 1;
  }
}; // 全局公共数据

var storeDate = {
  geometrys: {},
  //存储当前存在的三位空间查询体：如天际线体，可视域体
  layers: null
};

//随鼠标移动消息提示工具
function createTooltip$1(frameDiv) {
  var tooltip = function tooltip(frameDiv) {
    var div = document.createElement("DIV");
    div.className = "twipsy right";
    var arrow = document.createElement("DIV");
    arrow.className = "twipsy-arrow";
    div.appendChild(arrow);
    var title = document.createElement("DIV");
    title.className = "twipsy-inner";
    div.appendChild(title);
    this._div = div;
    this._title = title;
    this.message = "";
    frameDiv.appendChild(div);
    var that = this;

    div.onmousemove = function (evt) {
      that.showAt({
        x: evt.clientX,
        y: evt.clientY
      }, that.message);
    };
  };

  tooltip.prototype.setVisible = function (visible) {
    this._div.style.display = visible ? "block" : "none";
  };

  tooltip.prototype.showAt = function (position, message) {
    if (position && message) {
      this.setVisible(true);
      this._title.innerHTML = message;
      this._div.style.left = position.x + 10 + "px";
      this._div.style.top = position.y - this._div.clientHeight / 2 + "px";
      this.message = message;
    }
  };

  return new tooltip(frameDiv);
}

/**
 * 初始化
 * DrawMode：类型
 * clampMode：模式
 */

var initHandler = function initHandler(DrawMode, clampMode) {
  var clampmode = 0;

  if (clampMode) {
    clampmode = clampMode;
  }

  switch (DrawMode) {
    case "Point":
      window.handlerPoint = new Cesium.DrawHandler(viewer, Cesium.DrawMode.Point);
      break;

    case "Polyline":
      window.handlerPolyline = new Cesium.DrawHandler(viewer, Cesium.DrawMode.Line, clampmode);
      break;

    case "Polygon":
      window.handlerPolygon = new Cesium.DrawHandler(viewer, Cesium.DrawMode.Polygon, clampmode);
      break;

    case "Marker":
      window.handlerMarker = new Cesium.DrawHandler(viewer, Cesium.DrawMode.Marker, clampmode);
      break;

    case "Box":
      window.handlerBox = new Cesium.DrawHandler(viewer, Cesium.DrawMode.Box, clampmode);
      break;
  }

  if (!window.tooltip) {
    window.tooltip = createTooltip$1(viewer._element);
  } // 半透线创建


  if (!window.polylineCollection) {
    window.polylineCollection = new Cesium.PolylineCollection({
      translucentRS: Cesium.RenderState.fromCache({
        depthMask: false,
        depthTest: {
          enabled: false
        }
      })
    });
    window.polylineTransparent = window.polylineCollection.add({
      width: 2,
      material: Cesium.Material.fromType(Cesium.Material.ColorType, {
        color: Cesium.Color.fromCssColorString("#51ff00").withAlpha(0.3)
      })
    });
    viewer.scene.primitives.add(window.polylineCollection);
  }
};
/**
 * 绘制
 * PolyType：类型 
 * lineVisib：绘制时是否显示绘制线（boolean）
 * toolTipObj：绘制时提示内容{beforeDrawing：绘制开始前提示(string)，isDrawing：正在绘制时提示,即绘制过程中（string）}
 */


var handlerDrawing = function handlerDrawing(PolyType, lineVisib, toolTipObj) {
  var lineVisible = true;

  if (lineVisib === false) {
    lineVisible = lineVisib;
  }

  var DrawHandler = judgeDrawHandlerType(PolyType); //获取操作对象

  return new Promise(function (resolve, reject) {
    //做一些异步操作
    var tooltip = window.tooltip;
    var clearActFn = DrawHandler.activeEvt.addEventListener(function (isActive) {
      if (isActive == true) {
        viewer.enableCursorStyle = false;
        viewer._element.style.cursor = '';

        if (PolyType == "Point" || PolyType == "Marker") {
          document.body.classList.add("measureCur");
        } else {
          document.body.classList.add("drawCur");
        }
      } else {
        viewer.enableCursorStyle = true;
        tooltip.setVisible(false);

        if (PolyType == "Point" || PolyType == "Marker") {
          document.body.classList.remove('measureCur');
        } else {
          document.body.classList.remove('drawCur');
        }
      }
    });
    var clearMovFn = DrawHandler.movingEvt.addEventListener(function (windowPosition) {
      if (windowPosition.x < 200 && windowPosition.y < 150) {
        tooltip.setVisible(false);
        return;
      }
      //     tooltip.showAt(windowPosition, tiptext);
      // } else if (toolTipObj && toolTipObj.beforeDrawing) {
      //     tooltip.showAt(windowPosition, toolTipObj.beforeDrawing);
      // }else if (DrawHandler.isDrawing && toolTipObj.isDrawing) {
      //     tooltip.showAt(windowPosition, toolTipObj.isDrawing);
      // }

      if (DrawHandler.polyline && DrawHandler.isDrawing) {
        var p = _toConsumableArray(DrawHandler.polyline.positions);

        if (PolyType == "Polygon") {
          //画面时，需要首尾相连
          p.push(p[0]);
        }
        window.polylineTransparent.show = true;
        window.polylineTransparent.positions = p;
      }
    });
    var clearDrawFn = DrawHandler.drawEvt.addEventListener(function (result) {
      if (!result.object.positions && PolyType != "Point" && PolyType != "Box") {
        tooltip.showAt(result, '<p>请绘制正确的多边形</p>');
        DrawHandler.polygon.show = false;
        DrawHandler.polyline.show = false;
        DrawHandler.deactivate();
        DrawHandler.activate();
        return;
      }

      if (PolyType == "Box") {
        resolve({
          result: result
        });
        return;
      }

      if (PolyType == "Point" || PolyType == "Marker") {
        DrawHandler.clear(); // 不显示绘制的点

        resolve({
          result: result
        });
      } else {
        //半透线
        window.polylineTransparent.show = lineVisible;

        if (lineVisible) {
          if (PolyType == "Polygon" && lineVisible) {
            DrawHandler.polygon._polygon._material._color._value.alpha = 0.1; //绘制面透明度

            var p2 = _toConsumableArray(result.object.positions); //画面时，需要首尾相连


            p2.push(p2[0]);
            window.polylineTransparent.positions = p2;
          }
        }

        var positions = CartesiantoDegrees(result.object.positions);
        resolve({
          result: result,
          positions: positions
        });
      }

      clearActFn();
      clearMovFn();
      clearDrawFn();
    });
  });
}; //清除


var clearHandlerDrawing = function clearHandlerDrawing(PolyType) {
  var DrawHandler;

  if (!PolyType) {
    DrawHandler = window.handlerPolygon;
  } else {
    DrawHandler = judgeDrawHandlerType(PolyType);
  }
  if (!DrawHandler) return;
  DrawHandler.deactivate();
  DrawHandler.clear();
  viewer.enableCursorStyle = true; // document.body.classList.remove("drawCur");
  // document.body.classList.remove("measureCur");

  window.tooltip.setVisible(false);

  if (window.polylineTransparent) {
    window.polylineTransparent.show = false;
  }
}; // 类型判断


var judgeDrawHandlerType = function judgeDrawHandlerType(PolyType) {
  var DrawHandler;

  switch (PolyType) {
    case "Point":
      DrawHandler = window.handlerPoint;
      break;

    case "Polyline":
      DrawHandler = window.handlerPolyline;
      break;

    case "Polygon":
      DrawHandler = window.handlerPolygon;
      break;

    case "Marker":
      DrawHandler = window.handlerMarker;
      break;

    case "Box":
      DrawHandler = window.handlerBox;
      break;
  }

  return DrawHandler;
};

function skyLine(props) {
  // 设置默认值数据
  var state = reactive({
    skylineRadius: 10000,
    //分析半径
    lineWidth: 3,
    //天际线宽度
    skylineColor: "rgb(200, 0, 0, 1.0)",
    //天际线颜色
    skyBodyColor: "rgba(44,149,197,0.6)",
    //天际体颜色
    barrierColor: "rgba(255, 186, 1, 1)",
    //障碍物颜色
    skylineMode: 0,
    //分析模式
    highlightBarrier: false,
    //是否显示高亮障碍物
    getSkyline2d: false,
    //是否显示二维分析结果
    skylineSpatialAnalysisUrl: null,
    //分析服务地址 'http://www.supermapol.com/realspace/services/spatialAnalysis-data_all/restjsr/spatialanalyst/geometry/3d/skylinesectorbody.json'
    observerInformation: null,
    //观察者信息
    ignoreGlobe: true // 地球表面不参与分析

  }); // 传入props改变默认值

  if (props) {
    for (var key in props) {
      if (state.hasOwnProperty(key)) {
        if (props[key] != undefined) state[key] = props[key];
      } else {
        tool.Message.errorMsg(resource.AttributeError + key);
      }
    }
  } // 初始化数据


  var myChart,
      s3mInstance,
      skyline,
      scene,
      tipFlag = true;
  var echarts_box = ref(null);
  onMounted(function () {
    initMyChart();
  });

  if (storeState.isViewer) {
    scene = viewer.scene;
    skyline = new Cesium.Skyline(scene);
    skyline.ignoreGlobe = state.ignoreGlobe; //地球表面不参与分析

    skyline.build();
    s3mInstance = new Cesium.S3MInstanceCollection(scene._context);
    scene.primitives.add(s3mInstance); //初始化观察者信息（后面有需要可以添加监听）

    if (state.observerInformation) {
      skyLineUpdate(state.observerInformation);
    }

    if (!window.tooltip) {
      window.tooltip = createTooltip(viewer._element);
    }
  } //viewer 初始化完成的监听


  watch(function () {
    return storeState.isViewer;
  }, function (val) {
    if (val) {
      scene = viewer.scene;
      skyline = new Cesium.Skyline(viewer.scene);
      skyline.ignoreGlobe = state.ignoreGlobe;
      skyline.build();
      s3mInstance = new Cesium.S3MInstanceCollection(viewer.scene._context);
      viewer.scene.primitives.add(s3mInstance);

      if (state.observerInformation) {
        skyLineUpdate(state.observerInformation);
      }

      if (!window.tooltip) {
        window.tooltip = createTooltip(viewer._element);
      }
    }
  }); //初始化echarts

  function initMyChart() {
    if (window.echarts) {
      if (!myChart) {
        myChart = window.echarts.init(echarts_box.value); //初始化echarts

        window.onresize = function () {
          myChart.resize(); //自适应屏幕
        };
      }
    } else {
      tool.Message.warnMsg(resource.EchartsErr);
      return;
    }

    myChart.setOption({
      title: {
        text: "二维天际线",
        textStyle: {
          fontSize: 14
        }
      },
      grid: {
        left: 30,
        right: 0,
        top: 30,
        bottom: 8
      },
      tooltip: {},
      xAxis: {
        show: false
      },
      yAxis: {
        show: false
      },
      series: [{
        type: "bar",
        data: []
      }]
    });
  }
  /*
   ***分析模块***
  */
  //分析

  function skyLineAnalysis() {
    clear(); // 清除上一次分析结果
    // 天际线分析的视口位置设置成当前相机位置

    var cartographic = viewer.scene.camera.positionCartographic;
    var observerObj = {
      longitude: Cesium.Math.toDegrees(cartographic.longitude),
      latitude: Cesium.Math.toDegrees(cartographic.latitude),
      height: cartographic.height,
      pitch: Cesium.Math.toDegrees(scene.camera.pitch),
      direction: Cesium.Math.toDegrees(scene.camera.heading)
    };
    skyLineUpdate(observerObj);
  }

  function setLimitBody() {
    if (!window.handlerPolygon) {
      initHandler("Polygon");
    }

    tooltip.setVisible(false);

    if (tipFlag) {
      //只提示一次
      window.tooltip.showAt(' <p>点击鼠标左键绘制区域</p><p>点击鼠标右键结束绘制</p>', '450px');
      tipFlag = false;
    }

    handlerDrawing("Polygon").then(function (res) {
      skyline.removeLimitbody("limitBody");
      var handlerPolygon = window.handlerPolygon;
      var pos = res.result.object.positions;
      var positions = []; // 遍历多边形，取出所有点

      for (var i = 0, len = pos.length; i < len; i++) {
        //转化为经纬度，并加入至临时数组
        var cartographic = Cesium.Cartographic.fromCartesian(pos[i]);
        var longitude = Cesium.Math.toDegrees(cartographic.longitude);
        var latitude = Cesium.Math.toDegrees(cartographic.latitude);
        positions.push([longitude, latitude]);
      } //去除重复点


      var p = tool.unique(positions);
      var posArr = []; //再次遍历转化为接口所需的数组格式

      for (var _i = 0, _len = p.length; _i < _len; _i++) {
        posArr.push(positions[_i][0]);
        posArr.push(positions[_i][1]);
      } //添加限高体对象


      skyline.addLimitbody({
        position: posArr,
        name: "limitBody"
      });
      handlerPolygon.polygon.show = false;
      handlerPolygon.polyline.show = false; //   window.polylineTransparent.show = false; //半透线隐藏

      handlerPolygon.deactivate();
    }, function (err) {
      console.log(err);
    });
    window.handlerPolygon.activate();
  }

  function skyLineUpdate(observerObj) {
    skyline.viewPosition = [observerObj.longitude, observerObj.latitude, observerObj.height]; //设置俯仰和方向

    skyline.pitch = observerObj.pitch;
    skyline.direction = observerObj.direction;
    skyline.radius = Number(state.skylineRadius);
    skyline.lineWidth = Number(state.lineWidth);
    skyline.color = Cesium.Color.fromCssColorString(state.skylineColor);
    skyline.displayStyle = Number(state.skylineMode > 1 ? 0 : state.skylineMode);
    setTimeout(function () {
      if (state.highlightBarrier) {
        // 显示障碍物
        var BarrierColor = Cesium.Color.fromCssColorString(state.barrierColor);
        changeBarrierColor(BarrierColor);
      }

      if (state.skylineMode == 2) {
        // 是否切换天际体
        if (state.skylineSpatialAnalysisUrl) {
          setSkyLineBody();
        } else {
          setSkyLineBody2(observerObj); // setSkyLineBody(observerObj)
        }
      }

      var object = skyline.getSkyline2D();
      setOptions(object); // 设置二维天际线
    }, 300);
    state.observerInformation = observerObj;
  } // 改变障碍物颜色


  function changeBarrierColor(BarrierColor) {
    var ObjectIds = skyline.getObjectIds();
    console.log(ObjectIds);
    var layers = viewer.scene.layers._layerQueue;

    var _loop = function _loop(index) {
      layers.forEach(function (layer) {
        if (layer._id === Number(index)) {
          layer.setObjsColor(ObjectIds[index], BarrierColor);
        }
      });
    };

    for (var index in ObjectIds) {
      _loop(index);
    }
  }

  function setOptions(object) {
    if (state.observerInformation && myChart) {
      var option = {
        tooltip: {
          trigger: 'axis',
          // formatter: 'X: {b}<br/>Y : {c}'
          formatter: function formatter(param) {
            var datax = Number(param[0].axisValue);
            var datay = param[0].data;
            return ["X: " + datax.toFixed(6) + "<br/>", "Y: " + datay.toFixed(6)].join("");
          }
        },
        grid: {
          left: 40,
          right: 0,
          top: 35,
          bottom: 8,
          borderColor: '#333333'
        },
        // backgroundColor: "rgba(73,139,156,0.0)",
        color: 'red',
        xAxis: [{
          type: "category",
          boundaryGap: false,
          data: object.x,
          show: false
        }],
        yAxis: {
          min: function min(value) {
            return (value.min - 0.05).toFixed(2);
          },
          show: true,
          axisLine: {
            show: true
          }
        },
        dataZoom: [{
          type: "inside",
          xAxisIndex: 0,
          filterMode: "filter",
          start: 0,
          end: 100
        }],
        series: [{
          symbolSize: 8,
          symbol: 'circle',
          smooth: true,
          // name: "天际线分析",
          // symbol: "none",
          type: "line",
          data: object.y,
          lineStyle: {
            width: 2,
            shadowColor: 'rgba(145, 146, 148,0.7)',
            shadowBlur: 10,
            shadowOffsetY: 8
          }
        }]
      };
      myChart.setOption(option);
    }
  }

  function setSkyLineBody() {
    var param = skyline.getSkylineSectorParameter();
    var geometrySkylineSectorBodyPostParameter = {
      viewerPoint: param.viewPos,
      line3D: param.geoLine3D,
      height: 0,
      lonlat: true
    };
    var url = state.skylineSpatialAnalysisUrl;
    var queryData = JSON.stringify(geometrySkylineSectorBodyPostParameter);
    axios.post(url, queryData).then(function (response) {
      //再发送一次GET请求  获取到运算结果
      axios.get(response.data.newResourceLocation + ".json").then(function (response) {
        var data = response.data;

        if (data.geometry === null) {
          return;
        }

        var uint8Array = new Uint8Array(data.geometry.model);
        var buffer = uint8Array.buffer;
        s3mInstance.add("SkyLineBody", {
          id: 1,
          position: Cesium.Cartesian3.fromDegrees(data.geometry.position.x, data.geometry.position.y, data.geometry.position.z),
          hpr: new Cesium.HeadingPitchRoll(0, 0, 0),
          color: Cesium.Color.fromCssColorString(state.skyBodyColor)
        }, buffer, false);
        data.geometry.model = [4, 0, 0, 0].concat(data.geometry.model); // // 传到store可以做gpu查询

        data.geometry["name"] = resource.SkyLineBody;
        storeDate.geometrys["SkyLineBody"] = data.geometry;
        actions.setGeometrys();
      })["catch"](function (error) {
        console.log(error);
        tool.Message.errorMsg("获取天际线体数据失败", error);
      });
    })["catch"](function (error) {
      console.log(error);
      tool.Message.errorMsg("获取天际线体数据失败", error);
    });
  }

  function setSkyLineBody2(observerObj) {
    var points = skyline.getSkyline3D();
    var pointArr = new Array();
    var cameraPoint = Cesium.Cartesian3.fromDegrees(observerObj.longitude, observerObj.latitude, observerObj.height);
    pointArr.push(cameraPoint);

    for (var i = 0; i < points.x.length; i++) {
      var point = Cesium.Cartesian3.fromDegrees(points.x[i], points.y[i], points.z[i]);
      pointArr.push(point);
    }

    viewer.entities.add({
      id: 'SkyLineBody',
      polygon: {
        extrudedHeight: 10,
        hierarchy: pointArr,
        perPositionHeight: true,
        material: Cesium.Color.fromCssColorString(state.skyBodyColor)
      }
    });
  } // 清除


  function clear() {
    clearHandlerDrawing();
    tooltip.setVisible(false);
    if (!state.observerInformation) return; // viewer.entities.removeAll();

    viewer.entities.removeById('SkyLineBody');

    if (skyline) {
      skyline.clear();
    }

    for (var i = 0; i < scene.layers._layerQueue.length; i++) {
      var layer = scene.layers.findByIndex(i);
      layer.removeAllObjsColor();
    }

    state.observerInformation = null;
    myChart.clear();
    initMyChart();
    s3mInstance.removeCollection("SkyLineBody");

    if (storeDate.geometrys.SkyLineBody) {
      delete storeDate.geometrys.SkyLineBody;
      actions.setGeometrys();
    }
  }

  watch(function () {
    return state.skylineRadius;
  }, function (val) {
    if (state.observerInformation) {
      skyline.radius = parseFloat(val);
      skyline.pitch = parseFloat(state.observerInformation.pitch);
    }
  });
  watch(function () {
    return state.lineWidth;
  }, function (val) {
    skyline.lineWidth = Number(val);

    if (state.observerInformation) {
      skyline.pitch = parseFloat(state.observerInformation.pitch); //加上才能实时改变线宽，可能是缺陷
    }
  });
  watch(function () {
    return state.skylineColor;
  }, function (newValue) {
    if (state.observerInformation && newValue != "") {
      var color = Cesium.Color.fromCssColorString(newValue);
      skyline.color = color;
      skyline.pitch = parseFloat(state.observerInformation.pitch);
    }
  });
  watch(function () {
    return state.barrierColor;
  }, function (newValue) {
    if (state.observerInformation || !state.highlightBarrier) {
      var BarrierColor = Cesium.Color.fromCssColorString(newValue);
      changeBarrierColor(BarrierColor);
    }
  });
  watch(function () {
    return state.ignoreGlobe;
  }, function (newValue) {
    if (skyline) skyline.ignoreGlobe = newValue;
  });
  watch(function () {
    return state.highlightBarrier;
  }, function (newValue) {
    if (newValue && state.observerInformation) {
      var BarrierColor = Cesium.Color.fromCssColorString(state.barrierColor);
      changeBarrierColor(BarrierColor);
    } else {
      for (var i = 0; i < scene.layers._layerQueue.length; i++) {
        var layer = scene.layers.findByIndex(i);
        layer.removeAllObjsColor();
      }
    }
  });
  watch(function () {
    return state.skyBodyColor;
  }, function (newValue) {
    if (state.observerInformation && newValue != "") {
      var color = Cesium.Color.fromCssColorString(newValue);

      if (state.skylineSpatialAnalysisUrl) {
        s3mInstance.getInstance("SkyLineBody", 1).updateColor(color);
      } else {
        viewer.entities.getById('SkyLineBody').polygon.material = color; //不走服务用这个
      }
    }
  });
  watch(function () {
    return state.getSkyline2d;
  }, function (newValue) {
    if (!newValue || !myChart) {
      state.getSkyline2d = false;
      return;
    }

    setTimeout(function () {
      myChart.resize(); //自适应屏幕
    }, 200);
  });
  watch(function () {
    return state.skylineMode;
  }, function (newValue) {
    if (newValue == 0) {
      skyline.displayStyle = 0;
      viewer.entities.removeById('SkyLineBody');
      s3mInstance.removeCollection("SkyLineBody");

      if (storeDate.geometrys.SkyLineBody) {
        delete storeDate.geometrys.SkyLineBody;
        actions.setGeometrys();
      }
    } else if (newValue == 1) {
      skyline.displayStyle = 1;
      viewer.entities.removeById('SkyLineBody');
      s3mInstance.removeCollection("SkyLineBody");

      if (storeDate.geometrys.SkyLineBody) {
        delete storeDate.geometrys.SkyLineBody;
        actions.setGeometrys();
      }
    } else if (newValue == 2) {
      // 需要iServer910支持=
      skyline.displayStyle = 0;

      if (state.observerInformation) {
        if (state.skylineSpatialAnalysisUrl) {
          setSkyLineBody(state.observerInformation);
        } else {
          setSkyLineBody2(state.observerInformation); // setSkyLineBody(state.observerInformation)
        }
      }
    }
  }); // 销毁

  onBeforeUnmount(function () {
    clear();

    skyline = undefined;
    myChart = undefined;
    s3mInstance = undefined;
  });
  return _objectSpread2(_objectSpread2({}, toRefs(state)), {}, {
    skyLineAnalysis: skyLineAnalysis,
    setLimitBody: setLimitBody,
    echarts_box: echarts_box,
    clear: clear
  });
}

var script = {
  name: "Sm3dSkyline",
  props: {
    //分析服务地址
    skylineSpatialAnalysisUrl: {
      type: String
    },
    //观察者信息：查看或设置观察者信息
    observerInformation: {
      type: Object
    },
    //天际线分析半径
    skylineRadius: {
      type: Number
    },
    //天际线宽度
    lineWidth: {
      type: Number
    },
    //天际线颜色
    skylineColor: {
      type: String
    },
    //天际体颜色
    skyBodyColor: {
      type: String
    },
    //高亮障碍物颜色
    barrierColor: {
      type: String
    },
    //显示高亮障碍物
    highlightBarrier: {
      type: Boolean,
      "default": false
    },
    //天际线分析模式：线，面，体
    skylineMode: {
      type: Number
    },
    //显示二维分析结果
    getSkyline2d: {
      type: Boolean,
      "default": false
    },
    //忽略地表参与分析
    ignoreGlobe: {
      type: Boolean,
      "default": true
    }
  },
  setup: function setup(props) {
    var _skyLine = skyLine(props),
        skylineRadius = _skyLine.skylineRadius,
        lineWidth = _skyLine.lineWidth,
        skylineColor = _skyLine.skylineColor,
        skyBodyColor = _skyLine.skyBodyColor,
        barrierColor = _skyLine.barrierColor,
        highlightBarrier = _skyLine.highlightBarrier,
        getSkyline2d = _skyLine.getSkyline2d,
        skyLineAnalysis = _skyLine.skyLineAnalysis,
        setLimitBody = _skyLine.setLimitBody,
        clear = _skyLine.clear,
        echarts_box = _skyLine.echarts_box,
        skylineMode = _skyLine.skylineMode,
        ignoreGlobe = _skyLine.ignoreGlobe;

    return {
      skylineRadius: skylineRadius,
      lineWidth: lineWidth,
      skylineColor: skylineColor,
      skyBodyColor: skyBodyColor,
      barrierColor: barrierColor,
      highlightBarrier: highlightBarrier,
      getSkyline2d: getSkyline2d,
      skyLineAnalysis: skyLineAnalysis,
      setLimitBody: setLimitBody,
      clear: clear,
      echarts_box: echarts_box,
      skylineMode: skylineMode,
      ignoreGlobe: ignoreGlobe
    };
  }
};

var _hoisted_1 = {
  id: "skyLine-panel",
  "class": "sm-panel"
};
var _hoisted_2 = {
  "class": "sm-function-module-sub-section",
  style: {
    "margin": "0"
  }
};
var _hoisted_3 = {
  "class": "sm-half-L"
};
var _hoisted_4 = {
  style: {
    "width": "35%"
  }
};
var _hoisted_5 = {
  selected: "",
  value: "0"
};
var _hoisted_6 = {
  value: "1"
};
var _hoisted_7 = {
  value: "2"
};
var _hoisted_8 = {
  "class": "sm-half-L"
};
var _hoisted_9 = {
  style: {
    "width": "35%"
  }
};
var _hoisted_10 = {
  "class": "sm-half-L"
};
var _hoisted_11 = {
  style: {
    "width": "35%"
  }
};
var _hoisted_12 = {
  "class": "sm-half-L"
};
var _hoisted_13 = {
  style: {
    "width": "35%"
  }
};
var _hoisted_14 = {
  "class": "sm-half-L"
};
var _hoisted_15 = {
  style: {
    "width": "35%"
  }
};
var _hoisted_16 = {
  "class": "sm-half-L"
};
var _hoisted_17 = {
  style: {
    "width": "35%"
  }
};
var _hoisted_18 = {
  "class": "sm-half-L"
};
var _hoisted_19 = {
  style: {
    "width": "auto"
  }
};
var _hoisted_20 = {
  style: {
    "width": "auto"
  }
};
var _hoisted_21 = {
  "class": "sm-half-L flex-start"
};
var _hoisted_22 = {
  "class": "boxchild"
};
var _hoisted_23 = {
  ref: "echarts_box",
  id: "echarts_box"
};
function render(_ctx, _cache, $props, $setup, $data, $options) {
  var _component_el_slider = resolveComponent("el-slider");

  var _component_el_color_picker = resolveComponent("el-color-picker");

  var _directive_stopdrag = resolveDirective("stopdrag");

  var _directive_drag = resolveDirective("drag");

  return openBlock(), createElementBlock(Fragment, null, [withDirectives((openBlock(), createElementBlock("div", _hoisted_1, [withDirectives((openBlock(), createElementBlock("div", _hoisted_2, [createElementVNode("div", _hoisted_3, [createElementVNode("label", _hoisted_4, toDisplayString(_ctx.Resource.displayMode), 1
  /* TEXT */
  ), withDirectives(createElementVNode("select", {
    "class": "sm-select",
    style: {
      "width": "63%"
    },
    "onUpdate:modelValue": _cache[0] || (_cache[0] = function ($event) {
      return $setup.skylineMode = $event;
    })
  }, [createElementVNode("option", _hoisted_5, toDisplayString(_ctx.Resource.polylineShow), 1
  /* TEXT */
  ), createElementVNode("option", _hoisted_6, toDisplayString(_ctx.Resource.polygonShow), 1
  /* TEXT */
  ), createElementVNode("option", _hoisted_7, toDisplayString(_ctx.Resource.bodyShow), 1
  /* TEXT */
  )], 512
  /* NEED_PATCH */
  ), [[vModelSelect, $setup.skylineMode]])]), createElementVNode("div", _hoisted_8, [createElementVNode("label", _hoisted_9, toDisplayString(_ctx.Resource.skylineRadius), 1
  /* TEXT */
  ), withDirectives(createElementVNode("input", {
    type: "number",
    "class": "sm-input",
    style: {
      "width": "63%"
    },
    "onUpdate:modelValue": _cache[1] || (_cache[1] = function ($event) {
      return $setup.skylineRadius = $event;
    })
  }, null, 512
  /* NEED_PATCH */
  ), [[vModelText, $setup.skylineRadius]])]), createElementVNode("div", _hoisted_10, [createElementVNode("label", _hoisted_11, toDisplayString(_ctx.Resource.lineWidth), 1
  /* TEXT */
  ), createVNode(_component_el_slider, {
    modelValue: $setup.lineWidth,
    "onUpdate:modelValue": _cache[2] || (_cache[2] = function ($event) {
      return $setup.lineWidth = $event;
    }),
    min: 1,
    step: 1,
    max: 10,
    "input-size": "mini",
    debounce: 500,
    "tooltip-class": "tooltip-class",
    style: {
      "width": "63%"
    }
  }, null, 8
  /* PROPS */
  , ["modelValue"])]), createElementVNode("div", _hoisted_12, [createElementVNode("label", _hoisted_13, toDisplayString(_ctx.Resource.skylineColor), 1
  /* TEXT */
  ), createVNode(_component_el_color_picker, {
    modelValue: $setup.skylineColor,
    "onUpdate:modelValue": _cache[3] || (_cache[3] = function ($event) {
      return $setup.skylineColor = $event;
    }),
    size: "mini",
    "show-alpha": "",
    style: {
      "width": "63%"
    }
  }, null, 8
  /* PROPS */
  , ["modelValue"])]), createElementVNode("div", _hoisted_14, [createElementVNode("label", _hoisted_15, toDisplayString(_ctx.Resource.skyBodyColor), 1
  /* TEXT */
  ), createVNode(_component_el_color_picker, {
    modelValue: $setup.skyBodyColor,
    "onUpdate:modelValue": _cache[4] || (_cache[4] = function ($event) {
      return $setup.skyBodyColor = $event;
    }),
    size: "mini",
    "show-alpha": "",
    style: {
      "width": "63%"
    }
  }, null, 8
  /* PROPS */
  , ["modelValue"])]), createElementVNode("div", _hoisted_16, [createElementVNode("label", _hoisted_17, toDisplayString(_ctx.Resource.barrierColor), 1
  /* TEXT */
  ), createVNode(_component_el_color_picker, {
    modelValue: $setup.barrierColor,
    "onUpdate:modelValue": _cache[5] || (_cache[5] = function ($event) {
      return $setup.barrierColor = $event;
    }),
    size: "mini",
    "show-alpha": "",
    style: {
      "width": "63%"
    }
  }, null, 8
  /* PROPS */
  , ["modelValue"])]), createElementVNode("div", _hoisted_18, [createElementVNode("label", _hoisted_19, [withDirectives(createElementVNode("input", {
    type: "checkbox",
    "onUpdate:modelValue": _cache[6] || (_cache[6] = function ($event) {
      return $setup.getSkyline2d = $event;
    })
  }, null, 512
  /* NEED_PATCH */
  ), [[vModelCheckbox, $setup.getSkyline2d]]), createTextVNode(" " + toDisplayString(_ctx.Resource.graphDisplay), 1
  /* TEXT */
  )]), createElementVNode("label", _hoisted_20, [withDirectives(createElementVNode("input", {
    type: "checkbox",
    "onUpdate:modelValue": _cache[7] || (_cache[7] = function ($event) {
      return $setup.highlightBarrier = $event;
    })
  }, null, 512
  /* NEED_PATCH */
  ), [[vModelCheckbox, $setup.highlightBarrier]]), createTextVNode(" " + toDisplayString(_ctx.Resource.highlightBarrier), 1
  /* TEXT */
  )])]), createElementVNode("div", _hoisted_21, [withDirectives(createElementVNode("input", {
    checked: "",
    type: "checkbox",
    "onUpdate:modelValue": _cache[8] || (_cache[8] = function ($event) {
      return $setup.ignoreGlobe = $event;
    })
  }, null, 512
  /* NEED_PATCH */
  ), [[vModelCheckbox, $setup.ignoreGlobe]]), createElementVNode("label", null, toDisplayString(_ctx.Resource.ignoreGlobe), 1
  /* TEXT */
  )]), createElementVNode("div", _hoisted_22, [createElementVNode("button", {
    "class": "tbtn",
    type: "button",
    onClick: _cache[9] || (_cache[9] = function () {
      return $setup.skyLineAnalysis && $setup.skyLineAnalysis.apply($setup, arguments);
    })
  }, toDisplayString(_ctx.Resource.analyze), 1
  /* TEXT */
  ), createElementVNode("button", {
    "class": "tbtn tbtn-margin-left",
    type: "button ",
    onClick: _cache[10] || (_cache[10] = function () {
      return $setup.setLimitBody && $setup.setLimitBody.apply($setup, arguments);
    })
  }, toDisplayString(_ctx.Resource.limitBody), 1
  /* TEXT */
  ), createElementVNode("button", {
    onClick: _cache[11] || (_cache[11] = function () {
      return $setup.clear && $setup.clear.apply($setup, arguments);
    }),
    "class": "tbtn tbtn-margin-left",
    type: "button"
  }, toDisplayString(_ctx.Resource.clear), 1
  /* TEXT */
  )])])), [[_directive_stopdrag]])])), [[_directive_drag]]), withDirectives(createElementVNode("div", _hoisted_23, null, 512
  /* NEED_PATCH */
  ), [[vShow, $setup.getSkyline2d]])], 64
  /* STABLE_FRAGMENT */
  );
}

script.render = render;
script.__file = "src/components/analysis_3d/sky-line/sky-line.vue";

script.install = function (app) {
  app.component(script.name, script);
};

export default script;
