import { reactive, toRefs, watch, onBeforeUnmount, resolveComponent, resolveDirective, openBlock, createElementBlock, Fragment, withDirectives, createElementVNode, toDisplayString, createVNode, createCommentVNode, renderList, vModelSelect, vShow } from 'vue';

function _typeof(obj) {
  "@babel/helpers - typeof";

  if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
    _typeof = function (obj) {
      return typeof obj;
    };
  } else {
    _typeof = function (obj) {
      return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
    };
  }

  return _typeof(obj);
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);

  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    if (enumerableOnly) symbols = symbols.filter(function (sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    });
    keys.push.apply(keys, symbols);
  }

  return keys;
}

function _objectSpread2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};

    if (i % 2) {
      ownKeys(Object(source), true).forEach(function (key) {
        _defineProperty(target, key, source[key]);
      });
    } else if (Object.getOwnPropertyDescriptors) {
      Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
      ownKeys(Object(source)).forEach(function (key) {
        Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
      });
    }
  }

  return target;
}

function _toConsumableArray(arr) {
  return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread();
}

function _arrayWithoutHoles(arr) {
  if (Array.isArray(arr)) return _arrayLikeToArray(arr);
}

function _iterableToArray(iter) {
  if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter);
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

  return arr2;
}

function _nonIterableSpread() {
  throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

/*
* 常用工具类
*/
//axios本版本不支持jsonp
var axiosJsonp = function axiosJsonp(url) {
  if (!url) {
    console.error('Axios.JSONP 至少需要一个url参数!');
    return;
  }

  return new Promise(function (resolve, reject) {
    window.jsonCallBack = function (result) {
      resolve(result);
    };

    var JSONP = document.createElement("script");
    JSONP.type = "text/javascript";
    JSONP.src = "".concat(url, "&callback=jsonCallBack");
    document.getElementsByTagName("head")[0].appendChild(JSONP);
    setTimeout(function () {
      document.getElementsByTagName("head")[0].removeChild(JSONP);
    }, 500);
  });
}; //判断两数组或对象相等


var isEqualArr = function isEqualArr(arg1, arg2) {
  if (!arg1 || !arg2) return true;
  var bol = true;

  if (Object.keys(arg1).length != Object.keys(arg2).length) {
    return false;
  }

  for (var key in arg1) {
    if (_typeof(arg1[key]) == 'object') {
      bol = isSame(arg1[key], arg2[key]);

      if (!bol) {
        break;
      }
    } else if (arg1[key] != arg2[key]) {
      bol = false;
      break;
    }
  }

  return bol;
}; //坐标转化
//笛卡尔转经纬度


var CartesiantoDegrees = function CartesiantoDegrees(Cartesians) {
  var array = [].concat(Cartesians);
  var positions = [];

  for (var i = 0, len = array.length; i < len; i++) {
    var cartographic = Cesium.Cartographic.fromCartesian(array[i]);
    var longitude = Cesium.Math.toDegrees(cartographic.longitude);
    var latitude = Cesium.Math.toDegrees(cartographic.latitude);
    var h = cartographic.height;

    if (positions.indexOf(longitude) == -1 && positions.indexOf(latitude) == -1) {
      positions.push(longitude);
      positions.push(latitude);
      positions.push(h);
    }
  }

  return positions;
}; //笛卡尔转经纬度(每个点是独立的对象)


var CartesiantoDegreesObjs = function CartesiantoDegreesObjs(Cartesians) {
  var array = [].concat(Cartesians);
  var positions = [];

  for (var i = 0, len = array.length; i < len; i++) {
    var cartographic = Cesium.Cartographic.fromCartesian(array[i]);
    var obj = {
      longitude: Cesium.Math.toDegrees(cartographic.longitude),
      latitude: Cesium.Math.toDegrees(cartographic.latitude),
      height: cartographic.height
    };
    positions.push(obj);
  }

  return positions;
}; // 弧度转经纬度


var CartographictoDegrees = function CartographictoDegrees(wgsPosition) {
  var longitude = Cesium.Math.toDegrees(wgsPosition.longitude);
  var latitude = Cesium.Math.toDegrees(wgsPosition.latitude);
  var height = wgsPosition.height;
  return [longitude, latitude, height];
}; //去重函数  数组


var unique = function unique(arr) {
  var res = [];
  var json = {};

  for (var i = 0; i < arr.length; i++) {
    if (!json[arr[i]]) {
      res.push(arr[i]);
      json[arr[i]] = 1;
    }
  }

  return res;
}; // 获取渐变色函数


function gradientColors(start, end, steps, gamma) {
  var i,
      j,
      ms,
      me,
      output = [],
      so = [];
  gamma = gamma || 1;

  var normalize = function normalize(channel) {
    return Math.pow(channel / 255, gamma);
  };

  start = parseColor(start).map(normalize);
  end = parseColor(end).map(normalize);

  for (i = 0; i < steps; i++) {
    ms = i / (steps - 1);
    me = 1 - ms;

    for (j = 0; j < 3; j++) {
      so[j] = pad(Math.round(Math.pow(start[j] * me + end[j] * ms, 1 / gamma) * 255).toString(16));
    }

    output.push('#' + so.join(''));
  }

  return output;

  function parseColor(hexStr) {
    return hexStr.length === 4 ? hexStr.substr(1).split('').map(function (s) {
      return 0x11 * parseInt(s, 16);
    }) : [hexStr.substr(1, 2), hexStr.substr(3, 2), hexStr.substr(5, 2)].map(function (s) {
      return parseInt(s, 16);
    });
  }

  function pad(s) {
    return s.length === 1 ? '0' + s : s;
  }
}

function getAngleAndRadian(pointA, pointB) {
  //建立以点A为原点，X轴为east,Y轴为north,Z轴朝上的坐标系
  var transform = Cesium.Transforms.eastNorthUpToFixedFrame(pointA); //向量AB

  var positionvector = Cesium.Cartesian3.subtract(pointB, pointA, new Cesium.Cartesian3()); //因transform是将A为原点的eastNorthUp坐标系中的点转换到世界坐标系的矩阵
  //AB为世界坐标中的向量
  //因此将AB向量转换为A原点坐标系中的向量，需乘以transform的逆矩阵。

  var vector = Cesium.Matrix4.multiplyByPointAsVector(Cesium.Matrix4.inverse(transform, new Cesium.Matrix4()), positionvector, new Cesium.Cartesian3()); //归一化

  var direction = Cesium.Cartesian3.normalize(vector, new Cesium.Cartesian3()); //heading

  var heading1 = Math.atan2(direction.y, direction.x) - Cesium.Math.PI_OVER_TWO;
  var radian = Cesium.Math.TWO_PI - Cesium.Math.zeroToTwoPi(heading1);
  var angle = radian * (180 / Math.PI);

  if (angle < 0) {
    angle = angle + 360;
  }

  return {
    angle: angle,
    radian: radian
  };
}

function getPitch(pointA, pointB) {
  var transfrom = Cesium.Transforms.eastNorthUpToFixedFrame(pointA);
  var vector = Cesium.Cartesian3.subtract(pointB, pointA, new Cesium.Cartesian3());
  var direction = Cesium.Matrix4.multiplyByPointAsVector(Cesium.Matrix4.inverse(transfrom, transfrom), vector, vector);
  Cesium.Cartesian3.normalize(direction, direction); //因为direction已归一化，斜边长度等于1，所以余弦函数等于direction.z

  var radian = Cesium.Math.PI_OVER_TWO - Cesium.Math.acosClamped(direction.z);
  var angle = radian * (180 / Math.PI);

  if (angle < 0) {
    angle = angle + 360;
  }

  return {
    angle: angle,
    radian: radian
  };
}

var tool = {
  axiosJsonp: axiosJsonp,
  isEqualArr: isEqualArr,
  CartesiantoDegrees: CartesiantoDegrees,
  CartesiantoDegreesObjs: CartesiantoDegreesObjs,
  unique: unique,
  gradientColors: gradientColors,
  getAngleAndRadian: getAngleAndRadian,
  CartographictoDegrees: CartographictoDegrees,
  getPitch: getPitch
};

var ResourceCN = {
  showRenderLoopErrors: '渲染时发生错误，已停止渲染。',
  AttributeError: '该组件props没有这个属性：',
  NoPickPositionSupported: "不支持深度纹理,无法绘制多边形，地形操作功能无法使用！",
  NoTerrain: "请在地形里使用地形组件！",
  initViewerWarn: '请先初始化viewer!',
  MoveMouseHeightBox: '点击鼠标左键结束矩形绘制，移动鼠标绘制box高度',
  RightClickEndDrawing: '右键单击结束绘制',
  LeftClickBottomBox: '点击鼠标左键，开始绘制矩形作为box底面',
  ClickModelAddBox: '点击模型，添加裁剪盒子',
  SkyLineWarn: "获取天际线体前，请先绘制天际线！",
  SkyLineBody: '天际线体',
  ShadowqueryWarn: "此操作需要先开启阴影！",
  VeiwshedBody: '可视体',
  VeiwshedBodyHidden: '不可视体',
  EchartsErr: "二维显示需要echarts支持，未找到相关依赖！",
  BaseMapImg: '底图',
  tip1: '<p>点击左键确定操作区域中间点</p><p>右键单击结束绘制</p>'
};

// 组件内部的语言资源：主要包括提示信息
var currentLanguage, Resource;
var cookieLanguage = getLang().toLowerCase();

function getLang() {
  //浏览器语言  IE用browserLanguage，非IE使用language进行判断
  var lang = (navigator.language || navigator.browserLanguage).toLowerCase();
  window.lang = lang; //判断portal设置语言 通过cookie获取
  //   const cookies = document.cookie.split(';');
  //   if (cookies.length > 0) {
  //     cookies.forEach(function (cookie) {
  //       const arr = cookie.split('=');
  //       if (arr[0].toLowerCase().trim() === 'language') {
  //         lang = arr[1];
  //         return;
  //       }
  //     });
  //   }

  return lang;
}

if (cookieLanguage !== undefined) {
  currentLanguage = cookieLanguage;
} else {
  currentLanguage = (navigator.language || navigator.browserLanguage).toLowerCase(); // 获取当前浏览器的语言
}

if (currentLanguage.startsWith('zh')) {
  Resource = ResourceCN;
} else if (currentLanguage.startsWith('ja')) {
  Resource = ResourceCN;
} else {
  Resource = ResourceCN;
}

var resource = Resource;

// 创建一个简单的store状态管理

var storeState = reactive({
  isViewer: false,
  //viewer初始化标志
  changeLayers: 0,
  //图层改变加载完毕监听
  changeGeometrys: 0 //三维分析体改变标志

});

var storeDate = {
  geometrys: {},
  //存储当前存在的三位空间查询体：如天际线体，可视域体
  layers: null
};

function createTooltip(frameDiv) {
  var tooltip = function tooltip(frameDiv) {
    var div = document.createElement('DIV');
    div.className = "tooltip";
    this._div = div;
    this.message = '';
    frameDiv.appendChild(div);
  };

  tooltip.prototype.setVisible = function (visible) {
    if (visible) {
      this._div.style.right = '10px';
    } else {
      this._div.style.right = '-300px';
    }
  };

  tooltip.prototype.showAt = function (message, top) {
    //top:200px => string
    if (top) {
      this._div.style.top = top;
    }

    if (message) {
      this.setVisible(true);
      this._div.innerHTML = message;
    }
  };

  return new tooltip(frameDiv);
}

function spatialQuery3d(props) {
  // 设置默认值数据
  var state = reactive({
    layerNames: [],
    //当前存在的可选择图层
    selectedLayerName: null,
    //默认选择图层名称
    scale: 3,
    //缩放
    positionMode: "intersects",
    //位置模式
    Xpitch: 0,
    //x旋转
    Yroll: 0,
    //y旋转
    Zheading: 0,
    //z旋转
    geometryType: "box",
    //选择模型类型
    drawType: "Fill_And_WireFrame",
    //模型显示类型
    FillColor: "rgba(255,251,25,0.3)",
    //模型填充颜色
    WireFrameColor: "rgba(255,255,0,1)",
    // 模型线框颜色
    searchColor: "rgba(255, 186, 1, 1)",
    //查询结果颜色
    GeometryBodyNames: [],
    //场景存在的天际线体对象等存在的数组
    //默认geometry参数
    boxParameters: [100, 100, 100],
    sphereParameters: [100],
    coneParameters: [100, 200],
    cylinderParameters: [100, 100, 200],
    ellicpseParameters: [100, 50, 50],
    rotateOrigin: null,
    showTable: false,
    //属性查询表格显示
    atributesData: [],
    //属性查询值
    selectIds: [] //表格id选中

  }); // 传入props改变默认值

  if (props) {
    for (var key in props) {
      if (state.hasOwnProperty(key)) {
        if (props[key] != undefined) state[key] = props[key];
      } else {
        tool.Message.errorMsg(resource.AttributeError + key);
      }
    }
  } // 初始化数据


  var scene,
      tipFlag = true;
  var layers, spatialQuery;
  var geometry,
      GeometryBodys = [];
  var s3mInstanceColc;

  if (storeState.isViewer) {
    if (!window.tooltip) {
      window.tooltip = createTooltip(viewer._element);
    }

    init();
  } //viewer 初始化完成的监听


  watch(function () {
    return storeState.isViewer;
  }, function (val) {
    if (val) {
      if (!window.tooltip) {
        window.tooltip = createTooltip(viewer._element);
      }

      init();
    }
  }); //监听图层加载完成

  watch(function () {
    return storeState.changeLayers;
  }, function (val) {
    getLayerNames();
  });

  if (storeState.changeGeometrys) {
    setGeometryBodys();
  } //监听场景存在其他三维体


  watch(function () {
    return storeState.changeGeometrys;
  }, function (val) {
    setGeometryBodys();
  });

  function setGeometryBodys() {
    state.GeometryBodyNames = [];
    GeometryBodys = [];

    if (storeDate.geometrys) {
      for (var _key in storeDate.geometrys) {
        GeometryBodys.push(_key);
        var name = storeDate.geometrys[_key].name;

        if (!state.GeometryBodyNames.includes(name)) {
          state.GeometryBodyNames.push(name);
        }
      }
    }

    if (state.GeometryBodyNames.length === 0) {
      if (props && props.geometryType) {
        state.geometryType = props.geometryType;
      } else {
        state.geometryType = 'box';
      }
    }
  }

  function init() {
    scene = viewer.scene;
    layers = viewer.scene.layers.layerQueue;
    spatialQuery = new Cesium.SpatialQuery3D(scene);
    spatialQuery.outlineColor = Cesium.Color.fromCssColorString(state.WireFrameColor);
    spatialQuery.fillColor = Cesium.Color.fromCssColorString(state.FillColor);
    spatialQuery.fillStyle = Cesium.FillStyle[state.drawType];
    getGeometry(state.geometryType);
    getPositionMode(state.positionMode);
    spatialQuery.build();
    setTimeout(function () {
      if (state.layerNames.length === 0) {
        getLayerNames();
      }
    }, 1000);
    s3mInstanceColc = new Cesium.S3MInstanceCollection(scene._context);
    viewer.scene.primitives.add(s3mInstanceColc);
  }

  function getLayerNames() {
    var layer = getLayer(state.selectedLayerName);

    if (spatialQuery && spatialQuery.layers) {
      spatialQuery.layers = layer ? [layer] : [];
    }

    state.layerNames.length = 0;

    if (layers && layers.length > 0) {
      layers.forEach(function (element, index) {
        if (!state.layerNames.includes(element._name)) {
          state.layerNames.push(element._name);
        }
      });

      if (!state.selectedLayerName) {
        state.selectedLayerName = state.layerNames[0];
      }
    }
  }
  /*
   ***分析模块***
  */
  //分析


  function analysis() {
    try {
      var layer = getLayer(state.selectedLayerName);

      if (!layer) {
        tool.Message.warnMsg('请选择需要查询的图层！');
        return;
      }

      spatialQuery.layers = [layer];
      tooltip.setVisible(false);
      layer.selectedColor = Cesium.Color.fromCssColorString(state.searchColor);
      layer.selectColorType = Cesium.SelectColorType.REPLACE;
      layer.selectEnabled = false;

      if (typeof state.geometryType === 'number') {
        //三维体查询,目前只支持这两种
        getGeometry(state.geometryType);
        spatialQuery.build();
        return;
      }

      spatialQuery.build();
      viewer.enableCursorStyle = false;
      viewer._element.style.cursor = "";
      document.body.classList.add("measureCur");

      if (tipFlag) {
        //只提示一次
        window.tooltip.showAt(' <p>点击鼠标左键确认查询位置</p>', '300px');
        tipFlag = false;
      } //鼠标左键事件监听


      viewer.eventManager.addEventListener("CLICK", LEFT_CLICK, true);
    } catch (err) {
      console.error(err);
    }
  }

  function LEFT_CLICK(e) {
    document.body.classList.remove("measureCur"); // 获取鼠标点击的笛卡尔坐标

    var cartesian = scene.pickPosition(e.message.position);
    var position = tool.CartesiantoDegrees(cartesian); // 将获取的点的位置转化成经纬度

    setPosition(position); // let h = position[2] + 60;
    // addModel(Cesium.Cartesian3.fromDegrees(position[0], position[1], h)); //添加编辑模型

    tooltip.setVisible(false);
    viewer.eventManager.removeEventListener("CLICK", LEFT_CLICK); //移除鼠标点击事件监听

    setTimeout(function () {
      getAtributes();
    }, 1000);
  }

  function getLayer(layerName) {
    return layers.find(function (item, index) {
      return item._name === layerName;
    });
  }

  function getQueryIDs() {
    return spatialQuery.getQueryIDs();
  }

  function getGeometry(geometryType) {
    switch (geometryType) {
      case "box":
        {
          var p = state.boxParameters;
          geometry = new Cesium.GeoBox(p[0], p[1], p[2]);
        }
        break;

      case "sphere":
        {
          var _p = state.sphereParameters;
          geometry = new Cesium.GeoSphere(_p[0]);
        }
        break;

      case "cone":
        {
          var _p2 = state.coneParameters;
          geometry = new Cesium.GeoCone(_p2[0], _p2[1]);

          if (state.rotateOrigin) {
            geometry.rotateOrigin = getRotateOrigin();
          }
        }
        break;

      case "cylinder":
        {
          var _p3 = state.cylinderParameters;
          geometry = new Cesium.GeoCylinder(_p3[0], _p3[1], _p3[2]);
        }
        break;

      case "ellicpse":
        {
          var _p4 = state.ellicpseParameters;
          geometry = new Cesium.GeoEllipsoid(_p4[0], _p4[1], _p4[2]);
        }
        break;

      default:
        {
          geometry = new Cesium.GeoModel3D();
          geometry.geoModel = storeDate.geometrys['SkyLineBody'];
          spatialQuery.clear();
        }
        break;
    }

    spatialQuery.geometry = geometry;
  }

  function getRotateOrigin() {
    var r = state.rotateOrigin;

    if (r == "APEX") {
      return Cesium.RotationOrigin.APEX;
    } else {
      return Cesium.RotationOrigin.CENTER;
    }
  }

  function getPositionMode(positionMode) {
    var mode;

    switch (positionMode) {
      case "intersects":
        mode = Cesium.PositionMode.Intersects;
        break;

      case "disjoint":
        mode = Cesium.PositionMode.Disjoint;
        break;

      case "contains":
        mode = Cesium.PositionMode.Contains;
        break;

      default:
        mode = Cesium.PositionMode.Intersects;
        break;
    }

    spatialQuery.positionMode = mode;
  }

  function setPosition(newPosArr) {
    //传入经纬度数组
    if (spatialQuery && spatialQuery.geometry) {
      spatialQuery.geometry.geoPosition = new Cesium.Point3D(newPosArr[0], newPosArr[1], newPosArr[2]);
    }
  }

  var queryIDs = [];

  function getAtributes() {
    state.atributesData.length = 0;
    var selectLayer = getLayer(state.selectedLayerName);
    selectLayer.indexedDBSetting.isAttributesSave = true;
    var query = spatialQuery.getQueryIDs();
    queryIDs = query[0].ids;
    selectLayer.setSelection(queryIDs);
    if (query.length < 1) return;

    var _loop = function _loop(i) {
      selectLayer.getAttributesById(queryIDs[i]).then(function (data) {
        if (data) {
          console.log(data);
          delete data.Field_SmUserID;
          delete data.SmUserID;
          delete data.X;
          delete data.Y;
          delete data.Z;
          state.atributesData.push(data);
          if (i == queryIDs.length - 1) state.showTable = true;
        }
      });
    };

    for (var i = 0; i < queryIDs.length; i++) {
      _loop(i);
    }
  } // 清除


  function clear() {
    state.showTable = false;
    state.atributesData.length = 0;
    var layer = getLayer(state.selectedLayerName);
    layer.removeAllObjsColor();

    if (layer) {
      layer.selectedColor = new Cesium.Color(0.7, 0.7, 1, 1);
      layer.setSelection([]);
      layer.selectColorType = Cesium.SelectColorType.MIX;
    }

    spatialQuery.clear();
    tooltip.setVisible(false);
    document.body.classList.remove("measureCur");
    spatialQuery.geometry.geoPosition = new Cesium.Point3D(0, 0, 0);
    viewer.eventManager.removeEventListener("CLICK", LEFT_CLICK); //移除鼠标点击事件监听
  }

  watch(function () {
    return state.Xpitch;
  }, function (val) {
    if (val == "") return;
    geometry.geoRotationX = parseFloat(val);
  });
  watch(function () {
    return state.Yroll;
  }, function (val) {
    if (val == "") return;
    geometry.geoRotationY = parseFloat(val);
  });
  watch(function () {
    return state.Zheading;
  }, function (val) {
    if (val == "") return;
    geometry.geoRotationZ = parseFloat(val);
  });
  watch(function () {
    return state.scale;
  }, function (val) {
    if (val == "") return;
    geometry.geoScaleX = parseFloat(val);
    geometry.geoScaleY = parseFloat(val);
    geometry.geoScaleZ = parseFloat(val);
  });
  watch(function () {
    return state.positionMode;
  }, function (val) {
    if (val == "") return;
    getPositionMode(val);
    setTimeout(function () {
      return getAtributes();
    }, 1000);
  });
  watch(function () {
    return state.geometryType;
  }, function (val) {
    if (val === "") return;
    getGeometry(val);
  });
  watch(function () {
    return state.drawType;
  }, function (val) {
    if (val == "") return;
    spatialQuery.fillStyle = Cesium.FillStyle[val];
  });
  watch(function () {
    return state.FillColor;
  }, function (val) {
    if (val == "") return;
    spatialQuery.fillColor = Cesium.Color.fromCssColorString(val);
  });
  watch(function () {
    return state.WireFrameColor;
  }, function (val) {
    if (val == "") return;
    spatialQuery.outlineColor = Cesium.Color.fromCssColorString(val);
  });
  watch(function () {
    return state.searchColor;
  }, function (val) {
    if (val == "") return;
    getLayer(state.selectedLayerName).selectedColor = Cesium.Color.fromCssColorString(val);
  });
  watch(function () {
    return state.selectedLayerName;
  }, function (val, oldval) {
    var layer = getLayer(oldval);

    if (layer) {
      layer.selectedColor = new Cesium.Color(0.7, 0.7, 1, 1);
      layer.setSelection([]);
      layer.selectColorType = Cesium.SelectColorType.MIX;
    }

    clear();
  });
  watch(function () {
    return state.selectIds;
  }, function (val) {
    var layer = getLayer(state.selectedLayerName);
    var ids = []; // layer.removeAllObjsColor();

    layer.removeObjsColor(queryIDs);
    val.forEach(function (el) {
      if (el.SmID) ids.push(el.SmID);
    });

    var oldids = _toConsumableArray(queryIDs);

    oldids = oldids.filter(function (id) {
      return !ids.includes(Number(id));
    });
    layer.setSelection(oldids);
    layer.setObjsColor(ids, new Cesium.Color(221 / 255, 104 / 255, 219 / 255, 1));
  }); // 销毁

  onBeforeUnmount(function () {
    spatialQuery.destroy();
    spatialQuery = undefined;
    layers = undefined;
    geometry = undefined;
  });
  return _objectSpread2(_objectSpread2({}, toRefs(state)), {}, {
    setPosition: setPosition,
    getQueryIDs: getQueryIDs,
    analysis: analysis,
    clear: clear
  });
}

var script = {
  name: "Sm3dSpatialQuery3d",
  props: {
    //默认选择图层名称
    selectedLayerName: {
      type: String
    },
    //x旋转
    Xpitch: {
      type: Number
    },
    //y旋转
    Yroll: {
      type: Number
    },
    //z旋转
    Zheading: {
      type: Number
    },
    //缩放
    scale: {
      type: Number
    },
    //位置模式
    positionMode: {
      type: String
    },
    //选择模型类型
    geometryType: {
      type: String
    },
    //模型显示类型
    drawType: {
      type: String
    },
    //模型填充颜色
    FillColor: {
      type: String
    },
    //模型线框颜色
    WireFrameColor: {
      type: String
    },
    //查询结果颜色
    searchColor: {
      type: String
    },
    //设置长方体类型参数
    boxParameters: {
      type: Array
    },
    //设置球体类型参数
    sphereParameters: {
      type: Array
    },
    //设置圆锥类型参数
    coneParameters: {
      type: Array
    },
    //设置圆柱类型参数
    cylinderParameters: {
      type: Array
    },
    //设置椭圆类型参数
    ellicpseParameters: {
      type: Array
    },
    //圆锥绕点旋转方式
    rotateOrigin: {
      type: String
    },
    //表格选中id
    selectIds: {
      type: Array
    }
  },
  // components: {
  //   myTable
  // },
  setup: function setup(props) {
    var _spatialQuery3d = spatialQuery3d(props),
        scale = _spatialQuery3d.scale,
        selectedLayerName = _spatialQuery3d.selectedLayerName,
        layerNames = _spatialQuery3d.layerNames,
        positionMode = _spatialQuery3d.positionMode,
        GeometryBodyNames = _spatialQuery3d.GeometryBodyNames,
        geometryType = _spatialQuery3d.geometryType,
        analysis = _spatialQuery3d.analysis,
        clear = _spatialQuery3d.clear,
        FillColor = _spatialQuery3d.FillColor,
        WireFrameColor = _spatialQuery3d.WireFrameColor,
        searchColor = _spatialQuery3d.searchColor,
        showTable = _spatialQuery3d.showTable,
        atributesData = _spatialQuery3d.atributesData,
        selectIds = _spatialQuery3d.selectIds;

    function getIDs(ids) {
      selectIds.value = ids;
    }

    return {
      scale: scale,
      selectedLayerName: selectedLayerName,
      layerNames: layerNames,
      positionMode: positionMode,
      GeometryBodyNames: GeometryBodyNames,
      geometryType: geometryType,
      analysis: analysis,
      clear: clear,
      FillColor: FillColor,
      WireFrameColor: WireFrameColor,
      searchColor: searchColor,
      showTable: showTable,
      atributesData: atributesData,
      getIDs: getIDs
    };
  },
  data: function data() {
    return {
      tableData: [{
        date: "2016-05-03",
        name: "王小虎",
        province: "上海",
        city: "普陀区",
        address: "上海市普陀区金沙江路 1518 弄",
        zip: 200333,
        zip2: 200333,
        zip3: 200333,
        zip4: 200333,
        zip5: 200333,
        zip6: 200333,
        zip7: 200333,
        zip8: 200333
      }, {
        date: "2016-05-02",
        name: "王小虎",
        province: "上海",
        city: "普陀区",
        address: "上海市普陀区金沙江路 1518 弄",
        zip: 200333
      }, {
        date: "2016-05-04",
        name: "王小虎",
        province: "上海",
        city: "普陀区",
        address: "上海市普陀区金沙江路 1518 弄",
        zip: 200333
      }, {
        date: "2016-05-01",
        name: "王小虎",
        province: "上海",
        city: "普陀区",
        address: "上海市普陀区金沙江路 1518 弄",
        zip: 200333
      }, {
        date: "2016-05-08",
        name: "王小虎",
        province: "上海",
        city: "普陀区",
        address: "上海市普陀区金沙江路 1518 弄",
        zip: 200333
      }, {
        date: "2016-05-06",
        name: "王小虎",
        province: "上海",
        city: "普陀区",
        address: "上海市普陀区金沙江路 1518 弄",
        zip: 200333
      }, {
        date: "2016-05-07",
        name: "王小虎",
        province: "上海",
        city: "普陀区",
        address: "上海市普陀区金沙江路 1518 弄",
        zip: 200333
      }]
    };
  }
};

var _hoisted_1 = {
  id: "openness-panel",
  "class": "sm-panel"
};
var _hoisted_2 = {
  "class": "sm-function-module-sub-section",
  style: {
    "margin": "0"
  }
};
var _hoisted_3 = {
  "class": "sm-half-L"
};
var _hoisted_4 = {
  style: {
    "width": "40%"
  }
};
var _hoisted_5 = {
  "class": "sm-half-L"
};
var _hoisted_6 = {
  style: {
    "width": "40%"
  }
};
var _hoisted_7 = ["value"];
var _hoisted_8 = {
  "class": "sm-half-L"
};
var _hoisted_9 = {
  style: {
    "width": "40%"
  }
};
var _hoisted_10 = {
  value: "intersects"
};
var _hoisted_11 = {
  value: "disjoint"
};
var _hoisted_12 = {
  value: "contains"
};
var _hoisted_13 = {
  "class": "sm-half-L"
};
var _hoisted_14 = {
  style: {
    "width": "40%"
  }
};
var _hoisted_15 = {
  value: "box"
};
var _hoisted_16 = ["value"];
var _hoisted_17 = {
  "class": "sm-half-L"
};
var _hoisted_18 = {
  style: {
    "width": "40%"
  }
};
var _hoisted_19 = {
  "class": "sm-half-L"
};
var _hoisted_20 = {
  style: {
    "width": "40%"
  }
};
var _hoisted_21 = {
  "class": "sm-half-L"
};
var _hoisted_22 = {
  style: {
    "width": "40%"
  }
};
var _hoisted_23 = {
  "class": "boxchild"
};
function render(_ctx, _cache, $props, $setup, $data, $options) {
  var _component_el_slider = resolveComponent("el-slider");

  var _component_el_color_picker = resolveComponent("el-color-picker");

  var _directive_stopdrag = resolveDirective("stopdrag");

  var _directive_drag = resolveDirective("drag");

  return openBlock(), createElementBlock(Fragment, null, [withDirectives((openBlock(), createElementBlock("div", _hoisted_1, [withDirectives((openBlock(), createElementBlock("div", _hoisted_2, [createElementVNode("div", _hoisted_3, [createElementVNode("label", _hoisted_4, toDisplayString(_ctx.Resource.scale), 1
  /* TEXT */
  ), createVNode(_component_el_slider, {
    modelValue: $setup.scale,
    "onUpdate:modelValue": _cache[0] || (_cache[0] = function ($event) {
      return $setup.scale = $event;
    }),
    min: 0.2,
    max: 10,
    step: 0.2,
    "input-size": "mini",
    debounce: 500,
    "tooltip-class": "tooltip-class",
    style: {
      "width": "58%"
    }
  }, null, 8
  /* PROPS */
  , ["modelValue", "min", "step"]), createCommentVNode(" <input class=\"sm-input-S\" min=\"1\" step=\"1\" type=\"number\" v-model=\"clipWidth\" /> ")]), createElementVNode("div", _hoisted_5, [createElementVNode("label", _hoisted_6, toDisplayString(_ctx.Resource.searchLayers), 1
  /* TEXT */
  ), withDirectives(createElementVNode("select", {
    "class": "sm-select",
    style: {
      "width": "58%"
    },
    "onUpdate:modelValue": _cache[1] || (_cache[1] = function ($event) {
      return $setup.selectedLayerName = $event;
    })
  }, [(openBlock(true), createElementBlock(Fragment, null, renderList($setup.layerNames, function (layer, index) {
    return openBlock(), createElementBlock("option", {
      key: index,
      value: layer
    }, toDisplayString(layer), 9
    /* TEXT, PROPS */
    , _hoisted_7);
  }), 128
  /* KEYED_FRAGMENT */
  ))], 512
  /* NEED_PATCH */
  ), [[vModelSelect, $setup.selectedLayerName]])]), createElementVNode("div", _hoisted_8, [createElementVNode("label", _hoisted_9, toDisplayString(_ctx.Resource.positionMode), 1
  /* TEXT */
  ), withDirectives(createElementVNode("select", {
    "class": "sm-select",
    style: {
      "width": "58%"
    },
    "onUpdate:modelValue": _cache[2] || (_cache[2] = function ($event) {
      return $setup.positionMode = $event;
    })
  }, [createElementVNode("option", _hoisted_10, toDisplayString(_ctx.Resource.intersects), 1
  /* TEXT */
  ), createElementVNode("option", _hoisted_11, toDisplayString(_ctx.Resource.disjoint), 1
  /* TEXT */
  ), createElementVNode("option", _hoisted_12, toDisplayString(_ctx.Resource.contains), 1
  /* TEXT */
  )], 512
  /* NEED_PATCH */
  ), [[vModelSelect, $setup.positionMode]])]), withDirectives(createElementVNode("div", _hoisted_13, [createElementVNode("label", _hoisted_14, toDisplayString(_ctx.Resource.geometryType), 1
  /* TEXT */
  ), withDirectives(createElementVNode("select", {
    "class": "sm-select",
    style: {
      "width": "58%"
    },
    "onUpdate:modelValue": _cache[3] || (_cache[3] = function ($event) {
      return $setup.geometryType = $event;
    })
  }, [createElementVNode("option", _hoisted_15, toDisplayString(_ctx.Resource.box), 1
  /* TEXT */
  ), (openBlock(true), createElementBlock(Fragment, null, renderList($setup.GeometryBodyNames, function (geometry, index) {
    return openBlock(), createElementBlock("option", {
      key: index,
      value: index
    }, toDisplayString(geometry), 9
    /* TEXT, PROPS */
    , _hoisted_16);
  }), 128
  /* KEYED_FRAGMENT */
  ))], 512
  /* NEED_PATCH */
  ), [[vModelSelect, $setup.geometryType]])], 512
  /* NEED_PATCH */
  ), [[vShow, $setup.GeometryBodyNames.length > 0]]), createElementVNode("div", _hoisted_17, [createElementVNode("label", _hoisted_18, toDisplayString(_ctx.Resource.modelFillColor), 1
  /* TEXT */
  ), createVNode(_component_el_color_picker, {
    modelValue: $setup.FillColor,
    "onUpdate:modelValue": _cache[4] || (_cache[4] = function ($event) {
      return $setup.FillColor = $event;
    }),
    size: "mini",
    "show-alpha": "",
    style: {
      "width": "58%"
    }
  }, null, 8
  /* PROPS */
  , ["modelValue"])]), createElementVNode("div", _hoisted_19, [createElementVNode("label", _hoisted_20, toDisplayString(_ctx.Resource.modelWireFrameColor), 1
  /* TEXT */
  ), createVNode(_component_el_color_picker, {
    modelValue: $setup.WireFrameColor,
    "onUpdate:modelValue": _cache[5] || (_cache[5] = function ($event) {
      return $setup.WireFrameColor = $event;
    }),
    size: "mini",
    "show-alpha": "",
    style: {
      "width": "58%"
    }
  }, null, 8
  /* PROPS */
  , ["modelValue"])]), createElementVNode("div", _hoisted_21, [createElementVNode("label", _hoisted_22, toDisplayString(_ctx.Resource.searchColor), 1
  /* TEXT */
  ), createVNode(_component_el_color_picker, {
    modelValue: $setup.searchColor,
    "onUpdate:modelValue": _cache[6] || (_cache[6] = function ($event) {
      return $setup.searchColor = $event;
    }),
    size: "mini",
    "show-alpha": "",
    style: {
      "width": "58%"
    }
  }, null, 8
  /* PROPS */
  , ["modelValue"])]), createElementVNode("div", _hoisted_23, [createElementVNode("button", {
    "class": "tbtn",
    type: "button",
    onClick: _cache[7] || (_cache[7] = function () {
      return $setup.analysis && $setup.analysis.apply($setup, arguments);
    })
  }, toDisplayString(_ctx.Resource.search), 1
  /* TEXT */
  ), createElementVNode("button", {
    onClick: _cache[8] || (_cache[8] = function () {
      return $setup.clear && $setup.clear.apply($setup, arguments);
    }),
    "class": "tbtn",
    style: {
      "margin-left": "4px"
    },
    type: "button"
  }, toDisplayString(_ctx.Resource.clear), 1
  /* TEXT */
  )])])), [[_directive_stopdrag]])])), [[_directive_drag]]), createCommentVNode(" <my-table :table-data=\"atributesData\" :show=\"showTable\" @get-ids=\"getIDs\" /> ")], 2112
  /* STABLE_FRAGMENT, DEV_ROOT_FRAGMENT */
  );
}

script.render = render;
script.__file = "src/components/space-search/spatial-query3d/spatial-query3d.vue";

script.install = function (app) {
  app.component(script.name, script);
};

export default script;
