import { reactive, toRefs, watch, onBeforeUnmount, resolveComponent, resolveDirective, withDirectives, openBlock, createElementBlock, createElementVNode, toDisplayString, createVNode, vShow, vModelCheckbox, createTextVNode } from 'vue';

function _typeof(obj) {
  "@babel/helpers - typeof";

  if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
    _typeof = function (obj) {
      return typeof obj;
    };
  } else {
    _typeof = function (obj) {
      return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
    };
  }

  return _typeof(obj);
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);

  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    if (enumerableOnly) symbols = symbols.filter(function (sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    });
    keys.push.apply(keys, symbols);
  }

  return keys;
}

function _objectSpread2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};

    if (i % 2) {
      ownKeys(Object(source), true).forEach(function (key) {
        _defineProperty(target, key, source[key]);
      });
    } else if (Object.getOwnPropertyDescriptors) {
      Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
      ownKeys(Object(source)).forEach(function (key) {
        Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
      });
    }
  }

  return target;
}

function _toConsumableArray(arr) {
  return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread();
}

function _arrayWithoutHoles(arr) {
  if (Array.isArray(arr)) return _arrayLikeToArray(arr);
}

function _iterableToArray(iter) {
  if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter);
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

  return arr2;
}

function _nonIterableSpread() {
  throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

/*
* 常用工具类
*/
//axios本版本不支持jsonp
var axiosJsonp = function axiosJsonp(url) {
  if (!url) {
    console.error('Axios.JSONP 至少需要一个url参数!');
    return;
  }

  return new Promise(function (resolve, reject) {
    window.jsonCallBack = function (result) {
      resolve(result);
    };

    var JSONP = document.createElement("script");
    JSONP.type = "text/javascript";
    JSONP.src = "".concat(url, "&callback=jsonCallBack");
    document.getElementsByTagName("head")[0].appendChild(JSONP);
    setTimeout(function () {
      document.getElementsByTagName("head")[0].removeChild(JSONP);
    }, 500);
  });
}; //判断两数组或对象相等


var isEqualArr = function isEqualArr(arg1, arg2) {
  if (!arg1 || !arg2) return true;
  var bol = true;

  if (Object.keys(arg1).length != Object.keys(arg2).length) {
    return false;
  }

  for (var key in arg1) {
    if (_typeof(arg1[key]) == 'object') {
      bol = isSame(arg1[key], arg2[key]);

      if (!bol) {
        break;
      }
    } else if (arg1[key] != arg2[key]) {
      bol = false;
      break;
    }
  }

  return bol;
}; //坐标转化
//笛卡尔转经纬度


var CartesiantoDegrees = function CartesiantoDegrees(Cartesians) {
  var array = [].concat(Cartesians);
  var positions = [];

  for (var i = 0, len = array.length; i < len; i++) {
    var cartographic = Cesium.Cartographic.fromCartesian(array[i]);
    var longitude = Cesium.Math.toDegrees(cartographic.longitude);
    var latitude = Cesium.Math.toDegrees(cartographic.latitude);
    var h = cartographic.height;

    if (positions.indexOf(longitude) == -1 && positions.indexOf(latitude) == -1) {
      positions.push(longitude);
      positions.push(latitude);
      positions.push(h);
    }
  }

  return positions;
}; //笛卡尔转经纬度(每个点是独立的对象)


var CartesiantoDegreesObjs = function CartesiantoDegreesObjs(Cartesians) {
  var array = [].concat(Cartesians);
  var positions = [];

  for (var i = 0, len = array.length; i < len; i++) {
    var cartographic = Cesium.Cartographic.fromCartesian(array[i]);
    var obj = {
      longitude: Cesium.Math.toDegrees(cartographic.longitude),
      latitude: Cesium.Math.toDegrees(cartographic.latitude),
      height: cartographic.height
    };
    positions.push(obj);
  }

  return positions;
}; // 弧度转经纬度


var CartographictoDegrees = function CartographictoDegrees(wgsPosition) {
  var longitude = Cesium.Math.toDegrees(wgsPosition.longitude);
  var latitude = Cesium.Math.toDegrees(wgsPosition.latitude);
  var height = wgsPosition.height;
  return [longitude, latitude, height];
}; //去重函数  数组


var unique = function unique(arr) {
  var res = [];
  var json = {};

  for (var i = 0; i < arr.length; i++) {
    if (!json[arr[i]]) {
      res.push(arr[i]);
      json[arr[i]] = 1;
    }
  }

  return res;
}; // 获取渐变色函数


function gradientColors(start, end, steps, gamma) {
  var i,
      j,
      ms,
      me,
      output = [],
      so = [];
  gamma = gamma || 1;

  var normalize = function normalize(channel) {
    return Math.pow(channel / 255, gamma);
  };

  start = parseColor(start).map(normalize);
  end = parseColor(end).map(normalize);

  for (i = 0; i < steps; i++) {
    ms = i / (steps - 1);
    me = 1 - ms;

    for (j = 0; j < 3; j++) {
      so[j] = pad(Math.round(Math.pow(start[j] * me + end[j] * ms, 1 / gamma) * 255).toString(16));
    }

    output.push('#' + so.join(''));
  }

  return output;

  function parseColor(hexStr) {
    return hexStr.length === 4 ? hexStr.substr(1).split('').map(function (s) {
      return 0x11 * parseInt(s, 16);
    }) : [hexStr.substr(1, 2), hexStr.substr(3, 2), hexStr.substr(5, 2)].map(function (s) {
      return parseInt(s, 16);
    });
  }

  function pad(s) {
    return s.length === 1 ? '0' + s : s;
  }
}

function getAngleAndRadian(pointA, pointB) {
  //建立以点A为原点，X轴为east,Y轴为north,Z轴朝上的坐标系
  var transform = Cesium.Transforms.eastNorthUpToFixedFrame(pointA); //向量AB

  var positionvector = Cesium.Cartesian3.subtract(pointB, pointA, new Cesium.Cartesian3()); //因transform是将A为原点的eastNorthUp坐标系中的点转换到世界坐标系的矩阵
  //AB为世界坐标中的向量
  //因此将AB向量转换为A原点坐标系中的向量，需乘以transform的逆矩阵。

  var vector = Cesium.Matrix4.multiplyByPointAsVector(Cesium.Matrix4.inverse(transform, new Cesium.Matrix4()), positionvector, new Cesium.Cartesian3()); //归一化

  var direction = Cesium.Cartesian3.normalize(vector, new Cesium.Cartesian3()); //heading

  var heading1 = Math.atan2(direction.y, direction.x) - Cesium.Math.PI_OVER_TWO;
  var radian = Cesium.Math.TWO_PI - Cesium.Math.zeroToTwoPi(heading1);
  var angle = radian * (180 / Math.PI);

  if (angle < 0) {
    angle = angle + 360;
  }

  return {
    angle: angle,
    radian: radian
  };
}

function getPitch(pointA, pointB) {
  var transfrom = Cesium.Transforms.eastNorthUpToFixedFrame(pointA);
  var vector = Cesium.Cartesian3.subtract(pointB, pointA, new Cesium.Cartesian3());
  var direction = Cesium.Matrix4.multiplyByPointAsVector(Cesium.Matrix4.inverse(transfrom, transfrom), vector, vector);
  Cesium.Cartesian3.normalize(direction, direction); //因为direction已归一化，斜边长度等于1，所以余弦函数等于direction.z

  var radian = Cesium.Math.PI_OVER_TWO - Cesium.Math.acosClamped(direction.z);
  var angle = radian * (180 / Math.PI);

  if (angle < 0) {
    angle = angle + 360;
  }

  return {
    angle: angle,
    radian: radian
  };
}

var tool = {
  axiosJsonp: axiosJsonp,
  isEqualArr: isEqualArr,
  CartesiantoDegrees: CartesiantoDegrees,
  CartesiantoDegreesObjs: CartesiantoDegreesObjs,
  unique: unique,
  gradientColors: gradientColors,
  getAngleAndRadian: getAngleAndRadian,
  CartographictoDegrees: CartographictoDegrees,
  getPitch: getPitch
};

var ResourceCN = {
  showRenderLoopErrors: '渲染时发生错误，已停止渲染。',
  AttributeError: '该组件props没有这个属性：',
  NoPickPositionSupported: "不支持深度纹理,无法绘制多边形，地形操作功能无法使用！",
  NoTerrain: "请在地形里使用地形组件！",
  initViewerWarn: '请先初始化viewer!',
  MoveMouseHeightBox: '点击鼠标左键结束矩形绘制，移动鼠标绘制box高度',
  RightClickEndDrawing: '右键单击结束绘制',
  LeftClickBottomBox: '点击鼠标左键，开始绘制矩形作为box底面',
  ClickModelAddBox: '点击模型，添加裁剪盒子',
  SkyLineWarn: "获取天际线体前，请先绘制天际线！",
  SkyLineBody: '天际线体',
  ShadowqueryWarn: "此操作需要先开启阴影！",
  VeiwshedBody: '可视体',
  VeiwshedBodyHidden: '不可视体',
  EchartsErr: "二维显示需要echarts支持，未找到相关依赖！",
  BaseMapImg: '底图',
  tip1: '<p>点击左键确定操作区域中间点</p><p>右键单击结束绘制</p>'
};

// 组件内部的语言资源：主要包括提示信息
var currentLanguage, Resource;
var cookieLanguage = getLang().toLowerCase();

function getLang() {
  //浏览器语言  IE用browserLanguage，非IE使用language进行判断
  var lang = (navigator.language || navigator.browserLanguage).toLowerCase();
  window.lang = lang; //判断portal设置语言 通过cookie获取
  //   const cookies = document.cookie.split(';');
  //   if (cookies.length > 0) {
  //     cookies.forEach(function (cookie) {
  //       const arr = cookie.split('=');
  //       if (arr[0].toLowerCase().trim() === 'language') {
  //         lang = arr[1];
  //         return;
  //       }
  //     });
  //   }

  return lang;
}

if (cookieLanguage !== undefined) {
  currentLanguage = cookieLanguage;
} else {
  currentLanguage = (navigator.language || navigator.browserLanguage).toLowerCase(); // 获取当前浏览器的语言
}

if (currentLanguage.startsWith('zh')) {
  Resource = ResourceCN;
} else if (currentLanguage.startsWith('ja')) {
  Resource = ResourceCN;
} else {
  Resource = ResourceCN;
}

var resource = Resource;

// 创建一个简单的store状态管理

var storeState = reactive({
  isViewer: false,
  //viewer初始化标志
  changeLayers: 0,
  //图层改变加载完毕监听
  changeGeometrys: 0 //三维分析体改变标志

});
var actions = {
  setIsViewer: function setIsViewer(newValue) {
    storeState.isViewer = newValue;
  },
  setChangeLayers: function setChangeLayers(newValue) {
    storeState.changeLayers += 1;
  },
  setGeometrys: function setGeometrys(newValue) {
    storeState.changeGeometrys += 1;
  }
}; // 全局公共数据

var storeDate = {
  geometrys: {},
  //存储当前存在的三位空间查询体：如天际线体，可视域体
  layers: null
};

//随鼠标移动消息提示工具
function createTooltip(frameDiv) {
  var tooltip = function tooltip(frameDiv) {
    var div = document.createElement("DIV");
    div.className = "twipsy right";
    var arrow = document.createElement("DIV");
    arrow.className = "twipsy-arrow";
    div.appendChild(arrow);
    var title = document.createElement("DIV");
    title.className = "twipsy-inner";
    div.appendChild(title);
    this._div = div;
    this._title = title;
    this.message = "";
    frameDiv.appendChild(div);
    var that = this;

    div.onmousemove = function (evt) {
      that.showAt({
        x: evt.clientX,
        y: evt.clientY
      }, that.message);
    };
  };

  tooltip.prototype.setVisible = function (visible) {
    this._div.style.display = visible ? "block" : "none";
  };

  tooltip.prototype.showAt = function (position, message) {
    if (position && message) {
      this.setVisible(true);
      this._title.innerHTML = message;
      this._div.style.left = position.x + 10 + "px";
      this._div.style.top = position.y - this._div.clientHeight / 2 + "px";
      this.message = message;
    }
  };

  return new tooltip(frameDiv);
}

/**
 * 初始化
 * DrawMode：类型
 * clampMode：模式
 */

var initHandler = function initHandler(DrawMode, clampMode) {
  var clampmode = 0;

  if (clampMode) {
    clampmode = clampMode;
  }

  switch (DrawMode) {
    case "Point":
      window.handlerPoint = new Cesium.DrawHandler(viewer, Cesium.DrawMode.Point);
      break;

    case "Polyline":
      window.handlerPolyline = new Cesium.DrawHandler(viewer, Cesium.DrawMode.Line, clampmode);
      break;

    case "Polygon":
      window.handlerPolygon = new Cesium.DrawHandler(viewer, Cesium.DrawMode.Polygon, clampmode);
      break;

    case "Marker":
      window.handlerMarker = new Cesium.DrawHandler(viewer, Cesium.DrawMode.Marker, clampmode);
      break;

    case "Box":
      window.handlerBox = new Cesium.DrawHandler(viewer, Cesium.DrawMode.Box, clampmode);
      break;
  }

  if (!window.tooltip) {
    window.tooltip = createTooltip(viewer._element);
  } // 半透线创建


  if (!window.polylineCollection) {
    window.polylineCollection = new Cesium.PolylineCollection({
      translucentRS: Cesium.RenderState.fromCache({
        depthMask: false,
        depthTest: {
          enabled: false
        }
      })
    });
    window.polylineTransparent = window.polylineCollection.add({
      width: 2,
      material: Cesium.Material.fromType(Cesium.Material.ColorType, {
        color: Cesium.Color.fromCssColorString("#51ff00").withAlpha(0.3)
      })
    });
    viewer.scene.primitives.add(window.polylineCollection);
  }
};
/**
 * 绘制
 * PolyType：类型 
 * lineVisib：绘制时是否显示绘制线（boolean）
 * toolTipObj：绘制时提示内容{beforeDrawing：绘制开始前提示(string)，isDrawing：正在绘制时提示,即绘制过程中（string）}
 */


var handlerDrawing = function handlerDrawing(PolyType, lineVisib, toolTipObj) {
  var lineVisible = true;

  if (lineVisib === false) {
    lineVisible = lineVisib;
  }

  var DrawHandler = judgeDrawHandlerType(PolyType); //获取操作对象

  return new Promise(function (resolve, reject) {
    //做一些异步操作
    var tooltip = window.tooltip;
    var clearActFn = DrawHandler.activeEvt.addEventListener(function (isActive) {
      if (isActive == true) {
        viewer.enableCursorStyle = false;
        viewer._element.style.cursor = '';

        if (PolyType == "Point" || PolyType == "Marker") {
          document.body.classList.add("measureCur");
        } else {
          document.body.classList.add("drawCur");
        }
      } else {
        viewer.enableCursorStyle = true;
        tooltip.setVisible(false);

        if (PolyType == "Point" || PolyType == "Marker") {
          document.body.classList.remove('measureCur');
        } else {
          document.body.classList.remove('drawCur');
        }
      }
    });
    var clearMovFn = DrawHandler.movingEvt.addEventListener(function (windowPosition) {
      if (windowPosition.x < 200 && windowPosition.y < 150) {
        tooltip.setVisible(false);
        return;
      }
      //     tooltip.showAt(windowPosition, tiptext);
      // } else if (toolTipObj && toolTipObj.beforeDrawing) {
      //     tooltip.showAt(windowPosition, toolTipObj.beforeDrawing);
      // }else if (DrawHandler.isDrawing && toolTipObj.isDrawing) {
      //     tooltip.showAt(windowPosition, toolTipObj.isDrawing);
      // }

      if (DrawHandler.polyline && DrawHandler.isDrawing) {
        var p = _toConsumableArray(DrawHandler.polyline.positions);

        if (PolyType == "Polygon") {
          //画面时，需要首尾相连
          p.push(p[0]);
        }
        window.polylineTransparent.show = true;
        window.polylineTransparent.positions = p;
      }
    });
    var clearDrawFn = DrawHandler.drawEvt.addEventListener(function (result) {
      if (!result.object.positions && PolyType != "Point" && PolyType != "Box") {
        tooltip.showAt(result, '<p>请绘制正确的多边形</p>');
        DrawHandler.polygon.show = false;
        DrawHandler.polyline.show = false;
        DrawHandler.deactivate();
        DrawHandler.activate();
        return;
      }

      if (PolyType == "Box") {
        resolve({
          result: result
        });
        return;
      }

      if (PolyType == "Point" || PolyType == "Marker") {
        DrawHandler.clear(); // 不显示绘制的点

        resolve({
          result: result
        });
      } else {
        //半透线
        window.polylineTransparent.show = lineVisible;

        if (lineVisible) {
          if (PolyType == "Polygon" && lineVisible) {
            DrawHandler.polygon._polygon._material._color._value.alpha = 0.1; //绘制面透明度

            var p2 = _toConsumableArray(result.object.positions); //画面时，需要首尾相连


            p2.push(p2[0]);
            window.polylineTransparent.positions = p2;
          }
        }

        var positions = CartesiantoDegrees(result.object.positions);
        resolve({
          result: result,
          positions: positions
        });
      }

      clearActFn();
      clearMovFn();
      clearDrawFn();
    });
  });
}; //清除


var clearHandlerDrawing = function clearHandlerDrawing(PolyType) {
  var DrawHandler;

  if (!PolyType) {
    DrawHandler = window.handlerPolygon;
  } else {
    DrawHandler = judgeDrawHandlerType(PolyType);
  }
  if (!DrawHandler) return;
  DrawHandler.deactivate();
  DrawHandler.clear();
  viewer.enableCursorStyle = true; // document.body.classList.remove("drawCur");
  // document.body.classList.remove("measureCur");

  window.tooltip.setVisible(false);

  if (window.polylineTransparent) {
    window.polylineTransparent.show = false;
  }
}; // 类型判断


var judgeDrawHandlerType = function judgeDrawHandlerType(PolyType) {
  var DrawHandler;

  switch (PolyType) {
    case "Point":
      DrawHandler = window.handlerPoint;
      break;

    case "Polyline":
      DrawHandler = window.handlerPolyline;
      break;

    case "Polygon":
      DrawHandler = window.handlerPolygon;
      break;

    case "Marker":
      DrawHandler = window.handlerMarker;
      break;

    case "Box":
      DrawHandler = window.handlerBox;
      break;
  }

  return DrawHandler;
};

function createTooltip$1(frameDiv) {
  var tooltip = function tooltip(frameDiv) {
    var div = document.createElement('DIV');
    div.className = "tooltip";
    this._div = div;
    this.message = '';
    frameDiv.appendChild(div);
  };

  tooltip.prototype.setVisible = function (visible) {
    if (visible) {
      this._div.style.right = '10px';
    } else {
      this._div.style.right = '-300px';
    }
  };

  tooltip.prototype.showAt = function (message, top) {
    //top:200px => string
    if (top) {
      this._div.style.top = top;
    }

    if (message) {
      this.setVisible(true);
      this._div.innerHTML = message;
    }
  };

  return new tooltip(frameDiv);
}

function viewshed(props) {
  // 设置默认值数据
  var state = reactive({
    viewshedSpatialUrl: "http://www.supermapol.com/realspace/services/spatialAnalysis-data_all/restjsr/spatialanalyst/geometry/3d/viewshedbody.json",
    observerInformation: null,
    //观察者信息
    direction: 1.0,
    //方向
    pitch: 1.0,
    //俯仰角度
    addheight: 1.8,
    //附加高度
    distance: 200,
    //距离
    verticalFov: 60,
    //  垂直视角
    horizontalFov: 90,
    //水平视角
    hintLineColor: "rgb(212,202,45)",
    //提示线颜色
    visibleAreaColor: "rgba(9,199,112,0.5)",
    //可视区域颜色
    hiddenAreaColor: "rgba(238,114,22,0.5)",
    //不可视区域颜色
    visibleBodyColor: "rgba(9,199,112,0.7)",
    //可视域体颜色
    invisibleBodyColor: "rgba(238,114,22,0.7)",
    //不可视域体颜色
    visibleBody: false,
    //显示可视域体
    invisibleBody: false,
    //显示不可视域体
    viewshedAnimation: false,
    //动画演示
    DynamicLine: [],
    //路线点
    DynamicSpeed: 10 //动态分析行进速度

  }); // 传入props改变默认值

  if (props) {
    for (var key in props) {
      if (state.hasOwnProperty(key)) {
        if (props[key] != undefined) state[key] = props[key];
      } else {
        tool.Message.errorMsg(resource.AttributeError + key);
      }
    }
  } // 初始化数据


  var viewshed3D, handler, s3mInstanceColc, scene, startPosition;
  var tipFlag = true;
  var Carurls = ['public/data/s3m/car1.s3m'],
      timers,
      dynamicLayer3D;

  if (storeState.isViewer) {
    if (!window.tooltip) {
      window.tooltip = createTooltip$1(viewer._element);
    }

    init();
  } //viewer 初始化完成的监听


  watch(function () {
    return storeState.isViewer;
  }, function (val) {
    if (val) {
      if (!window.tooltip) {
        window.tooltip = createTooltip$1(viewer._element);
      }

      init();
    }
  });

  function init() {
    scene = viewer.scene;
    viewshed3D = new Cesium.ViewShed3D(scene);
    handler = new Cesium.ScreenSpaceEventHandler(scene.canvas);
    viewshed3D.hintLineColor = Cesium.Color.fromCssColorString(state.hintLineColor);
    viewshed3D.visibleAreaColor = Cesium.Color.fromCssColorString(state.visibleAreaColor);
    viewshed3D.hiddenAreaColor = Cesium.Color.fromCssColorString(state.hiddenAreaColor);
    s3mInstanceColc = new Cesium.S3MInstanceCollection(scene._context);
    viewer.scene.primitives.add(s3mInstanceColc);
    dynamicLayer3D = new Cesium.DynamicLayer3D(scene.context, Carurls);
    dynamicLayer3D.updateInterval = 100;
    dynamicLayer3D.setCullEnabled(Carurls[0], Cesium.CullFace.BACK);
    dynamicLayer3D.maxVisibleAltitude = 2000;
    dynamicLayer3D.minVisibleAltitude = 0;
    scene.primitives.add(dynamicLayer3D);
  }
  /*
   ***分析模块***
  */
  //分析

  function analysis() {
    viewer.enableCursorStyle = false;
    viewer._element.style.cursor = "";
    document.body.classList.add("measureCur");

    if (state.viewshedAnimation) {
      if (timers) {
        clear();
        state.viewshedAnimation = true;
        document.body.classList.add("measureCur");
      }

      handlerPolyline();
    } else {
      if (tipFlag) {
        //只提示一次
        window.tooltip.showAt(' <p>点击鼠标左键确认观察者位置</p> <p>右键单击结束分析</p>', '450px');
        tipFlag = false;
      }

      LEFT_CLICK();
    }
  } //   点击左键确认观察者点


  function LEFT_CLICK() {
    s3mInstanceColc.removeCollection("VeiwshedBody");
    s3mInstanceColc.removeCollection("VeiwshedBodyHidden");
    viewshed3D.distance = 0.00001;
    viewshed3D.visibleAreaColor = Cesium.Color.fromCssColorString(state.visibleAreaColor);
    viewshed3D.hiddenAreaColor = Cesium.Color.fromCssColorString(state.hiddenAreaColor);
    handler.setInputAction(function (e) {
      var position = scene.pickPosition(e.position);
      startPosition = position; //记录分析观察者笛卡尔坐标

      var p = tool.CartesiantoDegrees(position); // 将获取的点的位置转化成经纬度

      p[2] += Number(state.addheight); //添加附加高度

      viewshed3D.viewPosition = p;
      viewshed3D.build(); // 观察者信息记录

      state.observerInformation = p;
      document.body.classList.remove("measureCur");
      removeInputAction('LEFT_CLICK');
      MOUSE_MOVE();
      RIGHT_CLICK(); // 添加观察者点

      var p2 = Cesium.Cartesian3.fromDegrees(p[0], p[1], p[2]);
      addPoint(p2);
    }, Cesium.ScreenSpaceEventType.LEFT_CLICK);
  }

  function addPoint(p) {
    viewer.entities.removeById('viewshedPoint');
    viewer.entities.add(new Cesium.Entity({
      id: 'viewshedPoint',
      point: new Cesium.PointGraphics({
        color: colorUpdate(state.hiddenAreaColor),
        pixelSize: 8
      }),
      position: p
    }));
  } // 鼠标移动实时分析


  function MOUSE_MOVE() {
    handler.setInputAction(function (e) {
      // tooltip.setVisible(false);
      //获取鼠标屏幕坐标,并将其转化成笛卡尔坐标
      var position = e.endPosition;
      var endPosition = scene.pickPosition(position); //计算该点与视口位置点坐标的距离

      var distance = Cesium.Cartesian3.distance(startPosition, endPosition);

      if (distance > 0) {
        var p2 = tool.CartesiantoDegrees(endPosition); // 将获取的点的位置转化成经纬度
        // 通过该点设置可视域分析对象的距离及方向

        viewshed3D.setDistDirByPoint(p2);
      }
    }, Cesium.ScreenSpaceEventType.MOUSE_MOVE);
  } // //鼠标右键确认分析距离和方向，不再执行鼠标移动事件中对可视域的操作


  function RIGHT_CLICK() {
    handler.setInputAction(function (e) {
      state.direction = viewshed3D.direction.toFixed(2);
      state.pitch = viewshed3D.pitch.toFixed(2);
      state.distance = viewshed3D.distance.toFixed(2);
      state.horizontalFov = viewshed3D.horizontalFov;
      state.verticalFov = viewshed3D.verticalFov;

      if (state.visibleBody) {
        getVisibleResult();
      }

      if (state.invisibleBody) {
        getInVisibleResult();
      }

      tooltip.setVisible(false);
      removeInputAction('MOUSE_MOVE');
      removeInputAction('RIGHT_CLICK');
    }, Cesium.ScreenSpaceEventType.RIGHT_CLICK);
  } //移除鼠标事件


  function removeInputAction(type) {
    switch (type) {
      case 'LEFT_CLICK':
        handler.removeInputAction(Cesium.ScreenSpaceEventType.LEFT_CLICK);
        break;

      case 'MOUSE_MOVE':
        handler.removeInputAction(Cesium.ScreenSpaceEventType.MOUSE_MOVE);
        break;

      case 'RIGHT_CLICK':
        handler.removeInputAction(Cesium.ScreenSpaceEventType.RIGHT_CLICK);
        break;

      case 'ALL':
      default:
        handler.removeInputAction(Cesium.ScreenSpaceEventType.LEFT_CLICK);
        handler.removeInputAction(Cesium.ScreenSpaceEventType.MOUSE_MOVE);
        handler.removeInputAction(Cesium.ScreenSpaceEventType.RIGHT_CLICK);
        break;
    }
  } // 可视域体走数据服务


  function getVisibleResult() {
    var obj = viewshed3D.getViewshedParameter();
    var geometryViewShedBodyvisibleParameter = {
      viewerPoint: obj.viewPosition,
      point3DsList: obj.point3DList,
      radius: obj.distance,
      lonlat: true,
      viewShedType: "VISIBLEBODY"
    };
    var queryData = JSON.stringify(geometryViewShedBodyvisibleParameter);
    var color = Cesium.Color.fromCssColorString(state.visibleBodyColor); //先发送POST请求

    window.axios.post(state.viewshedSpatialUrl, queryData).then(function (response) {
      //再发送一次GET请求  获取到运算结果
      window.axios.get(response.data.newResourceLocation + ".json").then(function (response) {
        var data = response.data; //失败 没有内容

        if (data.geometry == null) {
          tool.Message.errorMsg('获取geometry失败');
          return;
        } //将二进制流构建arrayBuffer 添加至S3MInstanceCollection


        var u8 = new Uint8Array(data.geometry.model);
        var ab = u8.buffer; //注意  若添加多个模型 请保证各个名称唯一  否则可能引起显示错乱问题

        s3mInstanceColc.add("VeiwshedBody", {
          id: 1,
          position: Cesium.Cartesian3.fromDegrees(data.geometry.position.x, data.geometry.position.y, data.geometry.position.z),
          hpr: new Cesium.HeadingPitchRoll(0, 0, 0),
          //scale : new Cesium.Cartesian3(39.37007900000045,39.37007900000045,39.37007900000045),
          color: color //offset : new Cesium.Cartesian3(0,0,690)

        }, ab, false);
        data.geometry.model = [4, 0, 0, 0].concat(data.geometry.model); // 分析区域颜色和可视域体颜色会影响，所以先透明

        viewshed3D.visibleAreaColor = Cesium.Color.fromCssColorString("rgba(0,0,0,0)");
        viewshed3D.hiddenAreaColor = Cesium.Color.fromCssColorString("rgba(0,0,0,0)"); // // 传到store可以做gpu查询

        data.geometry["name"] = resource.VeiwshedBody;
        storeDate.geometrys["VeiwshedBody"] = data.geometry;
        actions.setGeometrys();
      })["catch"](function (error) {
        console.log(error);
      });
    })["catch"](function (error) {
      console.log(error);
    });
  }

  function getInVisibleResult() {
    var obj = viewshed3D.getViewshedParameter();
    var geometryViewShedBodyvisibleParameter = {
      viewerPoint: obj.viewPosition,
      point3DsList: obj.point3DList,
      radius: obj.distance,
      lonlat: true,
      viewShedType: "HIDDENBODY"
    };
    var queryData = JSON.stringify(geometryViewShedBodyvisibleParameter);
    var color = Cesium.Color.fromCssColorString(state.invisibleBodyColor); //先发送POST请求

    window.axios.post(state.viewshedSpatialUrl, queryData).then(function (response) {
      //再发送一次GET请求  获取到运算结果
      window.axios.get(response.data.newResourceLocation + ".json").then(function (response) {
        var data = response.data; //失败 没有内容

        if (data.geometry == null) {
          tool.Message.errorMsg('获取geometry失败');
          return;
        } //将二进制流构建arrayBuffer 添加至S3MInstanceCollection


        var u8 = new Uint8Array(data.geometry.model);
        var ab = u8.buffer; //注意  若添加多个模型 请保证各个名称唯一  否则可能引起显示错乱问题

        s3mInstanceColc.add("VeiwshedBodyHidden", {
          id: 1,
          position: Cesium.Cartesian3.fromDegrees(data.geometry.position.x, data.geometry.position.y, data.geometry.position.z),
          hpr: new Cesium.HeadingPitchRoll(0, 0, 0),
          //scale : new Cesium.Cartesian3(39.37007900000045,39.37007900000045,39.37007900000045),
          color: color //offset : new Cesium.Cartesian3(0,0,690)

        }, ab, false);
        data.geometry.model = [4, 0, 0, 0].concat(data.geometry.model);
        viewshed3D.visibleAreaColor = Cesium.Color.fromCssColorString("rgba(0,0,0,0)");
        viewshed3D.hiddenAreaColor = Cesium.Color.fromCssColorString("rgba(0,0,0,0)"); // // 传到store可以做gpu查询

        data.geometry["name"] = resource.VeiwshedBodyHidden;
        storeDate.geometrys["VeiwshedBodyHidden"] = data.geometry;
        actions.setGeometrys();
      })["catch"](function (error) {
        console.log(error);
      });
    })["catch"](function (error) {
      console.log(error);
    });
  } // 清除


  function clear() {
    clearViewshed();
    dynamicLayer3D.clearState(Carurls[0], [1]);
    clearInterval(timers);
    timers = null;
    state.viewshedAnimation = false;
    clearHandlerDrawing("Polyline");
  }

  function clearViewshed() {
    tooltip.setVisible(false);
    viewer.entities.removeById('viewshedPoint');
    document.body.classList.remove("measureCur");
    viewshed3D.distance = 0.00001;
    viewshed3D.viewPosition = [0, 0, 0];
    state.visibleBody = false;
    state.invisibleBody = false;
    state.observerInformation = null;
  }
  /*
  动态可视域模块
  */
  //绘制路线


  function handlerPolyline() {
    if (!window.handlerPolyline) {
      initHandler("Polyline");
    }

    if (props.DynamicLine) {
      //如果传入路线,就不需要绘制路线了
      setCarState();
      return;
    }

    handlerDrawing("Polyline", Cesium.ClampMode.Ground).then(function (res) {
      var handlerPolyline = window.handlerPolyline;
      handlerPolyline.polyline.show = false;
      window.polylineTransparent.show = true; //半透线隐藏

      handlerPolyline.deactivate();
      state.DynamicLine = res.result.object._positions;
      tooltip.setVisible(false);

      if (state.DynamicLine.length < 2) {
        tool.Message.warnMsg('至少需要两个点！');
        return;
      }
      setCarState();
    }, function (err) {
      console.log(err);
    });
    window.handlerPolyline.activate();
  } // 添加动态可视域动画模型


  function setCarState() {
    viewshed3D.distance = state.distance;
    viewshed3D.build();
    var points = state.DynamicLine;
    var points2 = [];

    for (var i = 1, j = points.length; i < j; i++) {
      var startPoint = points[i - 1];
      var endPoint = points[i];
      var d = Cesium.Cartesian3.distance(startPoint, endPoint);
      var count = parseInt(d / (state.DynamicSpeed * 0.05)) + 1;

      for (var _i = 1, _j = count; _i <= _j; _i++) {
        points2.push(Cesium.Cartesian3.lerp(startPoint, endPoint, _i / count, new Cesium.Cartesian3()));
      }
    }

    var positions = tool.CartesiantoDegreesObjs(points2);
    var CarState = new Cesium.DynamicObjectState({
      id: 1,
      longitude: positions[0].longitude,
      latitude: positions[0].latitude,
      altitude: positions[0].height,
      scale: new Cesium.Cartesian3(1, 1, 1)
    });
    dynamicLayer3D.updateObjectWithModel(Carurls[0], [CarState]);
    var index = 1;
    timers = setInterval(function () {
      if (index >= positions.length) {
        clearInterval(timers);
        return;
      }

      CarState.longitude = positions[index].longitude;
      CarState.latitude = positions[index].latitude;
      CarState.altitude = positions[index].height;
      dynamicLayer3D.updateObjectWithModel(Carurls[0], [CarState]);
      var getAngleAndRadian = tool.getAngleAndRadian(points2[index - 1], points2[index]);
      viewshed3D.direction = getAngleAndRadian.angle;
      viewshed3D.viewPosition = [CarState.longitude, CarState.latitude, CarState.altitude + Number(state.addheight)];
      index += 1;
    }, 50);
  } // 监听


  watch(function () {
    return state.visibleBody;
  }, function (val) {
    if (val && state.observerInformation) {
      getVisibleResult();
    } else {
      s3mInstanceColc.removeCollection("VeiwshedBody");

      if (!state.invisibleBody) {
        viewshed3D.visibleAreaColor = Cesium.Color.fromCssColorString(state.visibleAreaColor);
        viewshed3D.hiddenAreaColor = Cesium.Color.fromCssColorString(state.hiddenAreaColor);
      }

      if (storeDate.geometrys.VeiwshedBody) {
        delete storeDate.geometrys.VeiwshedBody;
        actions.setGeometrys();
      }
    }
  });
  watch(function () {
    return state.invisibleBody;
  }, function (val) {
    if (val && state.observerInformation) {
      getInVisibleResult();
    } else {
      s3mInstanceColc.removeCollection("VeiwshedBodyHidden");

      if (!state.visibleBody) {
        viewshed3D.visibleAreaColor = Cesium.Color.fromCssColorString(state.visibleAreaColor);
        viewshed3D.hiddenAreaColor = Cesium.Color.fromCssColorString(state.hiddenAreaColor);
      }

      if (storeDate.geometrys.VeiwshedBodyHidden) {
        delete storeDate.geometrys.VeiwshedBodyHidden;
        actions.setGeometrys();
      }
    }
  });
  watch(function () {
    return state.addheight;
  }, function (val) {
    if (val === '' || val < 0) {
      // 避免删除导致崩溃
      val = 0;
    }

    if (state.observerInformation) {
      state.observerInformation[2] += parseFloat(val);
      viewshed3D.viewPosition = state.observerInformation;
    }
  });
  watch(function () {
    return state.pitch;
  }, function (val) {
    if (val === '' || val < 0) {
      // 避免删除导致崩溃
      val = 0;
    }

    viewshed3D.pitch = parseFloat(val);
  });
  watch(function () {
    return state.direction;
  }, function (val) {
    if (val === '' || val < 0) {
      // 避免删除导致崩溃
      val = 0;
    }

    viewshed3D.direction = parseFloat(val);
  });
  watch(function () {
    return state.distance;
  }, function (val) {
    if (val === '' || val < 0) {
      // 避免删除导致崩溃
      val = 0;
    }

    viewshed3D.distance = parseFloat(val);
  });
  watch(function () {
    return state.verticalFov;
  }, function (val) {
    if (val === '' || val < 0) {
      // 避免删除导致崩溃
      val = 0;
    }

    viewshed3D.verticalFov = parseFloat(val);
  });
  watch(function () {
    return state.horizontalFov;
  }, function (val) {
    if (val === '' || val < 0) {
      // 避免删除导致崩溃
      val = 0;
    }

    viewshed3D.horizontalFov = parseFloat(val);
  });
  watch(function () {
    return state.hintLineColor;
  }, function (val) {
    viewshed3D.hintLineColor = colorUpdate(val);
  });
  watch(function () {
    return state.visibleAreaColor;
  }, function (val) {
    viewshed3D.visibleAreaColor = colorUpdate(val);
  });
  watch(function () {
    return state.visibleBodyColor;
  }, function (val) {
    s3mInstanceColc.getInstance("VeiwshedBody", 1).updateColor(colorUpdate(val));
  });
  watch(function () {
    return state.hiddenAreaColor;
  }, function (val) {
    viewshed3D.hiddenAreaColor = colorUpdate(val);
  });
  watch(function () {
    return state.invisibleBodyColor;
  }, function (val) {
    s3mInstanceColc.getInstance("VeiwshedBodyHidden", 1).updateColor(colorUpdate(val));
  });
  watch(function () {
    return state.viewshedAnimation;
  }, function (val) {
    if (val) {
      clearViewshed();
      tooltip.showAt('<p>点击分析按钮激活事件</p><p>点击鼠标左键确认模型移动路线</p><p>单击右键结束分析</p>', '300px');
    } else {
      clear();
    }
  });

  function colorUpdate(val) {
    if (val == "") return;
    return Cesium.Color.fromCssColorString(val);
  } // 销毁


  onBeforeUnmount(function () {
    clear();
    s3mInstanceColc.destroy();
    viewshed3D.destroy();
    handler.destroy();
    DynamicLayer3D.destroy();
    viewshed3D = undefined;
    handler = undefined;
    s3mInstanceColc = undefined;
  });
  return _objectSpread2(_objectSpread2({}, toRefs(state)), {}, {
    analysis: analysis,
    clear: clear
  });
}

var script = {
  name: "Sm3dViewshed",
  props: {
    //可视域体数据服务
    viewshedSpatialUrl: {
      type: String
    },
    //初始化观察者信息
    observerInformation: {
      type: Object
    },
    //方向角
    direction: {
      type: Number
    },
    //俯仰角
    pitch: {
      type: Number
    },
    //附加高度
    addheight: {
      type: Number
    },
    //可视域距离
    distance: {
      type: Number
    },
    //水平视角
    verticalFov: {
      type: Number
    },
    //垂直视角
    horizontalFov: {
      type: Number
    },
    //可视线颜色
    hintLineColor: {
      type: String
    },
    //可视区域颜色
    visibleAreaColor: {
      type: String
    },
    //不可视域颜色
    hiddenAreaColor: {
      type: String
    },
    //可视域体颜色
    visibleBodyColor: {
      type: String
    },
    //不可视域体颜色
    invisibleBodyColor: {
      type: String
    },
    //显示可视域体
    visibleBody: {
      type: Boolean
    },
    //显示不可视域体
    invisibleBody: {
      type: Boolean
    },
    //动态可视域设置
    viewshedAnimation: {
      type: Boolean
    },
    //动态可视域路线点
    DynamicLine: {
      type: Array
    },
    //动态分析行进速度
    DynamicSpeed: {
      type: Number
    }
  },
  setup: function setup(props) {
    var _viewshed = viewshed(props),
        visibleBody = _viewshed.visibleBody,
        invisibleBody = _viewshed.invisibleBody,
        viewshedAnimation = _viewshed.viewshedAnimation,
        analysis = _viewshed.analysis,
        clear = _viewshed.clear,
        addheight = _viewshed.addheight,
        verticalFov = _viewshed.verticalFov,
        horizontalFov = _viewshed.horizontalFov,
        hintLineColor = _viewshed.hintLineColor,
        visibleAreaColor = _viewshed.visibleAreaColor,
        hiddenAreaColor = _viewshed.hiddenAreaColor,
        visibleBodyColor = _viewshed.visibleBodyColor,
        invisibleBodyColor = _viewshed.invisibleBodyColor;

    return {
      addheight: addheight,
      verticalFov: verticalFov,
      horizontalFov: horizontalFov,
      hintLineColor: hintLineColor,
      visibleAreaColor: visibleAreaColor,
      hiddenAreaColor: hiddenAreaColor,
      visibleBodyColor: visibleBodyColor,
      invisibleBodyColor: invisibleBodyColor,
      visibleBody: visibleBody,
      invisibleBody: invisibleBody,
      viewshedAnimation: viewshedAnimation,
      analysis: analysis,
      clear: clear
    };
  }
};

var _hoisted_1 = {
  id: "viewshed",
  "class": "sm-panel"
};
var _hoisted_2 = {
  "class": "sm-function-module-sub-section",
  style: {
    "margin": "0"
  }
};
var _hoisted_3 = {
  "class": "sm-half-L"
};
var _hoisted_4 = {
  style: {
    "width": "35%"
  }
};
var _hoisted_5 = {
  "class": "sm-half-L"
};
var _hoisted_6 = {
  style: {
    "width": "35%"
  }
};
var _hoisted_7 = {
  "class": "sm-half-L"
};
var _hoisted_8 = {
  style: {
    "width": "35%"
  }
};
var _hoisted_9 = {
  "class": "sm-half-L"
};
var _hoisted_10 = {
  style: {
    "width": "35%"
  }
};
var _hoisted_11 = {
  "class": "sm-half-L"
};
var _hoisted_12 = {
  style: {
    "width": "35%"
  }
};
var _hoisted_13 = {
  "class": "sm-half-L"
};
var _hoisted_14 = {
  style: {
    "width": "35%"
  }
};
var _hoisted_15 = {
  "class": "sm-half-L"
};
var _hoisted_16 = {
  style: {
    "width": "35%"
  }
};
var _hoisted_17 = {
  "class": "sm-half-L"
};
var _hoisted_18 = {
  style: {
    "width": "35%"
  }
};
var _hoisted_19 = {
  "class": "sm-half-L"
};
var _hoisted_20 = {
  style: {
    "width": "auto"
  }
};
var _hoisted_21 = {
  style: {
    "width": "auto"
  }
};
var _hoisted_22 = {
  style: {
    "width": "auto"
  }
};
var _hoisted_23 = {
  "class": "boxchild"
};
function render(_ctx, _cache, $props, $setup, $data, $options) {
  var _component_el_slider = resolveComponent("el-slider");

  var _component_el_color_picker = resolveComponent("el-color-picker");

  var _directive_stopdrag = resolveDirective("stopdrag");

  var _directive_drag = resolveDirective("drag");

  return withDirectives((openBlock(), createElementBlock("div", _hoisted_1, [withDirectives((openBlock(), createElementBlock("div", _hoisted_2, [createElementVNode("div", _hoisted_3, [createElementVNode("label", _hoisted_4, toDisplayString(_ctx.Resource.addheight), 1
  /* TEXT */
  ), createVNode(_component_el_slider, {
    modelValue: $setup.addheight,
    "onUpdate:modelValue": _cache[0] || (_cache[0] = function ($event) {
      return $setup.addheight = $event;
    }),
    min: 1,
    step: 0.1,
    max: 10,
    "input-size": "mini",
    debounce: 500,
    "tooltip-class": "tooltip-class",
    style: {
      "width": "63%"
    }
  }, null, 8
  /* PROPS */
  , ["modelValue", "step"])]), createElementVNode("div", _hoisted_5, [createElementVNode("label", _hoisted_6, toDisplayString(_ctx.Resource.verticalFov), 1
  /* TEXT */
  ), createVNode(_component_el_slider, {
    modelValue: $setup.verticalFov,
    "onUpdate:modelValue": _cache[1] || (_cache[1] = function ($event) {
      return $setup.verticalFov = $event;
    }),
    min: 1,
    max: 179,
    "input-size": "mini",
    debounce: 500,
    "tooltip-class": "tooltip-class",
    style: {
      "width": "63%"
    }
  }, null, 8
  /* PROPS */
  , ["modelValue"])]), createElementVNode("div", _hoisted_7, [createElementVNode("label", _hoisted_8, toDisplayString(_ctx.Resource.horizontalFov), 1
  /* TEXT */
  ), createVNode(_component_el_slider, {
    modelValue: $setup.horizontalFov,
    "onUpdate:modelValue": _cache[2] || (_cache[2] = function ($event) {
      return $setup.horizontalFov = $event;
    }),
    min: 1,
    max: 179,
    "input-size": "mini",
    debounce: 500,
    "tooltip-class": "tooltip-class",
    style: {
      "width": "63%"
    }
  }, null, 8
  /* PROPS */
  , ["modelValue"])]), createElementVNode("div", _hoisted_9, [createElementVNode("label", _hoisted_10, toDisplayString(_ctx.Resource.hintLineColor), 1
  /* TEXT */
  ), createVNode(_component_el_color_picker, {
    modelValue: $setup.hintLineColor,
    "onUpdate:modelValue": _cache[3] || (_cache[3] = function ($event) {
      return $setup.hintLineColor = $event;
    }),
    size: "mini",
    "show-alpha": "",
    style: {
      "width": "63%"
    }
  }, null, 8
  /* PROPS */
  , ["modelValue"])]), withDirectives(createElementVNode("div", _hoisted_11, [createElementVNode("label", _hoisted_12, toDisplayString(_ctx.Resource.visibleAreaColor), 1
  /* TEXT */
  ), createVNode(_component_el_color_picker, {
    modelValue: $setup.visibleAreaColor,
    "onUpdate:modelValue": _cache[4] || (_cache[4] = function ($event) {
      return $setup.visibleAreaColor = $event;
    }),
    size: "mini",
    "show-alpha": "",
    style: {
      "width": "63%"
    }
  }, null, 8
  /* PROPS */
  , ["modelValue"])], 512
  /* NEED_PATCH */
  ), [[vShow, !$setup.visibleBody && !$setup.invisibleBody]]), withDirectives(createElementVNode("div", _hoisted_13, [createElementVNode("label", _hoisted_14, toDisplayString(_ctx.Resource.hiddenAreaColor), 1
  /* TEXT */
  ), createVNode(_component_el_color_picker, {
    modelValue: $setup.hiddenAreaColor,
    "onUpdate:modelValue": _cache[5] || (_cache[5] = function ($event) {
      return $setup.hiddenAreaColor = $event;
    }),
    size: "mini",
    "show-alpha": "",
    style: {
      "width": "63%"
    }
  }, null, 8
  /* PROPS */
  , ["modelValue"])], 512
  /* NEED_PATCH */
  ), [[vShow, !$setup.visibleBody && !$setup.invisibleBody]]), withDirectives(createElementVNode("div", _hoisted_15, [createElementVNode("label", _hoisted_16, toDisplayString(_ctx.Resource.visibleBodyColor), 1
  /* TEXT */
  ), createVNode(_component_el_color_picker, {
    modelValue: $setup.visibleBodyColor,
    "onUpdate:modelValue": _cache[6] || (_cache[6] = function ($event) {
      return $setup.visibleBodyColor = $event;
    }),
    size: "mini",
    "show-alpha": "",
    style: {
      "width": "63%"
    }
  }, null, 8
  /* PROPS */
  , ["modelValue"])], 512
  /* NEED_PATCH */
  ), [[vShow, $setup.visibleBody]]), withDirectives(createElementVNode("div", _hoisted_17, [createElementVNode("label", _hoisted_18, toDisplayString(_ctx.Resource.invisibleBodyColor), 1
  /* TEXT */
  ), createVNode(_component_el_color_picker, {
    modelValue: $setup.invisibleBodyColor,
    "onUpdate:modelValue": _cache[7] || (_cache[7] = function ($event) {
      return $setup.invisibleBodyColor = $event;
    }),
    size: "mini",
    "show-alpha": "",
    style: {
      "width": "63%"
    }
  }, null, 8
  /* PROPS */
  , ["modelValue"])], 512
  /* NEED_PATCH */
  ), [[vShow, $setup.invisibleBody]]), createElementVNode("div", _hoisted_19, [createElementVNode("label", _hoisted_20, [withDirectives(createElementVNode("input", {
    type: "checkbox",
    "onUpdate:modelValue": _cache[8] || (_cache[8] = function ($event) {
      return $setup.visibleBody = $event;
    })
  }, null, 512
  /* NEED_PATCH */
  ), [[vModelCheckbox, $setup.visibleBody]]), createTextVNode(" " + toDisplayString(_ctx.Resource.displayVisualsBody), 1
  /* TEXT */
  )]), createElementVNode("label", _hoisted_21, [withDirectives(createElementVNode("input", {
    type: "checkbox",
    "onUpdate:modelValue": _cache[9] || (_cache[9] = function ($event) {
      return $setup.invisibleBody = $event;
    })
  }, null, 512
  /* NEED_PATCH */
  ), [[vModelCheckbox, $setup.invisibleBody]]), createTextVNode(" " + toDisplayString(_ctx.Resource.displayInvisibleBody), 1
  /* TEXT */
  )]), createElementVNode("label", _hoisted_22, [withDirectives(createElementVNode("input", {
    type: "checkbox",
    "onUpdate:modelValue": _cache[10] || (_cache[10] = function ($event) {
      return $setup.viewshedAnimation = $event;
    })
  }, null, 512
  /* NEED_PATCH */
  ), [[vModelCheckbox, $setup.viewshedAnimation]]), createTextVNode(" " + toDisplayString(_ctx.Resource.viewshedAnimation), 1
  /* TEXT */
  )])]), createElementVNode("div", _hoisted_23, [createElementVNode("button", {
    type: "button",
    "class": "tbtn",
    onClick: _cache[11] || (_cache[11] = function () {
      return $setup.analysis && $setup.analysis.apply($setup, arguments);
    })
  }, toDisplayString(_ctx.Resource.analyze), 1
  /* TEXT */
  ), createElementVNode("button", {
    type: "button",
    "class": "tbtn tbtn-margin-left",
    onClick: _cache[12] || (_cache[12] = function () {
      return $setup.clear && $setup.clear.apply($setup, arguments);
    })
  }, toDisplayString(_ctx.Resource.clear), 1
  /* TEXT */
  )])])), [[_directive_stopdrag]])])), [[_directive_drag]]);
}

script.render = render;
script.__file = "src/components/analysis_3d/viewshed/viewshed.vue";

script.install = function (app) {
  app.component(script.name, script);
};

export default script;
