import { reactive, toRefs, watch, onBeforeUnmount, resolveComponent, resolveDirective, withDirectives, openBlock, createElementBlock, createElementVNode, vModelRadio, createCommentVNode, vShow, Fragment, renderList, toDisplayString, vModelSelect, vModelCheckbox, createVNode, createTextVNode } from 'vue';

function _typeof(obj) {
  "@babel/helpers - typeof";

  if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
    _typeof = function (obj) {
      return typeof obj;
    };
  } else {
    _typeof = function (obj) {
      return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
    };
  }

  return _typeof(obj);
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);

  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    if (enumerableOnly) symbols = symbols.filter(function (sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    });
    keys.push.apply(keys, symbols);
  }

  return keys;
}

function _objectSpread2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};

    if (i % 2) {
      ownKeys(Object(source), true).forEach(function (key) {
        _defineProperty(target, key, source[key]);
      });
    } else if (Object.getOwnPropertyDescriptors) {
      Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
      ownKeys(Object(source)).forEach(function (key) {
        Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
      });
    }
  }

  return target;
}

// 创建一个简单的store状态管理

var storeState = reactive({
  isViewer: false,
  //viewer初始化标志
  changeLayers: 0,
  //图层改变加载完毕监听
  changeGeometrys: 0 //三维分析体改变标志

});

/*
* 常用工具类
*/
//axios本版本不支持jsonp
var axiosJsonp = function axiosJsonp(url) {
  if (!url) {
    console.error('Axios.JSONP 至少需要一个url参数!');
    return;
  }

  return new Promise(function (resolve, reject) {
    window.jsonCallBack = function (result) {
      resolve(result);
    };

    var JSONP = document.createElement("script");
    JSONP.type = "text/javascript";
    JSONP.src = "".concat(url, "&callback=jsonCallBack");
    document.getElementsByTagName("head")[0].appendChild(JSONP);
    setTimeout(function () {
      document.getElementsByTagName("head")[0].removeChild(JSONP);
    }, 500);
  });
}; //判断两数组或对象相等


var isEqualArr = function isEqualArr(arg1, arg2) {
  if (!arg1 || !arg2) return true;
  var bol = true;

  if (Object.keys(arg1).length != Object.keys(arg2).length) {
    return false;
  }

  for (var key in arg1) {
    if (_typeof(arg1[key]) == 'object') {
      bol = isSame(arg1[key], arg2[key]);

      if (!bol) {
        break;
      }
    } else if (arg1[key] != arg2[key]) {
      bol = false;
      break;
    }
  }

  return bol;
}; //坐标转化
//笛卡尔转经纬度


var CartesiantoDegrees = function CartesiantoDegrees(Cartesians) {
  var array = [].concat(Cartesians);
  var positions = [];

  for (var i = 0, len = array.length; i < len; i++) {
    var cartographic = Cesium.Cartographic.fromCartesian(array[i]);
    var longitude = Cesium.Math.toDegrees(cartographic.longitude);
    var latitude = Cesium.Math.toDegrees(cartographic.latitude);
    var h = cartographic.height;

    if (positions.indexOf(longitude) == -1 && positions.indexOf(latitude) == -1) {
      positions.push(longitude);
      positions.push(latitude);
      positions.push(h);
    }
  }

  return positions;
}; //笛卡尔转经纬度(每个点是独立的对象)


var CartesiantoDegreesObjs = function CartesiantoDegreesObjs(Cartesians) {
  var array = [].concat(Cartesians);
  var positions = [];

  for (var i = 0, len = array.length; i < len; i++) {
    var cartographic = Cesium.Cartographic.fromCartesian(array[i]);
    var obj = {
      longitude: Cesium.Math.toDegrees(cartographic.longitude),
      latitude: Cesium.Math.toDegrees(cartographic.latitude),
      height: cartographic.height
    };
    positions.push(obj);
  }

  return positions;
}; // 弧度转经纬度


var CartographictoDegrees = function CartographictoDegrees(wgsPosition) {
  var longitude = Cesium.Math.toDegrees(wgsPosition.longitude);
  var latitude = Cesium.Math.toDegrees(wgsPosition.latitude);
  var height = wgsPosition.height;
  return [longitude, latitude, height];
}; //去重函数  数组


var unique = function unique(arr) {
  var res = [];
  var json = {};

  for (var i = 0; i < arr.length; i++) {
    if (!json[arr[i]]) {
      res.push(arr[i]);
      json[arr[i]] = 1;
    }
  }

  return res;
}; // 获取渐变色函数


function gradientColors(start, end, steps, gamma) {
  var i,
      j,
      ms,
      me,
      output = [],
      so = [];
  gamma = gamma || 1;

  var normalize = function normalize(channel) {
    return Math.pow(channel / 255, gamma);
  };

  start = parseColor(start).map(normalize);
  end = parseColor(end).map(normalize);

  for (i = 0; i < steps; i++) {
    ms = i / (steps - 1);
    me = 1 - ms;

    for (j = 0; j < 3; j++) {
      so[j] = pad(Math.round(Math.pow(start[j] * me + end[j] * ms, 1 / gamma) * 255).toString(16));
    }

    output.push('#' + so.join(''));
  }

  return output;

  function parseColor(hexStr) {
    return hexStr.length === 4 ? hexStr.substr(1).split('').map(function (s) {
      return 0x11 * parseInt(s, 16);
    }) : [hexStr.substr(1, 2), hexStr.substr(3, 2), hexStr.substr(5, 2)].map(function (s) {
      return parseInt(s, 16);
    });
  }

  function pad(s) {
    return s.length === 1 ? '0' + s : s;
  }
}

function getAngleAndRadian(pointA, pointB) {
  //建立以点A为原点，X轴为east,Y轴为north,Z轴朝上的坐标系
  var transform = Cesium.Transforms.eastNorthUpToFixedFrame(pointA); //向量AB

  var positionvector = Cesium.Cartesian3.subtract(pointB, pointA, new Cesium.Cartesian3()); //因transform是将A为原点的eastNorthUp坐标系中的点转换到世界坐标系的矩阵
  //AB为世界坐标中的向量
  //因此将AB向量转换为A原点坐标系中的向量，需乘以transform的逆矩阵。

  var vector = Cesium.Matrix4.multiplyByPointAsVector(Cesium.Matrix4.inverse(transform, new Cesium.Matrix4()), positionvector, new Cesium.Cartesian3()); //归一化

  var direction = Cesium.Cartesian3.normalize(vector, new Cesium.Cartesian3()); //heading

  var heading1 = Math.atan2(direction.y, direction.x) - Cesium.Math.PI_OVER_TWO;
  var radian = Cesium.Math.TWO_PI - Cesium.Math.zeroToTwoPi(heading1);
  var angle = radian * (180 / Math.PI);

  if (angle < 0) {
    angle = angle + 360;
  }

  return {
    angle: angle,
    radian: radian
  };
}

function getPitch(pointA, pointB) {
  var transfrom = Cesium.Transforms.eastNorthUpToFixedFrame(pointA);
  var vector = Cesium.Cartesian3.subtract(pointB, pointA, new Cesium.Cartesian3());
  var direction = Cesium.Matrix4.multiplyByPointAsVector(Cesium.Matrix4.inverse(transfrom, transfrom), vector, vector);
  Cesium.Cartesian3.normalize(direction, direction); //因为direction已归一化，斜边长度等于1，所以余弦函数等于direction.z

  var radian = Cesium.Math.PI_OVER_TWO - Cesium.Math.acosClamped(direction.z);
  var angle = radian * (180 / Math.PI);

  if (angle < 0) {
    angle = angle + 360;
  }

  return {
    angle: angle,
    radian: radian
  };
}

var tool = {
  axiosJsonp: axiosJsonp,
  isEqualArr: isEqualArr,
  CartesiantoDegrees: CartesiantoDegrees,
  CartesiantoDegreesObjs: CartesiantoDegreesObjs,
  unique: unique,
  gradientColors: gradientColors,
  getAngleAndRadian: getAngleAndRadian,
  CartographictoDegrees: CartographictoDegrees,
  getPitch: getPitch
};

var ResourceCN = {
  showRenderLoopErrors: '渲染时发生错误，已停止渲染。',
  AttributeError: '该组件props没有这个属性：',
  NoPickPositionSupported: "不支持深度纹理,无法绘制多边形，地形操作功能无法使用！",
  NoTerrain: "请在地形里使用地形组件！",
  initViewerWarn: '请先初始化viewer!',
  MoveMouseHeightBox: '点击鼠标左键结束矩形绘制，移动鼠标绘制box高度',
  RightClickEndDrawing: '右键单击结束绘制',
  LeftClickBottomBox: '点击鼠标左键，开始绘制矩形作为box底面',
  ClickModelAddBox: '点击模型，添加裁剪盒子',
  SkyLineWarn: "获取天际线体前，请先绘制天际线！",
  SkyLineBody: '天际线体',
  ShadowqueryWarn: "此操作需要先开启阴影！",
  VeiwshedBody: '可视体',
  VeiwshedBodyHidden: '不可视体',
  EchartsErr: "二维显示需要echarts支持，未找到相关依赖！",
  BaseMapImg: '底图',
  tip1: '<p>点击左键确定操作区域中间点</p><p>右键单击结束绘制</p>'
};

// 组件内部的语言资源：主要包括提示信息
var currentLanguage, Resource;
var cookieLanguage = getLang().toLowerCase();

function getLang() {
  //浏览器语言  IE用browserLanguage，非IE使用language进行判断
  var lang = (navigator.language || navigator.browserLanguage).toLowerCase();
  window.lang = lang; //判断portal设置语言 通过cookie获取
  //   const cookies = document.cookie.split(';');
  //   if (cookies.length > 0) {
  //     cookies.forEach(function (cookie) {
  //       const arr = cookie.split('=');
  //       if (arr[0].toLowerCase().trim() === 'language') {
  //         lang = arr[1];
  //         return;
  //       }
  //     });
  //   }

  return lang;
}

if (cookieLanguage !== undefined) {
  currentLanguage = cookieLanguage;
} else {
  currentLanguage = (navigator.language || navigator.browserLanguage).toLowerCase(); // 获取当前浏览器的语言
}

if (currentLanguage.startsWith('zh')) {
  Resource = ResourceCN;
} else if (currentLanguage.startsWith('ja')) {
  Resource = ResourceCN;
} else {
  Resource = ResourceCN;
}

var resource = Resource;

function createTooltip(frameDiv) {
  var tooltip = function tooltip(frameDiv) {
    var div = document.createElement('DIV');
    div.className = "tooltip";
    this._div = div;
    this.message = '';
    frameDiv.appendChild(div);
  };

  tooltip.prototype.setVisible = function (visible) {
    if (visible) {
      this._div.style.right = '10px';
    } else {
      this._div.style.right = '-300px';
    }
  };

  tooltip.prototype.showAt = function (message, top) {
    //top:200px => string
    if (top) {
      this._div.style.top = top;
    }

    if (message) {
      this.setVisible(true);
      this._div.innerHTML = message;
    }
  };

  return new tooltip(frameDiv);
}

function ColorTable(option) {
  this.tableName = option.tableName;
  this.opacityMinValue = option.opacityMinValue;
  this.opacityMaxValue = option.opacityMaxValue;
  this.gradientMinOpacity = option.gradientMinOpacity;
  this.gradientMaxOpacity = option.gradientMaxOpacity;
  this.visibleMinValue = option.visibleMinValue;
  this.visibleMaxValue = option.visibleMaxValue;
}

ColorTable.prototype.setColorTable = function (layer, index) {
  if (!Cesium.defined(layer)) {
    return;
  }

  var minValue = layer.minValue;
  var maxValue = layer.maxValue;
  var minExtent = this.visibleMinValue;
  var maxExtent = this.visibleMaxValue;

  if (minExtent > maxExtent) {
    var temp = minExtent;
    minExtent = maxExtent;
    maxExtent = temp;
  }

  this.setOpacityFunction(layer, minValue, maxValue, minExtent, maxExtent);
  this.setColorFunction(layer, minValue, maxValue, minExtent, maxExtent, index);
};

ColorTable.prototype.setOpacityFunction = function (layer, minValue, maxValue, minExtent, maxExtent) {
  var minOpacity = this.opacityMinValue;
  var maxOpacity = this.opacityMaxValue;
  var opacityFunction = new Cesium.PiecewiseFunction();
  opacityFunction.addPoint(minValue, 0.0);
  opacityFunction.addPoint(minValue + (maxValue - minValue) * minExtent, minOpacity);
  opacityFunction.addPoint(minValue + (maxValue - minValue) * maxExtent, maxOpacity);
  opacityFunction.addPoint(minValue + (maxValue - minValue) * (maxExtent + 0.01), minOpacity);
  opacityFunction.addPoint(maxValue, 0.0);
  layer.opacityTransferFunction = opacityFunction;
};

ColorTable.prototype.setColorFunction = function (layer, minValue, maxValue, minExtent, maxExtent, index) {
  var colorfun = new Cesium.ColorTransferFunction();
  var extentRange = maxExtent - minExtent;
  var span = extentRange / 15;

  switch (index) {
    case 1:
      colorfun.addRGBPoint(minValue, 9 / 255, 9 / 255, 212 / 255);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * minExtent, 9 / 255, 10 / 255, 255 / 255);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span), 9 / 255, 51 / 255, 255 / 255);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span * 2), 9 / 255, 102 / 255, 255 / 255);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span * 3), 9 / 255, 153 / 255, 255 / 255);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span * 4), 9 / 255, 204 / 255, 255 / 255);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span * 5), 9 / 255, 255 / 255, 255 / 255);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span * 6), 51 / 255, 255 / 255, 204 / 255);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span * 7), 102 / 255, 255 / 255, 153 / 255);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span * 8), 153 / 255, 255 / 255, 102 / 255);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span * 9), 204 / 255, 255 / 255, 51 / 255);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span * 10), 255 / 255, 255 / 255, 0);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span * 11), 255 / 255, 204 / 255, 0);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span * 12), 255 / 255, 153 / 255, 0);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span * 13), 255 / 255, 102 / 255, 0);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span * 14), 255 / 255, 51 / 255, 0);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span * 15), 255 / 255, 0, 0);
      break;

    case 2:
      colorfun.addRGBPoint(minValue, 255 / 255, 103 / 255, 103 / 255);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * minExtent, 255 / 255, 0, 255 / 255);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span), 255 / 255, 51 / 255, 255 / 255);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span * 2), 255 / 255, 102 / 255, 255 / 255);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span * 3), 255 / 255, 153 / 255, 255 / 255);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span * 4), 255 / 255, 204 / 255, 255 / 255);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span * 5), 255 / 255, 255 / 255, 255 / 255);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span * 6), 51 / 255, 255 / 255, 204 / 255);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span * 7), 102 / 255, 255 / 255, 153 / 255);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span * 8), 153 / 255, 255 / 255, 102 / 255);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span * 9), 204 / 255, 255 / 255, 51 / 255);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span * 10), 255 / 255, 255 / 255, 0);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span * 11), 255 / 255, 204 / 255, 0);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span * 12), 255 / 255, 153 / 255, 0);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span * 13), 255 / 255, 102 / 255, 0);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span * 14), 255 / 255, 51 / 255, 0);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span * 15), 255 / 255, 0, 0);
      break;

    case 3:
      colorfun.addRGBPoint(minValue, 157 / 255, 0, 255 / 255);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * minExtent, 157 / 255, 0, 255 / 255);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span), 157 / 255, 51 / 255, 255 / 255);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span * 2), 157 / 255, 102 / 255, 255 / 255);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span * 3), 157 / 255, 153 / 255, 255 / 255);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span * 4), 157 / 255, 204 / 255, 255 / 255);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span * 5), 157 / 255, 255 / 255, 255 / 255);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span * 6), 51 / 255, 255 / 255, 204 / 255);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span * 7), 102 / 255, 255 / 255, 153 / 255);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span * 8), 153 / 255, 255 / 255, 102 / 255);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span * 9), 204 / 255, 255 / 255, 51 / 255);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span * 10), 255 / 255, 255 / 255, 0);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span * 11), 255 / 255, 204 / 255, 0);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span * 12), 255 / 255, 153 / 255, 0);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span * 13), 255 / 255, 102 / 255, 0);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span * 14), 255 / 255, 51 / 255, 0);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span * 15), 255 / 255, 0, 0);
      break;

    case 4:
      colorfun.addRGBPoint(minValue, 149 / 255, 232 / 255, 249 / 255);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * minExtent, 149 / 255, 0, 255 / 255);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span), 149 / 255, 51 / 255, 255 / 255);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span * 2), 149 / 255, 102 / 255, 255 / 255);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span * 3), 149 / 255, 153 / 255, 255 / 255);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span * 4), 149 / 255, 204 / 255, 255 / 255);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span * 5), 149 / 255, 255 / 255, 255 / 255);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span * 6), 51 / 255, 255 / 255, 204 / 255);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span * 7), 102 / 255, 255 / 255, 153 / 255);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span * 8), 153 / 255, 255 / 255, 102 / 255);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span * 9), 204 / 255, 255 / 255, 51 / 255);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span * 10), 255 / 255, 255 / 255, 0);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span * 11), 255 / 255, 204 / 255, 0);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span * 12), 255 / 255, 153 / 255, 0);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span * 13), 255 / 255, 102 / 255, 0);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span * 14), 255 / 255, 51 / 255, 0);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span * 15), 255 / 255, 0, 0);
      break;

    case 5:
      colorfun.addRGBPoint(minValue, 26 / 255, 255 / 255, 156 / 255);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * minExtent, 26 / 255, 0, 255 / 255);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span), 26 / 255, 51 / 255, 255 / 255);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span * 2), 26 / 255, 102 / 255, 255 / 255);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span * 3), 26 / 255, 153 / 255, 255 / 255);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span * 4), 26 / 255, 204 / 255, 255 / 255);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span * 5), 26 / 255, 255 / 255, 255 / 255);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span * 6), 51 / 255, 255 / 255, 204 / 255);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span * 7), 102 / 255, 255 / 255, 153 / 255);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span * 8), 153 / 255, 255 / 255, 102 / 255);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span * 9), 204 / 255, 255 / 255, 51 / 255);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span * 10), 255 / 255, 255 / 255, 0);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span * 11), 255 / 255, 204 / 255, 0);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span * 12), 255 / 255, 153 / 255, 0);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span * 13), 255 / 255, 102 / 255, 0);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span * 14), 255 / 255, 51 / 255, 0);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span * 15), 255 / 255, 0, 0);
      break;

    default:
      colorfun.addRGBPoint(minValue, 0, 0, 255 / 255);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * minExtent, 0, 0, 255 / 255);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span), 0, 51 / 255, 255 / 255);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span * 2), 0, 102 / 255, 255 / 255);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span * 3), 0, 153 / 255, 255 / 255);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span * 4), 0, 204 / 255, 255 / 255);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span * 5), 0, 255 / 255, 255 / 255);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span * 6), 51 / 255, 255 / 255, 204 / 255);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span * 7), 102 / 255, 255 / 255, 153 / 255);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span * 8), 153 / 255, 255 / 255, 102 / 255);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span * 9), 204 / 255, 255 / 255, 51 / 255);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span * 10), 255 / 255, 255 / 255, 0);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span * 11), 255 / 255, 204 / 255, 0);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span * 12), 255 / 255, 153 / 255, 0);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span * 13), 255 / 255, 102 / 255, 0);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span * 14), 255 / 255, 51 / 255, 0);
      colorfun.addRGBPoint(minValue + (maxValue - minValue) * (minExtent + span * 15), 255 / 255, 0, 0);
      break;
  }

  if (minExtent + span * 15 < 1.0) {
    colorfun.addRGBPoint(maxValue, 255 / 255, 0, 0);
  }

  layer.colorTransferFunction = colorfun;
};

ColorTable.prototype.setGradientOpacityValue = function (layer) {
  var minValue = layer.minValue;
  var maxValue = layer.maxValue;
  var minExtent = this.gradientMinOpacity;
  var maxExtent = this.gradientMaxOpacity;

  if (minExtent > maxExtent) {
    var temp = minExtent;
    minExtent = maxExtent;
    maxExtent = temp;
  }

  layer.gradientOpacityMinValue = Math.abs(maxValue - minValue) * 0.1 * minExtent;
  layer.gradientOpacityMaxValue = Math.abs(maxValue - minValue) * 0.1 * maxExtent;
};

function volume(props) {
  // 设置默认值数据
  var state = reactive({
    volumeDataUrl: '',
    operationType: 'addDate',
    dimensions: [],
    variables: [],
    selectedDateName: null,
    xDim: null,
    yDim: null,
    zDim: null,
    timeDim: null,
    //数值模式
    drawMode: 'volume',
    opacityInterval: [0, 1],
    useGradientOpacity: false,
    gradientOpacityValue: [0, 1],
    gradientOpacity: [0, 1],
    showClipPlane: false,
    clipX: 0.5,
    clipY: 0.5,
    clipRotate: 0,
    //剖切
    xOffset: 0.5,
    yOffset: 0.5,
    zOffset: 0.5,
    //等值面
    contourValue: 1,
    contourRange: [0, 1],
    // 公共部分
    zScale: 0,
    colorInterval: [0, 1],
    timeOrder: 0,
    timeRange: [0, 24],
    openLight: false
  }); // 传入props改变默认值

  if (props) {
    for (var key in props) {
      if (state.hasOwnProperty(key)) {
        if (props[key] != undefined) state[key] = props[key];
      } else {
        tool.Message.errorMsg(resource.AttributeError + key);
      }
    }
  } // 初始化数据


  var gridLayer;
  var scaleScratch = new Cesium.Cartesian3(1, 1, 1); //z拉伸

  var scratchCartesian3 = new Cesium.Cartesian3(0.5, 0.5, 0.5); //偏移

  var scratchClipPlane = Cesium.Plane.fromPointNormal(new Cesium.Cartesian3(0, 0, 0), new Cesium.Cartesian3(1, 0, 0)); //裁剪面

  var colorTable;

  if (storeState.isViewer) {
    if (!window.tooltip) {
      window.tooltip = createTooltip(viewer._element);
    }

    init();
  } //viewer 初始化完成的监听


  watch(function () {
    return storeState.isViewer;
  }, function (val) {
    if (val) {
      if (!window.tooltip) {
        window.tooltip = createTooltip(viewer._element);
      }

      init();
    }
  });

  function init() {
    if (!state.volumeDataUrl) return tool.Message.warnMsg('请先定义数据路径！'); // let promise = viewer.scene.addVoxelGridLayer("public/data/netcdf/Ningxia_24.nc", "test");
    // let promise = scene.addVoxelGridLayer("public/data/netcdf/result_100_200_9_40.nc", );

    var promise = viewer.scene.addVoxelGridLayer(state.volumeDataUrl, "test");
    Cesium.when(promise, function (layer) {
      gridLayer = layer;
      state.dimensions = gridLayer._NetCDFInfo.dimensions;
      state.variables = gridLayer._NetCDFInfo.variables;
      state.selectedDateName = state.variables[0].name;
      state.xDim = state.dimensions[0].name;
      state.yDim = state.dimensions[0].name;
      state.zDim = state.dimensions[0].name;
      state.timeDim = state.dimensions[0].name; //默认体渲染位置

      gridLayer.layerBounds = new Cesium.Rectangle(99.95422, 32.25671, 107.1912, 37.1386);
      gridLayer.zBounds = new Cesium.Cartesian2(500, 50000);
    });
  } // 加载数据开始渲染


  function startRender() {
    if (!gridLayer) {
      init();
      return;
    }

    if (state.xDim == state.yDim || state.xDim == state.zDim || state.yDim == state.zDim) {
      tool.Message.warnMsg("各维度名不能一样");
      return;
    }

    colorTable = new ColorTable({
      opacityMinValue: 0.0,
      opacityMaxValue: 0.8,
      gradientMinOpacity: 1.0,
      gradientMaxOpacity: 1.0,
      visibleMinValue: 0,
      visibleMaxValue: 0.37
    });
    colorTable.setColorTable(gridLayer, 0);
    gridLayer.startRender({
      variableName: state.selectedDateName,
      xDimName: state.xDim,
      yDimName: state.yDim,
      zDimName: state.zDim,
      timeDimName: state.timeDim
    });
    changeAttrbute();
    viewer.scene.camera.flyTo({
      destination: {
        x: -1688158.0372444934,
        y: 6654029.431965283,
        z: 2998692.1265170774
      },
      orientation: {
        heading: 0.028840576504810755,
        pitch: -0.8994386458052253,
        roll: 6.283185307179586
      }
    });
  } // 加载数据后再修改部分最大最小属性值


  function changeAttrbute() {
    state.contourRange = [Math.ceil(gridLayer.minValue), Math.ceil(gridLayer.maxValue)];
    state.contourValue = Math.ceil(gridLayer.minValue);
    var recordDimension = gridLayer._NetCDFInfo.recordDimension;

    if (recordDimension && recordDimension.length > 0) {
      state.timeRange = [0, recordDimension.length];
    }
  } // 添加裁剪面


  function addClipPlane() {
    if (!Cesium.defined(gridLayer) || gridLayer.getNumberOfClipPlanes() > 0) {
      return;
    }

    state.showClipPlane = true;
    gridLayer.addClipPlane(scratchClipPlane);
    addPoint();
  } //在裁剪时增加点标志


  function addPoint() {
    var lat = gridLayer.layerBounds.west + (gridLayer.layerBounds.east - gridLayer.layerBounds.west) * Number(state.clipX);
    var lng = gridLayer.layerBounds.south + (gridLayer.layerBounds.north - gridLayer.layerBounds.south) * Number(state.clipY);
    viewer.entities.removeById('volume-clip-plane');
    viewer.entities.add({
      id: 'volume-clip-plane',
      position: Cesium.Cartesian3.fromDegrees(lat, lng, 50000),
      point: {
        color: Cesium.Color.YELLOW,
        pixelSize: 10
      }
    });
  } // 移除裁剪面


  function removeClipPlane() {
    if (!Cesium.defined(gridLayer) || gridLayer.getNumberOfClipPlanes() === 0) {
      return;
    }

    state.showClipPlane = false;
    gridLayer.removeAllClipPlanes();
    viewer.entities.removeById('volume-clip-plane');
  }

  function clear() {
    if (!gridLayer) {
      return;
    }

    viewer.scene.layers.remove(gridLayer.name);
    gridLayer = null;
    init();
  } // 销毁


  onBeforeUnmount(function () {
    viewer.scene.layers.remove(gridLayer.name);
    gridLayer = null;
  }); // 监听
  // 数值部分

  watch(function () {
    return state.drawMode;
  }, function (val) {
    if (!gridLayer) return;

    if (val === 'slice') {
      gridLayer.volumeRenderMode = 1;
    } else if (val === 'gradient') {
      gridLayer.volumeRenderMode = 2;
    } else {
      gridLayer.volumeRenderMode = 0;
    }
  });
  watch(function () {
    return state.useGradientOpacity;
  }, function (val) {
    if (!gridLayer) return;
    gridLayer.useGradientOpacity = val;
  });
  watch(function () {
    return state.gradientOpacityValue;
  }, function (val) {
    if (!gridLayer) return;
    colorTable.gradientMinOpacity = val[0];
    colorTable.gradientMaxOpacity = val[1];
    colorTable.setGradientOpacityValue(gridLayer);
  });
  watch(function () {
    return state.opacityInterval;
  }, function (val) {
    if (!gridLayer) return;
    colorTable.opacityMinValue = val[0];
    colorTable.opacityMaxValue = val[1];
    colorTable.setColorTable(gridLayer);
  });
  watch(function () {
    return state.gradientOpacity;
  }, function (val) {
    if (!gridLayer) return;
    gridLayer.gradientOpacityMinOpacity = val[0];
    gridLayer.gradientOpacityMaxOpacity = val[1];
  });
  watch(function () {
    return state.zScale;
  }, function (val) {
    if (!gridLayer) return;
    scaleScratch.z = parseFloat(val);
    gridLayer.scale = scaleScratch;
  });
  watch(function () {
    return state.colorInterval;
  }, function (val) {
    if (!gridLayer) return;
    colorTable.visibleMinValue = val[0];
    colorTable.visibleMaxValue = val[1];
    colorTable.setColorTable(gridLayer);
  });
  watch(function () {
    return state.timeOrder;
  }, function (val) {
    if (!gridLayer) return;
    gridLayer.frameIndex = Number(val);
  });
  watch(function () {
    return state.openLight;
  }, function (val) {
    if (!gridLayer) return;
    gridLayer.enableLighting = val;
  });
  watch(function () {
    return state.clipX;
  }, function (val) {
    if (!gridLayer) return;
    addPoint();
    var newPosX = parseFloat(val);
    var newPosY = parseFloat(state.clipY);
    var newRot = Cesium.Math.toRadians(state.clipRotate);
    var qua = Cesium.Quaternion.fromAxisAngle(Cesium.Cartesian3.UNIT_Z, newRot);
    var pos = new Cesium.Cartesian3(newPosX, newPosY, 0.0);
    var transRotScale = new Cesium.TranslationRotationScale(pos, qua);
    var transformMatrix = Cesium.Matrix4.fromTranslationRotationScale(transRotScale);
    Cesium.Plane.fromPointNormal(new Cesium.Cartesian3(0, 0, 0), new Cesium.Cartesian3(1, 0, 0), scratchClipPlane);
    Cesium.Plane.transform(scratchClipPlane, transformMatrix, scratchClipPlane);
  });
  watch(function () {
    return state.clipY;
  }, function (val) {
    if (!gridLayer) return;
    addPoint();
    var newPosX = parseFloat(state.clipX);
    var newPosY = parseFloat(val);
    var pos = new Cesium.Cartesian3(newPosX, newPosY, 0.0);
    Cesium.Plane.fromPointNormal(pos, new Cesium.Cartesian3(0, 1, 0), scratchClipPlane);
  });
  watch(function () {
    return state.clipRotate;
  }, function (val) {
    if (!gridLayer) return;
    var newPosX = parseFloat(state.clipX);
    var newPosY = parseFloat(state.clipY);
    var newRot = Cesium.Math.toRadians(val);
    var qua = Cesium.Quaternion.fromAxisAngle(Cesium.Cartesian3.UNIT_Z, newRot);
    var pos = new Cesium.Cartesian3(newPosX, newPosY, 0.0);
    var rotMatrix3 = Cesium.Matrix3.fromQuaternion(qua);
    var rotMatrix4 = Cesium.Matrix4.fromRotationTranslation(rotMatrix3);
    var normal = new Cesium.Cartesian3(1, 0, 0);
    normal = Cesium.Matrix4.multiplyByPoint(rotMatrix4, normal, new Cesium.Cartesian3());
    Cesium.Plane.fromPointNormal(pos, normal, scratchClipPlane);
  }); // 剖切模式

  watch(function () {
    return state.xOffset;
  }, function (val) {
    if (!gridLayer) return;
    scratchCartesian3.x = parseFloat(val);
    gridLayer.sliceCoordinate = scratchCartesian3;
  });
  watch(function () {
    return state.yOffset;
  }, function (val) {
    if (!gridLayer) return;
    scratchCartesian3.y = parseFloat(val);
    gridLayer.sliceCoordinate = scratchCartesian3;
  });
  watch(function () {
    return state.zOffset;
  }, function (val) {
    if (!gridLayer) return;
    scratchCartesian3.z = parseFloat(val);
    gridLayer.sliceCoordinate = scratchCartesian3;
  });
  watch(function () {
    return state.contourValue;
  }, function (val) {
    if (!gridLayer) return;
    gridLayer.contourValue = parseFloat(val);
  });
  return _objectSpread2(_objectSpread2({}, toRefs(state)), {}, {
    startRender: startRender,
    addClipPlane: addClipPlane,
    removeClipPlane: removeClipPlane,
    clear: clear
  });
}

var script = {
  name: "Sm3dVolumeRender",
  props: {
    //数据地址
    volumeDataUrl: {
      type: String,
      required: true
    }
  },
  setup: function setup(props) {
    var _volume = volume(props),
        operationType = _volume.operationType,
        dimensions = _volume.dimensions,
        variables = _volume.variables,
        selectedDateName = _volume.selectedDateName,
        xDim = _volume.xDim,
        yDim = _volume.yDim,
        zDim = _volume.zDim,
        timeDim = _volume.timeDim,
        drawMode = _volume.drawMode,
        opacityInterval = _volume.opacityInterval,
        useGradientOpacity = _volume.useGradientOpacity,
        gradientOpacityValue = _volume.gradientOpacityValue,
        gradientOpacity = _volume.gradientOpacity,
        openLight = _volume.openLight,
        showClipPlane = _volume.showClipPlane,
        clipX = _volume.clipX,
        clipY = _volume.clipY,
        clipRotate = _volume.clipRotate,
        addClipPlane = _volume.addClipPlane,
        removeClipPlane = _volume.removeClipPlane,
        xOffset = _volume.xOffset,
        yOffset = _volume.yOffset,
        zOffset = _volume.zOffset,
        contourValue = _volume.contourValue,
        zScale = _volume.zScale,
        colorInterval = _volume.colorInterval,
        timeOrder = _volume.timeOrder,
        startRender = _volume.startRender,
        contourRange = _volume.contourRange,
        timeRange = _volume.timeRange,
        clear = _volume.clear;

    return {
      operationType: operationType,
      dimensions: dimensions,
      variables: variables,
      selectedDateName: selectedDateName,
      xDim: xDim,
      yDim: yDim,
      zDim: zDim,
      timeDim: timeDim,
      drawMode: drawMode,
      opacityInterval: opacityInterval,
      useGradientOpacity: useGradientOpacity,
      gradientOpacityValue: gradientOpacityValue,
      gradientOpacity: gradientOpacity,
      openLight: openLight,
      showClipPlane: showClipPlane,
      clipX: clipX,
      clipY: clipY,
      clipRotate: clipRotate,
      addClipPlane: addClipPlane,
      removeClipPlane: removeClipPlane,
      xOffset: xOffset,
      yOffset: yOffset,
      zOffset: zOffset,
      contourValue: contourValue,
      zScale: zScale,
      colorInterval: colorInterval,
      timeOrder: timeOrder,
      startRender: startRender,
      contourRange: contourRange,
      timeRange: timeRange,
      clear: clear
    };
  }
};

var _hoisted_1 = {
  id: "volume-panel",
  "class": "sm-panel"
};
var _hoisted_2 = {
  "class": "sm-function-module-sub-section",
  style: {
    "margin": "0"
  }
};
var _hoisted_3 = {
  "class": "sm-half-L"
};
var _hoisted_4 = {
  style: {
    "width": "auto"
  }
};

var _hoisted_5 = /*#__PURE__*/createTextVNode(" 数据加载 ");

var _hoisted_6 = {
  style: {
    "width": "auto"
  }
};

var _hoisted_7 = /*#__PURE__*/createTextVNode(" 数据操作 ");

var _hoisted_8 = {
  "class": "sm-half-L"
};

var _hoisted_9 = /*#__PURE__*/createElementVNode("label", {
  style: {
    "width": "auto"
  }
}, "数据加载中···", -1
/* HOISTED */
);

var _hoisted_10 = [_hoisted_9];
var _hoisted_11 = {
  style: {
    "width": "100%"
  }
};
var _hoisted_12 = {
  "class": "sm-half-L"
};

var _hoisted_13 = /*#__PURE__*/createElementVNode("label", {
  style: {
    "width": "30%"
  }
}, "数据名称", -1
/* HOISTED */
);

var _hoisted_14 = ["value"];
var _hoisted_15 = {
  "class": "sm-half-L"
};

var _hoisted_16 = /*#__PURE__*/createElementVNode("label", {
  style: {
    "width": "30%"
  }
}, "X轴方向", -1
/* HOISTED */
);

var _hoisted_17 = ["value"];
var _hoisted_18 = {
  "class": "sm-half-L"
};

var _hoisted_19 = /*#__PURE__*/createElementVNode("label", {
  style: {
    "width": "30%"
  }
}, "Y轴方向", -1
/* HOISTED */
);

var _hoisted_20 = ["value"];
var _hoisted_21 = {
  "class": "sm-half-L"
};

var _hoisted_22 = /*#__PURE__*/createElementVNode("label", {
  style: {
    "width": "30%"
  }
}, "Z轴方向", -1
/* HOISTED */
);

var _hoisted_23 = ["value"];
var _hoisted_24 = {
  "class": "sm-half-L"
};

var _hoisted_25 = /*#__PURE__*/createElementVNode("label", {
  style: {
    "width": "30%"
  }
}, "时间纬度", -1
/* HOISTED */
);

var _hoisted_26 = ["value"];
var _hoisted_27 = {
  "class": "boxchild",
  style: {
    "padding-bottom": "0"
  }
};
var _hoisted_28 = {
  style: {
    "width": "100%"
  }
};
var _hoisted_29 = {
  "class": "sm-half-L"
};

var _hoisted_30 = /*#__PURE__*/createElementVNode("label", {
  style: {
    "width": "38%"
  }
}, "绘制模式", -1
/* HOISTED */
);

var _hoisted_31 = /*#__PURE__*/createElementVNode("option", {
  value: "volume"
}, "数值模式", -1
/* HOISTED */
);

var _hoisted_32 = /*#__PURE__*/createElementVNode("option", {
  value: "slice"
}, "剖切模式", -1
/* HOISTED */
);

var _hoisted_33 = /*#__PURE__*/createElementVNode("option", {
  value: "gradient"
}, "等值面模式", -1
/* HOISTED */
);

var _hoisted_34 = [_hoisted_31, _hoisted_32, _hoisted_33];
var _hoisted_35 = {
  style: {
    "width": "100%"
  }
};
var _hoisted_36 = {
  "class": "sm-half-L"
};
var _hoisted_37 = {
  style: {
    "width": "auto"
  }
};

var _hoisted_38 = /*#__PURE__*/createTextVNode("使用梯度透明度 ");

var _hoisted_39 = {
  "class": "sm-half-L"
};

var _hoisted_40 = /*#__PURE__*/createElementVNode("label", {
  style: {
    "width": "40%"
  }
}, "梯度作用域", -1
/* HOISTED */
);

var _hoisted_41 = {
  "class": "sm-half-L"
};

var _hoisted_42 = /*#__PURE__*/createElementVNode("label", {
  style: {
    "width": "40%"
  }
}, "梯度透明度", -1
/* HOISTED */
);

var _hoisted_43 = {
  "class": "sm-half-L"
};

var _hoisted_44 = /*#__PURE__*/createElementVNode("label", {
  style: {
    "width": "40%"
  }
}, "透明范围", -1
/* HOISTED */
);

var _hoisted_45 = {
  style: {
    "width": "100%"
  }
};
var _hoisted_46 = {
  "class": "sm-half-L"
};

var _hoisted_47 = /*#__PURE__*/createElementVNode("label", {
  style: {
    "width": "40%"
  }
}, "沿X轴偏移", -1
/* HOISTED */
);

var _hoisted_48 = {
  "class": "sm-half-L"
};

var _hoisted_49 = /*#__PURE__*/createElementVNode("label", {
  style: {
    "width": "40%"
  }
}, "沿Y轴偏移", -1
/* HOISTED */
);

var _hoisted_50 = {
  "class": "sm-half-L"
};

var _hoisted_51 = /*#__PURE__*/createElementVNode("label", {
  style: {
    "width": "40%"
  }
}, "沿Z轴偏移", -1
/* HOISTED */
);

var _hoisted_52 = {
  "class": "sm-half-L"
};

var _hoisted_53 = /*#__PURE__*/createElementVNode("label", {
  style: {
    "width": "40%"
  }
}, "等值面", -1
/* HOISTED */
);

var _hoisted_54 = {
  "class": "sm-half-L"
};

var _hoisted_55 = /*#__PURE__*/createElementVNode("label", {
  style: {
    "width": "40%"
  }
}, "沿Z轴缩放", -1
/* HOISTED */
);

var _hoisted_56 = {
  "class": "sm-half-L"
};

var _hoisted_57 = /*#__PURE__*/createElementVNode("label", {
  style: {
    "width": "40%"
  }
}, "颜色范围", -1
/* HOISTED */
);

var _hoisted_58 = {
  "class": "sm-half-L"
};

var _hoisted_59 = /*#__PURE__*/createElementVNode("label", {
  style: {
    "width": "40%"
  }
}, "时间序列", -1
/* HOISTED */
);

var _hoisted_60 = {
  "class": "sm-half-L"
};

var _hoisted_61 = /*#__PURE__*/createElementVNode("label", {
  style: {
    "width": "40%"
  }
}, "裁剪面X方向", -1
/* HOISTED */
);

var _hoisted_62 = {
  "class": "sm-half-L"
};

var _hoisted_63 = /*#__PURE__*/createElementVNode("label", {
  style: {
    "width": "40%"
  }
}, "裁剪面Y方向", -1
/* HOISTED */
);

var _hoisted_64 = {
  "class": "sm-half-L"
};

var _hoisted_65 = /*#__PURE__*/createElementVNode("label", {
  style: {
    "width": "40%"
  }
}, "裁剪面旋转", -1
/* HOISTED */
);

var _hoisted_66 = {
  "class": "sm-half-L"
};
var _hoisted_67 = {
  style: {
    "width": "auto"
  }
};

var _hoisted_68 = /*#__PURE__*/createTextVNode("开启光照 ");

var _hoisted_69 = {
  "class": "boxchild",
  style: {
    "padding-bottom": "0"
  }
};
function render(_ctx, _cache, $props, $setup, $data, $options) {
  var _component_el_slider = resolveComponent("el-slider");

  var _directive_stopdrag = resolveDirective("stopdrag");

  var _directive_drag = resolveDirective("drag");

  return withDirectives((openBlock(), createElementBlock("div", _hoisted_1, [withDirectives((openBlock(), createElementBlock("div", _hoisted_2, [createElementVNode("div", _hoisted_3, [createElementVNode("label", _hoisted_4, [withDirectives(createElementVNode("input", {
    type: "radio",
    value: "addDate",
    "onUpdate:modelValue": _cache[0] || (_cache[0] = function ($event) {
      return $setup.operationType = $event;
    })
  }, null, 512
  /* NEED_PATCH */
  ), [[vModelRadio, $setup.operationType]]), _hoisted_5]), createElementVNode("label", _hoisted_6, [withDirectives(createElementVNode("input", {
    type: "radio",
    value: "operation",
    "onUpdate:modelValue": _cache[1] || (_cache[1] = function ($event) {
      return $setup.operationType = $event;
    })
  }, null, 512
  /* NEED_PATCH */
  ), [[vModelRadio, $setup.operationType]]), _hoisted_7])]), createCommentVNode(" 数据加载 "), withDirectives(createElementVNode("div", _hoisted_8, _hoisted_10, 512
  /* NEED_PATCH */
  ), [[vShow, !$setup.variables || $setup.variables.length === 0]]), withDirectives(createElementVNode("div", _hoisted_11, [createElementVNode("div", _hoisted_12, [_hoisted_13, withDirectives(createElementVNode("select", {
    "class": "sm-select-m",
    style: {
      "width": "68%"
    },
    "onUpdate:modelValue": _cache[2] || (_cache[2] = function ($event) {
      return $setup.selectedDateName = $event;
    })
  }, [(openBlock(true), createElementBlock(Fragment, null, renderList($setup.variables, function (variable, index) {
    return openBlock(), createElementBlock("option", {
      value: variable.name,
      key: index
    }, toDisplayString(variable.name), 9
    /* TEXT, PROPS */
    , _hoisted_14);
  }), 128
  /* KEYED_FRAGMENT */
  ))], 512
  /* NEED_PATCH */
  ), [[vModelSelect, $setup.selectedDateName]])]), createElementVNode("div", _hoisted_15, [_hoisted_16, withDirectives(createElementVNode("select", {
    "class": "sm-select-m",
    style: {
      "width": "68%"
    },
    "onUpdate:modelValue": _cache[3] || (_cache[3] = function ($event) {
      return $setup.xDim = $event;
    })
  }, [(openBlock(true), createElementBlock(Fragment, null, renderList($setup.dimensions, function (dimension, index) {
    return openBlock(), createElementBlock("option", {
      value: dimension.name,
      key: index
    }, toDisplayString(dimension.name + ':' + dimension.size), 9
    /* TEXT, PROPS */
    , _hoisted_17);
  }), 128
  /* KEYED_FRAGMENT */
  ))], 512
  /* NEED_PATCH */
  ), [[vModelSelect, $setup.xDim]])]), createElementVNode("div", _hoisted_18, [_hoisted_19, withDirectives(createElementVNode("select", {
    "class": "sm-select-m",
    style: {
      "width": "68%"
    },
    "onUpdate:modelValue": _cache[4] || (_cache[4] = function ($event) {
      return $setup.yDim = $event;
    })
  }, [(openBlock(true), createElementBlock(Fragment, null, renderList($setup.dimensions, function (dimension, index) {
    return openBlock(), createElementBlock("option", {
      value: dimension.name,
      key: index
    }, toDisplayString(dimension.name + ':' + dimension.size), 9
    /* TEXT, PROPS */
    , _hoisted_20);
  }), 128
  /* KEYED_FRAGMENT */
  ))], 512
  /* NEED_PATCH */
  ), [[vModelSelect, $setup.yDim]])]), createElementVNode("div", _hoisted_21, [_hoisted_22, withDirectives(createElementVNode("select", {
    "class": "sm-select-m",
    style: {
      "width": "68%"
    },
    "onUpdate:modelValue": _cache[5] || (_cache[5] = function ($event) {
      return $setup.zDim = $event;
    })
  }, [(openBlock(true), createElementBlock(Fragment, null, renderList($setup.dimensions, function (dimension, index) {
    return openBlock(), createElementBlock("option", {
      value: dimension.name,
      key: index
    }, toDisplayString(dimension.name + ':' + dimension.size), 9
    /* TEXT, PROPS */
    , _hoisted_23);
  }), 128
  /* KEYED_FRAGMENT */
  ))], 512
  /* NEED_PATCH */
  ), [[vModelSelect, $setup.zDim]])]), createElementVNode("div", _hoisted_24, [_hoisted_25, withDirectives(createElementVNode("select", {
    "class": "sm-select-m",
    style: {
      "width": "68%"
    },
    "onUpdate:modelValue": _cache[6] || (_cache[6] = function ($event) {
      return $setup.timeDim = $event;
    })
  }, [(openBlock(true), createElementBlock(Fragment, null, renderList($setup.dimensions, function (dimension, index) {
    return openBlock(), createElementBlock("option", {
      value: dimension.name,
      key: index
    }, toDisplayString(dimension.name + ':' + dimension.size), 9
    /* TEXT, PROPS */
    , _hoisted_26);
  }), 128
  /* KEYED_FRAGMENT */
  ))], 512
  /* NEED_PATCH */
  ), [[vModelSelect, $setup.timeDim]])]), createElementVNode("div", _hoisted_27, [createElementVNode("button", {
    "class": "tbtn",
    type: "button",
    onClick: _cache[7] || (_cache[7] = function () {
      return $setup.startRender && $setup.startRender.apply($setup, arguments);
    })
  }, "加载"), createElementVNode("button", {
    "class": "tbtn tbtn-margin-left",
    type: "button",
    onClick: _cache[8] || (_cache[8] = function () {
      return $setup.clear && $setup.clear.apply($setup, arguments);
    })
  }, "清除")])], 512
  /* NEED_PATCH */
  ), [[vShow, $setup.operationType === 'addDate' && $setup.variables.length > 0]]), createCommentVNode(" 操作模式 "), withDirectives(createElementVNode("div", _hoisted_28, [createElementVNode("div", _hoisted_29, [_hoisted_30, withDirectives(createElementVNode("select", {
    "class": "sm-select-m",
    style: {
      "width": "60%"
    },
    "onUpdate:modelValue": _cache[9] || (_cache[9] = function ($event) {
      return $setup.drawMode = $event;
    })
  }, _hoisted_34, 512
  /* NEED_PATCH */
  ), [[vModelSelect, $setup.drawMode]])]), createCommentVNode(" 数值模式 "), withDirectives(createElementVNode("div", _hoisted_35, [createElementVNode("div", _hoisted_36, [createElementVNode("label", _hoisted_37, [withDirectives(createElementVNode("input", {
    checked: "",
    type: "checkbox",
    "onUpdate:modelValue": _cache[10] || (_cache[10] = function ($event) {
      return $setup.useGradientOpacity = $event;
    })
  }, null, 512
  /* NEED_PATCH */
  ), [[vModelCheckbox, $setup.useGradientOpacity]]), _hoisted_38])]), withDirectives(createElementVNode("div", _hoisted_39, [_hoisted_40, createVNode(_component_el_slider, {
    modelValue: $setup.gradientOpacityValue,
    "onUpdate:modelValue": _cache[11] || (_cache[11] = function ($event) {
      return $setup.gradientOpacityValue = $event;
    }),
    min: 0,
    max: 1,
    range: "",
    step: 0.01,
    "input-size": "mini",
    debounce: 500,
    "tooltip-class": "tooltip-class",
    style: {
      "width": "58%"
    }
  }, null, 8
  /* PROPS */
  , ["modelValue", "step"])], 512
  /* NEED_PATCH */
  ), [[vShow, $setup.useGradientOpacity]]), withDirectives(createElementVNode("div", _hoisted_41, [_hoisted_42, createVNode(_component_el_slider, {
    modelValue: $setup.gradientOpacity,
    "onUpdate:modelValue": _cache[12] || (_cache[12] = function ($event) {
      return $setup.gradientOpacity = $event;
    }),
    min: 0,
    max: 1,
    range: "",
    step: 0.01,
    "input-size": "mini",
    debounce: 500,
    "tooltip-class": "tooltip-class",
    style: {
      "width": "58%"
    }
  }, null, 8
  /* PROPS */
  , ["modelValue", "step"])], 512
  /* NEED_PATCH */
  ), [[vShow, $setup.useGradientOpacity]]), createElementVNode("div", _hoisted_43, [_hoisted_44, createVNode(_component_el_slider, {
    modelValue: $setup.opacityInterval,
    "onUpdate:modelValue": _cache[13] || (_cache[13] = function ($event) {
      return $setup.opacityInterval = $event;
    }),
    min: 0,
    max: 1,
    range: "",
    step: 0.01,
    "input-size": "mini",
    debounce: 500,
    "tooltip-class": "tooltip-class",
    style: {
      "width": "58%"
    }
  }, null, 8
  /* PROPS */
  , ["modelValue", "step"])])], 512
  /* NEED_PATCH */
  ), [[vShow, $setup.drawMode === 'volume']]), createCommentVNode(" 剖切模式 "), withDirectives(createElementVNode("div", _hoisted_45, [createElementVNode("div", _hoisted_46, [_hoisted_47, createVNode(_component_el_slider, {
    modelValue: $setup.xOffset,
    "onUpdate:modelValue": _cache[14] || (_cache[14] = function ($event) {
      return $setup.xOffset = $event;
    }),
    min: 0,
    max: 1,
    step: 0.01,
    "input-size": "mini",
    debounce: 500,
    "tooltip-class": "tooltip-class",
    style: {
      "width": "58%"
    }
  }, null, 8
  /* PROPS */
  , ["modelValue", "step"])]), createElementVNode("div", _hoisted_48, [_hoisted_49, createVNode(_component_el_slider, {
    modelValue: $setup.yOffset,
    "onUpdate:modelValue": _cache[15] || (_cache[15] = function ($event) {
      return $setup.yOffset = $event;
    }),
    min: 0,
    max: 1,
    step: 0.01,
    "input-size": "mini",
    debounce: 500,
    "tooltip-class": "tooltip-class",
    style: {
      "width": "58%"
    }
  }, null, 8
  /* PROPS */
  , ["modelValue", "step"])]), createElementVNode("div", _hoisted_50, [_hoisted_51, createVNode(_component_el_slider, {
    modelValue: $setup.zOffset,
    "onUpdate:modelValue": _cache[16] || (_cache[16] = function ($event) {
      return $setup.zOffset = $event;
    }),
    min: 0,
    max: 1,
    step: 0.01,
    "input-size": "mini",
    debounce: 500,
    "tooltip-class": "tooltip-class",
    style: {
      "width": "58%"
    }
  }, null, 8
  /* PROPS */
  , ["modelValue", "step"])])], 512
  /* NEED_PATCH */
  ), [[vShow, $setup.drawMode === 'slice']]), createCommentVNode(" 等值面 "), withDirectives(createElementVNode("div", _hoisted_52, [_hoisted_53, createVNode(_component_el_slider, {
    modelValue: $setup.contourValue,
    "onUpdate:modelValue": _cache[17] || (_cache[17] = function ($event) {
      return $setup.contourValue = $event;
    }),
    min: $setup.contourRange[0],
    max: $setup.contourRange[1],
    step: 1,
    "input-size": "mini",
    debounce: 500,
    "tooltip-class": "tooltip-class",
    style: {
      "width": "58%"
    }
  }, null, 8
  /* PROPS */
  , ["modelValue", "min", "max"])], 512
  /* NEED_PATCH */
  ), [[vShow, $setup.drawMode === 'gradient']]), createCommentVNode(" 公共部分 "), withDirectives(createElementVNode("div", _hoisted_54, [_hoisted_55, createVNode(_component_el_slider, {
    modelValue: $setup.zScale,
    "onUpdate:modelValue": _cache[18] || (_cache[18] = function ($event) {
      return $setup.zScale = $event;
    }),
    min: 1,
    step: 0.1,
    "input-size": "mini",
    debounce: 500,
    "tooltip-class": "tooltip-class",
    style: {
      "width": "58%"
    }
  }, null, 8
  /* PROPS */
  , ["modelValue", "step"])], 512
  /* NEED_PATCH */
  ), [[vShow, $setup.drawMode !== 'gradient']]), withDirectives(createElementVNode("div", _hoisted_56, [_hoisted_57, createVNode(_component_el_slider, {
    modelValue: $setup.colorInterval,
    "onUpdate:modelValue": _cache[19] || (_cache[19] = function ($event) {
      return $setup.colorInterval = $event;
    }),
    min: 0,
    max: 1,
    range: "",
    step: 0.01,
    "input-size": "mini",
    debounce: 500,
    "tooltip-class": "tooltip-class",
    style: {
      "width": "58%"
    }
  }, null, 8
  /* PROPS */
  , ["modelValue", "step"])], 512
  /* NEED_PATCH */
  ), [[vShow, $setup.drawMode !== 'gradient']]), createElementVNode("div", _hoisted_58, [_hoisted_59, createVNode(_component_el_slider, {
    modelValue: $setup.timeOrder,
    "onUpdate:modelValue": _cache[20] || (_cache[20] = function ($event) {
      return $setup.timeOrder = $event;
    }),
    min: 0,
    max: $setup.timeRange[1],
    "input-size": "mini",
    debounce: 500,
    "tooltip-class": "tooltip-class",
    style: {
      "width": "58%"
    }
  }, null, 8
  /* PROPS */
  , ["modelValue", "max"])]), withDirectives(createElementVNode("div", _hoisted_60, [_hoisted_61, createVNode(_component_el_slider, {
    modelValue: $setup.clipX,
    "onUpdate:modelValue": _cache[21] || (_cache[21] = function ($event) {
      return $setup.clipX = $event;
    }),
    min: 0,
    max: 1,
    step: 0.01,
    "input-size": "mini",
    debounce: 500,
    "tooltip-class": "tooltip-class",
    style: {
      "width": "58%"
    }
  }, null, 8
  /* PROPS */
  , ["modelValue", "step"])], 512
  /* NEED_PATCH */
  ), [[vShow, $setup.showClipPlane]]), withDirectives(createElementVNode("div", _hoisted_62, [_hoisted_63, createVNode(_component_el_slider, {
    modelValue: $setup.clipY,
    "onUpdate:modelValue": _cache[22] || (_cache[22] = function ($event) {
      return $setup.clipY = $event;
    }),
    min: 0,
    max: 1,
    step: 0.01,
    "input-size": "mini",
    debounce: 500,
    "tooltip-class": "tooltip-class",
    style: {
      "width": "58%"
    }
  }, null, 8
  /* PROPS */
  , ["modelValue", "step"])], 512
  /* NEED_PATCH */
  ), [[vShow, $setup.showClipPlane]]), withDirectives(createElementVNode("div", _hoisted_64, [_hoisted_65, createVNode(_component_el_slider, {
    modelValue: $setup.clipRotate,
    "onUpdate:modelValue": _cache[23] || (_cache[23] = function ($event) {
      return $setup.clipRotate = $event;
    }),
    min: -180,
    max: 180,
    "input-size": "mini",
    debounce: 500,
    "tooltip-class": "tooltip-class",
    style: {
      "width": "58%"
    }
  }, null, 8
  /* PROPS */
  , ["modelValue"])], 512
  /* NEED_PATCH */
  ), [[vShow, $setup.showClipPlane]]), createElementVNode("div", _hoisted_66, [createElementVNode("label", _hoisted_67, [withDirectives(createElementVNode("input", {
    type: "checkbox",
    "onUpdate:modelValue": _cache[24] || (_cache[24] = function ($event) {
      return $setup.openLight = $event;
    })
  }, null, 512
  /* NEED_PATCH */
  ), [[vModelCheckbox, $setup.openLight]]), _hoisted_68])]), withDirectives(createElementVNode("div", _hoisted_69, [createElementVNode("button", {
    "class": "tbtn",
    type: "button",
    onClick: _cache[25] || (_cache[25] = function () {
      return $setup.addClipPlane && $setup.addClipPlane.apply($setup, arguments);
    }),
    style: {
      "width": "auto"
    }
  }, "添加裁剪面"), createElementVNode("button", {
    "class": "tbtn tbtn-margin-left",
    type: "button",
    style: {
      "width": "auto"
    },
    onClick: _cache[26] || (_cache[26] = function () {
      return $setup.removeClipPlane && $setup.removeClipPlane.apply($setup, arguments);
    })
  }, "移除裁剪面")], 512
  /* NEED_PATCH */
  ), [[vShow, $setup.drawMode === 'volume']])], 512
  /* NEED_PATCH */
  ), [[vShow, $setup.operationType === 'operation']])])), [[_directive_stopdrag]])])), [[_directive_drag]]);
}

script.render = render;
script.__file = "src/components/scene/volume-render/volume-render.vue";

script.install = function (app) {
  app.component(script.name, script);
};

export default script;
